// D import file generated from 'tango/core/Array.d'
module tango.core.Array;
private import tango.core.Traits;

private import tango.stdc.stdlib;

version (TangoDoc)
{
    alias int Num;
    alias int Elem;
    alias int Elem2;
    alias bool function(Elem) Pred1E;
    alias bool function(Elem, Elem) Pred2E;
    alias Elem2 function(Elem, Elem) Map2E;
    alias Elem function(Elem, Elem) Reduce2E;
    alias size_t function(size_t) Oper1A;
}
private 
{
    template IsEqual(T)
{
struct IsEqual
{
    static bool opCall(T p1, T p2)
{
static if(is(T == class) || is(T == struct))
{
return (p1 == p2) != 0;
}
else
{
return p1 == p2;
}

}

}
}
    template IsLess(T)
{
struct IsLess
{
    static bool opCall(T p1, T p2)
{
return p1 < p2;
}

}
}
    template RandOper()
{
struct RandOper
{
    static size_t opCall(size_t lim)
{
size_t max = size_t.max - size_t.max % lim;
size_t val;
do
{
static if(size_t.sizeof == 4)
{
val = cast(size_t)rand() << 16 & -65536u | cast(size_t)rand() & 65535u;
}
else
{
val = cast(size_t)rand() << 48 & 18446462598732840960LU | cast(size_t)rand() << 32 & 281470681743360LU | cast(size_t)rand() << 16 & 4294901760LU | cast(size_t)rand() & 65535LU;
}

}
while (val > max);return val % lim;
}

}
}
    template ElemTypeOf(T)
{
alias typeof(T[0]) ElemTypeOf;
}
}
version (TangoDoc)
{
    size_t find(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    size_t find(Elem[] buf, Elem[] pat, Pred2E pred = Pred2E.init);
}
else
{
    template find_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
foreach (size_t pos, Elem cur; buf)
{
if (pred(cur,pat))
return pos;
}
return buf.length;
}
size_t fn(Elem[] buf, Elem[] pat, Pred pred = Pred.init)
{
if (buf.length == 0 || pat.length == 0 || buf.length < pat.length)
{
return buf.length;
}
size_t end = buf.length - pat.length + 1;
{
for (size_t pos = 0;
 pos < end; ++pos)
{
{
if (pred(buf[pos],pat[0]))
{
size_t mat = 0;
do
{
if (++mat >= pat.length)
return pos - pat.length + 1;
if (++pos >= buf.length)
return buf.length;
}
while (pred(buf[pos],pat[mat]));pos -= mat;
}
}
}
}
return buf.length;
}
}
    template find(Buf,Pat)
{
size_t find(Buf buf, Pat pat)
{
return find_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template find(Buf,Pat,Pred)
{
size_t find(Buf buf, Pat pat, Pred pred)
{
return find_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t rfind(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    size_t rfind(Elem[] buf, Elem[] pat, Pred2E pred = Pred2E.init);
}
else
{
    template rfind_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
if (buf.length == 0)
return buf.length;
size_t pos = buf.length;
do
{
if (pred(buf[--pos],pat))
return pos;
}
while (pos > 0);return buf.length;
}
size_t fn(Elem[] buf, Elem[] pat, Pred pred = Pred.init)
{
if (buf.length == 0 || pat.length == 0 || buf.length < pat.length)
{
return buf.length;
}
size_t pos = buf.length - pat.length + 1;
do
{
if (pred(buf[--pos],pat[0]))
{
size_t mat = 0;
do
{
if (++mat >= pat.length)
return pos - pat.length + 1;
if (++pos >= buf.length)
return buf.length;
}
while (pred(buf[pos],pat[mat]));pos -= mat;
}
}
while (pos > 0);return buf.length;
}
}
    template rfind(Buf,Pat)
{
size_t rfind(Buf buf, Pat pat)
{
return rfind_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template rfind(Buf,Pat,Pred)
{
size_t rfind(Buf buf, Pat pat, Pred pred)
{
return rfind_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t kfind(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    size_t kfind(Elem[] buf, Elem[] pat, Pred2E pred = Pred2E.init);
}
else
{
    template kfind_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
foreach (size_t pos, Elem cur; buf)
{
if (pred(cur,pat))
return pos;
}
return buf.length;
}
size_t fn(Elem[] buf, Elem[] pat, Pred pred = Pred.init)
{
if (buf.length == 0 || pat.length == 0 || buf.length < pat.length)
{
return buf.length;
}
static if(is(alloca))
{
size_t[] func = (cast(size_t*)alloca((pat.length + 1) * size_t.sizeof))[0..pat.length + 1];
}
else
{
size_t[] func = new size_t[](pat.length + 1);
scope(exit) delete func;
}

func[0] = 0;
{
for (size_t m = 0,i = 1; i < pat.length; ++i)
{
{
while (m > 0 && !pred(pat[m],pat[i]))
m = func[m - 1];
if (pred(pat[m],pat[i]))
++m;
func[i] = m;
}
}
}
{
for (size_t m = 0,i = 0; i < buf.length; ++i)
{
{
while (m > 0 && !pred(pat[m],buf[i]))
m = func[m - 1];
if (pred(pat[m],buf[i]))
{
++m;
if (m == pat.length)
{
return i - pat.length + 1;
}
}
}
}
}
return buf.length;
}
}
    template kfind(Buf,Pat)
{
size_t kfind(Buf buf, Pat pat)
{
return kfind_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template kfind(Buf,Pat,Pred)
{
size_t kfind(Buf buf, Pat pat, Pred pred)
{
return kfind_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t krfind(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    size_t krfind(Elem[] buf, Elem[] pat, Pred2E pred = Pred2E.init);
}
else
{
    template krfind_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
if (buf.length == 0)
return buf.length;
size_t pos = buf.length;
do
{
if (pred(buf[--pos],pat))
return pos;
}
while (pos > 0);return buf.length;
}
size_t fn(Elem[] buf, Elem[] pat, Pred pred = Pred.init)
{
if (buf.length == 0 || pat.length == 0 || buf.length < pat.length)
{
return buf.length;
}
static if(is(alloca))
{
size_t[] func = (cast(size_t*)alloca((pat.length + 1) * size_t.sizeof))[0..pat.length + 1];
}
else
{
size_t[] func = new size_t[](pat.length + 1);
scope(exit) delete func;
}

func[$ - 1] = 0;
{
for (size_t m = 0,i = pat.length - 1; i > 0; --i)
{
{
while (m > 0 && !pred(pat[$ - m - 1],pat[i - 1]))
m = func[$ - m];
if (pred(pat[$ - m - 1],pat[i - 1]))
++m;
func[i - 1] = m;
}
}
}
size_t m = 0;
size_t i = buf.length;
do
{
--i;
while (m > 0 && !pred(pat[$ - m - 1],buf[i]))
m = func[$ - m - 1];
if (pred(pat[$ - m - 1],buf[i]))
{
++m;
if (m == pat.length)
{
return i;
}
}
}
while (i > 0);return buf.length;
}
}
    template krfind(Buf,Pat)
{
size_t krfind(Buf buf, Pat pat)
{
return krfind_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template krfind(Buf,Pat,Pred)
{
size_t krfind(Buf buf, Pat pat, Pred pred)
{
return krfind_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t findIf(Elem[] buf, Pred1E pred);
}
else
{
    template findIf_(Elem,Pred)
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred)
{
foreach (size_t pos, Elem cur; buf)
{
if (pred(cur))
return pos;
}
return buf.length;
}
}
    template findIf(Buf,Pred)
{
size_t findIf(Buf buf, Pred pred)
{
return findIf_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t rfindIf(Elem[] buf, Pred1E pred);
}
else
{
    template rfindIf_(Elem,Pred)
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred)
{
if (buf.length == 0)
return buf.length;
size_t pos = buf.length;
do
{
if (pred(buf[--pos]))
return pos;
}
while (pos > 0);return buf.length;
}
}
    template rfindIf(Buf,Pred)
{
size_t rfindIf(Buf buf, Pred pred)
{
return rfindIf_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t findAdj(Elem[] buf, Pred2E pred = Pred2E.init);
}
else
{
    template findAdj_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred = Pred.init)
{
if (buf.length < 2)
return buf.length;
auto sav = cast(BaseTypeOf!(Elem))buf[0];
foreach (size_t pos, Elem cur; buf[1..$])
{
if (pred(cur,sav))
return pos;
sav = cast(BaseTypeOf!(Elem))cur;
}
return buf.length;
}
}
    template findAdj(Buf)
{
size_t findAdj(Buf buf)
{
return findAdj_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template findAdj(Buf,Pred)
{
size_t findAdj(Buf buf, Pred pred)
{
return findAdj_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    equals_t contains(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    equals_t contains(Elem[] buf, Elem[] pat, Pred2E pred = Pred2E.init);
}
else
{
    template contains(Buf,Pat)
{
equals_t contains(Buf buf, Pat pat)
{
return cast(equals_t)(find(buf,pat) != buf.length);
}
}
    template contains(Buf,Pat,Pred)
{
equals_t contains(Buf buf, Pat pat, Pred pred)
{
return cast(equals_t)(find(buf,pat,pred) != buf.length);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t mismatch(Elem[] bufA, Elem[] bufB, Pred2E pred = Pred2E.init);
}
else
{
    template mismatch_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] bufA, Elem[] bufB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
while (posA < bufA.length && posB < bufB.length)
{
if (!pred(bufB[posB],bufA[posA]))
break;
++posA , ++posB;
}
return posA;
}
}
    template mismatch(BufA,BufB)
{
size_t mismatch(BufA bufA, BufB bufB)
{
return mismatch_!(ElemTypeOf!(BufA)).fn(bufA,bufB);
}
}
    template mismatch(BufA,BufB,Pred)
{
size_t mismatch(BufA bufA, BufB bufB, Pred pred)
{
return mismatch_!(ElemTypeOf!(BufA),Pred).fn(bufA,bufB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t count(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
}
else
{
    template count_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
size_t cnt = 0;
foreach (size_t pos, Elem cur; buf)
{
if (pred(cur,pat))
++cnt;
}
return cnt;
}
}
    template count(Buf,Pat)
{
size_t count(Buf buf, Pat pat)
{
return count_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template count(Buf,Pat,Pred)
{
size_t count(Buf buf, Pat pat, Pred pred)
{
return count_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t countIf(Elem[] buf, Pred1E pred = Pred1E.init);
}
else
{
    template countIf_(Elem,Pred)
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred)
{
size_t cnt = 0;
foreach (size_t pos, Elem cur; buf)
{
if (pred(cur))
++cnt;
}
return cnt;
}
}
    template countIf(Buf,Pred)
{
size_t countIf(Buf buf, Pred pred)
{
return countIf_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t replace(Elem[] buf, Elem pat, Elem val, Pred2E pred = Pred2E.init);
}
else
{
    template replace_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Elem val, Pred pred = Pred.init)
{
size_t cnt = 0;
foreach (size_t pos, ref Elem cur; buf)
{
if (pred(cur,pat))
{
cur = val;
++cnt;
}
}
return cnt;
}
}
    template replace(Buf,Elem)
{
size_t replace(Buf buf, Elem pat, Elem val)
{
return replace_!(ElemTypeOf!(Buf)).fn(buf,pat,val);
}
}
    template replace(Buf,Elem,Pred)
{
size_t replace(Buf buf, Elem pat, Elem val, Pred pred)
{
return replace_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,val,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t replaceIf(Elem[] buf, Elem val, Pred2E pred = Pred2E.init);
}
else
{
    template replaceIf_(Elem,Pred)
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem val, Pred pred)
{
size_t cnt = 0;
foreach (size_t pos, ref Elem cur; buf)
{
if (pred(cur))
{
cur = val;
++cnt;
}
}
return cnt;
}
}
    template replaceIf(Buf,Elem,Pred)
{
size_t replaceIf(Buf buf, Elem val, Pred pred)
{
return replaceIf_!(ElemTypeOf!(Buf),Pred).fn(buf,val,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t remove(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
    size_t remove(Elem[] buf, Elem pat);
}
else
{
    template remove_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
size_t cnt = 0;
{
for (size_t pos = 0,len = buf.length; pos < len; ++pos)
{
{
if (pred(buf[pos],pat))
++cnt;
else
exch(pos,pos - cnt);
}
}
}
return buf.length - cnt;
}
}
    template remove(Buf,Pat)
{
size_t remove(Buf buf, Pat pat)
{
return remove_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template remove(Buf,Pat,Pred)
{
size_t remove(Buf buf, Pat pat, Pred pred)
{
return remove_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t removeIf(Elem[] buf, Pred1E pred);
}
else
{
    template removeIf_(Elem,Pred)
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
size_t cnt = 0;
{
for (size_t pos = 0,len = buf.length; pos < len; ++pos)
{
{
if (pred(buf[pos]))
++cnt;
else
exch(pos,pos - cnt);
}
}
}
return buf.length - cnt;
}
}
    template removeIf(Buf,Pred)
{
size_t removeIf(Buf buf, Pred pred)
{
return removeIf_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t distinct(Elem[] buf, Pred2E pred = Pred2E.init);
}
else
{
    template distinct_(Elem,Pred = IsEqual!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
if (buf.length < 2)
return buf.length;
size_t cnt = 0;
Elem pat = buf[0];
{
for (size_t pos = 1,len = buf.length; pos < len; ++pos)
{
{
if (pred(buf[pos],pat))
++cnt;
else
{
pat = buf[pos];
exch(pos,pos - cnt);
}
}
}
}
return buf.length - cnt;
}
}
    template distinct(Buf)
{
size_t distinct(Buf buf)
{
return distinct_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template distinct(Buf,Pred)
{
size_t distinct(Buf buf, Pred pred)
{
return distinct_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    void shuffle(Elem[] buf, Oper1A oper = Oper1A.init);
}
else
{
    template shuffle_(Elem,Oper)
{
static assert(isCallableType!(Oper));
void fn(Elem[] buf, Oper oper)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
{
for (size_t pos = buf.length - 1;
 pos > 0; --pos)
{
{
exch(pos,oper(pos + 1));
}
}
}
}
}
    template shuffle(Buf,Oper = RandOper!())
{
void shuffle(Buf buf, Oper oper = Oper.init)
{
return shuffle_!(ElemTypeOf!(Buf),Oper).fn(buf,oper);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t partition(Elem[] buf, Pred1E pred);
}
else
{
    template partition_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Pred pred)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
if (buf.length < 2)
return 0;
size_t l = 0,r = buf.length,i = l,j = r - 1;
while (true)
{
while (i < r && pred(buf[i]))
++i;
while (j > l && !pred(buf[j]))
--j;
if (i >= j)
break;
exch(i++,j--);
}
return i;
}
}
    template partition(Buf,Pred)
{
size_t partition(Buf buf, Pred pred)
{
return partition_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t select(Elem[] buf, Num num, Pred2E pred = Pred2E.init);
}
else
{
    template select_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, size_t num, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
if (buf.length < 2)
return buf.length;
size_t l = 0,r = buf.length - 1,k = num;
while (r > l)
{
size_t i = l,j = r - 1;
Elem v = buf[r];
while (true)
{
while (i < r && pred(buf[i],v))
++i;
while (j > l && pred(v,buf[j]))
--j;
if (i >= j)
break;
exch(i++,j--);
}
exch(i,r);
if (i >= k)
r = i - 1;
if (i <= k)
l = i + 1;
}
return num - 1;
}
}
    template select(Buf,Num)
{
size_t select(Buf buf, Num num)
{
return select_!(ElemTypeOf!(Buf)).fn(buf,num);
}
}
    template select(Buf,Num,Pred)
{
size_t select(Buf buf, Num num, Pred pred)
{
return select_!(ElemTypeOf!(Buf),Pred).fn(buf,num,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    template sort(Elem,Pred2E = IsLess!(Elem))
{
void sort(Elem[] buf, Pred2E pred = Pred2E.init);
}
}
else
{
    template sort_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
void fn(Elem[] buf, Pred pred = Pred.init)
{
bool equiv(Elem p1, Elem p2)
{
return !pred(p1,p2) && !pred(p2,p1);
}
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
void insertionSort(size_t l, size_t r)
{
{
for (size_t i = r;
 i > l; --i)
{
{
if (pred(buf[i],buf[i - 1]))
exch(i,i - 1);
}
}
}
{
for (size_t i = l + 2;
 i <= r; ++i)
{
{
size_t j = i;
Elem v = buf[i];
while (pred(v,buf[j - 1]))
{
buf[j] = buf[j - 1];
j--;
}
buf[j] = v;
}
}
}
}
size_t medianOf(size_t l, size_t m, size_t r)
{
if (pred(buf[m],buf[l]))
{
if (pred(buf[r],buf[m]))
return m;
else
{
if (pred(buf[r],buf[l]))
return r;
else
return l;
}
}
else
{
if (pred(buf[r],buf[m]))
{
if (pred(buf[r],buf[l]))
return l;
else
return r;
}
else
return m;
}
}
void quicksort(size_t l, size_t r, size_t d)
{
if (r <= l)
return ;
enum 
{
MIN_LENGTH = 80,
}
if (r - l < MIN_LENGTH)
return insertionSort(l,r);
if (d-- == 0)
{
makeHeap(buf[l..r + 1],pred);
sortHeap(buf[l..r + 1],pred);
return ;
}
exch(r,medianOf(l,l + (r - l) / 2,r));
Elem v = buf[r];
size_t i = l,j = r,p = l,q = r;
while (true)
{
while (pred(buf[i],v))
++i;
while (pred(v,buf[--j]))
if (j == l)
break;
if (i >= j)
break;
exch(i,j);
if (equiv(buf[i],v))
exch(p++,i);
if (equiv(v,buf[j]))
exch(--q,j);
++i;
}
exch(i,r);
if (p < i)
{
j = i - 1;
{
for (size_t k = l;
 k < p; k++ , j--)
{
exch(k,j);
}
}
quicksort(l,j,d);
}
if (++i < q)
{
{
for (size_t k = r - 1;
 k >= q; k-- , i++)
{
exch(k,i);
}
}
quicksort(i,r,d);
}
}
size_t maxDepth(size_t x)
{
size_t d = 0;
do
{
++d;
x /= 2;
}
while (x > 1);return d * 2;
}
if (buf.length > 1)
{
quicksort(0,buf.length - 1,maxDepth(buf.length));
}
}
}
    template sort(Buf)
{
void sort(Buf buf)
{
return sort_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template sort(Buf,Pred)
{
void sort(Buf buf, Pred pred)
{
return sort_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t lbound(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
}
else
{
    template lbound_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
size_t beg = 0,end = buf.length,mid = end / 2;
while (beg < end)
{
if (pred(buf[mid],pat))
beg = mid + 1;
else
end = mid;
mid = beg + (end - beg) / 2;
}
return mid;
}
}
    template lbound(Buf,Pat)
{
size_t lbound(Buf buf, Pat pat)
{
return lbound_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template lbound(Buf,Pat,Pred)
{
size_t lbound(Buf buf, Pat pat, Pred pred)
{
return lbound_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    size_t ubound(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
}
else
{
    template ubound_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
size_t fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
size_t beg = 0,end = buf.length,mid = end / 2;
while (beg < end)
{
if (!pred(pat,buf[mid]))
beg = mid + 1;
else
end = mid;
mid = beg + (end - beg) / 2;
}
return mid;
}
}
    template ubound(Buf,Pat)
{
size_t ubound(Buf buf, Pat pat)
{
return ubound_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template ubound(Buf,Pat,Pred)
{
size_t ubound(Buf buf, Pat pat, Pred pred)
{
return ubound_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    bool bsearch(Elem[] buf, Elem pat, Pred2E pred = Pred2E.init);
}
else
{
    template bsearch_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
bool fn(Elem[] buf, Elem pat, Pred pred = Pred.init)
{
size_t pos = lbound(buf,pat,pred);
return pos < buf.length && !(pat < buf[pos]);
}
}
    template bsearch(Buf,Pat)
{
bool bsearch(Buf buf, Pat pat)
{
return bsearch_!(ElemTypeOf!(Buf)).fn(buf,pat);
}
}
    template bsearch(Buf,Pat,Pred)
{
bool bsearch(Buf buf, Pat pat, Pred pred)
{
return bsearch_!(ElemTypeOf!(Buf),Pred).fn(buf,pat,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    bool includes(Elem[] setA, Elem[] setB, Pred2E pred = Pred2E.init);
}
else
{
    template includes_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
bool fn(Elem[] setA, Elem[] setB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
while (posA < setA.length && posB < setB.length)
{
if (pred(setB[posB],setA[posA]))
return false;
else
if (pred(setA[posA],setB[posB]))
++posA;
else
++posA , ++posB;
}
return posB == setB.length;
}
}
    template includes(BufA,BufB)
{
bool includes(BufA setA, BufB setB)
{
return includes_!(ElemTypeOf!(BufA)).fn(setA,setB);
}
}
    template includes(BufA,BufB,Pred)
{
bool includes(BufA setA, BufB setB, Pred pred)
{
return includes_!(ElemTypeOf!(BufA),Pred).fn(setA,setB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem[] unionOf(Elem[] setA, Elem[] setB, Pred2E pred = Pred2E.init);
}
else
{
    template unionOf_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
Elem[] fn(Elem[] setA, Elem[] setB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
Elem[] setU;
while (posA < setA.length && posB < setB.length)
{
if (pred(setA[posA],setB[posB]))
setU ~= setA[posA++];
else
if (pred(setB[posB],setA[posA]))
setU ~= setB[posB++];
else
setU ~= setA[posA++] , posB++;
}
setU ~= setA[posA..$];
setU ~= setB[posB..$];
return setU;
}
}
    template unionOf(BufA,BufB)
{
ElemTypeOf!(BufA)[] unionOf(BufA setA, BufB setB)
{
return unionOf_!(ElemTypeOf!(BufA)).fn(setA,setB);
}
}
    template unionOf(BufA,BufB,Pred)
{
ElemTypeOf!(BufA)[] unionOf(BufA setA, BufB setB, Pred pred)
{
return unionOf_!(ElemTypeOf!(BufA),Pred).fn(setA,setB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem[] intersectionOf(Elem[] setA, Elem[] setB, Pred2E pred = Pred2E.init);
}
else
{
    template intersectionOf_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
Elem[] fn(Elem[] setA, Elem[] setB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
Elem[] setI;
while (posA < setA.length && posB < setB.length)
{
if (pred(setA[posA],setB[posB]))
++posA;
else
if (pred(setB[posB],setA[posA]))
++posB;
else
setI ~= setA[posA++] , posB++;
}
return setI;
}
}
    template intersectionOf(BufA,BufB)
{
ElemTypeOf!(BufA)[] intersectionOf(BufA setA, BufB setB)
{
return intersectionOf_!(ElemTypeOf!(BufA)).fn(setA,setB);
}
}
    template intersectionOf(BufA,BufB,Pred)
{
ElemTypeOf!(BufA)[] intersectionOf(BufA setA, BufB setB, Pred pred)
{
return intersectionOf_!(ElemTypeOf!(BufA),Pred).fn(setA,setB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem[] missingFrom(Elem[] setA, Elem[] setB, Pred2E pred = Pred2E.init);
}
else
{
    template missingFrom_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
Elem[] fn(Elem[] setA, Elem[] setB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
Elem[] setM;
while (posA < setA.length && posB < setB.length)
{
if (pred(setA[posA],setB[posB]))
setM ~= setA[posA++];
else
if (pred(setB[posB],setA[posA]))
++posB;
else
++posA , ++posB;
}
setM ~= setA[posA..$];
return setM;
}
}
    template missingFrom(BufA,BufB)
{
ElemTypeOf!(BufA)[] missingFrom(BufA setA, BufB setB)
{
return missingFrom_!(ElemTypeOf!(BufA)).fn(setA,setB);
}
}
    template missingFrom(BufA,BufB,Pred)
{
ElemTypeOf!(BufA)[] missingFrom(BufA setA, BufB setB, Pred pred)
{
return missingFrom_!(ElemTypeOf!(BufA),Pred).fn(setA,setB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem[] differenceOf(Elem[] setA, Elem[] setB, Pred2E pred = Pred2E.init);
}
else
{
    template differenceOf_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
Elem[] fn(Elem[] setA, Elem[] setB, Pred pred = Pred.init)
{
size_t posA = 0,posB = 0;
Elem[] setD;
while (posA < setA.length && posB < setB.length)
{
if (pred(setA[posA],setB[posB]))
setD ~= setA[posA++];
else
if (pred(setB[posB],setA[posA]))
setD ~= setB[posB++];
else
++posA , ++posB;
}
setD ~= setA[posA..$];
setD ~= setB[posB..$];
return setD;
}
}
    template differenceOf(BufA,BufB)
{
ElemTypeOf!(BufA)[] differenceOf(BufA setA, BufB setB)
{
return differenceOf_!(ElemTypeOf!(BufA)).fn(setA,setB);
}
}
    template differenceOf(BufA,BufB,Pred)
{
ElemTypeOf!(BufA)[] differenceOf(BufA setA, BufB setB, Pred pred)
{
return differenceOf_!(ElemTypeOf!(BufA),Pred).fn(setA,setB,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    void makeHeap(Elem[] buf, Pred2E pred = Pred2E.init);
}
else
{
    template makeHeap_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
void fn(Elem[] buf, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
void fixDown(size_t pos, size_t end)
{
if (end <= pos)
return ;
while (pos <= (end - 1) / 2)
{
size_t nxt = 2 * pos + 1;
if (nxt < end && pred(buf[nxt],buf[nxt + 1]))
++nxt;
if (!pred(buf[pos],buf[nxt]))
break;
exch(pos,nxt);
pos = nxt;
}
}
if (buf.length < 2)
return ;
size_t end = buf.length - 1,pos = end / 2 + 2;
do
{
fixDown(--pos,end);
}
while (pos > 0);}
}
    template makeHeap(Buf)
{
void makeHeap(Buf buf)
{
return makeHeap_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template makeHeap(Buf,Pred)
{
void makeHeap(Buf buf, Pred pred)
{
return makeHeap_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    void pushHeap(ref Elem[] buf, Elem val, Pred2E pred = Pred2E.init);
}
else
{
    template pushHeap_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
void fn(ref Elem[] buf, Elem val, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
void fixUp(size_t pos)
{
if (pos < 1)
return ;
size_t par = (pos - 1) / 2;
while (pos > 0 && pred(buf[par],buf[pos]))
{
exch(par,pos);
pos = par;
par = (pos - 1) / 2;
}
}
buf ~= val;
if (buf.length > 1)
{
fixUp(buf.length - 1);
}
}
}
    template pushHeap(Buf,Val)
{
void pushHeap(ref Buf buf, Val val)
{
return pushHeap_!(ElemTypeOf!(Buf)).fn(buf,val);
}
}
    template pushHeap(Buf,Val,Pred)
{
void pushHeap(ref Buf buf, Val val, Pred pred)
{
return pushHeap_!(ElemTypeOf!(Buf),Pred).fn(buf,val,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    void popHeap(ref Elem[] buf, Pred2E pred = Pred2E.init);
}
else
{
    template popHeap_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
void fn(ref Elem[] buf, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
void fixDown(size_t pos, size_t end)
{
if (end <= pos)
return ;
while (pos <= (end - 1) / 2)
{
size_t nxt = 2 * pos + 1;
if (nxt < end && pred(buf[nxt],buf[nxt + 1]))
++nxt;
if (!pred(buf[pos],buf[nxt]))
break;
exch(pos,nxt);
pos = nxt;
}
}
if (buf.length > 1)
{
exch(0,buf.length - 1);
fixDown(0,buf.length - 2);
}
if (buf.length > 0)
{
buf.length = buf.length - 1;
}
}
}
    template popHeap(Buf)
{
void popHeap(ref Buf buf)
{
return popHeap_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template popHeap(Buf,Pred)
{
void popHeap(ref Buf buf, Pred pred)
{
return popHeap_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    void sortHeap(Elem[] buf, Pred2E pred = Pred2E.init);
}
else
{
    template sortHeap_(Elem,Pred = IsLess!(Elem))
{
static assert(isCallableType!(Pred));
void fn(Elem[] buf, Pred pred = Pred.init)
{
void exch(size_t p1, size_t p2)
{
Elem t = buf[p1];
buf[p1] = buf[p2];
buf[p2] = t;
}
void fixDown(size_t pos, size_t end)
{
if (end <= pos)
return ;
while (pos <= (end - 1) / 2)
{
size_t nxt = 2 * pos + 1;
if (nxt < end && pred(buf[nxt],buf[nxt + 1]))
++nxt;
if (!pred(buf[pos],buf[nxt]))
break;
exch(pos,nxt);
pos = nxt;
}
}
if (buf.length < 2)
return ;
size_t pos = buf.length - 1;
while (pos > 0)
{
exch(0,pos);
fixDown(0,--pos);
}
}
}
    template sortHeap(Buf)
{
void sortHeap(Buf buf)
{
return sortHeap_!(ElemTypeOf!(Buf)).fn(buf);
}
}
    template sortHeap(Buf,Pred)
{
void sortHeap(Buf buf, Pred pred)
{
return sortHeap_!(ElemTypeOf!(Buf),Pred).fn(buf,pred);
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem2[] map(Elem[] array, Map2E func, Elem2[] buf = null);
}
else
{
    template map(Func,Array)
{
ReturnTypeOf!(Func)[] map(Array array, Func func, ReturnTypeOf!(Func)[] buf = null)
{
if (buf.length < array.length)
{
buf.length = array.length;
}
foreach (i, a; array)
{
buf[i] = func(a);
}
return buf;
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem reduce(Elem[] array, Reduce2E func);
}
else
{
    template reduce(Array,Func)
{
static assert(isCallableType!(Func));
ReturnTypeOf!(Func) reduce(Array array, Func func)
{
if (array.length == 0)
return ReturnTypeOf!(Func).init;
auto e = array[0];
foreach (i, a; array)
{
if (i == 0)
continue;
e = func(e,a);
}
return e;
}
}
    debug (UnitTest)
{
    }
}
version (TangoDoc)
{
    Elem[] filter(Elem[] array, Pred1E pred, Elem[] buf = null);
}
else
{
    template filter(Array,Pred)
{
static assert(isCallableType!(Pred));
ParameterTupleOf!(Pred)[0][] filter(Array array, Pred pred, ParameterTupleOf!(Pred)[0][] buf = null)
{
buf.length = 0;
foreach (i, e; array)
{
if (pred(e))
{
buf ~= e;
}
}
return buf;
}
}
    debug (UnitTest)
{
    }
}
