// D import file generated from 'tango/core/RuntimeTraits.d'
module tango.core.RuntimeTraits;
TypeInfo realType(TypeInfo type)
{
auto def = cast(TypeInfo_Typedef)type;
if (def !is null)
{
return def.base;
}
else
if (type.classinfo.name.length is 14 && type.classinfo.name[9..$] == "Const" || type.classinfo.name.length is 18 && type.classinfo.name[9..$] == "Invariant" || type.classinfo.name.length is 15 && type.classinfo.name[9..$] == "Shared" || type.classinfo.name.length is 14 && type.classinfo.name[9..$] == "Inout")
{
return (cast(TypeInfo_Const)type).next;
}
return type;
}
ClassInfo asClass(TypeInfo type)
{
if (isInterface(type))
{
auto klass = cast(TypeInfo_Interface)type;
return klass.info;
}
if (isClass(type))
{
auto klass = cast(TypeInfo_Class)type;
return klass.info;
}
return null;
}
bool isDerived(ClassInfo derived, ClassInfo base);
bool implements(ClassInfo implementor, ClassInfo iface);
bool isImplicitly(ClassInfo test, ClassInfo target)
{
return isDerived(test,target) || implements(test,target);
}
bool isImplicitly(TypeInfo test, TypeInfo target)
{
if (test is target)
return true;
if (isStaticArray(test) && isDynamicArray(target) && valueType(test) is valueType(target))
{
return true;
}
auto klass1 = asClass(test);
auto klass2 = asClass(target);
if (isClass(test) && isClass(target))
{
return isDerived(klass1,klass2);
}
if (isInterface(test) && isInterface(target))
{
return isDerived(klass1,klass2);
}
if (klass1 && klass2)
{
return isImplicitly(klass1,klass2);
}
if (klass1 || klass2)
{
return false;
}
if (isSignedInteger(test) && isSignedInteger(target) || isUnsignedInteger(test) && isUnsignedInteger(target) || isFloat(test) && isFloat(target) || isCharacter(test) && isCharacter(target))
{
return test.tsize() <= target.tsize();
}
if (isSignedInteger(test) && isUnsignedInteger(target))
{
return false;
}
if (isUnsignedInteger(test) && isSignedInteger(target))
{
return test.tsize() < target.tsize();
}
return false;
}
ClassInfo[] baseClasses(ClassInfo type);
ClassInfo[] baseInterfaces(ClassInfo type);
ClassInfo[] interfaceGraph(ClassInfo type);
struct applyInterfaces
{
    static applyInterfaces opCall(ClassInfo type)
{
applyInterfaces apply;
apply.type = type;
return apply;
}

    int opApply(scope int delegate(ref ClassInfo) dg);
    ClassInfo type;
}
ClassInfo[] baseTypes(ClassInfo type)
{
if (type is null)
return null;
return baseClasses(type) ~ baseInterfaces(type);
}
ModuleInfo* moduleOf(ClassInfo type);
ClassInfo[] directInterfaces(ClassInfo type);
ClassInfo[] derivedTypes(ClassInfo type);
bool isDynamicArray(TypeInfo type)
{
type = realType(type);
return type.classinfo.name[9] == 'A' && type.classinfo.name.length == 11 || type.classinfo.name.length == 12 && type.classinfo.name[9..12] == "Aya" || cast(TypeInfo_Array)type !is null;
}
bool isStaticArray(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_StaticArray)type !is null;
}
bool isArray(TypeInfo type)
{
type = realType(type);
return isDynamicArray(type) || isStaticArray(type);
}
bool isAssociativeArray(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_AssociativeArray)type !is null;
}
bool isCharacter(TypeInfo type)
{
type = realType(type);
return type is typeid(char) || type is typeid(wchar) || type is typeid(dchar);
}
bool isString(TypeInfo type)
{
type = realType(type);
return isArray(type) && isCharacter(valueType(type));
}
bool isUnsignedInteger(TypeInfo type)
{
type = realType(type);
return type is typeid(uint) || type is typeid(ulong) || type is typeid(ushort) || type is typeid(ubyte);
}
bool isSignedInteger(TypeInfo type)
{
type = realType(type);
return type is typeid(int) || type is typeid(long) || type is typeid(short) || type is typeid(byte);
}
bool isInteger(TypeInfo type)
{
type = realType(type);
return isSignedInteger(type) || isUnsignedInteger(type);
}
bool isBool(TypeInfo type)
{
type = realType(type);
return type is typeid(bool);
}
bool isFloat(TypeInfo type)
{
type = realType(type);
return type is typeid(float) || type is typeid(double) || type is typeid(real);
}
bool isPrimitive(TypeInfo type)
{
type = realType(type);
return isArray(type) || isAssociativeArray(type) || isCharacter(type) || isFloat(type) || isInteger(type);
}
bool isInterface(TypeInfo type)
{
return cast(TypeInfo_Interface)type !is null;
}
bool isPointer(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_Pointer)type !is null;
}
bool isClass(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_Class)type !is null;
}
bool isStruct(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_Struct)type !is null;
}
bool isFunction(TypeInfo type)
{
type = realType(type);
return cast(TypeInfo_Function)type !is null || cast(TypeInfo_Delegate)type !is null;
}
bool isReferenceType(TypeInfo type)
{
return isClass(type) || isPointer(type) || isDynamicArray(type);
}
bool isUserDefined(TypeInfo type)
{
return isClass(type) || isStruct(type);
}
bool isValueType(TypeInfo type)
{
return !(isDynamicArray(type) || isAssociativeArray(type) || isPointer(type) || isClass(type) || isFunction(type));
}
TypeInfo keyType(TypeInfo type)
{
type = realType(type);
auto assocArray = cast(TypeInfo_AssociativeArray)type;
if (assocArray)
return assocArray.key;
if (isArray(type))
return typeid(size_t);
return null;
}
TypeInfo valueType(TypeInfo type)
{
type = realType(type);
if (isArray(type))
return type.next;
auto assocArray = cast(TypeInfo_AssociativeArray)type;
if (assocArray)
return assocArray.value;
auto pointer = cast(TypeInfo_Pointer)type;
if (pointer)
return pointer.m_next;
return null;
}
TypeInfo returnType(TypeInfo type)
{
type = realType(type);
auto delegat = cast(TypeInfo_Delegate)type;
if (delegat)
return delegat.next;
auto func = cast(TypeInfo_Function)type;
if (func)
return func.next;
return null;
}
debug (UnitTest)
{
    interface I1
{
}
    interface I2
{
}
    interface I3
{
}
    interface I4
{
}
    class A
{
}
    class B : A,I1
{
}
    class C : B,I2,I3
{
}
    class D : A,I1
{
    int foo(int i)
{
return i;
}
}
    struct S1
{
}
            }
