// D import file generated from 'tango/core/Traits.d'
module tango.core.Traits;
template BaseTypeOf(T)
{
static if(is(T S : const(S)))
{
    alias S BaseTypeOf;
}
else
{
    static if(is(T S : shared(S)))
{
    alias S BaseTypeOf;
}
else
{
    static if(is(T S : shared(const(S))))
{
    alias S BaseTypeOf;
}
else
{
    alias T BaseTypeOf;
}
}
}
}
template InoutTypeOf(T,M)
{
static assert(is(BaseTypeOf!(T) == BaseTypeOf!(M)));
static if(is(immutable(BaseTypeOf!(T)) == T) && is(immutable(BaseTypeOf!(T)) == M))
{
    alias immutable(BaseTypeOf!(T)) InoutTypeOf;
}
else
{
    static if(is(BaseTypeOf!(T) == T) && is(BaseTypeOf!(T) == M))
{
    alias BaseTypeOf!(T) InoutTypeOf;
}
else
{
    alias const(BaseTypeOf!(T)) InoutTypeOf;
}
}
}
template isStringType(T)
{
const bool isStringType = is(T : const(char)[]) || is(T : const(wchar)[]) || is(T : const(dchar)[]);

}
template isCharType(T)
{
const bool isCharType = is(BaseTypeOf!(T) == char) || is(BaseTypeOf!(T) == wchar) || is(BaseTypeOf!(T) == dchar);

}
template isSignedIntegerType(T)
{
const bool isSignedIntegerType = is(BaseTypeOf!(T) == byte) || is(BaseTypeOf!(T) == short) || is(BaseTypeOf!(T) == int) || is(BaseTypeOf!(T) == long);

}
template isUnsignedIntegerType(T)
{
const bool isUnsignedIntegerType = is(BaseTypeOf!(T) == ubyte) || is(BaseTypeOf!(T) == ushort) || is(BaseTypeOf!(T) == uint) || is(BaseTypeOf!(T) == ulong);

}
template isIntegerType(T)
{
const bool isIntegerType = isSignedIntegerType!(T) || isUnsignedIntegerType!(T);

}
template isRealType(T)
{
const bool isRealType = is(BaseTypeOf!(T) == float) || is(BaseTypeOf!(T) == double) || is(BaseTypeOf!(T) == real);

}
template isComplexType(T)
{
const bool isComplexType = is(BaseTypeOf!(T) == cfloat) || is(BaseTypeOf!(T) == cdouble) || is(BaseTypeOf!(T) == creal);

}
template isImaginaryType(T)
{
const bool isImaginaryType = is(T == ifloat) || is(T == idouble) || is(T == ireal);

}
template isFloatingPointType(T)
{
const bool isFloatingPointType = isRealType!(T) || isComplexType!(T) || isImaginaryType!(T);

}
template isAtomicType(T)
{
static if(is(T == bool) || is(T == char) || is(T == wchar) || is(T == dchar) || is(T == byte) || is(T == short) || is(T == int) || is(T == long) || is(T == ubyte) || is(T == ushort) || is(T == uint) || is(T == ulong) || is(T == float) || is(T == double) || is(T == real) || is(T == ifloat) || is(T == idouble) || is(T == ireal))
{
    const isAtomicType = true;
}
else
{
    const isAtomicType = false;
}
}
template ComplexTypeOf(T)
{
static if(is(T == float) || is(T == ifloat) || is(T == cfloat))
{
    alias cfloat ComplexTypeOf;
}
else
{
    static if(is(T == double) || is(T == idouble) || is(T == cdouble))
{
    alias cdouble ComplexTypeOf;
}
else
{
    static if(is(T == real) || is(T == ireal) || is(T == creal))
{
    alias creal ComplexTypeOf;
}
else
{
    static assert(0,"unsupported type in ComplexTypeOf " ~ T.stringof);
}
}
}
}
template RealTypeOf(T)
{
static if(is(T == float) || is(T == ifloat) || is(T == cfloat))
{
    alias float RealTypeOf;
}
else
{
    static if(is(T == double) || is(T == idouble) || is(T == cdouble))
{
    alias double RealTypeOf;
}
else
{
    static if(is(T == real) || is(T == ireal) || is(T == creal))
{
    alias real RealTypeOf;
}
else
{
    static assert(0,"unsupported type in RealTypeOf " ~ T.stringof);
}
}
}
}
template ImaginaryTypeOf(T)
{
static if(is(T == float) || is(T == ifloat) || is(T == cfloat))
{
    alias ifloat ImaginaryTypeOf;
}
else
{
    static if(is(T == double) || is(T == idouble) || is(T == cdouble))
{
    alias idouble ImaginaryTypeOf;
}
else
{
    static if(is(T == real) || is(T == ireal) || is(T == creal))
{
    alias ireal ImaginaryTypeOf;
}
else
{
    static assert(0,"unsupported type in ImaginaryTypeOf " ~ T.stringof);
}
}
}
}
template MaxPrecTypeOf(T)
{
static if(isComplexType!(T))
{
    alias creal MaxPrecTypeOf;
}
else
{
    static if(isImaginaryType!(T))
{
    alias ireal MaxPrecTypeOf;
}
else
{
    alias real MaxPrecTypeOf;
}
}
}
template isPointerType(T)
{
const isPointerType = false;
}
template isPointerType(T : T*)
{
const isPointerType = true;
}
debug (UnitTest)
{
    }
template isReferenceType(T)
{
const bool isReferenceType = isPointerType!(T) || is(T == class) || is(T == interface) || is(T == delegate);

}
template isDynamicArrayType(T)
{
const bool isDynamicArrayType = is(typeof(T.init[0])[] == T);

}
template isStaticArrayType(T : T[U],size_t U)
{
const bool isStaticArrayType = true;

}
template isStaticArrayType(T)
{
const bool isStaticArrayType = false;

}
template isArrayType(T)
{
static if(is(T U : U[]))
{
    const bool isArrayType = true;

}
else
{
    const bool isArrayType = false;

}
}
debug (UnitTest)
{
    }
template isAssocArrayType(T)
{
const bool isAssocArrayType = is(typeof(T.init.values[0])[typeof(T.init.keys[0])] == T);

}
template isCallableType(T)
{
const bool isCallableType = is(T == function) || is(typeof(*T) == function) || is(T == delegate) || is(typeof(T.opCall) == function);

}
template ReturnTypeOf(Fn)
{
static if(is(Fn Ret == return))
{
    alias Ret ReturnTypeOf;
}
else
{
    static assert(false,"Argument has no return type.");
}
}
template ExprTypeOf(Expr)
{
static if(isCallableType!(Expr))
{
    alias ReturnTypeOf!(Expr) ExprTypeOf;
}
else
{
    alias Expr ExprTypeOf;
}
}
template ReturnTypeOf(alias fn)
{
alias ReturnTypeOf!(typeof(fn)) ReturnTypeOf;
}
template ParameterTupleOf(Fn)
{
static if(is(Fn Params == function))
{
    alias Params ParameterTupleOf;
}
else
{
    static if(is(Fn Params == delegate))
{
    alias ParameterTupleOf!(Params) ParameterTupleOf;
}
else
{
    static if(is(Fn Params == Params*))
{
    alias ParameterTupleOf!(Params) ParameterTupleOf;
}
else
{
    static assert(false,"Argument has no parameters.");
}
}
}
}
template ParameterTupleOf(alias fn)
{
alias ParameterTupleOf!(typeof(fn)) ParameterTupleOf;
}
template BaseTypeTupleOf(T)
{
static if(is(T Base == super))
{
    alias Base BaseTypeTupleOf;
}
else
{
    static assert(false,"Argument is not a class or interface.");
}
}
template BaseTypeOfArrays(T)
{
static if(is(T S : S[]))
{
    alias BaseTypeOfArrays!(S) BaseTypeOfArrays;
}
else
{
    alias T BaseTypeOfArrays;
}
}
template ElementTypeOfArray(T : T[])
{
alias T ElementTypeOfArray;
}
template rankOfArray(T)
{
static if(is(T S : S[]))
{
    const uint rankOfArray = 1 + rankOfArray!(S);

}
else
{
    const uint rankOfArray = 0;

}
}
template KeyTypeOfAA(T)
{
alias typeof(T.init.keys[0]) KeyTypeOfAA;
}
template ValTypeOfAA(T)
{
alias typeof(T.init.values[0]) ValTypeOfAA;
}
template staticArraySize(T)
{
static assert(isStaticArrayType!(T),"staticArraySize needs a static array as type");
static assert(rankOfArray!(T) == 1,"implemented only for 1d arrays...");
const size_t staticArraySize = (T).sizeof / (typeof(*T.ptr)).sizeof;

}
template DynamicArrayType(T)
{
static if(isStaticArrayType!(T))
{
    alias typeof(T.dup) DynamicArrayType;
}
else
{
    alias T DynamicArrayType;
}
}
debug (UnitTest)
{
    static assert(is(BaseTypeOfArrays!(real[][]) == real));
    static assert(is(BaseTypeOfArrays!(real[2][3]) == real));
    static assert(is(ElementTypeOfArray!(real[]) == real));
    static assert(is(ElementTypeOfArray!(real[][]) == real[]));
    static assert(is(ElementTypeOfArray!(real[2][]) == real[2]));
    static assert(is(ElementTypeOfArray!(real[2][2]) == real[2]));
    static assert(rankOfArray!(real[][]) == 2);
    static assert(rankOfArray!(real[2][]) == 2);
    static assert(is(ValTypeOfAA!(char[int]) == char));
    static assert(is(KeyTypeOfAA!(char[int]) == int));
    static assert(is(ValTypeOfAA!(char[][int]) == char[]));
    static assert(is(KeyTypeOfAA!(char[][int[]]) == const(int)[]));
    static assert(isAssocArrayType!(char[][int[]]));
    static assert(!isAssocArrayType!(char[]));
    static assert(is(DynamicArrayType!(char[2]) == DynamicArrayType!(char[])));
    static assert(is(DynamicArrayType!(char[2]) == char[]));
    static assert(staticArraySize!(char[2]) == 2);
}
char[] ctfe_i2a(int i);
char[] ctfe_i2a(long i);
char[] ctfe_i2a(uint i);
char[] ctfe_i2a(ulong i);
debug (UnitTest)
{
    }
