// D import file generated from 'tango/core/Variant.d'
module tango.core.Variant;
private import tango.core.Memory;

private import tango.core.Vararg;

private import tango.core.Traits;

private import tango.core.Tuple;

private extern (C) Object _d_toObject(void*);


version (DigitalMars)
{
    version (X86)
{
    version (Windows)
{
    version = EnableVararg;
}
else
{
    version (Posix)
{
    version = EnableVararg;
}
}
}
    version (X86_64)
{
    version (Windows)
{
    version = EnableVararg;
}
else
{
    version (Posix)
{
    version = EnableVararg;
}
}
    version = DigitalMarsX64;
    import tango.math.Math;
}
}
else
{
    version (LDC)
{
    version (X86)
{
    version (linux)
{
    version = EnableVararg;
}
}
else
{
    version (X86_64)
{
    version (linux)
{
    version = EnableVararg;
}
    import tango.math.Math;
}
}
}
else
{
    version (DDoc)
{
    version = EnableVararg;
}
}
}
version (EnableVararg)
{
}
else
{
    pragma (msg, "Note: Variant vararg functionality not supported for this compiler/platform combination.");
    pragma (msg, "To override and enable vararg support anyway, compile with the EnableVararg version.");
}
private 
{
    struct VariantStorage
{
    union
{
void[] heap;
struct Array
{
    size_t length;
    const(void)* ptr;
}
Array array;
Object obj;
ubyte[array.sizeof] data;
}
    void setArray(const(void)* ptr, size_t length)
{
array.length = 0;
array.ptr = ptr;
array.length = length;
}
}
    template isObject(T)
{
static if(is(T : Object))
{
    const isObject = true;
}
else
{
    const isObject = false;
}
}
    template isInterface(T)
{
static if(is(T == interface))
{
    const isInterface = true;
}
else
{
    const isInterface = false;
}
}
    alias Tuple!(bool,char,wchar,dchar,byte,short,int,long,ubyte,ushort,uint,ulong,float,double,real,ifloat,idouble,ireal,cfloat,cdouble,creal) BasicTypes;
    template isBasicTypeImpl(T,U)
{
const isBasicTypeImpl = is(T == U);
}
    template isBasicTypeImpl(T,U,Us...)
{
static if(is(T == U))
{
    const isBasicTypeImpl = true;
}
else
{
    const isBasicTypeImpl = isBasicTypeImpl!(T,Us);
}
}
    template isBasicType(T)
{
const isBasicType = isBasicTypeImpl!(T,BasicTypes);
}
    template canImplicitCastToType(dsttypeT)
{
bool canImplicitCastToType(TypeInfo srctype)
{
while (cast(TypeInfo_Typedef)srctype !is null)
{
if (srctype is typeid(dsttypeT))
return true;
srctype = srctype.next;
}
foreach (T; BasicTypes)
{
static if(is(dsttypeT == T))
{
foreach (U; BasicTypes)
{
static if(U.sizeof < T.sizeof || U.sizeof == T.sizeof && (isCharType!(T) || isUnsignedIntegerType!(T)) ^ !(isCharType!(U) || isUnsignedIntegerType!(U)))
{
if (srctype is typeid(U))
return true;
}

}
return false;
}

}
static if(is(T[] : dsttypeT))
{
if (typeid(T[]) is srctype)
return true;
if (auto ti_sa = cast(TypeInfo_StaticArray)srctype)
return ti_sa.next is typeid(T);
return false;
}
else
{
static if(is(dsttypeT == void*))
{
return cast(TypeInfo_Pointer)srctype !is null;
}
else
{
static if(is(dsttypeT == void[]))
{
return cast(TypeInfo_Array)srctype !is null || cast(TypeInfo_StaticArray)srctype !is null;
}
else
{
return false;
}

}

}

}
}
    template returnT(T)
{
static if(isStaticArrayType!(T))
{
    alias typeof(T.dup) returnT;
}
else
{
    alias T returnT;
}
}
    bool isBasicTypeInfo(TypeInfo ti);
    private import RuntimeTraits = tango.core.RuntimeTraits;

    alias RuntimeTraits.isStaticArray isStaticArrayTypeInfo;
    alias RuntimeTraits.isClass isObjectTypeInfo;
    alias RuntimeTraits.isInterface isInterfaceTypeInfo;
}
class VariantTypeMismatchException : Exception
{
    this(TypeInfo expected, TypeInfo got)
{
super("cannot convert " ~ expected.toString() ~ " value to a " ~ got.toString());
}
}
class VariantVoidVarargException : Exception
{
    this()
{
super("cannot use Variants containing a void with varargs");
}
}
struct Variant
{
    static template opCall(T)
{
Variant opCall(T value)
{
Variant _this;
static if(isStaticArrayType!(T))
{
_this = value.dup;
}
else
{
_this = value;
}

return _this;
}
}

    static template opCall()
{
Variant opCall(TypeInfo type, void* ptr)
{
Variant _this;
Variant.fromPtr(type,ptr,_this);
return _this;
}
}

    template opAssign(T)
{
Variant opAssign(T value)
{
static if(isStaticArrayType!(T))
{
return this = value.dup;
}
else
{
static if(is(T == Variant))
{
type = value.type;
this.value = value.value;
return this;
}
else
{
type = typeid(T);
static if(isDynamicArrayType!(T))
{
this.value.setArray(value.ptr,value.length);
}
else
{
static if(isInterface!(T))
{
this.value.obj = cast(Object)value;
}
else
{
static if(T.sizeof <= this.value.data.length)
{
this.value.data[0..T.sizeof] = (cast(ubyte*)&value)[0..T.sizeof];
}
else
{
auto buffer = (cast(ubyte*)&value)[0..T.sizeof].dup;
this.value.heap = cast(void[])buffer;
}

}

}

return this;
}

}

}
}
    @property template isA(T)
{
bool isA()
{
return cast(bool)(typeid(T) is type);
}
}

    @property template isImplicitly(T)
{
bool isImplicitly()
{
static if(is(T == class) || is(T == interface))
{
if (cast(TypeInfo_Class)type || cast(TypeInfo_Interface)type)
return cast(T)value.obj !is null;
else
return false;
}
else
{
return cast(bool)(typeid(T) is type) || canImplicitCastToType!(T)(type);
}

}
}

    @property bool isEmpty()
{
return isA!(void);
}

    void clear()
{
_type = typeid(void);
value = value.init;
}
    version (DDoc)
{
    @property template get(T)
{
T get()
{
}
}

}
else
{
    @property template get(S)
{
returnT!(S) get()
{
alias returnT!(S) T;
if (type !is typeid(T) && !isObject!(T) && !isInterface!(T) && !canImplicitCastToType!(T)(type))
throw new VariantTypeMismatchException(type,typeid(T));
static if(isBasicType!(T))
{
if (type is typeid(T))
{
static if(T.sizeof <= value.sizeof)
{
return *cast(T*)&value;
}
else
{
return *cast(T*)value.heap.ptr;
}

}
else
{
foreach (U; BasicTypes)
{
if (type is typeid(U))
{
static if(U.sizeof <= value.sizeof)
{
return cast(T)*cast(U*)&value;
}
else
{
return cast(T)*cast(U*)value.heap.ptr;
}

}
}
throw new VariantTypeMismatchException(type,typeid(T));
}
}
else
{
static if(isDynamicArrayType!(T))
{
return (cast(typeof(T.ptr))value.array.ptr)[0..value.array.length];
}
else
{
static if(isObject!(T) || isInterface!(T))
{
return cast(T)this.value.obj;
}
else
{
static if(T.sizeof <= this.value.data.length)
{
T result;
(cast(ubyte*)&result)[0..T.sizeof] = this.value.data[0..T.sizeof];
return result;
}
else
{
T result;
(cast(ubyte*)&result)[0..T.sizeof] = (cast(ubyte[])this.value.heap)[0..T.sizeof];
return result;
}

}

}

}

}
}

}
    template opBinary(immutable(char)[] op,T)
{
auto opBinary(T rhs)
{
mixin("return get!(T) " ~ op ~ " rhs;");
}
}
    template opBinaryRight(immutable(char)[] op,T)
{
auto opBinaryRight(T lhs)
{
mixin("return lhs " ~ op ~ " get!(T);");
}
}
    template opOpAssign(immutable(char)[] op,T)
{
Variant opOpAssign(T value)
{
mixin("return (this = get!(T) " ~ op ~ " value);");
}
}
    template opEquals(T)
{
int opEquals(T rhs)
{
static if(is(T == Variant))
{
return opEqualsVariant(rhs);
}
else
{
return get!(T) == rhs;
}

}
}
    template opCmp(T)
{
int opCmp(T rhs)
{
static if(is(T == Variant))
{
return opCmpVariant(rhs);
}
else
{
auto lhs = get!(T);
return lhs < rhs ? -1 : lhs == rhs ? 0 : 1;
}

}
}
    hash_t toHash()
{
return type.getHash(this.ptr);
}
    string toString()
{
return type.toString();
}
    @property TypeInfo type()
{
return _type;
}

    @property void* ptr()
{
if (type.tsize <= value.sizeof)
return &value;
else
return value.heap.ptr;
}

    version (EnableVararg)
{
    static Variant[] fromVararg(TypeInfo[] types, void* args);

    static Variant[] fromVararg(...);

}
    private 
{
    TypeInfo _type = typeid(void);
    VariantStorage value;
    @property TypeInfo type(TypeInfo v)
{
return _type = v;
}

    static void* fromPtr(TypeInfo type, void* ptr, out Variant r);

    int opEqualsVariant(Variant rhs)
{
if (type != rhs.type)
return false;
return cast(bool)type.equals(this.ptr,rhs.ptr);
}
    int opCmpVariant(Variant rhs);
}
}
debug (UnitTest)
{
            version (EnableVararg)
{
    private import tango.core.Vararg;

    }
}
