// D import file generated from 'tango/core/sync/Atomic.d'
module tango.core.sync.Atomic;
version (LDC)
{
    import ldc.intrinsics;
}
private 
{
    template isIntegerType(T)
{
const bool isIntegerType = isSignedIntegerType!(T) || isUnsignedIntegerType!(T);

}
    template isPointerOrClass(T)
{
const isPointerOrClass = is(T == class);
}
    template isPointerOrClass(T : T*)
{
const isPointerOrClass = true;
}
    template isSignedIntegerType(T)
{
const bool isSignedIntegerType = is(T == byte) || is(T == short) || is(T == int) || is(T == long);

}
    template isUnsignedIntegerType(T)
{
const bool isUnsignedIntegerType = is(T == ubyte) || is(T == ushort) || is(T == uint) || is(T == ulong);

}
    template ClassPtr(T)
{
static if(is(T == class))
{
    alias void* ClassPtr;
}
else
{
    alias T ClassPtr;
}
}
}
extern (C) void thread_yield();

template atomicValueIsProperlyAligned(T)
{
bool atomicValueIsProperlyAligned(size_t addr)
{
return addr % ClassPtr!(T).sizeof == 0;
}
}
version (D_InlineAsm_X86)
{
    template memoryBarrier(bool ll,bool ls,bool sl,bool ss,bool device = false)
{
void memoryBarrier()
{
static if(device)
{
if (ls || sl || ll || ss)
{
asm { push EBX; }
asm { mov EAX,0; }
asm { cpuid; }
asm { pop EBX; }
}
}
else
{
static if(ls || sl || ll && ss)
{
asm { mfence; }
}
else
{
static if(ll)
{
asm { lfence; }
}
else
{
static if(ss)
{
asm { sfence; }
}

}

}

}

}
}
}
else
{
    version (D_InlineAsm_X86_64)
{
    template memoryBarrier(bool ll,bool ls,bool sl,bool ss,bool device = false)
{
void memoryBarrier()
{
static if(device)
{
if (ls || sl || ll || ss)
{
asm { push RBX; }
asm { mov RAX,0; }
asm { cpuid; }
asm { pop RBX; }
}
}
else
{
static if(ls || sl || ll && ss)
{
asm { mfence; }
}
else
{
static if(ll)
{
asm { lfence; }
}
else
{
static if(ss)
{
asm { sfence; }
}

}

}

}

}
}
}
else
{
    pragma (msg, "WARNING: no atomic operations on this architecture");
    pragma (msg, "WARNING: this is *slow* you probably want to change this!");
    int dummy;
    template memoryBarrier(bool ll,bool ls,bool sl,bool ss,bool device = false)
{
void memoryBarrier()
{
synchronized {
dummy = 1;
}
}
}
    enum 
{
LockVersion = true,
}
}
}
static if(!is(typeof(LockVersion)))
{
    enum 
{
LockVersion = false,
}
}
enum 
{
strictFences = false,
}
void writeBarrier()
{
memoryBarrier!(false,false,strictFences,true)();
}
void readBarrier()
{
memoryBarrier!(true,strictFences,false,false)();
}
void fullBarrier()
{
memoryBarrier!(true,true,true,true)();
}
version (LDC)
{
    template atomicSwap(T)
{
T atomicSwap(ref T val, T newval)
{
T oldval = void;
static if(isPointerOrClass!(T))
{
oldval = cast(T)llvm_atomic_swap!(size_t)(cast(size_t*)&val,cast(size_t)newval);
}
else
{
static if(is(T == bool))
{
oldval = llvm_atomic_swap!(ubyte)(cast(ubyte*)&val,newval ? 1 : 0) ? 0 : 1;
}
else
{
oldval = llvm_atomic_swap!(T)(&val,newval);
}

}

return oldval;
}
}
}
else
{
    version (D_InlineAsm_X86)
{
    template atomicSwap(T)
{
T atomicSwap(ref T val, T newval)
in
{
static if(T.sizeof > size_t.sizeof)
{
assert(atomicValueIsProperlyAligned!(size_t)(cast(size_t)&val));
}
else
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
}

}
body
{
T* posVal = &val;
static if(T.sizeof == (byte).sizeof)
{
asm { mov AL,newval; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xchg[ECX],AL; }
}
else
{
static if(T.sizeof == (short).sizeof)
{
asm { mov AX,newval; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xchg[ECX],AX; }
}
else
{
static if(T.sizeof == (int).sizeof)
{
asm { mov EAX,newval; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xchg[ECX],EAX; }
}
else
{
static if(T.sizeof == (long).sizeof)
{
static assert(false,"Invalid template type specified, 8bytes in 32 bit mode: " ~ T.stringof);
}
else
{
static assert(false,"Invalid template type specified: " ~ T.stringof);
}

}

}

}

}
}
}
else
{
    version (D_InlineAsm_X86_64)
{
    template atomicSwap(T)
{
T atomicSwap(ref T val, T newval)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
}
body
{
T* posVal = &val;
static if(T.sizeof == (byte).sizeof)
{
asm { mov AL,newval; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xchg[RCX],AL; }
}
else
{
static if(T.sizeof == (short).sizeof)
{
asm { mov AX,newval; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xchg[RCX],AX; }
}
else
{
static if(T.sizeof == (int).sizeof)
{
asm { mov EAX,newval; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xchg[RCX],EAX; }
}
else
{
static if(T.sizeof == (long).sizeof)
{
asm { mov RAX,newval; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xchg[RCX],RAX; }
}
else
{
static assert(false,"Invalid template type specified: " ~ T.stringof);
}

}

}

}

}
}
}
else
{
    template atomicSwap(T)
{
T atomicSwap(ref T val, T newval)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
}
body
{
T oldVal;
synchronized(typeid(T)) {
oldVal = val;
val = newval;
}
return oldVal;
}
}
}
}
}
private template aCasT(T,V)
{
T aCasT(ref T val, T newval, T equalTo)
{
union UVConv
{
    V v;
    T t;
}
union UVPtrConv
{
    V* v;
    T* t;
}
UVConv vNew,vOld,vAtt;
UVPtrConv valPtr;
vNew.t = newval;
vOld.t = equalTo;
valPtr.t = &val;
vAtt.v = atomicCAS(*valPtr.v,vNew.v,vOld.v);
return vAtt.t;
}
}

private template aCas(T)
{
T aCas(ref T val, T newval, T equalTo)
{
static if(T.sizeof == 1)
{
return aCasT!(T,ubyte)(val,newval,equalTo);
}
else
{
static if(T.sizeof == 2)
{
return aCasT!(T,ushort)(val,newval,equalTo);
}
else
{
static if(T.sizeof == 4)
{
return aCasT!(T,uint)(val,newval,equalTo);
}
else
{
static if(T.sizeof == 8)
{
return aCasT!(T,ulong)(val,newval,equalTo);
}
else
{
static assert(0,"invalid type " ~ T.stringof);
}

}

}

}

}
}

version (LDC)
{
    template atomicCAS(T)
{
T atomicCAS(ref T val, T newval, T equalTo)
{
T oldval = void;
static if(isPointerOrClass!(T))
{
oldval = cast(T)cast(void*)llvm_atomic_cmp_swap!(size_t)(cast(size_t*)cast(void*)&val,cast(size_t)cast(void*)equalTo,cast(size_t)cast(void*)newval);
}
else
{
static if(is(T == bool))
{
oldval = aCas(val,newval,equalTo);
}
else
{
static if(isIntegerType!(T))
{
oldval = llvm_atomic_cmp_swap!(T)(&val,equalTo,newval);
}
else
{
oldval = aCas(val,newval,equalTo);
}

}

}

return oldval;
}
}
}
else
{
    version (D_InlineAsm_X86)
{
    version (darwin)
{
    extern (C) ubyte OSAtomicCompareAndSwap64(long oldValue, long newValue, long* theValue);

}
    template atomicCAS(T)
{
T atomicCAS(ref T val, T newval, T equalTo)
in
{
static if(ClassPtr!(T).sizeof > size_t.sizeof)
{
assert(atomicValueIsProperlyAligned!(size_t)(cast(size_t)&val));
}
else
{
assert(atomicValueIsProperlyAligned!(ClassPtr!(T))(cast(size_t)&val));
}

}
body
{
T* posVal = &val;
static if(T.sizeof == (byte).sizeof)
{
asm { mov DL,newval; }
asm { mov AL,equalTo; }
asm { mov ECX,posVal; }
asm { lock; }
asm { cmpxchg[ECX],DL; }
}
else
{
static if(T.sizeof == (short).sizeof)
{
asm { mov DX,newval; }
asm { mov AX,equalTo; }
asm { mov ECX,posVal; }
asm { lock; }
asm { cmpxchg[ECX],DX; }
}
else
{
static if(ClassPtr!(T).sizeof == (int).sizeof)
{
asm { mov EDX,newval; }
asm { mov EAX,equalTo; }
asm { mov ECX,posVal; }
asm { lock; }
asm { cmpxchg[ECX],EDX; }
}
else
{
static if(T.sizeof == (long).sizeof)
{
version (darwin)
{
union UVConv
{
    long v;
    T t;
}
union UVPtrConv
{
    long* v;
    T* t;
}
UVConv vEqual,vNew;
UVPtrConv valPtr;
vEqual.t = equalTo;
vNew.t = newval;
valPtr.t = &val;
while (1)
{
if (OSAtomicCompareAndSwap64(vEqual.v,vNew.v,valPtr.v) != 0)
{
return equalTo;
}
else
{
{
T res = val;
if (res !is equalTo)
return res;
}
}
}
}
else
{
T res;
asm { push EDI; }
asm { push EBX; }
asm { lea EDI,newval; }
asm { mov EBX,[EDI]; }
asm { mov ECX,4[EDI]; }
asm { lea EDI,equalTo; }
asm { mov EAX,[EDI]; }
asm { mov EDX,4[EDI]; }
asm { mov EDI,val; }
asm { lock; }
asm { cmpxchg8b[EDI]; }
asm { lea EDI,res; }
asm { mov[EDI],EAX; }
asm { mov 4[EDI],EDX; }
asm { pop EBX; }
asm { pop EDI; }
return res;
}

}
else
{
static assert(false,"Invalid template type specified: " ~ T.stringof);
}

}

}

}

}
}
}
else
{
    version (D_InlineAsm_X86_64)
{
    template atomicCAS(T)
{
T atomicCAS(ref T val, T newval, T equalTo)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
}
body
{
T* posVal = &val;
static if(T.sizeof == (byte).sizeof)
{
asm { mov DL,newval; }
asm { mov AL,equalTo; }
asm { mov RCX,posVal; }
asm { lock; }
asm { cmpxchg[RCX],DL; }
}
else
{
static if(T.sizeof == (short).sizeof)
{
asm { mov DX,newval; }
asm { mov AX,equalTo; }
asm { mov RCX,posVal; }
asm { lock; }
asm { cmpxchg[RCX],DX; }
}
else
{
static if(ClassPtr!(T).sizeof == (int).sizeof)
{
asm { mov EDX,newval; }
asm { mov EAX,equalTo; }
asm { mov RCX,posVal; }
asm { lock; }
asm { cmpxchg[RCX],EDX; }
}
else
{
static if(ClassPtr!(T).sizeof == (long).sizeof)
{
asm { mov RDX,newval; }
asm { mov RAX,equalTo; }
asm { mov RCX,posVal; }
asm { lock; }
asm { cmpxchg[RCX],RDX; }
}
else
{
static assert(false,"Invalid template type specified: " ~ T.stringof);
}

}

}

}

}
}
}
else
{
    template atomicCAS(T)
{
T atomicCAS(ref T val, T newval, T equalTo)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
}
body
{
T oldval;
synchronized(typeid(T)) {
oldval = val;
if (oldval == equalTo)
{
val = newval;
}
}
return oldval;
}
}
}
}
}
template atomicCASB(T)
{
bool atomicCASB(ref T val, T newval, T equalTo)
{
return equalTo is atomicCAS(val,newval,equalTo);
}
}
template atomicLoad(T)
{
T atomicLoad(ref T val)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val));
static assert(ClassPtr!(T).sizeof <= size_t.sizeof,"invalid size for " ~ T.stringof);
}
body
{
T res = val;
return res;
}
}
template atomicStore(T)
{
void atomicStore(ref T val, T newVal)
in
{
assert(atomicValueIsProperlyAligned!(T)(cast(size_t)&val),"invalid alignment");
static assert(ClassPtr!(T).sizeof <= size_t.sizeof,"invalid size for " ~ T.stringof);
}
body
{
val = newVal;
}
}
version (LDC)
{
    template atomicAdd(T)
{
T atomicAdd(ref T val, T incV)
{
static if(isPointerOrClass!(T))
{
return cast(T)llvm_atomic_load_add!(size_t)(cast(size_t*)&val,incV);
}
else
{
static if(isIntegerType!(T))
{
static assert(isIntegerType!(T),"invalid type " ~ T.stringof);
return llvm_atomic_load_add!(T)(&val,cast(T)incV);
}
else
{
return atomicOp(val,delegate T(T a)
{
return a + incV;
}
);
}

}

}
}
}
else
{
    version (D_InlineAsm_X86)
{
    template atomicAdd(T,U = T)
{
T atomicAdd(ref T val, U incV_)
{
T incV = cast(T)incV_;
static if(isIntegerType!(T) || isPointerOrClass!(T))
{
T* posVal = &val;
T res;
static if(T.sizeof == 1)
{
asm { mov DL,incV; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xadd byte ptr[ECX],DL; }
asm { mov byte ptr res[EBP],DL; }
}
else
{
static if(T.sizeof == 2)
{
asm { mov DX,incV; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xadd short ptr[ECX],DX; }
asm { mov short ptr res[EBP],DX; }
}
else
{
static if(T.sizeof == 4)
{
asm { mov EDX,incV; }
asm { mov ECX,posVal; }
asm { lock; }
asm { xadd int ptr[ECX],EDX; }
asm { mov int ptr res[EBP],EDX; }
}
else
{
static if(T.sizeof == 8)
{
return atomicOp(val,delegate (T x)
{
return x + incV;
}
);
}
else
{
static assert(0,"Unsupported type size");
}

}

}

}

return res;
}
else
{
return atomicOp(val,delegate T(T a)
{
return a + incV;
}
);
}

}
}
}
else
{
    version (D_InlineAsm_X86_64)
{
    template atomicAdd(T,U = T)
{
T atomicAdd(ref T val, U incV_)
{
T incV = cast(T)incV_;
static if(isIntegerType!(T) || isPointerOrClass!(T))
{
T* posVal = &val;
T res;
static if(T.sizeof == 1)
{
asm { mov DL,incV; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xadd byte ptr[RCX],DL; }
asm { mov byte ptr res[EBP],DL; }
}
else
{
static if(T.sizeof == 2)
{
asm { mov DX,incV; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xadd short ptr[RCX],DX; }
asm { mov short ptr res[EBP],DX; }
}
else
{
static if(T.sizeof == 4)
{
asm { mov EDX,incV; }
asm { mov RCX,posVal; }
asm { lock; }
asm { xadd int ptr[RCX],EDX; }
asm { mov int ptr res[EBP],EDX; }
}
else
{
static if(T.sizeof == 8)
{
asm { mov RAX,val; }
asm { mov RDX,incV; }
asm { lock; }
asm { xadd qword ptr[RAX],RDX; }
asm { mov res[EBP],RDX; }
}
else
{
static assert(0,"Unsupported type size for type:" ~ T.stringof);
}

}

}

}

return res;
}
else
{
return atomicOp(val,delegate T(T a)
{
return a + incV;
}
);
}

}
}
}
else
{
    static if(LockVersion)
{
    template atomicAdd(T,U = T)
{
T atomicAdd(ref T val, U incV_)
{
T incV = cast(T)incV_;
static assert(isIntegerType!(T) || isPointerOrClass!(T),"invalid type: " ~ T.stringof);
synchronized(typeid(T)) {
T oldV = val;
val += incV;
return oldV;
}
}
}
}
else
{
    template atomicAdd(T,U = T)
{
T atomicAdd(ref T val, U incV_)
{
T incV = cast(T)incV_;
static assert(isIntegerType!(T) || isPointerOrClass!(T),"invalid type: " ~ T.stringof);
synchronized(typeid(T)) {
T oldV,newVal,nextVal;
nextVal = val;
do
{
oldV = nextVal;
newV = oldV + incV;
auto nextVal = atomicCAS!(T)(val,newV,oldV);
}
while (nextVal != oldV);return oldV;
}
}
}
}
}
}
}
template atomicOp(T)
{
T atomicOp(ref T val, T delegate(T) f)
{
T oldV,newV,nextV;
int i = 0;
nextV = val;
do
{
oldV = nextV;
newV = f(oldV);
nextV = aCas!(T)(val,newV,oldV);
if (nextV is oldV || newV is oldV)
return oldV;
}
while (++i < 200);while (true)
{
thread_yield();
oldV = val;
newV = f(oldV);
nextV = aCas!(T)(val,newV,oldV);
if (nextV is oldV || newV is oldV)
return oldV;
}
}
}
template flagGet(T)
{
T flagGet(ref T flag)
{
T res;
res = flag;
memoryBarrier!(true,false,strictFences,false)();
return res;
}
}
template flagSet(T)
{
T flagSet(ref T flag, T newVal)
{
memoryBarrier!(false,strictFences,false,true)();
return atomicSwap(flag,newVal);
}
}
template flagOp(T)
{
T flagOp(ref T flag, T delegate(T) op)
{
memoryBarrier!(false,strictFences,false,true)();
return atomicOp(flag,op);
}
}
template flagAdd(T)
{
T flagAdd(ref T flag, T incV = cast(T)1)
{
static if(!LockVersion)
{
memoryBarrier!(false,strictFences,false,true)();
}

return atomicAdd(flag,incV);
}
}
template nextValue(T)
{
T nextValue(ref T val)
{
return atomicAdd(val,cast(T)1);
}
}
