// D import file generated from 'tango/core/sync/Condition.d'
module tango.core.sync.Condition;
public import tango.core.Exception;

public import tango.core.sync.Mutex;

version (Win32)
{
    private import tango.core.sync.Semaphore;

    private import tango.sys.win32.UserGdi;

}
else
{
    version (Posix)
{
    private import tango.core.sync.Config;

    private import tango.stdc.errno;

    private import tango.stdc.posix.pthread;

    private import tango.stdc.posix.time;

}
}
class Condition
{
    this(Mutex m);
    ~this();
    void wait();
    bool wait(double period);
    void notify();
    void notifyAll();
    private version (Win32)
{
    bool timedWait(DWORD timeout);
    void notify(bool all);
    HANDLE m_blockLock;
    HANDLE m_blockQueue;
    Mutex m_assocMutex;
    CRITICAL_SECTION m_unblockLock;
    int m_numWaitersGone = 0;
    int m_numWaitersBlocked = 0;
    int m_numWaitersToUnblock = 0;
}
else
{
    version (Posix)
{
    pthread_cond_t m_hndl;
    pthread_mutex_t* m_mutexAddr;
}
}

}
debug (UnitTest)
{
    private import tango.core.Thread;

    private import tango.core.sync.Mutex;

    private import tango.core.sync.Semaphore;

    void testNotify();
    void testNotifyAll();
    void testWaitTimeout();
    }
