// D import file generated from 'tango/core/sync/ReadWriteMutex.d'
module tango.core.sync.ReadWriteMutex;
public import tango.core.Exception;

private import tango.core.sync.Condition;

private import tango.core.sync.Mutex;

version (Win32)
{
    private import tango.sys.win32.UserGdi;

}
else
{
    version (Posix)
{
    private import tango.stdc.posix.pthread;

}
}
class ReadWriteMutex
{
    enum Policy 
{
PREFER_READERS,
PREFER_WRITERS,
}
    this(Policy policy = Policy.PREFER_WRITERS);
    Policy policy()
{
return m_policy;
}
    @property Reader reader()
{
return m_reader;
}

    @property Writer writer()
{
return m_writer;
}

    class Reader : Object.Monitor
{
    this()
{
m_proxy.link = this;
(cast(void**)this)[1] = &m_proxy;
}
    void lock();
    void unlock();
    bool tryLock();
    private 
{
    bool shouldQueueReader();
    struct MonitorProxy
{
    Object.Monitor link;
}
    MonitorProxy m_proxy;
}
}
    class Writer : Object.Monitor
{
    this()
{
m_proxy.link = this;
(cast(void**)this)[1] = &m_proxy;
}
    void lock();
    void unlock();
    bool tryLock();
    private 
{
    bool shouldQueueWriter();
    struct MonitorProxy
{
    Object.Monitor link;
}
    MonitorProxy m_proxy;
}
}
    private 
{
    Policy m_policy;
    Reader m_reader;
    Writer m_writer;
    Mutex m_commonMutex;
    Condition m_readerQueue;
    Condition m_writerQueue;
    int m_numQueuedReaders;
    int m_numActiveReaders;
    int m_numQueuedWriters;
    int m_numActiveWriters;
}
}
debug (UnitTest)
{
    private import tango.core.Thread;

    void testRead(ReadWriteMutex.Policy policy);
    void testReadWrite(ReadWriteMutex.Policy policy);
    }
