// D import file generated from 'tango/core/sync/Semaphore.d'
module tango.core.sync.Semaphore;
public import tango.core.Exception;

version (Win32)
{
    private import tango.sys.win32.UserGdi;

}
else
{
    version (Posix)
{
    private import tango.core.sync.Config;

    private import tango.stdc.errno;

    private import tango.stdc.posix.pthread;

    private import tango.stdc.posix.semaphore;

}
}
class Semaphore
{
    this(uint count = 0);
    ~this();
    void wait();
    bool wait(double period);
    void notify();
    bool tryWait();
    private version (Win32)
{
    HANDLE m_hndl;
}
else
{
    version (darwin)
{
    task_t creatingTask;
    semaphore_t m_hndl;
}
else
{
    version (Posix)
{
    sem_t m_hndl;
}
}
}

}
debug (UnitTest)
{
    private import tango.core.Thread;

    void testWait();
    void testWaitTimeout();
    }
