// D import file generated from 'tango/core/tools/Demangler.d'
module tango.core.tools.Demangler;
version (TangoDemangler)
{
    import tango.core.Traits;
    import tango.stdc.string;
    debug (traceDemangler)
{
    import tango.io.Stdout;
}
    version (DigitalMars)
{
    version (Windows)
{
    bool isMD5Hashed(const(char)[] name);
    const(char)[] decompressOMFSymbol(const(char)[] garbled, char[]* buf)
{
int ungarbledLength = 0;
bool compressed = false;
{
for (int ci = 0;
 ci < garbled.length; ++ci)
{
{
char c = garbled[ci];
if (0 == (c & 128))
{
++ungarbledLength;
}
else
{
compressed = true;
int matchLen = void;
if (c & 64)
{
matchLen = (c & 7) + 1;
}
else
{
if (ci + 2 >= garbled.length)
{
return garbled;
}
else
{
matchLen = cast(int)(c & 56) << 4;
matchLen += garbled[ci + 1] & ~128;
ci += 2;
}
}
ungarbledLength += matchLen;
}
}
}
}
if (!compressed || ungarbledLength > (*buf).length)
{
return garbled;
}
else
{
char[] ungarbled = (*buf)[$ - ungarbledLength..$];
*buf = (*buf)[0..$ - ungarbledLength];
int ui = 0;
{
for (int ci = 0;
 ci < garbled.length; ++ci)
{
{
char c = garbled[ci];
if (0 == (c & 128))
{
ungarbled[ui++] = c;
}
else
{
int matchOff = void;
int matchLen = void;
if (c & 64)
{
matchOff = (c >> 3 & 7) + 1;
matchLen = (c & 7) + 1;
}
else
{
matchOff = cast(int)(c & 7) << 7;
matchLen = cast(int)(c & 56) << 4;
matchLen += garbled[ci + 1] & ~128;
matchOff += garbled[ci + 2] & ~128;
ci += 2;
}
int matchStart = ui - matchOff;
if (matchStart + matchLen > ui)
{
return garbled;
}
const(char)[] match = ungarbled[matchStart..matchStart + matchLen];
ungarbled[ui..ui + matchLen] = match;
ui += matchLen;
}
}
}
}
return ungarbled;
}
}
}
}
    const(char)[] decompressSymbol(const(char)[] func, char[]* buf);
    uint toUint(const(char)[] s)
{
uint res = 0;
{
for (int i = 0;
 i < s.length; ++i)
{
{
if (s[i] >= '0' && s[i] <= '9')
{
res *= 10;
res += s[i] - '0';
}
else
{
assert(false);
}
}
}
}
return res;
}
    public class Demangler
{
    uint templateExpansionDepth = 1;
    bool foldDefaults = false;
    bool expandFunctionTypes = false;
    bool printTypeKind = false;
    public void verbosity(uint level);

    this()
{
verbosity(1);
}
    this(uint verbosityLevel)
{
verbosity(verbosityLevel);
}
    public inout(char)[] demangle(inout(char)[] input)
{
char[4096] buf = void;
auto res = DemangleInstance(this,input,buf);
if (res.mangledName() && res.input.length == 0)
{
return cast(inout(char)[])res.slice().dup;
}
else
{
if (res.slice().length)
res.output.append(" ");
if (res.type() && res.input.length == 0)
{
return cast(inout(char)[])res.slice().dup;
}
else
{
return input;
}
}
}

    public inout(char)[] demangle(inout(char)[] input, char[] output)
{
auto res = DemangleInstance(this,input,output);
if (res.mangledName() && res.input.length == 0)
{
return cast(inout(char)[])res.slice();
}
else
{
if (res.slice().length)
res.output.append(" ");
if (res.type() && res.input.length == 0)
{
return cast(inout(char)[])res.slice();
}
else
{
return input;
}
}
}

    struct DemangleInstance
{
    debug (traceDemangler)
{
    private const(char)[][] _trace;

}
    private const(char)[] input;

    private uint _templateDepth;

    Buffer output;
    Demangler prefs;
    struct BufState
{
    DemangleInstance* dem;
    const(char)[] input;
    size_t len;
    static BufState opCall(ref DemangleInstance dem)
{
BufState res;
res.dem = &dem;
res.len = dem.output.length;
res.input = dem.input;
return res;
}

    bool reset()
{
dem.output.length = len;
dem.input = input;
return false;
}
    bool resetOutput()
{
dem.output.length = len;
return false;
}
    const(char)[] sliceFrom()
{
return dem.output.data[len..dem.output.length];
}
}
    BufState checkpoint()
{
return BufState(this);
}
    static DemangleInstance opCall(Demangler prefs, const(char)[] input, const(char)[] output);

    debug (traceDemangler)
{
    private void trace(const(char)[] where);

    private template report(T...)
{
void report(const(char)[] fmt, T args)
{
int len = _trace.length;
const(char)[] spaces = "            ";
spaces = spaces[0..len < spaces.length ? len : spaces.length];
Stdout(spaces);
Stdout.formatln(fmt,args);
}
}

    private void trace(bool result)
{
_trace = _trace[0..$ - 1];
int len = _trace.length;
const(char)[] spaces = "            ";
spaces = spaces[0..len < spaces.length ? len : spaces.length];
Stdout(spaces);
if (!result)
Stdout.formatln("fail");
else
Stdout.formatln("success");
}

}
    const(char)[] slice()
{
return output.slice();
}
    private const(char)[] consume(uint amt)
{
const(char)[] tmp = input[0..amt];
input = input[amt..$];
return tmp;
}

    bool mangledName();
    bool typedqualifiedName();
    bool qualifiedName(bool aliasHack = false);
    bool symbolName(bool aliasHack = false);
    bool lName();
    bool lNameAliasHack();
    bool number(ref uint value);
    bool numberNoParse();
    bool name(uint count);
    bool type();
    bool typeFunction();
    bool arguments();
    bool argument();
    bool typeNamed();
    bool templateInstanceName();
    bool templateArgs();
    bool templateArg();
    bool value();
    bool hexFloat();
    static bool isHexDigit(char c)
{
return c > '0' && c < '9' || c > 'a' && c < 'f' || c > 'A' && c < 'F';
}

    bool hexNumber(ref ulong value);
}
}

    private struct Buffer
{
    char[] data;
    size_t length;
    void append(const(char)[] s)
{
assert(this.length + s.length <= data.length);
size_t len = this.length + s.length;
if (len > data.length)
len = data.length;
data[this.length..len] = s[0..len - this.length];
this.length = len;
}
    void append(char c)
{
assert(this.length < data.length);
data[this.length..this.length + 1] = c;
this.length += 1;
}
    void append(Buffer b)
{
append(b.slice());
}
    template slice()
{
const(char)[] slice()
{
return data[0..this.length];
}
}
}

    static Demangler demangler;

    static this();
}
else
{
    import core = core.demangle;
    public class Demangler
{
    public inout(char)[] demangle(inout(char)[] input)
{
return cast(typeof(return))core.demangle(input);
}

    public inout(char)[] demangle(inout(char)[] input, char[] output)
{
return cast(typeof(return))core.demangle(input,output);
}

}

    static Demangler demangler;

    static this();
}
