// D import file generated from 'tango/io/FilePath.d'
module tango.io.FilePath;
private import tango.io.Path;

private import tango.io.model.IFile;

private import tango.stdc.string;

class FilePath : PathView
{
    private PathParser!(char) p;

    private bool dir_;

    final template opOpAssign(immutable(char)[] s : "~")
{
FilePath opOpAssign(const(char)[] path)
{
return append(path);
}
}

    public alias bool delegate(FilePath, bool) Filter;

    static FilePath opCall(char[] filepath = null)
{
return new FilePath(filepath);
}

    this(char[] filepath = null)
{
set(filepath,true);
}
    const final override string toString()
{
return (cast(const(char)[])p.toString()).idup;
}

    const final @property FilePath dup()
{
return FilePath(p.toString().dup);
}

    final inout inout(char)[] cString()
{
return p.fp[0..p.end_ + 1];
}

    final @property inout inout(char)[] root()
{
return p.root;
}

    final @property inout inout(char)[] folder()
{
return p.folder;
}

    final @property inout inout(char)[] parent()
{
return p.parent;
}

    final @property inout inout(char)[] name()
{
return p.name;
}

    final @property char[] ext()
{
return p.ext;
}

    final @property inout inout(char)[] suffix()
{
return p.suffix;
}

    final @property inout inout(char)[] path()
{
return p.path;
}

    final @property inout inout(char)[] file()
{
return p.file;
}

    const final override bool opEquals(Object o)
{
return this is o || o && opEquals(o.toString());
}

    const final bool opEquals(const(char)[] s)
{
return p.equals(s);
}

    const final @property bool isAbsolute()
{
return p.isAbsolute;
}

    const final @property bool isEmpty()
{
return p.isEmpty;
}

    const final @property bool isChild()
{
return p.isChild;
}

    final FilePath replace(char from, char to)
{
.replace(path,from,to);
return this;
}

    final @property FilePath standard()
{
.standard(path);
return this;
}

    final @property FilePath native()
{
.native(path);
return this;
}

    final FilePath cat(const(char)[][] others...);

    final FilePath append(const(char)[] path)
{
if (file.length)
path = prefixed(path);
return cat(path);
}

    final FilePath prepend(const(char)[] path)
{
adjust(0,p.folder_,p.folder_,padded(path));
return parse();
}

    FilePath set(FilePath path)
{
return set(path.toString(),false);
}
    final FilePath set(const(char)[] path, bool convert = false)
{
p.end_ = cast(int)path.length;
expand(p.end_);
if (p.end_)
{
p.fp[0..p.end_] = path;
if (convert)
.standard(p.fp[0..p.end_]);
}
p.fp[p.end_] = '\x00';
return parse();
}

    final @property FilePath isFolder(bool folder)
{
dir_ = folder;
return this;
}

    final @property FilePath root(const(char)[] other)
{
auto x = adjust(0,p.folder_,p.folder_,padded(other,':'));
p.folder_ += x;
p.suffix_ += x;
p.name_ += x;
return this;
}

    final @property FilePath folder(const(char)[] other)
{
auto x = adjust(p.folder_,p.name_,p.name_ - p.folder_,padded(other));
p.suffix_ += x;
p.name_ += x;
return this;
}

    final @property FilePath name(const(char)[] other)
{
auto x = adjust(p.name_,p.suffix_,p.suffix_ - p.name_,other);
p.suffix_ += x;
return this;
}

    final @property FilePath suffix(const(char)[] other)
{
adjust(p.suffix_,p.end_,p.end_ - p.suffix_,prefixed(other,'.'));
return this;
}

    final @property FilePath path(const(char)[] other)
{
adjust(0,p.name_,p.name_,padded(other));
return parse();
}

    final @property FilePath file(const(char)[] other)
{
adjust(p.name_,p.end_,p.end_ - p.name_,other);
return parse();
}

    final FilePath pop();

    static char[] join(const(char)[][] paths...)
{
return FS.join(paths);
}

    final FilePath absolute(const(char)[] prefix)
{
if (!isAbsolute)
prepend(padded(prefix));
return this;
}

    static inout(char)[] stripped(inout(char)[] path, char c = FileConst.PathSeparatorChar)
{
return FS.stripped(path,c);
}

    static inout(char[]) padded(inout(char[]) path, char c = FileConst.PathSeparatorChar)
{
return FS.padded(path,c);
}

    static char[] prefixed(const(char)[] s, char c = FileConst.PathSeparatorChar)
{
if (s.length && s[0] != c)
s = c ~ s;
return s.dup;
}

    private final FilePath parse()
{
p.parse(p.fp,p.end_);
return this;
}


    private final void expand(size_t size)
{
++size;
if (p.fp.length < size)
p.fp.length = size + 127 & ~127;
}


    private final int adjust(int head, int tail, int len, const(char)[] sub)
{
len = cast(int)(sub.length - len);
if (len && sub.ptr >= p.fp.ptr + head + len && sub.ptr < p.fp.ptr + p.fp.length)
{
char[512] tmp = void;
assert(sub.length < tmp.length);
sub = (tmp[0..sub.length] = sub);
}
expand(len + p.end_);
memmove(p.fp.ptr + tail + len,p.fp.ptr + tail,p.end_ + 1 - tail);
memmove(p.fp.ptr + head,sub.ptr,sub.length);
p.end_ += len;
return len;
}


    final FilePath create()
{
createPath(this.toString());
return this;
}

    final FilePath[] toList(Filter filter = null);

    static FilePath from(ref FileInfo info)
{
char[512] tmp = void;
auto len = info.path.length + info.name.length;
assert(tmp.length - len > 1);
tmp[0..info.path.length] = info.path;
tmp[info.path.length..len] = info.name;
return FilePath(tmp[0..len]).isFolder(info.folder);
}

    final @property inout bool exists()
{
auto cstr = cString();
return FS.exists(cstr);
}

    const final @property Time modified()
{
return timeStamps().modified;
}

    const final @property Time accessed()
{
return timeStamps().accessed;
}

    const final @property Time created()
{
return timeStamps().created;
}

    final FilePath rename(FilePath dst)
{
FS.rename(cString(),dst.cString());
return this.set(dst);
}

    final inout inout(FilePath) copy(const(char)[] source)
{
FS.copy(source ~ '\x00',cString());
return this;
}

    const final ulong fileSize()
{
return FS.fileSize(cString());
}

    const final @property bool isWritable()
{
return FS.isWritable(cString());
}

    const final @property bool isFolder()
{
if (dir_)
return true;
return FS.isFolder(cString());
}

    const final @property bool isFile()
{
if (dir_)
return false;
return FS.isFile(cString());
}

    const final Stamps timeStamps()
{
return FS.timeStamps(cString());
}

    final inout inout(FilePath) copy(const(FilePath) src)
{
FS.copy(src.cString(),cString());
return this;
}

    final inout inout(FilePath) remove()
{
FS.remove(cString());
return this;
}

    final FilePath rename(const(char)[] dst)
{
FS.rename(cString(),dst ~ '\x00');
return this.set(dst,true);
}

    final inout inout(FilePath) createFile()
{
FS.createFile(cString());
return this;
}

    final inout inout(FilePath) createFolder()
{
FS.createFolder(cString());
return this;
}

    const final int opApply(scope int delegate(ref FileInfo) dg)
{
return FS.list(cString(),dg);
}

}
interface PathView
{
    alias FS.Stamps Stamps;
    const immutable(char)[] toString();

    template cString()
{
inout inout(char)[] cString();
}
    @property inout inout(char)[] root();

    @property inout inout(char)[] folder();

    @property inout inout(char)[] name();

    @property char[] ext();

    @property inout inout(char)[] suffix();

    @property inout inout(char)[] path();

    @property inout inout(char)[] file();

    const @property bool isAbsolute();

    const @property bool isEmpty();

    const @property bool isChild();

    @property inout bool exists();

    const @property Time modified();

    const @property Time accessed();

    const @property Time created();

    const @property ulong fileSize();

    const @property bool isWritable();

    const @property bool isFolder();

    const @property Stamps timeStamps();

}
debug (UnitTest)
{
    }
debug (FilePath)
{
    import tango.io.Console;
    void main()
{
assert(FilePath("/foo/").create.exists);
Cout(FilePath("c:/temp/").file("foo.bar")).newline;
}
}
