// D import file generated from 'tango/io/UnicodeFile.d'
module tango.io.UnicodeFile;
private import tango.io.device.File;

public import tango.text.convert.UnicodeBom;

template UnicodeFile(T)
{
class UnicodeFile
{
    private UnicodeBom!(T) bom_;

    private const(char)[] path_;

    this(const(char)[] path, Encoding encoding)
{
bom_ = new UnicodeBom!(T)(encoding);
path_ = path;
}
    static UnicodeFile opCall(const(char)[] name, Encoding encoding)
{
return new UnicodeFile(name,encoding);
}

    override immutable(char)[] toString()
{
return path_.idup;
}

    Encoding encoding()
{
return bom_.encoding;
}
    UnicodeBom!(T) bom()
{
return bom_;
}
    final T[] read()
{
auto content = File.get(path_);
return bom_.decode(content);
}

    final void write(const(T)[] content, bool writeBom)
{
void[] converted = bom_.encode(content.dup);
scope conduit = new File(path_,File.ReadWriteCreate);
scope(exit) conduit.close();
if (writeBom)
conduit.write(bom_.signature);
conduit.write(converted);
}

    final void append(const(T)[] content)
{
File.append(path_,bom_.encode(content.dup));
}

}
}
debug (UnicodeFile)
{
    import tango.io.Stdout;
    void main()
{
auto file = UnicodeFile!(char)("UnicodeFile.d",Encoding.UTF_8);
auto content = file.read;
Stdout(content).newline;
}
}
