// D import file generated from 'tango/io/device/Conduit.d'
module tango.io.device.Conduit;
private 
{
    import tango.core.Thread;
    import tango.core.Exception;
}
public import tango.io.model.IConduit;

class Conduit : IConduit
{
    version (TangoRuntime)
{
    protected Fiber.Scheduler scheduler;

}
    private uint duration = -1;

    this();
    ~this()
{
detach();
}
    abstract override string toString();

    const abstract size_t bufferSize();

    abstract size_t read(void[] dst);

    abstract size_t write(const(void)[] src);

    abstract void detach();

    final @property void timeout(uint millisec)
{
duration = millisec;
}

    const final @property uint timeout()
{
return duration;
}

    const @property bool isAlive()
{
return true;
}

    final @property IConduit conduit()
{
return this;
}

    IOStream flush()
{
return this;
}
    void close()
{
this.detach();
}
    final void error(const(char[]) msg);

    final @property InputStream input()
{
return this;
}

    final @property OutputStream output()
{
return this;
}

    final Conduit put(void[] src)
{
put(src,this);
return this;
}

    final Conduit get(void[] dst)
{
get(dst,this);
return this;
}

    final Conduit rewind()
{
seek(0);
return this;
}

    OutputStream copy(InputStream src, size_t max = -1)
{
transfer(src,this,max);
return this;
}
    long seek(long offset, Anchor anchor = Anchor.Begin)
{
error(this.toString() ~ " does not support seek requests");
return 0;
}
    template text(T = char)
{
char[] text(size_t max = -1)
{
return cast(T[])load(max);
}
}
    void[] load(size_t max = -1)
{
return load(this,max);
}
    static void[] load(InputStream src, size_t max = -1);

    static void put(void[] src, OutputStream output);

    static void get(void[] dst, InputStream input);

    static size_t transfer(InputStream src, OutputStream dst, size_t max = -1);

}
class InputFilter : InputStream
{
    protected InputStream source;

    this(InputStream source)
{
this.source = source;
}
    @property IConduit conduit()
{
return source.conduit;
}

    size_t read(void[] dst)
{
return source.read(dst);
}
    void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}
    IOStream flush()
{
source.flush();
return this;
}
    long seek(long offset, Anchor anchor = Anchor.Begin)
{
return source.seek(offset,anchor);
}
    @property InputStream input()
{
return source;
}

    void close()
{
source.close();
}
}
class OutputFilter : OutputStream
{
    protected OutputStream sink;

    this(OutputStream sink)
{
this.sink = sink;
}
    @property IConduit conduit()
{
return sink.conduit;
}

    size_t write(const(void)[] src)
{
return sink.write(src);
}
    OutputStream copy(InputStream src, size_t max = -1)
{
Conduit.transfer(src,this,max);
return this;
}
    IOStream flush()
{
sink.flush();
return this;
}
    long seek(long offset, Anchor anchor = Anchor.Begin)
{
return sink.seek(offset,anchor);
}
    @property OutputStream output()
{
return sink;
}

    void close()
{
sink.close();
}
}
