// D import file generated from 'tango/io/device/Device.d'
module tango.io.device.Device;
private import tango.sys.Common;

public import tango.io.device.Conduit;

class Device : Conduit,ISelectable
{
    public alias Conduit.error error;

    final void error()
{
error(this.toString() ~ " :: " ~ SysError.lastMsg);
}

    override immutable(char)[] toString()
{
return "<device>";
}

    const override size_t bufferSize()
{
return 1024 * 16;
}

    version (Win32)
{
    struct IO
{
    OVERLAPPED asynch;
    Handle handle;
    bool track;
    void* task;
}
    protected IO io;

    protected void reopen(Handle handle)
{
io.handle = handle;
}

    final @property Handle fileHandle()
{
return io.handle;
}

    version (TangoRuntime)
{
    override void dispose()
{
if (io.handle != INVALID_HANDLE_VALUE)
if (scheduler)
scheduler.close(io.handle,toString);
detach();
}

}
    override void detach()
{
if (io.handle != INVALID_HANDLE_VALUE)
CloseHandle(io.handle);
io.handle = INVALID_HANDLE_VALUE;
}

    override size_t read(void[] dst);

    override size_t write(const(void)[] src);

    version (TangoRuntime)
{
    protected final size_t wait(scheduler.Type type, uint bytes, uint timeout);


}
}
    version (Posix)
{
    protected int handle = -1;

    protected void reopen(Handle handle)
{
this.handle = handle;
}

    final @property Handle fileHandle()
{
return cast(Handle)handle;
}

    override void detach()
{
if (handle >= 0)
{
posix.close(handle);
}
handle = -1;
}

    override size_t read(void[] dst)
{
auto read = posix.read(handle,dst.ptr,dst.length);
if (read is -1)
error();
else
if (read is 0 && dst.length > 0)
return Eof;
return read;
}

    override size_t write(const(void)[] src)
{
size_t written = posix.write(handle,src.ptr,src.length);
if (written is -1)
error();
return written;
}

}
}
