// D import file generated from 'tango/io/device/SerialPort.d'
module tango.io.device.SerialPort;
private import tango.core.Array;

private 
{
    import tango.core.Exception;
    import tango.io.device.Device;
    import tango.stdc.stringz;
    import tango.sys.Common;
}
version (Windows)
{
    private import Integer = tango.text.convert.Integer;

    private import tango.stdc.stringz;

}
else
{
    version (Posix)
{
    private 
{
    import tango.io.FilePath;
    import tango.stdc.posix.termios;
}
}
}
class SerialPort : Device
{
    private const(char)[] str;

    private static const(char)[][] _ports;


    this(const(char)[] port)
{
create(port);
}
    override string toString()
{
return str.idup;
}

    SerialPort speed(uint speed);
    static const(char)[][] ports();

    version (Win32)
{
    private void create(const(char)[] port)
{
str = port;
io.handle = CreateFileA(("\\\\.\\" ~ port).toStringz(),GENERIC_READ | GENERIC_WRITE,0,null,OPEN_EXISTING,0,null);
if (io.handle is INVALID_HANDLE_VALUE)
{
error();
}
DCB config;
GetCommState(io.handle,&config);
config.BaudRate = 9600;
config.ByteSize = 8;
config.Parity = NOPARITY;
config.StopBits = ONESTOPBIT;
config.flag0 |= bm_DCB_fBinary | bm_DCB_fParity;
if (!SetCommState(io.handle,&config))
error();
}

}
    version (Posix)
{
    private __gshared static speed_t[uint] baudRates;



    shared static this();
    private void create(const(char)[] file);

    private void makeRaw(termios* options)
{
options.c_iflag &= ~(IGNBRK | BRKINT | PARMRK | ISTRIP | INLCR | IGNCR | ICRNL | IXON);
options.c_oflag &= ~OPOST;
options.c_lflag &= ~(ECHO | ECHONL | ICANON | ISIG | IEXTEN);
options.c_cflag &= ~(CSIZE | PARENB);
options.c_cflag |= CS8;
}

    private static inout(char)[] rest(inout(char)[] str, in char[] prefix)
{
if (str.length < prefix.length)
return null;
if (str[0..prefix.length] != prefix)
return null;
return str[prefix.length..$];
}


    private static bool isInRange(const(char)[] str, char lower, char upper);


}
}
