// D import file generated from 'tango/io/device/ThreadPipe.d'
module tango.io.device.ThreadPipe;
private import tango.core.Exception;

private import tango.io.device.Conduit;

private import tango.core.sync.Condition;

class ThreadPipe : Conduit
{
    private bool _closed;

    private 
{
    size_t _readIdx;
    size_t _remaining;
}
    private void[] _buf;

    private Mutex _mutex;

    private Condition _condition;

    this(size_t bufferSize = 1024 * 16)
{
_buf = new ubyte[](bufferSize);
_closed = false;
_readIdx = (_remaining = 0);
_mutex = new Mutex;
_condition = new Condition(_mutex);
}
    const override size_t bufferSize()
{
return _buf.length;
}

    override string toString()
{
return "<threadpipe>";
}

    const override bool isAlive();

    size_t remaining();
    size_t writable();
    void stop();
    override void detach()
{
}

    override size_t read(void[] dst);

    ThreadPipe clear();
    override size_t write(const(void)[] src);

}
debug (UnitTest)
{
    import tango.core.Thread;
    }
