// D import file generated from 'tango/io/model/IConduit.d'
module tango.io.model.IConduit;
interface IConduit : InputStream,OutputStream
{
    abstract @property size_t bufferSize();

    abstract immutable(char)[] toString();

    const abstract @property bool isAlive();

    abstract void detach();

    abstract void error(const(char[]) msg);

    interface Seek
{
}
    interface Truncate
{
    void truncate(long size);
}
}
interface ISelectable
{
    version (Windows)
{
    alias void* Handle;
}
else
{
    alias int Handle;
}
    @property Handle fileHandle();

}
interface IOStream
{
    enum Eof = -1;
    enum Anchor 
{
Begin = 0,
Current = 1,
End = 2,
}
    long seek(long offset, Anchor anchor = Anchor.Begin);
    @property IConduit conduit();

    IOStream flush();
    void close();
    interface Mutator
{
}
}
interface InputStream : IOStream
{
    size_t read(void[] dst);
    void[] load(size_t max = -1);
    @property InputStream input();

}
interface OutputStream : IOStream
{
    size_t write(const(void)[] src);
    OutputStream copy(InputStream src, size_t max = -1);
    @property OutputStream output();

}
interface InputBuffer : InputStream
{
    void[] slice();
    bool next(scope size_t delegate(const(void)[]) scan);
    size_t reader(scope size_t delegate(const(void)[]) consumer);
}
interface OutputBuffer : OutputStream
{
    alias append opCall;
    void[] slice();
    OutputBuffer append(const(void)[]);
    size_t writer(size_t delegate(void[]) producer);
}
