// D import file generated from 'tango/io/stream/Bzip.d'
module tango.io.stream.Bzip;
private import tango.util.compress.c.bzlib;

private import tango.core.Exception;

private import tango.io.device.Conduit;

private import tango.io.model.IConduit;

private 
{
    private enum 
{
BUFFER_SIZE = 4 * 1024,
}

    private enum 
{
DEFAULT_BLOCKSIZE = 9,
}

    private enum 
{
DEFAULT_WORKFACTOR = 0,
}

}
class BzipOutput : OutputFilter
{
    enum BlockSize : int
{
Normal = 9,
Fast = 1,
Best = 9,
}
    private 
{
    bool bzs_valid = false;
    bz_stream bzs;
    ubyte[] out_chunk;
    size_t _written = 0;
}
    this(OutputStream stream, int blockSize = BlockSize.Normal);
    private void init(OutputStream stream, int blockSize);

    ~this()
{
if (bzs_valid)
kill_bzs();
}
    void reset(OutputStream stream, int blockSize = BlockSize.Normal);
    override size_t write(const(void)[] src);

    size_t written()
{
return _written;
}
    override void close()
{
if (bzs_valid)
commit();
super.close();
}

    void commit();
    override long seek(long offset, Anchor anchor = Anchor.Begin);

    private void kill_bzs()
{
check_valid();
BZ2_bzCompressEnd(&bzs);
bzs_valid = false;
}

    private void check_valid();

}
class BzipInput : InputFilter
{
    private 
{
    bool bzs_valid = false;
    bz_stream bzs;
    ubyte[] in_chunk;
}
    this(InputStream stream, bool small = false);
    private void init(InputStream stream, bool small);

    ~this()
{
if (bzs_valid)
kill_bzs();
}
    void reset(InputStream stream, bool small = false);
    override size_t read(void[] dst);

    override void close()
{
check_valid();
kill_bzs();
super.close();
}

    override long seek(long offset, Anchor anchor = Anchor.Begin);

    private void kill_bzs()
{
check_valid();
BZ2_bzDecompressEnd(&bzs);
bzs_valid = false;
}

    private void check_valid();

}
class BzipException : IOException
{
    this(in int code)
{
super(codeName(code));
}
    this(string msg)
{
super(msg);
}
    private string codeName(in int code);

}
class BzipClosedException : IOException
{
    this()
{
super("cannot operate on closed bzip2 stream");
}
}
class BzipStillOpenException : IOException
{
    this()
{
super("cannot reset an open bzip2 stream");
}
}
debug (UnitTest)
{
    import tango.io.device.Array;
    }
