// D import file generated from 'tango/io/stream/Data.d'
module tango.io.stream.Data;
private import tango.core.ByteSwap;

private import tango.io.device.Conduit;

private import tango.io.stream.Buffered;

version = DataIntArrayLength;
class DataInput : InputFilter
{
    public alias array get;

    public alias boolean getBool;

    public alias int8 getByte;

    public alias int16 getShort;

    public alias int32 getInt;

    public alias int64 getLong;

    public alias float32 getFloat;

    public alias float64 getDouble;

    public enum 
{
Native = 0,
Network = 1,
Big = 1,
Little = 2,
}

    private bool flip;

    protected InputStream input;

    private Allocate allocator;

    private alias void[] delegate(size_t) Allocate;

    this(InputStream stream);
    final DataInput allocate(Allocate allocate)
{
allocator = allocate;
return this;
}

    final DataInput endian(int e);

    final size_t array(void[] dst);

    final void[] array();

    final bool boolean()
{
bool x;
eat(&x,x.sizeof);
return x;
}

    final byte int8()
{
byte x;
eat(&x,x.sizeof);
return x;
}

    final short int16()
{
short x;
eat(&x,x.sizeof);
if (flip)
ByteSwap.swap16(&x,x.sizeof);
return x;
}

    final int int32()
{
int x;
eat(&x,x.sizeof);
if (flip)
ByteSwap.swap32(&x,x.sizeof);
return x;
}

    final long int64()
{
long x;
eat(&x,x.sizeof);
if (flip)
ByteSwap.swap64(&x,x.sizeof);
return x;
}

    final float float32()
{
float x;
eat(&x,x.sizeof);
if (flip)
ByteSwap.swap32(&x,x.sizeof);
return x;
}

    final double float64()
{
double x;
eat(&x,x.sizeof);
if (flip)
ByteSwap.swap64(&x,x.sizeof);
return x;
}

    final override size_t read(void[] data)
{
eat(data.ptr,data.length);
return data.length;
}

    private final void eat(void* dst, size_t bytes);


}
class DataOutput : OutputFilter
{
    public alias array put;

    public alias boolean putBool;

    public alias int8 putByte;

    public alias int16 putShort;

    public alias int32 putInt;

    public alias int64 putLong;

    public alias float32 putFloat;

    public alias float64 putFloat;

    public enum 
{
Native = 0,
Network = 1,
Big = 1,
Little = 2,
}

    private bool flip;

    private OutputStream output;

    this(OutputStream stream)
{
super(output = BufferedOutput.create(stream));
}
    final DataOutput endian(int e);

    final ulong array(const(void)[] src);

    final void boolean(bool x)
{
eat(&x,x.sizeof);
}

    final void int8(byte x)
{
eat(&x,x.sizeof);
}

    final void int16(short x)
{
if (flip)
ByteSwap.swap16(&x,x.sizeof);
eat(&x,x.sizeof);
}

    final void int32(int x)
{
if (flip)
ByteSwap.swap32(&x,x.sizeof);
eat(&x,(uint).sizeof);
}

    final void int64(long x)
{
if (flip)
ByteSwap.swap64(&x,x.sizeof);
eat(&x,x.sizeof);
}

    final void float32(float x)
{
if (flip)
ByteSwap.swap32(&x,x.sizeof);
eat(&x,x.sizeof);
}

    final void float64(double x)
{
if (flip)
ByteSwap.swap64(&x,x.sizeof);
eat(&x,x.sizeof);
}

    final override size_t write(const(void)[] data)
{
eat(data.ptr,data.length);
return data.length;
}

    private final void eat(in void* src, size_t bytes)
{
auto count = output.write(src[0..bytes]);
assert(count is bytes);
}


}
debug (UnitTest)
{
    import tango.io.device.Array;
    }
debug (Data)
{
    import tango.io.device.Array;
    void main()
{
auto buf = new Array(64);
auto output = new DataOutput(buf);
output.array("blah blah");
output.int32(1024);
auto input = new DataInput(buf);
assert(input.array.length is 9);
assert(input.int32 is 1024);
}
}
