// D import file generated from 'tango/io/stream/Digester.d'
module tango.io.stream.Digester;
private import tango.io.device.Conduit;

private import tango.util.digest.Digest;

class DigestInput : InputFilter,InputFilter.Mutator
{
    private Digest filter;

    this(InputStream stream, Digest digest)
{
super(stream);
filter = digest;
}
    final override size_t read(void[] dst)
{
auto len = source.read(dst);
if (len != Eof)
filter.update(dst[0..len]);
return len;
}

    final DigestInput slurp(void[] dst = null);

    final Digest digest()
{
return filter;
}

}
class DigestOutput : OutputFilter,InputFilter.Mutator
{
    private Digest filter;

    this(OutputStream stream, Digest digest)
{
super(stream);
filter = digest;
}
    final override size_t write(const(void)[] src)
{
auto len = sink.write(src);
if (len != Eof)
filter.update(src[0..len]);
return len;
}

    final Digest digest()
{
return filter;
}

}
debug (DigestStream)
{
    import tango.io.Stdout;
    import tango.io.device.Array;
    import tango.util.digest.Md5;
    import tango.io.stream.FileStream;
    void main()
{
auto output = new DigestOutput(new Array(1024,1024),new Md5);
output.copy(new FileInput("Digester.d"));
Stdout.formatln("hex digest:{}",output.digest.hexDigest);
}
}
