// D import file generated from 'tango/io/stream/Endian.d'
module tango.io.stream.Endian;
private import tango.core.ByteSwap;

private import tango.io.device.Conduit;

private import tango.io.stream.Buffered;

template EndianInput(T)
{
class EndianInput : InputFilter,InputFilter.Mutator
{
    static if(T.sizeof != 2 && T.sizeof != 4 && T.sizeof != 8)
{
    pragma (msg, "EndianInput :: type should be of length 2, 4, or 8 bytes");
}
    this(InputStream stream)
{
super(BufferedInput.create(stream));
}
    final override size_t read(void[] dst)
{
auto len = source.read(dst[0..dst.length & ~(T.sizeof - 1)]);
if (len != Eof)
{
len &= ~(T.sizeof - 1);
static if(T.sizeof == 2)
{
ByteSwap.swap16(dst.ptr,len);
}

static if(T.sizeof == 4)
{
ByteSwap.swap32(dst.ptr,len);
}

static if(T.sizeof == 8)
{
ByteSwap.swap64(dst.ptr,len);
}

}
return len;
}

}
}
template EndianOutput(T)
{
class EndianOutput : OutputFilter,OutputFilter.Mutator
{
    static if(T.sizeof != 2 && T.sizeof != 4 && T.sizeof != 8)
{
    pragma (msg, "EndianOutput :: type should be of length 2, 4, or 8 bytes");
}
    private OutputBuffer output;

    this(OutputStream stream)
{
super(output = BufferedOutput.create(stream));
}
    final override size_t write(const(void)[] src)
{
size_t writer(void[] dst)
{
auto len = dst.length;
if (len > src.length)
len = src.length;
len &= ~(T.sizeof - 1);
dst[0..len] = src[0..len];
static if(T.sizeof == 2)
{
ByteSwap.swap16(dst.ptr,len);
}

static if(T.sizeof == 4)
{
ByteSwap.swap32(dst.ptr,len);
}

static if(T.sizeof == 8)
{
ByteSwap.swap64(dst.ptr,len);
}

return len;
}
return output.writer(&writer);
}

}
}
debug (UnitTest)
{
    import tango.io.device.Array;
    }
