// D import file generated from 'tango/io/stream/Iterator.d'
module tango.io.stream.Iterator;
private import tango.io.stream.Buffered;

protected import tango.io.device.Conduit;

template Iterator(T)
{
class Iterator : InputFilter
{
    private InputBuffer source;

    protected 
{
    const(T)[] slice;
    const(T)[] delim;
}
    abstract protected size_t scan(const(void)[] data);


    this(InputStream stream = null)
{
super(stream);
if (stream)
set(stream);
}
    Iterator set(InputStream stream)
{
assert(stream);
source = BufferedInput.create(stream);
super.source = source;
return this;
}
    final const(T)[] get()
{
return slice;
}

    int opApply(scope int delegate(ref const(T)[]) dg)
{
bool more;
int result;
do
{
more = consume();
result = dg(slice);
}
while (more && !result);return result;
}
    int opApply(scope int delegate(ref int, ref const(T)[]) dg)
{
bool more;
int result,tokens;
do
{
more = consume();
result = dg(tokens,slice);
++tokens;
}
while (more && !result);return result;
}
    int opApply(scope int delegate(ref int, ref const(T)[], ref const(T)[]) dg)
{
bool more;
int result,tokens;
do
{
delim = null;
more = consume();
result = dg(tokens,slice,delim);
++tokens;
}
while (more && !result);return result;
}
    final @property const(T)[] next()
{
if (consume() || slice.length)
return slice;
return null;
}

    protected final size_t set(const(T)* content, size_t start, size_t end)
{
slice = content[start..end];
return end;
}


    protected final size_t set(const(T)* content, size_t start, size_t end, size_t next)
{
slice = content[start..end];
delim = content[end..next + 1];
return end;
}


    protected final size_t notFound()
{
return Eof;
}


    protected final size_t found(size_t i)
{
return (i + 1) * T.sizeof;
}


    protected final bool has(const(T)[] set, T match)
{
foreach (T c; set)
{
if (match is c)
return true;
}
return false;
}


    private bool consume()
{
if (source.next(&scan))
return true;
source.reader(delegate (const(void)[] arr)
{
slice = (cast(const(T)*)arr.ptr)[0..arr.length / T.sizeof];
return cast(size_t)arr.length;
}
);
return false;
}

}
}
