// D import file generated from 'tango/io/stream/Map.d'
module tango.io.stream.Map;
private 
{
    import tango.io.stream.Lines;
    import tango.io.stream.Buffered;
}
private import Text = tango.text.Util;

private import tango.io.device.Conduit;

template MapInput(T)
{
class MapInput : Lines!(T)
{
    this(InputStream stream)
{
super(stream);
}
    final int opApply(scope int delegate(ref const(T)[] name, ref const(T)[] value) dg)
{
int ret;
foreach (line; super)
{
auto text = Text.trim(line);
if (text.length && text[0] != '#')
{
auto i = Text.locate(text,cast(T)'=');
if (i < text.length)
{
auto name = Text.trim(text[0..i]);
auto value = Text.trim(text[i + 1..$]);
if ((ret = dg(name,value)) != 0)
break;
}
}
}
return ret;
}

    final MapInput load(ref const(T)[][T[]] properties)
{
foreach (name, value; this)
{
properties[name] = value;
}
return this;
}

}
}
template MapOutput(T)
{
class MapOutput : OutputFilter
{
    private const(T)[] eol;

    private enum const(T)[] prefix = "# ";

    private enum const(T)[] equals = " = ";

    version (Win32)
{
    private enum const(T)[] NL = "\x0d\x0a";

}
    version (Posix)
{
    private enum const(T)[] NL = "\x0a";

}
    this(OutputStream stream, const(T)[] newline = NL)
{
super(BufferedOutput.create(stream));
eol = newline;
}
    final MapOutput newline()
{
sink.write(eol);
return this;
}

    final MapOutput comment(const(T)[] text)
{
sink.write(prefix);
sink.write(text);
sink.write(eol);
return this;
}

    final MapOutput append(const(T)[] name, const(T)[] value)
{
sink.write(name);
sink.write(equals);
sink.write(value);
sink.write(eol);
return this;
}

    final MapOutput append(const(T)[][T[]] properties)
{
foreach (key, value; properties)
{
append(key,value);
}
return this;
}

}
}
debug (UnitTest)
{
    import tango.io.Stdout;
    import tango.io.device.Array;
    }
