// D import file generated from 'tango/io/stream/Snoop.d'
module tango.io.stream.Snoop;
private 
{
    import tango.io.Console;
    import tango.io.device.Conduit;
}
private import tango.text.convert.Format;

version (DigitalMars)
{
    private import tango.core.Vararg;

}
else
{
    version (GNU)
{
    private import tango.core.Vararg;

}
}
private alias void delegate(const(char)[]) Snoop;

class SnoopInput : InputStream
{
    private InputStream host;

    private Snoop snoop;

    this(InputStream host, Snoop snoop = null)
{
assert(host);
this.host = host;
this.snoop = snoop ? snoop : &snooper;
}
    InputStream input()
{
return host;
}
    final IConduit conduit()
{
return host.conduit;
}

    final size_t read(void[] dst)
{
auto x = host.read(dst);
trace("{}: read {} bytes",host.conduit,x is -1 ? 0 : x);
return x;
}

    void[] load(size_t max = -1)
{
auto x = host.load(max);
trace("{}: loaded {} bytes",x.length);
return x;
}
    final InputStream flush()
{
host.flush();
trace("{}: flushed/cleared",host.conduit);
return this;
}

    final void close()
{
host.close();
trace("{}: closed",host.conduit);
}

    final long seek(long offset, Anchor anchor = Anchor.Begin)
{
auto s = host.seek(offset,anchor);
trace("{}: seek at offset {} from anchor {}",host.conduit,offset,anchor);
return s;
}

    private void snooper(const(char)[] x)
{
Cerr(x).newline;
}

    private void trace(const(char)[] format,...)
{
char[256] tmp = void;
snoop(Format.vprint(tmp,format,_arguments,_argptr));
}

}
class SnoopOutput : OutputStream
{
    private OutputStream host;

    private Snoop snoop;

    this(OutputStream host, Snoop snoop = null)
{
assert(host);
this.host = host;
this.snoop = snoop ? snoop : &snooper;
}
    OutputStream output()
{
return host;
}
    final size_t write(const(void)[] src)
{
auto x = host.write(src);
trace("{}: wrote {} bytes",host.conduit,x is -1 ? 0 : x);
return x;
}

    final IConduit conduit()
{
return host.conduit;
}

    final OutputStream flush()
{
host.flush();
trace("{}: flushed",host.conduit);
return this;
}

    final void close()
{
host.close();
trace("{}: closed",host.conduit);
}

    final OutputStream copy(InputStream src, size_t max = -1)
{
host.copy(src,max);
trace("{}: copied from {}",host.conduit,src.conduit);
return this;
}

    final long seek(long offset, Anchor anchor = Anchor.Begin)
{
auto s = host.seek(offset,anchor);
trace("{}: seek at offset {} from anchor {}",host.conduit,offset,anchor);
return s;
}

    private void snooper(const(char)[] x)
{
Cerr(x).newline;
}

    private void trace(const(char)[] format,...)
{
char[256] tmp = void;
snoop(Format.vprint(tmp,format,_arguments,_argptr));
}

}
debug (Snoop)
{
    void main()
{
auto s = new SnoopInput(null);
auto o = new SnoopOutput(null);
}
}
