// D import file generated from 'tango/io/vfs/FtpFolder.d'
module tango.io.vfs.FtpFolder;
private 
{
    import tango.net.ftp.FtpClient;
    import tango.io.vfs.model.Vfs;
    import tango.io.vfs.FileFolder;
    import tango.io.device.Conduit;
    import tango.text.Util;
    import Time = tango.time.Time;
}
private const(char)[] fixName(const(char)[] toFix)
{
if (containsPattern(toFix,"/"))
toFix = toFix[locatePrior(toFix,'/') + 1..$];
return toFix;
}

private const(char)[] checkFirst(const(char)[] toFix)
{
for (; toFix.length > 0 && toFix[$ - 1] == '/';)
{
toFix = toFix[0..$ - 1];
}
return toFix;
}

private const(char)[] checkLast(const(char)[] toFix)
{
for (; toFix.length > 1 && toFix[0] == '/' && toFix[1] == '/';)
{
toFix = toFix[1..$];
}
if (toFix.length && toFix[0] != '/')
toFix = '/' ~ toFix;
return toFix;
}

private const(char)[] checkCat(const(char)[] first, const(char)[] last)
{
return checkFirst(first) ~ checkLast(last);
}

private FtpFileInfo[] getEntries(FTPConnection ftp, const(char)[] path = "");

private FtpFileInfo[] getFiles(FTPConnection ftp, const(char)[] path = "");

private FtpFileInfo[] getFolders(FTPConnection ftp, const(char)[] path = "");

class FtpFolderEntry : VfsFolderEntry
{
    const(char)[] toString_;
    const(char)[] name_;
    const(char)[] username_;
    const(char)[] password_;
    uint port_;
    public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21)
in
{
assert(server.length > 0);
}
body
{
toString_ = checkFirst(server);
name_ = checkLast(path);
username_ = username;
password_ = password;
port_ = port;
}

    final VfsFolder open()
{
return new FtpFolder(toString_,name_,username_,password_,port_);
}

    final VfsFolder create();

    final @property bool exists();

}
class FtpFolder : VfsFolder
{
    const(char)[] toString_;
    const(char)[] name_;
    const(char)[] username_;
    const(char)[] password_;
    uint port_;
    public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21)
in
{
assert(server.length > 0);
}
body
{
toString_ = checkFirst(server);
name_ = checkLast(path);
username_ = username;
password_ = password;
port_ = port;
}

    final @property const(char)[] name()
{
return fixName(name_);
}

    final override string toString()
{
return checkCat(toString_,name_).idup;
}

    final @property VfsFile file(const(char)[] path)
{
return new FtpFile(toString_,checkLast(checkCat(name_,path)),username_,password_,port_);
}

    final @property VfsFolderEntry folder(const(char)[] path)
{
return new FtpFolderEntry(toString_,checkLast(checkCat(name_,path)),username_,password_,port_);
}

    final @property VfsFolders self();

    final @property VfsFolders tree();

    final int opApply(scope int delegate(ref VfsFolder) dg);

    final VfsFolder clear();

    final @property bool writable();

    VfsFolder close(bool commit = true)
{
return this;
}
    void verify(VfsFolder folder, bool mounting)
{
return ;
}
}
class FtpFolders : VfsFolders
{
    const(char)[] toString_;
    const(char)[] name_;
    const(char)[] username_;
    const(char)[] password_;
    uint port_;
    bool flat_;
    FtpFileInfo[] infos_;
    package this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, FtpFileInfo[] infos = null, bool flat = false)
in
{
assert(server.length > 0);
}
body
{
toString_ = checkFirst(server);
name_ = checkLast(path);
username_ = username;
password_ = password;
port_ = port;
infos_ = infos;
flat_ = flat;
}

    public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, bool flat = false);

    final int opApply(scope int delegate(ref VfsFolder) dg);

    final @property size_t files();

    final @property size_t folders();

    final @property size_t entries();

    final @property ulong bytes();

    final VfsFolders subset(const(char)[] pattern);

    final @property VfsFiles catalog(const(char)[] pattern);

    final @property VfsFiles catalog(VfsFilter filter = null);

}
class FtpFile : VfsFile
{
    const(char)[] toString_;
    const(char)[] name_;
    const(char)[] username_;
    const(char)[] password_;
    uint port_;
    bool conOpen;
    FTPConnection conn;
    public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21)
in
{
assert(server.length > 0);
}
body
{
toString_ = checkFirst(server);
name_ = checkLast(path);
username_ = username;
password_ = password;
port_ = port;
}

    final @property const(char)[] name()
{
return fixName(name_);
}

    final override string toString()
{
return checkCat(toString_,name_).idup;
}

    final @property bool exists();

    final @property ulong size();

    final VfsFile copy(VfsFile source)
{
output.copy(source.input);
return this;
}

    final VfsFile move(VfsFile source)
{
copy(source);
source.remove();
return this;
}

    final VfsFile create()
{
char[1] a = "0";
output.write(a);
return this;
}

    final VfsFile create(InputStream stream)
{
output.copy(stream);
return this;
}

    final VfsFile remove();

    final @property InputStream input();

    final @property OutputStream output();

    final @property VfsFile dup()
{
return new FtpFile(toString_,name_,username_,password_,port_);
}

    final @property Time.Time mtime();

    final @property Time.Time ctime();

    final @property Time.Time atime();

    final @property Time.Time modified()
{
return mtime();
}

}
class FtpFiles : VfsFiles
{
    const(char)[] toString_;
    const(char)[] name_;
    const(char)[] username_;
    const(char)[] password_;
    uint port_;
    FtpFileInfo[] infos_;
    public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, FtpFileInfo[] infos = null)
in
{
assert(server.length > 0);
}
body
{
toString_ = checkFirst(server);
name_ = checkLast(path);
username_ = username;
password_ = password;
port_ = port;
if (infos !is null)
infos_ = infos;
else
fillInfos();
}

    final void fillInfos();

    final int opApply(scope int delegate(ref VfsFile) dg);

    final @property size_t files()
{
return infos_.length;
}

    final @property ulong bytes();

}
