// D import file generated from 'tango/io/vfs/model/Vfs.d'
module tango.io.vfs.model.Vfs;
private import tango.time.Time;

private import tango.io.model.IConduit;

private import tango.io.model.IFile;

alias FileInfo VfsFilterInfo;
alias VfsFilterInfo* VfsInfo;
alias bool delegate(VfsInfo) VfsFilter;
struct VfsStats
{
    ulong bytes;
    size_t files;
    size_t folders;
}
interface VfsHost : VfsFolder
{
    VfsHost mount(VfsFolder folder, const(char)[] name = null);
    VfsHost mount(VfsFolders group);
    VfsHost dismount(VfsFolder folder);
    VfsHost map(VfsFile target, const(char)[] name);
    VfsHost map(VfsFolderEntry target, const(char)[] name);
}
interface VfsFolder
{
    @property const(char)[] name();

    string toString();
    @property VfsFile file(const(char)[] path);

    @property VfsFolderEntry folder(const(char)[] path);

    @property VfsFolders self();

    @property VfsFolders tree();

    int opApply(scope int delegate(ref VfsFolder) dg);
    VfsFolder clear();
    @property bool writable();

    VfsFolder close(bool commit = true);
    void verify(VfsFolder folder, bool mounting);
}
interface VfsFolders
{
    int opApply(scope int delegate(ref VfsFolder) dg);
    @property size_t files();

    @property size_t folders();

    @property size_t entries();

    @property ulong bytes();

    VfsFolders subset(const(char)[] pattern);
    @property VfsFiles catalog(const(char)[] pattern);

    @property VfsFiles catalog(VfsFilter filter = null);

}
interface VfsFiles
{
    int opApply(scope int delegate(ref VfsFile) dg);
    @property size_t files();

    @property ulong bytes();

}
interface VfsFile
{
    @property const(char)[] name();

    immutable(char)[] toString();
    @property bool exists();

    @property ulong size();

    VfsFile copy(VfsFile source);
    VfsFile move(VfsFile source);
    VfsFile create();
    VfsFile create(InputStream stream);
    VfsFile remove();
    @property InputStream input();

    @property OutputStream output();

    @property VfsFile dup();

    @property Time modified();

}
interface VfsFolderEntry
{
    VfsFolder open();
    VfsFolder create();
    @property bool exists();

}
interface VfsSync
{
    VfsFolder sync();
}
