// D import file generated from 'tango/math/GammaFunction.d'
module tango.math.GammaFunction;
private import tango.math.Math;

private import tango.math.IEEE;

private import tango.math.ErrorFunction;

version (Windows)
{
    version (DigitalMars)
{
}
}
enum real MAXGAMMA = 0xd.b718c0668cfcd32p+7L;
private 
{
    enum real SQRT2PI = 0xa.06c98ffb1382cb3p-2L;
    enum real[] GammaNumeratorCoeffs = [1,0xd.67a16c819b329cfp-4,0xb.9d4c8e423af8d75p-5,0xe.3f48c3a8eb59549p-7,0xc.368b16651967f43p-9,0x8.61bc7173757be6cp-11,0xe.e2e335be82ff5aap-15,0xb.0b22bda3f22434ap-18];
    enum real[] GammaDenominatorCoeffs = [1,0xd.47cfd572ec7e458p-5,-0xe.5bc4ad33ab775efp-6,-0xb.dcdd58036983295p-8,0xe.338d7bc79890417p-9,-0xd.08f5dfd7cb1296ep-14,-0xa.23da6911853beedp-13,0xf.60ea2ddc2f0334bp-16,-0xe.a6712682de85473p-20];
    enum real[] GammaSmallCoeffs = [1,0x9.3c467e37db0c7a9p-4,-0xa.7e7a01357d17bf6p-4,-0xa.c0af47d126bf183p-8,0xa.a89190575156b8dp-6,-0xa.cd787dcec1710bp-8,-0x9.da5b0e9dfef9225p-10,0xe.c9ac74eceb4fe9ap-11,-0x9.c7e25e5d6d3baebp-13];
    enum real[] GammaSmallNegCoeffs = [-1,0x9.3c467e37db0c7aap-4,0xa.7e7a01357d15e26p-4,-0xa.c0af47d12347f64p-8,-0xa.a891905d76d7a5bp-6,-0xa.cd787d141dd783fp-8,0x9.da5386f18f02ca1p-10,0xe.c9cc5f1dd68989bp-11,0x9.48db9f702de5dd1p-13];
    enum real[] logGammaStirlingCoeffs = [0xa.aaaaaaaaaaa9fccp-7,-0xb.60b60b603a84d88p-12,0xd.00d009230e5f8f2p-14,-0x9.c09844e9fce8b2p-14,0xd.c88d492aad13bdcp-14,-0xf.6853da103043d91p-13,0xa.01291c2cc08d984p-11];
    enum real[] logGammaNumerator = [-0x8.76e92c89d552051p+20,-0x9.8e367172c42168fp+21,-0xf.80ac0a01ca3be18p+20,-0xb.a7ff206258c259ap+19,-0x8.6ce36847cf55aa8p+17,-0xa.a635b8c9af8fe44p+13,-0x8.73b0da149959557p+8];
    enum real[] logGammaDenominator = [-0xa.02aab96bae8462bp+21,-0xe.f75b009ccc726bbp+21,-0x8.837be6f6aee63cfp+21,-0x9.2f0b8c242463369p+19,-0x9.80981dccd30a505p+16,-0x8.4f3b55a0d74b28p+12,-0x8.07cae76cf2faa77p+6,1];
    real gammaStirling(real x)
{
enum real[] SmallStirlingCoeffs = [0xa.aaaaaaaaaaaa1d5p-7,0xe.38e38e3906ec3c9p-12,-0xa.fb934785ac83a1cp-12,-0xf.09e6a087023bef3p-16,0xc.d8798b21a2130b7p-14,0x9.293b11d1a395704p-17,-0x9.bfb5e477c59ba6fp-14,-0xc.64b44430295c395p-19,0xb.b5d54e369f76edep-14];
enum real[] LargeStirlingCoeffs = [1L,0xa.aaaaaaaaaaaaaabp-7L,0xe.38e38e38e38e38ep-12L,-0xa.fb93476d5a63df2p-12L,-0xf.09e7232fd42cab1p-16L,0xc.d87fb43a79620e4p-14L,0x9.23b0241ce01c3f2p-17L];
real w = 1L / x;
real y = exp(x);
if (x > 1024L)
{
w = poly(w,LargeStirlingCoeffs);
real v = pow(x,0.5L * x - 0.25L);
y = v * (v / y);
}
else
{
w = 1L + w * poly(w,SmallStirlingCoeffs);
y = pow(x,x - 0.5L) / y;
}
y = SQRT2PI * y * w;
return y;
}
}
real sgnGamma(real x)
{
if (isNaN(x))
return x;
if (x > 0)
return 1;
if (x < -1 / (real).epsilon)
{
return NaN(TANGO_NAN.SGNGAMMA);
}
long n = rndlong(x);
if (x == n)
{
return x == 0 ? copysign(1,x) : NaN(TANGO_NAN.SGNGAMMA);
}
return n & 1 ? 1 : -1;
}
debug (UnitTest)
{
    }
real gamma(real x);
debug (UnitTest)
{
    }
real logGamma(real x);
debug (UnitTest)
{
    }
private 
{
    enum real MAXLOG = 0xb.17217f7d1cf79acp+10L;
    enum real MINLOG = -0xb.21b38b6aa03736cp+10L;
    enum real BETA_BIG = 0x8p+60L;
    enum real BETA_BIGINV = 0x8p-66L;
}
real beta(real x, real y)
{
if (x + y > MAXGAMMA)
{
return exp(logGamma(x) + logGamma(y) - logGamma(x + y));
}
else
return gamma(x) * gamma(y) / gamma(x + y);
}
debug (UnitTest)
{
    }
real betaIncomplete(real aa, real bb, real xx);
real betaIncompleteInv(real aa, real bb, real yy0);
debug (UnitTest)
{
    }
private 
{
    real betaDistExpansion1(real a, real b, real x);
    real betaDistExpansion2(real a, real b, real x);
    real betaDistPowerSeries(real a, real b, real x);
}
real gammaIncomplete(real a, real x);
real gammaIncompleteCompl(real a, real x);
real gammaIncompleteComplInv(real a, real p);
debug (UnitTest)
{
    }
real digamma(real x);
import tango.stdc.stdio;
debug (UnitTest)
{
    }
