// D import file generated from 'tango/math/random/ExpSource.d'
module tango.math.random.ExpSource;
private import Integer = tango.text.convert.Integer;

import tango.math.Math;
import tango.math.random.Ziggurat;
import tango.core.Traits;
final template ExpSource(RandG,T)
{
class ExpSource
{
    static assert(isRealType!(T),T.stringof ~ " not acceptable, only floating point variables supported");
    static real probDensityF(real x)
{
return exp(-x);
}

    static real invProbDensityF(real x)
{
return -log(x);
}

    static real cumProbDensityFCompl(real x)
{
return exp(-x);
}

    static T tailGenerator(RandG r, T dMin)
{
return dMin - log(r.uniform!(T)());
}

    alias Ziggurat!(RandG,T,probDensityF,tailGenerator,false) SourceT;
    SourceT source;
    this(RandG r)
{
source = SourceT.create!(invProbDensityF,cumProbDensityFCompl)(r,0xf.64ec94bf5dc14bcp-1L);
}
    template opCall(U,S...)
{
ExpSource opCall(ref U a, S args)
{
randomize(a,args);
return this;
}
}
    T getRandom()
{
return source.getRandom();
}
    T getRandom(T beta)
{
return beta * source.getRandom();
}
    template randomize(U)
{
U randomize(ref U x)
{
return source.randomize(x);
}
}
    template randomize(U,V)
{
U randomize(ref U x, V beta)
{
return source.randomizeOp(delegate (T el)
{
return el * cast(T)beta;
}
,x);
}
}
    template randomizeOp(U,S)
{
U randomizeOp(scope S delegate(T) op, ref U a)
{
return source.randomizeOp(op,a);
}
}
    struct ExpDistribution
{
    T beta;
    ExpSource source;
    static template create()
{
ExpDistribution create(ExpSource source, T beta)
{
ExpDistribution res;
res.beta = beta;
res.source = source;
return res;
}
}

    template opCall(U,S...)
{
ExpDistribution opCall(ref U a, S args)
{
randomize(a,args);
return this;
}
}
    T getRandom()
{
return beta * source.getRandom();
}
    template randomize(U)
{
U randomize(ref U a)
{
return source.randomizeOp(delegate (T x)
{
return beta * x;
}
,a);
}
}
    template randomize(U,V)
{
U randomize(ref U a, V b)
{
return source.randomizeOp(delegate (T x)
{
return cast(T)b * x;
}
,a);
}
}
}
    ExpDistribution expD(T beta)
{
return ExpDistribution.create(this,beta);
}
}
}

