// D import file generated from 'tango/math/random/Kiss.d'
module tango.math.random.Kiss;
version (Win32)
{
    private extern (Windows) int QueryPerformanceCounter(ulong*);


}
version (Posix)
{
    private import tango.stdc.posix.sys.time;

}
struct Kiss
{
    public alias natural toInt;

    public alias fraction toReal;

    private uint kiss_k;

    private uint kiss_m;

    private uint kiss_x = 1;

    private uint kiss_y = 2;

    private uint kiss_z = 4;

    private uint kiss_w = 8;

    private uint kiss_carry = 0;

    private 
{
    enum double M_RAN_INVM32 = 0x8p-35;
    enum double M_RAN_INVM52 = 0x8p-55;
}
    public static __gshared Kiss instance;


    shared static this();
    static Kiss opCall()
{
Kiss rand;
rand.seed();
return rand;
}

    void seed();
    void seed(uint seed)
{
kiss_x = seed | 1;
kiss_y = seed | 2;
kiss_z = seed | 4;
kiss_w = seed | 8;
kiss_carry = 0;
}
    uint natural()
{
kiss_x = kiss_x * 69069 + 1;
kiss_y ^= kiss_y << 13;
kiss_y ^= kiss_y >> 17;
kiss_y ^= kiss_y << 5;
kiss_k = (kiss_z >> 2) + (kiss_w >> 3) + (kiss_carry >> 2);
kiss_m = kiss_w + kiss_w + kiss_z + kiss_carry;
kiss_z = kiss_w;
kiss_w = kiss_m;
kiss_carry = kiss_k >> 30;
return kiss_x + kiss_y + kiss_w;
}
    uint natural(uint max)
{
return natural() % max;
}
    uint natural(uint min, uint max)
{
return natural() % (max - min) + min;
}
    double fraction()
{
return cast(int)natural() * M_RAN_INVM32 + (0.5 + M_RAN_INVM32 / 2);
}
    double fractionEx()
{
return cast(int)natural() * M_RAN_INVM32 + (0.5 + M_RAN_INVM52 / 2) + (cast(int)natural() & 1048575) * M_RAN_INVM52;
}
}
debug (Kiss)
{
    import tango.io.Stdout;
    import tango.time.StopWatch;
    void main();
}
