// D import file generated from 'tango/math/random/Random.d'
module tango.math.random.Random;
import tango.math.random.engines.URandom;
import tango.math.random.engines.KissCmwc;
import tango.math.random.engines.ArraySource;
import tango.math.random.engines.Sync;
import tango.math.random.engines.Twister;
import tango.math.random.NormalSource;
import tango.math.random.ExpSource;
import tango.math.Math;
import tango.core.Traits;
private template ctfe_powI(T)
{
T ctfe_powI(T x, int p)
{
T xx = cast(T)1;
if (p < 0)
{
p = -p;
x = 1 / x;
}
{
for (int i = 0;
 i < p; ++i)
{
xx *= x;
}
}
return xx;
}
}

version (Win32)
{
    private extern (Windows) int QueryPerformanceCounter(ulong*);


}
version (Posix)
{
    private import tango.stdc.posix.sys.time;

}
version (darwin)
{
    version = has_urandom;
}
version (linux)
{
    version = has_urandom;
}
version (solaris)
{
    version = has_urandom;
}
template isFloat(T)
{
static if(is(T == float) || is(T == double) || is(T == real))
{
    enum bool isFloat = true;
}
else
{
    enum bool isFloat = false;
}
}
alias KissCmwc_32_1 DefaultEngine;
final template RandomG(SourceT = DefaultEngine)
{
class RandomG
{
    SourceT source;
    NormalSource!(RandomG,float) normalFloat;
    NormalSource!(RandomG,double) normalDouble;
    NormalSource!(RandomG,real) normalReal;
    ExpSource!(RandomG,float) expFloat;
    ExpSource!(RandomG,double) expDouble;
    ExpSource!(RandomG,real) expReal;
    this(bool randomInit = true)
{
if (randomInit)
this.seed();
}
    RandomG seed()
{
static if(source.canSeed)
{
source.seed(&rand.uniform!(uint));
}

return this;
}
    RandomG seed(scope uint delegate() seedSource)
{
static if(source.canSeed)
{
source.seed(seedSource);
}

return this;
}
    uint next()
{
return uniform!(uint)();
}
    uint next(uint to)
{
return uniformR!(uint)(to);
}
    uint next(uint from, uint to)
{
return uniformR2!(uint)(from,to);
}
    static RandomG!(Sync!(DefaultEngine)) instance()
{
return rand;
}

    template uniform(T,bool boundCheck = true)
{
T uniform()
{
static if(is(T == uint))
{
return source.next();
}
else
{
static if(is(T == int) || is(T == short) || is(T == ushort) || is(T == char) || is(T == byte) || is(T == ubyte))
{
union Uint2A
{
    T t;
    uint u;
}
Uint2A a;
a.u = source.next();
return a.t;
}
else
{
static if(is(T == long) || is(T == ulong))
{
return cast(T)source.nextL();
}
else
{
static if(is(T == bool))
{
return cast(bool)(source.next & 1u);
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
static if(T.mant_dig < 30)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact32 = ctfe_powI(halfT,32);
enum uint minV = 1u << T.mant_dig - 1;
uint nV = source.next();
if (nV >= minV)
{
T res = nV * fact32;
static if(boundCheck)
{
if (res != cast(T)1)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
else
{
T scale = fact32;
while (nV == 0)
{
nV = source.next();
scale *= fact32;
}
T res = nV * scale + source.next() * scale * fact32;
static if(boundCheck)
{
if (res != cast(T)0)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
}
else
{
static if(T.mant_dig < 62)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact64 = ctfe_powI(halfT,64);
enum ulong minV = 1LU << T.mant_dig - 1;
ulong nV = source.nextL();
if (nV >= minV)
{
T res = nV * fact64;
static if(boundCheck)
{
if (res != cast(T)1)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
else
{
enum T fact32 = ctfe_powI(halfT,32);
enum ulong minV2 = 1LU << T.mant_dig - 33;
if (nV >= minV2)
{
return (cast(T)nV + cast(T)source.next() * fact32) * fact64;
}
else
{
T scale = fact64;
while (nV == 0)
{
nV = source.nextL();
scale *= fact64;
}
T res = scale * (cast(T)nV + cast(T)source.nextL() * fact64);
static if(boundCheck)
{
if (res != cast(T)0)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
}
}
else
{
static if(T.mant_dig <= 64)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact8 = ctfe_powI(halfT,8);
enum T fact72 = ctfe_powI(halfT,72);
ubyte nB = source.nextB();
if (nB != 0)
{
T res = nB * fact8 + source.nextL() * fact72;
static if(boundCheck)
{
if (res != cast(T)1)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
else
{
enum T fact64 = ctfe_powI(halfT,64);
T scale = fact8;
while (nB == 0)
{
nB = source.nextB();
scale *= fact8;
}
T res = (cast(T)nB + cast(T)source.nextL() * fact64) * scale;
static if(boundCheck)
{
if (res != cast(T)0)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}
}
else
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact32 = ctfe_powI(halfT,32);
uint nL = source.next();
T fact = fact32;
while (nL == 0)
{
fact *= fact32;
nL = source.next();
}
T res = nL * fact;
{
for (int rBits = T.mant_dig - 1;
 rBits > 0; rBits -= 32)
{
{
fact *= fact32;
res += source.next() * fact;
}
}
}
static if(boundCheck)
{
if (res != cast(T)0 && res != cast(T)1)
return res;
return uniform!(T,boundCheck)();
}
else
{
return res;
}

}

}

}

}
else
{
static if(is(T == cfloat) || is(T == cdouble) || is(T == creal))
{
return cast(T)(uniform!(realType!(T))() + 1i * uniform!(realType!(T))());
}
else
{
static if(is(T == ifloat) || is(T == idouble) || is(T == ireal))
{
return cast(T)(1i * uniform!(realType!(T))());
}
else
{
static assert(0,T.stringof ~ " unsupported type for uniform distribution");
}

}

}

}

}

}

}

}
}
    template uniformR(T,bool boundCheck = true)
{
T uniformR(T to)
in
{
assert(to > 0,"empty range");
}
body
{
static if(is(T == uint) || is(T == int) || is(T == short) || is(T == ushort) || is(T == char) || is(T == byte) || is(T == ubyte))
{
uint d = (uint).max / cast(uint)to,dTo = to * d;
uint nV = source.next();
if (nV >= dTo)
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.next();
if (nV < dTo)
break;
}
}
}
assert(nV < dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
}
return cast(T)(nV % to);
}
else
{
static if(is(T == ulong) || is(T == long))
{
ulong d = (ulong).max / cast(ulong)to,dTo = to * d;
ulong nV = source.nextL();
if (nV >= dTo)
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.nextL();
if (nV < dTo)
break;
}
}
}
assert(nV < dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
}
return cast(T)(nV % to);
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
T res = uniform!(T,false)() * to;
static if(boundCheck)
{
if (res != cast(T)0 && res != to)
return res;
return uniformR(to);
}
else
{
return res;
}

}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformR distribution");
}

}

}

}
}
    template uniformRSymm(T,bool boundCheck = true,bool excludeZero = isFloat!(T))
{
T uniformRSymm(T to, int iter = 2000)
in
{
assert(to > 0,"empty range");
}
body
{
static if(is(T == int) || is(T == short) || is(T == byte))
{
int d = (int).max / to,dTo = to * d;
int nV = cast(int)source.next();
static if(excludeZero)
{
int isIn = nV < dTo && nV > -dTo && nV != 0;
}
else
{
int isIn = nV < dTo && nV > -dTo;
}

if (isIn)
{
return cast(T)(nV % to);
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = cast(int)source.next();
if (nV < dTo && nV > -dTo)
break;
}
}
}
assert(nV < dTo && nV > -dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
return cast(T)(nV % to);
}
}
else
{
static if(is(T == long))
{
long d = (long).max / to,dTo = to * d;
long nV = cast(long)source.nextL();
static if(excludeZero)
{
int isIn = nV < dTo && nV > -dTo && nV != 0;
}
else
{
int isIn = nV < dTo && nV > -dTo;
}

if (isIn)
{
return nV % to;
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.nextL();
if (nV < dTo && nV > -dTo)
break;
}
}
}
assert(nV < dTo && nV > -dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
return nV % to;
}
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
static if(T.mant_dig < 30)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact32 = ctfe_powI(halfT,32);
enum uint minV = 1u << T.mant_dig;
uint nV = source.next();
if (nV >= minV)
{
T res = nV * fact32 * to;
static if(boundCheck)
{
if (res != to)
return (1 - 2 * cast(int)(nV & 1u)) * res;
assert(iter > 0,"error with the generator, probability < 10^(-8*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return (1 - 2 * cast(int)(nV & 1u)) * res;
}

}
else
{
T scale = fact32;
while (nV == 0)
{
nV = source.next();
scale *= fact32;
}
uint nV2 = source.next();
T res = (cast(T)nV + cast(T)nV2 * fact32) * scale * to;
static if(excludeZero)
{
if (res != cast(T)0)
return (1 - 2 * cast(int)(nV & 1u)) * res;
assert(iter > 0,"error with the generator, probability < 10^(-8*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return (1 - 2 * cast(int)(nV & 1u)) * res;
}

}
}
else
{
static if(T.mant_dig < 62)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact64 = ctfe_powI(halfT,64);
enum ulong minV = 1LU << T.mant_dig;
ulong nV = source.nextL();
if (nV >= minV)
{
T res = nV * fact64 * to;
static if(boundCheck)
{
if (res != to)
return (1 - 2 * cast(int)(nV & 1LU)) * res;
assert(iter > 0,"error with the generator, probability < 10^(-16*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return (1 - 2 * cast(int)(nV & 1LU)) * res;
}

}
else
{
enum T fact32 = ctfe_powI(halfT,32);
enum ulong minV2 = 1LU << T.mant_dig - 32;
if (nV >= minV2)
{
uint nV2 = source.next();
T res = (cast(T)nV + cast(T)nV2 * fact32) * fact64 * to;
return (1 - 2 * cast(int)(nV2 & 1LU)) * res;
}
else
{
T scale = fact64;
while (nV == 0)
{
nV = source.nextL();
scale *= fact64;
}
ulong nV2 = source.nextL();
T res = to * scale * (cast(T)nV + cast(T)nV2 * fact64);
static if(excludeZero)
{
if (res != cast(T)0)
return (1 - 2 * cast(int)(nV2 & 1LU)) * res;
assert(iter > 0,"error with the generator, probability < 10^(-16*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return (1 - 2 * cast(int)(nV2 & 1LU)) * res;
}

}
}
}
else
{
static if(T.mant_dig <= 64)
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact8 = ctfe_powI(halfT,8);
enum T fact72 = ctfe_powI(halfT,72);
ubyte nB = source.nextB();
if (nB != 0)
{
ulong nL = source.nextL();
T res = to * (nB * fact8 + nL * fact72);
static if(boundCheck)
{
if (res != to)
return (1 - 2 * cast(int)(nL & 1LU)) * res;
assert(iter > 0,"error with the generator, probability < 10^(-16*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return (1 - 2 * cast(int)(nL & 1LU)) * res;
}

}
else
{
enum T fact64 = ctfe_powI(halfT,64);
T scale = fact8;
while (nB == 0)
{
nB = source.nextB();
scale *= fact8;
}
ulong nL = source.nextL();
T res = (cast(T)nB + cast(T)nL * fact64) * scale * to;
static if(excludeZero)
{
if (res != cast(T)0)
return nL & 1LU ? res : -res;
assert(iter > 0,"error with the generator, probability < 10^(-16*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return nL & 1LU ? res : -res;
}

}
}
else
{
enum T halfT = cast(T)1 / cast(T)2;
enum T fact32 = ctfe_powI(halfT,32);
uint nL = source.next();
T fact = fact32;
while (nL == 0)
{
fact *= fact32;
nL = source.next();
}
T res = nL * fact;
{
for (int rBits = T.mant_dig;
 rBits > 0; rBits -= 32)
{
{
fact *= fact32;
nL = source.next();
res += nL * fact;
}
}
}
static if(boundCheck)
{
if (res != to && res != cast(T)0)
return nL & 1LU ? res : -res;
assert(iter > 0,"error with the generator, probability < 10^(-16*2000)");
return uniformRSymm(to,iter - 1);
}
else
{
return nL & 1LU ? res : -res;
}

}

}

}

}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformRSymm distribution");
}

}

}

}
}
    template uniformR2(T,bool boundCheck = true)
{
T uniformR2(T from, T to)
in
{
assert(to > from,"empy range in uniformR2");
static if(is(T == int) || is(T == long))
{
assert(from > T.min / 2 && to < T.max / 2," from..to range too big");
}

}
body
{
static if(is(T == int) || is(T == long) || is(T == uint) || is(T == ulong))
{
return from + uniformR(to - from);
}
else
{
static if(is(T == char) || is(T == byte) || is(T == ubyte) || is(T == short) || is(T == ushort))
{
int d = cast(int)to - cast(int)from;
int nV = uniformR!(int)(d);
return cast(T)(nV + cast(int)from);
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
T res = from + (to - from) * uniform!(T,false);
static if(boundCheck)
{
if (res != from && res != to)
return res;
return uniformR2(from,to);
}
else
{
return res;
}

}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformR2 distribution");
}

}

}

}
}
    template uniformEl(T)
{
T uniformEl(const(T[]) arr)
{
assert(arr.length > 0,"array has to be non empty");
return arr[uniformR(arr.length)];
}
}
    template randomizeUniform(U,bool boundCheck)
{
U randomizeUniform(ref U a)
{
static if(is(U S : S[]))
{
alias BaseTypeOfArrays!(U) T;
static if(is(T == byte) || is(T == ubyte) || is(T == char))
{
uint val = source.next();
int rest = 4;
{
for (size_t i = 0;
 i < a.length; ++i)
{
{
if (rest != 0)
{
a[i] = cast(T)(255u & val);
val >>= 8;
--rest;
}
else
{
val = source.next();
a[i] = cast(T)(255u & val);
val >>= 8;
rest = 3;
}
}
}
}
}
else
{
static if(is(T == uint) || is(T == int))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
*aPtr = cast(T)source.next();
}
}
}
else
{
static if(is(T == ulong) || is(T == long))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
*aPtr = cast(T)source.nextL();
}
}
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
*aPtr = uniform!(T,boundCheck)();
}
}
}
}
else
{
static assert(T.stringof ~ " type not supported by randomizeUniform");
}

}

}

}

}
else
{
a = uniform!(U,boundCheck)();
}

return a;
}
}
    template randomizeUniformR(U,V,bool boundCheck = true)
{
U randomizeUniformR(ref U a, V to)
in
{
assert(cast(BaseTypeOfArrays!(U))to > 0,"empty range");
}
body
{
alias BaseTypeOfArrays!(U) T;
static assert(is(V : T),"incompatible a and to type " ~ U.stringof ~ " " ~ V.stringof);
static if(is(U S : S[]))
{
static if(is(T == uint) || is(T == int) || is(T == char) || is(T == byte) || is(T == ubyte))
{
uint d = (uint).max / cast(uint)to,dTo = cast(uint)to * d;
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
uint nV = source.next();
if (nV < dTo)
{
*aPtr = cast(T)(nV % cast(uint)to);
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.next();
if (nV < dTo)
break;
}
}
}
assert(nV < dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
*aPtr = cast(T)(nV % cast(uint)to);
}
}
}
}
}
else
{
static if(is(T == ulong) || is(T == long))
{
ulong d = (ulong).max / cast(ulong)to,dTo = cast(ulong)to * d;
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
ulong nV = source.nextL();
if (nV < dTo)
{
el = cast(T)(nV % cast(ulong)to);
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.nextL();
if (nV < dTo)
break;
}
}
}
assert(nV < dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
el = cast(T)(nV % cast(ulong)to);
}
}
}
}
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
*aPtr = uniformR!(T,boundCheck)(cast(T)to);
}
}
}
}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformR distribution");
}

}

}

}
else
{
a = uniformR!(T,boundCheck)(cast(T)to);
}

return a;
}
}
    template randomizeUniformR2(U,V,W,bool boundCheck = true)
{
U randomizeUniformR2(ref U a, V from, W to)
in
{
alias BaseTypeOfArrays!(U) T;
assert(cast(T)to > cast(T)from,"empy range in uniformR2");
static if(is(T == int) || is(T == long))
{
assert(from > T.min / 2 && to < T.max / 2," from..to range too big");
}

}
body
{
alias BaseTypeOfArrays!(U) T;
static assert(is(V : T),"incompatible a and from type " ~ U.stringof ~ " " ~ V.stringof);
static assert(is(W : T),"incompatible a and to type " ~ U.stringof ~ " " ~ W.stringof);
static if(is(U S : S[]))
{
static if(is(T == uint) || is(T == ulong))
{
T d = cast(T)to - cast(T)from;
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
*aPtr = from + uniformR!(d)();
}
}
}
}
else
{
if (is(T == char) || is(T == byte) || is(T == ubyte))
{
int d = cast(int)to - cast(int)from;
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
*aPtr = cast(T)(uniformR!(d) + cast(int)from);
}
}
}
}
else
static if(is(T == float) || is(T == double) || is(T == real))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
T res = cast(T)from + (cast(T)to - cast(T)from) * uniform!(T,false);
static if(boundCheck)
{
if (res != cast(T)from && res != cast(T)to)
{
*aPtr = res;
}
else
{
*aPtr = uniformR2!(T,boundCheck)(cast(T)from,cast(T)to);
}
}
else
{
*aPtr = res;
}

}
}
}
}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformR2 distribution");
}

}

}
else
{
a = uniformR2!(T,boundCheck)(from,to);
}

return a;
}
}
    template randomizeUniformRSymm(U,V,bool boundCheck = true,bool excludeZero = isFloat!(BaseTypeOfArrays!(U)))
{
U randomizeUniformRSymm(ref U a, V to)
in
{
assert(cast(BaseTypeOfArrays!(U))to > 0,"empty range");
}
body
{
alias BaseTypeOfArrays!(U) T;
static assert(is(V : T),"incompatible a and to type " ~ U.stringof ~ " " ~ V.stringof);
static if(is(U S : S[]))
{
static if(is(T == int) || is(T == byte))
{
int d = (int).max / cast(int)to,dTo = cast(int)to * d;
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
int nV = cast(int)source.next();
static if(excludeZero)
{
int isIn = nV < dTo && nV > -dTo && nV != 0;
}
else
{
int isIn = nV < dTo && nV > -dTo;
}

if (isIn)
{
*aPtr = cast(T)(nV % cast(int)to);
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = cast(int)source.next();
if (nV < dTo && nV > -dTo)
break;
}
}
}
assert(nV < dTo && nV > -dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
*aPtr = cast(T)(nV % cast(int)to);
}
}
}
}
}
else
{
static if(is(T == long))
{
long d = (long).max / cast(T)to,dTo = cast(T)to * d;
long nV = cast(long)source.nextL();
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
static if(excludeZero)
{
int isIn = nV < dTo && nV > -dTo && nV != 0;
}
else
{
int isIn = nV < dTo && nV > -dTo;
}

if (isIn)
{
*aPtr = nV % cast(T)to;
}
else
{
{
for (int i = 0;
 i < 1000; ++i)
{
{
nV = source.nextL();
if (nV < dTo && nV > -dTo)
break;
}
}
}
assert(nV < dTo && nV > -dTo,"this is less probable than 1.e-301, something is wrong with the random number generator");
*aPtr = nV % cast(T)to;
}
}
}
}
}
else
{
static if(is(T == float) || is(T == double) || is(T == real))
{
T* aEnd = a.ptr + a.length;
{
for (T* aPtr = a.ptr;
 aPtr != aEnd; ++aPtr)
{
{
*aPtr = uniformRSymm!(T,boundCheck,excludeZero)(cast(T)to);
}
}
}
}
else
{
static assert(0,T.stringof ~ " unsupported type for uniformRSymm distribution");
}

}

}

}
else
{
a = uniformRSymm!(T,boundCheck,excludeZero)(cast(T)to);
}

return a;
}
}
    template spawn(RandG = RandomG)
{
RandG spawn()
{
RandG res = new RandG(false);
synchronized(this) {
res.seed(&uniform!(uint));
}
return res;
}
}
    template UniformDistribution(T,bool boundCheck)
{
struct UniformDistribution
{
    RandomG r;
    static UniformDistribution create(RandomG r)
{
UniformDistribution res;
res.r = r;
return res;
}

    template opCall(U,S...)
{
UniformDistribution opCall(ref U a, S args)
{
randomize(a,args);
return this;
}
}
    T getRandom()
{
return r.uniform!(T,boundCheck)();
}
    template randomize(U)
{
U randomize(ref U a)
{
return r.randomizeUniform!(U,boundCheck)(a);
}
}
}
}
    template UniformRDistribution(T,bool boundCheck)
{
struct UniformRDistribution
{
    T to;
    RandomG r;
    static UniformRDistribution create(RandomG r, T to)
{
UniformRDistribution res;
res.r = r;
res.to = to;
return res;
}

    template opCall(U)
{
UniformRDistribution opCall(ref U a)
{
randomize(a);
return this;
}
}
    T getRandom()
{
return r.uniformR!(T,boundCheck)(to);
}
    template randomize(U)
{
U randomize(ref U a)
{
return r.randomizeUniformR!(U,T,boundCheck)(a,to);
}
}
}
}
    template UniformRSymmDistribution(T,bool boundCheck = true,bool excludeZero = isFloat!(T))
{
struct UniformRSymmDistribution
{
    T to;
    RandomG r;
    static UniformRSymmDistribution create(RandomG r, T to)
{
UniformRSymmDistribution res;
res.r = r;
res.to = to;
return res;
}

    template opCall(U)
{
UniformRSymmDistribution opCall(ref U a)
{
randomize(a);
return this;
}
}
    T getRandom()
{
return r.uniformRSymm!(T,boundCheck,excludeZero)(to);
}
    template randomize(U)
{
U randomize(ref U a)
{
return r.randomizeUniformRSymm!(U,T,boundCheck)(a,to);
}
}
}
}
    template UniformR2Distribution(T,bool boundCheck)
{
struct UniformR2Distribution
{
    T from;
    T to;
    RandomG r;
    static UniformR2Distribution create(RandomG r, T from, T to)
{
UniformR2Distribution res;
res.r = r;
res.from = from;
res.to = to;
return res;
}

    template opCall(U,S...)
{
UniformR2Distribution opCall(ref U a, S args)
{
randomize(a,args);
return this;
}
}
    T getRandom()
{
return r.uniformR2!(T,boundCheck)(from,to);
}
    template randomize(U)
{
U randomize(ref U a)
{
return r.randomizeUniformR2!(U,T,T,boundCheck)(a,from,to);
}
}
}
}
    template GammaDistribution(T)
{
struct GammaDistribution
{
    RandomG r;
    T alpha;
    T theta;
    static GammaDistribution create(RandomG r, T alpha = cast(T)1, T theta = cast(T)1)
{
GammaDistribution res;
res.r = r;
res.alpha = alpha;
res.theta = theta;
assert(alpha >= cast(T)1,"implemented only for alpha>=1");
return res;
}

    template opCall(U,S...)
{
GammaDistribution opCall(ref U a, S args)
{
randomize(a,args);
return this;
}
}
    T getRandom(T a = alpha, T t = theta)
in
{
assert(a >= cast(T)1,"implemented only for alpha>=1");
}
body
{
T d = a - cast(T)1 / cast(T)3;
T c = cast(T)1 / sqrt(d * cast(T)9);
auto n = r.normalSource!(T)();
for (;;)
{
{
do
{
T x = n.getRandom();
T v = c * x + cast(T)1;
v = v * v * v;
}
while (v <= 0);T u = r.uniform!(T)();
if (u < 1 - cast(T)0.331 * (x * x) * (x * x))
return t * d * v;
if (log(u) < x * x / 2 + d * (1 - v + log(v)))
return t * d * v;
}
}
}
    template randomize(U)
{
U randomize(ref U b, T a = alpha, T t = theta)
{
static if(is(U S : S[]))
{
alias BaseTypeOfArrays!(U) T;
T* bEnd = b.ptr + b.length;
{
for (T* bPtr = b.ptr;
 bPtr != bEnd; ++bPtr)
{
{
*bPtr = cast(BaseTypeOfArrays!(U))getRandom(a,t);
}
}
}
}
else
{
b = cast(U)getRandom(a,t);
}

return b;
}
}
    template randomizeOp(U,S)
{
U randomizeOp(S delegate(T) op, ref U b, T a = alpha, T t = theta)
{
static if(is(U S : S[]))
{
alias BaseTypeOfArrays!(U) T;
T* bEnd = b.ptr + b.length;
{
for (T* bPtr = b.ptr;
 bPtr != bEnd; ++bPtr)
{
{
*bPtr = cast(BaseTypeOfArrays!(U))op(getRandom(a,t));
}
}
}
}
else
{
b = cast(U)op(getRandom(a));
}

return b;
}
}
}
}
    template normalSource(T)
{
NormalSource!(RandomG,T) normalSource()
{
static if(is(T == float))
{
if (!normalFloat)
normalFloat = new NormalSource!(RandomG,T)(this);
return normalFloat;
}
else
{
static if(is(T == double))
{
if (!normalDouble)
normalDouble = new NormalSource!(RandomG,T)(this);
return normalDouble;
}
else
{
static if(is(T == real))
{
if (!normalReal)
normalReal = new NormalSource!(RandomG,T)(this);
return normalReal;
}
else
{
static assert(0,T.stringof ~ " no normal source implemented");
}

}

}

}
}
    template expSource(T)
{
ExpSource!(RandomG,T) expSource()
{
static if(is(T == float))
{
if (!expFloat)
expFloat = new ExpSource!(RandomG,T)(this);
return expFloat;
}
else
{
static if(is(T == double))
{
if (!expDouble)
expDouble = new ExpSource!(RandomG,T)(this);
return expDouble;
}
else
{
static if(is(T == real))
{
if (!expReal)
expReal = new ExpSource!(RandomG,T)(this);
return expReal;
}
else
{
static assert(0,T.stringof ~ " no exp source implemented");
}

}

}

}
}
    template normalD(T)
{
NormalSource!(RandomG,T).NormalDistribution normalD(T sigma = cast(T)1, T mu = cast(T)0)
{
return normalSource!(T)().normalD(sigma,mu);
}
}
    template expD(T)
{
ExpSource!(RandomG,T).ExpDistribution expD(T beta)
{
return expSource!(T)().expD(beta);
}
}
    template gammaD(T)
{
GammaDistribution!(T) gammaD(T alpha = cast(T)1, T theta = cast(T)1)
{
return GammaDistribution!(T).create(this,alpha,theta);
}
}
    template uniformD(T)
{
UniformDistribution!(T,true) uniformD()
{
return UniformDistribution!(T,true).create(this);
}
}
    template uniformBoundsD(T)
{
UniformDistribution!(T,false) uniformBoundsD()
{
return UniformDistribution!(T,false).create(this);
}
}
    template uniformRD(T)
{
UniformRDistribution!(T,true) uniformRD(T to)
{
return UniformRDistribution!(T,true).create(this,to);
}
}
    template uniformRBoundsD(T)
{
UniformRDistribution!(T,false) uniformRBoundsD(T to)
{
return UniformRDistribution!(T,false).create(this,to);
}
}
    template uniformRSymmD(T)
{
UniformRSymmDistribution!(T,true,isFloat!(T)) uniformRSymmD(T to)
{
return UniformRSymmDistribution!(T,true,isFloat!(T)).create(this,to);
}
}
    template uniformRSymmBoundsD(T)
{
UniformRSymmDistribution!(T,false,isFloat!(T)) uniformRSymmBoundsD(T to)
{
return UniformRSymmDistribution!(T,false,isFloat!(T)).create(this,to);
}
}
    template uniformR2D(T)
{
UniformR2Distribution!(T,true) uniformR2D(T from, T to)
{
return UniformR2Distribution!(T,true).create(this,from,to);
}
}
    template uniformR2BoundsD(T)
{
UniformR2Distribution!(T,false) uniformR2BoundsD(T from, T to)
{
return UniformR2Distribution!(T,false).create(this,from,to);
}
}
    template normal(T)
{
T normal()
{
return normalSource!(T).getRandom();
}
}
    template normalSigma(T)
{
T normalSigma(T sigma)
{
return normalSource!(T).getRandom(sigma);
}
}
    template normalSigmaMu(T)
{
T normalSigmaMu(T sigma, T mu)
{
return normalSource!(T).getRandom(sigma,mu);
}
}
    template exp(T)
{
T exp()
{
return expSource!(T).getRandom();
}
}
    template expBeta(T)
{
T expBeta(T beta)
{
return expSource!(T).getRandom(beta);
}
}
    template gamma(T)
{
T gamma(T alpha = cast(T)1, T sigma = cast(T)1)
in
{
assert(alpha >= cast(T)1,"implemented only for alpha>=1");
}
body
{
auto n = normalSource!(T);
T d = alpha - cast(T)1 / cast(T)3;
T c = cast(T)1 / sqrt(d * cast(T)9);
for (;;)
{
{
T x,v;
do
{
x = n.getRandom();
v = c * x + cast(T)1;
v = v * v * v;
}
while (v <= 0);T u = uniform!(T)();
if (u < 1 - cast(T)0.331 * (x * x) * (x * x))
return sigma * d * v;
if (log(u) < x * x / 2 + d * (1 - v + log(v)))
return sigma * d * v;
}
}
}
}
    override string toString()
{
return source.toString().idup;
}

    size_t fromString(const(char[]) s)
{
return source.fromString(s);
}
    template opCall(U)
{
RandomG opCall(ref U a)
{
randomize(a);
return this;
}
}
    template getRandom(T)
{
T getRandom()
{
return uniform!(T,true)();
}
}
    template randomize(U)
{
U randomize(ref U a)
{
return randomizeUniform!(U,true)(a);
}
}
}
}

alias RandomG!() Random;
alias RandomG!(Sync!(DefaultEngine)) RandomSync;
static __gshared RandomSync rand;

shared static this();
debug (UnitTest)
{
    import tango.math.random.engines.KISS;
    import tango.math.random.engines.CMWC;
    import tango.stdc.stdio;
    import tango.io.Stdout;
    template checkMean(T)
{
bool checkMean(T[] a, real maxmin, real minmax, real expectedMean, real maxOffset, bool alwaysPrint = false, bool checkB = false)
{
T minV,maxV;
real meanV = 0L;
if (a.length > 0)
{
minV = a[0];
maxV = a[0];
foreach (el; a)
{
assert(!checkB || cast(T)0 < el && el < cast(T)1,"el out of bounds");
if (el < minV)
minV = el;
if (el > maxV)
maxV = el;
meanV += cast(real)el;
}
meanV /= cast(real)a.length;
bool printM = false;
if (cast(real)minV > maxmin)
printM = true;
if (cast(real)maxV < minmax)
printM = true;
if (expectedMean - maxOffset > meanV || meanV > expectedMean + maxOffset)
printM = true;
if (printM)
{
version (GNU)
{
printf("WARNING tango.math.Random statistic is strange: %.*s[%d] %Lg %Lg %Lg\x0a\x00",cast(int)T.stringof.length,T.stringof.ptr,a.length,cast(real)minV,meanV,cast(real)maxV);
}
else
{
printf("WARNING tango.math.Random statistic is strange: %.*s[%d] %Lg %Lg %Lg\x0a\x00",cast(int)T.stringof.length,T.stringof.ptr,a.length,cast(real)minV,meanV,cast(real)maxV);
}

}
else
if (alwaysPrint)
{
version (GNU)
{
printf("tango.math.Random statistic: %.*s[%d] %Lg %Lg %Lg\x0a\x00",cast(int)T.stringof.length,T.stringof.ptr,a.length,cast(real)minV,meanV,cast(real)maxV);
}
else
{
printf("tango.math.Random statistic: %.*s[%d] %Lg %Lg %Lg\x0a\x00",cast(int)T.stringof.length,T.stringof.ptr,a.length,cast(real)minV,meanV,cast(real)maxV);
}

}
return printM;
}
assert(0);
}
}
    template doTests(RandG,Arrays...)
{
bool doTests(RandG r, real maxmin, real minmax, real expectedMean, real maxOffset, bool alwaysPrint, bool checkB, Arrays arrs)
{
bool gFail = false;
foreach (i, TA; Arrays)
{
alias BaseTypeOfArrays!(TA) T;
r(arrs[i]);
bool fail = checkMean!(T)(arrs[i],maxmin,minmax,expectedMean,maxOffset,alwaysPrint,checkB);
foreach (ref el; arrs[i])
{
r(el);
}
fail |= checkMean!(T)(arrs[i],maxmin,minmax,expectedMean,maxOffset,alwaysPrint,checkB);
gFail |= fail;
}
return gFail;
}
}
    template testRandSource(RandS)
{
void testRandSource()
{
auto r = new RandomG!(RandS);
const(char[]) initialState = r.toString();
bool allStats = false;
try
{
r.uniform!(uint)();
r.uniform!(ubyte)();
r.uniform!(ulong)();
int count = 10000;
{
for (int i = count;
 i != 0; --i)
{
{
float f = r.uniform!(float)();
assert(0 < f && f < 1,"float out of bounds");
double d = r.uniform!(double)();
assert(0 < d && d < 1,"double out of bounds");
real rr = r.uniform!(real)();
assert(0 < rr && rr < 1,"double out of bounds");
}
}
}
const(char[]) status = r.toString();
uint tVal = r.uniform!(uint)();
ubyte t2Val = r.uniform!(ubyte)();
ulong t3Val = r.uniform!(ulong)();
byte[1000] barr;
ubyte[1000] ubarr;
uint[1000] uiarr;
int[1000] iarr;
float[1000] farr;
double[1000] darr;
real[1000] rarr;
byte[] barr2 = barr[];
ubyte[] ubarr2 = ubarr[];
uint[] uiarr2 = uiarr[];
int[] iarr2 = iarr[];
float[] farr2 = farr[];
double[] darr2 = darr[];
real[] rarr2 = rarr[];
bool fail = false,gFail = false;
if (allStats)
Stdout("Uniform").newline;
fail = doTests(r,-100L,100L,0L,20L,allStats,false,barr2);
fail |= doTests(r,100L,155L,127.5L,20L,allStats,false,ubarr2);
fail |= doTests(r,0.25L * cast(real)(uint).max,0.75L * cast(real)(uint).max,0.5L * (uint).max,0.2L * (uint).max,allStats,false,uiarr2);
fail |= doTests(r,0.5L * cast(real)(int).min,0.5L * cast(real)(int).max,0L,0.2L * (uint).max,allStats,false,iarr2);
fail |= doTests(r,0.2L,0.8L,0.5L,0.2L,allStats,true,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with Uniform distribution");
if (allStats)
Stdout("UniformD").newline;
fail = doTests(r.uniformD!(int)(),-100L,100L,0L,20L,allStats,false,barr2);
fail |= doTests(r.uniformD!(int)(),100L,155L,127.5L,20L,allStats,false,ubarr2);
fail |= doTests(r.uniformD!(int)(),0.25L * cast(real)(uint).max,0.75L * cast(real)(uint).max,0.5L * (uint).max,0.2L * (uint).max,allStats,false,uiarr2);
fail |= doTests(r.uniformD!(real)(),0.5L * cast(real)(int).min,0.5L * cast(real)(int).max,0L,0.2L * (uint).max,allStats,false,iarr2);
fail |= doTests(r.uniformD!(real)(),0.2L,0.8L,0.5L,0.2L,allStats,true,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with UniformD distribution");
if (allStats)
Stdout("UniformBoundsD").newline;
fail = doTests(r.uniformBoundsD!(int)(),-100L,100L,0L,20L,allStats,false,barr2);
fail |= doTests(r.uniformBoundsD!(int)(),100L,155L,127.5L,20L,allStats,false,ubarr2);
fail |= doTests(r.uniformBoundsD!(int)(),0.25L * cast(real)(uint).max,0.75L * cast(real)(uint).max,0.5L * (uint).max,0.2L * (uint).max,allStats,false,uiarr2);
fail |= doTests(r.uniformBoundsD!(int)(),0.5L * cast(real)(int).min,0.5L * cast(real)(int).max,0L,0.2L * (uint).max,allStats,false,iarr2);
fail |= doTests(r.uniformBoundsD!(int)(),0.2L,0.8L,0.5L,0.2L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with UniformBoundsD distribution");
if (allStats)
Stdout("UniformRD").newline;
fail = doTests(r.uniformRD(cast(byte)101),25L,75L,50L,15L,allStats,false,barr2);
fail |= doTests(r.uniformRD(cast(ubyte)201),50L,150L,100L,20L,allStats,false,ubarr2);
fail |= doTests(r.uniformRD(1001u),250L,750L,500L,100L,allStats,false,uiarr2);
fail |= doTests(r.uniformRD(1001),250L,750L,500L,100L,allStats,false,iarr2);
fail |= doTests(r.uniformRD(1000L),250L,750L,500L,100L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.uniformRD(1L),0.2L,0.8L,0.5L,0.2L,allStats,true,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with uniformRD distribution");
if (allStats)
Stdout("UniformRBoundsD").newline;
fail = doTests(r.uniformRBoundsD(cast(byte)101),25L,75L,50L,15L,allStats,false,barr2);
fail |= doTests(r.uniformRBoundsD(cast(ubyte)201),50L,150L,100L,20L,allStats,false,ubarr2);
fail |= doTests(r.uniformRBoundsD(1001u),250L,750L,500L,100L,allStats,false,uiarr2);
fail |= doTests(r.uniformRBoundsD(1001),250L,750L,500L,100L,allStats,false,iarr2);
fail |= doTests(r.uniformRBoundsD(1000L),250L,750L,500L,100L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with uniformRBoundsD distribution");
if (allStats)
Stdout("Rsymm").newline;
fail = doTests(r.uniformRSymmD!(byte)(cast(byte)100),-40L,40L,0L,30L,allStats,false,barr2);
fail |= doTests(r.uniformRSymmD!(int)(1000),-300L,300L,0L,200L,allStats,false,iarr2);
fail |= doTests(r.uniformRSymmD!(real)(1L),-0.3L,0.3L,0L,0.3L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with Rsymm distribution");
if (allStats)
Stdout("RsymmBounds").newline;
fail = doTests(r.uniformRSymmBoundsD!(byte)(cast(byte)100),-40L,40L,0L,30L,allStats,false,barr2);
fail |= doTests(r.uniformRSymmBoundsD!(int)(1000),-300L,300L,0L,200L,allStats,false,iarr2);
fail |= doTests(r.uniformRSymmBoundsD!(real)(1L),-0.3L,0.3L,0L,0.3L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with RsymmBounds distribution");
if (allStats)
Stdout("Norm").newline;
fail = doTests(r.normalSource!(float)(),-0.5L,0.5L,0L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.normalSource!(double)(),-0.5L,0.5L,0L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.normalSource!(real)(),-0.5L,0.5L,0L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.normalD!(real)(0.5L,5L),4.5L,5.5L,5L,0.5L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with Normal distribution");
if (allStats)
Stdout("Exp").newline;
fail = doTests(r.expSource!(float)(),0.8L,2L,1L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.expSource!(double)(),0.8L,2L,1L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.expSource!(real)(),0.8L,2L,1L,1L,allStats,false,farr2,darr2,rarr2);
fail |= doTests(r.expD!(real)(5L),1L,7L,5L,1L,allStats,false,farr2,darr2,rarr2);
gFail |= fail;
if (fail)
Stdout("... with Exp distribution");
uint seed = 0;
r.seed(delegate ()
{
return 2 * seed++;
}
);
auto v1 = r.uniform!(int)();
seed = 0;
r.seed(delegate ()
{
return 2 * seed++;
}
);
auto v2 = r.uniform!(int)();
assert(v1 == v2,"Re-seed failure: " ~ RandS.stringof);
r.fromString(status);
assert(r.uniform!(uint)() == tVal,"restoring of status from str failed");
assert(r.uniform!(ubyte)() == t2Val,"restoring of status from str failed");
assert(r.uniform!(ulong)() == t3Val,"restoring of status from str failed");
assert(!gFail,"Random.d failure");
}
catch(Exception e)
{
Stdout(initialState).newline;
throw e;
}
}
}
    }
