// D import file generated from 'tango/math/random/engines/CMWC.d'
module tango.math.random.engines.CMWC;
private import Integer = tango.text.convert.Integer;

template CMWC(uint cmwc_r = 1024u,ulong cmwc_a = 987769338LU)
{
struct CMWC
{
    uint[cmwc_r] cmwc_q = void;
    uint cmwc_i = cmwc_r - 1u;
    uint cmwc_c = 123;
    uint nBytes = 0;
    uint restB = 0;
    enum int canCheckpoint = true;
    enum int canSeed = true;
    void skip(uint n)
{
{
for (int i = n;
 i != n; --i)
{
{
next();
}
}
}
}
    ubyte nextB()
{
if (nBytes > 0)
{
ubyte res = cast(ubyte)(restB & 255);
restB >>= 8;
--nBytes;
return res;
}
else
{
restB = next();
ubyte res = cast(ubyte)(restB & 255);
restB >>= 8;
nBytes = 3;
return res;
}
}
    uint next()
{
enum uint rMask = cmwc_r - 1u;
static assert((rMask & cmwc_r) == 0,"cmwc_r is supposed to be a power of 2");
enum uint m = -2u;
cmwc_i = cmwc_i + 1 & rMask;
ulong t = cmwc_a * cmwc_q[cmwc_i] + cmwc_c;
cmwc_c = cast(uint)(t >> 32);
uint x = cast(uint)t + cmwc_c;
if (x < cmwc_c)
{
++x;
++cmwc_c;
}
return cmwc_q[cmwc_i] = m - x;
}
    ulong nextL()
{
return (cast(ulong)next() << 32) + cast(ulong)next();
}
    void seed(scope uint delegate() rSeed)
{
cmwc_i = cmwc_r - 1u;
{
for (int ii = 0;
 ii < 10; ++ii)
{
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
{
cmwc_q[i] = rSeed();
}
}
}
uint nV = rSeed();
uint to = (uint).max / cmwc_a * cmwc_a;
{
for (int i = 0;
 i < 10; ++i)
{
{
if (nV < to)
break;
nV = rSeed();
}
}
}
cmwc_c = cast(uint)(nV % cmwc_a);
nBytes = 0;
restB = 0;
if (cmwc_c == 0)
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
if (cmwc_q[i] != 0)
return ;
}
}
}
else
if (cmwc_c == cmwc_a - 1)
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
if (cmwc_q[i] != -1u)
return ;
}
}
}
else
return ;
}
}
}
cmwc_c = 1;
}
    char[] toString()
{
char[] res = new char[](4 + 16 + (cmwc_r + 5) * 9);
int i = 0;
res[i..i + 4] = "CMWC"[];
i += 4;
Integer.format(res[i..i + 16],cmwc_a,cast(char[])"x16");
i += 16;
res[i] = '_';
++i;
Integer.format(res[i..i + 8],cmwc_r,cast(char[])"x8");
i += 8;
foreach (val; cmwc_q)
{
res[i] = '_';
++i;
Integer.format(res[i..i + 8],val,cast(char[])"x8");
i += 8;
}
foreach (val; [cmwc_i,cmwc_c,nBytes,restB])
{
res[i] = '_';
++i;
Integer.format(res[i..i + 8],val,cast(char[])"x8");
i += 8;
}
assert(i == res.length,"unexpected size");
return res;
}
    size_t fromString(const(char[]) s)
{
char[16] tmpC;
size_t i = 0;
assert(s[i..i + 4] == "CMWC","unexpected kind, expected CMWC");
i += 4;
assert(s[i..i + 16] == Integer.format(tmpC,cmwc_a,"x16"),"unexpected cmwc_a");
i += 16;
assert(s[i] == '_',"unexpected format, expected _");
i++;
assert(s[i..i + 8] == Integer.format(tmpC,cmwc_r,"x8"),"unexpected cmwc_r");
i += 8;
foreach (ref val; cmwc_q)
{
assert(s[i] == '_',"no separator _ found");
++i;
size_t ate;
val = cast(uint)Integer.convert(s[i..i + 8],16,&ate);
assert(ate == 8,"unexpected read size");
i += 8;
}
foreach (val; [&cmwc_i,&cmwc_c,&nBytes,&restB])
{
assert(s[i] == '_',"no separator _ found");
++i;
size_t ate;
*val = cast(uint)Integer.convert(s[i..i + 8],16,&ate);
assert(ate == 8,"unexpected read size");
i += 8;
}
return i;
}
}
}
alias CMWC!(4096u,18782LU) CMWC_4096_1;
alias CMWC!(2048u,1030770LU) CMWC_2048_1;
alias CMWC!(2048u,1047570LU) CMWC_2048_2;
alias CMWC!(1024u,5555698LU) CMWC_1024_1;
alias CMWC!(1024u,987769338LU) CMWC_1024_2;
alias CMWC!(512u,123462658LU) CMWC_512_1;
alias CMWC!(512u,123484214LU) CMWC_512_2;
alias CMWC!(256u,987662290LU) CMWC_256_1;
alias CMWC!(256u,987665442LU) CMWC_256_2;
alias CMWC!(128u,987688302LU) CMWC_128_1;
alias CMWC!(128u,987689614LU) CMWC_128_2;
alias CMWC!(64u,987651206LU) CMWC_64_1;
alias CMWC!(64u,987657110LU) CMWC_64_2;
alias CMWC!(32u,987655670LU) CMWC_32_1;
alias CMWC!(32u,987655878LU) CMWC_32_2;
alias CMWC!(16u,987651178LU) CMWC_16_1;
alias CMWC!(16u,987651182LU) CMWC_16_2;
alias CMWC!(8u,987651386LU) CMWC_8_1;
alias CMWC!(8u,987651670LU) CMWC_8_2;
alias CMWC!(4u,987654366LU) CMWC_4_1;
alias CMWC!(4u,987654978LU) CMWC_4_2;
alias CMWC_1024_2 CMWC_default;
