// D import file generated from 'tango/math/random/engines/KissCmwc.d'
module tango.math.random.engines.KissCmwc;
private import Integer = tango.text.convert.Integer;

template KissCmwc(uint cmwc_r = 1024u,ulong cmwc_a = 987769338LU)
{
struct KissCmwc
{
    uint[cmwc_r] cmwc_q = void;
    uint cmwc_i = cmwc_r - 1u;
    uint cmwc_c = 123;
    private uint kiss_x = 123456789;

    private uint kiss_y = 362436000;

    private uint kiss_z = 521288629;

    private uint kiss_c = 7654321;

    uint nBytes = 0;
    uint restB = 0;
    enum int canCheckpoint = true;
    enum int canSeed = true;
    void skip(uint n)
{
{
for (int i = n;
 i != n; --i)
{
{
next();
}
}
}
}
    ubyte nextB()
{
if (nBytes > 0)
{
ubyte res = cast(ubyte)(restB & 255);
restB >>= 8;
--nBytes;
return res;
}
else
{
restB = next();
ubyte res = cast(ubyte)(restB & 255);
restB >>= 8;
nBytes = 3;
return res;
}
}
    uint next()
{
enum uint rMask = cmwc_r - 1u;
static assert((rMask & cmwc_r) == 0,"cmwc_r is supposed to be a power of 2");
enum uint m = -2u;
cmwc_i = cmwc_i + 1 & rMask;
ulong t = cmwc_a * cmwc_q[cmwc_i] + cmwc_c;
cmwc_c = cast(uint)(t >> 32);
uint x = cast(uint)t + cmwc_c;
if (x < cmwc_c)
{
++x;
++cmwc_c;
}
enum ulong a = 698769069LU;
ulong k_t;
kiss_x = 69069 * kiss_x + 12345;
kiss_y ^= kiss_y << 13;
kiss_y ^= kiss_y >> 17;
kiss_y ^= kiss_y << 5;
k_t = a * kiss_z + kiss_c;
kiss_c = cast(uint)(k_t >> 32);
kiss_z = cast(uint)k_t;
return (cmwc_q[cmwc_i] = m - x) + kiss_x + kiss_y + kiss_z;
}
    ulong nextL()
{
return (cast(ulong)next() << 32) + cast(ulong)next();
}
    void seed(scope uint delegate() rSeed)
{
kiss_x = rSeed();
{
for (int i = 0;
 i < 100; ++i)
{
{
kiss_y = rSeed();
if (kiss_y != 0)
break;
}
}
}
if (kiss_y == 0)
kiss_y = 362436000;
kiss_z = rSeed();
kiss_c = rSeed() % 698769069;
cmwc_i = cmwc_r - 1u;
{
for (int ii = 0;
 ii < 10; ++ii)
{
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
{
cmwc_q[i] = rSeed();
}
}
}
uint nV = rSeed();
uint to = (uint).max / cmwc_a * cmwc_a;
{
for (int i = 0;
 i < 10; ++i)
{
{
if (nV < to)
break;
nV = rSeed();
}
}
}
cmwc_c = cast(uint)(nV % cmwc_a);
nBytes = 0;
restB = 0;
if (cmwc_c == 0)
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
if (cmwc_q[i] != 0)
return ;
}
}
}
else
if (cmwc_c == cmwc_a - 1)
{
{
for (uint i = 0;
 i < cmwc_r; ++i)
{
if (cmwc_q[i] != -1u)
return ;
}
}
}
else
return ;
}
}
}
cmwc_c = 1;
}
    char[] toString()
{
char[] res = new char[](11 + 16 + (cmwc_r + 9) * 9);
int i = 0;
res[i..i + 11] = "CMWC+KISS99"[];
i += 11;
Integer.format(res[i..i + 16],cmwc_a,cast(char[])"x16");
i += 16;
res[i] = '_';
++i;
Integer.format(res[i..i + 8],cmwc_r,cast(char[])"x8");
i += 8;
foreach (val; cmwc_q)
{
res[i] = '_';
++i;
Integer.format(res[i..i + 8],val,cast(char[])"x8");
i += 8;
}
foreach (val; [cmwc_i,cmwc_c,nBytes,restB,kiss_x,kiss_y,kiss_z,kiss_c])
{
res[i] = '_';
++i;
Integer.format(res[i..i + 8],val,cast(char[])"x8");
i += 8;
}
assert(i == res.length,"unexpected size");
return res;
}
    size_t fromString(const(char[]) s)
{
char[16] tmpC;
size_t i = 0;
assert(s[i..i + 11] == "CMWC+KISS99","unexpected kind, expected CMWC+KISS99");
i += 11;
assert(s[i..i + 16] == Integer.format(tmpC,cmwc_a,"x16"),"unexpected cmwc_a");
i += 16;
assert(s[i] == '_',"unexpected format, expected _");
i++;
assert(s[i..i + 8] == Integer.format(tmpC,cmwc_r,"x8"),"unexpected cmwc_r");
i += 8;
foreach (ref val; cmwc_q)
{
assert(s[i] == '_',"no separator _ found");
++i;
size_t ate;
val = cast(uint)Integer.convert(s[i..i + 8],16,&ate);
assert(ate == 8,"unexpected read size");
i += 8;
}
foreach (val; [&cmwc_i,&cmwc_c,&nBytes,&restB,&kiss_x,&kiss_y,&kiss_z,&kiss_c])
{
assert(s[i] == '_',"no separator _ found");
++i;
size_t ate;
*val = cast(uint)Integer.convert(s[i..i + 8],16,&ate);
assert(ate == 8,"unexpected read size");
i += 8;
}
return i;
}
}
}
alias KissCmwc!(4096u,18782LU) KissCmwc_4096_1;
alias KissCmwc!(2048u,1030770LU) KissCmwc_2048_1;
alias KissCmwc!(2048u,1047570LU) KissCmwc_2048_2;
alias KissCmwc!(1024u,5555698LU) KissCmwc_1024_1;
alias KissCmwc!(1024u,987769338LU) KissCmwc_1024_2;
alias KissCmwc!(512u,123462658LU) KissCmwc_512_1;
alias KissCmwc!(512u,123484214LU) KissCmwc_512_2;
alias KissCmwc!(256u,987662290LU) KissCmwc_256_1;
alias KissCmwc!(256u,987665442LU) KissCmwc_256_2;
alias KissCmwc!(128u,987688302LU) KissCmwc_128_1;
alias KissCmwc!(128u,987689614LU) KissCmwc_128_2;
alias KissCmwc!(64u,987651206LU) KissCmwc_64_1;
alias KissCmwc!(64u,987657110LU) KissCmwc_64_2;
alias KissCmwc!(32u,987655670LU) KissCmwc_32_1;
alias KissCmwc!(32u,987655878LU) KissCmwc_32_2;
alias KissCmwc!(16u,987651178LU) KissCmwc_16_1;
alias KissCmwc!(16u,987651182LU) KissCmwc_16_2;
alias KissCmwc!(8u,987651386LU) KissCmwc_8_1;
alias KissCmwc!(8u,987651670LU) KissCmwc_8_2;
alias KissCmwc!(4u,987654366LU) KissCmwc_4_1;
alias KissCmwc!(4u,987654978LU) KissCmwc_4_2;
alias KissCmwc_1024_2 KissCmwc_default;
