// D import file generated from 'tango/math/random/engines/Twister.d'
module tango.math.random.engines.Twister;
private import Integer = tango.text.convert.Integer;

struct Twister
{
    private enum : uint
{
N = 624,
M = 397,
MATRIX_A = -1727483681u,
UPPER_MASK = -2147483648u,
LOWER_MASK = 2147483647,
}

    enum int canCheckpoint = true;
    enum int canSeed = true;
    private uint[N] mt;

    private uint mti = mt.length + 1;

    uint next()
{
uint y;
static uint[2] mag01 = [0,MATRIX_A];
if (mti >= mt.length)
{
int kk;
{
for (kk = 0; kk < mt.length - M; kk++)
{
{
y = mt[kk] & UPPER_MASK | mt[kk + 1] & LOWER_MASK;
mt[kk] = mt[kk + M] ^ y >> 1 ^ mag01[y & 1u];
}
}
}
for (; kk < mt.length - 1; kk++)
{
{
y = mt[kk] & UPPER_MASK | mt[kk + 1] & LOWER_MASK;
mt[kk] = mt[kk + (M - mt.length)] ^ y >> 1 ^ mag01[y & 1u];
}
}
y = mt[mt.length - 1] & UPPER_MASK | mt[0] & LOWER_MASK;
mt[mt.length - 1] = mt[M - 1] ^ y >> 1 ^ mag01[y & 1u];
mti = 0;
}
y = mt[mti++];
y ^= y >> 11;
y ^= y << 7 & 2636928640LU;
y ^= y << 15 & 4022730752LU;
y ^= y >> 18;
return y;
}
    ubyte nextB()
{
return cast(ubyte)(next() & 255);
}
    ulong nextL()
{
return (cast(ulong)next() << 32) + cast(ulong)next();
}
    void seed(uint s)
{
mt[0] = s & -1u;
{
for (mti = 1; mti < mt.length; mti++)
{
{
mt[mti] = cast(uint)(1812433253LU * (mt[mti - 1] ^ mt[mti - 1] >> 30) + mti);
mt[mti] &= 4294967295LU;
}
}
}
}
    void addEntropy(scope uint delegate() r)
{
int i,j,k;
i = 1;
j = 0;
{
for (k = mt.length; k; k--)
{
{
mt[i] = cast(uint)((mt[i] ^ (mt[i - 1] ^ mt[i - 1] >> 30) * 1664525LU) + r() + j);
mt[i] &= 4294967295LU;
i++;
j++;
if (i >= mt.length)
{
mt[0] = mt[mt.length - 1];
i = 1;
}
}
}
}
{
for (k = mt.length - 1; k; k--)
{
{
mt[i] = cast(uint)((mt[i] ^ (mt[i - 1] ^ mt[i - 1] >> 30) * 1566083941LU) - i);
mt[i] &= 4294967295LU;
i++;
if (i >= mt.length)
{
mt[0] = mt[mt.length - 1];
i = 1;
}
}
}
}
mt[0] |= 2147483648LU;
mti = 0;
}
    void seed(scope uint delegate() r)
{
seed(19650218LU);
addEntropy(r);
}
    char[] toString();
    size_t fromString(const(char[]) s);
}
