// D import file generated from 'tango/net/device/Berkeley.d'
module tango.net.device.Berkeley;
private import tango.sys.Common;

private import tango.core.Exception;

import consts = tango.sys.consts.socket;
private import tango.stdc.string;

private import tango.stdc.stringz;

enum 
{
SOCKET_ERROR = consts.SOCKET_ERROR,
}
enum SocketOption 
{
DEBUG = consts.SO_DEBUG,
BROADCAST = consts.SO_BROADCAST,
REUSEADDR = consts.SO_REUSEADDR,
LINGER = consts.SO_LINGER,
DONTLINGER = ~consts.SO_LINGER,
OOBINLINE = consts.SO_OOBINLINE,
ACCEPTCONN = consts.SO_ACCEPTCONN,
KEEPALIVE = consts.SO_KEEPALIVE,
DONTROUTE = consts.SO_DONTROUTE,
TYPE = consts.SO_TYPE,
SNDBUF = consts.SO_SNDBUF,
RCVBUF = consts.SO_RCVBUF,
ERROR = consts.SO_ERROR,
MULTICAST_TTL = consts.IP_MULTICAST_TTL,
MULTICAST_LOOP = consts.IP_MULTICAST_LOOP,
ADD_MEMBERSHIP = consts.IP_ADD_MEMBERSHIP,
DROP_MEMBERSHIP = consts.IP_DROP_MEMBERSHIP,
TCP_NODELAY = consts.TCP_NODELAY,
WIN_UPDATE_ACCEPT_CONTEXT = 28683,
WIN_CONNECT_TIME = 28684,
WIN_UPDATE_CONNECT_CONTEXT = 28688,
}
enum SocketOptionLevel 
{
SOCKET = consts.SOL_SOCKET,
IP = consts.IPPROTO_IP,
TCP = consts.IPPROTO_TCP,
UDP = consts.IPPROTO_UDP,
}
enum SocketType 
{
STREAM = consts.SOCK_STREAM,
DGRAM = consts.SOCK_DGRAM,
SEQPACKET = consts.SOCK_SEQPACKET,
}
enum ProtocolType 
{
IP = consts.IPPROTO_IP,
IPV4 = consts.IPPROTO_IP,
IPV6 = consts.IPPROTO_IPV6,
ICMP = consts.IPPROTO_ICMP,
IGMP = consts.IPPROTO_IGMP,
TCP = consts.IPPROTO_TCP,
PUP = consts.IPPROTO_PUP,
UDP = consts.IPPROTO_UDP,
IDP = consts.IPPROTO_IDP,
}
enum AddressFamily 
{
UNSPEC = consts.AF_UNSPEC,
UNIX = consts.AF_UNIX,
INET = consts.AF_INET,
IPX = consts.AF_IPX,
APPLETALK = consts.AF_APPLETALK,
INET6 = consts.AF_INET6,
}
enum SocketShutdown 
{
RECEIVE = consts.SHUT_RD,
SEND = consts.SHUT_WR,
BOTH = consts.SHUT_RDWR,
}
enum SocketFlags 
{
NONE = 0,
OOB = consts.MSG_OOB,
PEEK = consts.MSG_PEEK,
DONTROUTE = consts.MSG_DONTROUTE,
NOSIGNAL = 16384,
}
enum AIFlags : int
{
PASSIVE = consts.AI_PASSIVE,
CANONNAME = consts.AI_CANONNAME,
NUMERICHOST = consts.AI_NUMERICHOST,
NUMERICSERV = consts.AI_NUMERICSERV,
ALL = consts.AI_ALL,
ADDRCONFIG = consts.AI_ADDRCONFIG,
V4MAPPED = consts.AI_V4MAPPED,
MASK = consts.AI_MASK,
DEFAULT = consts.AI_DEFAULT,
}
enum AIError 
{
BADFLAGS = consts.EAI_BADFLAGS,
NONAME = consts.EAI_NONAME,
AGAIN = consts.EAI_AGAIN,
FAIL = consts.EAI_FAIL,
NODATA = consts.EAI_NODATA,
FAMILY = consts.EAI_FAMILY,
SOCKTYPE = consts.EAI_SOCKTYPE,
SERVICE = consts.EAI_SERVICE,
MEMORY = consts.EAI_MEMORY,
}
enum NIFlags : int
{
MAXHOST = consts.NI_MAXHOST,
MAXSERV = consts.NI_MAXSERV,
NUMERICHOST = consts.NI_NUMERICHOST,
NUMERICSERV = consts.NI_NUMERICSERV,
NOFQDN = consts.NI_NOFQDN,
NAMEREQD = consts.NI_NAMEREQD,
DGRAM = consts.NI_DGRAM,
}
version (BigEndian)
{
    private ushort htons(ushort x)
{
return x;
}

    private uint htonl(uint x)
{
return x;
}

}
else
{
    private import tango.core.BitManip;

    private ushort htons(ushort x)
{
return cast(ushort)(x >> 8 | x << 8);
}

    private uint htonl(uint x)
{
return bswap(x);
}

}
version (Win32)
{
    pragma (lib, "ws2_32.lib");
    private import tango.sys.win32.WsaSock;

    private enum socket_t : int
{
init = ~0,
}

    package extern (Windows) 
{
    alias closesocket close;
    socket_t socket(int af, int type, int protocol);
    int ioctlsocket(socket_t s, int cmd, uint* argp);
    uint inet_addr(const(char)* cp);
    int bind(socket_t s, Address.sockaddr* name, int namelen);
    int connect(socket_t s, Address.sockaddr* name, int namelen);
    int listen(socket_t s, int backlog);
    socket_t accept(socket_t s, Address.sockaddr* addr, int* addrlen);
    int closesocket(socket_t s);
    int shutdown(socket_t s, int how);
    int getpeername(socket_t s, Address.sockaddr* name, int* namelen);
    int getsockname(socket_t s, Address.sockaddr* name, int* namelen);
    int send(socket_t s, const(void)* buf, int len, int flags);
    int sendto(socket_t s, const(void)* buf, int len, int flags, Address.sockaddr* to, int tolen);
    int recv(socket_t s, void* buf, int len, int flags);
    int recvfrom(socket_t s, void* buf, int len, int flags, Address.sockaddr* from, int* fromlen);
    int select(int nfds, SocketSet.fd* readfds, SocketSet.fd* writefds, SocketSet.fd* errorfds, SocketSet.timeval* timeout);
    int getsockopt(socket_t s, int level, int optname, void* optval, int* optlen);
    int setsockopt(socket_t s, int level, int optname, const(void)* optval, int optlen);
    int gethostname(void* namebuffer, int buflen);
    char* inet_ntoa(uint ina);
    NetHost.hostent* gethostbyname(const(char)* name);
    NetHost.hostent* gethostbyaddr(const(void)* addr, int len, int type);
    int function(const(char)* node, const(char)* service, Address.addrinfo* hints, Address.addrinfo** res) getaddrinfo;
    void function(Address.addrinfo* res) freeaddrinfo;
    int function(Address.sockaddr* sa, int salen, char* host, int hostlen, char* serv, int servlen, int flags) getnameinfo;
    bool function(socket_t, uint, void*, DWORD, DWORD, DWORD, DWORD*, OVERLAPPED*) AcceptEx;
    bool function(socket_t, HANDLE, DWORD, DWORD, OVERLAPPED*, void*, DWORD) TransmitFile;
    bool function(socket_t, void*, int, void*, DWORD, DWORD*, OVERLAPPED*) ConnectEx;
}

    private __gshared HMODULE lib;


    shared static this();
    }
else
{
    private import tango.stdc.errno;

    private enum socket_t : int
{
init = -1,
}

    package extern (C) 
{
    socket_t socket(int af, int type, int protocol);
    int fcntl(socket_t s, int f,...);
    uint inet_addr(const(char)* cp);
    int bind(socket_t s, const(Address.sockaddr)* name, int namelen);
    int connect(socket_t s, const(Address.sockaddr)* name, int namelen);
    int listen(socket_t s, int backlog);
    socket_t accept(socket_t s, Address.sockaddr* addr, int* addrlen);
    int close(socket_t s);
    int shutdown(socket_t s, int how);
    int getpeername(socket_t s, Address.sockaddr* name, int* namelen);
    int getsockname(socket_t s, Address.sockaddr* name, int* namelen);
    int send(socket_t s, const(void)* buf, size_t len, int flags);
    int sendto(socket_t s, const(void)* buf, size_t len, int flags, Address.sockaddr* to, int tolen);
    int recv(socket_t s, void* buf, size_t len, int flags);
    int recvfrom(socket_t s, void* buf, size_t len, int flags, Address.sockaddr* from, int* fromlen);
    int select(int nfds, SocketSet.fd* readfds, SocketSet.fd* writefds, SocketSet.fd* errorfds, SocketSet.timeval* timeout);
    int getsockopt(socket_t s, int level, int optname, void* optval, int* optlen);
    int setsockopt(socket_t s, int level, int optname, const(void)* optval, int optlen);
    int gethostname(void* namebuffer, int buflen);
    char* inet_ntoa(uint ina);
    NetHost.hostent* gethostbyname(const(char)* name);
    NetHost.hostent* gethostbyaddr(const(void)* addr, int len, int type);
    int getaddrinfo(const(char)* node, const(char)* service, Address.addrinfo* hints, Address.addrinfo** res);
    void freeaddrinfo(Address.addrinfo* res);
    int getnameinfo(Address.sockaddr* sa, int salen, char* host, int hostlen, char* serv, int servlen, int flags);
    const(char)* gai_strerror(int errcode);
    const(char)* inet_ntop(int af, const(void)* src, char* dst, int len);
}

}
public struct Berkeley
{
    socket_t sock;
    SocketType type;
    AddressFamily family;
    ProtocolType protocol;
    version (Windows)
{
    bool synchronous;
}
    enum INVALID_SOCKET = socket_t.init;
    enum 
{
Error = -1,
}
    alias Error ERROR;
    alias noDelay setNoDelay;
    alias addressReuse setAddressReuse;
    void open(AddressFamily family, SocketType type, ProtocolType protocol, bool create = true)
{
this.type = type;
this.family = family;
this.protocol = protocol;
if (create)
reopen();
}
    void reopen(socket_t sock = sock.init)
{
if (this.sock != sock.init)
this.detach();
if (sock is sock.init)
{
sock = cast(socket_t)socket(family,type,protocol);
if (sock is sock.init)
exception("Unable to create socket: ");
}
this.sock = sock;
}
    void detach()
{
if (sock != sock.init)
.close(sock);
sock = sock.init;
}
    const @property socket_t handle()
{
return sock;
}

    const @property int error()
{
int errcode;
getOption(SocketOptionLevel.SOCKET,SocketOption.ERROR,(&errcode)[0..1]);
return errcode;
}

    @property static int lastError();


    const @property bool isAlive()
{
int type,typesize = type.sizeof;
return getsockopt(sock,SocketOptionLevel.SOCKET,SocketOption.TYPE,cast(char*)&type,&typesize) != Error;
}

    @property AddressFamily addressFamily()
{
return family;
}

    Berkeley* bind(Address addr)
{
if (Error == .bind(sock,addr.name,addr.nameLen))
exception("Unable to bind socket: ");
return &this;
}
    Berkeley* connect(Address to);
    Berkeley* listen(int backlog)
{
if (Error == .listen(sock,backlog))
exception("Unable to listen on socket: ");
return &this;
}
    void accept(ref Berkeley target)
{
auto newsock = .accept(sock,null,null);
if (socket_t.init is newsock)
exception("Unable to accept socket connection: ");
target.reopen(newsock);
target.protocol = protocol;
target.family = family;
target.type = type;
}
    Berkeley* shutdown(SocketShutdown how)
{
.shutdown(sock,how);
return &this;
}
    @property Berkeley* linger(int period);

    @property Berkeley* addressReuse(bool enabled)
{
int[1] x = enabled;
return setOption(SocketOptionLevel.SOCKET,SocketOption.REUSEADDR,x);
}

    @property Berkeley* noDelay(bool enabled)
{
int[1] x = enabled;
return setOption(SocketOptionLevel.TCP,SocketOption.TCP_NODELAY,x);
}

    void joinGroup(IPv4Address address, bool onOff);
    const Address newFamilyObject()
{
if (family is AddressFamily.INET)
return new IPv4Address;
if (family is AddressFamily.INET6)
return new IPv6Address;
return new UnknownAddress;
}

    @property static char[] hostName()
{
char[64] name;
if (Error == .gethostname(name.ptr,name.length))
exception("Unable to obtain host name: ");
return name[0..strlen(name.ptr)].dup;
}


    @property static uint hostAddress()
{
auto ih = new NetHost;
ih.getHostByName(hostName);
assert(ih.addrList.length);
return ih.addrList[0];
}


    const @property Address remoteAddress()
{
auto addr = newFamilyObject();
auto nameLen = addr.nameLen;
if (Error == .getpeername(sock,addr.name,&nameLen))
exception("Unable to obtain remote socket address: ");
assert(addr.addressFamily is family);
return addr;
}

    const @property Address localAddress()
{
auto addr = newFamilyObject();
auto nameLen = addr.nameLen;
if (Error == .getsockname(sock,addr.name,&nameLen))
exception("Unable to obtain local socket address: ");
assert(addr.addressFamily is family);
return addr;
}

    const int send(const(void)[] buf, SocketFlags flags = SocketFlags.NONE);

    const int sendTo(const(void)[] buf, SocketFlags flags, Address to)
{
return sendTo(buf,cast(int)flags,to.name,to.nameLen);
}

    const int sendTo(const(void)[] buf, Address to)
{
return sendTo(buf,SocketFlags.NONE,to);
}

    const int sendTo(const(void)[] buf, SocketFlags flags = SocketFlags.NONE)
{
return sendTo(buf,cast(int)flags,null,0);
}

    private const int sendTo(const(void)[] buf, int flags, Address.sockaddr* to, int len);


    const int receive(void[] buf, SocketFlags flags = SocketFlags.NONE)
{
if (!buf.length)
badArg("Socket.receive :: target buffer has 0 length");
return .recv(sock,buf.ptr,buf.length,cast(int)flags);
}

    const int receiveFrom(void[] buf, SocketFlags flags, Address from)
{
if (!buf.length)
badArg("Socket.receiveFrom :: target buffer has 0 length");
assert(from.addressFamily() == family);
int nameLen = from.nameLen();
return .recvfrom(sock,buf.ptr,buf.length,cast(int)flags,from.name(),&nameLen);
}

    const int receiveFrom(void[] buf, Address from)
{
return receiveFrom(buf,SocketFlags.NONE,from);
}

    const int receiveFrom(void[] buf, SocketFlags flags = SocketFlags.NONE)
{
if (!buf.length)
badArg("Socket.receiveFrom :: target buffer has 0 length");
return .recvfrom(sock,buf.ptr,buf.length,cast(int)flags,null,null);
}

    const int getOption(SocketOptionLevel level, SocketOption option, void[] result)
{
int len = cast(int)result.length;
if (Error == .getsockopt(sock,cast(int)level,cast(int)option,result.ptr,&len))
exception("Unable to get socket option: ");
return len;
}

    Berkeley* setOption(SocketOptionLevel level, SocketOption option, const(void)[] value)
{
if (Error == .setsockopt(sock,cast(int)level,cast(int)option,value.ptr,cast(int)value.length))
exception("Unable to set socket option: ");
return &this;
}
    const @property bool blocking();

    @property void blocking(bool yes);

    static void exception(immutable(char)[] msg);

    protected static void badArg(immutable(char)[] msg);


}

public abstract class Address
{
    public struct sockaddr
{
    ushort sa_family;
    char[14] sa_data = 0;
}

    struct addrinfo
{
    int ai_flags;
    int ai_family;
    int ai_socktype;
    int ai_protocol;
    uint ai_addrlen;
    version (freebsd)
{
    char* ai_canonname;
    sockaddr* ai_addr;
}
else
{
    sockaddr* ai_addr;
    char* ai_canonname;
}
    addrinfo* ai_next;
}
    abstract @property sockaddr* name();

    const abstract @property int nameLen();

    private static ushort ntohs(ushort x)
{
return htons(x);
}


    private static uint ntohl(uint x)
{
return htonl(x);
}


    private static char[] fromInt(char[] tmp, int i);


    private static int toInt(const(char)[] s);


    static void exception(immutable(char)[] msg);

    static Address create(sockaddr* sa);

    static Address resolve(const(char)[] host, const(char)[] service = null, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0)
{
return resolveAll(host,service,af,flags)[0];
}

    static Address resolve(const(char)[] host, ushort port, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0)
{
return resolveAll(host,port,af,flags)[0];
}

    static Address[] resolveAll(const(char)[] host, const(char)[] service = null, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0);

    static Address[] resolveAll(const(char)[] host, ushort port, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0)
{
char[16] buf;
return resolveAll(host,fromInt(buf,port),af,flags);
}

    static Address passive(const(char)[] service, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0)
{
return resolve(null,service,af,flags | AIFlags.PASSIVE);
}

    static Address passive(ushort port, AddressFamily af = AddressFamily.UNSPEC, AIFlags flags = cast(AIFlags)0)
{
return resolve(null,port,af,flags | AIFlags.PASSIVE);
}

    @property char[] toAddrString()
{
char[1025] host = void;
getnameinfo(name,nameLen,host.ptr,host.length,null,0,NIFlags.NUMERICHOST);
return fromStringz(host.ptr).dup;
}

    @property char[] toPortString();

    override string toString()
{
return toAddrString.idup ~ ":" ~ toPortString.idup;
}

    @property AddressFamily addressFamily()
{
return cast(AddressFamily)name.sa_family;
}

}


public class UnknownAddress : Address
{
    sockaddr sa;
    override @property sockaddr* name()
{
return &sa;
}

    const override @property int nameLen()
{
return sa.sizeof;
}

    override @property AddressFamily addressFamily()
{
return cast(AddressFamily)sa.sa_family;
}

    override string toString()
{
return "Unknown";
}

}

public class IPv4Address : Address
{
    enum 
{
ADDR_ANY = 0,
ADDR_NONE = cast(uint)-1,
PORT_ANY = 0,
}
    struct sockaddr_in
{
    version (freebsd)
{
    ubyte sin_len;
    ubyte sinfamily = AddressFamily.INET;
}
else
{
    ushort sinfamily = AddressFamily.INET;
}
    ushort sin_port;
    uint sin_addr;
    char[8] sin_zero = 0;
}
    static assert(sockaddr_in.sizeof is 16);
    private sockaddr_in sin;

    protected this()
{
}

    this(ushort port)
{
sin.sin_addr = 0;
sin.sin_port = htons(port);
}
    this(uint addr, ushort port)
{
sin.sin_addr = htonl(addr);
sin.sin_port = htons(port);
}
    this(const(char)[] addr, ushort port = PORT_ANY)
{
uint uiaddr = parse(addr);
if (ADDR_NONE == uiaddr)
{
auto ih = new NetHost;
if (!ih.getHostByName(addr))
{
char[16] tmp = void;
exception("Unable to resolve " ~ addr.idup ~ ":" ~ fromInt(tmp,port).idup);
}
uiaddr = ih.addrList[0];
}
sin.sin_addr = htonl(uiaddr);
sin.sin_port = htons(port);
}
    this(sockaddr* addr)
{
sin = *cast(sockaddr_in*)addr;
}
    override @property sockaddr* name()
{
return cast(sockaddr*)&sin;
}

    const override @property int nameLen()
{
return cast(int)sin.sizeof;
}

    override @property AddressFamily addressFamily()
{
return AddressFamily.INET;
}

    const @property ushort port()
{
return ntohs(sin.sin_port);
}

    const @property uint addr()
{
return ntohl(sin.sin_addr);
}

    const override @property char[] toAddrString();

    const override @property char[] toPortString()
{
char[8] _port;
return fromInt(_port,port()).dup;
}

    override string toString()
{
return toAddrString().idup ~ ":" ~ toPortString().idup;
}

    static uint parse(const(char)[] addr);

}

debug (UnitTest)
{
    }
class IPv6Address : Address
{
    protected 
{
    struct sockaddr_in6
{
    ushort sin_family;
    ushort sin_port;
    uint sin6_flowinfo;
    ubyte[16] sin6_addr;
    uint sin6_scope_id;
}
    sockaddr_in6 sin;
    this()
{
}
    this(sockaddr* sa)
{
sin = *cast(sockaddr_in6*)sa;
}
    override @property sockaddr* name()
{
return cast(sockaddr*)&sin;
}

    const override @property int nameLen()
{
return cast(int)sin.sizeof;
}

    public 
{
    override @property AddressFamily addressFamily()
{
return AddressFamily.INET6;
}

    enum ushort PORT_ANY = 0;
    const @property ushort port()
{
return ntohs(sin.sin_port);
}

    this(int port)
{
this("::",port);
}
    this(const(char)[] addr, int port = PORT_ANY);
    this(const(char)[] addr, const(char)[] service);
    @property ubyte[] addr()
{
return sin.sin6_addr;
}

    version (Posix)
{
    const override @property char[] toAddrString()
{
char[100] buff = 0;
return fromStringz(inet_ntop(AddressFamily.INET6,&sin.sin6_addr,buff.ptr,100)).dup;
}

}
    const override @property char[] toPortString()
{
char[8] _port;
return fromInt(_port,port()).dup;
}

    override string toString()
{
return "[" ~ toAddrString.idup ~ "]:" ~ toPortString.idup;
}

}
}
}
debug (UnitTest)
{
    }
public class NetHost
{
    const(char)[] name;
    const(char)[][] aliases;
    uint[] addrList;
    struct hostent
{
    const(char)* h_name;
    const(char)** h_aliases;
    version (Win32)
{
    short h_addrtype;
    short h_length;
}
else
{
    int h_addrtype;
    int h_length;
}
    const(char)** h_addr_list;
    const(char)* h_addr()
{
return h_addr_list[0];
}
}
    protected void validHostent(hostent* he);

    void populate(hostent* he);
    bool getHostByName(const(char)[] name);
    bool getHostByAddr(uint addr);
    bool getHostByAddr(const(char)[] addr);
}

debug (UnitTest)
{
    import tango.io.Stdout;
    }
public class SocketSet
{
    import tango.stdc.config;
    struct timeval
{
    c_long seconds;
    c_long microseconds;
}
    private size_t nbytes;

    private byte* buf;

    struct fd
{
}
    version (Windows)
{
    @property uint count()
{
return *cast(uint*)buf;
}

    @property void count(int setter)
{
*cast(uint*)buf = setter;
}

    @property socket_t* first()
{
return cast(socket_t*)(buf + (uint).sizeof);
}

}
else
{
    version (Posix)
{
    import tango.core.BitManip;
    size_t nfdbits;
    socket_t _maxfd = cast(socket_t)0;
    const uint fdelt(socket_t s)
{
return cast(uint)(s / nfdbits);
}

    const uint fdmask(socket_t s)
{
return 1 << cast(uint)(s % nfdbits);
}

    @property uint* first()
{
return cast(uint*)buf;
}

    @property public socket_t maxfd()
{
return _maxfd;
}


}
}
    public 
{
    this(uint max);
    this(SocketSet o);
    this();
    SocketSet dup()
{
return new SocketSet(this);
}
    SocketSet reset();
    void add(socket_t s);
    void add(Berkeley* s)
{
add(s.handle);
}
    void remove(socket_t s);
    void remove(Berkeley* s)
{
remove(s.handle);
}
    int isSet(socket_t s);
    int isSet(Berkeley* s)
{
return isSet(s.handle);
}
    const @property size_t max()
{
return nbytes / socket_t.sizeof;
}

    fd* toFd_set()
{
return cast(fd*)buf;
}
    static int select(SocketSet checkRead, SocketSet checkWrite, SocketSet checkError, timeval* tv);

    static int select(SocketSet checkRead, SocketSet checkWrite, SocketSet checkError, long microseconds)
{
timeval tv = {cast(typeof(timeval.seconds))(microseconds / 1000000),cast(typeof(timeval.microseconds))(microseconds % 1000000)};
return select(checkRead,checkWrite,checkError,&tv);
}

    static int select(SocketSet checkRead, SocketSet checkWrite, SocketSet checkError)
{
return select(checkRead,checkWrite,checkError,null);
}

}
}

