// D import file generated from 'tango/net/device/LocalSocket.d'
module tango.net.device.LocalSocket;
private import tango.net.device.Socket;

version (Windows)
{
    pragma (msg, "not yet available for windows");
}
class LocalSocket : Socket
{
    private this()
{
super(AddressFamily.UNIX,SocketType.STREAM,ProtocolType.IP);
}

    this(const(char)[] path)
{
this(new LocalAddress(path));
}
    this(LocalAddress addr)
{
this();
super.connect(addr);
}
    override immutable(char)[] toString()
{
return "<localsocket>";
}

}
class LocalServerSocket : LocalSocket
{
    this(const(char)[] path, int backlog = 32, bool reuse = false)
{
auto addr = new LocalAddress(path);
native.addressReuse(reuse).bind(addr).listen(backlog);
}
    override immutable(char)[] toString()
{
return "<localaccept>";
}

    Socket accept(Socket recipient = null)
{
if (recipient is null)
recipient = new LocalSocket;
native.accept(*recipient.native);
recipient.timeout = timeout;
return recipient;
}
}
class LocalAddress : Address
{
    align (1)struct sockaddr_un
{
    ushort sun_family = AddressFamily.UNIX;
    char[108] sun_path;
}

    protected 
{
    sockaddr_un sun;
    const(char)[] _path;
    size_t _pathLength;
}
    this(const(char)[] path)
{
assert(path.length < 108);
sun.sun_path[0..path.length] = path;
sun.sun_path[path.length..$] = 0;
_pathLength = path.length;
_path = sun.sun_path[0..path.length];
}
    final override @property sockaddr* name()
{
return cast(sockaddr*)&sun;
}

    const final override @property int nameLen()
{
return cast(int)(_pathLength + (ushort).sizeof);
}

    final override @property AddressFamily addressFamily()
{
return AddressFamily.UNIX;
}

    final override string toString()
{
if (isAbstract)
return "unix:abstract=" ~ _path[1..$].idup;
else
return "unix:path=" ~ _path.idup;
}

    const final @property const(char)[] path()
{
return _path;
}

    const final @property bool isAbstract()
{
return _path[0] == 0;
}

}
debug (LocalSocket)
{
    import tango.io.Stdout;
    void main()
{
auto y = new LocalSocket("foo");
auto x = new LocalServerSocket("foo");
}
}
