// D import file generated from 'tango/net/device/Multicast.d'
module tango.net.device.Multicast;
public import tango.net.InternetAddress;

public import tango.net.device.Datagram;

class Multicast : Datagram
{
    private InternetAddress group;

    enum 
{
Host = 0,
Subnet = 1,
Site = 32,
Region = 64,
Continent = 128,
Unrestricted = 255,
}
    this()
{
super();
}
    this(InternetAddress group, bool reuse = false);
    Multicast loopback(bool yes = true)
{
uint[1] onoff = yes;
native.setOption(SocketOptionLevel.IP,SocketOption.MULTICAST_LOOP,onoff);
return this;
}
    Multicast ttl(uint value = Subnet)
{
uint[1] options = value;
native.setOption(SocketOptionLevel.IP,SocketOption.MULTICAST_TTL,options);
return this;
}
    Multicast join()
{
native.joinGroup(group,true);
return this;
}
    Multicast leave()
{
native.joinGroup(group,false);
return this;
}
}
debug (Multicast)
{
    import tango.io.Console;
    void main()
{
auto group = new InternetAddress("225.0.0.10",8080);
auto multi = new Multicast(group);
multi.join.write("hello",group);
char[8] tmp;
auto bytes = multi.read(tmp);
Cout(tmp[0..bytes]).newline;
}
}
