// D import file generated from 'tango/net/device/Socket.d'
module tango.net.device.Socket;
private import tango.sys.Common;

private import tango.io.device.Conduit;

package import tango.net.device.Berkeley;

version (Windows)
{
    private import tango.sys.win32.WsaSock;

}
class Socket : Conduit,ISelectable
{
    public alias native socket;

    private SocketSet pending;

    private Berkeley berkeley;

    deprecated void setTimeout(double t)
{
timeout = cast(uint)(t * 1000);
}

    deprecated bool hadTimeout()
{
return false;
}

    this()
{
this(AddressFamily.INET,SocketType.STREAM,ProtocolType.TCP);
}
    this(Address addr)
{
this(addr.addressFamily,SocketType.STREAM,ProtocolType.TCP);
}
    this(AddressFamily family, SocketType type, ProtocolType protocol);
    override string toString()
{
return "<socket>";
}

    @property Handle fileHandle()
{
return cast(Handle)berkeley.sock;
}

    @property Berkeley* native()
{
return &berkeley;
}

    const override @property size_t bufferSize()
{
return 1024 * 8;
}

    Socket connect(const(char)[] address, uint port)
{
assert(port < (ushort).max);
scope addr = new IPv4Address(address,cast(ushort)port);
return connect(addr);
}
    Socket connect(Address addr);
    Socket bind(Address address)
{
berkeley.bind(address);
return this;
}
    Socket shutdown()
{
berkeley.shutdown(SocketShutdown.BOTH);
return this;
}
    override void detach()
{
berkeley.detach();
}

    override size_t read(void[] dst);

    override size_t write(const(void)[] src);

    override OutputStream copy(InputStream src, size_t max = -1);

    package final bool wait(bool reading)
{
if (timeout != -1)
{
SocketSet read,write;
if (pending is null)
pending = new SocketSet(1);
pending.reset().add(native.sock);
if (reading)
read = pending;
else
write = pending;
int i = pending.select(read,write,null,timeout * 1000);
if (i <= 0)
{
if (i is 0)
super.error("Socket :: request timeout");
return false;
}
}
return true;
}


    final void error()
{
super.error(this.toString() ~ " :: " ~ SysError.lastMsg);
}

    version (Win32)
{
    private OVERLAPPED overlapped;

    private void asyncConnect(Address addr);

    private void asyncCopy(Handle handle);

    private size_t asyncRead(void[] dst);

    private size_t asyncWrite(const(void)[] src);

    version (TangoRuntime)
{
    private size_t wait(scheduler.Type type, uint bytes = 0);

}
    private static void patch(socket_t dst, uint how, socket_t* src = null)
{
auto len = src ? src.sizeof : 0;
if (setsockopt(dst,SocketOptionLevel.SOCKET,how,src,len))
berkeley.exception("patch :: ");
}


}
    version (Posix)
{
    private void asyncConnect(Address addr)
{
assert(false);
}

    Socket asyncCopy(Handle file)
{
assert(false);
}
    private size_t asyncRead(void[] dst)
{
assert(false);
}

    private size_t asyncWrite(const(void)[] src)
{
assert(false);
}

}
}
class ServerSocket : Socket
{
    this(uint port, int backlog = 32, bool reuse = false)
{
scope addr = new IPv4Address(cast(ushort)port);
this(addr,backlog,reuse);
}
    this(Address addr, int backlog = 32, bool reuse = false)
{
super(addr);
berkeley.addressReuse(reuse).bind(addr).listen(backlog);
}
    override string toString()
{
return "<accept>";
}

    Socket accept(Socket recipient = null);
    version (Windows)
{
    private void asyncAccept(Socket recipient);

}
    version (Posix)
{
    private void asyncAccept(Socket recipient)
{
assert(false);
}

}
}
