// D import file generated from 'tango/net/http/ChunkStream.d'
module tango.net.http.ChunkStream;
private import tango.io.stream.Lines;

private 
{
    import tango.io.device.Conduit;
    import tango.io.stream.Buffered;
}
private import Integer = tango.text.convert.Integer;

class ChunkOutput : OutputFilter
{
    private OutputBuffer output;

    this(OutputStream stream)
{
super(output = BufferedOutput.create(stream));
}
    final override size_t write(const(void)[] src)
{
char[8] tmp = void;
output.append(Integer.format(tmp,src.length,"x")).append("\x0d\x0a").append(src).append("\x0d\x0a");
return src.length;
}

    final void terminate(scope void delegate(OutputBuffer) headers = null)
{
output.append("0\x0d\x0a");
if (headers)
headers(output);
output.append("\x0d\x0a");
}

}
class ChunkInput : Lines!(char)
{
    private alias void delegate(const(char)[] line) Headers;

    private Headers headers;

    private uint available;

    this(InputStream stream, Headers headers = null)
{
set(stream);
this.headers = headers;
}
    override ChunkInput set(InputStream stream)
{
super.set(stream);
available = nextChunk();
return this;
}

    final override size_t read(void[] dst);

    private final uint nextChunk()
{
const(char)[] tmp;
if ((tmp = super.next).ptr)
return cast(uint)Integer.parse(tmp,16);
return 0;
}


}
debug (ChunkStream)
{
    import tango.io.Console;
    import tango.io.device.Array;
    void main()
{
auto buf = new Array(40);
auto chunk = new ChunkOutput(buf);
chunk.write("hello world");
chunk.terminate;
auto input = new ChunkInput(buf);
Cout.stream.copy(input);
}
}
