// D import file generated from 'tango/net/http/HttpTokens.d'
module tango.net.http.HttpTokens;
private import tango.time.Time;

private import tango.io.device.Array;

private import tango.io.stream.Buffered;

private 
{
    import tango.net.http.HttpStack;
    import tango.net.http.HttpConst;
}
private import Text = tango.text.Util;

private import Integer = tango.text.convert.Integer;

private import TimeStamp = tango.text.convert.TimeStamp;

struct HttpToken
{
    char[] name;
    char[] value;
}
class HttpTokens
{
    protected HttpStack stack;

    private Array input;

    private Array output;

    private bool parsed;

    private bool inclusive;

    private char separator;

    private char[1] sepString;

    this(char separator, bool inclusive = false)
{
stack = new HttpStack;
this.inclusive = inclusive;
this.separator = separator;
sepString[0] = separator;
input = new Array(0);
output = new Array(4096,1024);
}
    this(HttpTokens source)
{
stack = source.stack.clone();
input = null;
output = source.output;
parsed = true;
inclusive = source.inclusive;
separator = source.separator;
sepString[0] = source.sepString[0];
}
    abstract void parse(InputBuffer input);

    void parse(char[] content)
{
input.assign(content);
parse(input);
}
    HttpTokens reset()
{
stack.reset();
parsed = false;
output.clear();
return this;
}
    bool isParsed()
{
return parsed;
}
    void setParsed(bool parsed)
{
this.parsed = parsed;
}
    char[] get(const(char)[] name, const(char)[] ret = null)
{
Token token = stack.findToken(name);
if (token)
{
HttpToken element;
if (split(token,element))
ret = trim(element.value);
}
return ret.dup;
}
    int getInt(const(char)[] name, int ret = -1)
{
char[] value = get(name);
if (value.length)
ret = cast(int)Integer.parse(value);
return ret;
}
    Time getDate(const(char)[] name, Time date = Time.epoch)
{
char[] value = get(name);
if (value.length)
date = TimeStamp.parse(value);
return date;
}
    int opApply(scope int delegate(ref HttpToken) dg);
    void produce(scope size_t delegate(const(void)[]) consume, const(char)[] eol = null);
    protected bool handleMissingSeparator(char[] s, ref HttpToken element)
{
return false;
}

    final private bool split(Token t, ref HttpToken element)
{
auto s = t.toString().dup;
if (s.length)
{
auto i = Text.locate(s,separator);
if (i < s.length)
{
auto j = inclusive ? i + 1 : i;
element.name = s[0..j];
element.value = ++i < s.length ? s[i..$] : null;
return true;
}
else
return handleMissingSeparator(s,element);
}
return false;
}


    FilteredTokens createFilter(char[] match)
{
return new FilteredTokens(this,match);
}
    private static class FilteredTokens
{
    private char[] match;

    private HttpTokens tokens;

    this(HttpTokens tokens, const(char)[] match)
{
this.match = match.dup;
this.tokens = tokens;
}
    int opApply(scope int delegate(ref HttpToken) dg);
}


    private bool isSpace(char c)
{
return cast(bool)(c is ' ' || c is '\x09' || c is '\x0d' || c is '\x0a');
}

    private char[] trim(char[] source);

    char[] formatTokens(OutputBuffer dst, char[] delim);
    protected void add(const(char)[] name, scope void delegate(OutputBuffer) value)
{
auto prior = output.slice().length;
output.append(name);
if (!inclusive)
output.append(sepString);
value(output);
stack.push(cast(char[])output.slice()[prior..$]);
}

    protected void add(const(char)[] name, const(char)[] value);

    protected void addInt(const(char)[] name, size_t value)
{
char[16] tmp = void;
add(name,Integer.format(tmp,cast(long)value));
}

    protected void addDate(const(char)[] name, Time value)
{
char[40] tmp = void;
add(name,TimeStamp.format(tmp,value));
}

    protected bool remove(const(char)[] name)
{
return stack.removeToken(name);
}

}
