// D import file generated from 'tango/stdc/posix/signal.d'
module tango.stdc.posix.signal;
private import tango.stdc.posix.config;

version (solaris)
{
    private import tango.stdc.stdint;

}
public import tango.stdc.signal;

public import tango.stdc.stddef;

public import tango.stdc.posix.sys.types;

extern (C) 
{
    private alias void function(int) sigfn_t;

    private alias void function(int, siginfo_t*, void*) sigactfn_t;

    enum 
{
SIGEV_SIGNAL,
SIGEV_NONE,
SIGEV_THREAD,
}
    union sigval
{
    int sival_int;
    void* sival_ptr;
}
    private extern (C) int __libc_current_sigrtmin();


    private extern (C) int __libc_current_sigrtmax();


    alias __libc_current_sigrtmin SIGRTMIN;
    alias __libc_current_sigrtmax SIGRTMAX;
    version (linux)
{
    const SIGALRM = 14;
    const SIGBUS = 7;
    const SIGCHLD = 17;
    const SIGCONT = 18;
    const SIGHUP = 1;
    const SIGKILL = 9;
    const SIGPIPE = 13;
    const SIGQUIT = 3;
    const SIGSTOP = 19;
    const SIGTSTP = 20;
    const SIGTTIN = 21;
    const SIGTTOU = 22;
    const SIGUSR1 = 10;
    const SIGUSR2 = 12;
    const SIGURG = 23;
}
else
{
    version (darwin)
{
    const SIGALRM = 14;
    const SIGBUS = 10;
    const SIGCHLD = 20;
    const SIGCONT = 19;
    const SIGHUP = 1;
    const SIGKILL = 9;
    const SIGPIPE = 13;
    const SIGQUIT = 3;
    const SIGSTOP = 17;
    const SIGTSTP = 18;
    const SIGTTIN = 21;
    const SIGTTOU = 22;
    const SIGUSR1 = 30;
    const SIGUSR2 = 31;
    const SIGURG = 16;
}
else
{
    version (freebsd)
{
    const SIGALRM = 14;
    const SIGBUS = 10;
    const SIGCHLD = 20;
    const SIGCONT = 19;
    const SIGHUP = 1;
    const SIGKILL = 9;
    const SIGPIPE = 13;
    const SIGQUIT = 3;
    const SIGSTOP = 17;
    const SIGTSTP = 18;
    const SIGTTIN = 21;
    const SIGTTOU = 22;
    const SIGUSR1 = 30;
    const SIGUSR2 = 31;
    const SIGURG = 16;
}
else
{
    version (solaris)
{
    const SIGALRM = 14;
    const SIGBUS = 10;
    const SIGCHLD = 18;
    const SIGCONT = 25;
    const SIGHUP = 1;
    const SIGKILL = 9;
    const SIGPIPE = 13;
    const SIGQUIT = 3;
    const SIGSTOP = 23;
    const SIGTSTP = 24;
    const SIGTTIN = 26;
    const SIGTTOU = 27;
    const SIGUSR1 = 16;
    const SIGUSR2 = 17;
    const SIGURG = 21;
}
else
{
    static assert(0,"Platform not supported...");
}
}
}
}
    struct sigaction_t
{
    static if(true)
{
    union
{
sigfn_t sa_handler;
sigactfn_t sa_sigaction;
}
}
else
{
    sigfn_t sa_handler;
}
    version (freebsd)
{
    int sa_flags;
    sigset_t sa_mask;
}
else
{
    sigset_t sa_mask;
    int sa_flags;
}
    version (darwin)
{
}
else
{
    void function() sa_restorer;
}
}
    version (linux)
{
    const SIG_HOLD = cast(sigfn_t)1;
    private const _SIGSET_NWORDS = 1024 / (8 * c_ulong.sizeof);

    struct sigset_t
{
    c_ulong[_SIGSET_NWORDS] __val;
}
    const SA_NOCLDSTOP = 1;
    const SIG_BLOCK = 0;
    const SIG_UNBLOCK = 1;
    const SIG_SETMASK = 2;
    private const __SI_MAX_SIZE = 128;

    static if(false)
{
    private const __SI_PAD_SIZE = __SI_MAX_SIZE / (int).sizeof - 4;

}
else
{
    private const __SI_PAD_SIZE = __SI_MAX_SIZE / (int).sizeof - 3;

}
    struct siginfo_t
{
    int si_signo;
    int si_errno;
    int si_code;
    union _sifields_t
{
    int[__SI_PAD_SIZE] _pad;
    struct _kill_t
{
    pid_t si_pid;
    uid_t si_uid;
}
    _kill_t _kill;
    struct _timer_t
{
    int si_tid;
    int si_overrun;
    sigval si_sigval;
}
    _timer_t _timer;
    struct _rt_t
{
    pid_t si_pid;
    uid_t si_uid;
    sigval si_sigval;
}
    _rt_t _rt;
    struct _sigchild_t
{
    pid_t si_pid;
    uid_t si_uid;
    int si_status;
    clock_t si_utime;
    clock_t si_stime;
}
    _sigchild_t _sigchld;
    struct _sigfault_t
{
    void* si_addr;
}
    _sigfault_t _sigfault;
    struct _sigpoll_t
{
    c_long si_band;
    int si_fd;
}
    _sigpoll_t _sigpoll;
}
    _sifields_t _sifields;
}
    enum 
{
SI_ASYNCNL = -60,
SI_TKILL = -6,
SI_SIGIO,
SI_ASYNCIO,
SI_MESGQ,
SI_TIMER,
SI_QUEUE,
SI_USER,
SI_KERNEL = 128,
}
    int kill(pid_t, int);
    int sigaction(int, in sigaction_t*, sigaction_t*);
    int sigaddset(sigset_t*, int);
    int sigdelset(sigset_t*, int);
    int sigemptyset(sigset_t*);
    int sigfillset(sigset_t*);
    int sigismember(in sigset_t*, int);
    int sigpending(sigset_t*);
    int sigprocmask(int, in sigset_t*, sigset_t*);
    int sigsuspend(in sigset_t*);
    int sigwait(in sigset_t*, int*);
}
else
{
    version (darwin)
{
    alias uint sigset_t;
    const SIG_BLOCK = 1;
    const SIG_UNBLOCK = 2;
    const SIG_SETMASK = 3;
    struct siginfo_t
{
    int si_signo;
    int si_errno;
    int si_code;
    pid_t si_pid;
    uid_t si_uid;
    int si_status;
    void* si_addr;
    sigval si_value;
    int si_band;
    uint[7] pad;
}
    int kill(pid_t, int);
    int sigaction(int, in sigaction_t*, sigaction_t*);
    int sigaddset(sigset_t*, int);
    int sigdelset(sigset_t*, int);
    int sigemptyset(sigset_t*);
    int sigfillset(sigset_t*);
    int sigismember(in sigset_t*, int);
    int sigpending(sigset_t*);
    int sigprocmask(int, in sigset_t*, sigset_t*);
    int sigsuspend(in sigset_t*);
    int sigwait(in sigset_t*, int*);
    int sigaltstack(void*, void*);
}
else
{
    version (freebsd)
{
    struct sigset_t
{
    uint[4] __bits;
}
    const SIG_BLOCK = 2;
    const SIG_UNBLOCK = 1;
    const SIG_SETMASK = 3;
    struct siginfo_t
{
    int si_signo;
    int si_errno;
    int si_code;
    pid_t si_pid;
    uid_t si_uid;
    int si_status;
    void* si_addr;
    sigval si_value;
    union __reason
{
    struct __fault
{
    int _trapno;
}
    __fault _fault;
    struct __timer
{
    int _timerid;
    int _overrun;
}
    __timer _timer;
    struct __mesgq
{
    int _mqd;
}
    __mesgq _mesgq;
    struct __poll
{
    c_long _band;
}
    __poll _poll;
    struct ___spare___
{
    c_long __spare1__;
    int[7] __spare2__;
}
    ___spare___ __spare__;
}
    __reason _reason;
}
    int kill(pid_t, int);
    int sigaction(int, in sigaction_t*, sigaction_t*);
    int sigaddset(sigset_t*, int);
    int sigdelset(sigset_t*, int);
    int sigemptyset(sigset_t*);
    int sigfillset(sigset_t*);
    int sigismember(in sigset_t*, int);
    int sigpending(sigset_t*);
    int sigprocmask(int, in sigset_t*, sigset_t*);
    int sigsuspend(in sigset_t*);
    int sigwait(in sigset_t*, int*);
}
else
{
    version (solaris)
{
    alias id_t taskid_t;
    alias id_t projid_t;
    alias id_t poolid_t;
    alias id_t zoneid_t;
    alias id_t ctid_t;
    const SIG_HOLD = cast(sigfn_t)2;
    struct sigset_t
{
    uint[4] __sigbits;
}
    const SA_NOCLDSTOP = 131072;
    const SIG_BLOCK = 1;
    const SIG_UNBLOCK = 2;
    const SIG_SETMASK = 3;
    static if(size_t.sizeof == 8)
{
    const SI_MAXSZ = 256;
    const SI_PAD = SI_MAXSZ / (int).sizeof - 4;
}
else
{
    const SI_MAXSZ = 128;
    const SI_PAD = SI_MAXSZ / (int).sizeof - 3;
}
    struct siginfo_t
{
    int si_signo;
    int si_code;
    int si_errno;
    static if(size_t.sizeof == 8)
{
    int si_pad;
}
    union __data
{
    int[SI_PAD] __pad;
    struct __proc
{
    pid_t __pid;
    union __pdata
{
    struct __kill
{
    uid_t __uid;
    sigval __value;
}
    struct __cld
{
    clock_t __utime;
    int __status;
    clock_t __stime;
}
}
    ctid_t __ctid;
    zoneid_t __zoneid;
}
    struct __fault
{
    void* __addr;
    int __trapno;
    caddr_t __pc;
}
    struct __file
{
    int __fd;
    long __band;
}
    struct __prof
{
    caddr_t __faddr;
    timespec __tstamp;
    short __syscall;
    char __nsysarg;
    char __fault;
    long[8] __sysarg;
    int[10] __mstate;
}
    struct __rctl
{
    int32_t __entity;
}
}
}
    enum 
{
SI_NOINFO = 32767,
SI_DTRACE = 2050,
SI_RCTL = 2049,
SI_USER = 0,
SI_LWP = -1,
SI_QUEUE = -2,
SI_TIMER = -3,
SI_ASYNCIO = -4,
SI_MESGQ = -5,
}
    int kill(pid_t, int);
    int sigaction(int, in sigaction_t*, sigaction_t*);
    int sigaddset(sigset_t*, int);
    int sigdelset(sigset_t*, int);
    int sigemptyset(sigset_t*);
    int sigfillset(sigset_t*);
    int sigismember(in sigset_t*, int);
    int sigpending(sigset_t*);
    int sigprocmask(int, in sigset_t*, sigset_t*);
    int sigsuspend(in sigset_t*);
    int sigwait(in sigset_t*, int*);
}
}
}
}
    version (linux)
{
    const SIGPOLL = 29;
    const SIGPROF = 27;
    const SIGSYS = 31;
    const SIGTRAP = 5;
    const SIGVTALRM = 26;
    const SIGXCPU = 24;
    const SIGXFSZ = 25;
    const SA_ONSTACK = 134217728;
    const SA_RESETHAND = -2147483648u;
    const SA_RESTART = 268435456;
    const SA_SIGINFO = 4;
    const SA_NOCLDWAIT = 2;
    const SA_NODEFER = 1073741824;
    const SS_ONSTACK = 1;
    const SS_DISABLE = 2;
    const MINSIGSTKSZ = 2048;
    const SIGSTKSZ = 8192;
    struct stack_t
{
    void* ss_sp;
    int ss_flags;
    size_t ss_size;
}
    struct sigstack
{
    void* ss_sp;
    int ss_onstack;
}
    enum 
{
ILL_ILLOPC = 1,
ILL_ILLOPN,
ILL_ILLADR,
ILL_ILLTRP,
ILL_PRVOPC,
ILL_PRVREG,
ILL_COPROC,
ILL_BADSTK,
}
    enum 
{
FPE_INTDIV = 1,
FPE_INTOVF,
FPE_FLTDIV,
FPE_FLTOVF,
FPE_FLTUND,
FPE_FLTRES,
FPE_FLTINV,
FPE_FLTSUB,
}
    enum 
{
SEGV_MAPERR = 1,
SEGV_ACCERR,
}
    enum 
{
BUS_ADRALN = 1,
BUS_ADRERR,
BUS_OBJERR,
}
    enum 
{
TRAP_BRKPT = 1,
TRAP_TRACE,
}
    enum 
{
CLD_EXITED = 1,
CLD_KILLED,
CLD_DUMPED,
CLD_TRAPPED,
CLD_STOPPED,
CLD_CONTINUED,
}
    enum 
{
POLL_IN = 1,
POLL_OUT,
POLL_MSG,
POLL_ERR,
POLL_PRI,
POLL_HUP,
}
    sigfn_t bsd_signal(int sig, sigfn_t func);
    sigfn_t sigset(int sig, sigfn_t func);
    int killpg(pid_t, int);
    int sigaltstack(in stack_t*, stack_t*);
    int sighold(int);
    int sigignore(int);
    int siginterrupt(int, int);
    int sigpause(int);
    int sigrelse(int);
}
else
{
    version (freebsd)
{
    const SIGPROF = 27;
    const SIGSYS = 12;
    const SIGTRAP = 5;
    const SIGVTALRM = 26;
    const SIGXCPU = 24;
    const SIGXFSZ = 25;
    const SA_ONSTACK = 1;
    const SA_RESETHAND = 4;
    const SA_RESTART = 2;
    const SA_SIGINFO = 64;
    const SA_NOCLDWAIT = 32;
    const SA_NODEFER = 16;
    const SS_ONSTACK = 1;
    const SS_DISABLE = 4;
    const MINSIGSTKSZ = 512 * 4;
    const SIGSTKSZ = MINSIGSTKSZ + 32768;
    struct stack_t
{
    void* ss_sp;
    size_t ss_size;
    int ss_flags;
}
    struct sigstack
{
    char* ss_sp;
    int ss_onstack;
}
    enum 
{
ILL_ILLOPC = 1,
ILL_ILLOPN,
ILL_ILLADR,
ILL_ILLTRP,
ILL_PRVOPC,
ILL_PRVREG,
ILL_COPROC,
ILL_BADSTK,
}
    enum 
{
FPE_INTOVF = 1,
FPE_INTDIV,
FPE_FLTDIV,
FPE_FLTOVF,
FPE_FLTUND,
FPE_FLTRES,
FPE_FLTINV,
FPE_FLTSUB,
}
    enum 
{
SEGV_MAPERR = 1,
SEGV_ACCERR,
}
    enum 
{
BUS_ADRALN = 1,
BUS_ADRERR,
BUS_OBJERR,
}
    enum 
{
TRAP_BRKPT = 1,
TRAP_TRACE,
}
    enum 
{
CLD_EXITED = 1,
CLD_KILLED,
CLD_DUMPED,
CLD_TRAPPED,
CLD_STOPPED,
CLD_CONTINUED,
}
    enum 
{
POLL_IN = 1,
POLL_OUT,
POLL_MSG,
POLL_ERR,
POLL_PRI,
POLL_HUP,
}
    int killpg(pid_t, int);
    int sigaltstack(stack_t*, stack_t*);
    int sigblock(int);
    int sigignore(int);
    int siginterrupt(int, int);
    int sigpause(int);
    int sigrelse(int);
}
}
    version (darwin)
{
    const int SA_ONSTACK = 1;

    const int SA_RESTART = 2;

    const int SA_RESETHAND = 4;

    const int SA_NOCLDSTOP = 8;

    const int SA_NODEFER = 16;

    const int SA_NOCLDWAIT = 32;

    const int SA_SIGINFO = 64;

    const int SA_USERTRAMP = 256;

    const MINSIGSTKSZ = 32768;
    const SIGSTKSZ = 131072;
}
    version (solaris)
{
    const SA_ONSTACK = 1;
    const SA_RESETHAND = 2;
    const SA_RESTART = 4;
    const SA_SIGINFO = 8;
    const SA_NOCLDWAIT = 65536;
    const SA_NODEFER = 16;
    const SS_ONSTACK = 1;
    const SS_DISABLE = 2;
    const MINSIGSTKSZ = 2048;
    const SIGSTKSZ = 8192;
    struct stack_t
{
    void* ss_sp;
    size_t ss_size;
    int ss_flags;
}
    struct sigstack
{
    void* ss_sp;
    int ss_onstack;
}
}
    version (linux)
{
    struct timespec
{
    time_t tv_sec;
    c_long tv_nsec;
}
}
else
{
    version (darwin)
{
    struct timespec
{
    time_t tv_sec;
    c_long tv_nsec;
}
}
else
{
    version (freebsd)
{
    struct timespec
{
    time_t tv_sec;
    c_long tv_nsec;
}
}
else
{
    version (solaris)
{
    struct timespec
{
    time_t tv_sec;
    c_long tv_nsec;
}
}
}
}
}
    version (linux)
{
    private const __SIGEV_MAX_SIZE = 64;

    static if(false)
{
    private const __SIGEV_PAD_SIZE = __SIGEV_MAX_SIZE / (int).sizeof - 4;

}
else
{
    private const __SIGEV_PAD_SIZE = __SIGEV_MAX_SIZE / (int).sizeof - 3;

}
    struct sigevent
{
    sigval sigev_value;
    int sigev_signo;
    int sigev_notify;
    union _sigev_un_t
{
    int[__SIGEV_PAD_SIZE] _pad;
    pid_t _tid;
    struct _sigev_thread_t
{
    void function(sigval) _function;
    void* _attribute;
}
    _sigev_thread_t _sigev_thread;
}
    _sigev_un_t _sigev_un;
}
    int sigqueue(pid_t, int, in sigval);
    int sigtimedwait(in sigset_t*, siginfo_t*, in timespec*);
    int sigwaitinfo(in sigset_t*, siginfo_t*);
}
else
{
    version (freebsd)
{
    struct sigevent
{
    int sigev_notify;
    int sigev_signo;
    sigval sigev_value;
    struct __sigev_thread
{
    void function(sigval) _function;
    void* _attribute;
}
    union _sigev_un
{
    lwpid_t _threadid;
    __sigev_thread _sigev_thread;
    c_long[8] __spare__;
}
}
    int sigqueue(pid_t, int, in sigval);
    int sigtimedwait(in sigset_t*, siginfo_t*, in timespec*);
    int sigwaitinfo(in sigset_t*, siginfo_t*);
}
else
{
    version (solaris)
{
    struct sigevent
{
    int sigev_notify;
    int sigev_signo;
    sigval sigev_value;
    void function(sigval) sigev_notify_function;
    pthread_attr_t* sigev_notify_attributes;
    private int __sigev_pad2;

}
}
else
{
    version (darwin)
{
    struct sigevent
{
    int sigev_notify;
    int sigev_signo;
    sigval sigev_value;
    void function(sigval) sigev_notify_function;
    pthread_attr_t* sigev_notify_attributes;
}
}
}
}
}
    version (linux)
{
    int pthread_kill(pthread_t, int);
    int pthread_sigmask(int, in sigset_t*, sigset_t*);
}
else
{
    version (darwin)
{
    int pthread_kill(pthread_t, int);
    int pthread_sigmask(int, in sigset_t*, sigset_t*);
}
else
{
    version (freebsd)
{
    int pthread_kill(pthread_t, int);
    int pthread_sigmask(int, in sigset_t*, sigset_t*);
}
else
{
    version (solaris)
{
    int pthread_kill(pthread_t, int);
    int pthread_sigmask(int, in sigset_t*, sigset_t*);
}
}
}
}
}
