// D import file generated from 'tango/stdc/posix/sys/select.d'
module tango.stdc.posix.sys.select;
private import tango.stdc.posix.config;

public import tango.stdc.time;

public import tango.stdc.posix.sys.time;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.signal;

extern (C) version (linux)
{
    private 
{
    alias c_long __fd_mask;
    const int __NFDBITS = 8 * __fd_mask.sizeof;

    extern (D) int __FDELT(int d)
{
return d / __NFDBITS;
}

    extern (D) int __FDMASK(int d)
{
return cast(__fd_mask)(1 << d % __NFDBITS);
}

}
    const FD_SETSIZE = 1024;
    struct fd_set
{
    __fd_mask[FD_SETSIZE / __NFDBITS] fds_bits;
}
    extern (D) void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] &= ~__FDMASK(fd);
}

    extern (D) int FD_ISSET(int fd, fd_set* fdset)
{
return cast(int)(fdset.fds_bits[__FDELT(fd)] & __FDMASK(fd));
}

    extern (D) void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] |= __FDMASK(fd);
}

    extern (D) void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}

    int pselect(int, fd_set*, fd_set*, fd_set*, in timespec*, in sigset_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
}
else
{
    version (darwin)
{
    private 
{
    const uint __DARWIN_NBBY = 8;

    const uint __DARWIN_NFDBITS = (int).sizeof * __DARWIN_NBBY;

    alias uint __fd_mask;
    const __NFDBITS = 8 * __fd_mask.sizeof;
    extern (D) int __FDELT(int d)
{
return d / __NFDBITS;
}

    extern (D) __fd_mask __FDMASK(int d)
{
return cast(__fd_mask)1 << d % __NFDBITS;
}

}
    const FD_SETSIZE = 1024;
    struct fd_set
{
    int[(FD_SETSIZE + (__DARWIN_NFDBITS - 1)) / __DARWIN_NFDBITS] fds_bits;
}
    extern (D) void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] &= ~__FDMASK(fd);
}

    extern (D) int FD_ISSET(int fd, fd_set* fdset)
{
return fdset.fds_bits[__FDELT(fd)] & __FDMASK(fd);
}

    extern (D) void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] |= __FDMASK(fd);
}

    extern (D) void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}

}
else
{
    version (freebsd)
{
    private 
{
    const uint FD_SETSIZE = 1024;

    alias c_long __fd_mask;
    const _NFDBITS = 8 * __fd_mask.sizeof;
    extern (D) int __FDELT(int d)
{
return d / _NFDBITS;
}

    extern (D) __fd_mask __FDMASK(int d)
{
return cast(__fd_mask)1 << d % _NFDBITS;
}

}
    struct fd_set
{
    c_ulong[(FD_SETSIZE + (_NFDBITS - 1)) / _NFDBITS] fds_bits;
}
    extern (D) void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] &= ~__FDMASK(fd);
}

    extern (D) int FD_ISSET(int fd, fd_set* fdset)
{
return fdset.fds_bits[__FDELT(fd)] & __FDMASK(fd);
}

    extern (D) void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] |= __FDMASK(fd);
}

    extern (D) void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}

}
else
{
    version (solaris)
{
    private 
{
    alias c_long __fd_mask;
    const NBBY = 8;
    const FD_NFDBITS = __fd_mask.sizeof * NBBY;
    extern (D) int __FDELT(int d)
{
return d / FD_NFDBITS;
}

    extern (D) __fd_mask __FDMASK(int d)
{
return cast(__fd_mask)1 << d % FD_NFDBITS;
}

}
    version (X86_64)
{
    const FD_SETSIZE = 65536;
}
else
{
    const FD_SETSIZE = 1024;
}
    struct fd_set
{
    __fd_mask[(FD_SETSIZE + FD_NFDBITS - 1) / FD_NFDBITS] fds_bits;
}
    extern (D) void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] &= ~__FDMASK(fd);
}

    extern (D) int FD_ISSET(int fd, fd_set* fdset)
{
return fdset.fds_bits[__FDELT(fd)] & __FDMASK(fd);
}

    extern (D) void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] |= __FDMASK(fd);
}

    extern (D) void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}

}
}
}
}

