// D import file generated from 'tango/stdc/posix/sys/stat.d'
module tango.stdc.posix.sys.stat;
private import tango.stdc.posix.config;

private import tango.stdc.stdint;

private import tango.stdc.posix.time;

public import tango.stdc.stddef;

public import tango.stdc.posix.sys.types;

private import tango.core.Octal;

extern (C) 
{
    version (linux)
{
    static if(__USE_LARGEFILE64)
{
    private alias uint _pad_t;

}
else
{
    private alias ushort _pad_t;

}
    align (4)struct stat_t
{
    dev_t st_dev;
    version (X86_64)
{
}
else
{
    _pad_t __pad1;
}
    static if(__USE_LARGEFILE64)
{
    ino_t __st_ino;
}
else
{
    ino_t st_ino;
}
    version (X86_64)
{
    nlink_t st_nlink;
    mode_t st_mode;
}
else
{
    mode_t st_mode;
    nlink_t st_nlink;
}
    uid_t st_uid;
    gid_t st_gid;
    version (X86_64)
{
    int pad0;
    dev_t st_rdev;
}
else
{
    dev_t st_rdev;
    _pad_t __pad2;
}
    off_t st_size;
    blksize_t st_blksize;
    blkcnt_t st_blocks;
    static if(false)
{
    timespec st_atim;
    timespec st_mtim;
    timespec st_ctim;
    alias st_atim.tv_sec st_atime;
    alias st_mtim.tv_sec st_mtime;
    alias st_ctim.tv_sec st_ctime;
}
else
{
    time_t st_atime;
    c_ulong st_atimensec;
    time_t st_mtime;
    c_ulong st_mtimensec;
    time_t st_ctime;
    c_ulong st_ctimensec;
}
    version (X86_64)
{
    c_long[3] __unused;
}
else
{
    static if(__USE_LARGEFILE64)
{
    ino64_t st_ino;
}
else
{
    c_ulong __unused4;
    c_ulong __unused5;
}
}
}

    const S_IRUSR = octal!(400);
    const S_IWUSR = octal!(200);
    const S_IXUSR = octal!(100);
    const S_IRWXU = S_IRUSR | S_IWUSR | S_IXUSR;
    const S_IRGRP = S_IRUSR >> 3;
    const S_IWGRP = S_IWUSR >> 3;
    const S_IXGRP = S_IXUSR >> 3;
    const S_IRWXG = S_IRWXU >> 3;
    const S_IROTH = S_IRGRP >> 3;
    const S_IWOTH = S_IWGRP >> 3;
    const S_IXOTH = S_IXGRP >> 3;
    const S_IRWXO = S_IRWXG >> 3;
    const S_ISUID = octal!(4000);
    const S_ISGID = octal!(2000);
    const S_ISVTX = octal!(1000);
    private extern (D) bool S_ISTYPE(mode_t mode, uint mask)
{
return (mode & S_IFMT) == mask;
}


    extern (D) bool S_ISBLK(mode_t mode)
{
return S_ISTYPE(mode,S_IFBLK);
}

    extern (D) bool S_ISCHR(mode_t mode)
{
return S_ISTYPE(mode,S_IFCHR);
}

    extern (D) bool S_ISDIR(mode_t mode)
{
return S_ISTYPE(mode,S_IFDIR);
}

    extern (D) bool S_ISFIFO(mode_t mode)
{
return S_ISTYPE(mode,S_IFIFO);
}

    extern (D) bool S_ISREG(mode_t mode)
{
return S_ISTYPE(mode,S_IFREG);
}

    extern (D) bool S_ISLNK(mode_t mode)
{
return S_ISTYPE(mode,S_IFLNK);
}

    extern (D) bool S_ISSOCK(mode_t mode)
{
return S_ISTYPE(mode,S_IFSOCK);
}

    static if(true)
{
    extern bool S_TYPEISMQ(stat_t* buf)
{
return false;
}

    extern bool S_TYPEISSEM(stat_t* buf)
{
return false;
}

    extern bool S_TYPEISSHM(stat_t* buf)
{
return false;
}

}
}
else
{
    version (darwin)
{
    struct stat_t
{
    dev_t st_dev;
    ino_t st_ino;
    mode_t st_mode;
    nlink_t st_nlink;
    uid_t st_uid;
    gid_t st_gid;
    dev_t st_rdev;
    time_t st_atime;
    c_ulong st_atimensec;
    time_t st_mtime;
    c_ulong st_mtimensec;
    time_t st_ctime;
    c_ulong st_ctimensec;
    off_t st_size;
    blkcnt_t st_blocks;
    blksize_t st_blksize;
    uint st_flags;
    uint st_gen;
    int st_lspare;
    long[2] st_qspare;
}
    const S_IRUSR = octal!(400);
    const S_IWUSR = octal!(200);
    const S_IXUSR = octal!(100);
    const S_IRWXU = S_IRUSR | S_IWUSR | S_IXUSR;
    const S_IRGRP = S_IRUSR >> 3;
    const S_IWGRP = S_IWUSR >> 3;
    const S_IXGRP = S_IXUSR >> 3;
    const S_IRWXG = S_IRWXU >> 3;
    const S_IROTH = S_IRGRP >> 3;
    const S_IWOTH = S_IWGRP >> 3;
    const S_IXOTH = S_IXGRP >> 3;
    const S_IRWXO = S_IRWXG >> 3;
    const S_ISUID = octal!(4000);
    const S_ISGID = octal!(2000);
    const S_ISVTX = octal!(1000);
    private extern (D) bool S_ISTYPE(mode_t mode, uint mask)
{
return (mode & S_IFMT) == mask;
}


    extern (D) bool S_ISBLK(mode_t mode)
{
return S_ISTYPE(mode,S_IFBLK);
}

    extern (D) bool S_ISCHR(mode_t mode)
{
return S_ISTYPE(mode,S_IFCHR);
}

    extern (D) bool S_ISDIR(mode_t mode)
{
return S_ISTYPE(mode,S_IFDIR);
}

    extern (D) bool S_ISFIFO(mode_t mode)
{
return S_ISTYPE(mode,S_IFIFO);
}

    extern (D) bool S_ISREG(mode_t mode)
{
return S_ISTYPE(mode,S_IFREG);
}

    extern (D) bool S_ISLNK(mode_t mode)
{
return S_ISTYPE(mode,S_IFLNK);
}

    extern (D) bool S_ISSOCK(mode_t mode)
{
return S_ISTYPE(mode,S_IFSOCK);
}

}
else
{
    version (freebsd)
{
    struct stat_t
{
    dev_t st_dev;
    ino_t st_ino;
    mode_t st_mode;
    nlink_t st_nlink;
    uid_t st_uid;
    gid_t st_gid;
    dev_t st_rdev;
    time_t st_atime;
    c_ulong st_atimensec;
    time_t st_mtime;
    c_ulong st_mtimensec;
    time_t st_ctime;
    c_ulong st_ctimensec;
    off_t st_size;
    blkcnt_t st_blocks;
    blksize_t st_blksize;
    fflags_t st_flags;
    uint st_gen;
    int st_lspare;
    timespec st_birthtimespec;
    byte[16 - timespec.sizeof] padding;
}
    const S_IRUSR = octal!(400);
    const S_IWUSR = octal!(200);
    const S_IXUSR = octal!(100);
    const S_IRWXU = octal!(700);
    const S_IRGRP = octal!(40);
    const S_IWGRP = octal!(20);
    const S_IXGRP = octal!(10);
    const S_IRWXG = octal!(70);
    const S_IROTH = octal!(4);
    const S_IWOTH = octal!(2);
    const S_IXOTH = octal!(1);
    const S_IRWXO = octal!(7);
    const S_ISUID = octal!(4000);
    const S_ISGID = octal!(2000);
    const S_ISVTX = octal!(1000);
    private extern (D) bool S_ISTYPE(mode_t mode, uint mask)
{
return (mode & S_IFMT) == mask;
}


    extern (D) bool S_ISBLK(mode_t mode)
{
return S_ISTYPE(mode,S_IFBLK);
}

    extern (D) bool S_ISCHR(mode_t mode)
{
return S_ISTYPE(mode,S_IFCHR);
}

    extern (D) bool S_ISDIR(mode_t mode)
{
return S_ISTYPE(mode,S_IFDIR);
}

    extern (D) bool S_ISFIFO(mode_t mode)
{
return S_ISTYPE(mode,S_IFIFO);
}

    extern (D) bool S_ISREG(mode_t mode)
{
return S_ISTYPE(mode,S_IFREG);
}

    extern (D) bool S_ISLNK(mode_t mode)
{
return S_ISTYPE(mode,S_IFLNK);
}

    extern (D) bool S_ISSOCK(mode_t mode)
{
return S_ISTYPE(mode,S_IFSOCK);
}

}
else
{
    version (solaris)
{
    const _ST_FSTYPSZ = 16;
    struct stat_t
{
    version (X86_64)
{
    dev_t st_dev;
    ino_t st_ino;
    mode_t st_mode;
    nlink_t st_nlink;
    uid_t st_uid;
    gid_t st_gid;
    dev_t st_rdev;
    off_t st_size;
    time_t st_atime;
    c_ulong st_atimensec;
    time_t st_mtime;
    c_ulong st_mtimensec;
    time_t st_ctime;
    c_ulong st_ctimensec;
    blksize_t st_blksize;
    blkcnt_t st_blocks;
    char[_ST_FSTYPSZ] st_fstype;
}
else
{
    dev_t st_dev;
    c_long[3] st_pad1;
    ino_t st_ino;
    mode_t st_mode;
    nlink_t st_nlink;
    uid_t st_uid;
    gid_t st_gid;
    dev_t st_rdev;
    c_long[2] st_pad2;
    off_t st_size;
    static if(!__USE_LARGEFILE64)
{
    c_long st_pad3;
}
    time_t st_atime;
    c_ulong st_atimensec;
    time_t st_mtime;
    c_ulong st_mtimensec;
    time_t st_ctime;
    c_ulong st_ctimensec;
    blksize_t st_blksize;
    blkcnt_t st_blocks;
    char[_ST_FSTYPSZ] st_fstype;
    c_long[8] st_pad4;
}
}
    enum 
{
S_IFMT = 61440,
S_IAMB = 511,
S_IFIFO = 4096,
S_IFCHR = 8192,
S_IFDIR = 16384,
S_IFNAM = 20480,
S_INSEM = 1,
S_INSHD = 2,
S_IFBLK = 24576,
S_IFREG = 32768,
S_IFLNK = 40960,
S_IFSOCK = 49152,
S_IFDOOR = 53248,
S_IFPORT = 57344,
S_ISUID = 2048,
S_ISGID = 1024,
S_ISVTX = 512,
S_IREAD = octal!(400),
S_IWRITE = octal!(200),
S_IEXEC = octal!(100),
S_ENFMT = S_ISGID,
S_IRWXU = octal!(700),
S_IRUSR = octal!(400),
S_IWUSR = octal!(200),
S_IXUSR = octal!(100),
S_IRWXG = octal!(70),
S_IRGRP = octal!(40),
S_IWGRP = octal!(20),
S_IXGRP = octal!(10),
S_IRWXO = octal!(7),
S_IROTH = octal!(4),
S_IWOTH = octal!(2),
S_IXOTH = octal!(1),
}
    extern (D) bool S_ISFIFO(mode_t mode)
{
return (mode & 61440) == 4096;
}

    extern (D) bool S_ISCHR(mode_t mode)
{
return (mode & 61440) == 8192;
}

    extern (D) bool S_ISDIR(mode_t mode)
{
return (mode & 61440) == 16384;
}

    extern (D) bool S_ISBLK(mode_t mode)
{
return (mode & 61440) == 24576;
}

    extern (D) bool S_ISREG(mode_t mode)
{
return (mode & 61440) == 32768;
}

    extern (D) bool S_ISLNK(mode_t mode)
{
return (mode & 61440) == 40960;
}

    extern (D) bool S_ISSOCK(mode_t mode)
{
return (mode & 61440) == 49152;
}

    extern (D) bool S_ISDOOR(mode_t mode)
{
return (mode & 61440) == 53248;
}

    extern (D) bool S_ISPORT(mode_t mode)
{
return (mode & 61440) == 57344;
}

}
}
}
}
    int chmod(in char*, mode_t);
    int fchmod(int, mode_t);
    int mkdir(in char*, mode_t);
    int mkfifo(in char*, mode_t);
    mode_t umask(mode_t);
    static if(__USE_LARGEFILE64)
{
    int fstat64(int, stat_t*);
    alias fstat64 fstat;
    int lstat64(in char*, stat_t*);
    alias lstat64 lstat;
    int stat64(in char*, stat_t*);
    alias stat64 stat;
}
else
{
    int fstat(int, stat_t*);
    int lstat(in char*, stat_t*);
    int stat(in char*, stat_t*);
}
    version (linux)
{
    const S_IFMT = octal!(170000);
    const S_IFBLK = octal!(60000);
    const S_IFCHR = octal!(20000);
    const S_IFIFO = octal!(10000);
    const S_IFREG = octal!(100000);
    const S_IFDIR = octal!(40000);
    const S_IFLNK = octal!(120000);
    const S_IFSOCK = octal!(140000);
    int mknod(in char*, mode_t, dev_t);
}
else
{
    version (darwin)
{
    const S_IFMT = octal!(170000);
    const S_IFBLK = octal!(60000);
    const S_IFCHR = octal!(20000);
    const S_IFIFO = octal!(10000);
    const S_IFREG = octal!(100000);
    const S_IFDIR = octal!(40000);
    const S_IFLNK = octal!(120000);
    const S_IFSOCK = octal!(140000);
    int mknod(in char*, mode_t, dev_t);
}
else
{
    version (freebsd)
{
    const S_IFMT = octal!(170000);
    const S_IFBLK = octal!(60000);
    const S_IFCHR = octal!(20000);
    const S_IFIFO = octal!(10000);
    const S_IFREG = octal!(100000);
    const S_IFDIR = octal!(40000);
    const S_IFLNK = octal!(120000);
    const S_IFSOCK = octal!(140000);
    int mknod(in char*, mode_t, dev_t);
}
else
{
    version (solaris)
{
    int mknod(in char*, mode_t, dev_t);
}
}
}
}
}
