// D import file generated from 'tango/stdc/posix/time.d'
module tango.stdc.posix.time;
private import tango.stdc.posix.config;

public import tango.stdc.time;

public import tango.stdc.posix.sys.types;

public import tango.stdc.posix.signal;

extern (C) 
{
    version (linux)
{
    time_t timegm(tm*);
}
else
{
    version (darwin)
{
    time_t timegm(tm*);
}
else
{
    version (freebsd)
{
    time_t timegm(tm*);
}
else
{
    version (solaris)
{
    time_t timegm(tm* t)
{
time_t tl,tb;
tm* tg;
tl = mktime(t);
if (tl == -1)
{
t.tm_hour--;
tl = mktime(t);
if (tl == -1)
return -1;
tl += 3600;
}
tg = gmtime(&tl);
tg.tm_isdst = 0;
tb = mktime(tg);
if (tb == -1)
{
tg.tm_hour--;
tb = mktime(tg);
if (tb == -1)
return -1;
tb += 3600;
}
return tl - (tb - tl);
}
}
}
}
}
    version (linux)
{
    const CLOCK_PROCESS_CPUTIME_ID = 2;
    const CLOCK_THREAD_CPUTIME_ID = 3;
    struct itimerspec
{
    timespec it_interval;
    timespec it_value;
}
    const CLOCK_REALTIME = 0;
    const TIMER_ABSTIME = 1;
    alias int clockid_t;
    alias int timer_t;
    int clock_getres(clockid_t, timespec*);
    int nanosleep(in timespec*, timespec*);
    int timer_create(clockid_t, sigevent*, timer_t*);
    int timer_delete(timer_t);
    int timer_gettime(timer_t, itimerspec*);
    int timer_getoverrun(timer_t);
    int timer_settime(timer_t, int, in itimerspec*, itimerspec*);
}
else
{
    version (darwin)
{
    int nanosleep(in timespec*, timespec*);
}
else
{
    version (freebsd)
{
    const CLOCK_PROCESS_CPUTIME_ID = 2;
    const CLOCK_THREAD_CPUTIME_ID = 3;
    struct itimerspec
{
    timespec it_interval;
    timespec it_value;
}
    const CLOCK_REALTIME = 0;
    const TIMER_ABSTIME = 1;
    alias int clockid_t;
    alias int timer_t;
    int clock_getres(clockid_t, timespec*);
    int clock_gettime(clockid_t, timespec*);
    int clock_settime(clockid_t, in timespec*);
    int nanosleep(in timespec*, timespec*);
    int timer_create(clockid_t, sigevent*, timer_t*);
    int timer_delete(timer_t);
    int timer_gettime(timer_t, itimerspec*);
    int timer_getoverrun(timer_t);
    int timer_settime(timer_t, int, in itimerspec*, itimerspec*);
}
else
{
    version (solaris)
{
    const CLOCK_PROCESS_CPUTIME_ID = 5;
    const CLOCK_THREAD_CPUTIME_ID = 2;
    struct itimerspec
{
    timespec it_interval;
    timespec it_value;
}
    const CLOCK_REALTIME = 3;
    const TIMER_ABSTIME = 1;
    alias int clockid_t;
    alias int timer_t;
    int clock_getres(clockid_t, timespec*);
    int clock_gettime(clockid_t, timespec*);
    int clock_settime(clockid_t, in timespec*);
    int nanosleep(in timespec*, timespec*);
    int timer_create(clockid_t, sigevent*, timer_t*);
    int timer_delete(timer_t);
    int timer_gettime(timer_t, itimerspec*);
    int timer_getoverrun(timer_t);
    int timer_settime(timer_t, int, in itimerspec*, itimerspec*);
}
}
}
}
    version (linux)
{
    char* asctime_r(in tm*, char*);
    char* ctime_r(in time_t*, char*);
    tm* gmtime_r(in time_t*, tm*);
    tm* localtime_r(in time_t*, tm*);
}
else
{
    version (darwin)
{
    char* asctime_r(in tm*, char*);
    char* ctime_r(in time_t*, char*);
    tm* gmtime_r(in time_t*, tm*);
    tm* localtime_r(in time_t*, tm*);
}
else
{
    version (freebsd)
{
    char* asctime_r(in tm*, char*);
    char* ctime_r(in time_t*, char*);
    tm* gmtime_r(in time_t*, tm*);
    tm* localtime_r(in time_t*, tm*);
}
else
{
    version (solaris)
{
    char* asctime_r(in tm*, char*);
    char* ctime_r(in time_t*, char*);
    tm* gmtime_r(in time_t*, tm*);
    tm* localtime_r(in time_t*, tm*);
}
}
}
}
    version (linux)
{
    extern __gshared int daylight;

    extern __gshared c_long timezone;

    tm* getdate(in char*);
    char* strptime(in char*, in char*, tm*);
}
else
{
    version (darwin)
{
    extern __gshared c_long timezone;

    tm* getdate(in char*);
    char* strptime(in char*, in char*, tm*);
}
else
{
    version (freebsd)
{
    extern __gshared c_long timezone;

    char* strptime(in char*, in char*, tm*);
}
else
{
    version (solaris)
{
    extern __gshared c_long timezone;

    tm* getdate(in char*);
    char* strptime(in char*, in char*, tm*);
}
}
}
}
}
