// D import file generated from 'tango/sys/HomeFolder.d'
module tango.sys.HomeFolder;
import TextUtil = tango.text.Util;
import Path = tango.io.Path;
import tango.sys.Environment;
version (Posix)
{
    import tango.core.Exception;
    import tango.stdc.stdlib;
    import tango.stdc.posix.pwd;
    import tango.stdc.errno;
    private extern (C) size_t strlen(in char*);


}
@property char[] homeFolder();

version (Posix)
{
    inout(char)[] expandTilde(inout(char)[] inputPath)
{
if (inputPath.length < 1 || inputPath[0] != '~')
return inputPath;
if (inputPath.length == 1 || inputPath[1] == '/')
return expandFromEnvironment(inputPath);
else
return expandFromDatabase(inputPath);
}
    private inout(char)[] expandFromEnvironment(inout(char)[] path)
in
{
assert(path.length >= 1);
assert(path[0] == '~');
}
body
{
char[] home = homeFolder;
if (home is null)
return cast(inout)path;
if (home[$ - 1] == '/')
home = home[0..$ - 1];
return cast(inout)Path.join(home,path[1..$]);
}

    private inout(char)[] expandFromDatabase(inout(char)[] path);

}
version (Windows)
{
    inout(char)[] expandTilde(inout(char)[] inputPath)
{
inputPath = cast(inout(char)[])Path.standard(inputPath.dup);
if (inputPath.length < 1 || inputPath[0] != '~')
{
return cast(inout)inputPath;
}
if (inputPath.length == 1 || inputPath[1] == '/')
{
return expandCurrentUser(inputPath);
}
return expandOtherUser(inputPath);
}
    private inout(char)[] expandCurrentUser(inout(char)[] path)
{
auto userProfileDir = homeFolder;
auto offset = TextUtil.locate(path,'/');
if (offset == path.length)
{
return cast(inout(char)[])userProfileDir;
}
return cast(inout)Path.join(userProfileDir,path[offset + 1..$]);
}

    private inout(char)[] expandOtherUser(inout(char)[] path)
{
auto profileDir = Path.parse(homeFolder).parent;
return cast(inout)Path.join(profileDir,path[1..$]);
}

}
debug (UnitTest)
{
    }
