// D import file generated from 'tango/sys/Pipe.d'
module tango.sys.Pipe;
private import tango.sys.Common;

private import tango.io.device.Device;

private import tango.core.Exception;

version (Posix)
{
    private import tango.stdc.posix.unistd;

}
debug (PipeConduit)
{
    private import tango.io.Stdout;

}
private enum 
{
DefaultBufferSize = 8 * 1024,
}

class PipeConduit : Device
{
    version (OLD)
{
    alias Device.fileHandle fileHandle;
    alias Device.copy copy;
    alias Device.read read;
    alias Device.write write;
    alias Device.close close;
    alias Device.error error;
}
    private uint _bufferSize;

    private this(Handle handle, uint bufferSize = DefaultBufferSize);

    public ~this()
{
close();
}

    public const override size_t bufferSize()
{
return _bufferSize;
}


    public override immutable(char)[] toString()
{
return "<pipe>";
}


    version (OLD)
{
    protected override uint read(void[] dst)
{
uint result;
DWORD read;
void* p = dst.ptr;
if (!ReadFile(handle,p,dst.length,&read,null))
{
if (SysError.lastCode() == ERROR_BROKEN_PIPE)
{
return Eof;
}
else
{
error();
}
}
if (read == 0 && dst.length > 0)
{
return Eof;
}
return read;
}


    protected override uint write(const(void)[] src)
{
DWORD written;
if (!WriteFile(handle,src.ptr,src.length,&written,null))
{
error();
}
return written;
}


}
}
class Pipe
{
    private PipeConduit _source;

    private PipeConduit _sink;

    public this(uint bufferSize = DefaultBufferSize);

    version (Windows)
{
    package this(uint bufferSize, SECURITY_ATTRIBUTES* sa)
{
HANDLE sinkHandle;
HANDLE sourceHandle;
if (CreatePipe(&sourceHandle,&sinkHandle,sa,cast(DWORD)bufferSize))
{
_source = new PipeConduit(sourceHandle);
_sink = new PipeConduit(sinkHandle);
}
else
{
error();
}
}

}
    @property public PipeConduit sink()
{
return _sink;
}


    @property public PipeConduit source()
{
return _source;
}


    private final void error();


}
