// D import file generated from 'tango/sys/SharedLib.d'
module tango.sys.SharedLib;
private 
{
    import tango.stdc.stringz;
    version (Windows)
{
    import tango.sys.Common;
    import tango.sys.win32.Types;
    extern (Windows) 
{
    void* GetProcAddress(HINSTANCE, const(char)*);
    BOOL FreeLibrary(HMODULE);
    version (Win32SansUnicode)
{
    HINSTANCE LoadLibraryA(const(char)*);
}
else
{
    enum 
{
CP_UTF8 = 65001,
}
    HINSTANCE LoadLibraryW(const(wchar)*);
    int MultiByteToWideChar(uint, uint, const(char)*, int, wchar*, int);
}
}
}
else
{
    version (Posix)
{
    import tango.stdc.posix.dlfcn;
}
else
{
    static assert(false,"No support for this platform");
}
}
    version (SharedLibVerbose)
{
    import tango.util.log.Trace;
}
}
version (Posix)
{
    version (freebsd)
{
}
else
{
    pragma (lib, "dl");
}
}
final class SharedLib
{
    enum LoadMode 
{
Now = 1,
Lazy = 2,
Global = 4,
Local = 8,
}
    static SharedLib load(const(char)[] path, LoadMode mode = LoadMode.Now | LoadMode.Global)
{
return loadImpl(path,mode,true);
}

    static SharedLib loadNoThrow(const(char)[] path, LoadMode mode = LoadMode.Now | LoadMode.Global)
{
return loadImpl(path,mode,false);
}

    private static SharedLib loadImpl(const(char)[] path, LoadMode mode, bool throwExceptions);


    void unload()
{
return unloadImpl(true);
}
    void unloadNoThrow()
{
return unloadImpl(false);
}
    private void unloadImpl(bool throwExceptions);

    @property const(char)[] path()
{
return this.path_;
}

    void* getSymbol(const(char)* name)
{
return getSymbolImpl(name,true);
}
    void* getSymbolNoThrow(const(char)* name)
{
return getSymbolImpl(name,false);
}
    private void* getSymbolImpl(const(char)* name, bool throwExceptions)
{
assert(loaded);
return getSymbol_(name,throwExceptions);
}

    static uint numLoadedLibs()
{
return cast(uint)loadedLibs.keys.length;
}

    private 
{
    version (Windows)
{
    HMODULE handle;
    void load_(LoadMode mode, bool throwExceptions);
    void* getSymbol_(const(char)* name, bool throwExceptions);
    void unload_(bool throwExceptions);
}
else
{
    version (Posix)
{
    void* handle;
    void load_(LoadMode mode, bool throwExceptions);
    void* getSymbol_(const(char)* name, bool throwExceptions);
    void unload_(bool throwExceptions);
}
else
{
    static assert(false,"No support for this platform");
}
}
    const(char)[] path_;
    int refCnt = 0;
    @property bool loaded()
{
return handle !is null;
}

    this(const(char)[] path)
{
this.path_ = path;
}
}
    private __gshared static 
{
    SharedLib[char[]] loadedLibs;
    Object mutex;
}


    shared static this();
}

class SharedLibException : Exception
{
    this(immutable(char)[] msg)
{
super(msg);
}
}
debug (SharedLib)
{
    void main()
{
auto lib = new SharedLib("foo");
}
}
