// D import file generated from 'tango/text/Arguments.d'
module tango.text.Arguments;
private import tango.text.Util;

private import tango.util.container.more.Stack;

version = dashdash;
class Arguments
{
    public alias get opCall;

    public alias get opIndex;

    private Stack!(Argument) stack;

    private Argument[const(char)[]] args;

    private Argument[const(char)[]] aliases;

    private char eq;

    private 
{
    const(char)[] sp;
    const(char)[] lp;
}
    private const(char)[][] msgs = errmsg;

    private const const(char)[][] errmsg = ["argument '{0}' expects {2} parameter(s) but has {1}\x0a","argument '{0}' expects {3} parameter(s) but has {1}\x0a","argument '{0}' is missing\x0a","argument '{0}' requires '{4}'\x0a","argument '{0}' conflicts with '{4}'\x0a","unexpected argument '{0}'\x0a","argument '{0}' expects one of {5}\x0a","invalid parameter for argument '{0}': {4}\x0a"];


    this(const(char)[] sp = "-", const(char)[] lp = "--", char eq = '=')
{
this.sp = sp;
this.lp = lp;
this.eq = eq;
get(null).params();
}
    final bool parse(const(char)[] input, bool sloppy = false);

    final bool parse(const(char)[][] input, bool sloppy = false);

    final Arguments clear();

    final Argument get(char name)
{
return get((&name)[0..1]);
}

    final Argument get(const(char)[] name)
{
auto a = name in args;
if (a is null)
{
name = name.dup;
return args[name] = new Argument(name);
}
return *a;
}

    final int opApply(scope int delegate(ref Argument) dg);

    final char[] errors(char[] delegate(char[] buf, const(char)[] fmt,...) dg);

    final Arguments errors(const(char)[][] errors)
{
if (errors.length is errmsg.length)
msgs = errors;
else
assert(false);
return this;
}

    final Arguments help(scope void delegate(const(char)[] arg, const(char)[] help) dg);

    private bool argument(const(char)[] s, const(char)[] p, bool sloppy, bool flag)
{
if (s.length >= p.length && s[0..p.length] == p)
{
s = s[p.length..$];
auto i = locate(s,eq);
if (i < s.length)
enable(s[0..i],sloppy,flag).append(s[i + 1..$],true);
else
if (s.length)
enable(s,sloppy,flag);
else
get(null).append(p,true);
return true;
}
return false;
}

    private Argument enable(const(char)[] elem, bool sloppy, bool flag = false)
{
if (flag && elem.length > 1)
{
auto arg = enable(elem[0..1],sloppy);
elem = elem[1..$];
if (arg.error is arg.None)
{
if (arg.cat)
arg.append(elem,true);
else
arg = enable(elem,sloppy,true);
}
return arg;
}
auto a = elem in args;
if (a is null)
if ((a = elem in aliases) is null)
return get(elem).params().enable(!sloppy);
return a.enable();
}

    class Argument
{
    enum 
{
None,
ParamLo,
ParamHi,
Required,
Requires,
Conflict,
Extra,
Option,
Invalid,
}
    alias void delegate() Invoker;
    alias const(char)[] delegate(const(char)[] value) Inspector;
    public 
{
    int min;
    int max;
    int error;
}
    public bool set;

    public char[] aliases;

    private 
{
    bool req;
    bool cat;
    bool exp;
    bool fail;
}
    public 
{
    const(char)[] name;
    const(char)[] text;
}
    private const(char)[] bogus;

    private 
{
    const(char)[][] values;
    const(char)[][] options;
    const(char)[][] deefalts;
}
    private Invoker invoker;

    private Inspector inspector;

    private 
{
    Argument[] dependees;
    Argument[] conflictees;
}
    this(const(char)[] name)
{
this.name = name;
}
    override immutable(char)[] toString()
{
return name.idup;
}

    final const(char)[][] assigned()
{
return values.length ? values : deefalts;
}

    final Argument aliased(char name)
{
this.outer.aliases[(&name)[0..1].idup] = this;
this.aliases ~= name;
return this;
}

    final @property Argument required()
{
this.req = true;
return this;
}

    final Argument requires(Argument arg)
{
dependees ~= arg;
return this;
}

    final Argument requires(const(char)[] other)
{
return requires(this.outer.get(other));
}

    final Argument requires(char other)
{
return requires((&other)[0..1]);
}

    final Argument conflicts(Argument arg)
{
conflictees ~= arg;
return this;
}

    final Argument conflicts(const(char)[] other)
{
return conflicts(this.outer.get(other));
}

    final Argument conflicts(char other)
{
return conflicts((&other)[0..1]);
}

    final Argument params()
{
return params(0,42);
}

    final Argument params(int count)
{
return params(count,count);
}

    final Argument params(int min, int max)
{
this.min = min;
this.max = max;
return this;
}

    final Argument defaults(const(char)[] values)
{
this.deefalts ~= values;
return this;
}

    final Argument bind(Inspector inspector)
{
this.inspector = inspector;
return this;
}

    final Argument bind(Invoker invoker)
{
this.invoker = invoker;
return this;
}

    final Argument smush(bool yes = true)
{
cat = yes;
return this;
}

    final @property Argument explicit()
{
exp = true;
return this;
}

    final Argument title(const(char)[] name)
{
this.name = name;
return this;
}

    final Argument help(const(char)[] text)
{
this.text = text;
return this;
}

    final Argument halt()
{
this.fail = true;
return this;
}

    final Argument restrict(const(char)[][] options...)
{
this.options = options;
return this;
}

    private Argument enable(bool unexpected = false)
{
this.set = true;
if (max > 0)
this.outer.stack.push(this);
if (invoker)
invoker();
if (unexpected)
error = Extra;
return this;
}

    private void append(const(char)[] value, bool explicit = false);

    private int valid();

}
}
debug (UnitTest)
{
    }
debug (Arguments)
{
    import tango.io.Stdout;
    void main();
}
