// D import file generated from 'tango/text/Regex.d'
module tango.text.Regex;
debug (TangoRegex)
{
    import tango.io.Stdout;
}
private template Pair(T)
{
struct Pair
{
    static Pair opCall(T a, T b)
{
Pair p;
p.a = a;
p.b = b;
return p;
}

    union
{
struct
{
T first;
T second;
}
struct
{
T a;
T b;
}
}
}
}

private template List(T)
{
class List
{
    class Element
{
    T value;
    Element prev;
    Element next;
    this(T v)
{
value = v;
}
}
    size_t len;
    Element head;
    Element tail;
    List opCatAssign(T v)
{
if (tail is null)
head = (tail = new Element(v));
else
{
tail.next = new Element(v);
tail.next.prev = tail;
tail = tail.next;
}
++len;
return this;
}
    List insertAfter(T w, T v)
{
foreach (e; &this.elements)
{
if (e.value is w)
return insertAfter(e,v);
}
return null;
}
    List insertAfter(Element e, T v)
{
auto tmp = new Element(v);
tmp.prev = e;
tmp.next = e.next;
e.next.prev = tmp;
e.next = tmp;
if (e is tail)
tail = tmp;
++len;
return this;
}
    List opCatAssign(List l)
{
if (l.empty())
return this;
if (tail is null)
{
head = l.head;
tail = l.tail;
}
else
{
tail.next = l.head;
tail.next.prev = tail;
tail = l.tail;
}
len += l.len;
return this;
}
    List pushFront(T v)
{
if (head is null)
head = (tail = new Element(v));
else
{
head.prev = new Element(v);
head.prev.next = head;
head = head.prev;
}
++len;
return this;
}
    List insertBefore(T w, T v)
{
foreach (e; &this.elements)
{
if (e.value is w)
return insertBefore(e,v);
}
return null;
}
    List insertBefore(Element e, T v)
{
auto tmp = new Element(v);
tmp.prev = e.prev;
tmp.next = e;
e.prev.next = tmp;
e.prev = tmp;
if (e is head)
head = tmp;
++len;
return this;
}
    List pushFront(List l)
{
if (l.empty())
return this;
if (head is null)
{
head = l.head;
tail = l.tail;
}
else
{
head.prev = l.tail;
head.prev.next = head;
head = l.head;
}
len += l.len;
return this;
}
    size_t length()
{
return len;
}
    bool empty()
{
return head is null;
}
    void clear()
{
head = null;
tail = null;
len = 0;
}
    void pop()
{
remove(tail);
}
    void remove(Element e)
{
if (e is null)
return ;
if (e.prev is null)
head = e.next;
else
e.prev.next = e.next;
if (e.next is null)
tail = e.prev;
else
e.next.prev = e.prev;
--len;
}
    int elements(int delegate(ref Element) dg)
{
{
for (Element e = head;
 e !is null; e = e.next)
{
{
int ret = dg(e);
if (ret)
return ret;
}
}
}
return 0;
}
    int elements_reverse(int delegate(ref Element) dg)
{
{
for (Element e = tail;
 e !is null; e = e.prev)
{
{
int ret = dg(e);
if (ret)
return ret;
}
}
}
return 0;
}
    int opApply(int delegate(ref T) dg)
{
{
for (Element e = head;
 e !is null; e = e.next)
{
{
int ret = dg(e.value);
if (ret)
return ret;
}
}
}
return 0;
}
    int opApplyReverse(int delegate(ref T) dg)
{
{
for (Element e = tail;
 e !is null; e = e.prev)
{
{
int ret = dg(e.value);
if (ret)
return ret;
}
}
}
return 0;
}
}
}

private template Stack(T)
{
struct Stack
{
    size_t _top;
    T[] stack;
    void push(T v)
{
if (_top >= stack.length)
stack.length = stack.length * 2 + 1;
stack[_top] = v;
++_top;
}
    alias push opCatAssign;
    void opCatAssign(T[] vs)
{
size_t end = _top + vs.length;
if (end > stack.length)
stack.length = end * 2;
stack[_top..end] = vs;
_top = end;
}
    void pop(size_t num)
{
assert(_top >= num);
_top -= num;
}
    T pop()
{
assert(_top > 0);
return stack[--_top];
}
    T top()
{
assert(_top > 0);
return stack[_top - 1];
}
    T* topPtr()
{
assert(_top > 0);
return &stack[_top - 1];
}
    bool empty()
{
return _top == 0;
}
    void clear()
{
_top = 0;
}
    size_t length()
{
return _top;
}
    T[] array()
{
return stack[0.._top];
}
    T opIndex(size_t i)
{
return stack[i];
}
    Stack dup()
{
Stack s;
s._top = _top;
s.stack = stack.dup;
return s;
}
}
}

private template Set(T)
{
struct Set
{
    bool[T] data;
    static Set opCall()
{
Set s;
return s;
}

    static Set opCall(T v)
{
Set s;
s ~= v;
return s;
}

    void opAddAssign(T v)
{
data[v] = true;
}
    void opAddAssign(Set s)
{
foreach (v; s.elements)
{
data[v] = true;
}
}
    alias opAddAssign opCatAssign;
    size_t length()
{
return data.length;
}
    T[] elements()
{
return data.keys;
}
    bool remove(T v)
{
if ((v in data) is null)
return false;
data.remove(v);
return true;
}
    bool contains(T v)
{
return (v in data) !is null;
}
    bool contains(Set s)
{
Set tmp = s - this;
return tmp.empty;
}
    bool empty()
{
return data.length == 0;
}
    Set opSub(Set s)
{
Set res = dup;
foreach (v; s.elements)
{
res.remove(v);
}
return res;
}
    Set dup()
{
Set s;
foreach (v; data.keys)
{
s.data[v] = true;
}
return s;
}
}
}

template quickSort(T)
{
void quickSort(T[] a)
{
quickSort(a,cast(size_t)0,a.length);
}
}
template quickSort(T)
{
void quickSort(T[] a, size_t l, size_t r)
{
T t;
auto i = r - l;
if (i < 3)
{
if (i < 2)
return ;
if (a[l] < a[l + 1])
return ;
t = a[l];
a[l] = a[l + 1];
a[l + 1] = t;
return ;
}
auto p = a[l];
i = l;
auto j = r;
while (true)
{
++i;
for (; i < j && a[i] < p; ++i)
{
{
}
}
--j;
for (; i < j && a[j] >= p; --j)
{
{
}
}
if (i >= j)
break;
t = a[i];
a[i] = a[j];
a[j] = t;
}
--i;
a[l] = a[i];
a[i] = p;
quickSort(a,l,i);
quickSort(a,i + 1,r);
}
}
import tango.math.Math;
template CharRange(char_t)
{
struct CharRange
{
    char_t l_;
    char_t r_;
    static CharRange opCall(char_t c)
{
CharRange cr;
cr.l_ = c;
cr.r_ = c;
return cr;
}

    static CharRange opCall(char_t a, char_t b)
{
CharRange cr;
cr.l_ = min(a,b);
cr.r_ = max(a,b);
return cr;
}

    char_t l()
{
return l_;
}
    char_t r()
{
return r_;
}
    int opCmp(CharRange cr)
{
if (l_ == cr.l_)
return 0;
if (l_ < cr.l_)
return -1;
return 1;
}
    const bool opEquals(ref const CharRange cr)
{
if (l_ == cr.l_ && r_ == cr.r_)
return true;
return false;
}

    bool contains(char_t c)
{
return c >= l_ && c <= r_;
}
    bool contains(CharRange cr)
{
return l_ <= cr.l_ && r_ >= cr.r_;
}
    bool intersects(CharRange cr)
{
return r_ >= cr.l_ && l_ <= cr.r_;
}
    CharRange intersect(CharRange cr)
{
assert(intersects(cr));
CharRange ir;
ir.l_ = max(l_,cr.l_);
ir.r_ = min(r_,cr.r_);
if (ir.l_ > ir.r_)
ir.l_ = (ir.r_ = char_t.min);
return ir;
}
    CharRange[] subtract(CharRange cr)
{
CharRange[] sr;
if (cr.contains(this))
return sr;
if (!intersects(cr))
sr ~= this;
else
{
CharRange d;
if (contains(cr))
{
d.l_ = l_;
d.r_ = cast(char_t)(cr.l_ - 1);
if (d.l_ <= d.r_)
sr ~= d;
d.l_ = cast(char_t)(cr.r_ + 1);
d.r_ = r_;
if (d.l_ <= d.r_)
sr ~= d;
}
else
if (cr.r_ > l_)
{
d.l_ = cast(char_t)(cr.r_ + 1);
d.r_ = r_;
if (d.l_ <= d.r_)
sr ~= d;
}
else
if (cr.l_ < r_)
{
d.l_ = l_;
d.r_ = cast(char_t)(cr.l_ - 1);
if (d.l_ <= d.r_)
sr ~= d;
}
}
return sr;
}
    string toString()
{
string str;
if (l_ == r_)
{
if (l_ > 32 && l_ < 127)
str = Format.convert("'{}'",l_).idup;
else
str = Format.convert("({:x})",cast(int)l_).idup;
}
else
{
if (l_ > 32 && l_ < 127)
str = Format.convert("'{}'",l_).idup;
else
str = Format.convert("({:x})",cast(int)l_).idup;
str ~= "-";
if (r_ > 32 && r_ < 127)
str ~= Format.convert("'{}'",r_).idup;
else
str ~= Format.convert("({:x})",cast(int)r_).idup;
}
return str;
}
}
}
template CharClass(char_t)
{
struct CharClass
{
    alias CharRange!(char_t) range_t;
    static const 
{
    CharClass!(char_t) line_startend = {parts:[{l_:0,r_:0},{l_:10,r_:10},{l_:19,r_:19}]};
    CharClass!(char_t) digit = {parts:[{l_:48,r_:57}]};
    CharClass!(char_t) whitespace = {parts:[{l_:9,r_:9},{l_:10,r_:10},{l_:11,r_:11},{l_:19,r_:19},{l_:20,r_:20},{l_:32,r_:32}]};
}
    static if(is(char_t == char))
{
    static const 
{
    CharClass!(char_t) any_char = {parts:[{l_:1,r_:255}]};
    CharClass!(char_t) dot_oper = {parts:[{l_:1,r_:255}]};
    CharClass!(char_t) alphanum_ = {parts:[{l_:48,r_:57},{l_:65,r_:90},{l_:95,r_:95},{l_:97,r_:122}]};
}
}
    static if(is(char_t == wchar) || is(char_t == dchar))
{
    static const 
{
    CharClass!(char_t) any_char = {parts:[{l_:1,r_:65535}]};
    CharClass!(char_t) dot_oper = {parts:[{l_:1,r_:65535}]};
    CharClass!(char_t) alphanum_ = {parts:[{l_:48,r_:57},{l_:65,r_:90},{l_:95,r_:95},{l_:97,r_:122}]};
}
}
    range_t[] parts;
        static CharClass opCall(const(CharClass) cc)
{
CharClass ncc;
ncc.parts = cc.parts.dup;
return ncc;
}

    const int opCmp(in CharClass cc)
{
if (parts.length < cc.parts.length)
return -1;
if (parts.length > cc.parts.length)
return 1;
foreach (i, p; cc.parts)
{
if (p.l_ != parts[i].l_ || p.r_ != parts[i].r_)
return 1;
}
return 0;
}

    bool empty()
{
return parts.length <= 0;
}
    bool matches(char_t c)
{
foreach (p; parts)
{
if (p.contains(c))
return true;
}
return false;
}
    CharClass intersect(CharClass cc)
{
CharClass ic;
foreach (p; parts)
{
foreach (cp; cc.parts)
{
if (p.intersects(cp))
ic.parts ~= p.intersect(cp);
}
}
return ic;
}
    bool contains(range_t cr)
{
foreach (p; parts)
{
if (p.contains(cr))
return true;
}
return false;
}
    bool contains(CharClass cc)
{
Louter:
foreach (p; cc.parts)
{
foreach (p2; parts)
{
if (p2.contains(p))
continue Louter;
}
return false;
}
return true;
}
    void subtract(CharClass cc)
{
negate();
add(cc);
negate();
}
    void add(CharClass cc)
{
parts ~= cc.parts;
}
    void add(range_t cr)
{
parts ~= cr;
}
    void add(char_t c)
{
parts ~= CharRange!(char_t)(c);
}
    void negate()
{
optimize();
char_t start = char_t.min;
if (parts.length > 0 && parts[0].l_ == start)
{
start = parts[0].r_;
if (start < char_t.max)
++start;
foreach (i, ref cr; parts[0..$ - 1])
{
cr.l_ = start;
cr.r_ = cast(char_t)(parts[i + 1].l_ - 1);
start = parts[i + 1].r_;
if (start < char_t.max)
++start;
}
if (start != char_t.max)
{
parts[$ - 1].l_ = start;
parts[$ - 1].r_ = char_t.max;
}
else
parts.length = parts.length - 1;
return ;
}
foreach (i, ref cr; parts)
{
char_t tmp = cast(char_t)(cr.l_ - 1);
cr.l_ = start;
start = cr.r_;
if (start < char_t.max)
++start;
cr.r_ = tmp;
}
if (start != char_t.max)
parts ~= range_t(start,char_t.max);
}
    void optimize()
{
if (empty())
return ;
parts.sort;
size_t i = 0;
foreach (p; parts[1..$])
{
if (p.l_ > parts[i].r_ + 1)
{
++i;
parts[i].l_ = p.l_;
parts[i].r_ = p.r_;
continue;
}
parts[i].r_ = max(p.r_,parts[i].r_);
if (parts[i].r_ >= char_t.max)
break;
}
parts.length = i + 1;
}
    string toString()
{
string str;
str ~= "[";
foreach (p; parts)
{
str ~= p.toString();
}
str ~= "]";
return str;
}
}
}
debug (UnitTest)
{
    }
private template Predicate(char_t)
{
struct Predicate
{
    alias const(char_t)[] string_t;
    alias CharClass!(char_t) cc_t;
    alias CharRange!(char_t) cr_t;
    enum Type 
{
consume,
epsilon,
lookahead,
lookbehind,
}
    cc_t input;
    Type type;
    const 
{
    uint MAX_BITMAP_LENGTH = 256;
    uint MAX_SEARCH_LENGTH = 256;
}
    enum MatchMode 
{
generic,
generic_l,
single_char,
bitmap,
string_search,
single_char_l,
bitmap_l,
string_search_l,
}
    MatchMode mode;
    union
{
ubyte[] data_bmp;
string_t data_str;
}
    char_t data_chr;
    void compile()
{
assert(input.parts.length > 0);
if (input.parts.length == 1 && input.parts[0].l_ == input.parts[0].r_)
{
mode = type == Type.consume ? MatchMode.single_char : MatchMode.single_char_l;
data_chr = input.parts[0].l_;
return ;
}
foreach (p; input.parts)
{
if (p.l_ > MAX_BITMAP_LENGTH || p.r_ > MAX_BITMAP_LENGTH)
goto LnoBitmap;
}
data_bmp.length = MAX_BITMAP_LENGTH / 8;
foreach (p; input.parts)
{
{
for (char_t c = p.l_;
 c <= p.r_; ++c)
{
data_bmp[c / 8] |= 1 << (c & 7);
}
}
}
mode = type == Type.consume ? MatchMode.bitmap : MatchMode.bitmap_l;
return ;
LnoBitmap:
Lgeneric:
data_str = cast(char_t[])input.parts;
mode = type == Type.consume ? MatchMode.generic : MatchMode.generic_l;
}
    bool matches(char_t c)
{
if (type == Type.consume || type == Type.lookahead)
return input.matches(c);
assert(0);
}
    Predicate intersect(Predicate p)
{
Predicate p2;
if (type != Type.epsilon && p.type != Type.epsilon)
p2.input = input.intersect(p.input);
return p2;
}
    bool intersects(Predicate p)
{
if (type != p.type)
return false;
foreach (cr; input.parts)
{
foreach (cr2; p.input.parts)
{
if (cr.intersects(cr2))
return true;
}
}
return false;
}
    bool exceedsMax(uint maxc)
{
foreach (p; input.parts)
{
if (p.l_ > maxc || p.r_ > maxc)
return true;
}
return false;
}
    @property bool empty()
{
return type != Type.epsilon && input.empty();
}

    void subtract(Predicate p)
{
if (type != Type.epsilon && p.type != Type.epsilon)
input.subtract(p.input);
}
    void negate()
{
assert(type != Type.epsilon);
input.negate();
}
    void optimize()
{
assert(type != Type.epsilon);
input.optimize();
}
    int opCmp(const(Predicate) p)
{
return input.opCmp(p.input);
}
    const bool opEquals(ref const Predicate p)
{
if (type != p.type)
return false;
if (input.opCmp(p.input) != 0)
return false;
return true;
}

    cc_t getInput()
{
return input;
}
    void setInput(const(cc_t) cc)
{
input = cast(cc_t)cc;
}
    void appendInput(cr_t cr)
{
input.add(cr);
}
    void appendInput(cc_t cc)
{
input.add(cc);
}
    void appendInput(Predicate p)
{
input.add(p.input);
}
    string toString()
{
string str;
switch (type)
{
case Type.consume:
{
str = input.toString();
break;
}
case Type.epsilon:
{
str = "eps";
break;
}
case Type.lookahead:
{
str = "la:" ~ input.toString();
break;
}
case Type.lookbehind:
{
str = "lb:" ~ input.toString();
break;
}
default:
{
assert(0);
}
}
return str;
}
}
}

import Utf = tango.text.convert.Utf;
import tango.text.convert.Format;
class RegExpException : Exception
{
    this(string msg)
{
super("RegExp: " ~ msg);
}
}
private template TNFAState(char_t)
{
class TNFAState
{
    bool accept = false;
    bool visited = false;
    size_t index;
    List!(TNFATransition!(char_t)) transitions;
    this()
{
transitions = new List!(TNFATransition!(char_t));
}
}
}

private enum PriorityClass 
{
greedy = 0,
normal = 1,
reluctant = 2,
extraReluctant = 3,
}

private template TNFATransition(char_t)
{
class TNFATransition
{
    TNFAState!(char_t) target;
    Predicate!(char_t) predicate;
    uint priority;
    uint tag;
    PriorityClass priorityClass;
    this(PriorityClass pc)
{
priorityClass = pc;
}
    bool canFinish()
{
TNFAState!(char_t) t = target;
while (!t.accept)
{
TNFATransition!(char_t) highestPriTrans;
foreach (trans; t.transitions)
{
if (!highestPriTrans || highestPriTrans.priority > trans.priority)
highestPriTrans = trans;
}
if (!(highestPriTrans.predicate.type == Predicate!(char_t).Type.epsilon))
return false;
t = highestPriTrans.target;
}
return true;
}
}
}

private template TNFAFragment(char_t)
{
class TNFAFragment
{
    alias TNFAState!(char_t) state_t;
    alias TNFATransition!(char_t) trans_t;
    List!(trans_t) entries;
    List!(trans_t) exits;
    List!(trans_t) entry_state;
    List!(trans_t) exit_state;
    bool swapMatchingBracketSyntax;
    this()
{
entries = new List!(trans_t);
exits = new List!(trans_t);
entry_state = new List!(trans_t);
exit_state = new List!(trans_t);
}
    void setEntry(state_t state)
{
state.transitions ~= entries;
foreach (t; entry_state)
{
t.target = state;
}
}
    void setExit(state_t state)
{
state.transitions ~= exits;
foreach (t; exit_state)
{
t.target = state;
}
}
}
}

private final template TNFA(char_t)
{
class TNFA
{
    alias TNFATransition!(char_t) trans_t;
    alias TNFAFragment!(char_t) frag_t;
    alias TNFAState!(char_t) state_t;
    alias Predicate!(char_t) predicate_t;
    alias char_t[] string_t;
    alias CharRange!(char_t) range_t;
    alias CharClass!(char_t) cc_t;
    string_t pattern;
    state_t[] states;
    state_t start;
    bool swapMatchingBracketSyntax;
    this(string_t regex)
{
next_tag = 1;
transitions = new List!(trans_t);
pattern = regex;
}
    debug (TangoRegex)
{
    void print()
{
foreach (int i, s; states)
{
Stdout.format("{}{:d2}{}",s is start ? ">" : " ",i,s.accept ? "*" : " ");
bool first = true;
Stdout(" {");
foreach (t; s.transitions)
{
Stdout.format("{}{}{}:{}->{}",first ? "" : ", ",t.priority,"gnrx"[t.priorityClass],t.predicate.toString,t.target is null ? -1 : t.target.index);
if (t.tag > 0)
{
Stdout.format(" t{}",t.tag);
}
first = false;
}
Stdout("}").newline;
}
}
}
    uint tagCount()
{
return next_tag - 1;
}
    void parse(bool unanchored)
{
List!(frag_t) frags = new List!(frag_t);
Stack!(Operator) opStack;
Stack!(uint) tagStack;
Stack!(Pair!(uint)) occurStack;
opStack ~= Operator.eos;
bool perform(Operator next_op, bool explicit_operator = true)
{
int index = cast(int)opStack.top() * (Operator.max + 1);
index += cast(int)next_op;
debug (tnfa)
{
Stdout.formatln("\x09{}:{} -> {}  {} frag(s)",operator_names[opStack.top],operator_names[next_op],action_names[action_lookup[index]],frags.length);
}

switch (action_lookup[index])
{
case Act.pua:
{
opStack ~= next_op;
if (next_op == Operator.open_par)
{
tagStack ~= next_tag;
next_tag += 2;
}
break;
}
case Act.poc:
{
switch (opStack.top())
{
case Operator.concat:
{
constructConcat(frags);
break;
}
case Operator.altern:
{
constructAltern(frags);
break;
}
case Operator.zero_one_g:
{
constructZeroOne(frags,PriorityClass.greedy);
break;
}
case Operator.zero_one_ng:
{
constructZeroOne(frags,PriorityClass.reluctant);
break;
}
case Operator.zero_one_xr:
{
constructZeroOne(frags,PriorityClass.extraReluctant);
break;
}
case Operator.zero_more_g:
{
constructZeroMore(frags,PriorityClass.greedy);
break;
}
case Operator.zero_more_ng:
{
constructZeroMore(frags,PriorityClass.reluctant);
break;
}
case Operator.zero_more_xr:
{
constructZeroMore(frags,PriorityClass.extraReluctant);
break;
}
case Operator.one_more_g:
{
constructOneMore(frags,PriorityClass.greedy);
break;
}
case Operator.one_more_ng:
{
constructOneMore(frags,PriorityClass.reluctant);
break;
}
case Operator.one_more_xr:
{
constructOneMore(frags,PriorityClass.extraReluctant);
break;
}
case Operator.occur_g:
{
Pair!(uint) occur = occurStack.pop();
constructOccur(frags,occur.a,occur.b,PriorityClass.greedy);
break;
}
case Operator.occur_ng:
{
Pair!(uint) occur = occurStack.pop();
constructOccur(frags,occur.a,occur.b,PriorityClass.reluctant);
break;
}
default:
{
throw new RegExpException("cannot process operand at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
}
}
opStack.pop();
perform(next_op,false);
break;
}
case Act.poa:
{
opStack.pop();
break;
}
case Act.pca:
{
if (opStack.top() == Operator.open_par)
{
if (tagStack.empty())
throw new RegExpException(Format.convert("Missing opening parentheses for closing parentheses at char {} \"{}\"",cursor,Utf.toString(pattern[cursor..$])).idup);
constructBracket(frags,tagStack.top());
tagStack.pop();
}
else
{
assert(opStack.top() == Operator.open_par_nm);
constructBracket(frags);
}
opStack.pop();
break;
}
case Act.don:
{
return true;
}
case Act.err:
{
}
default:
{
throw new RegExpException(Format.convert("Unexpected operand at char {} \"{}\" in \"{}\"",cursor,Utf.toString(pattern[cursor..$]),Utf.toString(pattern)).idup);
}
}
return false;
}
if (unanchored)
{
frags ~= constructChars(cc_t.any_char,predicate_t.Type.consume);
perform(Operator.zero_more_xr,false);
perform(Operator.concat,false);
perform(Operator.open_par,false);
}
bool implicit_concat;
predicate_t.Type pred_type;
while (!endOfPattern())
{
pred_type = predicate_t.Type.consume;
dchar c = readPattern();
switch (c)
{
case '|':
{
perform(Operator.altern);
implicit_concat = false;
break;
}
case '(':
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = false;
if (peekPattern() == '?')
{
readPattern();
perform(swapMatchingBracketSyntax ? Operator.open_par : Operator.open_par_nm);
}
else
perform(swapMatchingBracketSyntax ? Operator.open_par_nm : Operator.open_par);
break;
}
case ')':
{
perform(Operator.close_par);
break;
}
case '?':
{
if (peekPattern() == '?')
{
readPattern();
perform(Operator.zero_one_ng);
}
else
perform(Operator.zero_one_g);
break;
}
case '*':
{
if (peekPattern() == '?')
{
readPattern();
perform(Operator.zero_more_ng);
}
else
perform(Operator.zero_more_g);
break;
}
case '+':
{
if (peekPattern() == '?')
{
readPattern();
perform(Operator.one_more_ng);
}
else
perform(Operator.one_more_g);
break;
}
case '{':
{
Pair!(uint) occur;
parseOccurCount(occur.a,occur.b);
occurStack ~= occur;
if (peekPattern() == '?')
{
readPattern();
perform(Operator.occur_ng);
}
else
perform(Operator.occur_g);
break;
}
case '[':
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
frags ~= constructCharClass(pred_type);
break;
}
case '.':
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
frags ~= constructChars(cc_t.dot_oper,pred_type);
break;
}
case '$':
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
frags ~= constructChars(cc_t.line_startend,predicate_t.Type.lookahead);
break;
}
case '^':
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
frags ~= constructChars(cc_t.line_startend,predicate_t.Type.lookbehind);
break;
}
case '>':
{
c = readPattern();
pred_type = predicate_t.Type.lookahead;
if (c == '[')
goto case '[';
else
if (c == '\x5c')
goto case '\x5c';
else
if (c == '.')
goto case '.';
else
goto default;
}
case '<':
{
c = readPattern();
pred_type = predicate_t.Type.lookbehind;
if (c == '[')
goto case '[';
else
if (c == '\x5c')
goto case '\x5c';
else
if (c == '.')
goto case '.';
else
goto default;
}
case '\x5c':
{
c = readPattern();
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
switch (c)
{
case 't':
{
frags ~= constructSingleChar('\x09',pred_type);
break;
}
case 'n':
{
frags ~= constructSingleChar('\x0a',pred_type);
break;
}
case 'r':
{
frags ~= constructSingleChar('\x0d',pred_type);
break;
}
case 'w':
{
frags ~= constructChars(cc_t.alphanum_,pred_type);
break;
}
case 'W':
{
auto cc = cc_t(cc_t.alphanum_);
cc.negate();
frags ~= constructChars(cc,pred_type);
break;
}
case 's':
{
frags ~= constructChars(cc_t.whitespace,pred_type);
break;
}
case 'S':
{
auto cc = cc_t(cc_t.whitespace);
cc.negate();
frags ~= constructChars(cc,pred_type);
break;
}
case 'd':
{
frags ~= constructChars(cc_t.digit,pred_type);
break;
}
case 'D':
{
auto cc = cc_t(cc_t.digit);
cc.negate();
frags ~= constructChars(cc,pred_type);
break;
}
case 'b':
{
if (pred_type != predicate_t.Type.consume)
throw new RegExpException("Escape sequence \\b not allowed in look-ahead or -behind");
auto cc = cc_t(cc_t.whitespace);
cc.negate();
perform(Operator.open_par_nm);
frags ~= constructChars(cc,predicate_t.Type.lookbehind);
perform(Operator.concat,false);
frags ~= constructChars(cc_t.whitespace,predicate_t.Type.lookahead);
perform(Operator.altern,false);
frags ~= constructChars(cc_t.whitespace,predicate_t.Type.lookbehind);
perform(Operator.concat,false);
frags ~= constructChars(cc,predicate_t.Type.lookahead);
perform(Operator.close_par,false);
break;
}
case 'B':
{
if (pred_type != predicate_t.Type.consume)
throw new RegExpException("Escape sequence \\B not allowed in look-ahead or -behind");
auto cc = cc_t(cc_t.whitespace);
cc.negate();
perform(Operator.open_par_nm);
frags ~= constructChars(cc,predicate_t.Type.lookbehind);
perform(Operator.concat,false);
frags ~= constructChars(cc,predicate_t.Type.lookahead);
perform(Operator.altern,false);
frags ~= constructChars(cc_t.whitespace,predicate_t.Type.lookbehind);
perform(Operator.concat,false);
frags ~= constructChars(cc_t.whitespace,predicate_t.Type.lookahead);
perform(Operator.close_par,false);
break;
}
case '(':
{
}
case ')':
{
}
case '[':
{
}
case ']':
{
}
case '{':
{
}
case '}':
{
}
case '*':
{
}
case '+':
{
}
case '?':
{
}
case '.':
{
}
case '\x5c':
{
}
case '^':
{
}
case '$':
{
}
case '|':
{
}
case '<':
{
}
case '>':
{
}
default:
{
frags ~= constructSingleChar(c,pred_type);
break;
}
}
break;
}
default:
{
if (implicit_concat)
perform(Operator.concat,false);
implicit_concat = true;
frags ~= constructSingleChar(c,pred_type);
}
}
}
if (unanchored)
{
perform(Operator.close_par,false);
if (implicit_concat)
perform(Operator.concat,false);
frags ~= constructChars(cc_t.any_char,predicate_t.Type.consume);
perform(Operator.zero_more_ng,false);
}
while (!perform(Operator.eos))
{
}
start = addState();
state_t finish = addState();
finish.accept = true;
foreach (f; frags)
{
f.setExit(finish);
f.setEntry(start);
}
List!(trans_t)[PriorityClass.max + 1] trans;
foreach (ref t; trans)
{
t = new List!(trans_t);
}
Stack!(trans_t) todo;
state_t state = start;
while (!todo.empty() || !state.visited)
{
if (!state.visited)
{
state.visited = true;
foreach_reverse (t; state.transitions)
{
todo ~= t;
}
}
if (todo.empty())
break;
trans_t t = todo.top();
todo.pop();
assert(t.priorityClass <= PriorityClass.max);
trans[t.priorityClass] ~= t;
state = t.target;
}
uint nextPrio;
foreach (ts; trans)
{
foreach (t; ts)
{
t.priority = nextPrio++;
}
}
}
    private 
{
    uint next_tag;
    size_t cursor;
    size_t next_cursor;
    List!(trans_t) transitions;
    state_t[state_t] clonedStates;
    trans_t[trans_t] clonedTransitions;
    enum Operator 
{
eos,
concat,
altern,
open_par,
close_par,
zero_one_g,
zero_more_g,
one_more_g,
zero_one_ng,
zero_more_ng,
one_more_ng,
zero_one_xr,
zero_more_xr,
one_more_xr,
open_par_nm,
occur_g,
occur_ng,
}
    const const(char)[][] operator_names = ["EOS","concat","|","(",")","?","*","+","??","*?","+?","??x","*?x","+?x","(?","{x,y}","{x,y}?"];

    enum Act 
{
pua,
poc,
poa,
pca,
don,
err,
}
    const const(char)[][] action_names = ["push+advance","pop+copy","pop+advance","pop+copy+advance","done","error"];

    const Act[] action_lookup = [Act.don,Act.pua,Act.pua,Act.pua,Act.err,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.poc,Act.pua,Act.poc,Act.pua,Act.poc,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.err,Act.pua,Act.pua,Act.pua,Act.pca,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.err,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.err,Act.pua,Act.pua,Act.pua,Act.pca,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.pua,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.poc,Act.pua,Act.poc,Act.poc];

    final dchar peekPattern()
{
auto tmp = next_cursor;
if (tmp < pattern.length)
return decode(pattern,tmp);
return 0;
}

    final dchar readPattern()
{
cursor = next_cursor;
if (next_cursor < pattern.length)
return decode(pattern,next_cursor);
return 0;
}

    final bool endOfPattern()
{
return next_cursor >= pattern.length;
}

    state_t addState()
{
state_t s = new state_t;
s.index = states.length;
states ~= s;
return s;
}
    trans_t addTransition(PriorityClass pc = PriorityClass.normal)
{
trans_t trans = new trans_t(pc);
transitions ~= trans;
return trans;
}
    uint parseNumber()
{
uint res;
while (!endOfPattern())
{
auto c = peekPattern();
if (c < '0' || c > '9')
break;
res = res * 10 + (c - '0');
readPattern();
}
return res;
}
    void parseOccurCount(out uint minOccur, out uint maxOccur)
{
assert(pattern[cursor] == '{');
minOccur = parseNumber();
if (peekPattern() == '}')
{
readPattern();
maxOccur = minOccur;
return ;
}
if (peekPattern() != ',')
throw new RegExpException("Invalid occurence range at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
readPattern();
maxOccur = parseNumber();
if (peekPattern() != '}')
throw new RegExpException("Invalid occurence range at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
readPattern();
if (maxOccur > 0 && maxOccur < minOccur)
throw new RegExpException("Invalid occurence range (max < min) at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
}
    trans_t clone(trans_t t)
{
if (t is null)
return null;
trans_t* tmp = t in clonedTransitions;
if (tmp !is null)
return *tmp;
trans_t t2 = new trans_t(t.priorityClass);
clonedTransitions[t] = t2;
t2.tag = t.tag;
t2.priority = t.priority;
t2.predicate = t.predicate;
t2.target = clone(t.target);
transitions ~= t2;
return t2;
}
    state_t clone(state_t s)
{
if (s is null)
return null;
state_t* tmp = s in clonedStates;
if (tmp !is null)
return *tmp;
state_t s2 = new state_t;
clonedStates[s] = s2;
s2.accept = s.accept;
s2.visited = s.visited;
foreach (t; s.transitions)
{
s2.transitions ~= clone(t);
}
s2.index = states.length;
states ~= s2;
return s2;
}
    frag_t clone(frag_t f)
{
if (f is null)
return null;
clonedStates = null;
clonedTransitions = null;
frag_t f2 = new frag_t;
foreach (t; f.entries)
{
f2.entries ~= clone(t);
}
foreach (t; f.exits)
{
f2.exits ~= clone(t);
}
foreach (t; f.entry_state)
{
f2.entry_state ~= clone(t);
}
foreach (t; f.exit_state)
{
f2.exit_state ~= clone(t);
}
return f2;
}
    frag_t constructSingleChar(char_t c, predicate_t.Type type)
{
debug (tnfa)
{
Stdout.formatln("constructCharFrag {}",c);
}

trans_t trans = addTransition();
trans.predicate.appendInput(CharRange!(char_t)(c));
trans.predicate.type = type;
frag_t frag = new frag_t;
frag.exit_state ~= trans;
frag.entries ~= trans;
return frag;
}
    frag_t constructChars(string_t chars, in predicate_t.Type type)
{
cc_t cc;
{
for (int i = 0;
 i < chars.length; ++i)
{
cc.add(chars[i]);
}
}
return constructChars(cc,type);
}
    frag_t constructChars(const(cc_t) charclass, in predicate_t.Type type)
{
debug (tnfa)
{
Stdout.format("constructChars type={}",type);
}

trans_t trans = addTransition();
trans.predicate.type = type;
trans.predicate.setInput(cc_t(charclass));
trans.predicate.optimize();
debug (tnfa)
{
Stdout.formatln("-> {}",trans.predicate.toString);
}

frag_t frag = new frag_t;
frag.exit_state ~= trans;
frag.entries ~= trans;
return frag;
}
    frag_t constructCharClass(predicate_t.Type type)
{
debug (tnfa)
{
Stdout.format("constructCharClass type={}",type);
}

auto oldCursor = cursor;
trans_t trans = addTransition();
bool negated = false;
if (peekPattern() == '^')
{
readPattern();
negated = true;
}
char_t last;
bool have_range_start,first_char = true;
for (; !endOfPattern() && peekPattern() != ']';)
{
{
dchar c = readPattern();
switch (c)
{
case '-':
{
if (first_char)
{
trans.predicate.appendInput(range_t(c));
break;
}
if (!have_range_start)
throw new RegExpException("Missing range start for '-' operator after \"" ~ Utf.toString(pattern).idup ~ "\"");
else
if (endOfPattern() || peekPattern() == ']')
throw new RegExpException("Missing range end for '-' operator after \"" ~ Utf.toString(pattern).idup ~ "\"");
else
{
c = readPattern();
trans.predicate.appendInput(range_t(last,c));
have_range_start = false;
}
break;
}
case '\x5c':
{
if (endOfPattern())
throw new RegExpException("unexpected end of string after \"" ~ Utf.toString(pattern).idup ~ "\"");
c = readPattern();
switch (c)
{
case 't':
{
c = '\x09';
break;
}
case 'n':
{
c = '\x0a';
break;
}
case 'r':
{
c = '\x0d';
break;
}
default:
{
break;
}
}
goto default;
}
default:
{
if (have_range_start)
trans.predicate.appendInput(range_t(last));
last = c;
have_range_start = true;
}
}
first_char = false;
}
}
if (!endOfPattern())
readPattern();
if (last != char_t.init)
trans.predicate.appendInput(range_t(last));
debug (tnfa)
{
Stdout.formatln(" {}",pattern[oldCursor..cursor]);
}

if (negated)
{
auto tmp = cc_t(cc_t.any_char);
tmp.subtract(trans.predicate.input);
trans.predicate.input = tmp;
}
else
trans.predicate.optimize();
debug (tnfa)
{
Stdout.formatln("-> {}",trans.predicate.toString);
}

trans.predicate.type = type;
frag_t frag = new frag_t;
frag.exit_state ~= trans;
frag.entries ~= trans;
return frag;
}
    void constructBracket(List!(frag_t) frags, uint tag = 0)
{
debug (tnfa)
{
Stdout.formatln("constructBracket");
}

state_t entry = addState(),exit = addState();
frags.tail.value.setEntry(entry);
frags.tail.value.setExit(exit);
trans_t tag1 = addTransition(),tag2 = addTransition();
tag1.predicate.type = predicate_t.Type.epsilon;
tag2.predicate.type = predicate_t.Type.epsilon;
if (tag > 0)
{
tag1.tag = tag++;
tag2.tag = tag;
}
tag1.target = entry;
exit.transitions ~= tag2;
frag_t frag = new frag_t;
frag.entries ~= tag1;
frag.exit_state ~= tag2;
frags.pop();
frags ~= frag;
}
    void constructOneMore(List!(frag_t) frags, PriorityClass prioClass)
{
debug (tnfa)
{
Stdout.formatln("constructOneMore");
}

if (frags.empty())
throw new RegExpException("too few arguments for + at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
trans_t repeat = addTransition(prioClass),cont = addTransition();
repeat.predicate.type = predicate_t.Type.epsilon;
cont.predicate.type = predicate_t.Type.epsilon;
state_t s = addState();
frags.tail.value.setExit(s);
s.transitions ~= repeat;
s.transitions ~= cont;
frag_t frag = new frag_t;
frag.entries ~= frags.tail.value.entries;
frag.entry_state ~= frags.tail.value.entry_state;
frag.entry_state ~= repeat;
frag.exit_state ~= cont;
frags.pop();
frags ~= frag;
}
    void constructZeroMore(List!(frag_t) frags, PriorityClass prioClass)
{
debug (tnfa)
{
Stdout.formatln("constructZeroMore");
}

if (frags.empty())
throw new RegExpException("too few arguments for * at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
trans_t enter = addTransition(prioClass),repeat = addTransition(prioClass),skip = addTransition();
skip.predicate.type = predicate_t.Type.epsilon;
repeat.predicate.type = predicate_t.Type.epsilon;
enter.predicate.type = predicate_t.Type.epsilon;
state_t entry = addState(),exit = addState();
frags.tail.value.setEntry(entry);
frags.tail.value.setExit(exit);
exit.transitions ~= repeat;
enter.target = entry;
frag_t frag = new frag_t;
frag.entries ~= skip;
frag.entries ~= enter;
frag.exit_state ~= skip;
frag.entry_state ~= repeat;
frags.pop();
frags ~= frag;
}
    void constructZeroOne(List!(frag_t) frags, PriorityClass prioClass)
{
debug (tnfa)
{
Stdout.formatln("constructZeroOne");
}

if (frags.empty())
throw new RegExpException("too few arguments for ? at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
trans_t use = addTransition(prioClass),skip = addTransition();
use.predicate.type = predicate_t.Type.epsilon;
skip.predicate.type = predicate_t.Type.epsilon;
state_t s = addState();
frags.tail.value.setEntry(s);
use.target = s;
frag_t frag = new frag_t;
frag.entries ~= use;
frag.entries ~= skip;
frag.exits ~= frags.tail.value.exits;
frag.exit_state ~= frags.tail.value.exit_state;
frag.exit_state ~= skip;
frags.pop();
frags ~= frag;
}
    void constructOccur(List!(frag_t) frags, uint minOccur, uint maxOccur, PriorityClass prioClass)
{
debug (tnfa)
{
Stdout.formatln("constructOccur {},{}",minOccur,maxOccur);
}

if (frags.empty())
throw new RegExpException("too few arguments for {x,y} at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
state_t s;
frag_t total = new frag_t,prev;
{
for (int i = 0;
 i < minOccur; ++i)
{
{
frag_t f = clone(frags.tail.value);
if (prev !is null)
{
s = addState();
prev.setExit(s);
f.setEntry(s);
}
else
{
total.entries = f.entries;
total.entry_state = f.entry_state;
}
prev = f;
}
}
}
if (maxOccur == 0)
{
frag_t f = frags.tail.value;
trans_t t = addTransition();
t.predicate.type = predicate_t.Type.epsilon;
f.entries ~= t;
f.exit_state ~= t;
t = addTransition();
t.predicate.type = predicate_t.Type.epsilon;
f.exits ~= t;
f.entry_state ~= t;
s = addState();
f.setEntry(s);
if (prev !is null)
prev.setExit(s);
else
{
total.entries = f.entries;
total.entry_state = f.entry_state;
}
prev = f;
}
{
for (int i = minOccur;
 i < maxOccur; ++i)
{
{
frag_t f;
if (i < maxOccur - 1)
f = clone(frags.tail.value);
else
f = frags.tail.value;
trans_t t = addTransition();
t.predicate.type = predicate_t.Type.epsilon;
f.entries ~= t;
f.exit_state ~= t;
if (prev !is null)
{
s = addState();
prev.setExit(s);
f.setEntry(s);
}
else
{
total.entries = f.entries;
total.entry_state = f.entry_state;
}
prev = f;
}
}
}
total.exits = prev.exits;
total.exit_state = prev.exit_state;
frags.pop();
frags ~= total;
}
    void constructAltern(List!(frag_t) frags)
{
debug (tnfa)
{
Stdout.formatln("constructAltern");
}

if (frags.empty() || frags.head is frags.tail)
throw new RegExpException("too few arguments for | at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
frag_t frag = new frag_t,f1 = frags.tail.value,f2 = frags.tail.prev.value;
frag.entry_state ~= f2.entry_state;
frag.entry_state ~= f1.entry_state;
frag.exit_state ~= f2.exit_state;
frag.exit_state ~= f1.exit_state;
frag.entries ~= f2.entries;
frag.entries ~= f1.entries;
frag.exits ~= f2.exits;
frag.exits ~= f1.exits;
frags.pop();
frags.pop();
frags ~= frag;
}
    void constructConcat(List!(frag_t) frags)
{
debug (tnfa)
{
Stdout.formatln("constructConcat");
}

if (frags.empty() || frags.head is frags.tail)
throw new RegExpException("too few operands for concatenation at \"" ~ Utf.toString(pattern[cursor..$]).idup ~ "\"");
frag_t f1 = frags.tail.value,f2 = frags.tail.prev.value;
state_t state = addState();
f2.setExit(state);
f1.setEntry(state);
frag_t frag = new frag_t;
frag.entries ~= f2.entries;
frag.exits ~= f1.exits;
frag.entry_state ~= f2.entry_state;
frag.exit_state ~= f1.exit_state;
frags.pop();
frags.pop();
frags ~= frag;
}
}
}
}


import tango.core.Array;
private template TDFA(char_t)
{
class TDFA
{
    alias Predicate!(char_t) predicate_t;
    alias CharRange!(char_t) range_t;
    alias CharClass!(char_t) charclass_t;
    alias char_t[] string_t;
    const uint CURRENT_POSITION_REGISTER = ~0;

    struct Command
{
    uint dst;
    uint src;
    string toString()
{
return Format.convert("{}<-{}",dst,src == CURRENT_POSITION_REGISTER ? "p" : Format.convert("{}",src)).idup;
}
    int opCmp(Command cmd)
{
if (src == CURRENT_POSITION_REGISTER && cmd.src != CURRENT_POSITION_REGISTER)
return 1;
if (src != CURRENT_POSITION_REGISTER && cmd.src == CURRENT_POSITION_REGISTER)
return -1;
if (dst < cmd.dst)
return -1;
if (dst == cmd.dst)
return 0;
return 1;
}
    const bool opEquals(ref const Command cmd)
{
if (dst != cmd.dst || src != cmd.src)
return false;
return true;
}

}
    struct TagIndex
{
    uint tag;
    uint index;
}
    class State
{
    enum Mode 
{
GENERIC,
MIXED,
LOOKUP,
}
    const 
{
    uint LOOKUP_LENGTH = 256;
    uint INVALID_STATE = 255;
}
    bool accept = false;
    bool reluctant = false;
    size_t index;
    Transition[] transitions;
    Transition[] generic_transitions;
    Command[] finishers;
    ubyte[] lookup;
    Mode mode;
    void optimize()
{
size_t[] remove_indeces;
foreach (i, t; transitions[0..$ - 1])
{
foreach (t2; transitions[i + 1..$])
{
if (t.predicate.type != t2.predicate.type || !t.equalTarget(t2))
continue;
t2.predicate.appendInput(t.predicate);
remove_indeces ~= i;
break;
}
}
if (remove_indeces.length > 0)
{
Transition[] tmp;
tmp.length = transitions.length - remove_indeces.length;
size_t next_remove,next;
foreach (i, t; transitions)
{
if (next_remove < remove_indeces.length && remove_indeces[next_remove] == i)
{
++next_remove;
continue;
}
tmp[next++] = t;
}
transitions = tmp;
foreach (t; transitions)
{
t.predicate.optimize();
}
}
}
    void createLookup()
{
size_t count;
foreach (t; transitions)
{
if (!t.predicate.exceedsMax(LOOKUP_LENGTH))
++count;
}
if (count < 1 || transitions.length > INVALID_STATE)
{
generic_transitions.length = transitions.length;
generic_transitions[] = transitions;
return ;
}
foreach (t; transitions)
{
if (t.predicate.exceedsMax(LOOKUP_LENGTH))
generic_transitions ~= t;
}
lookup.length = LOOKUP_LENGTH;
lookup[] = INVALID_STATE;
foreach (i, t; transitions)
{
foreach (p; t.predicate.input.parts)
{
if (p.l_ >= lookup.length)
continue;
{
for (char_t c = p.l_;
 c <= min(p.r_,LOOKUP_LENGTH - 1); ++c)
{
lookup[c] = cast(ubyte)i;
}
}
}
}
mode = count < transitions.length ? Mode.MIXED : Mode.LOOKUP;
}
}
    class Transition
{
    State target;
    predicate_t predicate;
    Command[] commands;
    final override int opCmp(Object o)
{
Transition t = cast(Transition)o;
assert(t !is null);
return predicate.opCmp(t.predicate);
}

    const final bool opEquals(const Object o)
{
auto t = cast(const(Transition))o;
if (t is null)
return false;
if (equalTarget(t) && t.predicate == predicate)
return true;
return false;
}

    const bool equalTarget(in Transition t)
{
if (t.target.index != target.index)
return false;
if (commands.length != t.commands.length)
return false;
Louter:
foreach (cmd; commands)
{
foreach (cmd2; t.commands)
{
if (cmd == cmd2)
continue Louter;
}
return false;
}
return true;
}

}
    State[] states;
    State start;
    Command[] initializer;
    uint num_tags;
    uint[TagIndex] registers;
    uint next_register;
    uint num_regs()
{
return next_register;
}
    this(TNFA!(char_t) tnfa)
{
num_tags = tnfa.tagCount();
next_register = num_tags;
{
for (int i = 1;
 i <= num_tags; ++i)
{
{
TagIndex ti;
ti.tag = i;
registers[ti] = i - 1;
}
}
}
SubsetState subset_start = new SubsetState;
StateElement se = new StateElement;
se.nfa_state = tnfa.start;
subset_start.elms ~= se;
predicate_t tmp_pred;
tmp_pred.setInput(CharClass!(char_t).line_startend);
subset_start = epsilonClosure(lookbehindClosure(epsilonClosure(subset_start,subset_start),tmp_pred),subset_start);
start = addState();
subset_start.dfa_state = start;
generateInitializers(subset_start);
generateFinishers(subset_start);
List!(SubsetState) subset_states = new List!(SubsetState),unmarked = new List!(SubsetState);
subset_states ~= subset_start;
unmarked ~= subset_start;
debug (tdfa)
{
Stdout.formatln("\x0a{} = {}\x0a",subset_start.dfa_state.index,subset_start.toString);
}

while (!unmarked.empty())
{
SubsetState state = unmarked.tail.value;
unmarked.pop();
foreach (pred; disjointPredicates(state))
{
debug (tdfa)
{
Stdout.format("from {} with {} reach",state.dfa_state.index,pred.toString);
}

SubsetState target = reach(state,pred);
if (target is null)
{
continue;
debug (tdfa)
{
Stdout.formatln(" nothing - lookbehind at beginning, skipping");
}

}
debug (tdfa)
{
Stdout.formatln(" {}",target.toString);
}

target = epsilonClosure(lookbehindClosure(epsilonClosure(target,state),pred),state);
Transition trans = new Transition;
state.dfa_state.transitions ~= trans;
debug (tdfa_new_trans)
{
Stdout.formatln("Creating with pred: {}",pred);
}

trans.predicate = pred;
uint[uint] cmds = null;
foreach (e; target.elms)
{
foreach (tag, ref index; e.tags)
{
bool found = false;
foreach (e2; state.elms)
{
int* i = tag in e2.tags;
if (i !is null && *i == index)
{
found = true;
break;
}
}
if (!found)
{
if (index < 0)
index = -index - 1;
cmds[tag] = index;
}
else
assert(index >= 0);
}
}
bool exists = false;
foreach (equivTarget; subset_states)
{
if (reorderTagIndeces(target,equivTarget,state,trans))
{
target = equivTarget;
exists = true;
break;
}
}
if (!exists)
{
State ts = addState();
target.dfa_state = ts;
subset_states ~= target;
unmarked ~= target;
debug (tdfa_add)
{
Stdout.formatln("\x0aAdded {} = {}\x0a",target.dfa_state.index,target.toString);
}

generateFinishers(target);
}
foreach (tag, index; cmds)
{
uint reg = registerFromTagIndex(tag,index);
bool found = false;
foreach (ref cmd; trans.commands)
{
if (cmd.src == reg)
{
found = true;
cmd.src = CURRENT_POSITION_REGISTER;
break;
}
}
if (!found)
{
Command cmd;
cmd.dst = reg;
cmd.src = CURRENT_POSITION_REGISTER;
trans.commands ~= cmd;
}
}
trans.target = target.dfa_state;
debug (tdfa)
{
Stdout.formatln("=> from {} with {} reach {}",state.dfa_state.index,pred.toString,target.dfa_state.index);
}

}
state.dfa_state.optimize();
}
uint[uint] regNums;
{
for (next_register = 0; next_register < num_tags; ++next_register)
{
regNums[next_register] = next_register;
}
}
void renumberCommand(ref Command cmd)
{
if (cmd.src != CURRENT_POSITION_REGISTER && (cmd.src in regNums) is null)
regNums[cmd.src] = next_register++;
if ((cmd.dst in regNums) is null)
regNums[cmd.dst] = next_register++;
if (cmd.src != CURRENT_POSITION_REGISTER)
cmd.src = regNums[cmd.src];
cmd.dst = regNums[cmd.dst];
}
foreach (state; states)
{
foreach (ref cmd; state.finishers)
{
renumberCommand(cmd);
}
state.finishers.sort;
foreach (trans; state.transitions)
{
foreach (ref cmd; trans.commands)
{
renumberCommand(cmd);
}
trans.commands.sort;
trans.predicate.compile();
}
}
debug (TangoRegex)
{
foreach (ref v; registers)
{
if ((v in regNums) !is null)
v = regNums[v];
}
}

minimizeDFA();
foreach (state; states)
{
state.createLookup();
}
}
    debug (TangoRegex)
{
    void print()
{
Stdout.formatln("#tags = {}",num_tags);
auto tis = new TagIndex[](registers.length);
foreach (k, v; registers)
{
tis[v] = k;
}
foreach (r, ti; tis)
{
Stdout.formatln("tag({},{}) in reg {}",ti.tag,ti.index,r);
}
Stdout.formatln("Initializer:");
foreach (cmd; initializer)
{
Stdout.formatln("{}",cmd.toString);
}
Stdout.formatln("Delta function:");
foreach (int i, s; states)
{
Stdout.format("{}{:d2}{}",s is start ? ">" : " ",i,s.accept ? "*" : " ");
bool first = true;
Stdout(" {");
foreach (t; s.transitions)
{
Stdout.format("{}{}->{} (",first ? "" : ", ",t.predicate.toString,t.target.index);
bool firstcmd = true;
foreach (cmd; t.commands)
{
if (firstcmd)
firstcmd = false;
else
Stdout(",");
Stdout.format("{}",cmd.toString);
}
Stdout(")");
first = false;
}
Stdout("} (");
bool firstcmd = true;
foreach (cmd; s.finishers)
{
if (firstcmd)
firstcmd = false;
else
Stdout(",");
Stdout.format("{}",cmd.toString);
}
Stdout.formatln(")");
}
}
}
    private 
{
    class StateElement
{
    TNFAState!(char_t) nfa_state;
    int[uint] tags;
    uint maxPriority;
    uint lastPriority;
    bool prioGreater(StateElement se)
{
if (maxPriority < se.maxPriority)
return true;
if (maxPriority == se.maxPriority)
{
assert(lastPriority != se.lastPriority);
return lastPriority < se.lastPriority;
}
return false;
}
    override int opCmp(Object o)
{
StateElement se = cast(StateElement)o;
assert(se !is null);
if (maxPriority < se.maxPriority)
return 1;
if (maxPriority == se.maxPriority)
{
if (lastPriority == se.lastPriority)
return 0;
return lastPriority < se.lastPriority;
}
return -1;
}

    override string toString()
{
const(char)[] str;
str = Format.convert("{} p{}.{} {{",nfa_state.index,maxPriority,lastPriority);
bool first = true;
foreach (k, v; tags)
{
str ~= Format.convert("{}m({},{})",first ? "" : ",",k,v);
first = false;
}
str ~= "}";
return str.idup;
}

}
    class SubsetState
{
    StateElement[] elms;
    State dfa_state;
    this(StateElement[] elms = null)
{
this.elms = elms;
}
    int opApply(int delegate(ref TNFATransition!(char_t)) dg)
{
int res;
foreach (elm; elms)
{
foreach (t; elm.nfa_state.transitions)
{
res = dg(t);
if (res)
return res;
}
}
return res;
}
    override string toString()
{
string str = "[ ";
bool first = true;
foreach (s; elms)
{
if (!first)
str ~= ", ";
str ~= s.toString();
first = false;
}
return str ~ " ]";
}

}
    struct Mark
{
    char_t c;
    bool end;
    int opCmp(Mark m)
{
if (c < m.c)
return -1;
if (c > m.c)
return 1;
if (end < m.end)
return -1;
if (end > m.end)
return 1;
return 0;
}
}
    uint registerFromTagIndex(uint tag, uint index)
{
if (index > 0)
{
TagIndex ti;
ti.tag = tag;
ti.index = index;
uint* i = ti in registers;
if (i !is null)
return *i;
return registers[ti] = next_register++;
}
else
return tag - 1;
}
    Mark[] marks_;
    State addState()
{
State s = new State;
s.index = states.length;
states ~= s;
return s;
}
    predicate_t[] disjointPredicates(SubsetState state)
{
alias CharRange!(char_t) range_t;
debug (tdfa)
{
Stdout.formatln("disjointPredicates()");
}

size_t num_marks;
foreach (t; state)
{
if (t.predicate.type != predicate_t.Type.epsilon)
{
debug (tdfa)
{
Stdout.formatln("{}",t.predicate.toString);
}

if (marks_.length < num_marks + 2 * t.predicate.getInput().parts.length)
marks_.length = num_marks + 2 * t.predicate.getInput().parts.length;
foreach (p; t.predicate.getInput().parts)
{
marks_[num_marks++] = Mark(p.l(),false);
marks_[num_marks++] = Mark(p.r(),true);
}
}
}
if (num_marks <= 1)
throw new Exception("disjointPredicates: No transitions in subset state");
debug (tdfa)
{
Stdout("\x0asorting...").newline;
}

quickSort(marks_[0..num_marks]);
assert(!marks_[0].end);
debug (tdfa)
{
Stdout("\x0asorted marks:\x0a");
bool first = true;
foreach (m; marks_[0..num_marks])
{
if (first)
first = false;
else
Stdout(",");
if (m.c > 32 && m.c < 127)
Stdout.format("{}{}",m.end ? "e" : "s",m.c);
else
Stdout.format("{}{:x}",m.end ? "e" : "s",cast(int)m.c);
}
Stdout.newline;
}

size_t next,active = 1;
char_t start = marks_[0].c,end;
range_t[] disjoint = new range_t[](num_marks / 2 + 1);
foreach (m; marks_[1..num_marks])
{
if (m.end)
{
assert(active > 0);
--active;
if (m.c < start)
continue;
end = m.c;
if (active > 0)
++m.c;
}
else
{
++active;
if (active == 1)
{
if (m.c > start)
{
start = m.c;
continue;
}
end = m.c;
++m.c;
}
else
if (m.c <= start)
continue;
else
end = m.c - 1;
}
if (disjoint.length <= next)
disjoint.length = disjoint.length * 2;
disjoint[next].l_ = start;
disjoint[next].r_ = end;
++next;
start = m.c;
}
disjoint.length = next;
predicate_t[] preds;
preds.length = 1;
Lmerge:
foreach (r; disjoint)
{
if (preds[$ - 1].empty())
preds[$ - 1].appendInput(r);
else
{
foreach (t; state)
{
if (t.predicate.type == predicate_t.Type.epsilon)
continue;
if (t.predicate.getInput().contains(r) != t.predicate.getInput().contains(preds[$ - 1].getInput()))
{
preds.length = preds.length + 1;
break;
}
}
preds[$ - 1].appendInput(r);
}
}
debug (tdfa)
{
Stdout("\x0adisjoint ranges:\x0a");
first = true;
foreach (r; disjoint)
{
if (first)
first = false;
else
Stdout(",");
Stdout.format("{}",r);
}
Stdout.newline;
Stdout("\x0adisjoint predicates:\x0a");
first = true;
foreach (ref p; preds)
{
if (first)
first = false;
else
Stdout(",");
Stdout.format("{}",p.toString);
}
Stdout.newline;
}

debug (tdfa)
{
Stdout.formatln("disjointPredicates() end");
}

return preds;
}
    SubsetState reach(SubsetState subst, ref predicate_t pred)
{
bool have_consume,have_lookahead;
foreach (t; subst)
{
if (t.predicate.type != predicate_t.Type.consume && t.predicate.type != predicate_t.Type.lookahead)
continue;
auto intpred = t.predicate.intersect(pred);
if (!intpred.empty())
{
if (t.predicate.type == predicate_t.Type.consume)
have_consume = true;
else
if (t.predicate.type == predicate_t.Type.lookahead)
have_lookahead = true;
}
}
predicate_t.Type processed_type;
if (have_lookahead)
processed_type = predicate_t.Type.lookahead;
else
if (have_consume)
processed_type = predicate_t.Type.consume;
else
{
debug (tdfa)
{
Stdout.formatln("\x0aERROR: reach found no consume/lookahead symbol for {} in \x0a{}",pred.toString,subst.toString);
}

return null;
}
pred.type = processed_type;
SubsetState r = new SubsetState;
foreach (s; subst.elms)
{
foreach (t; s.nfa_state.transitions)
{
if (t.predicate.type != processed_type)
continue;
auto intpred = t.predicate.intersect(pred);
if (!intpred.empty())
{
StateElement se = new StateElement;
se.maxPriority = max(t.priority,s.maxPriority);
se.lastPriority = t.priority;
se.nfa_state = t.target;
se.tags = s.tags;
r.elms ~= se;
}
}
}
if (have_lookahead && have_consume)
{
foreach (s; subst.elms)
{
foreach (t; s.nfa_state.transitions)
{
if (t.predicate.type != predicate_t.Type.consume)
continue;
auto intpred = t.predicate.intersect(pred);
if (!intpred.empty())
{
r.elms ~= s;
break;
}
}
}
}
return r;
}
    SubsetState lookbehindClosure(SubsetState from, predicate_t pred)
{
List!(StateElement) stack = new List!(StateElement);
StateElement[size_t] closure;
foreach (e; from.elms)
{
stack ~= e;
closure[e.nfa_state.index] = e;
}
while (!stack.empty())
{
StateElement se = stack.tail.value;
stack.pop();
foreach (t; se.nfa_state.transitions)
{
if (t.predicate.type != predicate_t.Type.lookbehind)
continue;
if (t.predicate.intersect(pred).empty())
continue;
uint new_maxPri = max(t.priority,se.maxPriority);
StateElement* tmp = t.target.index in closure;
if (tmp !is null)
{
if (tmp.maxPriority < new_maxPri)
{
continue;
}
else
if (tmp.maxPriority == new_maxPri)
{
if (tmp.lastPriority <= t.priority)
{
continue;
}
}
}
StateElement new_se = new StateElement;
new_se.maxPriority = max(t.priority,se.maxPriority);
new_se.lastPriority = t.priority;
new_se.nfa_state = t.target;
new_se.tags = se.tags;
closure[t.target.index] = new_se;
stack ~= new_se;
}
}
SubsetState res = new SubsetState;
res.elms = closure.values;
return res;
}
    SubsetState epsilonClosure(SubsetState from, SubsetState previous)
{
int firstFreeIndex = -1;
foreach (e; previous.elms)
{
foreach (ti; e.tags)
{
firstFreeIndex = max(firstFreeIndex,cast(int)ti);
}
}
++firstFreeIndex;
List!(StateElement) stack = new List!(StateElement);
StateElement[size_t] closure;
foreach (e; from.elms)
{
stack ~= e;
closure[e.nfa_state.index] = e;
}
while (!stack.empty())
{
StateElement se = stack.tail.value;
stack.pop();
foreach (t; se.nfa_state.transitions)
{
if (t.predicate.type != predicate_t.Type.epsilon)
continue;
uint new_maxPri = max(t.priority,se.maxPriority);
StateElement* tmp = t.target.index in closure;
if (tmp !is null)
{
if (tmp.maxPriority < new_maxPri)
{
continue;
}
else
if (tmp.maxPriority == new_maxPri)
{
if (tmp.lastPriority <= t.priority)
{
continue;
}
}
}
auto new_se = new StateElement;
new_se.maxPriority = new_maxPri;
new_se.lastPriority = t.priority;
new_se.nfa_state = t.target;
if (t.tag > 0)
{
foreach (k, v; se.tags)
{
new_se.tags[k] = v;
}
new_se.tags[t.tag] = firstFreeIndex;
}
else
new_se.tags = se.tags;
closure[t.target.index] = new_se;
stack ~= new_se;
}
}
SubsetState res = new SubsetState;
res.elms = closure.values;
if (firstFreeIndex > 0)
{
bool seenLastUsedIndex = false;
sluiLoop:
foreach (e; res.elms)
{
foreach (i; e.tags)
{
if (i == firstFreeIndex - 1)
{
seenLastUsedIndex = true;
break sluiLoop;
}
}
}
if (!seenLastUsedIndex)
{
foreach (e; res.elms)
{
foreach (ref i; e.tags)
{
if (i == firstFreeIndex)
i = -firstFreeIndex;
}
}
}
}
return res;
}
    bool reorderTagIndeces(SubsetState from, SubsetState to, SubsetState previous, Transition trans)
{
if (from.elms.length != to.elms.length)
return false;
bool[Command] cmds;
uint[TagIndex] reorderedIndeces;
StateElement[TagIndex] reordered_elements;
Louter:
foreach (fe; from.elms)
{
foreach (te; to.elms)
{
if (te.nfa_state.index != fe.nfa_state.index)
continue;
if (fe.tags.length != te.tags.length)
return false;
foreach (tag, findex; fe.tags)
{
if ((tag in te.tags) is null)
return false;
TagIndex ti;
ti.tag = tag;
ti.index = te.tags[tag];
if ((ti in reorderedIndeces) !is null)
{
auto rse = reordered_elements[ti];
auto ri = reorderedIndeces[ti];
if (ri != findex && (rse.maxPriority < fe.maxPriority || rse.maxPriority == fe.maxPriority && rse.lastPriority <= fe.lastPriority))
continue;
Command cmd;
cmd.src = registerFromTagIndex(tag,ri);
cmd.dst = registerFromTagIndex(tag,te.tags[tag]);
cmds.remove(cmd);
}
if (te.tags[tag] != findex)
{
Command cmd;
cmd.src = registerFromTagIndex(tag,findex);
cmd.dst = registerFromTagIndex(tag,te.tags[tag]);
cmds[cmd] = true;
}
reorderedIndeces[ti] = findex;
reordered_elements[ti] = fe;
}
continue Louter;
}
return false;
}
debug (tdfa)
{
Stdout.formatln("\x0areorder {} to {}\x0a",from.toString,to.dfa_state.index);
}

trans.commands ~= cmds.keys;
return true;
}
    void generateInitializers(SubsetState start)
{
uint[uint] cmds;
foreach (nds; start.elms)
{
foreach (k, v; nds.tags)
{
cmds[k] = v;
}
}
foreach (k, v; cmds)
{
Command cmd;
cmd.dst = registerFromTagIndex(k,v);
cmd.src = CURRENT_POSITION_REGISTER;
initializer ~= cmd;
}
}
    void generateFinishers(SubsetState r)
{
StateElement[] sorted_elms = r.elms.dup.sort;
bool reluctant = false;
foreach (se; sorted_elms)
{
debug (Finishers)
{
Stdout.formatln("Finisher: {}",se);
}

if (se.nfa_state.accept)
{
r.dfa_state.accept = true;
TNFATransition!(char_t) highestPriTrans;
if (!(sorted_elms[$ - 1] && sorted_elms[$ - 1].nfa_state && sorted_elms[$ - 1].nfa_state))
throw new Exception("Something is NULL that is expected to\x0a                            be non-null","tango/text/Regex.d",3506);
foreach (trans; sorted_elms[$ - 1].nfa_state.transitions)
{
if (trans.canFinish())
{
r.dfa_state.reluctant = true;
break;
}
}
bool[uint] finished_tags;
{
foreach (t, i; se.tags)
{
if (i > 0 && !(t in finished_tags))
{
finished_tags[t] = true;
Command cmd;
cmd.dst = registerFromTagIndex(t,0);
cmd.src = registerFromTagIndex(t,i);
r.dfa_state.finishers ~= cmd;
}
}
}
}
}
}
    void minimizeDFA()
{
class DiffTable
{
    this(size_t num)
{
diff_ = new bool[](num * (num + 1) / 2);
}
    ~this()
{
delete diff_;
}
    bool opCall(size_t a, size_t b)
{
if (a < b)
return diff_[b * (b + 1) / 2 + a];
return diff_[a * (a + 1) / 2 + b];
}
    void set(size_t a, size_t b)
{
if (a < b)
diff_[b * (b + 1) / 2 + a] = true;
else
diff_[a * (a + 1) / 2 + b] = true;
}
    bool[] diff_;
}
debug (tdfa)
{
Stdout.formatln("Minimizing TDFA");
}

scope diff = new DiffTable(states.length);
bool new_diff = true;
while (new_diff)
{
new_diff = false;
foreach (i, a; states[0..$ - 1])
{
Linner:
foreach (j, b; states[i + 1..$])
{
if (diff(i,j + i + 1))
continue;
if (a.accept != b.accept || a.transitions.length != b.transitions.length)
{
diff.set(i,j + i + 1);
new_diff = true;
continue;
}
if (a.accept)
{
if (a.finishers.length != b.finishers.length)
{
diff.set(i,j + i + 1);
new_diff = true;
continue;
}
foreach (k, cmd; a.finishers)
{
if (cmd != b.finishers[k])
{
diff.set(i,j + i + 1);
new_diff = true;
continue Linner;
}
}
}
Ltrans:
foreach (ta; a.transitions)
{
foreach (tb; b.transitions)
{
if (ta.predicate.intersects(tb.predicate))
{
if (diff(ta.target.index,tb.target.index))
{
diff.set(i,j + i + 1);
new_diff = true;
continue Linner;
}
if (ta.commands.length != tb.commands.length)
{
diff.set(i,j + i + 1);
new_diff = true;
continue Linner;
}
foreach (k, cmd; ta.commands)
{
if (cmd != tb.commands[k])
{
diff.set(i,j + i + 1);
new_diff = true;
continue Linner;
}
}
continue Ltrans;
}
}
diff.set(i,j + i + 1);
new_diff = true;
continue Linner;
}
}
}
}
foreach (i, a; states[0..$ - 1])
{
foreach (j, b; states[i + 1..$])
{
if (!diff(i,j + i + 1))
{
debug (tdfa)
{
Stdout.formatln("State {} == {}",i,j + i + 1);
}

foreach (k, c; states)
{
foreach (t; c.transitions)
{
if (t.target.index == j + i + 1)
t.target = a;
}
}
}
}
}
}
}
}
}

import tango.text.Util;
template RegExpT(char_t)
{
class RegExpT
{
    alias TDFA!(dchar) tdfa_t;
    alias TNFA!(dchar) tnfa_t;
    alias CharClass!(dchar) charclass_t;
    alias Predicate!(dchar) predicate_t;
    this(const(char_t)[] pattern, const(char_t)[] attributes = null)
{
this(pattern,false,true);
}
    this(const(char_t)[] pattern, bool swapMBS, bool unanchored, bool printNFA = false)
{
pattern_ = pattern;
debug (TangoRegex)
{
}
else
{
static if(is(char_t == dchar))
{
scope tnfa_t tnfa_ = new tnfa_t(pattern_);
}
else
{
scope tnfa_t tnfa_ = new tnfa_t(tango.text.convert.Utf.toString32(pattern_));
}

}

tnfa_.swapMatchingBracketSyntax = swapMBS;
tnfa_.parse(unanchored);
if (printNFA)
{
debug (TangoRegex)
{
Stdout.formatln("\x0aTNFA:");
}

debug (TangoRegex)
{
tnfa_.print;
}

}
tdfa_ = new tdfa_t(tnfa_);
registers_.length = tdfa_.num_regs();
}
    static RegExpT!(char_t) opCall(const(char_t)[] pattern, const(char_t)[] attributes = null)
{
return new RegExpT!(char_t)(pattern,attributes);
}

    public RegExpT!(char_t) search(const(char_t)[] input)
{
input_ = input;
next_start_ = 0;
last_start_ = 0;
return this;
}

    public int opApply(int delegate(ref RegExpT!(char_t)) dg)
{
int result;
while (!result && test())
result = dg(this);
return result;
}

    bool test(const(char_t)[] input)
{
this.input_ = input;
next_start_ = 0;
last_start_ = 0;
return test();
}
    bool test()
{
assert(registers_.length == tdfa_.num_regs());
registers_[0..$] = -1;
foreach (cmd; tdfa_.initializer)
{
assert(cmd.src == tdfa_.CURRENT_POSITION_REGISTER);
registers_[cmd.dst] = 0;
}
auto inp = input_[next_start_..$];
auto s = tdfa_.start;
debug (TangoRegex)
{
Stdout.formatln("{}{}: {}",s.accept ? "*" : " ",s.index,inp);
}

LmainLoop:
{
for (size_t p,next_p; p < inp.length;)
{
{
Lread_char:
dchar c = cast(dchar)inp[p];
if (c & 128)
c = decode(inp,next_p);
else
next_p = p + 1;
Lprocess_char:
debug (TangoRegex)
{
Stdout.formatln("{} (0x{:x})",c,cast(int)c);
}

tdfa_t.Transition t = void;
switch (s.mode)
{
case s.Mode.LOOKUP:
{
if (c < s.LOOKUP_LENGTH)
{
debug (TangoRegex)
{
Stdout.formatln("lookup");
}

auto i = s.lookup[c];
if (i == s.INVALID_STATE)
break LmainLoop;
t = s.transitions[i];
if (t.predicate.type != t.predicate.Type.consume)
goto Lno_consume;
goto Lconsume;
}
break LmainLoop;
}
case s.Mode.MIXED:
{
if (c < s.LOOKUP_LENGTH)
{
debug (TangoRegex)
{
Stdout.formatln("mixed");
}

auto i = s.lookup[c];
if (i == s.INVALID_STATE)
break;
t = s.transitions[i];
if (t.predicate.type != t.predicate.Type.consume)
goto Lno_consume;
goto Lconsume;
}
break;
}
case s.Mode.GENERIC:
{
}
default:
{
break;
}
}
Ltrans_loop:
{
for (tdfa_t.Transition* tp = &s.generic_transitions[0],tp_end = tp + s.generic_transitions.length; tp < tp_end; ++tp)
{
{
t = *tp;
switch (t.predicate.mode)
{
case predicate_t.MatchMode.single_char:
{
debug (TangoRegex)
{
Stdout.formatln("single char 0x{:x} == 0x{:x}",cast(int)c,cast(int)t.predicate.data_chr);
}

if (c != t.predicate.data_chr)
continue Ltrans_loop;
goto Lconsume;
}
case predicate_t.MatchMode.single_char_l:
{
debug (TangoRegex)
{
Stdout.formatln("single char 0x{:x} == 0x{:x}",cast(int)c,cast(int)t.predicate.data_chr);
}

if (c != t.predicate.data_chr)
continue Ltrans_loop;
goto Lno_consume;
}
case predicate_t.MatchMode.bitmap:
{
debug (TangoRegex)
{
Stdout.formatln("bitmap {}\x0a{}",c,t.predicate.toString);
}

if (c <= predicate_t.MAX_BITMAP_LENGTH && t.predicate.data_bmp[c / 8] & 1 << (c & 7))
goto Lconsume;
continue Ltrans_loop;
}
case predicate_t.MatchMode.bitmap_l:
{
debug (TangoRegex)
{
Stdout.formatln("bitmap {}\x0a{}",c,t.predicate.toString);
}

if (c <= predicate_t.MAX_BITMAP_LENGTH && t.predicate.data_bmp[c / 8] & 1 << (c & 7))
goto Lno_consume;
continue Ltrans_loop;
}
case predicate_t.MatchMode.string_search:
{
debug (TangoRegex)
{
Stdout.formatln("string search {} in {}",c,t.predicate.data_str);
}

if (indexOf(t.predicate.data_str.ptr,c,t.predicate.data_str.length) >= t.predicate.data_str.length)
continue Ltrans_loop;
goto Lconsume;
}
case predicate_t.MatchMode.string_search_l:
{
debug (TangoRegex)
{
Stdout.formatln("string search {} in {}",c,t.predicate.data_str);
}

if (indexOf(t.predicate.data_str.ptr,c,t.predicate.data_str.length) >= t.predicate.data_str.length)
continue Ltrans_loop;
goto Lno_consume;
}
case predicate_t.MatchMode.generic:
{
debug (TangoRegex)
{
Stdout.formatln("generic {}\x0a{}",c,t.predicate.toString);
}

{
for (auto cmp = t.predicate.data_str.ptr,cmpend = cmp + t.predicate.data_str.length; cmp < cmpend; ++cmp)
{
{
if (c < *cmp)
{
++cmp;
continue;
}
++cmp;
if (c <= *cmp)
goto Lconsume;
}
}
}
continue Ltrans_loop;
}
case predicate_t.MatchMode.generic_l:
{
debug (TangoRegex)
{
Stdout.formatln("generic {}\x0a{}",c,t.predicate.toString);
}

{
for (auto cmp = t.predicate.data_str.ptr,cmpend = cmp + t.predicate.data_str.length; cmp < cmpend; ++cmp)
{
{
if (c < *cmp)
{
++cmp;
continue;
}
++cmp;
if (c <= *cmp)
goto Lno_consume;
}
}
}
continue Ltrans_loop;
}
default:
{
assert(0);
}
}
Lconsume:
p = next_p;
Lno_consume:
s = t.target;
debug (TangoRegex)
{
Stdout.formatln("{}{}: {}",s.accept ? "*" : " ",s.index,inp[p..$]);
}

debug (TangoRegex)
{
Stdout.formatln("{} commands",t.commands.length);
}

foreach (cmd; t.commands)
{
if (cmd.src == tdfa_.CURRENT_POSITION_REGISTER)
registers_[cmd.dst] = cast(int)p;
else
registers_[cmd.dst] = registers_[cmd.src];
}
if (s.accept && s.reluctant)
goto Laccept;
if (p >= inp.length)
{
if (s.accept || c == 0)
break;
c = 0;
goto Lprocess_char;
}
goto Lread_char;
}
}
}
break;
}
}
}
if (s.accept)
{
Laccept:
foreach (cmd; s.finishers)
{
assert(cmd.src != tdfa_.CURRENT_POSITION_REGISTER);
registers_[cmd.dst] = registers_[cmd.src];
}
if (registers_.length > 1 && registers_[1] >= 0)
{
last_start_ = next_start_;
next_start_ += registers_[1];
}
return true;
}
return false;
}
    const(char_t)[] match(uint index)
{
if (index > tdfa_.num_tags)
return null;
int start = cast(int)last_start_ + registers_[index * 2],end = cast(int)last_start_ + registers_[index * 2 + 1];
if (start >= 0 && start < end && end <= input_.length)
return input_[start..end];
return null;
}
    const(char_t)[] opIndex(uint index)
{
return match(index);
}
    const(char_t)[] pre()
{
auto start = registers_[0];
if (start < 0)
return null;
return input_[0..last_start_ + start];
}
    const(char_t)[] post()
{
if (registers_[1] >= 0)
return input_[next_start_..$];
return input_[last_start_..$];
}
    inout(char_t)[][] split(inout(char_t)[] input)
{
auto res = new inout(char_t)[][](PREALLOC);
uint index;
inout(char_t)[] tmp = input;
foreach (r; search(input))
{
tmp = cast(inout(char_t)[])pre();
res[index++] = tmp[last_start_..$];
if (index >= res.length)
res.length = res.length * 2;
tmp = cast(inout(char_t)[])post();
}
res[index++] = tmp;
res.length = index;
return res;
}
    char_t[] replaceAll(const(char_t)[] input, const(char_t)[] replacement, char_t[] output_buffer = null)
{
const(char_t)[] tmp = input;
if (output_buffer.length <= 0)
output_buffer = new char_t[](input.length + replacement.length);
output_buffer.length = 0;
foreach (r; search(input))
{
tmp = pre();
if (tmp.length > last_start_)
output_buffer ~= tmp[last_start_..$];
output_buffer ~= replacement;
tmp = post();
}
output_buffer ~= tmp;
return output_buffer;
}
    char_t[] replaceLast(const(char_t)[] input, const(char_t)[] replacement, char_t[] output_buffer = null)
{
const(char_t)[] tmp_pre,tmp_post;
if (output_buffer.length <= 0)
output_buffer = new char_t[](input.length + replacement.length);
output_buffer.length = 0;
foreach (r; search(input))
{
tmp_pre = pre();
tmp_post = post();
}
if (tmp_pre !is null || tmp_post !is null)
{
output_buffer ~= tmp_pre;
output_buffer ~= replacement;
output_buffer ~= tmp_post;
}
else
output_buffer ~= input;
return output_buffer;
}
    char_t[] replaceFirst(const(char_t)[] input, const(char_t)[] replacement, char_t[] output_buffer = null)
{
const(char_t)[] tmp = input;
if (output_buffer.length <= 0)
output_buffer = new char_t[](input.length + replacement.length);
output_buffer.length = 0;
if (test(input))
{
tmp = pre();
if (tmp.length > last_start_)
output_buffer ~= tmp[last_start_..$];
output_buffer ~= replacement;
tmp = post();
}
output_buffer ~= tmp;
return output_buffer;
}
    char_t[] replaceAll(const(char_t)[] input, char_t[] delegate(RegExpT!(char_t)) dg, char_t[] output_buffer = null)
{
const(char_t)[] tmp = input;
if (output_buffer.length <= 0)
output_buffer = new char_t[](input.length);
output_buffer.length = 0;
foreach (r; search(input))
{
tmp = pre();
if (tmp.length > last_start_)
output_buffer ~= tmp[last_start_..$];
output_buffer ~= dg(this);
tmp = post();
}
output_buffer ~= tmp;
return output_buffer;
}
    const(char)[] compileToD(const(char)[] func_name = "match", bool lexer = false)
{
const(char)[] code;
const(char)[] str_type;
static if(is(char_t == char))
{
str_type = "const(char)[]";
}

static if(is(char_t == wchar))
{
str_type = "const(wchar)[]";
}

static if(is(char_t == dchar))
{
str_type = "const(dchar)[]";
}

if (lexer)
code = Format.convert("// {}\x0abool {}({} input, out uint token, out {} match",pattern_,func_name,str_type,str_type);
else
{
code = Format.convert("// {}\x0abool match({} input",pattern_,str_type);
code ~= Format.convert(", ref {}[] groups",str_type);
}
code ~= Format.convert(")\x0a{{\x0a    uint s = {};",tdfa_.start.index);
uint num_vars = tdfa_.num_regs();
if (num_vars > 0)
{
if (lexer)
code ~= "\x0a    static int ";
else
code ~= "\x0a    int ";
bool first = true;
{
for (int i = 0,used = 0; i < num_vars; ++i)
{
{
bool hasInit = false;
foreach (cmd; tdfa_.initializer)
{
if (cmd.dst == i)
{
hasInit = true;
break;
}
}
if (first)
first = false;
else
code ~= ", ";
if (used > 0 && used % 10 == 0)
code ~= "\x0a        ";
++used;
code ~= Format.convert("r{}",i);
if (hasInit)
code ~= "=0";
else
code ~= "=-1";
}
}
}
code ~= ";";
}
code ~= "\x0a\x0a    for ( size_t p, next_p; p < input.length; )\x0a    {";
code ~= "\x0a        dchar c = cast(dchar)input[p];\x0a        if ( c & 0x80 )\x0a            decode(input, next_p);";
code ~= "\x0a        else\x0a            next_p = p+1;\x0a        switch ( s )\x0a        {";
size_t[] finish_states;
foreach (s; tdfa_.states)
{
code ~= Format.convert("\x0a            case {}:",s.index);
if (s.accept)
{
finish_states ~= s.index;
tdfa_t.State target;
foreach (t; s.transitions)
{
if (target is null)
target = t.target;
else
if (target !is t.target)
{
target = null;
break;
}
}
if (target !is null && target is s)
s.transitions = null;
}
bool first_if = true;
charclass_t cc,ccTest;
foreach (t; s.transitions.sort)
{
ccTest.add(t.predicate.getInput());
ccTest.optimize();
if (t.predicate.getInput() < ccTest)
cc = t.predicate.getInput();
else
cc = ccTest;
if (first_if)
{
code ~= "\x0a                if ( ";
first_if = false;
}
else
code ~= "\x0a                else if ( ";
bool first_cond = true;
foreach (cr; cc.parts)
{
if (first_cond)
first_cond = false;
else
code ~= " || ";
if (cr.l() == cr.r())
code ~= Format.convert("c == 0x{:x}",cast(int)cr.l());
else
code ~= Format.convert("c >= 0x{:x} && c <= 0x{:x}",cast(int)cr.l(),cast(int)cr.r());
}
code ~= Format.convert(" ) {{\x0a                    s = {};",t.target.index);
if (t.predicate.type == (typeof(t.predicate.type)).consume)
code ~= "\x0a                    p = next_p;";
foreach (cmd; t.commands)
{
code ~= compileCommand(cmd,"                    ");
}
code ~= "\x0a                }";
}
if (!first_if)
code ~= Format.convert("\x0a                else\x0a                    {};\x0a                break;",s.accept ? Format.convert("goto finish{}",s.index) : "return false");
else
code ~= Format.convert("\x0a                {};",s.accept ? Format.convert("goto finish{}",s.index) : "return false");
}
size_t[][size_t] finisherGroup;
foreach (fs; finish_states)
{
bool haveFinisher = false;
foreach (fg; finisherGroup.keys)
{
bool equalCommands = false;
if (tdfa_.states[fs].finishers.length == tdfa_.states[fg].finishers.length)
{
equalCommands = true;
foreach (i, cmd; tdfa_.states[fs].finishers)
{
if (cmd != tdfa_.states[fg].finishers[i])
{
equalCommands = false;
break;
}
}
}
if (equalCommands)
{
finisherGroup[fg] ~= fs;
haveFinisher = true;
break;
}
}
if (!haveFinisher)
finisherGroup[fs] ~= fs;
}
code ~= "\x0a            default:\x0a                assert(0);\x0a        }\x0a    }\x0a\x0a    switch ( s )\x0a    {";
foreach (group, states; finisherGroup)
{
foreach (s; states)
{
code ~= Format.convert("\x0a        case {}: finish{}:",s,s);
}
foreach (cmd; tdfa_.states[group].finishers)
{
if (lexer)
{
if (tdfa_.states[group].finishers.length > 1)
throw new RegExpException("Lexer error: more than one finisher in flm lexer!");
if (cmd.dst % 2 == 0 || cmd.dst >= tdfa_.num_tags)
throw new RegExpException(Format.convert("Lexer error: unexpected dst register {} in flm lexer!",cmd.dst).idup);
code ~= Format.convert("\x0a            match = input[0 .. r{}];\x0a            token = {};",cmd.src,cmd.dst / 2);
}
else
code ~= compileCommand(cmd,"            ");
}
code ~= "\x0a            break;";
}
code ~= "\x0a        default:\x0a            return false;\x0a    }\x0a";
if (!lexer)
{
code ~= Format.convert("\x0a    groups.length = {};",tdfa_.num_tags / 2);
{
for (int i = 0;
 i < tdfa_.num_tags / 2; ++i)
{
code ~= Format.convert("\x0a    if ( r{} > -1 && r{} > -1 )\x0a        groups[{}] = input[r{} .. r{}];",2 * i,2 * i + 1,i,2 * i,2 * i + 1);
}
}
}
code ~= "\x0a    return true;\x0a}";
return code;
}
    public const(char_t)[] pattern()
{
return pattern_;
}

    uint tagCount()
{
return tdfa_.num_tags;
}
    int[] registers_;
    size_t next_start_;
    size_t last_start_;
    debug (TangoRegex)
{
    tnfa_t tnfa_;
}
    tdfa_t tdfa_;
    private 
{
    const int PREALLOC = 16;

    const(char_t)[] input_;
    const(char_t)[] pattern_;
    const(char)[] compileCommand(tdfa_t.Command cmd, const(char)[] indent)
{
const(char)[] code,dst;
code ~= Format.convert("\x0a{}r{} = ",indent,cmd.dst);
if (cmd.src == tdfa_.CURRENT_POSITION_REGISTER)
code ~= "p;";
else
code ~= Format.convert("r{};",cmd.src);
return code;
}
}
}
}
alias RegExpT!(char) Regex;
debug (utf)
{
    import tango.stdc.stdio;
}
class UtfException : Exception
{
    size_t idx;
    this(immutable(char)[] s, size_t i)
{
idx = i;
super(s);
}
}
bool isValidDchar(dchar c)
{
return c < 55296 || c > 57343 && c <= 1114111;
}
dchar decode(const(char)[] s, ref size_t idx);
dchar decode(const(wchar)[] s, ref size_t idx);
dchar decode(const(dchar)[] s, ref size_t idx);
void encode(ref const(char)[] s, dchar c)
in
{
assert(isValidDchar(c));
}
body
{
const(char)[] r = s;
if (c <= 127)
{
r ~= cast(char)c;
}
else
{
char[4] buf;
uint L;
if (c <= 2047)
{
buf[0] = cast(char)(192 | c >> 6);
buf[1] = cast(char)(128 | c & 63);
L = 2;
}
else
if (c <= 65535)
{
buf[0] = cast(char)(224 | c >> 12);
buf[1] = cast(char)(128 | c >> 6 & 63);
buf[2] = cast(char)(128 | c & 63);
L = 3;
}
else
if (c <= 1114111)
{
buf[0] = cast(char)(240 | c >> 18);
buf[1] = cast(char)(128 | c >> 12 & 63);
buf[2] = cast(char)(128 | c >> 6 & 63);
buf[3] = cast(char)(128 | c & 63);
L = 4;
}
else
{
assert(0);
}
r ~= buf[0..L];
}
s = r;
}
void encode(ref const(wchar)[] s, dchar c)
in
{
assert(isValidDchar(c));
}
body
{
const(wchar)[] r = s;
if (c <= 65535)
{
r ~= cast(wchar)c;
}
else
{
wchar[2] buf;
buf[0] = cast(wchar)((c - 65536 >> 10 & 1023) + 55296);
buf[1] = cast(wchar)((c - 65536 & 1023) + 56320);
r ~= buf;
}
s = r;
}
void encode(ref const(dchar)[] s, dchar c)
in
{
assert(isValidDchar(c));
}
body
{
s ~= c;
}
debug (UnitTest)
{
        debug (RegexTestOnly)
{
    import tango.io.Stdout;
    void main()
{
Stdout("All tests pass").newline();
}
}
}
