// D import file generated from 'tango/text/Text.d'
module tango.text.Text;
private import tango.text.Search;

private import tango.io.model.IConduit;

private import tango.text.convert.Layout;

private import Util = tango.text.Util;

private import Utf = tango.text.convert.Utf;

private import Float = tango.text.convert.Float;

private import Integer = tango.text.convert.Integer;

private import tango.stdc.string;

version (GNU)
{
    private import tango.core.Vararg;

}
else
{
    version (DigitalMars)
{
    private import tango.core.Vararg;

    version (X86_64)
{
    version = DigitalMarsX64;
}
}
}
template Text(T)
{
class Text : TextView!(T)
{
    public alias set opAssign;

    public alias append opCatAssign;

    private alias TextView!(T) TextViewT;

    private alias Layout!(T) LayoutT;

    private T[] content;

    private bool mutable;

    private Comparator comparator_;

    private 
{
    size_t selectPoint;
    size_t selectLength;
    size_t contentLength;
}
    private template Search(T)
{
struct Search
{
    private alias SearchFruct!(T) Engine;

    private alias size_t delegate(const(T)[], size_t) Call;

    private Text text;

    private Engine engine;

    static Search opCall(Text text, const(T)[] match)
{
Search s = void;
s.engine.match = match;
text.selectLength = 0;
s.text = text;
return s;
}

    @property bool prev()
{
return locate(&engine.reverse,text.slice(),text.point - 1);
}

    @property bool next()
{
return locate(&engine.forward,text.slice(),text.selectPoint + text.selectLength);
}

    @property bool within()
{
return engine.within(text.slice());
}

    @property size_t count()
{
return engine.count(text.slice());
}

    void replace(T chr)
{
replace((&chr)[0..1]);
}
    void replace(const(T)[] sub = null)
{
auto dst = new T[](text.length);
dst.length = 0;
foreach (token; engine.tokens(text.slice(),sub))
{
dst ~= token;
}
text.set(dst,false);
}
    private bool locate(Call call, const(T)[] content, size_t from)
{
auto index = call(content,from);
if (index < content.length)
{
text.select(index,engine.match().length);
return true;
}
return false;
}

}
}

    deprecated public struct Span
{
    size_t begin;
    size_t length;
}


    this(size_t space = 0)
{
content.length = space;
this.comparator_ = &simpleComparator;
}
    this(T[] content, bool copy)
{
set(content,copy);
this.comparator_ = &simpleComparator;
}
    this(const(T)[] content)
{
set(content);
this.comparator_ = &simpleComparator;
}
    this(TextViewT other, bool copy = true)
{
this(other.mslice(),copy);
}
    this(const(TextViewT) other, bool copy = true)
{
this(other.slice());
}
    final Text set(T[] chars, bool copy)
{
contentLength = chars.length;
if ((this.mutable = copy) is true)
content = chars.dup;
else
content = chars;
return select(0,0);
}

    final Text set(const(T)[] chars)
{
contentLength = chars.length;
content = chars.dup;
return select(0,0);
}

    final Text set(TextViewT other, bool copy = true)
{
return set(other.mslice(),copy);
}

    final Text select(size_t start = 0, size_t length = (int).max)
{
pinIndices(start,length);
selectPoint = start;
selectLength = length;
return this;
}

    const final const(T)[] selection()
{
return slice()[selectPoint..selectPoint + selectLength];
}

    final deprecated Span span()
{
Span s;
s.begin = selectPoint;
s.length = selectLength;
return s;
}

    final @property size_t point()
{
return selectPoint;
}

    final @property Text point(size_t index)
{
return select(index,0);
}

    Search!(T) search(const(T)[] match)
{
return Search!(T)(this,match);
}
    Search!(T) search(ref T match)
{
return search((&match)[0..1]);
}
    final deprecated bool select(T c)
{
auto s = slice();
auto x = Util.locate(s,c,selectPoint);
if (x < s.length)
{
select(x,1);
return true;
}
return false;
}

    final deprecated bool select(const(TextViewT) other)
{
return select(other.slice());
}

    final deprecated bool select(const(T)[] chars)
{
auto s = slice();
auto x = Util.locatePattern(s,chars,selectPoint);
if (x < s.length)
{
select(x,chars.length);
return true;
}
return false;
}

    final deprecated bool selectPrior(T c)
{
auto s = slice();
auto x = Util.locatePrior(s,c,selectPoint);
if (x < s.length)
{
select(x,1);
return true;
}
return false;
}

    final deprecated bool selectPrior(const(TextViewT) other)
{
return selectPrior(other.slice());
}

    final deprecated bool selectPrior(const(T)[] chars)
{
auto s = slice();
auto x = Util.locatePatternPrior(s,chars,selectPoint);
if (x < s.length)
{
select(x,chars.length);
return true;
}
return false;
}

    final Text format(const(T)[] format,...)
{
size_t emit(const(T)[] s)
{
append(s);
return s.length;
}
version (DigitalMarsX64)
{
va_list ap;
va_start(ap,__va_argsave);
scope(exit) va_end(ap);
LayoutT.instance.convert(&emit,_arguments,ap,format);
}
else
{
LayoutT.instance.convert(&emit,_arguments,_argptr,format);
}

return this;
}

    final Text append(const(TextViewT) other)
{
return append(other.slice());
}

    final Text append(const(T)[] chars)
{
return append(chars.ptr,chars.length);
}

    final Text append(T chr, size_t count = 1)
{
size_t point = selectPoint + selectLength;
expand(point,count);
return set(chr,point,count);
}

    final deprecated Text append(int v, const(T)[] fmt = null)
{
return append(cast(long)v,fmt);
}

    final deprecated Text append(long v, const(T)[] fmt = null)
{
T[64] tmp = void;
return append(Integer.format(tmp,v,fmt));
}

    final deprecated Text append(double v, int decimals = 2, int e = 10)
{
T[64] tmp = void;
return append(Float.format(tmp,v,decimals,e));
}

    final Text append(InputStream source)
{
T[8192 / T.sizeof] tmp = void;
while (true)
{
auto len = source.read(tmp);
if (len is source.Eof)
break;
assert((len & T.sizeof - 1) is 0);
append(tmp[0..len / T.sizeof]);
}
return this;
}

    final Text prepend(T chr, int count = 1)
{
expand(selectPoint,count);
return set(chr,selectPoint,count);
}

    final Text prepend(const(T)[] other)
{
expand(selectPoint,other.length);
content[selectPoint..selectPoint + other.length] = other;
return this;
}

    final Text prepend(const(TextViewT) other)
{
return prepend(other.slice());
}

    final Text encode(const(char)[] s)
{
T[1024] tmp = void;
static if(is(T == char))
{
return append(s);
}

static if(is(T == wchar))
{
return append(Utf.toString16(s,tmp));
}

static if(is(T == dchar))
{
return append(Utf.toString32(s,tmp));
}

}

    final Text encode(const(wchar)[] s)
{
T[1024] tmp = void;
static if(is(T == char))
{
return append(Utf.toString(s,tmp));
}

static if(is(T == wchar))
{
return append(s);
}

static if(is(T == dchar))
{
return append(Utf.toString32(s,tmp));
}

}

    final Text encode(const(dchar)[] s)
{
T[1024] tmp = void;
static if(is(T == char))
{
return append(Utf.toString(s,tmp));
}

static if(is(T == wchar))
{
return append(Utf.toString16(s,tmp));
}

static if(is(T == dchar))
{
return append(s);
}

}

    final Text encode(Object o)
{
return encode(o.toString());
}

    final Text replace(T chr)
{
return set(chr,selectPoint,selectLength);
}

    final Text replace(const(T)[] chars)
{
int chunk = cast(int)chars.length - cast(int)selectLength;
if (chunk >= 0)
expand(selectPoint,chunk);
else
remove(selectPoint,-chunk);
content[selectPoint..selectPoint + chars.length] = chars;
return select(selectPoint,chars.length);
}

    final Text replace(const(TextViewT) other)
{
return replace(other.slice());
}

    final Text remove()
{
remove(selectPoint,selectLength);
return select(selectPoint,0);
}

    private Text remove(size_t start, size_t count)
{
pinIndices(start,count);
if (count > 0)
{
if (!mutable)
realloc();
size_t i = start + count;
memmove(content.ptr + start,content.ptr + i,(contentLength - i) * T.sizeof);
contentLength -= count;
}
return this;
}

    final Text truncate(size_t index = size_t.max)
{
if (index is (int).max)
index = selectPoint + selectLength;
pinIndex(index);
return select(contentLength = index,0);
}

    final Text clear()
{
return select(contentLength = 0,0);
}

    final Text trim()
{
content = Util.trim(mslice());
select(0,contentLength = content.length);
return this;
}

    final Text strip(T matches)
{
content = Util.strip(mslice(),matches);
select(0,contentLength = content.length);
return this;
}

    final Text reserve(size_t extra)
{
realloc(extra);
return this;
}

    Text write(OutputStream sink)
{
sink.write(slice());
return this;
}
    const final override TypeInfo encoding()
{
return typeid(T);
}

    final override Comparator comparator(Comparator other)
{
auto tmp = comparator_;
if (other)
comparator_ = other;
return tmp;
}

    override hash_t toHash()
{
return Util.jhash(cast(ubyte*)content.ptr,contentLength * T.sizeof);
}

    const final override @property size_t length()
{
return contentLength;
}

    const final override bool equals(const(TextViewT) other)
{
if (other is this)
return true;
return equals(other.slice());
}

    const final override bool equals(const(T)[] other)
{
if (other.length == contentLength)
return Util.matching(other.ptr,content.ptr,contentLength);
return false;
}

    const final override bool ends(const(TextViewT) other)
{
return ends(other.slice());
}

    const final override bool ends(const(T)[] chars)
{
if (chars.length <= contentLength)
return Util.matching(content.ptr + (contentLength - chars.length),chars.ptr,chars.length);
return false;
}

    const final override bool starts(const(TextViewT) other)
{
return starts(other.slice());
}

    const final override bool starts(const(T)[] chars)
{
if (chars.length <= contentLength)
return Util.matching(content.ptr,chars.ptr,chars.length);
return false;
}

    const final override int compare(const(TextViewT) other)
{
if (other is this)
return 0;
return compare(other.slice());
}

    const final override int compare(const(T)[] chars)
{
return comparator_(slice(),chars);
}

    const final override T[] copy(T[] dst)
{
size_t i = contentLength;
if (i > dst.length)
i = dst.length;
return dst[0..i] = content[0..i];
}

    const final override const(T)[] slice()
{
return content[0..contentLength];
}

    override T[] mslice()
{
return content[0..contentLength];
}

    const override string toString()
{
return toString(null).idup;
}

    const final override char[] toString(char[] dst)
{
static if(is(T == char))
{
if (dst.length < length)
dst.length = length;
dst[] = slice()[];
return dst[0..this.length];
}

static if(is(T == wchar))
{
return Utf.toString(slice(),dst);
}

static if(is(T == dchar))
{
return Utf.toString(slice(),dst);
}

}

    const final override wchar[] toString16(wchar[] dst = null)
{
static if(is(T == char))
{
return Utf.toString16(slice(),dst);
}

static if(is(T == wchar))
{
if (dst.length < length)
dst.length = length;
dst[] = slice()[];
return dst[0..this.length];
}

static if(is(T == dchar))
{
return Utf.toString16(slice(),dst);
}

}

    const final override dchar[] toString32(dchar[] dst = null)
{
static if(is(T == char))
{
return Utf.toString32(slice(),dst);
}

static if(is(T == wchar))
{
return Utf.toString32(slice(),dst);
}

static if(is(T == dchar))
{
if (dst.length < length)
dst.length = length;
dst[] = slice()[];
return dst[0..length];
}

}

    const override int opCmp(Object o)
{
auto other = cast(TextViewT)o;
if (other is null)
return -1;
return compare(other);
}

    override bool opEquals(Object o)
{
auto other = cast(TextViewT)o;
if (other)
return equals(other);
char[1024] tmp = void;
return this.toString(tmp) == o.toString();
}

    final override bool opEquals(const(T)[] s)
{
return slice() == s;
}

    private const void pinIndex(ref size_t x)
{
if (x > contentLength)
x = contentLength;
}


    private const void pinIndices(ref size_t start, ref size_t length)
{
if (start > contentLength)
start = contentLength;
if (length > contentLength - start)
length = contentLength - start;
}


    private int simpleComparator(const(T)[] a, const(T)[] b)
{
size_t i = a.length;
if (b.length < i)
i = b.length;
{
for (int j,k; j < i; ++j)
{
if ((k = a[j] - b[j]) != 0)
return k;
}
}
return cast(int)a.length - cast(int)b.length;
}

    private void expand(size_t index, size_t count)
{
if (!mutable || contentLength + count > content.length)
realloc(count);
memmove(content.ptr + index + count,content.ptr + index,(contentLength - index) * T.sizeof);
selectLength += count;
contentLength += count;
}

    private Text set(T chr, size_t start, size_t count)
{
content[start..start + count] = chr;
return this;
}

    private void realloc(size_t count = 0)
{
size_t size = content.length + count + 127 & ~127;
if (mutable)
content.length = size;
else
{
mutable = true;
T[] x = content;
content = new T[](size);
if (contentLength)
content[0..contentLength] = x;
}
}

    private Text append(const(T)* chars, size_t count)
{
size_t point = selectPoint + selectLength;
expand(point,count);
content[point..point + count] = chars[0..count];
return this;
}

}
}
template TextView(T)
{
class TextView : UniText
{
    alias int delegate(const(T)[] a, const(T)[] b) Comparator;
    const abstract @property size_t length();

    const abstract bool equals(const(TextView) other);

    const abstract bool equals(const(T)[] other);

    const abstract bool ends(const(TextView) other);

    const abstract bool ends(const(T)[] chars);

    const abstract bool starts(const(TextView) other);

    const abstract bool starts(const(T)[] chars);

    const abstract int compare(const(TextView) other);

    const abstract int compare(const(T)[] chars);

    const abstract T[] copy(T[] dst);

    const abstract override int opCmp(Object o);

    abstract override bool opEquals(Object other);

    abstract bool opEquals(const(T)[] other);

    const abstract override TypeInfo encoding();

    abstract Comparator comparator(Comparator other);

    abstract override hash_t toHash();

    const abstract const(T)[] slice();

    abstract T[] mslice();

}
}
class UniText
{
    const abstract char[] toString(char[] dst = null);

    const abstract wchar[] toString16(wchar[] dst = null);

    const abstract dchar[] toString32(dchar[] dst = null);

    const abstract TypeInfo encoding();

}
debug (UnitTest)
{
    import tango.io.device.Array;
    }
debug (Text)
{
    void main()
{
auto t = new Text!(char);
t = "hello world";
auto s = t.search("o");
assert(s.next);
assert(t.selection() == "o");
assert(t.point is 4);
assert(s.next);
assert(t.selection() == "o");
assert(t.point is 7);
assert(!s.next);
t.point = 9;
assert(s.prev);
assert(t.selection() == "o");
assert(t.point is 7);
assert(s.prev);
assert(t.selection() == "o");
assert(t.point is 4);
assert(s.next);
assert(t.point is 7);
assert(s.prev);
assert(t.selection() == "o");
assert(t.point is 4);
assert(!s.prev);
assert(s.count is 2);
s.replace('O');
assert(t.slice() == "hellO wOrld");
assert(s.count is 0);
t.point = 0;
assert(t.search("hellO").next);
assert(t.selection() == "hellO");
assert(t.search("hellO").next);
assert(t.selection() == "hellO");
}
}
