// D import file generated from 'tango/text/Unicode.d'
module tango.text.Unicode;
private import tango.text.UnicodeData;

private import tango.text.convert.Utf;

char[] toUpper(const(char)[] input, char[] output = null);
wchar[] toUpper(const(wchar)[] input, wchar[] output = null);
dchar[] toUpper(const(dchar)[] input, dchar[] output = null);
char[] toLower(const(char)[] input, char[] output = null);
wchar[] toLower(const(wchar)[] input, wchar[] output = null);
dchar[] toLower(const(dchar)[] input, dchar[] output = null);
char[] toFold(const(char)[] input, char[] output = null);
wchar[] toFold(const(wchar)[] input, wchar[] output = null);
dchar[] toFold(const(dchar)[] input, dchar[] output = null);
bool isDigit(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & UnicodeData.GeneralCategory.Nd;
}
bool isLetter(int ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & (UnicodeData.GeneralCategory.Lu | UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.Lm | UnicodeData.GeneralCategory.Lo);
}
bool isLetterOrDigit(int ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & (UnicodeData.GeneralCategory.Lu | UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.Lm | UnicodeData.GeneralCategory.Lo | UnicodeData.GeneralCategory.Nd);
}
bool isLower(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & UnicodeData.GeneralCategory.Ll;
}
bool isTitle(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & UnicodeData.GeneralCategory.Lt;
}
bool isUpper(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & UnicodeData.GeneralCategory.Lu;
}
bool isWhitespace(dchar ch)
{
if (ch >= 9 && ch <= 13 || ch >= 28 && ch <= 31)
return true;
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & (UnicodeData.GeneralCategory.Zs | UnicodeData.GeneralCategory.Zl | UnicodeData.GeneralCategory.Zp) && ch != 160 && ch != 8239 && ch != 65279;
}
bool isSpace(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && d.generalCategory & (UnicodeData.GeneralCategory.Zs | UnicodeData.GeneralCategory.Zl | UnicodeData.GeneralCategory.Zp);
}
bool isPrintable(dchar ch)
{
UnicodeData* d = getUnicodeData(ch);
return d !is null && !(d.generalCategory & (UnicodeData.GeneralCategory.Cn | UnicodeData.GeneralCategory.Cc | UnicodeData.GeneralCategory.Cf | UnicodeData.GeneralCategory.Co | UnicodeData.GeneralCategory.Cs));
}
debug (UnicodeTest)
{
    void main()
{
}
    debug (UnitTest)
{
            }
}
