// D import file generated from 'tango/text/Util.d'
module tango.text.Util;
template trim(T)
{
T[] trim(T[] source)
{
auto head = source.ptr;
auto tail = head + source.length;
while (head < tail && isSpace(*head))
++head;
while (tail > head && isSpace(*(tail - 1)))
--tail;
return head[0..tail - head];
}
}
template triml(T)
{
T[] triml(T[] source)
{
auto head = source.ptr;
auto tail = head + source.length;
while (head < tail && isSpace(*head))
++head;
return head[0..tail - head];
}
}
template trimr(T)
{
T[] trimr(T[] source)
{
auto head = source.ptr;
auto tail = head + source.length;
while (tail > head && isSpace(*(tail - 1)))
--tail;
return head[0..tail - head];
}
}
template strip(T,S)
{
T[] strip(T[] source, S match)
{
auto head = source.ptr;
auto tail = head + source.length;
while (head < tail && *head is match)
++head;
while (tail > head && *(tail - 1) is match)
--tail;
return head[0..tail - head];
}
}
template stripl(T,S)
{
T[] stripl(T[] source, S match)
{
auto head = source.ptr;
auto tail = head + source.length;
while (head < tail && *head is match)
++head;
return head[0..tail - head];
}
}
template stripr(T,S)
{
T[] stripr(T[] source, S match)
{
auto head = source.ptr;
auto tail = head + source.length;
while (tail > head && *(tail - 1) is match)
--tail;
return head[0..tail - head];
}
}
template chopl(T,S)
{
T[] chopl(T[] source, S match)
{
if (match.length <= source.length)
if (source[0..match.length] == match)
source = source[match.length..$];
return source;
}
}
template chopr(T,S)
{
T[] chopr(T[] source, S match)
{
if (match.length <= source.length)
if (source[$ - match.length..$] == match)
source = source[0..$ - match.length];
return source;
}
}
template replace(T,S)
{
T[] replace(T[] source, S match, S replacement)
{
foreach (ref c; source)
{
if (c is match)
c = replacement;
}
return source;
}
}
template substitute(T)
{
T[] substitute(const(T)[] source, const(T)[] match, const(T)[] replacement)
{
T[] output;
foreach (s; patterns(source,match,replacement))
{
output ~= s;
}
return output;
}
}
template count(T)
{
size_t count(const(T)[] source, const(T)[] match)
{
size_t c;
foreach (s; patterns(source,match))
{
++c;
}
assert(c > 0);
return c - 1;
}
}
template contains(T)
{
bool contains(const(T)[] source, const(T) match)
{
return indexOf(source.ptr,match,source.length) != source.length;
}
}
template containsPattern(T)
{
bool containsPattern(const(T)[] source, const(T)[] match)
{
return locatePattern(source,match) != source.length;
}
}
template index(T,U = size_t)
{
size_t index(const(T)[] source, const(T)[] match, U start = 0)
{
return index!(T)(source,match,start);
}
}
template index(T)
{
size_t index(const(T)[] source, const(T)[] match, size_t start = 0)
{
return match.length is 1 ? locate(source,match[0],start) : locatePattern(source,match,start);
}
}
template rindex(T,U = size_t)
{
size_t rindex(const(T)[] source, const(T)[] match, U start = U.max)
{
return rindex!(T)(source,match,start);
}
}
template rindex(T)
{
size_t rindex(const(T)[] source, const(T)[] match, size_t start = size_t.max)
{
return match.length is 1 ? locatePrior(source,match[0],start) : locatePatternPrior(source,match,start);
}
}
template locate(T,U = size_t)
{
size_t locate(const(T)[] source, const(T) match, U start = 0)
{
return locate!(T)(source,match,start);
}
}
template locate(T)
{
size_t locate(const(T)[] source, const(T) match, size_t start = 0)
{
if (start > source.length)
start = source.length;
return indexOf(source.ptr + start,match,source.length - start) + start;
}
}
template locatePrior(T,U = size_t)
{
size_t locatePrior(const(T)[] source, const(T) match, U start = U.max)
{
return locatePrior!(T)(source,match,start);
}
}
template locatePrior(T)
{
size_t locatePrior(const(T)[] source, const(T) match, size_t start = size_t.max)
{
if (start > source.length)
start = source.length;
while (start > 0)
if (source[--start] is match)
return start;
return source.length;
}
}
template locatePattern(T,U = size_t)
{
size_t locatePattern(const(T)[] source, const(T)[] match, U start = 0)
{
return locatePattern!(T)(source,match,start);
}
}
template locatePattern(T)
{
size_t locatePattern(const(T)[] source, const(T)[] match, size_t start = 0)
{
size_t idx;
const(T)* p = source.ptr + start;
size_t extent = source.length - start - match.length + 1;
if (match.length && extent <= source.length)
{
while (extent)
if ((idx = indexOf(p,match[0],extent)) is extent)
break;
else
if (matching(p += idx,match.ptr,match.length))
return p - source.ptr;
else
{
extent -= idx + 1;
++p;
}
}
return source.length;
}
}
template locatePatternPrior(T,U = size_t)
{
size_t locatePatternPrior(const(T)[] source, const(T)[] match, U start = U.max)
{
return locatePatternPrior!(T)(source,match,start);
}
}
template locatePatternPrior(T)
{
size_t locatePatternPrior(const(T)[] source, const(T)[] match, size_t start = size_t.max)
{
auto len = source.length;
if (start > len)
start = len;
if (match.length && match.length <= len)
while (start)
{
start = locatePrior(source,match[0],start);
if (start is len)
break;
else
if (start + match.length <= len)
if (matching(source.ptr + start,match.ptr,match.length))
return start;
}
return len;
}
}
template head(T,S)
{
T[] head(T[] src, S[] pattern, out T[] tail)
{
auto i = locatePattern(src,pattern);
if (i != src.length)
{
tail = src[i + pattern.length..$];
src = src[0..i];
}
return src;
}
}
template tail(T,S)
{
T[] tail(T[] src, S[] pattern, out T[] head)
{
auto i = locatePatternPrior(src,pattern);
if (i != src.length)
{
head = src[0..i];
src = src[i + pattern.length..$];
}
return src;
}
}
template delimit(T,M)
{
T[][] delimit(T[] src, const(M)[] set)
{
T[][] result;
foreach (segment; delimiters(src,set))
{
result ~= segment;
}
return result;
}
}
template split(T)
{
inout(T)[][] split(inout(T)[] src, const(T)[] pattern)
{
const(T)[][] result;
foreach (segment; patterns(cast(const(T)[])src,pattern))
{
result ~= segment;
}
return cast(inout(T)[][])result;
}
}
alias toLines splitLines;
template toLines(T)
{
T[][] toLines(T[] src)
{
T[][] result;
foreach (line; lines(src))
{
result ~= line;
}
return result;
}
}
template lineOf(T)
{
T[] lineOf(T[] src, size_t index)
{
int i = 0;
foreach (line; lines(src))
{
if (i++ is index)
return line;
}
return null;
}
}
template join(T)
{
T[] join(const(T)[][] src, const(T)[] postfix = null, T[] dst = null)
{
return combine!(T)(dst,null,postfix,src);
}
}
template prefix(T)
{
T[] prefix(T[] dst, const(T)[] prefix, const(T)[][] src...)
{
return combine!(T)(dst,prefix,null,src);
}
}
template postfix(T)
{
T[] postfix(T[] dst, const(T)[] postfix, const(T)[][] src...)
{
return combine!(T)(dst,null,postfix,src);
}
}
template combine(T)
{
T[] combine(T[] dst, const(T)[] prefix, const(T)[] postfix, const(T)[][] src...)
{
size_t len = src.length * prefix.length + src.length * postfix.length;
foreach (segment; src)
{
len += segment.length;
}
if (dst.length < len)
dst.length = len;
T* p = dst.ptr;
foreach (segment; src)
{
p[0..prefix.length] = prefix;
p += prefix.length;
p[0..segment.length] = segment;
p += segment.length;
p[0..postfix.length] = postfix;
p += postfix.length;
}
if (len)
len -= postfix.length;
return dst[0..len];
}
}
template repeat(T,U = size_t)
{
T[] repeat(const(T)[] src, U count, T[] dst = null)
{
return repeat!(T)(src,count,dst);
}
}
template repeat(T)
{
T[] repeat(const(T)[] src, size_t count, T[] dst = null)
{
size_t len = src.length * count;
if (len is 0)
return null;
if (dst.length < len)
dst.length = len;
{
for (auto p = dst.ptr;
 count--; p += src.length)
{
p[0..src.length] = src;
}
}
return dst[0..len];
}
}
template isSpace(T)
{
bool isSpace(T c)
{
static if(T.sizeof is 1)
{
return c <= 32 && (c is ' ' || c is '\x09' || c is '\x0d' || c is '\x0a' || c is '\x0c' || c is '\x0b');
}
else
{
return c <= 32 && (c is ' ' || c is '\x09' || c is '\x0d' || c is '\x0a' || c is '\x0c' || c is '\x0b') || (c is '\U00002028' || c is '\U00002029');
}

}
}
template matching(T,U = size_t)
{
bool matching(const(T)* s1, const(T)* s2, U length)
{
return matching!(T)(s1,s2,length);
}
}
template matching(T)
{
bool matching(const(T)* s1, const(T)* s2, size_t length)
{
return mismatch(s1,s2,length) is length;
}
}
template indexOf(T,U = size_t)
{
size_t indexOf(const(T)* str, const(T) match, U length)
{
return indexOf!(T)(str,match,length);
}
}
template indexOf(T)
{
size_t indexOf(const(T)* str, const(T) match, size_t length)
{
static if(T.sizeof == 1)
{
enum : size_t
{
m1 = cast(size_t)72340172838076673L,
m2 = cast(size_t)9259542123273814144LU,
}
}

static if(T.sizeof == 2)
{
enum : size_t
{
m1 = cast(size_t)281479271743489L,
m2 = cast(size_t)9223512776490647552LU,
}
}

static if(T.sizeof == 4)
{
enum : size_t
{
m1 = cast(size_t)4294967297L,
m2 = cast(size_t)9223372039002259456LU,
}
}

static if(T.sizeof < size_t.sizeof)
{
if (length)
{
size_t m = match;
m += m << 8 * T.sizeof;
static if(T.sizeof < size_t.sizeof / 2)
{
m += m << 8 * T.sizeof * 2;
}

static if(T.sizeof < size_t.sizeof / 4)
{
m += m << 8 * T.sizeof * 4;
}

auto p = str;
auto e = p + length - size_t.sizeof / T.sizeof;
while (p < e)
{
auto v = *cast(size_t*)p ^ m;
if (v - m1 & ~v & m2)
break;
p += size_t.sizeof / T.sizeof;
}
e += size_t.sizeof / T.sizeof;
while (p < e)
if (*p++ is match)
return cast(size_t)(p - str - 1);
}
return length;
}
else
{
auto len = length;
{
for (auto p = str - 1;
 len--;)
{
if (*++p is match)
return cast(size_t)(p - str);
}
}
return length;
}

}
}
template mismatch(T,U = size_t)
{
size_t mismatch(const(T)* s1, const(T)* s2, U length)
{
return mismatch!(T)(s1,s2,length);
}
}
template mismatch(T)
{
size_t mismatch(const(T)* s1, const(T)* s2, size_t length)
{
assert(s1 && s2);
static if(T.sizeof < size_t.sizeof)
{
if (length)
{
auto start = s1;
auto e = start + length - size_t.sizeof / T.sizeof;
while (s1 < e)
{
if (*cast(size_t*)s1 != *cast(size_t*)s2)
break;
s1 += size_t.sizeof / T.sizeof;
s2 += size_t.sizeof / T.sizeof;
}
e += size_t.sizeof / T.sizeof;
while (s1 < e)
if (*s1++ != *s2++)
return s1 - start - 1;
}
return length;
}
else
{
auto len = length;
{
for (auto p = s1 - 1;
 len--;)
{
if (*++p != *s2++)
return p - s1;
}
}
return length;
}

}
}
template lines(T)
{
LineFruct!(T) lines(T[] src)
{
LineFruct!(T) lines;
lines.src = src;
return lines;
}
}
template delimiters(T,M)
{
DelimFruct!(T,M) delimiters(T[] src, const(M)[] set)
{
DelimFruct!(T,M) elements;
elements.set = set;
elements.src = src;
return elements;
}
}
template patterns(T)
{
PatternFruct!(T) patterns(const(T)[] src, const(T)[] pattern, const(T)[] sub = null)
{
PatternFruct!(T) elements;
elements.pattern = pattern;
elements.sub = sub;
elements.src = src;
return elements;
}
}
template quotes(T,M)
{
QuoteFruct!(T,M) quotes(T[] src, const(M)[] set)
{
QuoteFruct!(T,M) quotes;
quotes.set = set;
quotes.src = src;
return quotes;
}
}
template layout(T)
{
T[] layout(T[] output, const(T)[][] layout...)
{
const(T)[] badarg = cast(const(T)[])"{index out of range}";
const(T)[] toosmall = cast(const(T)[])"{output buffer too small}";
size_t pos,args;
bool state;
args = layout.length - 1;
foreach (c; layout[0])
{
if (state)
{
state = false;
if (c >= '0' && c <= '9')
{
size_t index = c - '0';
if (index < args)
{
const(T)[] x = layout[index + 1];
size_t limit = pos + x.length;
if (limit < output.length)
{
output[pos..limit] = x;
pos = limit;
continue;
}
else
return toosmall.dup;
}
else
return badarg.dup;
}
}
else
if (c is '%')
{
state = true;
continue;
}
if (pos < output.length)
{
output[pos] = c;
++pos;
}
else
return toosmall.dup;
}
return output[0..pos];
}
}
template unescape(T)
{
T[] unescape(const(T)[] src, T[] dst = null)
{
size_t delta;
auto s = src.ptr;
auto len = src.length;
if ((delta = indexOf(s,'\x5c',len)) < len)
{
if (dst.length < src.length)
dst.length = src.length;
auto d = dst.ptr;
do
{
d[0..delta] = s[0..delta];
len -= delta;
s += delta;
d += delta;
if (len < 2)
{
*d++ = '\x5c';
len = 0;
break;
}
T c = s[1];
switch (c)
{
case '\x5c':
{
break;
}
case '\'':
{
c = '\'';
break;
}
case '"':
{
c = '"';
break;
}
case 'a':
{
c = '\x07';
break;
}
case 'b':
{
c = '\x08';
break;
}
case 'f':
{
c = '\x0c';
break;
}
case 'n':
{
c = '\x0a';
break;
}
case 'r':
{
c = '\x0d';
break;
}
case 't':
{
c = '\x09';
break;
}
case 'v':
{
c = '\x0b';
break;
}
default:
{
*d++ = '\x5c';
}
}
*d++ = c;
len -= 2;
s += 2;
}
while ((delta = indexOf(s,'\x5c',len)) < len);d[0..len] = s[0..len];
return dst[0..d + len - dst.ptr];
}
return src.dup;
}
}
size_t jhash(const(ubyte)* k, size_t len, size_t c = 0);
size_t jhash(const(void)[] x, size_t c = 0)
{
return jhash(cast(ubyte*)x.ptr,x.length,c);
}
private template LineFruct(T)
{
struct LineFruct
{
    private T[] src;

    int opApply(scope int delegate(ref T[] line) dg)
{
int ret;
size_t pos,mark;
T[] line;
enum T nl = '\x0a';
enum T cr = '\x0d';
while ((pos = locate(src,nl,mark)) < src.length)
{
auto end = pos;
if (end && src[end - 1] is cr)
--end;
line = src[mark..end];
if ((ret = dg(line)) != 0)
return ret;
mark = pos + 1;
}
line = src[mark..$];
if (mark <= src.length)
ret = dg(line);
return ret;
}
}
}

private template DelimFruct(T,M)
{
struct DelimFruct
{
    private T[] src;

    private const(M)[] set;

    int opApply(scope int delegate(ref T[] token) dg)
{
int ret;
size_t pos,mark;
T[] token;
if (set.length is 1)
while ((pos = locate(src,set[0],mark)) < src.length)
{
token = src[mark..pos];
if ((ret = dg(token)) != 0)
return ret;
mark = pos + 1;
}
else
if (set.length > 1)
foreach (i, elem; src)
{
if (contains(set,elem))
{
token = src[mark..i];
if ((ret = dg(token)) != 0)
return ret;
mark = i + 1;
}
}
token = src[mark..$];
if (mark <= src.length)
ret = dg(token);
return ret;
}
}
}

private template PatternFruct(T)
{
struct PatternFruct
{
    private 
{
    const(T)[] src;
    const(T)[] sub;
    const(T)[] pattern;
}
    int opApply(scope int delegate(ref const(T)[] token) dg)
{
int ret;
size_t pos,mark;
const(T)[] token;
while ((pos = index(src,pattern,mark)) < src.length)
{
token = src[mark..pos];
if ((ret = dg(token)) != 0)
return ret;
if (sub.ptr && (ret = dg(sub)) != 0)
return ret;
mark = pos + pattern.length;
}
token = src[mark..$];
if (mark <= src.length)
ret = dg(token);
return ret;
}
}
}

private template QuoteFruct(T,M)
{
struct QuoteFruct
{
    private T[] src;

    private const(M)[] set;

    int opApply(scope int delegate(ref const(T)[] token) dg)
{
int ret;
size_t mark;
T[] token;
if (set.length)
{
for (size_t i = 0;
 i < src.length; ++i)
{
{
T c = src[i];
if (c is '"' || c is '\'')
i = locate(src,c,i + 1);
else
if (contains(set,c))
{
token = src[mark..i];
if ((ret = dg(token)) != 0)
return ret;
mark = i + 1;
}
}
}
}
token = src[mark..$];
if (mark <= src.length)
ret = dg(token);
return ret;
}
}
}

debug (UnitTest)
{
    }
debug (Util)
{
    auto x = import("Util.d");
    void main()
{
mismatch("".ptr,S(x).ptr,0);
indexOf("".ptr,'@',0);
char[] s;
split(s," ");
}
}
