// D import file generated from 'tango/text/convert/Layout.d'
module tango.text.convert.Layout;
private import tango.core.Exception;

private import Utf = tango.text.convert.Utf;

private 
{
    import Float = tango.text.convert.Float;
    import Integer = tango.text.convert.Integer;
}
private import tango.io.model.IConduit;

version (WithVariant)
{
    private import tango.core.Variant;

}
version (WithExtensions)
{
    private import tango.text.convert.Extensions;

}
else
{
    version (WithDateTime)
{
    private import tango.time.Time;

    private import tango.text.convert.DateTime;

}
}
version (GNU)
{
    private import tango.core.Vararg;

    alias void* Arg;
    alias va_list ArgList;
}
else
{
    version (LDC)
{
    private import tango.core.Vararg;

    alias void* Arg;
    alias va_list ArgList;
}
else
{
    version (DigitalMars)
{
    private import tango.core.Vararg;

    alias void* Arg;
    alias va_list ArgList;
    version (X86_64)
{
    version = DigitalMarsX64;
}
}
else
{
    alias void* Arg;
    alias void* ArgList;
}
}
}
template Layout(T)
{
class Layout
{
    public alias convert opCall;

    public alias size_t delegate(const(T)[]) Sink;

    static if(is(DateTimeLocale))
{
    private DateTimeLocale* dateTime = &DateTimeDefault;

}
    @property static Layout instance()
{
static __gshared Layout common;
if (common is null)
common = new Layout!(T);
return common;
}


    public final T[] sprint(T[] result, const(T)[] formatStr,...)
{
version (DigitalMarsX64)
{
va_list ap;
va_start(ap,__va_argsave);
scope(exit) va_end(ap);
return vprint(result,formatStr,_arguments,ap);
}
else
{
return vprint(result,formatStr,_arguments,_argptr);
}

}


    public final T[] vprint(T[] result, const(T)[] formatStr, TypeInfo[] arguments, ArgList args)
{
T* p = result.ptr;
auto available = result.length;
size_t sink(const(T)[] s)
{
auto len = s.length;
if (len > available)
len = available;
available -= len;
p[0..len] = s[0..len];
p += len;
return len;
}
convert(&sink,arguments,args,formatStr);
return result[0..cast(size_t)(p - result.ptr)];
}


    public final T[] convert(const(T)[] formatStr,...)
{
version (DigitalMarsX64)
{
va_list ap;
va_start(ap,__va_argsave);
scope(exit) va_end(ap);
return convert(_arguments,ap,formatStr);
}
else
{
return convert(_arguments,_argptr,formatStr);
}

}


    public final uint convert(Sink sink, const(T)[] formatStr,...)
{
version (DigitalMarsX64)
{
va_list ap;
va_start(ap,__va_argsave);
scope(exit) va_end(ap);
return convert(sink,_arguments,ap,formatStr);
}
else
{
return convert(sink,_arguments,_argptr,formatStr);
}

}


    public final uint convert(OutputStream output, const(T)[] formatStr,...)
{
size_t sink(const(T)[] s)
{
return output.write(s);
}
version (DigitalMarsX64)
{
va_list ap;
va_start(ap,__va_argsave);
scope(exit) va_end(ap);
return convert(&sink,_arguments,ap,formatStr);
}
else
{
return convert(&sink,_arguments,_argptr,formatStr);
}

}


    public final T[] convert(TypeInfo[] arguments, ArgList args, const(T)[] formatStr)
{
T[] output;
size_t sink(const(T)[] s)
{
output ~= s;
return s.length;
}
convert(&sink,arguments,args,formatStr);
return output;
}


    version (old)
{
    public final T[] convertOne(T[] result, TypeInfo ti, Arg arg)
{
return dispatch(result,null,ti,arg);
}


}
    public final uint convert(Sink sink, TypeInfo[] arguments, ArgList args, const(T)[] formatStr)
{
assert(formatStr,"null format specifier");
assert(arguments.length < 64,"too many args in Layout.convert");
version (GNU)
{
union ArgU
{
    int i;
    byte b;
    long l;
    short s;
    void[] a;
    real r;
    float f;
    double d;
    cfloat cf;
    cdouble cd;
    creal cr;
}
Arg[64] arglist = void;
ArgU[64] storedArgs = void;
foreach (i, arg; arguments)
{
static if(is(typeof(args.ptr)))
{
arglist[i] = args.ptr;
}
else
{
arglist[i] = args;
}

bool converted = false;
switch (arg.classinfo.name[9])
{
case TypeCode.FLOAT:
case TypeCode.IFLOAT:
{
storedArgs[i].f = va_arg!(float)(args);
arglist[i] = &storedArgs[i].f;
converted = true;
break;
}
case TypeCode.CFLOAT:
{
storedArgs[i].cf = va_arg!(cfloat)(args);
arglist[i] = &storedArgs[i].cf;
converted = true;
break;
}
case TypeCode.DOUBLE:
case TypeCode.IDOUBLE:
{
storedArgs[i].d = va_arg!(double)(args);
arglist[i] = &storedArgs[i].d;
converted = true;
break;
}
case TypeCode.CDOUBLE:
{
storedArgs[i].cd = va_arg!(cdouble)(args);
arglist[i] = &storedArgs[i].cd;
converted = true;
break;
}
case TypeCode.REAL:
case TypeCode.IREAL:
{
storedArgs[i].r = va_arg!(real)(args);
arglist[i] = &storedArgs[i].r;
converted = true;
break;
}
case TypeCode.CREAL:
{
storedArgs[i].cr = va_arg!(creal)(args);
arglist[i] = &storedArgs[i].cr;
converted = true;
break;
}
default:
{
break;
}
}
if (!converted)
{
switch (arg.tsize)
{
case 1:
{
storedArgs[i].b = va_arg!(byte)(args);
arglist[i] = &storedArgs[i].b;
break;
}
case 2:
{
storedArgs[i].s = va_arg!(short)(args);
arglist[i] = &storedArgs[i].s;
break;
}
case 4:
{
storedArgs[i].i = va_arg!(int)(args);
arglist[i] = &storedArgs[i].i;
break;
}
case 8:
{
storedArgs[i].l = va_arg!(long)(args);
arglist[i] = &storedArgs[i].l;
break;
}
case 16:
{
assert((void[]).sizeof == 16,"Structure size not supported");
storedArgs[i].a = va_arg!(void[])(args);
arglist[i] = &storedArgs[i].a;
break;
}
default:
{
assert(false,"Unknown size: " ~ Integer.toString(arg.tsize));
}
}
}
}
}
else
{
version (DigitalMarsX64)
{
Arg[64] arglist = void;
void[] buffer;
uint len = 0;
foreach (i, argType; arguments)
{
len += argType.tsize + size_t.sizeof - 1 & ~(size_t.sizeof - 1);
}
buffer.length = len;
len = 0;
foreach (i, argType; arguments)
{
va_arg(args,argType,buffer.ptr + len);
if (argType.classinfo.name.length != 25 && argType.classinfo.name[9] == TypeCode.ARRAY && (argType.classinfo.name[10] == TypeCode.USHORT || argType.classinfo.name[10] == TypeCode.SHORT))
{
printf("Warning: (u)short[] is broken for varargs in x86_64");
(cast(short[]*)(buffer.ptr + len)).length = 0;
}
arglist[i] = &buffer[len];
len += argType.tsize + size_t.sizeof - 1 & ~(size_t.sizeof - 1);
}
scope(exit) delete buffer;
}
else
{
Arg[64] arglist = void;
foreach (i, arg; arguments)
{
arglist[i] = args;
args += arg.tsize + size_t.sizeof - 1 & ~(size_t.sizeof - 1);
}
}

}

return parse(formatStr,arguments,arglist,sink);
}


    private uint parse(const(T)[] layout, TypeInfo[] ti, Arg[] args, Sink sink)
{
T[512] result = void;
int length,nextIndex;
const(T)* s = layout.ptr;
const(T)* fragment = s;
const(T)* end = s + layout.length;
while (true)
{
while (s < end && *s != '{')
++s;
length += sink(fragment[0..cast(size_t)(s - fragment)]);
if (s is end)
break;
if (*++s is '{')
{
fragment = s++;
continue;
}
int index = 0;
bool indexed = false;
while (*s >= '0' && *s <= '9')
{
index = index * 10 + *s++ - '0';
indexed = true;
}
while (s < end && *s is ' ')
++s;
bool crop;
bool left;
bool right;
int width;
if (*s is ',' || *s is '.')
{
if (*s is '.')
crop = true;
while (++s < end && *s is ' ')
{
}
if (*s is '-')
{
left = true;
++s;
}
else
right = true;
while (*s >= '0' && *s <= '9')
width = width * 10 + *s++ - '0';
while (s < end && *s is ' ')
++s;
}
const(T)[] format;
if (*s is ':' && s < end)
{
const(T)* fs = ++s;
while (s < end && *s != '}')
++s;
format = fs[0..cast(size_t)(s - fs)];
}
if (*s != '}')
{
length += sink("{malformed format}");
continue;
}
if (!indexed)
index = nextIndex;
nextIndex = index + 1;
fragment = ++s;
void emit(const(T)[] str)
{
int padding = width - cast(int)str.length;
if (crop)
{
if (padding < 0)
{
if (left)
{
length += sink("...");
length += sink(Utf.cropLeft(str[-padding..$]));
}
else
{
length += sink(Utf.cropRight(str[0..width]));
length += sink("...");
}
}
else
length += sink(str);
}
else
{
if (right && padding > 0)
length += spaces(sink,padding);
length += sink(str);
if (left && padding > 0)
length += spaces(sink,padding);
}
}
void process(TypeInfo _ti, Arg _arg)
{
if (_ti.classinfo.name.length is 14 && _ti.classinfo.name[9..$] == "Const" || _ti.classinfo.name.length is 18 && _ti.classinfo.name[9..$] == "Invariant" || _ti.classinfo.name.length is 15 && _ti.classinfo.name[9..$] == "Shared" || _ti.classinfo.name.length is 14 && _ti.classinfo.name[9..$] == "Inout")
{
process((cast(TypeInfo_Const)_ti).next,_arg);
return ;
}
version (WithVariant)
{
if (_ti is typeid(Variant))
{
auto vptr = cast(Variant*)_arg;
auto innerTi = vptr.type;
auto innerArg = vptr.ptr;
process(innerTi,innerArg);
}
}

if (_ti.classinfo.name.length is 20 && _ti.classinfo.name[9..$] == "StaticArray")
{
auto tiStat = cast(TypeInfo_StaticArray)_ti;
auto p = _arg;
length += sink("[");
{
for (int i = 0;
 i < tiStat.len; i++)
{
{
if (p !is _arg)
length += sink(", ");
process(tiStat.value,p);
p += tiStat.tsize / tiStat.len;
}
}
}
length += sink("]");
}
else
if (_ti.classinfo.name.length is 25 && _ti.classinfo.name[9..$] == "AssociativeArray")
{
auto tiAsso = cast(TypeInfo_AssociativeArray)_ti;
auto tiKey = tiAsso.key;
auto tiVal = tiAsso.next();
alias ubyte AV;
alias ubyte AK;
auto aa = *cast(AV[AK]*)_arg;
length += sink("{");
bool first = true;
size_t roundUp(size_t tsize)
{
version (X86_64)
{
return tsize + 15 & ~15;
}
else
{
return tsize + size_t.sizeof - 1 & ~(size_t.sizeof - 1);
}

}
foreach (ref v; aa)
{
auto pk = cast(Arg)(&v - roundUp(AK.sizeof));
auto pv = cast(Arg)(pk + roundUp(tiKey.tsize()));
if (!first)
length += sink(", ");
process(tiKey,pk);
length += sink(" => ");
process(tiVal,pv);
first = false;
}
length += sink("}");
}
else
if (_ti.classinfo.name[9] is TypeCode.ARRAY)
{
if (_ti is typeid(char[]) || _ti is typeid(immutable(char)[]) || _ti is typeid(const(char)[]))
emit(Utf.fromString8(*cast(char[]*)_arg,result));
else
if (_ti is typeid(wchar[]) || _ti is typeid(immutable(wchar)[]) || _ti is typeid(const(wchar)[]))
emit(Utf.fromString16(*cast(wchar[]*)_arg,result));
else
if (_ti is typeid(dchar[]) || _ti is typeid(immutable(dchar)[]) || _ti is typeid(const(dchar)[]))
emit(Utf.fromString32(*cast(dchar[]*)_arg,result));
else
{
auto arr = *cast(void[]*)_arg;
auto len = arr.length;
auto ptr = cast(Arg)arr.ptr;
auto elTi = _ti.next();
auto size = elTi.tsize();
length += sink("[");
while (len > 0)
{
if (ptr !is arr.ptr)
length += sink(", ");
process(elTi,ptr);
len -= 1;
ptr += size;
}
length += sink("]");
}
}
else
emit(dispatch(result,format,_ti,_arg));
}
if (index >= ti.length)
emit("{invalid index}");
else
process(ti[index],args[index]);
}
return length;
}

    private T[] dispatch(T[] result, const(T)[] format, TypeInfo type, Arg p)
{
switch (type.classinfo.name[9])
{
case TypeCode.BOOL:
{
enum T[] t = cast(T[])"true";
enum T[] f = cast(T[])"false";
return *cast(bool*)p ? t : f;
}
case TypeCode.BYTE:
{
return integer(result,*cast(byte*)p,format,(ubyte).max);
}
case TypeCode.VOID:
{
}
case TypeCode.UBYTE:
{
return integer(result,*cast(ubyte*)p,format,(ubyte).max,"u");
}
case TypeCode.SHORT:
{
return integer(result,*cast(short*)p,format,(ushort).max);
}
case TypeCode.USHORT:
{
return integer(result,*cast(ushort*)p,format,(ushort).max,"u");
}
case TypeCode.INT:
{
return integer(result,*cast(int*)p,format,(uint).max);
}
case TypeCode.UINT:
{
return integer(result,*cast(uint*)p,format,(uint).max,"u");
}
case TypeCode.ULONG:
{
return integer(result,*cast(long*)p,format,(ulong).max,"u");
}
case TypeCode.LONG:
{
return integer(result,*cast(long*)p,format,(ulong).max);
}
case TypeCode.FLOAT:
{
return floater(result,*cast(float*)p,format);
}
case TypeCode.IFLOAT:
{
return imaginary(result,*cast(ifloat*)p,format);
}
case TypeCode.IDOUBLE:
{
return imaginary(result,*cast(idouble*)p,format);
}
case TypeCode.IREAL:
{
return imaginary(result,*cast(ireal*)p,format);
}
case TypeCode.CFLOAT:
{
return complex(result,*cast(cfloat*)p,format);
}
case TypeCode.CDOUBLE:
{
return complex(result,*cast(cdouble*)p,format);
}
case TypeCode.CREAL:
{
return complex(result,*cast(creal*)p,format);
}
case TypeCode.DOUBLE:
{
return floater(result,*cast(double*)p,format);
}
case TypeCode.REAL:
{
return floater(result,*cast(real*)p,format);
}
case TypeCode.CHAR:
{
return Utf.fromString8((cast(char*)p)[0..1],result);
}
case TypeCode.WCHAR:
{
return Utf.fromString16((cast(wchar*)p)[0..1],result);
}
case TypeCode.DCHAR:
{
return Utf.fromString32((cast(dchar*)p)[0..1],result);
}
case TypeCode.POINTER:
{
return integer(result,*cast(size_t*)p,format,size_t.max,"x");
}
case TypeCode.CLASS:
{
auto c = *cast(Object*)p;
if (c)
return cast(T[])Utf.fromString8(c.toString(),result);
break;
}
case TypeCode.STRUCT:
{
auto s = cast(TypeInfo_Struct)type;
if (s.xtoString)
{
char[] delegate() toString;
toString.ptr = p;
toString.funcptr = cast(char[] function())s.xtoString;
return Utf.fromString8(toString(),result);
}
goto default;
}
case TypeCode.INTERFACE:
{
auto x = *cast(void**)p;
if (x)
{
auto pi = **cast(Interface***)x;
auto o = cast(Object)(*cast(void**)p - pi.offset);
return cast(T[])Utf.fromString8(o.toString(),result);
}
break;
}
case TypeCode.ENUM:
{
return dispatch(result,format,(cast(TypeInfo_Enum)type).base,p);
}
default:
{
return unknown(result,format,type,p);
}
}
return cast(T[])"{null}";
}

    protected T[] unknown(T[] result, const(T)[] format, TypeInfo type, Arg p)
{
version (WithExtensions)
{
result = Extensions!(T).run(type,result,p,format);
return result ? result : "{unhandled argument type: " ~ Utf.fromString8(type.toString,result) ~ "}";
}
else
{
version (WithDateTime)
{
if (type is typeid(Time))
{
static if(is(T == char))
{
return dateTime.format(result,*cast(Time*)p,format);
}
else
{
char[128] tmp0 = void;
char[128] tmp1 = void;
return Utf.fromString8(dateTime.format(tmp0,*cast(Time*)p,Utf.toString(format,tmp1)),result);
}

}
}

}

return cast(T[])"{unhandled argument type: " ~ cast(T[])Utf.fromString8(type.toString(),result) ~ cast(T[])"}";
}

    protected T[] integer(T[] output, long v, const(T)[] format, ulong mask = (ulong).max, const(T)[] def = "d")
{
if (format.length is 0)
format = def;
if (format[0] != 'd')
v &= mask;
return Integer.format(output,v,format);
}

    protected T[] floater(T[] output, real v, const(T)[] format)
{
uint dec = 2,exp = 10;
bool pad = true;
{
for (auto p = format.ptr,e = p + format.length; p < e; ++p)
{
switch (*p)
{
case '.':
{
pad = false;
break;
}
case 'e':
{
}
case 'E':
{
exp = 0;
break;
}
case 'x':
{
}
case 'X':
{
double d = v;
return integer(output,*cast(long*)&d,"x#");
}
default:
{
auto c = cast(T)*p;
if (c >= '0' && c <= '9')
{
dec = c - '0' , c = p[1];
if (c >= '0' && c <= '9' && ++p < e)
dec = dec * 10 + c - '0';
}
break;
}
}
}
}
return Float.format(output,v,dec,exp,pad);
}

    private void error(char[] msg)
{
throw new IllegalArgumentException(cast(immutable(char)[])msg);
}

    private size_t spaces(Sink sink, int count)
{
size_t ret;
enum immutable(T)[] Spaces = "                                ";
while (count > Spaces.length)
{
ret += sink(Spaces);
count -= Spaces.length;
}
return ret + sink(Spaces[0..count]);
}

    private T[] imaginary(T[] result, ireal val, const(T)[] format)
{
return floatingTail(result,val.im,format,"*1i");
}

    private T[] complex(T[] result, creal val, const(T)[] format)
{
static bool signed(real x)
{
static if((real).sizeof is 4)
{
return (*cast(uint*)&x & -2147483648u) != 0;
}
else
{
static if((real).sizeof is 8)
{
return (*cast(ulong*)&x & 9223372036854775808LU) != 0;
}
else
{
auto pe = cast(ubyte*)&x;
return (pe[9] & 128) != 0;
}

}

}
enum immutable(T)[] plus = "+";
auto len = floatingTail(result,val.re,format,signed(val.im) ? null : plus).length;
return result[0..len + floatingTail(result[len..$],val.im,format,"*1i").length];
}

    private T[] floatingTail(T[] result, real val, const(T)[] format, const(T)[] tail)
{
assert(result.length > tail.length);
auto res = floater(result[0..$ - tail.length],val,format);
auto len = res.length;
if (res.ptr !is result.ptr)
result[0..len] = res;
result[len..len + tail.length] = tail;
return result[0..len + tail.length];
}

}
}
private enum TypeCode 
{
EMPTY = 0,
VOID = 'v',
BOOL = 'b',
UBYTE = 'h',
BYTE = 'g',
USHORT = 't',
SHORT = 's',
UINT = 'k',
INT = 'i',
ULONG = 'm',
LONG = 'l',
REAL = 'e',
FLOAT = 'f',
DOUBLE = 'd',
CHAR = 'a',
WCHAR = 'u',
DCHAR = 'w',
ARRAY = 'A',
CLASS = 'C',
STRUCT = 'S',
ENUM = 'E',
CONST = 'x',
INVARIANT = 'y',
DELEGATE = 'D',
FUNCTION = 'F',
POINTER = 'P',
INTERFACE = 'I',
CFLOAT = 'q',
CDOUBLE = 'r',
CREAL = 'c',
IFLOAT = 'o',
IDOUBLE = 'p',
IREAL = 'j',
}

import tango.stdc.stdio;
debug (UnitTest)
{
    }
debug (Layout)
{
    import tango.io.Console;
    static if(is(typeof(Time)))
{
    import tango.time.WallClock;
}
    void main();
}
