// D import file generated from 'tango/text/convert/TimeStamp.d'
module tango.text.convert.TimeStamp;
private import tango.time.Time;

private import tango.core.Exception;

private import Util = tango.text.Util;

private import tango.time.chrono.Gregorian;

private import Integer = tango.text.convert.Integer;

template toTime(T)
{
ulong toTime(T[] src)
{
uint len;
auto x = parse(src,&len);
if (len < src.length)
throw new IllegalArgumentException("unknown time format: " ~ src.idup);
return x;
}
}
char[] toString(Time time)
{
char[32] tmp = void;
return format(tmp,time).dup;
}
wchar[] toString16(Time time)
{
wchar[32] tmp = void;
return format(tmp,time).dup;
}
dchar[] toString32(Time time)
{
dchar[32] tmp = void;
return format(tmp,time).dup;
}
template format(T,U = Time)
{
T[] format(T[] output, U t)
{
return format!(T)(output,cast(Time)t);
}
}
template format(T)
{
T[] format(T[] output, Time t)
{
enum const(T)[][] Months = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
enum const(T)[][] Days = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
T[] convert(T[] tmp, long i)
{
return Integer.formatter!(T)(tmp,i,'u',0,8);
}
assert(output.length >= 29);
if (t is t.max)
throw new IllegalArgumentException("TimeStamp.format :: invalid Time argument");
auto time = t.time;
auto date = Gregorian.generic.toDate(t);
T[14] tmp = void;
return Util.layout(output,cast(const(T)[])"%0, %1 %2 %3 %4:%5:%6 GMT",Days[date.dow],convert(tmp[0..2],date.day),Months[date.month - 1],convert(tmp[2..6],date.year),convert(tmp[6..8],time.hours),convert(tmp[8..10],time.minutes),convert(tmp[10..12],time.seconds));
}
}
template format8601(T,U = Time)
{
T[] format8601(T[] output, U t)
{
return format!(T)(output,cast(Time)t);
}
}
template format8601(T)
{
T[] format8601(T[] output, Time t)
{
T[] convert(T[] tmp, long i)
{
return Integer.formatter!(T)(tmp,i,'u',0,8);
}
assert(output.length >= 29);
if (t is t.max)
throw new IllegalArgumentException("TimeStamp.format :: invalid Time argument");
auto time = t.time;
auto date = Gregorian.generic.toDate(t);
T[20] tmp = void;
return Util.layout(output,cast(const(T)[])"%0-%1-%2T%3%:%4:%5Z",convert(tmp[0..4],date.year),convert(tmp[4..6],date.month),convert(tmp[6..8],date.day),convert(tmp[8..10],time.hours),convert(tmp[10..12],time.minutes),convert(tmp[12..14],time.seconds));
}
}
template parse(T)
{
Time parse(T[] src, size_t* ate = null)
{
size_t len;
Time value;
if ((len = rfc1123(src,value)) > 0 || (len = rfc850(src,value)) > 0 || (len = iso8601(src,value)) > 0 || (len = dostime(src,value)) > 0 || (len = asctime(src,value)) > 0)
{
if (ate)
*ate = len;
return value;
}
return Time.max;
}
}
template parse(T)
{
bool parse(T[] src, ref TimeOfDay tod, ref Date date, size_t* ate = null)
{
size_t len;
if ((len = rfc1123(src,tod,date)) > 0 || (len = rfc850(src,tod,date)) > 0 || (len = iso8601(src,tod,date)) > 0 || (len = dostime(src,tod,date)) > 0 || (len = asctime(src,tod,date)) > 0)
{
if (ate)
*ate = len;
return true;
}
return false;
}
}
template rfc1123(T)
{
size_t rfc1123(T[] src, ref Time value)
{
TimeOfDay tod;
Date date;
auto r = rfc1123!(T)(src,tod,date);
if (r)
value = Gregorian.generic.toTime(date,tod);
return r;
}
}
template rfc1123(T)
{
size_t rfc1123(T[] src, ref TimeOfDay tod, ref Date date)
{
T* p = src.ptr;
T* e = p + src.length;
bool dt(ref T* p)
{
return (date.day = parseInt(p,e)) > 0 && *p++ == ' ' && (date.month = parseMonth(p)) > 0 && *p++ == ' ' && (date.year = parseInt(p,e)) > 0;
}
if (parseShortDay(p) >= 0 && *p++ == ',' && *p++ == ' ' && dt(p) && *p++ == ' ' && time(tod,p,e) && *p++ == ' ' && p[0..3] == "GMT")
{
return cast(size_t)(p + 3 - src.ptr);
}
return 0;
}
}
template rfc850(T)
{
size_t rfc850(T[] src, ref Time value)
{
TimeOfDay tod;
Date date;
auto r = rfc850!(T)(src,tod,date);
if (r)
value = Gregorian.generic.toTime(date,tod);
return r;
}
}
template rfc850(T)
{
size_t rfc850(T[] src, ref TimeOfDay tod, ref Date date)
{
T* p = src.ptr;
T* e = p + src.length;
bool dt(ref T* p)
{
return (date.day = parseInt(p,e)) > 0 && *p++ == '-' && (date.month = parseMonth(p)) > 0 && *p++ == '-' && (date.year = parseInt(p,e)) > 0;
}
if (parseFullDay(p) >= 0 && *p++ == ',' && *p++ == ' ' && dt(p) && *p++ == ' ' && time(tod,p,e) && *p++ == ' ' && p[0..3] == "GMT")
{
if (date.year < 70)
date.year += 2000;
else
if (date.year < 100)
date.year += 1900;
return cast(size_t)(p + 3 - src.ptr);
}
return 0;
}
}
template asctime(T)
{
size_t asctime(T[] src, ref Time value)
{
TimeOfDay tod;
Date date;
auto r = asctime!(T)(src,tod,date);
if (r)
value = Gregorian.generic.toTime(date,tod);
return r;
}
}
template asctime(T)
{
size_t asctime(T[] src, ref TimeOfDay tod, ref Date date)
{
T* p = src.ptr;
T* e = p + src.length;
bool dt(ref T* p)
{
return (date.month = parseMonth(p)) > 0 && *p++ == ' ' && ((date.day = parseInt(p,e)) > 0 || *p++ == ' ' && (date.day = parseInt(p,e)) > 0);
}
if (parseShortDay(p) >= 0 && *p++ == ' ' && dt(p) && *p++ == ' ' && time(tod,p,e) && *p++ == ' ' && (date.year = parseInt(p,e)) > 0)
{
return cast(size_t)(p - src.ptr);
}
return 0;
}
}
template dostime(T)
{
size_t dostime(T[] src, ref Time value)
{
TimeOfDay tod;
Date date;
auto r = dostime!(T)(src,tod,date);
if (r)
value = Gregorian.generic.toTime(date,tod);
return r;
}
}
template dostime(T)
{
size_t dostime(T[] src, ref TimeOfDay tod, ref Date date)
{
T* p = src.ptr;
T* e = p + src.length;
bool dt(ref T* p)
{
return (date.month = parseInt(p,e)) > 0 && *p++ == '-' && ((date.day = parseInt(p,e)) > 0 && (*p++ == '-' && (date.year = parseInt(p,e)) > 0));
}
if (dt(p) >= 0 && *p++ == ' ' && (tod.hours = parseInt(p,e)) > 0 && *p++ == ':' && (tod.minutes = parseInt(p,e)) > 0 && (*p == 'A' || *p == 'P'))
{
if (*p is 'P')
tod.hours += 12;
if (date.year < 70)
date.year += 2000;
else
if (date.year < 100)
date.year += 1900;
return cast(size_t)(p + 2 - src.ptr);
}
return 0;
}
}
template iso8601(T)
{
size_t iso8601(T[] src, ref Time value)
{
TimeOfDay tod;
Date date;
size_t r = iso8601!(T)(src,tod,date);
if (r)
value = Gregorian.generic.toTime(date,tod);
return r;
}
}
template iso8601(T)
{
size_t iso8601(T[] src, ref TimeOfDay tod, ref Date date)
{
T* p = src.ptr;
T* e = p + src.length;
bool dt(ref T* p)
{
return (date.year = parseInt(p,e)) > 0 && *p++ == '-' && ((date.month = parseInt(p,e)) > 0 && (*p++ == '-' && (date.day = parseInt(p,e)) > 0));
}
if (dt(p) >= 0 && *p++ == ' ' && time(tod,p,e))
{
if (p - src.ptr)
{
T frac_sep = *p++;
if (frac_sep is ',' || frac_sep is '.')
tod.millis = parseInt(p,e);
else
return 0;
}
else
tod.millis = 0;
return cast(size_t)(p - src.ptr);
}
return 0;
}
}
private template time(T)
{
bool time(ref TimeOfDay time, ref T* p, T* e)
{
return (time.hours = parseInt(p,e)) >= 0 && *p++ == ':' && (time.minutes = parseInt(p,e)) >= 0 && *p++ == ':' && (time.seconds = parseInt(p,e)) >= 0;
}
}

private template parseMonth(T)
{
int parseMonth(ref T* p)
{
int month;
switch (p[0..3])
{
case "Jan":
{
month = 1;
break;
}
case "Feb":
{
month = 2;
break;
}
case "Mar":
{
month = 3;
break;
}
case "Apr":
{
month = 4;
break;
}
case "May":
{
month = 5;
break;
}
case "Jun":
{
month = 6;
break;
}
case "Jul":
{
month = 7;
break;
}
case "Aug":
{
month = 8;
break;
}
case "Sep":
{
month = 9;
break;
}
case "Oct":
{
month = 10;
break;
}
case "Nov":
{
month = 11;
break;
}
case "Dec":
{
month = 12;
break;
}
default:
{
return month;
}
}
p += 3;
return month;
}
}

private template parseShortDay(T)
{
int parseShortDay(ref T* p)
{
int day;
switch (p[0..3])
{
case "Sun":
{
day = 0;
break;
}
case "Mon":
{
day = 1;
break;
}
case "Tue":
{
day = 2;
break;
}
case "Wed":
{
day = 3;
break;
}
case "Thu":
{
day = 4;
break;
}
case "Fri":
{
day = 5;
break;
}
case "Sat":
{
day = 6;
break;
}
default:
{
return -1;
}
}
p += 3;
return day;
}
}

private template parseFullDay(T)
{
int parseFullDay(ref T* p)
{
static const(T)[][] days = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
foreach (i, day; days)
{
if (day == p[0..day.length])
{
p += day.length;
return cast(int)i;
}
}
return -1;
}
}

private static template parseInt(T)
{
int parseInt(ref T* p, T* e)
{
int value;
while (p < e && (*p >= '0' && *p <= '9'))
value = value * 10 + *p++ - '0';
return value;
}
}


debug (UnitTest)
{
    }
debug (TimeStamp)
{
    void main()
{
Time t;
auto dos = "12-31-06 08:49AM";
auto iso = "2006-01-31 14:49:30,001";
assert(dostime(dos,t) == dos.length);
assert(iso8601(iso,t) == iso.length);
wchar[30] tmp;
wchar[] test = "Sun, 06 Nov 1994 08:49:37 GMT";
auto time = parse(test);
auto text = format(tmp,time);
assert(text == test);
}
}
