// D import file generated from 'tango/text/json/JsonEscape.d'
module tango.text.json.JsonEscape;
private import tango.text.json.JsonParser;

private import Util = tango.text.Util;

private import Utf = tango.text.convert.Utf;

template unescape(T)
{
T[] unescape(const(T)[] src, T[] dst = null)
{
size_t content;
void append(const(T)[] s)
{
if (content + s.length > dst.length)
dst.length = dst.length + s.length + 1024;
dst[content..content + s.length] = s;
content += s.length;
}
unescape(src,&append);
return dst[0..content];
}
}
template escape(T)
{
T[] escape(const(T)[] src, T[] dst = null)
{
size_t content;
void append(const(T)[] s)
{
if (content + s.length > dst.length)
dst.length = dst.length + s.length + 1024;
dst[content..content + s.length] = s;
content += s.length;
}
escape(src,&append);
return dst[0..content];
}
}
template unescape(T)
{
void unescape(const(T)[] src, scope void delegate(const(T)[]) emit)
{
size_t delta;
auto s = src.ptr;
auto len = src.length;
enum : T
{
slash = '\x5c',
}
if ((delta = Util.indexOf(s,slash,len)) < len)
{
do
{
emit(s[0..delta]);
len -= delta;
s += delta;
if (len < 2)
{
emit("\\");
len = 0;
break;
}
switch (s[1])
{
case '\x5c':
{
emit("\\");
break;
}
case '/':
{
emit("/");
break;
}
case '"':
{
emit("\"");
break;
}
case 'b':
{
emit("\x08");
break;
}
case 'f':
{
emit("\x0c");
break;
}
case 'n':
{
emit("\x0a");
break;
}
case 'r':
{
emit("\x0d");
break;
}
case 't':
{
emit("\x09");
break;
}
case 'u':
{
if (len < 6)
goto default;
else
{
dchar v = 0;
T[6] t = void;
{
for (auto i = 2;
 i < 6; ++i)
{
{
T c = s[i];
if (c >= '0' && c <= '9')
{
}
else
if (c >= 'a' && c <= 'f')
c -= 39;
else
if (c >= 'A' && c <= 'F')
c -= 7;
else
goto default;
v = (v << 4) + c - '0';
}
}
}
emit(Utf.fromString32((&v)[0..1],t));
len -= 4;
s += 4;
}
break;
}
default:
{
throw new Exception("invalid escape");
}
}
s += 2;
len -= 2;
}
while ((delta = Util.indexOf(s,slash,len)) < len);emit(s[0..len]);
}
else
emit(src);
}
}
template escape(T)
{
void escape(const(T)[] src, scope void delegate(const(T)[]) emit)
{
T[2] patch = '\x5c';
auto s = src.ptr;
auto t = s;
auto e = s + src.length;
while (s < e)
{
switch (*s)
{
case '"':
{
}
case '/':
{
}
case '\x5c':
{
patch[1] = *s;
break;
}
case '\x0d':
{
patch[1] = 'r';
break;
}
case '\x0a':
{
patch[1] = 'n';
break;
}
case '\x09':
{
patch[1] = 't';
break;
}
case '\x08':
{
patch[1] = 'b';
break;
}
case '\x0c':
{
patch[1] = 'f';
break;
}
default:
{
++s;
continue;
}
}
emit(t[0..s - t]);
emit(patch);
t = ++s;
}
if (t is src.ptr)
emit(src);
else
emit(t[0..e - t]);
}
}
debug (JsonEscape)
{
    import tango.io.Stdout;
    void main();
}
