// D import file generated from 'tango/text/locale/Collation.d'
module tango.text.locale.Collation;
private import tango.text.locale.Core;

version (Windows)
{
    private import tango.text.locale.Win32;

}
else
{
    version (Posix)
{
    private import tango.text.locale.Posix;

}
}
public class StringComparer
{
    private static StringComparer invariant_;


    private static StringComparer invariantIgnoreCase_;


    private Culture culture_;

    private bool ignoreCase_;

    shared static this();
    public this(Culture culture, bool ignoreCase)
{
culture_ = culture;
ignoreCase_ = ignoreCase;
}

    public int compare(const(char)[] strA, const(char)[] strB)
{
return nativeMethods.compareString(culture_.id,strA,0,strA.length,strB,0,strB.length,ignoreCase_);
}

    public bool equals(const(char)[] strA, const(char)[] strB)
{
return compare(strA,strB) == 0;
}

    public static StringComparer currentCulture()
{
return new StringComparer(Culture.current,false);
}


    public static StringComparer currentCultureIgnoreCase()
{
return new StringComparer(Culture.current,true);
}


    public static StringComparer invariantCulture()
{
return invariant_;
}


    public static StringComparer invariantCultureIgnoreCase()
{
return invariantIgnoreCase_;
}


}

alias int delegate(const(char)[], const(char)[]) StringComparison;
public class StringSorter
{
    private static StringSorter invariant_;


    private static StringSorter invariantIgnoreCase_;


    private Culture culture_;

    private StringComparison comparison_;

    shared static this();
    public this(StringComparer comparer = null)
{
if (comparer is null)
comparer = StringComparer.currentCulture();
comparison_ = &comparer.compare;
}

    public this(StringComparison comparison)
{
comparison_ = comparison;
}

    public void sort(ref const(char)[][] array)
{
sort(array,0,array.length);
}

    public void sort(ref const(char)[][] array, size_t index, size_t count);

    @property public static StringSorter currentCulture()
{
return new StringSorter(StringComparer.currentCulture());
}



    @property public static StringSorter currentCultureIgnoreCase()
{
return new StringSorter(StringComparer.currentCultureIgnoreCase());
}



    public static StringSorter invariantCulture()
{
return invariant_;
}


    public static StringSorter invariantCultureIgnoreCase()
{
return invariantIgnoreCase_;
}


}

