// D import file generated from 'tango/text/xml/DocEntity.d'
module tango.text.xml.DocEntity;
private import Util = tango.text.Util;

template fromEntity(T)
{
T[] fromEntity(const(T)[] src, T[] dst = null)
{
ptrdiff_t delta;
auto s = src.ptr;
auto len = src.length;
if ((delta = Util.indexOf(s,'&',len)) < len)
{
if (dst.length < src.length)
dst.length = src.length;
auto d = dst.ptr;
do
{
d[0..delta] = s[0..delta];
len -= delta;
s += delta;
d += delta;
auto token = 0;
switch (s[1])
{
case 'a':
{
if (len > 4 && s[1..5] == "amp;")
*d++ = '&' , token = 5;
else
if (len > 5 && s[1..6] == "apos;")
*d++ = '\'' , token = 6;
break;
}
case 'g':
{
if (len > 3 && s[1..4] == "gt;")
*d++ = '>' , token = 4;
break;
}
case 'l':
{
if (len > 3 && s[1..4] == "lt;")
*d++ = '<' , token = 4;
break;
}
case 'q':
{
if (len > 5 && s[1..6] == "quot;")
*d++ = '"' , token = 6;
break;
}
default:
{
break;
}
}
if (token is 0)
*d++ = '&' , token = 1;
s += token , len -= token;
}
while ((delta = Util.indexOf(s,'&',len)) < len);d[0..len] = s[0..len];
return dst[0..d + len - dst.ptr];
}
if (dst.length < src.length)
dst.length = src.length;
dst[0..src.length] = src;
return dst[0..src.length];
}
}
template fromEntity(T)
{
void fromEntity(const(T)[] src, scope void delegate(const(T)[]) emit)
{
ptrdiff_t delta;
auto s = src.ptr;
auto len = src.length;
if ((delta = Util.indexOf(s,'&',len)) < len)
{
do
{
emit(s[0..delta]);
len -= delta;
s += delta;
auto token = 0;
switch (s[1])
{
case 'a':
{
if (len > 4 && s[1..5] == "amp;")
emit("&") , token = 5;
else
if (len > 5 && s[1..6] == "apos;")
emit("'") , token = 6;
break;
}
case 'g':
{
if (len > 3 && s[1..4] == "gt;")
emit(">") , token = 4;
break;
}
case 'l':
{
if (len > 3 && s[1..4] == "lt;")
emit("<") , token = 4;
break;
}
case 'q':
{
if (len > 5 && s[1..6] == "quot;")
emit("\"") , token = 6;
break;
}
default:
{
break;
}
}
if (token is 0)
emit("&") , token = 1;
s += token , len -= token;
}
while ((delta = Util.indexOf(s,'&',len)) < len);emit(s[0..len]);
}
else
emit(src);
}
}
template toEntity(T)
{
T[] toEntity(const(T)[] src, T[] dst = null)
{
const(T)[] entity;
auto s = src.ptr;
auto t = s;
auto e = s + src.length;
auto index = 0;
while (s < e)
switch (*s)
{
case '"':
{
entity = "&quot;";
goto common;
}
case '>':
{
entity = "&gt;";
goto common;
}
case '<':
{
entity = "&lt;";
goto common;
}
case '&':
{
entity = "&amp;";
goto common;
}
case '\'':
{
entity = "&apos;";
goto common;
common:
auto len = s - t;
if (dst.length <= index + len + entity.length)
dst.length = dst.length + len + entity.length + dst.length / 2;
dst[index..index + len] = t[0..len];
index += len;
dst[index..index + entity.length] = entity;
index += entity.length;
t = ++s;
break;
}
default:
{
++s;
break;
}
}
if (index)
{
auto len = e - t;
if (dst.length <= index + len)
dst.length = index + len;
dst[index..index + len] = t[0..len];
return dst[0..index + len];
}
if (dst.length < src.length)
dst.length = src.length;
dst[0..src.length] = src;
return dst[0..src.length];
}
}
template toEntity(T)
{
void toEntity(const(T)[] src, scope void delegate(const(T)[]) emit)
{
const(T)[] entity;
auto s = src.ptr;
auto t = s;
auto e = s + src.length;
while (s < e)
switch (*s)
{
case '"':
{
entity = "&quot;";
goto common;
}
case '>':
{
entity = "&gt;";
goto common;
}
case '<':
{
entity = "&lt;";
goto common;
}
case '&':
{
entity = "&amp;";
goto common;
}
case '\'':
{
entity = "&apos;";
goto common;
common:
if (s - t > 0)
emit(t[0..s - t]);
emit(entity);
t = ++s;
break;
}
default:
{
++s;
break;
}
}
if (entity.length)
emit(t[0..e - t]);
else
emit(src);
}
}
debug (DocEntity)
{
    import tango.io.Console;
    void main()
{
auto s = fromEntity("&amp;");
assert(s == "&");
s = fromEntity("&quot;");
assert(s == "\"");
s = fromEntity("&apos;");
assert(s == "'");
s = fromEntity("&gt;");
assert(s == ">");
s = fromEntity("&lt;");
assert(s == "<");
s = fromEntity("&lt;&amp;&apos;");
assert(s == "<&'");
s = fromEntity("*&lt;&amp;&apos;*");
assert(s == "*<&'*");
assert(fromEntity("abc") == "abc");
assert(fromEntity("abc&") == "abc&");
assert(fromEntity("abc&lt;") == "abc<");
assert(fromEntity("abc&gt;goo") == "abc>goo");
assert(fromEntity("&amp;") == "&");
assert(fromEntity("&quot;&apos;") == "\"'");
assert(fromEntity("&q&s") == "&q&s");
auto d = toEntity(">");
assert(d == "&gt;");
d = toEntity("<");
assert(d == "&lt;");
d = toEntity("&");
assert(d == "&amp;");
d = toEntity("'");
assert(d == "&apos;");
d = toEntity("\"");
assert(d == "&quot;");
d = toEntity("^^>*>*");
assert(d == "^^&gt;*&gt;*");
}
}
