// D import file generated from 'tango/text/xml/DocPrinter.d'
module tango.text.xml.DocPrinter;
private import tango.io.model.IConduit;

private import tango.text.xml.Document;

private import tango.core.Exception;

template DocPrinter(T)
{
class DocPrinter
{
    public alias Document!(T) Doc;

    public alias Doc.Node Node;

    private bool quick = true;

    private uint indentation = 2;

    version (Win32)
{
    private enum const(T)[] Eol = "\x0d\x0a";

}
else
{
    private enum const(T)[] Eol = "\x0a";

}
    final DocPrinter indent(uint indentation)
{
this.indentation = indentation;
return this;
}

    final DocPrinter cache(bool yes)
{
this.quick = yes;
return this;
}

    final T[] print(Doc doc, T[] content = null)
{
if (content !is null)
print(doc.tree,delegate (const(T)[][] s...)
{
size_t i = 0;
foreach (t; s)
{
if (i + t.length >= content.length)
throw new XmlException("Buffer is to small");
content[i..t.length] = t;
i += t.length;
}
content.length = i;
}
);
else
print(doc.tree,delegate (const(T)[][] s...)
{
foreach (t; s)
{
content ~= t;
}
}
);
return content;
}

    final void print(Doc doc, OutputStream stream)
{
print(doc.tree,delegate (const(T)[][] s...)
{
foreach (t; s)
{
stream.write(t);
}
}
);
}

    final void print(Node root, scope void delegate(const(T)[][]...) emit)
{
T[256] tmp;
T[256] spaces = ' ';
const(T)[] rawValue(Node node)
{
foreach (c; node.rawValue)
{
if (c > 32)
return node.rawValue;
}
return null;
}
void printNode(Node node, uint indent)
{
if (node.end && quick)
{
auto p = node.start;
auto l = node.end - p;
if (*p is '>')
++p , --l;
emit(p[0..l]);
}
else
switch (node.id)
{
case XmlNodeType.Document:
{
foreach (n; node.children)
{
printNode(n,indent);
}
break;
}
case XmlNodeType.Element:
{
if (indentation > 0)
emit(Eol,spaces[0..indent]);
emit("<",node.toString(tmp));
foreach (attr; node.attributes)
{
emit(" ",attr.toString(tmp),"=\"",attr.rawValue,"\"");
}
auto value = rawValue(node);
if (node.child)
{
emit(">");
if (value.length)
emit(value);
foreach (child; node.children)
{
printNode(child,indent + indentation);
}
if (node.lastChild.id != XmlNodeType.Data && indentation > 0)
emit(Eol,spaces[0..indent]);
emit("</",node.toString(tmp),">");
}
else
if (value.length)
emit(">",value,"</",node.toString(tmp),">");
else
emit("/>");
break;
}
case XmlNodeType.Data:
{
auto value = rawValue(node);
if (value.length)
emit(node.rawValue);
break;
}
case XmlNodeType.Comment:
{
emit("<!--",node.rawValue,"-->");
break;
}
case XmlNodeType.PI:
{
emit("<?",node.rawValue,"?>");
break;
}
case XmlNodeType.CData:
{
emit("<![CDATA[",node.rawValue,"]]>");
break;
}
case XmlNodeType.Doctype:
{
emit("<!DOCTYPE ",node.rawValue,">");
break;
}
default:
{
emit("<!-- unknown node type -->");
break;
}
}
}
printNode(root,0);
}

}
}
debug (1)
{
    import tango.text.xml.Document;
}
debug (1)
{
    import tango.util.log.Trace;
}
