// D import file generated from 'tango/text/xml/DocTester.d'
module tango.text.xml.DocTester;
private import tango.core.Exception;

private import tango.text.xml.Document;

private import tango.text.convert.Format;

private import tango.core.Vararg;

protected template DocTester(T)
{
class DocTester
{
    private alias Document!(T) Doc;

    private alias Doc.Node Node;

    final void validate(Doc doc)
{
validate(doc.elements);
}

    final void validate(Node node)
{
switch (node.id)
{
case XmlNodeType.Document:
{
foreach (n; node.children)
{
validate(n);
}
break;
}
case XmlNodeType.Element:
{
element(node);
foreach (n; node.attributes)
{
attribute(n);
}
foreach (n; node.children)
{
validate(n);
}
break;
}
case XmlNodeType.Attribute:
{
attribute(node);
break;
}
case XmlNodeType.Data:
{
data(node);
break;
}
case XmlNodeType.Comment:
{
comment(node);
break;
}
case XmlNodeType.PI:
{
pi(node);
break;
}
case XmlNodeType.CData:
{
cdata(node);
break;
}
case XmlNodeType.Doctype:
{
doctype(node);
break;
}
}
}

    void element(Node node)
{
uniqueAttrNames(node);
}
    void attribute(Node node)
{
}
    void data(Node node)
{
}
    void comment(Node node)
{
}
    void pi(Node node)
{
}
    void cdata(Node node)
{
}
    void doctype(Node node)
{
}
    static void uniqueAttrNames(Node node)
{
T[128] name1 = void,name2 = void;
foreach (attr; node.attributes)
{
auto name = attr.name(name1);
auto next = attr.nextSibling;
while (next !is null)
{
if (name == next.name(name2))
error("duplicate attribute name '{}' for element '{}'",name,node.name(name2));
next = attr.nextSibling;
}
}
}

    static void error(const(char)[] format,...)
{
throw new TextException(Format.convert(_arguments,_argptr,format).idup);
}

}
}

debug (DocTester)
{
    void main()
{
auto v = new DocTester!(char);
}
}
