// D import file generated from 'tango/text/xml/Document.d'
module tango.text.xml.Document;
package import tango.text.xml.PullParser;

version (Clear)
{
    extern (C) void* memset(void* s, int c, size_t n);

}
version = discrete;
template Document(T)
{
class Document : PullParser!(T)
{
    public alias NodeImpl* Node;

    private Node root;

    private NodeImpl[] list;

    private NodeImpl[][] lists;

    private 
{
    ptrdiff_t index;
    ptrdiff_t chunks;
    ptrdiff_t freelists;
}
    private XmlPath!(T) xpath;

    this(size_t nodes = 1000)
{
assert(nodes > 50);
super(null);
xpath = new XmlPath!(T);
chunks = nodes;
newlist();
root = allocate();
root.id = XmlNodeType.Document;
}
    final XmlPath!(T).NodeSet query()
{
return xpath.start(root);
}

    final @property Node tree()
{
return root;
}

    final @property Node elements()
{
if (root)
{
auto node = root.lastChild;
while (node)
if (node.id is XmlNodeType.Element)
return node;
else
node = node.prev;
}
return null;
}

    final Document reset()
{
root.lastChild = (root.firstChild = null);
version (Clear)
{
while (freelists)
{
auto list = lists[--freelists];
memset(list.ptr,0,NodeImpl.sizeof * list.length);
}
}
else
{
freelists = 0;
}

newlist();
index = 1;
version (d)
{
freelists = 0;
}

return this;
}

    final Document header(const(T)[] encoding = null)
{
if (encoding.length)
encoding = "xml version=\"1.0\" encoding=\"" ~ encoding ~ "\"";
else
encoding = "xml version=\"1.0\" encoding=\"UTF-8\"";
root.prepend(root.create(XmlNodeType.PI,encoding));
return this;
}

    final void parse(const(T[]) xml)
{
assert(xml);
reset();
super.reset(xml);
auto cur = root;
size_t defNamespace;
while (true)
{
auto p = text.point;
switch (super.next)
{
case XmlTokenType.EndElement:
{
}
case XmlTokenType.EndEmptyElement:
{
assert(cur.host);
cur.end = text.point;
cur = cur.host;
break;
}
case XmlTokenType.Data:
{
version (discrete)
{
auto node = allocate();
node.rawValue = super.rawValue;
node.id = XmlNodeType.Data;
cur.append(node);
}
else
{
if (cur.rawValue.length is 0)
cur.rawValue = super.rawValue;
else
cur.data(super.rawValue);
}

break;
}
case XmlTokenType.StartElement:
{
auto node = allocate();
node.host = cur;
node.prefixed = super.prefix;
node.id = XmlNodeType.Element;
node.localName = super.localName;
node.start = p;
if (cur.lastChild)
{
cur.lastChild.nextSibling = node;
node.prevSibling = cur.lastChild;
cur.lastChild = node;
}
else
{
cur.firstChild = node;
cur.lastChild = node;
}
cur = node;
break;
}
case XmlTokenType.Attribute:
{
auto attr = allocate();
attr.prefixed = super.prefix;
attr.rawValue = super.rawValue;
attr.localName = super.localName;
attr.id = XmlNodeType.Attribute;
cur.attrib(attr);
break;
}
case XmlTokenType.PI:
{
cur.pi_(super.rawValue,p[0..text.point - p]);
break;
}
case XmlTokenType.Comment:
{
cur.comment_(super.rawValue);
break;
}
case XmlTokenType.CData:
{
cur.cdata_(super.rawValue);
break;
}
case XmlTokenType.Doctype:
{
cur.doctype_(super.rawValue);
break;
}
case XmlTokenType.Done:
{
return ;
}
default:
{
break;
}
}
}
}

    private final Node allocate()
{
if (index >= list.length)
newlist();
auto p = &list[index++];
p.doc = this;
version (Clear)
{
}
else
{
p.start = (p.end = null);
p.host = (p.prevSibling = (p.nextSibling = (p.firstChild = (p.lastChild = (p.firstAttr = (p.lastAttr = null))))));
p.rawValue = (p.localName = (p.prefixed = null));
}

return p;
}


    private final void newlist()
{
index = 0;
if (freelists >= lists.length)
{
lists.length = lists.length + 1;
lists[$ - 1] = new NodeImpl[](chunks);
}
list = lists[freelists++];
}


    private struct Visitor
{
    private Node node;

    public alias value data;

    public alias hasValue hasData;

    bool exist()
{
return node != null;
}
    int opApply(scope int delegate(ref Node) dg)
{
int ret;
{
for (auto n = node;
 n; n = n.nextSibling)
{
if ((ret = dg(n)) != 0)
break;
}
}
return ret;
}
    Node name(const(T[]) prefix, const(T[]) local, scope bool delegate(Node) dg = null)
{
{
for (auto n = node;
 n; n = n.nextSibling)
{
{
if (local.ptr && local != n.localName)
continue;
if (prefix.ptr && prefix != n.prefixed)
continue;
if (dg.ptr && dg(n) is false)
continue;
return n;
}
}
}
return null;
}
    bool hasName(const(T[]) prefix, const(T[]) local)
{
return name(prefix,local) != null;
}
    version (Filter)
{
    Node value(const(T[]) prefix, const(T[]) local, const(T[]) value)
{
if (value.ptr)
return name(prefix,local,delegate (Node n)
{
return value == n.rawValue;
}
);
return name(prefix,local);
}
}
    Node value(const(T[]) match)
{
if (match.ptr)
{
for (auto n = node;
 n; n = n.nextSibling)
{
if (match == n.rawValue)
return n;
}
}
return null;
}
    bool hasValue(const(T[]) match)
{
return value(match) != null;
}
}

    private struct NodeImpl
{
    public void* user;

    package Document doc;

    package XmlNodeType id;

    package const(T)[] prefixed;

    package const(T)[] localName;

    package const(T)[] rawValue;

    package 
{
    Node host;
    Node prevSibling;
    Node nextSibling;
    Node firstChild;
    Node lastChild;
    Node firstAttr;
    Node lastAttr;
}
    package 
{
    const(T)* end;
    const(T)* start;
}
    @property Document document()
{
return doc;
}

    @property XmlNodeType type()
{
return id;
}

    @property Node parent()
{
return host;
}

    @property Node child()
{
return firstChild;
}

    deprecated Node childTail()
{
return lastChild;
}

    @property Node prev()
{
return prevSibling;
}

    @property Node next()
{
return nextSibling;
}

    @property const(T[]) prefix()
{
return prefixed;
}

    @property Node prefix(const(T[]) replace)
{
prefixed = replace;
return &this;
}

    @property const(T[]) name()
{
return localName;
}

    @property Node name(const(T[]) replace)
{
localName = replace;
return &this;
}

    @property const(T[]) value()
{
version (discrete)
{
if (type is XmlNodeType.Element)
foreach (child; children)
{
if (child.id is XmlNodeType.Data || child.id is XmlNodeType.CData)
return child.rawValue;
}
}

return rawValue;
}

    @property void value(const(T[]) val)
{
version (discrete)
{
if (type is XmlNodeType.Element)
foreach (child; children)
{
if (child.id is XmlNodeType.Data)
return child.value(val);
}
}

rawValue = val;
mutate();
}

    const(T[]) toString(T[] output = null)
{
if (prefixed.length)
{
auto len = prefixed.length + localName.length + 1;
if (prefixed.ptr + prefixed.length + 1 is localName.ptr && ':' is *(localName.ptr - 1))
return prefixed.ptr[0..len];
if (output.length < len)
output.length = len;
output[0..prefixed.length] = prefixed;
output[prefixed.length] = ':';
output[prefixed.length + 1..len] = localName;
return output[0..len];
}
return localName;
}
    @property size_t position()
{
auto count = 0;
auto prior = prevSibling;
while (prior)
++count , prior = prior.prevSibling;
return count;
}

    Node detach()
{
return remove();
}
    final XmlPath!(T).NodeSet query()
{
return doc.xpath.start(&this);
}

    @property Visitor children()
{
Visitor v = {firstChild};
return v;
}

    @property Visitor attributes()
{
Visitor v = {firstAttr};
return v;
}

    deprecated bool hasAttributes()
{
return firstAttr !is null;
}

    deprecated bool hasChildren()
{
return firstChild !is null;
}

    Node copy(Node tree)
{
assert(tree);
tree = tree.clone();
tree.migrate(document);
if (tree.id is XmlNodeType.Attribute)
attrib(tree);
else
append(tree);
return tree;
}
    Node move(Node tree)
{
tree.detach();
if (tree.doc is doc)
{
if (tree.id is XmlNodeType.Attribute)
attrib(tree);
else
append(tree);
}
else
tree = copy(tree);
return tree;
}
    Node element(const(T[]) prefix, const(T[]) local, const(T[]) value = null)
{
return element_(prefix,local,value).mutate();
}
    Node attribute(const(T[]) prefix, const(T[]) local, const(T[]) value = null)
{
return attribute_(prefix,local,value).mutate();
}
    Node data(const(T[]) data)
{
return data_(data).mutate();
}
    Node cdata(const(T[]) cdata)
{
return cdata_(cdata).mutate();
}
    Node comment(const(T[]) comment)
{
return comment_(comment).mutate();
}
    Node doctype(const(T[]) doctype)
{
return doctype_(doctype).mutate();
}
    Node pi(const(T[]) pi)
{
return pi_(pi,null).mutate();
}
    private Node element_(const(T[]) prefix, const(T[]) local, const(T[]) value = null)
{
auto node = create(XmlNodeType.Element,null);
append(node.set(prefix,local));
version (discrete)
{
if (value.length)
node.data_(value);
}
else
{
node.rawValue = value;
}

return node;
}

    private Node attribute_(const(T[]) prefix, const(T[]) local, const(T[]) value = null)
{
auto node = create(XmlNodeType.Attribute,value);
attrib(node.set(prefix,local));
return &this;
}

    private Node data_(const(T[]) data)
{
append(create(XmlNodeType.Data,data));
return &this;
}

    private Node cdata_(const(T[]) cdata)
{
append(create(XmlNodeType.CData,cdata));
return &this;
}

    private Node comment_(const(T[]) comment)
{
append(create(XmlNodeType.Comment,comment));
return &this;
}

    private Node pi_(const(T[]) pi, const(T[]) patch)
{
append(create(XmlNodeType.PI,pi).patch(patch));
return &this;
}

    private Node doctype_(const(T[]) doctype)
{
append(create(XmlNodeType.Doctype,doctype));
return &this;
}

    private void attrib(Node node)
{
assert(node.parent is null);
node.host = &this;
if (lastAttr)
{
lastAttr.nextSibling = node;
node.prevSibling = lastAttr;
lastAttr = node;
}
else
firstAttr = (lastAttr = node);
}

    private void append(Node node)
{
assert(node.parent is null);
node.host = &this;
if (lastChild)
{
lastChild.nextSibling = node;
node.prevSibling = lastChild;
lastChild = node;
}
else
firstChild = (lastChild = node);
}

    private void prepend(Node node)
{
assert(node.parent is null);
node.host = &this;
if (firstChild)
{
firstChild.prevSibling = node;
node.nextSibling = firstChild;
firstChild = node;
}
else
firstChild = (lastChild = node);
}

    private Node set(const(T[]) prefix, const(T[]) local)
{
this.localName = local;
this.prefixed = prefix;
return &this;
}

    private Node create(XmlNodeType type, const(T[]) value)
{
auto node = document.allocate();
node.rawValue = value;
node.id = type;
return node;
}

    private Node remove()
{
if (!host)
return &this;
mutate();
if (prevSibling && nextSibling)
{
prevSibling.nextSibling = nextSibling;
nextSibling.prevSibling = prevSibling;
prevSibling = null;
nextSibling = null;
host = null;
}
else
if (nextSibling)
{
debug (1)
{
assert(host.firstChild == &this);
}

parent.firstChild = nextSibling;
nextSibling.prevSibling = null;
nextSibling = null;
host = null;
}
else
if (type != XmlNodeType.Attribute)
{
if (prevSibling)
{
debug (1)
{
assert(host.lastChild == &this);
}

host.lastChild = prevSibling;
prevSibling.nextSibling = null;
prevSibling = null;
host = null;
}
else
{
debug (1)
{
assert(host.firstChild == &this);
}

debug (1)
{
assert(host.lastChild == &this);
}

host.firstChild = null;
host.lastChild = null;
host = null;
}
}
else
{
if (prevSibling)
{
debug (1)
{
assert(host.lastAttr == &this);
}

host.lastAttr = prevSibling;
prevSibling.nextSibling = null;
prevSibling = null;
host = null;
}
else
{
debug (1)
{
assert(host.firstAttr == &this);
}

debug (1)
{
assert(host.lastAttr == &this);
}

host.firstAttr = null;
host.lastAttr = null;
host = null;
}
}
return &this;
}

    private Node patch(const(T[]) text)
{
end = text.ptr + text.length;
start = text.ptr;
return &this;
}

    private Node mutate()
{
auto node = &this;
do
{
node.end = null;
}
while ((node = node.host) !is null);return &this;
}

    @property private Node dup()
{
return create(type,rawValue.dup).set(prefixed.dup,localName.dup);
}


    private Node clone()
{
auto p = dup;
foreach (attr; attributes)
{
p.attrib(attr.dup);
}
foreach (child; children)
{
p.append(child.clone());
}
return p;
}

    private void migrate(Document host)
{
this.doc = host;
foreach (attr; attributes)
{
attr.migrate(host);
}
foreach (child; children)
{
child.migrate(host);
}
}

}

}
}
private template XmlPath(T)
{
class XmlPath
{
    public alias Document!(T) Doc;

    public alias Doc.Node Node;

    private Node[] freelist;

    private 
{
    size_t freeIndex;
    size_t markIndex;
}
    private size_t recursion;

    final NodeSet start(Node root)
{
if (recursion is 0)
{
if (freelist.length is 0)
freelist.length = 256;
freeIndex = 0;
}
NodeSet set = {this};
auto mark = freeIndex;
allocate(root);
return set.assign(mark);
}

    struct NodeSet
{
    private XmlPath host;

    public Node[] nodes;

    @property NodeSet dup()
{
NodeSet copy = {host};
copy.nodes = nodes.dup;
return copy;
}

    @property size_t count()
{
return nodes.length;
}

    NodeSet first()
{
return nth(0);
}
    NodeSet last()
{
auto i = nodes.length;
if (i > 0)
--i;
return nth(i);
}
    NodeSet opIndex(size_t i)
{
return nth(i);
}
    NodeSet nth(size_t index)
{
NodeSet set = {host};
auto mark = host.mark();
if (index < nodes.length)
host.allocate(nodes[index]);
return set.assign(mark);
}
    NodeSet opSlice()
{
return child();
}
    NodeSet opIndex(const(T[]) name)
{
return child(name);
}
    NodeSet parent(const(T[]) name = null)
{
if (name.ptr)
return parent(delegate (Node node)
{
return node.name == name;
}
);
return parent(&always);
}
    NodeSet data(const(T[]) value = null)
{
if (value.ptr)
return child(delegate (Node node)
{
return node.value == value;
}
,XmlNodeType.Data);
return child(&always,XmlNodeType.Data);
}
    NodeSet cdata(const(T[]) value = null)
{
if (value.ptr)
return child(delegate (Node node)
{
return node.value == value;
}
,XmlNodeType.CData);
return child(&always,XmlNodeType.CData);
}
    NodeSet attribute(const(T[]) name = null)
{
if (name.ptr)
return attribute(delegate (Node node)
{
return node.name == name;
}
);
return attribute(&always);
}
    NodeSet descendant(const(T[]) name = null)
{
if (name.ptr)
return descendant(delegate (Node node)
{
return node.name == name;
}
);
return descendant(&always);
}
    NodeSet child(const(T[]) name = null)
{
if (name.ptr)
return child(delegate (Node node)
{
return node.name == name;
}
);
return child(&always);
}
    NodeSet ancestor(const(T[]) name = null)
{
if (name.ptr)
return ancestor(delegate (Node node)
{
return node.name == name;
}
);
return ancestor(&always);
}
    NodeSet prev(const(T[]) name = null)
{
if (name.ptr)
return prev(delegate (Node node)
{
return node.name == name;
}
);
return prev(&always);
}
    NodeSet next(const(T[]) name = null)
{
if (name.ptr)
return next(delegate (Node node)
{
return node.name == name;
}
);
return next(&always);
}
    NodeSet filter(scope bool delegate(Node) filter)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
test(filter,node);
}
return set.assign(mark);
}
    NodeSet child(scope bool delegate(Node) filter, XmlNodeType type = XmlNodeType.Element)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (parent; nodes)
{
foreach (child; parent.children)
{
if (child.id is type)
test(filter,child);
}
}
return set.assign(mark);
}
    NodeSet attribute(scope bool delegate(Node) filter)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
foreach (attr; node.attributes)
{
test(filter,attr);
}
}
return set.assign(mark);
}
    NodeSet descendant(scope bool delegate(Node) filter, XmlNodeType type = XmlNodeType.Element)
{
void traverse(Node parent)
{
foreach (child; parent.children)
{
if (child.id is type)
test(filter,child);
if (child.firstChild)
traverse(child);
}
}
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
traverse(node);
}
return set.assign(mark);
}
    NodeSet parent(scope bool delegate(Node) filter)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
auto p = node.parent;
if (p && p.id != XmlNodeType.Document && !set.has(p))
{
test(filter,p);
set.nodes = host.slice(mark);
}
}
return set.assign(mark);
}
    NodeSet ancestor(scope bool delegate(Node) filter)
{
NodeSet set = {host};
auto mark = host.mark();
void traverse(Node child)
{
auto p = child.host;
if (p && p.id != XmlNodeType.Document && !set.has(p))
{
test(filter,p);
set.nodes = host.slice(mark);
traverse(p);
}
}
foreach (node; nodes)
{
traverse(node);
}
return set.assign(mark);
}
    NodeSet next(scope bool delegate(Node) filter, XmlNodeType type = XmlNodeType.Element)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
auto p = node.nextSibling;
while (p)
{
if (p.id is type)
test(filter,p);
p = p.nextSibling;
}
}
return set.assign(mark);
}
    NodeSet prev(scope bool delegate(Node) filter, XmlNodeType type = XmlNodeType.Element)
{
NodeSet set = {host};
auto mark = host.mark();
foreach (node; nodes)
{
auto p = node.prevSibling;
while (p)
{
if (p.id is type)
test(filter,p);
p = p.prevSibling;
}
}
return set.assign(mark);
}
    int opApply(scope int delegate(ref Node) dg)
{
int ret;
foreach (node; nodes)
{
if ((ret = dg(node)) != 0)
break;
}
return ret;
}
    private bool always(Node node)
{
return true;
}

    private NodeSet assign(size_t mark)
{
nodes = host.slice(mark);
return this;
}

    private void test(scope bool delegate(Node) filter, Node node)
{
auto pop = host.push();
auto add = filter(node);
host.pop(pop);
if (add)
host.allocate(node);
}

    private bool has(Node p)
{
foreach (node; nodes)
{
if (node is p)
return true;
}
return false;
}

}
    private size_t mark()
{
return freeIndex;
}

    private size_t push()
{
++recursion;
return freeIndex;
}

    private void pop(size_t prior)
{
freeIndex = prior;
--recursion;
}

    private Node[] slice(size_t mark)
{
assert(mark <= freeIndex);
return freelist[mark..freeIndex];
}

    private size_t allocate(Node node)
{
if (freeIndex >= freelist.length)
freelist.length = freelist.length + freelist.length / 2;
freelist[freeIndex] = node;
return ++freeIndex;
}

}
}

version (Old)
{
    template IXmlPrinter(T)
{
interface IXmlPrinter
{
    public alias Document!(T) Doc;

    public alias Doc.Node Node;

    public alias print opCall;

    T[] print(Doc doc);
    void print(Node root, scope void delegate(T[][]...) emit);
}
}
}
debug (Document)
{
    import tango.io.Stdout;
    import tango.text.xml.DocPrinter;
    void main();
}
