// D import file generated from 'tango/text/xml/PullParser.d'
module tango.text.xml.PullParser;
private import tango.text.Util;

private import tango.core.Exception;

private import Integer = tango.text.convert.Integer;

private import Utf = tango.text.convert.Utf;

version (whitespace)
{
    version = retainwhite;
}
else
{
    version = stripwhite;
    version = partialwhite;
}
public enum XmlNodeType 
{
Element,
Data,
Attribute,
CData,
Comment,
PI,
Doctype,
Document,
}

public enum XmlTokenType 
{
Done,
StartElement,
Attribute,
EndElement,
EndEmptyElement,
Data,
Comment,
CData,
Doctype,
PI,
None,
}

template PullParser(Ch = char)
{
class PullParser
{
    public int depth;

    public const(Ch)[] prefix;

    public const(Ch)[] rawValue;

    public const(Ch)[] localName;

    public XmlTokenType type = XmlTokenType.None;

    package XmlText!(Ch) text;

    private bool stream;

    private const(char)[] errMsg;

    this(const(Ch[]) content = null)
{
reset(content);
}
    final @property XmlTokenType next()
{
auto e = text.end;
auto p = text.point;
if (p >= e)
return endOfInput();
version (stripwhite)
{
while (*p <= 32)
if (++p >= e)
return endOfInput();
}

if (type < XmlTokenType.EndElement)
{
version (retainwhite)
{
while (*p <= 32)
if (++p >= e)
return endOfInput();
}

switch (*p)
{
case '>':
{
++depth;
++p;
break;
}
case '/':
{
text.point = p;
return doEndEmptyElement();
}
default:
{
text.point = p;
return doAttributeName();
}
}
}
if (*p != '<')
{
auto q = p;
while (++p < e && *p != '<')
{
}
if (p < e)
{
version (partialwhite)
{
while (*(q - 1) <= 32)
--q;
}

text.point = p;
rawValue = q[0..p - q];
return type = XmlTokenType.Data;
}
return endOfInput();
}
switch (p[1])
{
case '!':
{
if (p[2..4] == "--")
{
text.point = p + 4;
return doComment();
}
else
if (p[2..9] == "[CDATA[")
{
text.point = p + 9;
return doCData();
}
else
if (p[2..9] == "DOCTYPE")
{
text.point = p + 9;
return doDoctype();
}
return doUnexpected("!",p);
}
case '?':
{
text.point = p + 2;
return doPI();
}
case '/':
{
p += 2;
auto q = p;
while (*q > 63 || text.name[*q])
++q;
if (*q is ':')
{
prefix = p[0..q - p];
p = ++q;
while (*q > 63 || text.attributeName[*q])
++q;
localName = p[0..q - p];
}
else
{
prefix = null;
localName = p[0..q - p];
}
while (*q <= 32)
if (++q >= e)
return endOfInput();
if (*q is '>')
{
--depth;
text.point = q + 1;
return type = XmlTokenType.EndElement;
}
return doExpected(">",q);
}
default:
{
auto q = ++p;
while (*q > 63 || text.name[*q])
++q;
if (q >= e)
return endOfInput();
if (*q != ':')
{
prefix = null;
localName = p[0..q - p];
}
else
{
prefix = p[0..q - p];
p = ++q;
while (*q > 63 || text.attributeName[*q])
++q;
localName = p[0..q - p];
}
text.point = q;
return type = XmlTokenType.StartElement;
}
}
}

    private XmlTokenType doAttributeName()
{
auto p = text.point;
auto q = p;
auto e = text.end;
while (*q > 63 || text.attributeName[*q])
++q;
if (q >= e)
return endOfInput();
if (*q is ':')
{
prefix = p[0..q - p];
p = ++q;
while (*q > 63 || text.attributeName[*q])
++q;
localName = p[0..q - p];
}
else
{
prefix = null;
localName = p[0..q - p];
}
if (*q <= 32)
{
while (*++q <= 32)
{
}
if (q >= e)
return endOfInput();
}
if (*q is '=')
{
while (*++q <= 32)
{
}
if (q >= e)
return endOfInput();
auto quote = *q;
switch (quote)
{
case '"':
{
}
case '\'':
{
p = q + 1;
while (*++q != quote)
{
}
if (q < e)
{
rawValue = p[0..q - p];
text.point = q + 1;
return type = XmlTokenType.Attribute;
}
return endOfInput();
}
default:
{
return doExpected("' or \"",q);
}
}
}
return doExpected("=",q);
}

    private XmlTokenType doEndEmptyElement()
{
if (text.point[0] is '/' && text.point[1] is '>')
{
localName = (prefix = null);
text.point += 2;
return type = XmlTokenType.EndEmptyElement;
}
return doExpected("/>",text.point);
}

    private XmlTokenType doComment()
{
auto e = text.end;
auto p = text.point;
auto q = p;
while (p < e)
{
while (*p != '-')
if (++p >= e)
return endOfInput();
if (p[0..3] == "-->")
{
text.point = p + 3;
rawValue = q[0..p - q];
return type = XmlTokenType.Comment;
}
++p;
}
return endOfInput();
}

    private XmlTokenType doCData()
{
auto e = text.end;
auto p = text.point;
while (p < e)
{
auto q = p;
while (*p != ']')
if (++p >= e)
return endOfInput();
if (p[0..3] == "]]>")
{
text.point = p + 3;
rawValue = q[0..p - q];
return type = XmlTokenType.CData;
}
++p;
}
return endOfInput();
}

    private XmlTokenType doPI()
{
auto e = text.end;
auto p = text.point;
auto q = p;
while (p < e)
{
while (*p != '?')
if (++p >= e)
return endOfInput();
if (p[1] == '>')
{
rawValue = q[0..p - q];
text.point = p + 2;
return type = XmlTokenType.PI;
}
++p;
}
return endOfInput();
}

    private XmlTokenType doDoctype()
{
auto e = text.end;
auto p = text.point;
while (*p <= 32)
if (++p >= e)
return endOfInput();
auto q = p;
while (p < e)
{
if (*p is '>')
{
rawValue = q[0..p - q];
prefix = null;
text.point = p + 1;
return type = XmlTokenType.Doctype;
}
else
{
if (*p == '[')
do
{
if (++p >= e)
return endOfInput();
}
while (*p != ']');++p;
}
}
if (p >= e)
return endOfInput();
return XmlTokenType.Doctype;
}

    private XmlTokenType endOfInput()
{
if (depth && stream is false)
error("Unexpected EOF");
return XmlTokenType.Done;
}

    private XmlTokenType doUnexpected(const(char[]) msg, const(Ch)* p)
{
return position("parse error :: unexpected  " ~ msg,p);
}

    private XmlTokenType doExpected(const(char[]) msg, const(Ch)* p)
{
char[6] tmp = void;
return position("parse error :: expected  " ~ msg ~ " instead of " ~ Utf.toString(p[0..1],tmp),p);
}

    private XmlTokenType position(const(char[]) msg, const(Ch)* p)
{
return error(msg ~ " at position " ~ Integer.toString(p - text.text.ptr));
}

    @property protected final XmlTokenType error(const(char[]) msg)
{
errMsg = msg;
throw new XmlException(msg.idup);
}



    const final @property const(Ch[]) value()
{
return rawValue;
}

    const final @property const(Ch[]) name()
{
if (prefix.length)
return prefix ~ ":" ~ localName;
return localName;
}

    const final @property const(char[]) error()
{
return errMsg;
}

    final bool reset()
{
text.reset(text.text);
reset_();
return true;
}

    final void reset(const(Ch[]) newText)
{
text.reset(newText);
reset_();
}

    final void incremental(bool yes = true)
{
stream = yes;
}

    private void reset_()
{
depth = 0;
errMsg = null;
type = XmlTokenType.None;
auto p = text.point;
if (p)
{
static if(Ch.sizeof == 1)
{
if (p[0] is 239 && p[1] is 187 && p[2] is 191)
p += 3;
}

auto e = text.end;
while (p < e && *p <= 32)
++p;
if (p < e)
if (p[0] is '<' && p[1] is '?' && p[2..5] == "xml")
{
p += 5;
while (p < e && *p != '?')
++p;
p += 2;
}
text.point = p;
}
}

}
}
package template XmlText(Ch)
{
struct XmlText
{
    package const(Ch)* end;

    package size_t len;

    package const(Ch)[] text;

    package const(Ch)* point;

    final void reset(const(Ch[]) newText)
{
this.text = newText;
this.len = newText.length;
this.point = text.ptr;
this.end = point + len;
}

    static enum ubyte[64] name = [0,1,1,1,1,1,1,1,1,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0];

    static enum ubyte[64] attributeName = [0,1,1,1,1,1,1,1,1,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0];

}
}

debug (UnitTest)
{
    template testParser(Ch)
{
void testParser(PullParser!(Ch) itr)
{
assert(itr.next);
assert(itr.value == "element [ <!ELEMENT element (#PCDATA)>]");
assert(itr.type == XmlTokenType.Doctype);
assert(itr.next);
assert(itr.localName == "element");
assert(itr.type == XmlTokenType.StartElement);
assert(itr.depth == 0);
assert(itr.next);
assert(itr.localName == "attr");
assert(itr.value == "1");
assert(itr.next);
assert(itr.type == XmlTokenType.Attribute);
assert(itr.localName == "attr2");
assert(itr.value == "two");
assert(itr.next);
assert(itr.value == "comment");
assert(itr.next);
assert(itr.rawValue == "test&amp;&#x5a;");
assert(itr.next);
assert(itr.prefix == "qual");
assert(itr.localName == "elem");
assert(itr.next);
assert(itr.type == XmlTokenType.EndEmptyElement);
assert(itr.next);
assert(itr.localName == "el2");
assert(itr.depth == 1);
assert(itr.next);
assert(itr.localName == "attr3");
assert(itr.value == "3three",itr.value);
assert(itr.next);
assert(itr.rawValue == "sdlgjsh");
assert(itr.next);
assert(itr.localName == "el3");
assert(itr.depth == 2);
assert(itr.next);
assert(itr.type == XmlTokenType.EndEmptyElement);
assert(itr.next);
assert(itr.value == "data");
assert(itr.next);
assert(itr.rawValue == "pi test",itr.rawValue);
assert(itr.next);
assert(itr.localName == "el2");
assert(itr.next);
assert(itr.localName == "element");
assert(!itr.next);
}
}
    enum immutable(char)[] testXML = "<?xml version=\"1.0\" ?><!DOCTYPE element [ <!ELEMENT element (#PCDATA)>]><element attr=\"1\" attr2=\"two\"><!--comment-->test&amp;&#x5a;<qual:elem /><el2 attr3 = '3three'><![CDATA[sdlgjsh]]><el3 />data<?pi test?></el2></element>";
    }
