// D import file generated from 'tango/text/xml/SaxParser.d'
module tango.text.xml.SaxParser;
private import tango.io.model.IConduit;

private import tango.text.xml.PullParser;

template Attribute(Ch = char)
{
struct Attribute
{
    const(Ch)[] localName;
    const(Ch)[] value;
}
}
public template SaxHandler(Ch = char)
{
class SaxHandler
{
    Locator!(Ch) locator;
    public void setDocumentLocator(Locator!(Ch) locator)
{
this.locator = locator;
}

    public void startDocument()
{
}

    public void endDocument()
{
}

    public void startPrefixMapping(const(Ch)[] prefix, const(Ch)[] uri)
{
}

    public void endPrefixMapping(const(Ch)[] prefix)
{
}

    public void startElement(const(Ch)[] uri, const(Ch)[] localName, const(Ch)[] qName, Attribute!(Ch)[] atts)
{
}

    public void endElement(const(Ch)[] uri, const(Ch)[] localName, const(Ch)[] qName)
{
}

    public void characters(const(Ch)[] ch)
{
}

    public void ignorableWhitespace(Ch[] ch)
{
}

    public void processingInstruction(const(Ch)[] target, const(Ch)[] data)
{
}

    public void skippedEntity(const(Ch)[] name)
{
}

}
}

public template EntityResolver(Ch = char)
{
interface EntityResolver
{
    public InputStream resolveEntity(const(Ch)[] publicId, const(Ch)[] systemId);

}
}

public template ErrorHandler(Ch = char)
{
interface ErrorHandler
{
    public void warning(SAXException exception);

    public void error(SAXException exception);

    public void fatalError(SAXException exception);

}
}

public template Locator(Ch = char)
{
interface Locator
{
    public const(Ch)[] getPublicId();

    public const(Ch)[] getSystemId();

    public int getLineNumber();

    public int getColumnNumber();

}
}

public class SAXException : Exception
{
    public this()
{
super("",cast(Throwable)null);
}

    public this(immutable(char)[] message)
{
super(message,cast(Throwable)null);
}

    public this(Exception e)
{
super("",e);
}

    public this(immutable(char)[] message, Exception e)
{
super(message,e);
}

    public immutable(char)[] message()
{
if (msg is null && next !is null)
{
return next.msg;
}
else
{
return msg;
}
}

}

template SaxParser(Ch = char)
{
class SaxParser : XMLReader!(Ch),Locator!(Ch)
{
    private SaxHandler!(Ch) saxHandler;

    private ErrorHandler!(Ch) errorHandler;

    private EntityResolver!(Ch) entityResolver;

    private const(Ch)[] content;

    private Attribute!(Ch)[] attributes;

    private int attrTop = 0;

    private bool hasStartElement = false;

    private const(Ch)[] startElemName;

    private PullParser!(Ch) parser;

    public this()
{
attributes = new Attribute!(Ch)[](255);
}

    public bool getFeature(const(Ch)[] name)
{
return false;
}

    public void setFeature(const(Ch)[] name, bool value)
{
}

    public Object getProperty(const(Ch)[] name)
{
return null;
}

    public void setProperty(const(Ch)[] name, Object value)
{
}

    public void setEntityResolver(EntityResolver!(Ch) resolver)
{
entityResolver = resolver;
}

    public EntityResolver!(Ch) getEntityResolver()
{
return entityResolver;
}

    public void setSaxHandler(SaxHandler!(Ch) handler)
{
saxHandler = handler;
}

    public SaxHandler!(Ch) getSaxHandler()
{
return saxHandler;
}

    public void setErrorHandler(ErrorHandler!(Ch) handler)
{
errorHandler = handler;
}

    public ErrorHandler!(Ch) getErrorHandler()
{
return errorHandler;
}

    private void parse(InputStream input)
{
doParse();
}

    private void parseUrl(const(Ch)[] systemId)
{
doParse();
}

    public void parse(const(Ch)[] content)
{
this.setContent(content);
doParse();
}

    public void parse()
{
doParse();
}

    public void setContent(const(Ch)[] content)
{
if (!parser)
{
parser = new PullParser!(Ch)(content);
}
else
{
parser.reset(content);
}
}

    public void reset()
{
parser.reset();
}

    private void doParse()
{
saxHandler.setDocumentLocator(this);
saxHandler.startDocument();
while (true)
{
switch (parser.next)
{
case XmlTokenType.StartElement:
{
if (hasStartElement)
{
saxHandler.startElement(null,startElemName,null,attributes[0..attrTop]);
hasStartElement = false;
attrTop = 0;
}
startElemName = parser.localName;
hasStartElement = true;
break;
}
case XmlTokenType.Attribute:
{
attributes[attrTop].localName = parser.localName;
attributes[attrTop].value = parser.rawValue;
attrTop++;
break;
}
case XmlTokenType.EndElement:
{
}
case XmlTokenType.EndEmptyElement:
{
if (hasStartElement)
{
saxHandler.startElement(null,startElemName,null,attributes[0..attrTop]);
hasStartElement = false;
attrTop = 0;
}
saxHandler.endElement(null,parser.localName,null);
break;
}
case XmlTokenType.Data:
{
if (hasStartElement)
{
saxHandler.startElement(null,startElemName,null,attributes[0..attrTop]);
hasStartElement = false;
attrTop = 0;
}
saxHandler.characters(parser.rawValue);
break;
}
case XmlTokenType.Comment:
{
}
case XmlTokenType.CData:
{
}
case XmlTokenType.Doctype:
{
}
case XmlTokenType.PI:
{
}
case XmlTokenType.None:
{
if (hasStartElement)
{
saxHandler.startElement(null,startElemName,null,attributes[0..attrTop]);
hasStartElement = false;
attrTop = 0;
}
break;
}
case XmlTokenType.Done:
{
goto foo;
}
default:
{
throw new SAXException("unknown parser token type");
}
}
}
foo:
saxHandler.endDocument();
}

    public const(Ch)[] getPublicId()
{
return null;
}

    public const(Ch)[] getSystemId()
{
return null;
}

    public int getLineNumber()
{
return 0;
}

    public int getColumnNumber()
{
return 0;
}

}
}
public abstract template XMLFilter(Ch = char)
{
class XMLFilter : XMLReader
{
    public void setParent(XMLReader parent)
{
}

    public XMLReader getParent()
{
return null;
}

}
}


public template XMLFilterImpl(Ch = char)
{
class XMLFilterImpl : SaxHandler,XMLFilter,EntityResolver,ErrorHandler
{
    public this()
{
}

    public this(XMLReader parent)
{
setParent(parent);
}

    public void setParent(XMLReader parent)
{
this.parent = parent;
}

    public XMLReader getParent()
{
return parent;
}

    public void setFeature(const(Ch)[] name, bool value)
{
if (parent !is null)
{
parent.setFeature(name,value);
}
else
{
throw new SAXException("Feature not recognized: " ~ name);
}
}

    public bool getFeature(const(Ch)[] name)
{
if (parent !is null)
{
return parent.getFeature(name);
}
else
{
throw new SAXException("Feature not recognized: " ~ name);
}
}

    public void setProperty(const(Ch)[] name, Object value)
{
if (parent !is null)
{
parent.setProperty(name,value);
}
else
{
throw new SAXException("Property not recognized: " ~ name);
}
}

    public Object getProperty(const(Ch)[] name)
{
if (parent !is null)
{
return parent.getProperty(name);
}
else
{
throw new SAXException("Property not recognized: " ~ name);
}
}

    public void setEntityResolver(EntityResolver resolver)
{
entityResolver = resolver;
}

    public EntityResolver getEntityResolver()
{
return entityResolver;
}

    public void setSaxHandler(SaxHandler handler)
{
saxHandler = handler;
}

    public SaxHandler getSaxHandler()
{
return saxHandler;
}

    public void setErrorHandler(ErrorHandler handler)
{
errorHandler = handler;
}

    public ErrorHandler getErrorHandler()
{
return errorHandler;
}

    private void parse(InputStream input)
{
setupParse();
parent.parse(input);
}

    public void parse(const(Ch)[] content)
{
}

    public void parse()
{
}

    public void setContent(const(Ch)[] content)
{
}

    private void parseUrl(const(Ch)[] systemId)
{
}

    public InputStream resolveEntity(const(Ch)[] publicId, const(Ch)[] systemId)
{
if (entityResolver !is null)
{
return entityResolver.resolveEntity(publicId,systemId);
}
else
{
return null;
}
}

    public void setDocumentLocator(Locator locator)
{
this.locator = locator;
if (saxHandler !is null)
{
saxHandler.setDocumentLocator(locator);
}
}

    public void startDocument()
{
if (saxHandler !is null)
{
saxHandler.startDocument();
}
}

    public void endDocument()
{
if (saxHandler !is null)
{
saxHandler.endDocument();
}
}

    public void startPrefixMapping(const(Ch)[] prefix, const(Ch)[] uri)
{
if (saxHandler !is null)
{
saxHandler.startPrefixMapping(prefix,uri);
}
}

    public void endPrefixMapping(const(Ch)[] prefix)
{
if (saxHandler !is null)
{
saxHandler.endPrefixMapping(prefix);
}
}

    public void startElement(const(Ch)[] uri, const(Ch)[] localName, const(Ch)[] qName, Attribute[] atts)
{
if (saxHandler !is null)
{
saxHandler.startElement(uri,localName,qName,atts);
}
}

    public void endElement(const(Ch)[] uri, const(Ch)[] localName, const(Ch)[] qName)
{
if (saxHandler !is null)
{
saxHandler.endElement(uri,localName,qName);
}
}

    public void characters(Ch[] ch)
{
if (saxHandler !is null)
{
saxHandler.characters(ch);
}
}

    public void ignorableWhitespace(Ch[] ch)
{
if (saxHandler !is null)
{
saxHandler.ignorableWhitespace(ch);
}
}

    public void processingInstruction(const(Ch)[] target, const(Ch)[] data)
{
if (saxHandler !is null)
{
saxHandler.processingInstruction(target,data);
}
}

    public void skippedEntity(const(Ch)[] name)
{
if (saxHandler !is null)
{
saxHandler.skippedEntity(name);
}
}

    public void warning(SAXException e)
{
if (errorHandler !is null)
{
errorHandler.warning(e);
}
}

    public void error(SAXException e)
{
if (errorHandler !is null)
{
errorHandler.error(e);
}
}

    public void fatalError(SAXException e)
{
if (errorHandler !is null)
{
errorHandler.fatalError(e);
}
}

    private void setupParse()
{
if (parent is null)
{
throw new Exception("No parent for filter");
}
parent.setEntityResolver(this);
parent.setSaxHandler(this);
parent.setErrorHandler(this);
}

    private XMLReader parent = null;

    private Locator locator = null;

    private EntityResolver entityResolver = null;

    private SaxHandler saxHandler = null;

    private ErrorHandler errorHandler = null;

}
}

public template XMLReader(Ch = char)
{
interface XMLReader
{
    public bool getFeature(const(Ch)[] name);

    public void setFeature(const(Ch)[] name, bool value);

    public Object getProperty(const(Ch)[] name);

    public void setProperty(const(Ch)[] name, Object value);

    public void setEntityResolver(EntityResolver!(Ch) resolver);

    public EntityResolver!(Ch) getEntityResolver();

    public void setSaxHandler(SaxHandler!(Ch) handler);

    public SaxHandler!(Ch) getSaxHandler();

    public void setErrorHandler(ErrorHandler!(Ch) handler);

    public ErrorHandler!(Ch) getErrorHandler();

    private void parse(InputStream input);

    private void parseUrl(const(Ch)[] systemId);

    public void parse(const(Ch)[] content);

    public void parse();

    public void setContent(const(Ch)[] content);

}
}

