// D import file generated from 'tango/time/Time.d'
module tango.time.Time;
struct TimeSpan
{
    package long ticks_;

    enum : long
{
NanosecondsPerTick = 100,
TicksPerMicrosecond = 1000 / NanosecondsPerTick,
TicksPerMillisecond = 1000 * TicksPerMicrosecond,
TicksPerSecond = 1000 * TicksPerMillisecond,
TicksPerMinute = 60 * TicksPerSecond,
TicksPerHour = 60 * TicksPerMinute,
TicksPerDay = 24 * TicksPerHour,
MillisPerSecond = 1000,
MillisPerMinute = MillisPerSecond * 60,
MillisPerHour = MillisPerMinute * 60,
MillisPerDay = MillisPerHour * 24,
DaysPerYear = 365,
DaysPer4Years = DaysPerYear * 4 + 1,
DaysPer100Years = DaysPer4Years * 25 - 1,
DaysPer400Years = DaysPer100Years * 4 + 1,
Epoch1601 = DaysPer400Years * 4 * TicksPerDay,
Epoch1970 = Epoch1601 + TicksPerSecond * 11644473600L,
}
    enum TimeSpan min = {(long).min};
    enum TimeSpan max = {(long).max};
    enum TimeSpan zero = {0};
    const @property long ticks()
{
return ticks_;
}

    const bool opEquals(ref const(TimeSpan) t)
{
return ticks_ is t.ticks_;
}

    const int opCmp(const(TimeSpan) t)
{
if (ticks_ < t.ticks_)
return -1;
if (ticks_ > t.ticks_)
return 1;
return 0;
}

    const template opBinary(immutable(char)[] o : "+")
{
TimeSpan opBinary(const(TimeSpan) t)
{
return TimeSpan(ticks_ + t.ticks_);
}
}

    template opOpAssign(immutable(char)[] o : "+")
{
TimeSpan opOpAssign(const(TimeSpan) t)
{
ticks_ += t.ticks_;
return this;
}
}
    const template opBinary(immutable(char)[] o : "-")
{
TimeSpan opBinary(const(TimeSpan) t)
{
return TimeSpan(ticks_ - t.ticks_);
}
}

    template opOpAssign(immutable(char)[] o : "-")
{
TimeSpan opOpAssign(const(TimeSpan) t)
{
ticks_ -= t.ticks_;
return this;
}
}
    const template opBinary(immutable(char)[] o : "*")
{
TimeSpan opBinary(long v)
{
return TimeSpan(ticks_ * v);
}
}

    template opOpAssign(immutable(char)[] o : "*")
{
TimeSpan opOpAssign(long v)
{
ticks_ *= v;
return this;
}
}
    const template opBinary(immutable(char)[] o : "/")
{
TimeSpan opBinary(long v)
{
return TimeSpan(ticks_ / v);
}
}

    template opOpAssign(immutable(char)[] o : "/")
{
TimeSpan opOpAssign(long v)
{
ticks_ /= v;
return this;
}
}
    const template opBinary(immutable(char)[] o : "/")
{
long opBinary(const(TimeSpan) t)
{
return ticks_ / t.ticks;
}
}

    const template opUnary(immutable(char)[] o : "-")
{
TimeSpan opUnary()
{
return TimeSpan(-ticks_);
}
}

    const @property long nanos()
{
return ticks_ * NanosecondsPerTick;
}

    const @property long micros()
{
return ticks_ / TicksPerMicrosecond;
}

    const @property long millis()
{
return ticks_ / TicksPerMillisecond;
}

    const @property long seconds()
{
return ticks_ / TicksPerSecond;
}

    const @property long minutes()
{
return ticks_ / TicksPerMinute;
}

    const @property long hours()
{
return ticks_ / TicksPerHour;
}

    const @property long days()
{
return ticks_ / TicksPerDay;
}

    const @property double interval()
{
return cast(double)ticks_ / TicksPerSecond;
}

    const @property TimeOfDay time()
{
return TimeOfDay(ticks_);
}

    static TimeSpan fromNanos(long value)
{
return TimeSpan(value / NanosecondsPerTick);
}

    static TimeSpan fromMicros(long value)
{
return TimeSpan(TicksPerMicrosecond * value);
}

    static TimeSpan fromMillis(long value)
{
return TimeSpan(TicksPerMillisecond * value);
}

    static TimeSpan fromSeconds(long value)
{
return TimeSpan(TicksPerSecond * value);
}

    static TimeSpan fromMinutes(long value)
{
return TimeSpan(TicksPerMinute * value);
}

    static TimeSpan fromHours(long value)
{
return TimeSpan(TicksPerHour * value);
}

    static TimeSpan fromDays(long value)
{
return TimeSpan(TicksPerDay * value);
}

    static TimeSpan fromInterval(double sec)
{
return TimeSpan(cast(long)(sec * TicksPerSecond + 0.1));
}

}
struct Time
{
    private long ticks_;

    private enum : long
{
maximum = (TimeSpan.DaysPer400Years * 25 - 366) * TimeSpan.TicksPerDay - 1,
minimum = -((TimeSpan.DaysPer400Years * 25 - 366) * TimeSpan.TicksPerDay - 1),
}

    enum Time min = {minimum};
    enum Time max = {maximum};
    enum Time epoch = {0};
    enum Time epoch1601 = {TimeSpan.Epoch1601};
    enum Time epoch1970 = {TimeSpan.Epoch1970};
    const @property long ticks()
{
return ticks_;
}

    const bool opEquals(ref const(Time) t)
{
return ticks_ is t.ticks_;
}

    const int opCmp(const(Time) t)
{
if (ticks_ < t.ticks_)
return -1;
if (ticks_ > t.ticks_)
return 1;
return 0;
}

    const template opBinary(immutable(char)[] o : "+")
{
Time opBinary(const(TimeSpan) t)
{
return Time(ticks_ + t.ticks_);
}
}

    template opOpAssign(immutable(char)[] o : "+")
{
Time opOpAssign(const(TimeSpan) t)
{
ticks_ += t.ticks_;
return this;
}
}
    const template opBinary(immutable(char)[] o : "-")
{
Time opBinary(const(TimeSpan) t)
{
return Time(ticks_ - t.ticks_);
}
}

    const template opBinary(immutable(char)[] o : "-")
{
TimeSpan opBinary(const(Time) t)
{
return TimeSpan(ticks_ - t.ticks_);
}
}

    template opOpAssign(immutable(char)[] o : "-")
{
Time opOpAssign(const(TimeSpan) t)
{
ticks_ -= t.ticks_;
return this;
}
}
    const @property Time date()
{
return this - TimeOfDay.modulo24(ticks_);
}

    const @property TimeOfDay time()
{
return TimeOfDay(ticks_);
}

    const @property TimeSpan span()
{
return TimeSpan(ticks_);
}

    const @property TimeSpan unix()
{
return TimeSpan(ticks_ - epoch1970.ticks_);
}

}
struct TimeOfDay
{
    public uint hours;

    public uint minutes;

    public uint seconds;

    public uint millis;

    static TimeOfDay opCall(uint hours, uint minutes, uint seconds, uint millis = 0)
{
TimeOfDay t = void;
t.hours = hours;
t.minutes = minutes;
t.seconds = seconds;
t.millis = millis;
return t;
}

    static TimeOfDay opCall(long ticks)
{
TimeOfDay t = void;
ticks = modulo24(ticks).ticks_;
t.millis = cast(uint)(ticks / TimeSpan.TicksPerMillisecond);
t.seconds = t.millis / 1000 % 60;
t.minutes = t.millis / 60000 % 60;
t.hours = t.millis / 3600000 % 24;
t.millis %= 1000;
return t;
}

    const @property TimeSpan span()
{
return TimeSpan.fromHours(hours) + TimeSpan.fromMinutes(minutes) + TimeSpan.fromSeconds(seconds) + TimeSpan.fromMillis(millis);
}

    package static TimeSpan modulo24(long ticks)
{
ticks %= TimeSpan.TicksPerDay;
if (ticks < 0)
ticks += TimeSpan.TicksPerDay;
return TimeSpan(ticks);
}


}
struct Date
{
    public 
{
    uint era;
    uint day;
    uint year;
    uint month;
    uint dow;
    uint doy;
}
}
struct DateTime
{
    public Date date;

    public TimeOfDay time;

}
debug (UnitTest)
{
    }
debug (Time)
{
    import tango.io.Stdout;
    import tango.time.Clock;
    import tango.time.chrono.Gregorian;
    Time foo()
{
auto d = Time(10);
auto e = TimeSpan(20);
return d + e;
}
    void main()
{
auto c = foo();
Stdout(c.ticks).newline;
auto t = TimeSpan(1);
auto h = t.hours;
auto m = t.time.minutes;
auto now = Clock.now;
auto time = now.time;
auto date = Gregorian.generic.toDate(now);
now = Gregorian.generic.toTime(date,time);
}
}
