// D import file generated from 'tango/time/chrono/GregorianBased.d'
module tango.time.chrono.GregorianBased;
private import tango.core.Exception;

private import tango.time.Time;

private import tango.time.chrono.Gregorian;

class GregorianBased : Gregorian
{
    private EraRange[] eraRanges_;

    private 
{
    int maxYear_;
    int minYear_;
}
    private int currentEra_ = -1;

    this()
{
eraRanges_ = EraRange.getEraRanges(id);
maxYear_ = eraRanges_[0].maxEraYear;
minYear_ = eraRanges_[0].minEraYear;
currentEra_ = EraRange.getCurrentEra(id);
}
    public const override Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond, uint era)
{
year = getGregorianYear(year,era);
return super.toTime(year,month,day,hour,minute,second,millisecond,era);
}


    public const override uint getYear(const(Time) time);


    public const override uint getEra(const(Time) time);


    public const override uint[] eras();


    private const uint getGregorianYear(uint year, uint era);


    @property protected const uint currentEra()
{
return currentEra_;
}



}
package struct EraRange
{
    private static EraRange[][uint] eraRanges;


    private static uint[uint] currentEras;


    private static bool initialized_;


    package uint era;

    package long ticks;

    package uint yearOffset;

    package uint minEraYear;

    package uint maxEraYear;

    private static void initialize();


    package static EraRange[] getEraRanges(uint calID)
{
if (!initialized_)
initialize();
return eraRanges[calID];
}


    package static uint getCurrentEra(uint calID)
{
if (!initialized_)
initialize();
return currentEras[calID];
}


    private static EraRange opCall(uint era, long ticks, uint yearOffset, uint minEraYear, uint prevEraYear)
{
EraRange eraRange;
eraRange.era = era;
eraRange.ticks = ticks;
eraRange.yearOffset = yearOffset;
eraRange.minEraYear = minEraYear;
eraRange.maxEraYear = prevEraYear - yearOffset;
return eraRange;
}


}

