// D import file generated from 'tango/time/chrono/Hijri.d'
module tango.time.chrono.Hijri;
private import tango.time.chrono.Calendar;

public class Hijri : Calendar
{
    private enum uint[] DAYS_TO_MONTH = [0,30,59,89,118,148,177,207,236,266,295,325,355];

    public enum uint HIJRI_ERA = 1;

    public const override Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond, uint era)
{
return Time((daysSinceJan1(year,month,day) - 1) * TimeSpan.TicksPerDay + getTimeTicks(hour,minute,second)) + TimeSpan.fromMillis(millisecond);
}


    public const override DayOfWeek getDayOfWeek(const(Time) time)
{
return cast(DayOfWeek)(cast(uint)(time.ticks / TimeSpan.TicksPerDay + 1) % 7);
}


    public const override uint getDayOfMonth(const(Time) time)
{
return extractPart(time.ticks,DatePart.Day);
}


    public const override uint getDayOfYear(const(Time) time)
{
return extractPart(time.ticks,DatePart.DayOfYear);
}


    public const override uint getMonth(const(Time) time)
{
return extractPart(time.ticks,DatePart.Month);
}


    public const override uint getYear(const(Time) time)
{
return extractPart(time.ticks,DatePart.Year);
}


    public const override uint getEra(const(Time) time)
{
return HIJRI_ERA;
}


    public const override uint getDaysInMonth(uint year, uint month, uint era)
{
if (month == 12)
return isLeapYear(year,CURRENT_ERA) ? 30 : 29;
return month % 2 == 1 ? 30 : 29;
}


    public const override uint getDaysInYear(uint year, uint era)
{
return isLeapYear(year,era) ? 355 : 354;
}


    public const override uint getMonthsInYear(uint year, uint era)
{
return 12;
}


    public const override bool isLeapYear(uint year, uint era)
{
return (14 + 11 * year) % 30 < 11;
}


    public const override uint[] eras()
{
auto tmp = [HIJRI_ERA];
return tmp.dup;
}


    public const override uint id()
{
return HIJRI;
}


    private const long daysToYear(uint year);


    private const long daysSinceJan1(uint year, uint month, uint day)
{
return cast(long)(daysToYear(year) + DAYS_TO_MONTH[month - 1] + day);
}


    private const int extractPart(long ticks, DatePart part);


}

