// D import file generated from 'tango/util/cipher/ChaCha.d'
module tango.util.cipher.ChaCha;
private import tango.util.cipher.Cipher;

private import tango.util.cipher.Salsa20;

class ChaCha : Salsa20
{
    override @property const(char)[] name()
{
return "ChaCha";
}

    this()
{
i0 = 12;
i1 = 13;
}
    this(bool encrypt, ubyte[] key, ubyte[] iv)
{
this();
init(encrypt,key,iv);
}
    override protected void keySetup()
{
uint offset;
const(ubyte)[] constants;
state[4] = ByteConverter.LittleEndian.to!(uint)(workingKey[0..4]);
state[5] = ByteConverter.LittleEndian.to!(uint)(workingKey[4..8]);
state[6] = ByteConverter.LittleEndian.to!(uint)(workingKey[8..12]);
state[7] = ByteConverter.LittleEndian.to!(uint)(workingKey[12..16]);
if (workingKey.length == 32)
{
constants = sigma;
offset = 16;
}
else
constants = tau;
state[8] = ByteConverter.LittleEndian.to!(uint)(workingKey[offset..offset + 4]);
state[9] = ByteConverter.LittleEndian.to!(uint)(workingKey[offset + 4..offset + 8]);
state[10] = ByteConverter.LittleEndian.to!(uint)(workingKey[offset + 8..offset + 12]);
state[11] = ByteConverter.LittleEndian.to!(uint)(workingKey[offset + 12..offset + 16]);
state[0] = ByteConverter.LittleEndian.to!(uint)(constants[0..4]);
state[1] = ByteConverter.LittleEndian.to!(uint)(constants[4..8]);
state[2] = ByteConverter.LittleEndian.to!(uint)(constants[8..12]);
state[3] = ByteConverter.LittleEndian.to!(uint)(constants[12..16]);
}


    override protected void ivSetup()
{
state[12] = (state[13] = 0);
state[14] = ByteConverter.LittleEndian.to!(uint)(workingIV[0..4]);
state[15] = ByteConverter.LittleEndian.to!(uint)(workingIV[4..8]);
}


    override protected void salsa20WordToByte(const(uint[]) input, ref ubyte[] output);


    debug (UnitTest)
{
    import std.stdio;
    }
}
