// D import file generated from 'tango/util/cipher/RC4.d'
module tango.util.cipher.RC4;
private import tango.util.cipher.Cipher;

class RC4 : StreamCipher
{
    private 
{
    ubyte[] state;
    const(ubyte)[] workingKey;
    ubyte x;
    ubyte y;
}
    this()
{
state = new ubyte[](256);
}
    this(bool encrypt, ubyte[] key)
{
this();
init(encrypt,key);
}
    final void init(bool encrypt, ubyte[] key)
{
if (key.length < 0 || key.length > 256)
invalid(name() ~ ": Invalid key length (requires 1-256 bytes)");
workingKey = key;
setup(workingKey);
_encrypt = (_initialized = true);
}

    final override @property const(char)[] name()
{
return "RC4";
}

    override ubyte returnByte(ubyte input)
{
if (!_initialized)
invalid(name() ~ ": Cipher not initialized");
y += state[++x];
ubyte t = state[x];
state[x] = state[y];
state[y] = t;
return input ^ state[cast(ubyte)(state[x] + state[y])];
}

    final override uint update(const(void[]) input_, void[] output_)
{
if (!_initialized)
invalid(name() ~ ": Cipher not initialized");
const(ubyte[]) input = cast(const(ubyte[]))input_;
ubyte[] output = cast(ubyte[])output_;
if (input.length > output.length)
invalid(name() ~ ": Output buffer too short");
{
for (int i = 0;
 i < input.length; i++)
{
{
y += state[++x];
ubyte t = state[x];
state[x] = state[y];
state[y] = t;
output[i] = input[i] ^ state[cast(ubyte)(state[x] + state[y])];
}
}
}
return cast(uint)input.length;
}

    final override void reset()
{
setup(workingKey);
}

    private void setup(const(ubyte)[] key)
{
{
for (int i = 0;
 i < 256; i++)
{
state[i] = cast(ubyte)i;
}
}
x = 0;
{
for (int i = 0;
 i < 256; i++)
{
{
x += key[i % key.length] + state[i];
ubyte t = state[i];
state[i] = state[x];
state[x] = t;
}
}
}
x = (y = 0);
}

    debug (UnitTest)
{
    }
}
