// D import file generated from 'tango/util/cipher/RC6.d'
module tango.util.cipher.RC6;
private import tango.util.cipher.Cipher;

class RC6 : BlockCipher
{
    private 
{
    enum uint ROUNDS = 20;
    enum uint BLOCK_SIZE = 16;
    enum uint P = -1209970333u;
    enum uint Q = -1640531527u;
    uint[] S;
    const(ubyte)[] workingKey;
}
    this()
{
}
    this(bool encrypt, ubyte[] key)
{
this();
init(encrypt,key);
}
    final override @property const(char)[] name()
{
return "RC6";
}

    const final override @property uint blockSize()
{
return BLOCK_SIZE;
}

    final void init(bool encrypt, ubyte[] key)
{
_encrypt = encrypt;
auto len = key.length;
if (len != 16 && len != 24 && len != 32)
invalid(name() ~ ": Invalid key length (requires 16/24/32 bytes)");
S = new uint[](2 * ROUNDS + 4);
workingKey = key;
setup(workingKey);
_initialized = true;
}

    final override uint update(const(void[]) input_, void[] output_);

    final override void reset()
{
setup(workingKey);
}

    private void setup(const(ubyte)[] key)
{
size_t c = key.length / 4;
uint[] L = new uint[](c);
{
for (int i = 0,j = 0; i < c; i++ , j += 4)
{
L[i] = ByteConverter.LittleEndian.to!(uint)(key[j..j + (int).sizeof]);
}
}
S[0] = P;
{
for (int i = 1;
 i <= 2 * ROUNDS + 3; i++)
{
S[i] = S[i - 1] + Q;
}
}
uint A,B,i,j,v = 3 * (2 * ROUNDS + 4);
{
for (int s = 1;
 s <= v; s++)
{
{
A = (S[i] = Bitwise.rotateLeft(S[i] + A + B,3u));
B = (L[j] = Bitwise.rotateLeft(L[j] + A + B,A + B));
i = (i + 1) % (2 * ROUNDS + 4);
j = (j + 1) % c;
}
}
}
}

    debug (UnitTest)
{
    }
}
