// D import file generated from 'tango/util/compress/Zip.d'
module tango.util.compress.Zip;
import tango.core.ByteSwap;
import tango.io.device.Array;
import tango.io.device.File;
import Path = tango.io.Path;
import tango.io.device.FileMap;
import tango.io.stream.Zlib;
import tango.util.digest.Crc32;
import tango.io.model.IConduit;
import tango.io.stream.Digester;
import tango.time.Time;
import tango.time.WallClock;
import tango.time.chrono.Gregorian;
import Path = tango.io.Path;
import Integer = tango.text.convert.Integer;
debug (Zip)
{
    import tango.io.Stdout;
}
private 
{
    align (1)struct LocalFileHeaderData
{
    ushort extract_version = (ushort).max;
    ushort general_flags = 0;
    ushort compression_method = 0;
    ushort modification_file_time = 0;
    ushort modification_file_date = 0;
    uint crc_32 = 0;
    uint compressed_size = 0;
    uint uncompressed_size = 0;
    ushort file_name_length = 0;
    ushort extra_field_length = 0;
    debug (Zip)
{
    void dump()
{
Stderr("LocalFileHeader.Data {")("\x0a")("  extract_version = ")(extract_version)("\x0a")("  general_flags = ")(general_flags)("\x0a")("  compression_method = ")(compression_method)("\x0a")("  modification_file_time = ")(modification_file_time)("\x0a")("  modification_file_date = ")(modification_file_date)("\x0a")("  crc_32 = ")(crc_32)("\x0a")("  compressed_size = ")(compressed_size)("\x0a")("  uncompressed_size = ")(uncompressed_size)("\x0a")("  file_name_length = ")(file_name_length)("\x0a")("  extra_field_length = ")(extra_field_length)("\x0a")("}").newline;
}
}
}

    struct LocalFileHeader
{
    const uint signature = 67324752;

    alias LocalFileHeaderData Data;
    Data data;
    static assert(Data.sizeof == 26);
    char[] file_name;
    ubyte[] extra_field;
    void[] data_arr()
{
return (&data)[0..1];
}
    void put(OutputStream output);
    void fill(InputStream src);
    bool agrees_with(FileHeader h)
{
if (data.extract_version != h.data.extract_version || data.general_flags != h.data.general_flags || data.compression_method != h.data.compression_method || data.modification_file_time != h.data.modification_file_time || data.modification_file_date != h.data.modification_file_date || file_name != h.file_name)
return false;
if (!h.usingDataDescriptor() && (data.crc_32 != h.data.crc_32 || data.compressed_size != h.data.compressed_size || data.uncompressed_size != h.data.uncompressed_size))
return false;
return true;
}
}
    align (1)struct FileHeaderData
{
    ubyte zip_version;
    ubyte file_attribute_type;
    ushort extract_version;
    ushort general_flags;
    ushort compression_method;
    ushort modification_file_time;
    ushort modification_file_date;
    uint crc_32;
    uint compressed_size;
    uint uncompressed_size;
    ushort file_name_length;
    ushort extra_field_length;
    ushort file_comment_length;
    ushort disk_number_start;
    ushort internal_file_attributes = 0;
    uint external_file_attributes = 0;
    int relative_offset_of_local_header;
    debug (Zip)
{
    void dump()
{
Stderr("FileHeader.Data {\x0a")("  zip_version = ")(zip_version)("\x0a")("  file_attribute_type = ")(file_attribute_type)("\x0a")("  extract_version = ")(extract_version)("\x0a")("  general_flags = ")(general_flags)("\x0a")("  compression_method = ")(compression_method)("\x0a")("  modification_file_time = ")(modification_file_time)("\x0a")("  modification_file_date = ")(modification_file_date)("\x0a")("  crc_32 = ")(crc_32)("\x0a")("  compressed_size = ")(compressed_size)("\x0a")("  uncompressed_size = ")(uncompressed_size)("\x0a")("  file_name_length = ")(file_name_length)("\x0a")("  extra_field_length = ")(extra_field_length)("\x0a")("  file_comment_length = ")(file_comment_length)("\x0a")("  disk_number_start = ")(disk_number_start)("\x0a")("  internal_file_attributes = ")(internal_file_attributes)("\x0a")("  external_file_attributes = ")(external_file_attributes)("\x0a")("  relative_offset_of_local_header = ")(relative_offset_of_local_header)("\x0a")("}").newline;
}
}
    void fromLocal(LocalFileHeader.Data data)
{
extract_version = data.extract_version;
general_flags = data.general_flags;
compression_method = data.compression_method;
modification_file_time = data.modification_file_time;
modification_file_date = data.modification_file_date;
crc_32 = data.crc_32;
compressed_size = data.compressed_size;
uncompressed_size = data.uncompressed_size;
file_name_length = data.file_name_length;
extra_field_length = data.extra_field_length;
}
}

    struct FileHeader
{
    const uint signature = 33639248;

    alias FileHeaderData Data;
    Data* data;
    static assert(Data.sizeof == 42);
    const(char)[] file_name;
    ubyte[] extra_field;
    const(char)[] file_comment;
    bool usingDataDescriptor()
{
return !!(data.general_flags & 1 << 3);
}
    uint compressionOptions()
{
return data.general_flags >> 1 & 3;
}
    bool usingUtf8()
{
return false;
}
    void[] data_arr()
{
return (cast(void*)data)[0..Data.sizeof];
}
    void put(OutputStream output);
    long map(void[] src);
}
    align (1)struct EndOfCDRecordData
{
    ushort disk_number = 0;
    ushort disk_with_start_of_central_directory = 0;
    ushort central_directory_entries_on_this_disk;
    ushort central_directory_entries_total;
    uint size_of_central_directory;
    uint offset_of_start_of_cd_from_starting_disk;
    ushort file_comment_length;
    debug (Zip)
{
    void dump()
{
Stderr.formatln("EndOfCDRecord.Data {}","{").formatln("  disk_number = {}",disk_number).formatln("  disk_with_start_of_central_directory = {}",disk_with_start_of_central_directory).formatln("  central_directory_entries_on_this_disk = {}",central_directory_entries_on_this_disk).formatln("  central_directory_entries_total = {}",central_directory_entries_total).formatln("  size_of_central_directory = {}",size_of_central_directory).formatln("  offset_of_start_of_cd_from_starting_disk = {}",offset_of_start_of_cd_from_starting_disk).formatln("  file_comment_length = {}",file_comment_length).formatln("}");
}
}
}

    struct EndOfCDRecord
{
    const uint signature = 101010256;

    alias EndOfCDRecordData Data;
    Data data;
    static assert(data.sizeof == 18);
    char[] file_comment;
    void[] data_arr()
{
return (cast(void*)&data)[0..data.sizeof];
}
    void put(OutputStream output);
    void fill(void[] src);
}
}
public enum Method 
{
Store,
Deflate,
Unsupported,
}

private 
{
    const ushort ZIP_VERSION = 20;

    const ushort MAX_EXTRACT_VERSION = 20;

    const ushort SUPPORTED_FLAGS = 14;

    const ushort UNSUPPORTED_FLAGS = ~SUPPORTED_FLAGS;

    Method toMethod(ushort method);
    ushort fromMethod(Method method);
}
interface ZipReader
{
    bool streamed();
    void close();
    bool more();
    ZipEntry get();
    ZipEntry get(ZipEntry);
    int opApply(int delegate(ref ZipEntry));
}
interface ZipWriter
{
    void finish();
    void putFile(ZipEntryInfo info, const(char)[] path);
    void putStream(ZipEntryInfo info, InputStream source);
    void putEntry(ZipEntryInfo info, ZipEntry entry);
    void putData(ZipEntryInfo info, const(void)[] data);
    Method method();
    Method method(Method);
}
class ZipBlockReader : ZipReader
{
    this(const(char)[] path)
{
file_source = new File(path);
this(file_source);
}
    this(InputStream source)
in
{
assert(cast(IConduit.Seek)source.conduit,"source stream must be seekable");
}
body
{
this.source = source;
this.seeker = source;
}
    bool streamed()
{
return false;
}
    void close()
{
state = State.Done;
source = null;
seeker = null;
delete headers;
if (file_source !is null)
{
file_source.close();
delete file_source;
}
}
    bool more();
    ZipEntry get()
{
if (!more())
ZipExhaustedException();
return new ZipEntry(headers[current_index++],&open_file);
}
    ZipEntry get(ZipEntry reuse)
{
if (!more())
ZipExhaustedException();
if (reuse is null)
return new ZipEntry(headers[current_index++],&open_file);
else
return reuse.reset(headers[current_index++],&open_file);
}
    int opApply(int delegate(ref ZipEntry) dg);
    private 
{
    InputStream source;
    InputStream seeker;
    enum State 
{
Init,
Open,
Done,
}
    State state;
    size_t current_index = 0;
    FileHeader[] headers;
    ubyte[] cd_data;
    File file_source = null;
    void read_cd();
    EndOfCDRecord read_eocd_record();
    InputStream open_file(FileHeader header, bool raw);
    InputStream open_file_raw(FileHeader header);
}
}
class ZipBlockWriter : ZipWriter
{
    this(const(char)[] path)
{
file_output = new File(path,File.WriteCreate);
this(file_output);
}
    this(OutputStream output)
in
{
assert(output !is null);
assert(cast(IConduit.Seek)output.conduit !is null);
}
body
{
this.output = output;
this.seeker = output;
method = Method.Deflate;
}
    void finish()
{
put_cd();
output.close();
output = null;
seeker = null;
if (file_output !is null)
delete file_output;
}
    void putFile(ZipEntryInfo info, const(char)[] path);
    void putStream(ZipEntryInfo info, InputStream source)
{
put_compressed(info,source);
}
    void putEntry(ZipEntryInfo info, ZipEntry entry)
{
put_raw(info,entry);
}
    void putData(ZipEntryInfo info, const(void)[] data);
    @property Method method()
{
return _method;
}

    @property Method method(Method v)
{
return _method = v;
}

    private 
{
    OutputStream output;
    OutputStream seeker;
    File file_output;
    Method _method;
    struct Entry
{
    FileHeaderData data;
    long header_position;
    const(char)[] filename;
    const(char)[] comment;
    ubyte[] extra;
}
    Entry[] entries;
    void put_cd();
    void put_raw(ZipEntryInfo info, ZipEntry entry);
    void put_compressed(ZipEntryInfo info, InputStream source);
    void patch_local_header(uint crc_32, uint compressed_size, uint uncompressed_size);
    void put_local_header(ZipEntryInfo info, Method method)
{
LocalFileHeader.Data data;
data.compression_method = fromMethod(method);
timeToDos(info.modified,data.modification_file_time,data.modification_file_date);
put_local_header(data,info.name);
}
    void put_local_header(LocalFileHeaderData data, const(char)[] file_name);
}
}
class ZipEntry
{
    ZipEntryInfo info;
    uint size()
{
return header.data.uncompressed_size;
}
    InputStream open()
{
if (!verified)
return new ZipEntryVerifier(this,open_dg(header,false));
else
return open_dg(header,false);
}
    void verify();
    ZipEntry dup()
{
return new ZipEntry(header,open_dg);
}
    private 
{
    alias InputStream delegate(FileHeader, bool raw) open_dg_t;
    open_dg_t open_dg;
    FileHeader header;
    bool verified = false;
    InputStream open_raw()
{
return open_dg(header,true);
}
    this(FileHeader header, open_dg_t open_dg)
{
this.reset(header,open_dg);
}
    ZipEntry reset(FileHeader header, open_dg_t open_dg);
}
}
struct ZipEntryInfo
{
    const(char)[] name;
    Time modified = Time.min;
    const(char)[] comment;
}
class ZipException : Exception
{
    this(immutable(char)[] msg)
{
super(msg);
}
    private 
{
    alias typeof(this) thisT;
    static void opCall(immutable(char)[] msg);

    @property static void badsig()
{
thisT("corrupt signature or unexpected section found");
}


    @property static void badsig(const(char)[] type)
{
thisT("corrupt " ~ type.idup ~ " signature or unexpected section found");
}


    @property static void incons(const(char)[] name)
{
thisT("inconsistent headers for file \"" ~ name.idup ~ "\"; archive is likely corrupted");
}


    @property static void missingdir()
{
thisT("could not locate central archive directory; file is corrupt or possibly not a Zip archive");
}


    @property static void toomanyentries()
{
thisT("too many archive entries");
}


    @property static void toolong()
{
thisT("archive is too long; limited to 4GB total");
}


    @property static void cdtoolong()
{
thisT("central directory is too long; limited to 4GB total");
}


    @property static void fntoolong()
{
thisT("file name too long; limited to 65,535 characters");
}


    @property static void eftoolong()
{
thisT("extra field too long; limited to 65,535 characters");
}


    @property static void cotoolong()
{
thisT("extra field too long; limited to 65,535 characters");
}


    @property static void fnencode()
{
thisT("could not encode filename into codepage 437");
}


    @property static void coencode()
{
thisT("could not encode comment into codepage 437");
}


    @property static void tooold()
{
thisT("cannot represent dates before January 1, 1980");
}


}
}
class ZipChecksumException : ZipException
{
    this(const(char)[] name)
{
super("checksum failed on zip entry \"" ~ name.idup ~ "\"");
}
    private static void opCall(const(char)[] name);


}
class ZipExhaustedException : ZipException
{
    this()
{
super("no more entries in archive");
}
    private static void opCall();


}
class ZipNotSupportedException : ZipException
{
    this(immutable(char)[] msg)
{
super(msg);
}
    private 
{
    alias ZipNotSupportedException thisT;
    static void opCall(const(char)[] msg);

    static void spanned()
{
thisT("split and multi-disk archives");
}

    static void zipver(ushort ver);

    static void flags();

    static void method(ushort m);

}
}
void createArchive(const(char)[] archive, Method method, const(char)[][] files...);
void extractArchive(const(char)[] archive, const(char)[] dest);
private 
{
    class ZipEntryVerifier : InputStream
{
    this(ZipEntry entry, InputStream source)
in
{
assert(entry !is null);
assert(source !is null);
}
body
{
this.entry = entry;
this.digest = new Crc32;
this.source = new DigestInput(source,digest);
}
    IConduit conduit()
{
return source.conduit;
}
    InputStream input()
{
return source;
}
    long seek(long ofs, Anchor anchor = Anchor.Begin)
{
return source.seek(ofs,anchor);
}
    void close()
{
check();
this.source.close();
this.entry = null;
this.digest = null;
this.source = null;
}
    size_t read(void[] dst)
{
auto bytes = source.read(dst);
if (bytes == IConduit.Eof)
check();
return bytes;
}
    override void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}

    override InputStream flush()
{
this.source.flush();
return this;
}

    private 
{
    Crc32 digest;
    InputStream source;
    ZipEntry entry;
    void check()
{
if (digest is null)
return ;
auto crc = digest.crc32Digest();
delete digest;
if (crc != entry.header.data.crc_32)
ZipChecksumException(entry.info.name);
else
entry.verified = true;
}
}
}
    void readExact(InputStream s, void[] dst);
    void writeExact(OutputStream s, const(void)[] src);
    template write(T)
{
void write(OutputStream s, T value)
{
version (BigEndian)
{
swap(value);
}

writeExact(s,(&value)[0..1]);
}
}
    template swapAll(T)
{
void swapAll(ref T data)
{
static if(is(typeof(T.record_fields)))
{
const fields = T.record_fields;
}
else
{
const fields = data.tupleof.length;
}

foreach (i, _; data.tupleof)
{
if (i == fields)
break;
swap(data.tupleof[i]);
}
}
}
    template swap(T)
{
void swap(ref T data)
{
static if(T.sizeof == 1)
{
}
else
{
static if(T.sizeof == 2)
{
ByteSwap.swap16(&data,2);
}
else
{
static if(T.sizeof == 4)
{
ByteSwap.swap32(&data,4);
}
else
{
static if(T.sizeof == 8)
{
ByteSwap.swap64(&data,8);
}
else
{
static if(T.sizeof == 10)
{
ByteSwap.swap80(&data,10);
}
else
{
static assert(false,"Can't swap " ~ T.stringof ~ "s.");
}

}

}

}

}

}
}
    const char[][] cp437_to_utf8_map_low = ["\x00"[],"\xe2\x98\xba","\xe2\x98\xbb","\xe2\x99\xa5","\xe2\x99\xa6","\xe2\x99\xa3","\xe2\x99\xa0","\xe2\x80\xa2","\xe2\x97\x98","\xe2\x97\x8b","\xe2\x97\x99","\xe2\x99\x82","\xe2\x99\x80","\xe2\x99\xaa","\xe2\x99\xab","\xe2\x98\xbc","\xe2\x96\xb6","\xe2\x97\x80","\xe2\x86\x95","\xe2\x80\xbc","\xc2\xb6","\xc2\xa7","\xe2\x96\xac","\xe2\x86\xa8","\xe2\x86\x91","\xe2\x86\x93","\xe2\x86\x92","\xe2\x86\x90","\xe2\x88\x9f","\xe2\x86\x94","\xe2\x96\xb2","\xe2\x96\xbc"];

    const char[][] cp437_to_utf8_map_high = ["\xc3\x87"[],"\xc3\xbc","\xc3\xa9","\xc3\xa2","\xc3\xa4","\xc3\xa0","\xc3\xa5","\xc3\xa7","\xc3\xaa","\xc3\xab","\xc3\xa8","\xc3\xaf","\xc3\xae","\xc3\xac","\xc3\x84","\xc3\x85","\xc3\x89","\xc3\xa6","\xc3\x86","\xc3\xb4","\xc3\xb6","\xc3\xb2","\xc3\xbb","\xc3\xb9","\xc3\xbf","\xc3\x96","\xc3\x9c","\xc3\xb8","\xc2\xa3","\xc2\xa5","\xe2\x82\xa7","\xc6\x92","\xc3\xa1","\xc3\xad","\xc3\xb3","\xc3\xba","\xc3\xb1","\xc3\x91","\xc2\xaa","\xc2\xba","\xc2\xbf","\xe2\x8c\x90","\xc2\xac","\xc2\xbd","\xc2\xbc","\xc2\xa1","\xc2\xab","\xc2\xbb","\xe2\x96\x91","\xe2\x96\x92","\xe2\x96\x93","\xe2\x94\x82","\xe2\x94\xa4","\xe2\x95\xa1","\xe2\x95\xa2","\xe2\x95\x96","\xe2\x95\x95","\xe2\x95\xa3","\xe2\x95\x91","\xe2\x95\x97","\xe2\x95\x9d","\xe2\x95\x9c","\xe2\x95\x9b","\xe2\x94\x90","\xe2\x94\x94","\xe2\x94\xb4","\xe2\x94\xac","\xe2\x94\x9c","\xe2\x94\x80","\xe2\x94\xbc","\xe2\x95\x9e","\xe2\x95\x9f","\xe2\x95\x9a","\xe2\x95\x94","\xe2\x95\xa9","\xe2\x95\xa6","\xe2\x95\xa0","\xe2\x95\x90","\xe2\x95\xac","\xe2\x95\xa7","\xe2\x95\xa8","\xe2\x95\xa4","\xe2\x95\xa5","\xe2\x95\x99","\xe2\x95\x98","\xe2\x95\x92","\xe2\x95\x93","\xe2\x95\xab","\xe2\x95\xaa","\xe2\x94\x98","\xe2\x94\x8c","\xe2\x96\x88","\xe2\x96\x84","\xe2\x96\x8c","\xe2\x96\x90","\xe2\x96\x80","\xce\xb1","\xc3\x9f","\xce\x93","\xcf\x80","\xce\xa3","\xcf\x83","\xc2\xb5","\xcf\x84","\xce\xa6","\xce\x98","\xce\xa9","\xce\xb4","\xe2\x88\x9e","\xcf\x86","\xce\xb5","\xe2\x88\xa9","\xe2\x89\xa1","\xc2\xb1","\xe2\x89\xa5","\xe2\x89\xa4","\xe2\x8c\xa0","\xe2\x8c\xa1","\xc3\xb7","\xe2\x89\x88","\xc2\xb0","\xe2\x88\x99","\xc2\xb7","\xe2\x88\x9a","\xe2\x81\xbf","\xc2\xb2","\xe2\x96\xa0","\xc2\xa0"];

    inout(char[]) cp437_to_utf8(inout(ubyte[]) s);
    debug (UnitTest)
{
    }
    const __gshared char[dchar] utf8_to_cp437_map;

    shared static this();
    inout(ubyte)[] utf8_to_cp437(inout(char)[] s);
    debug (UnitTest)
{
    }
    inout(char[]) utf8_to_utf8(inout(ubyte[]) s)
{
return cast(typeof(return))s;
}
    ubyte[] utf8_to_utf8(char[] s)
{
return cast(ubyte[])s;
}
    void dosToTime(ushort dostime, ushort dosdate, out Time time)
{
uint sec,min,hour,day,mon,year;
sec = (dostime & 31) * 2;
min = (dostime & 2016) >> 5;
hour = (dostime & 63488) >> 11;
day = dosdate & 31;
mon = (dosdate & 480) >> 5;
year = ((dosdate & 65024) >> 9) + 1980;
time = Gregorian.generic.toTime(year,mon,day,hour,min,sec);
}
    void timeToDos(Time time, out ushort dostime, out ushort dosdate)
{
if (time == Time.min)
time = WallClock.now;
auto date = Gregorian.generic.toDate(time);
if (date.year < 1980)
ZipException.tooold;
auto tod = time.time();
dostime = cast(ushort)(tod.seconds / 2 | tod.minutes << 5 | tod.hours << 11);
dosdate = cast(ushort)(date.day | date.month << 5 | date.year - 1980 << 9);
}
    private 
{
    import tango.io.device.Conduit;
    class CounterInput : InputStream
{
    this(InputStream input)
in
{
assert(input !is null);
}
body
{
this.source = input;
}
    override IConduit conduit()
{
return source.conduit;
}

    InputStream input()
{
return source;
}
    long seek(long ofs, Anchor anchor = Anchor.Begin)
{
return source.seek(ofs,anchor);
}
    override void close()
{
source.close();
source = null;
}

    override size_t read(void[] dst)
{
auto read = source.read(dst);
if (read != IConduit.Eof)
_count += read;
return read;
}

    override void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}

    override InputStream flush()
{
source.flush();
return this;
}

    long count()
{
return _count;
}
    private 
{
    InputStream source;
    long _count;
}
}
    class CounterOutput : OutputStream
{
    this(OutputStream output)
in
{
assert(output !is null);
}
body
{
this.sink = output;
}
    override IConduit conduit()
{
return sink.conduit;
}

    OutputStream output()
{
return sink;
}
    long seek(long ofs, Anchor anchor = Anchor.Begin)
{
return sink.seek(ofs,anchor);
}
    override void close()
{
sink.close();
sink = null;
}

    override size_t write(const(void)[] dst)
{
auto wrote = sink.write(dst);
if (wrote != IConduit.Eof)
_count += wrote;
return wrote;
}

    override OutputStream copy(InputStream src, size_t max = -1)
{
Conduit.transfer(src,this,max);
return this;
}

    override OutputStream flush()
{
sink.flush();
return this;
}

    long count()
{
return _count;
}
    private 
{
    OutputStream sink;
    long _count;
}
}
    class SliceSeekInputStream : InputStream
{
    this(InputStream source, long begin, long length)
in
{
assert(source !is null);
assert(cast(IConduit.Seek)source.conduit !is null);
assert(begin >= 0);
assert(length >= 0);
}
body
{
this.source = source;
this.seeker = source;
this.begin = begin;
this.length = length;
}
    override IConduit conduit()
{
return source.conduit;
}

    override void close()
{
source = null;
seeker = null;
}

    override size_t read(void[] dst);

    override void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}

    override InputStream flush()
{
source.flush();
return this;
}

    InputStream input()
{
return source;
}
    override long seek(long offset, Anchor anchor = cast(Anchor)0);

    private 
{
    InputStream source;
    InputStream seeker;
    long _position;
    long begin;
    long length;
    }
}
    class SliceInputStream : InputStream
{
    this(InputStream source, long length)
in
{
assert(source !is null);
assert(length >= 0);
}
body
{
this.source = source;
this._length = length;
}
    override IConduit conduit()
{
return source.conduit;
}

    override void close()
{
source = null;
}

    InputStream input()
{
return source;
}
    long seek(long ofs, Anchor anchor = Anchor.Begin)
{
return source.seek(ofs,anchor);
}
    override size_t read(void[] dst);

    override void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}

    override InputStream flush()
{
source.flush();
return this;
}

    private 
{
    InputStream source;
    long _length;
    }
}
    class SliceSeekOutputStream : OutputStream
{
    this(OutputStream source, long begin, long length)
in
{
assert(cast(IConduit.Seek)source.conduit !is null);
assert(begin >= 0);
assert(length >= 0);
}
body
{
this.source = source;
this.seeker = source;
this.begin = begin;
this.length = length;
}
    override IConduit conduit()
{
return source.conduit;
}

    override void close()
{
source = null;
seeker = null;
}

    size_t write(const(void)[] src);
    override OutputStream copy(InputStream src, size_t max = -1)
{
Conduit.transfer(src,this,max);
return this;
}

    override OutputStream flush()
{
source.flush();
return this;
}

    override OutputStream output()
{
return source;
}

    override long seek(long offset, Anchor anchor = cast(Anchor)0);

    private 
{
    OutputStream source;
    OutputStream seeker;
    long _position;
    long begin;
    long length;
    }
}
    class WrapSeekInputStream : InputStream
{
    this(InputStream source)
in
{
assert(source !is null);
assert(cast(IConduit.Seek)source.conduit !is null);
}
body
{
this.source = source;
this.seeker = source;
this._position = seeker.seek(0,Anchor.Current);
}
    this(InputStream source, long position)
in
{
assert(position >= 0);
}
body
{
this(source);
this._position = position;
}
    override IConduit conduit()
{
return source.conduit;
}

    override void close()
{
source = null;
seeker = null;
}

    override size_t read(void[] dst)
{
if (seeker.seek(0,Anchor.Current) != _position)
seeker.seek(_position,Anchor.Begin);
auto read = source.read(dst);
if (read != IConduit.Eof)
_position += read;
return read;
}

    override void[] load(size_t max = -1)
{
return Conduit.load(this,max);
}

    override InputStream flush()
{
source.flush();
return this;
}

    InputStream input()
{
return source;
}
    override long seek(long offset, Anchor anchor = cast(Anchor)0)
{
seeker.seek(_position,Anchor.Begin);
return _position = seeker.seek(offset,anchor);
}

    private 
{
    InputStream source;
    InputStream seeker;
    long _position;
    }
}
    class WrapSeekOutputStream : OutputStream
{
    this(OutputStream source)
in
{
assert(cast(IConduit.Seek)source.conduit !is null);
}
body
{
this.source = source;
this.seeker = source;
this._position = seeker.seek(0,Anchor.Current);
}
    this(OutputStream source, long position)
in
{
assert(position >= 0);
}
body
{
this(source);
this._position = position;
}
    override IConduit conduit()
{
return source.conduit;
}

    override void close()
{
source = null;
seeker = null;
}

    size_t write(const(void)[] src)
{
if (seeker.seek(0,Anchor.Current) != _position)
seeker.seek(_position,Anchor.Begin);
auto wrote = source.write(src);
if (wrote != IConduit.Eof)
_position += wrote;
return wrote;
}
    override OutputStream copy(InputStream src, size_t max = -1)
{
Conduit.transfer(src,this,max);
return this;
}

    override OutputStream flush()
{
source.flush();
return this;
}

    override OutputStream output()
{
return source;
}

    override long seek(long offset, Anchor anchor = cast(Anchor)0)
{
seeker.seek(_position,Anchor.Begin);
return _position = seeker.seek(offset,anchor);
}

    private 
{
    OutputStream source;
    OutputStream seeker;
    long _position;
    }
}
}
}
