// D import file generated from 'tango/util/container/Clink.d'
module tango.util.container.Clink;
template Clink(V)
{
struct Clink
{
    alias Clink!(V) Type;
    alias Type* Ref;
    Ref prev;
    Ref next;
    V value;
    Ref set(V v)
{
return set(v,&this,&this);
}
    Ref set(V v, Ref p, Ref n)
{
value = v;
prev = p;
next = n;
return &this;
}
    const @property bool singleton()
{
return next is &this;
}

    void linkNext(Ref p)
{
if (p)
{
next.prev = p;
p.next = next;
p.prev = &this;
next = p;
}
}
    void addNext(V v, scope Ref delegate() alloc)
{
auto p = alloc().set(v,&this,next);
next.prev = p;
next = p;
}
    Ref addPrev(V v, scope Ref delegate() alloc)
{
auto p = prev;
auto c = alloc().set(v,p,&this);
p.next = c;
prev = c;
return c;
}
    void linkPrev(Ref p)
{
if (p)
{
prev.next = p;
p.prev = prev;
p.next = &this;
prev = p;
}
}
    const @property int size()
{
int c = 0;
auto p = &this;
do
{
++c;
p = p.next;
}
while (p !is &this);return c;
}

    Ref find(V element)
{
auto p = &this;
do
{
if (element == p.value)
return p;
p = p.next;
}
while (p !is &this);return null;
}
    const int count(V element)
{
int c = 0;
auto p = &this;
do
{
if (element == p.value)
++c;
p = p.next;
}
while (p !is &this);return c;
}

    Ref nth(size_t n)
{
auto p = &this;
{
for (int i = 0;
 i < n; ++i)
{
p = p.next;
}
}
return p;
}
    void unlinkNext()
{
auto nn = next.next;
nn.prev = &this;
next = nn;
}
    void unlinkPrev()
{
auto pp = prev.prev;
pp.next = &this;
prev = pp;
}
    void unlink()
{
auto p = prev;
auto n = next;
p.next = n;
n.prev = p;
prev = &this;
next = &this;
}
    const Ref copyList(scope Ref delegate() alloc)
{
auto hd = &this;
auto newlist = alloc().set(hd.value,null,null);
auto current = newlist;
{
for (const(Type)* p = next;
 p !is hd; p = p.next)
{
{
current.next = alloc().set(p.value,current,null);
current = current.next;
}
}
}
newlist.prev = current;
current.next = newlist;
return newlist;
}

}
}
