// D import file generated from 'tango/util/container/RedBlack.d'
module tango.util.container.RedBlack;
import tango.util.container.model.IContainer;
alias int AttributeDummy;
template RedBlack(V,A = AttributeDummy)
{
struct RedBlack
{
    alias RedBlack!(V,A) Type;
    alias Type* Ref;
    enum : bool
{
RED = false,
BLACK = true,
}
    package Ref left;

    package Ref right;

    package Ref parent;

    package V value;

    static if(!is(typeof(A) == AttributeDummy))
{
    A attribute;
}
    package bool color;

    static if(!is(typeof(A) == AttributeDummy))
{
    final Ref set(V v, A a)
{
attribute = a;
return set(v);
}

}
    final Ref set(V v)
{
value = v;
left = null;
right = null;
parent = null;
color = BLACK;
return &this;
}

    protected Ref dup(scope Ref delegate() alloc)
{
static if(is(typeof(A) == AttributeDummy))
{
auto t = alloc().set(value);
}
else
{
auto t = alloc().set(value,attribute);
}

t.color = color;
return t;
}

    public void checkImplementation()
{
assert(parent is null || &this is parent.left || &this is parent.right);
assert(left is null || &this is left.parent);
assert(right is null || &this is right.parent);
assert(color is BLACK || colorOf(left) is BLACK && colorOf(right) is BLACK);
if (left !is null)
left.checkImplementation();
if (right !is null)
right.checkImplementation();
}

    Ref leftmost()
{
auto p = &this;
for (; p.left; p = p.left)
{
{
}
}
return p;
}
    Ref rightmost()
{
auto p = &this;
for (; p.right; p = p.right)
{
{
}
}
return p;
}
    Ref root()
{
auto p = &this;
for (; p.parent; p = p.parent)
{
{
}
}
return p;
}
    bool isRoot()
{
return parent is null;
}
    Ref successor()
{
if (right)
return right.leftmost;
auto p = parent;
auto ch = &this;
while (p && ch is p.right)
{
ch = p;
p = p.parent;
}
return p;
}
    Ref predecessor()
{
if (left)
return left.rightmost;
auto p = parent;
auto ch = &this;
while (p && ch is p.left)
{
ch = p;
p = p.parent;
}
return p;
}
    @property size_t size()
{
auto c = 1;
if (left)
c += left.size;
if (right)
c += right.size;
return c;
}

    Ref find(V value, Compare!(V) cmp)
{
auto t = &this;
for (;;)
{
{
auto diff = cmp(value,t.value);
if (diff is 0)
return t;
else
if (diff < 0)
t = t.left;
else
t = t.right;
if (t is null)
break;
}
}
return null;
}
    Ref findFirst(V value, Compare!(V) cmp, bool after = true)
{
auto t = &this;
auto tLower = &this;
auto tGreater = &this;
for (;;)
{
{
auto diff = cmp(value,t.value);
if (diff is 0)
return t;
else
if (diff < 0)
{
tGreater = t;
t = t.left;
}
else
{
tLower = t;
t = t.right;
}
if (t is null)
break;
}
}
if (after)
{
if (cmp(value,tGreater.value) <= 0)
if (cmp(value,tGreater.value) < 0)
return tGreater;
}
else
{
if (cmp(value,tLower.value) >= 0)
if (cmp(value,tLower.value) > 0)
return tLower;
}
return null;
}
    int count(V value, Compare!(V) cmp)
{
auto c = 0;
auto t = &this;
while (t)
{
int diff = cmp(value,t.value);
if (diff is 0)
{
++c;
if (t.left is null)
t = t.right;
else
if (t.right is null)
t = t.left;
else
{
c += t.right.count(value,cmp);
t = t.left;
}
}
else
if (diff < 0)
t = t.left;
else
t = t.right;
}
return c;
}
    static if(!is(typeof(A) == AttributeDummy))
{
    Ref findAttribute(A attribute, Compare!(A) cmp)
{
auto t = &this;
while (t)
{
if (t.attribute == attribute)
return t;
else
if (t.right is null)
t = t.left;
else
if (t.left is null)
t = t.right;
else
{
auto p = t.left.findAttribute(attribute,cmp);
if (p !is null)
return p;
else
t = t.right;
}
}
return null;
}
    int countAttribute(A attrib, Compare!(A) cmp)
{
int c = 0;
auto t = &this;
while (t)
{
if (t.attribute == attribute)
++c;
if (t.right is null)
t = t.left;
else
if (t.left is null)
t = t.right;
else
{
c += t.left.countAttribute(attribute,cmp);
t = t.right;
}
}
return c;
}
    Ref find(V value, A attribute, Compare!(V) cmp)
{
auto t = &this;
for (;;)
{
{
int diff = cmp(value,t.value);
if (diff is 0 && t.attribute == attribute)
return t;
else
if (diff <= 0)
t = t.left;
else
t = t.right;
if (t is null)
break;
}
}
return null;
}
}
    Ref copyTree(scope Ref delegate() alloc)
{
auto t = dup(alloc);
if (left)
{
t.left = left.copyTree(alloc);
t.left.parent = t;
}
if (right)
{
t.right = right.copyTree(alloc);
t.right.parent = t;
}
return t;
}
    Ref insertLeft(Ref cell, Ref root)
{
left = cell;
cell.parent = &this;
return cell.fixAfterInsertion(root);
}
    Ref insertRight(Ref cell, Ref root)
{
right = cell;
cell.parent = &this;
return cell.fixAfterInsertion(root);
}
    Ref remove(Ref root)
{
if (left is null && right is null && parent is null)
return null;
if (left && right)
{
auto s = successor;
root = swapPosition(&this,s,root);
}
if (left is null && right is null)
{
if (color is BLACK)
root = this.fixAfterDeletion(root);
if (parent)
{
if (&this is parent.left)
parent.left = null;
else
if (&this is parent.right)
parent.right = null;
parent = null;
}
}
else
{
auto replacement = left;
if (replacement is null)
replacement = right;
replacement.parent = parent;
if (parent is null)
root = replacement;
else
if (&this is parent.left)
parent.left = replacement;
else
parent.right = replacement;
left = null;
right = null;
parent = null;
if (color is BLACK)
root = replacement.fixAfterDeletion(root);
}
return root;
}
    static Ref swapPosition(Ref x, Ref y, Ref root)
{
auto px = x.parent;
bool xpl = px !is null && x is px.left;
auto lx = x.left;
auto rx = x.right;
auto py = y.parent;
bool ypl = py !is null && y is py.left;
auto ly = y.left;
auto ry = y.right;
if (x is py)
{
y.parent = px;
if (px !is null)
{
if (xpl)
px.left = y;
else
px.right = y;
}
x.parent = y;
if (ypl)
{
y.left = x;
y.right = rx;
if (rx !is null)
rx.parent = y;
}
else
{
y.right = x;
y.left = lx;
if (lx !is null)
lx.parent = y;
}
x.left = ly;
if (ly !is null)
ly.parent = x;
x.right = ry;
if (ry !is null)
ry.parent = x;
}
else
{
if (y is px)
{
x.parent = py;
if (py !is null)
{
if (ypl)
py.left = x;
else
py.right = x;
}
y.parent = x;
if (xpl)
{
x.left = y;
x.right = ry;
if (ry !is null)
ry.parent = x;
}
else
{
x.right = y;
x.left = ly;
if (ly !is null)
ly.parent = x;
}
y.left = lx;
if (lx !is null)
lx.parent = y;
y.right = rx;
if (rx !is null)
rx.parent = y;
}
else
{
x.parent = py;
if (py !is null)
{
if (ypl)
py.left = x;
else
py.right = x;
}
x.left = ly;
if (ly !is null)
ly.parent = x;
x.right = ry;
if (ry !is null)
ry.parent = x;
y.parent = px;
if (px !is null)
{
if (xpl)
px.left = y;
else
px.right = y;
}
y.left = lx;
if (lx !is null)
lx.parent = y;
y.right = rx;
if (rx !is null)
rx.parent = y;
}
}
bool c = x.color;
x.color = y.color;
y.color = c;
if (root is x)
root = y;
else
if (root is y)
root = x;
return root;
}

    static bool colorOf(Ref p)
{
return p is null ? BLACK : p.color;
}

    static Ref parentOf(Ref p)
{
return p is null ? null : p.parent;
}

    static void setColor(Ref p, bool c)
{
if (p !is null)
p.color = c;
}

    static Ref leftOf(Ref p)
{
return p is null ? null : p.left;
}

    static Ref rightOf(Ref p)
{
return p is null ? null : p.right;
}

    package Ref rotateLeft(Ref root)
{
auto r = right;
right = r.left;
if (r.left)
r.left.parent = &this;
r.parent = parent;
if (parent is null)
root = r;
else
if (parent.left is &this)
parent.left = r;
else
parent.right = r;
r.left = &this;
parent = r;
return root;
}

    package Ref rotateRight(Ref root)
{
auto l = left;
left = l.right;
if (l.right !is null)
l.right.parent = &this;
l.parent = parent;
if (parent is null)
root = l;
else
if (parent.right is &this)
parent.right = l;
else
parent.left = l;
l.right = &this;
parent = l;
return root;
}

    package Ref fixAfterInsertion(Ref root)
{
color = RED;
auto x = &this;
while (x && x !is root && x.parent.color is RED)
{
if (parentOf(x) is leftOf(parentOf(parentOf(x))))
{
auto y = rightOf(parentOf(parentOf(x)));
if (colorOf(y) is RED)
{
setColor(parentOf(x),BLACK);
setColor(y,BLACK);
setColor(parentOf(parentOf(x)),RED);
x = parentOf(parentOf(x));
}
else
{
if (x is rightOf(parentOf(x)))
{
x = parentOf(x);
root = x.rotateLeft(root);
}
setColor(parentOf(x),BLACK);
setColor(parentOf(parentOf(x)),RED);
if (parentOf(parentOf(x)) !is null)
root = parentOf(parentOf(x)).rotateRight(root);
}
}
else
{
auto y = leftOf(parentOf(parentOf(x)));
if (colorOf(y) is RED)
{
setColor(parentOf(x),BLACK);
setColor(y,BLACK);
setColor(parentOf(parentOf(x)),RED);
x = parentOf(parentOf(x));
}
else
{
if (x is leftOf(parentOf(x)))
{
x = parentOf(x);
root = x.rotateRight(root);
}
setColor(parentOf(x),BLACK);
setColor(parentOf(parentOf(x)),RED);
if (parentOf(parentOf(x)) !is null)
root = parentOf(parentOf(x)).rotateLeft(root);
}
}
}
root.color = BLACK;
return root;
}

    package Ref fixAfterDeletion(Ref root)
{
auto x = &this;
while (x !is root && colorOf(x) is BLACK)
{
if (x is leftOf(parentOf(x)))
{
auto sib = rightOf(parentOf(x));
if (colorOf(sib) is RED)
{
setColor(sib,BLACK);
setColor(parentOf(x),RED);
root = parentOf(x).rotateLeft(root);
sib = rightOf(parentOf(x));
}
if (colorOf(leftOf(sib)) is BLACK && colorOf(rightOf(sib)) is BLACK)
{
setColor(sib,RED);
x = parentOf(x);
}
else
{
if (colorOf(rightOf(sib)) is BLACK)
{
setColor(leftOf(sib),BLACK);
setColor(sib,RED);
root = sib.rotateRight(root);
sib = rightOf(parentOf(x));
}
setColor(sib,colorOf(parentOf(x)));
setColor(parentOf(x),BLACK);
setColor(rightOf(sib),BLACK);
root = parentOf(x).rotateLeft(root);
x = root;
}
}
else
{
auto sib = leftOf(parentOf(x));
if (colorOf(sib) is RED)
{
setColor(sib,BLACK);
setColor(parentOf(x),RED);
root = parentOf(x).rotateRight(root);
sib = leftOf(parentOf(x));
}
if (colorOf(rightOf(sib)) is BLACK && colorOf(leftOf(sib)) is BLACK)
{
setColor(sib,RED);
x = parentOf(x);
}
else
{
if (colorOf(leftOf(sib)) is BLACK)
{
setColor(rightOf(sib),BLACK);
setColor(sib,RED);
root = sib.rotateLeft(root);
sib = leftOf(parentOf(x));
}
setColor(sib,colorOf(parentOf(x)));
setColor(parentOf(x),BLACK);
setColor(leftOf(sib),BLACK);
root = parentOf(x).rotateRight(root);
x = root;
}
}
}
setColor(x,BLACK);
return root;
}

}
}
