// D import file generated from 'tango/util/container/Slink.d'
module tango.util.container.Slink;
import tango.util.container.model.IContainer;
alias int KeyDummy;
template Slink(V,K = KeyDummy,bool Identity = false,bool HashCache = false)
{
struct Slink
{
    alias Slink!(V,K,Identity,HashCache) Type;
    alias Type* Ref;
    alias Compare!(V) Comparator;
    Ref next;
    V value;
    static if(HashCache == true)
{
    hash_t cache;
}
    static if(!is(typeof(K) == KeyDummy))
{
    K key;
    final Ref set(K k, V v, Ref n)
{
key = k;
return set(v,n);
}

    final int hash()
{
return typeid(K).getHash(&key);
}

    final Ref findKey(K key)
{
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key is p.key)
return p;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key == p.key)
return p;
}
}
}

return null;
}

    final Ref findPair(K key, V value)
{
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key is p.key && value == p.value)
return p;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key == p.key && value == p.value)
return p;
}
}
}

return null;
}

    const final int indexKey(K key)
{
int i = 0;
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next , ++i)
{
if (key is p.key)
return i;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next , ++i)
{
if (key == p.key)
return i;
}
}
}

return -1;
}

    const final int indexPair(K key, V value)
{
int i = 0;
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next , ++i)
{
if (key is p.key && value == p.value)
return i;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next , ++i)
{
if (key == p.key && value == p.value)
return i;
}
}
}

return -1;
}

    final int countKey(K key)
{
int c = 0;
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key is p.key)
++c;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key == p.key)
++c;
}
}
}

return c;
}

    final int countPair(K key, V value)
{
int c = 0;
static if(Identity == true)
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key is p.key && value == p.value)
++c;
}
}
}
else
{
{
for (auto p = &this;
 p; p = p.next)
{
if (key == p.key && value == p.value)
++c;
}
}
}

return c;
}

}
    final Ref set(V v, Ref n)
{
next = n;
value = v;
return &this;
}

    final void attach(Ref p)
{
if (p)
p.next = next;
next = p;
}

    final void detachNext()
{
if (next)
next = next.next;
}

    final Ref find(V element)
{
{
for (auto p = &this;
 p; p = p.next)
{
if (element == p.value)
return p;
}
}
return null;
}

    const final int index(V element)
{
int i;
{
for (auto p = &this;
 p; p = p.next , ++i)
{
if (element == p.value)
return i;
}
}
return -1;
}

    const final int count(V element)
{
int c;
{
for (auto p = &this;
 p; p = p.next)
{
if (element == p.value)
++c;
}
}
return c;
}

    const final int count()
{
int c;
{
for (auto p = &this;
 p; p = p.next)
{
++c;
}
}
return c;
}

    final Ref tail()
{
auto p = &this;
while (p.next)
p = p.next;
return p;
}

    final Ref nth(int n)
{
auto p = &this;
{
for (int i;
 i < n; ++i)
{
p = p.next;
}
}
return p;
}

    final Ref copy(scope Ref delegate() alloc)
{
auto newlist = dup(alloc);
auto current = newlist;
{
for (auto p = next;
 p; p = p.next)
{
{
current.next = p.dup(alloc);
current = current.next;
}
}
}
current.next = null;
return newlist;
}

    Ref dup(scope Ref delegate() alloc)
{
auto ret = alloc();
static if(is(typeof(K) == KeyDummy))
{
ret.set(value,next);
}
else
{
ret.set(key,value,next);
}

return ret;
}
    static Ref merge(Ref fst, Ref snd, Comparator cmp)
{
auto a = fst;
auto b = snd;
Ref hd = null;
Ref current = null;
for (;;)
{
{
if (a is null)
{
if (hd is null)
hd = b;
else
current.next = b;
return hd;
}
else
if (b is null)
{
if (hd is null)
hd = a;
else
current.next = a;
return hd;
}
int diff = cmp(a.value,b.value);
if (diff <= 0)
{
if (hd is null)
hd = a;
else
current.next = a;
current = a;
a = a.next;
}
else
{
if (hd is null)
hd = b;
else
current.next = b;
current = b;
b = b.next;
}
}
}
}

    static Ref split(Ref s)
{
auto fast = s;
auto slow = s;
if (fast is null || fast.next is null)
return null;
while (fast)
{
fast = fast.next;
if (fast && fast.next)
{
fast = fast.next;
slow = slow.next;
}
}
auto r = slow.next;
slow.next = null;
return r;
}

    static Ref sort(Ref s, Comparator cmp)
{
if (s is null || s.next is null)
return s;
else
{
auto right = split(s);
auto left = s;
left = sort(left,cmp);
right = sort(right,cmp);
return merge(left,right,cmp);
}
}

}
}
