// D import file generated from 'tango/util/container/more/BitSet.d'
module tango.util.container.more.BitSet;
private import core.bitop;

template BitSet(int Count = 0)
{
struct BitSet
{
    private enum width = size_t.sizeof * 8;

    const template opBinary(immutable(char)[] s : "&")
{
bool opBinary(size_t i)
{
return and(i);
}
}

    template opOpAssign(immutable(char)[] s : "|")
{
void opOpAssign(size_t i)
{
or(i);
}
}
    template opOpAssign(immutable(char)[] s : "^")
{
void opOpAssign(size_t i)
{
xor(i);
}
}
    static if(Count == 0)
{
    private size_t[] bits;

}
else
{
    private size_t[(Count + width - 1) / width] bits;

}
    void add(size_t i)
{
static if(Count == 0)
{
size(i);
}

or(i);
}
    const bool has(size_t i)
{
auto idx = i / width;
return idx < bits.length && (bits[idx] & 1 << i % width) != 0;
}

    const bool and(size_t i)
{
return (bits[i / width] & 1 << i % width) != 0;
}

    void or(size_t i)
{
bits[i / width] |= 1 << i % width;
}
    void xor(size_t i)
{
bits[i / width] ^= 1 << i % width;
}
    void clr(size_t i)
{
bits[i / width] &= ~(1 << i % width);
}
    BitSet* clr()
{
bits[] = 0;
return &this;
}
    const @property BitSet dup()
{
BitSet x;
static if(Count == 0)
{
x.bits.length = this.bits.length;
}

x.bits[] = bits[];
return x;
}

    const @property size_t size()
{
return width * bits.length;
}

    static if(Count == 0)
{
    BitSet* size(size_t i)
{
i = i / width;
if (i >= bits.length)
bits.length = i + 1;
return &this;
}
}
}
}
