// D import file generated from 'tango/util/container/more/CacheMap.d'
module tango.util.container.more.CacheMap;
private import tango.stdc.stdlib;

private import tango.util.container.HashMap;

public import tango.util.container.Container;

template CacheMap(K,V,alias Hash = Container.hash,alias Reap = Container.reap,alias Heap = Container.Collect)
{
class CacheMap
{
    private alias QueuedEntry Type;

    private alias Type* Ref;

    private alias HashMap!(K,Ref,Hash,reaper,Heap) Map;

    private Map hash;

    private Type[] links;

    private 
{
    Ref head;
    Ref tail;
}
    private uint capacity;

    this(uint capacity)
{
hash = new Map;
this.capacity = capacity;
hash.buckets(capacity,0.75);
links.length = capacity;
head = (tail = &links[0]);
foreach (ref link; links[1..$])
{
link.prev = tail;
tail.next = &link;
tail = &link;
}
}
    static template reaper(K,R)
{
void reaper(K k, R r)
{
Reap(k,r.value);
}
}

    const final @property uint size()
{
return hash.size;
}

    final int opApply(scope int delegate(ref K key, ref V value) dg)
{
K key;
V value;
int result;
auto node = head;
auto i = hash.size;
while (i--)
{
key = node.key;
value = node.value;
if ((result = dg(key,value)) != 0)
break;
node = node.next;
}
return result;
}

    bool get(K key, ref V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
value = entry.value;
reReference(entry);
return true;
}
return false;
}
    final bool add(K key, V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
reReference(entry.set(key,value));
return false;
}
addEntry(key,value);
return true;
}

    final bool take(K key)
{
V value;
return take(key,value);
}

    final bool take(K key, ref V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
value = entry.value;
deReference(entry);
hash.removeKey(key);
return true;
}
return false;
}

    private Ref deReference(Ref entry)
{
if (entry !is tail)
{
if (entry is head)
head = entry.next;
entry.extract;
tail = entry.append(tail);
}
return entry;
}

    private Ref reReference(Ref entry)
{
if (entry !is head)
{
if (entry is tail)
tail = entry.prev;
entry.extract;
head = entry.prepend(head);
}
return entry;
}

    private Ref addEntry(K key, V value)
{
assert(capacity);
if (hash.size < capacity)
hash.add(key,tail);
else
{
Reap(tail.key,tail.value);
if (!hash.replaceKey(tail.key,key))
throw new Exception("key missing!");
}
return reReference(tail.set(key,value));
}

    private struct QueuedEntry
{
    private K key;

    private 
{
    Ref prev;
    Ref next;
}
    private V value;

    Ref set(K key, V value)
{
this.value = value;
this.key = key;
return &this;
}
    Ref prepend(Ref before)
{
if (before)
{
prev = before.prev;
if (prev)
prev.next = &this;
next = before;
before.prev = &this;
}
return &this;
}
    Ref append(Ref after)
{
if (after)
{
next = after.next;
if (next)
next.prev = &this;
prev = after;
after.next = &this;
}
return &this;
}
    Ref extract()
{
if (prev)
prev.next = next;
if (next)
next.prev = prev;
next = (prev = null);
return &this;
}
}

}
}
debug (CacheMap)
{
    import tango.io.Stdout;
    import tango.core.Memory;
    import tango.time.StopWatch;
    void main();
}
