// D import file generated from 'tango/util/container/more/Heap.d'
module tango.util.container.more.Heap;
private import tango.core.Exception;

template minHeapCompare(T)
{
bool minHeapCompare(T a, T b)
{
return a <= b;
}
}
template maxHeapCompare(T)
{
bool maxHeapCompare(T a, T b)
{
return a >= b;
}
}
template defaultHeapSwap(T)
{
void defaultHeapSwap(T t, size_t index)
{
}
}
template Heap(T,alias Compare = minHeapCompare!(T),alias Move = defaultHeapSwap!(T))
{
struct Heap
{
    private T[] heap;

    private size_t next;

    void push(T t)
{
auto index = next++;
while (heap.length <= index)
heap.length = 2 * heap.length + 32;
heap[index] = t;
Move(t,index);
fixup(index);
}
    void push(T[] array)
{
if (heap.length < next + array.length)
heap.length = next + array.length + 32;
foreach (t; array)
{
push(t);
}
}
    T pop()
{
return removeAt(0);
}
    void removeAll(T t)
{
while (remove(t))
{
}
}
    bool remove(T t)
{
foreach (i, a; heap)
{
if (a is t || a == t)
{
removeAt(i);
return true;
}
}
return false;
}
    T removeAt(size_t index)
{
if (next <= index)
{
throw new NoSuchElementException("Heap :: tried to remove an" ~ " element with index greater than the size of the heap " ~ "(did you call pop() from an empty heap?)");
}
next--;
auto t = heap[index];
if (next > index)
{
heap[index] = heap[next];
Move(heap[index],index);
fixdown(index);
if (heap[index] is heap[next])
fixup(index);
}
return t;
}
    T peek()
{
assert(next > 0);
return heap[0];
}
    const @property size_t size()
{
return next;
}

    void clear()
{
next = 0;
}
    void clear(T[] host)
{
this.heap = host;
clear();
}
    const size_t capacity()
{
return heap.length;
}

    size_t capacity(size_t value)
{
if (value < next)
{
throw new IllegalArgumentException("Heap :: illegal truncation");
}
heap.length = value;
return value;
}
    Heap clone()
{
Heap other;
other.heap = this.heap.dup;
other.next = this.next;
return other;
}
    private const size_t parent(size_t index)
{
return (index - 1) / 2;
}


    private void fixup(size_t index)
{
if (index == 0)
return ;
size_t par = parent(index);
if (!Compare(heap[par],heap[index]))
{
swap(par,index);
fixup(par);
}
}

    private void fixdown(size_t index)
{
size_t left = 2 * index + 1;
size_t down;
if (left >= next)
{
return ;
}
if (left == next - 1)
{
down = left;
}
else
if (Compare(heap[left],heap[left + 1]))
{
down = left;
}
else
{
down = left + 1;
}
if (!Compare(heap[index],heap[down]))
{
swap(index,down);
fixdown(down);
}
}

    private void swap(size_t a, size_t b)
{
auto t1 = heap[a];
auto t2 = heap[b];
heap[a] = t2;
Move(t2,a);
heap[b] = t1;
Move(t1,b);
}

    alias pop remove;
    template opOpAssign(immutable(char)[] s : "~")
{
void opOpAssign(T t)
{
push(t);
}
}
    template opOpAssign(immutable(char)[] s : "~")
{
void opOpAssign(T[] array)
{
push(array);
}
}
}
}
template MinHeap(T)
{
alias Heap!(T,minHeapCompare) MinHeap;
}
template MaxHeap(T)
{
alias Heap!(T,maxHeapCompare) MaxHeap;
}
debug (UnitTest)
{
                    long[] swapped;
    size_t[] indices;
    void onMove(long a, size_t b)
{
swapped ~= a;
indices ~= b;
}
            }
