// D import file generated from 'tango/util/container/more/Stack.d'
module tango.util.container.more.Stack;
private import tango.core.Exception;

template Stack(V,int Size = 0)
{
struct Stack
{
    alias nth opIndex;
    alias slice opSlice;
    template opOpAssign(immutable(char)[] s : ">>")
{
Stack* opOpAssign(uint d)
{
return rotateRight(d);
}
}
    template opOpAssign(immutable(char)[] s : "<<")
{
Stack* opOpAssign(uint d)
{
return rotateLeft(d);
}
}
    template opOpAssign(immutable(char)[] s : "~")
{
Stack* opOpAssign(V value)
{
return push(value);
}
}
    static if(Size == 0)
{
    private uint depth;

    private V[] stack;

}
else
{
    private uint depth;

    private V[Size] stack;

}
    Stack* clear()
{
depth = 0;
return &this;
}
    @property size_t size()
{
return depth;
}

    size_t unused()
{
return stack.length - depth;
}
    Stack clone()
{
Stack s = void;
static if(Size == 0)
{
s.stack.length = stack.length;
}

s.stack[] = stack;
s.depth = depth;
return s;
}
    @property V dup()
{
auto v = top;
push(v);
return v;
}

    Stack* push(V value)
{
static if(Size == 0)
{
if (depth >= stack.length)
stack.length = stack.length + 64;
stack[depth++] = value;
}
else
{
if (depth < stack.length)
stack[depth++] = value;
else
error(143);
}

return &this;
}
    Stack* append(V[] value...)
{
foreach (v; value)
{
push(v);
}
return &this;
}
    V pop()
{
if (depth)
return stack[--depth];
return error(176);
}
    @property V top()
{
if (depth)
return stack[depth - 1];
return error(192);
}

    V swap()
{
auto p = stack.ptr + depth;
if ((p -= 2) >= stack.ptr)
{
auto v = p[0];
p[0] = p[1];
return p[1] = v;
}
return error(213);
}
    V nth(size_t i)
{
if (i < depth)
return stack[depth - i - 1];
return error(230);
}
    Stack* rotateLeft(size_t d)
{
if (d <= depth)
{
auto p = &stack[depth - d];
auto t = *p;
while (--d)
*p++ = *(p + 1);
*p = t;
}
else
error(252);
return &this;
}
    Stack* rotateRight(size_t d)
{
if (d <= depth)
{
auto p = &stack[depth - 1];
auto t = *p;
while (--d)
*p-- = *(p - 1);
*p = t;
}
else
error(275);
return &this;
}
    V[] slice()
{
return stack[0..depth];
}
    private V error(size_t line)
{
throw new RangeError("tango/util/container/more/Stack.d",line);
}

    int opApply(scope int delegate(ref V value) dg)
{
int result;
{
for (int i = depth;
 i-- && result is 0;)
{
result = dg(stack[i]);
}
}
return result;
}
}
}
debug (Stack)
{
    import tango.io.Stdout;
    void main();
}
