// D import file generated from 'tango/util/container/more/StackMap.d'
module tango.util.container.more.StackMap;
private import tango.stdc.stdlib;

private import tango.util.container.HashMap;

public import tango.util.container.Container;

template StackMap(K,V,alias Hash = Container.hash,alias Reap = Container.reap,alias Heap = Container.Collect)
{
class StackMap
{
    private alias QueuedEntry Type;

    private alias Type* Ref;

    private alias HashMap!(K,Ref,Hash,reaper,Heap) Map;

    private Map hash;

    private Type[] links;

    private 
{
    Ref head;
    Ref tail;
    Ref start;
}
    private size_t capacity;

    this(size_t capacity)
{
hash = new Map;
this.capacity = capacity;
hash.buckets(capacity,0.75);
links.length = capacity;
head = (tail = &links[0]);
foreach (ref link; links[1..$])
{
link.prev = tail;
tail.next = &link;
tail = &link;
}
}
    ~this()
{
}
    static template reaper(K,R)
{
void reaper(K k, R r)
{
Reap(k,r.value);
}
}

    const final @property size_t size()
{
return hash.size;
}

    final void clear()
{
hash.clear;
start = null;
}

    final bool push(K key, V value)
{
return add(key,value);
}

    bool popHead(ref K key, ref V value)
{
if (start)
{
key = head.key;
return take(key,value);
}
return false;
}
    bool popTail(ref K key, ref V value)
{
if (start)
{
key = start.key;
return take(key,value);
}
return false;
}
    final int opApply(scope int delegate(ref K key, ref V value) dg)
{
K key;
V value;
int result;
auto node = start;
while (node)
{
key = node.key;
value = node.value;
if ((result = dg(key,value)) != 0)
break;
node = node.prev;
}
return result;
}

    final bool add(K key, V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
entry.set(key,value);
return false;
}
entry = addEntry(key,value);
if (start is null)
start = entry;
return true;
}

    bool get(K key, ref V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
value = entry.value;
return true;
}
return false;
}
    final bool take(K key, ref V value)
{
Ref entry = null;
if (hash.get(key,entry))
{
value = entry.value;
if (entry is start)
start = entry.prev;
deReference(entry);
hash.removeKey(key);
return true;
}
return false;
}

    private Ref deReference(Ref entry)
{
if (entry !is tail)
{
if (entry is head)
head = entry.next;
entry.extract;
tail = entry.append(tail);
}
return entry;
}

    private Ref reReference(Ref entry)
{
if (entry !is head)
{
if (entry is tail)
tail = entry.prev;
entry.extract;
head = entry.prepend(head);
}
return entry;
}

    private Ref addEntry(K key, V value)
{
if (hash.size < capacity)
{
hash.add(key,tail);
return reReference(tail.set(key,value));
}
throw new Exception("Full");
}

    private struct QueuedEntry
{
    private K key;

    private 
{
    Ref prev;
    Ref next;
}
    private V value;

    Ref set(K key, V value)
{
this.value = value;
this.key = key;
return &this;
}
    Ref prepend(Ref before)
{
if (before)
{
prev = before.prev;
if (prev)
prev.next = &this;
next = before;
before.prev = &this;
}
return &this;
}
    Ref append(Ref after)
{
if (after)
{
next = after.next;
if (next)
next.prev = &this;
prev = after;
after.next = &this;
}
return &this;
}
    Ref extract()
{
if (prev)
prev.next = next;
if (next)
next.prev = prev;
next = (prev = null);
return &this;
}
}

}
}
debug (StackMap)
{
    import tango.io.Stdout;
    import tango.core.Memory;
    import tango.time.StopWatch;
    void main();
}
