// D import file generated from 'tango/util/digest/Md4.d'
module tango.util.digest.Md4;
public import tango.util.digest.Digest;

private import tango.util.digest.MerkleDamgard;

class Md4 : MerkleDamgard
{
    protected uint[4] context;

    private enum ubyte padChar = 128;

    this()
{
}
    override uint digestSize()
{
return 16;
}

    override void reset()
{
super.reset();
context[] = initial[];
}

    override void createDigest(ubyte[] buf);

    protected override uint blockSize()
{
return 64;
}


    protected override uint addSize()
{
return 8;
}


    protected override void padMessage(ubyte[] data)
{
data[0] = padChar;
data[1..$] = 0;
}


    protected override void padLength(ubyte[] data, ulong length)
{
length <<= 3;
littleEndian64((cast(ubyte*)&length)[0..8],cast(ulong[])data);
}


    protected override void transform(const(ubyte[]) input);


    protected static uint f(uint x, uint y, uint z)
{
return x & y | ~x & z;
}


    protected static uint h(uint x, uint y, uint z)
{
return x ^ y ^ z;
}


    private static uint g(uint x, uint y, uint z)
{
return x & y | x & z | y & z;
}


    private static void ff(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += f(b,c,d) + x + ac;
a = rotateLeft(a,s);
}


    private static void gg(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += g(b,c,d) + x + ac;
a = rotateLeft(a,s);
}


    private static void hh(ref uint a, uint b, uint c, uint d, uint x, uint s, uint ac)
{
a += h(b,c,d) + x + ac;
a = rotateLeft(a,s);
}


    private static const uint[4] initial = [1732584193,-271733879u,-1732584194u,271733878];


    private static enum 
{
S11 = 3,
S12 = 7,
S13 = 11,
S14 = 19,
S21 = 3,
S22 = 5,
S23 = 9,
S24 = 13,
S31 = 3,
S32 = 9,
S33 = 11,
S34 = 15,
}


}
debug (UnitTest)
{
    }
