// D import file generated from 'tango/util/digest/MerkleDamgard.d'
module tango.util.digest.MerkleDamgard;
public import tango.core.ByteSwap;

public import tango.util.digest.Digest;

package class MerkleDamgard : Digest
{
    private uint bytes;

    private ubyte[] buffer;

    protected abstract void createDigest(ubyte[] buf);


    protected abstract uint blockSize();


    @property protected abstract uint addSize();



    protected abstract void padMessage(ubyte[] data);


    protected void padLength(ubyte[] data, ulong length)
{
}

    protected abstract void transform(const(ubyte[]) data);


    protected void extend()
{
}

    this()
{
buffer = new ubyte[](blockSize());
reset();
}
    protected void reset()
{
bytes = 0;
}

    override MerkleDamgard update(const(void[]) input)
{
auto block = blockSize();
uint i = bytes & block - 1;
const(ubyte[]) data = cast(const(ubyte[]))input;
bytes += data.length;
if (data.length + i < block)
buffer[i..i + data.length] = data[];
else
{
buffer[i..block] = data[0..block - i];
transform(buffer);
{
for (i = block - i; i + block - 1 < data.length; i += block)
{
transform(data[i..i + block]);
}
}
buffer[0..data.length - i] = data[i..data.length];
}
return this;
}

    override ubyte[] binaryDigest(ubyte[] buf = null)
{
auto block = blockSize();
uint i = bytes & block - 1;
if (i < block - addSize)
padMessage(buffer[i..block - addSize]);
else
{
padMessage(buffer[i..block]);
transform(buffer);
buffer[] = 0;
}
padLength(buffer[block - addSize..block],bytes);
transform(buffer);
extend();
if (buf.length < digestSize())
buf.length = digestSize();
createDigest(buf);
reset();
return buf;
}

    static protected final void littleEndian32(const(ubyte[]) input, uint[] output);



    static protected final void bigEndian32(const(ubyte[]) input, uint[] output);



    static protected final void littleEndian64(const(ubyte[]) input, ulong[] output);



    static protected final void bigEndian64(const(ubyte[]) input, ulong[] output);



    static protected final uint rotateLeft(uint x, uint n)
{
return x << n | x >> 32 - n;
}



}

