// D import file generated from 'tango/util/digest/Ripemd160.d'
module tango.util.digest.Ripemd160;
private import tango.util.digest.MerkleDamgard;

public import tango.util.digest.Digest;

final class Ripemd160 : MerkleDamgard
{
    private uint[5] context;

    private enum uint padChar = 128;

    private static enum uint[5] initial = [1732584193,-271733879u,-1732584194u,271733878,-1009589776u];


    this()
{
}
    override uint digestSize()
{
return 20;
}

    override void reset()
{
super.reset();
context[] = initial[];
}

    override void createDigest(ubyte[] buf);

    protected override uint blockSize()
{
return 64;
}


    protected override uint addSize()
{
return 8;
}


    protected override void padMessage(ubyte[] at)
{
at[0] = padChar;
at[1..at.length] = 0;
}


    protected override void padLength(ubyte[] at, ulong length)
{
length <<= 3;
littleEndian64((cast(ubyte*)&length)[0..8],cast(ulong[])at);
}


    protected override void transform(const(ubyte[]) input);


}

debug (UnitTest)
{
    }
