// D import file generated from 'tango/util/digest/Ripemd256.d'
module tango.util.digest.Ripemd256;
private import tango.util.digest.MerkleDamgard;

public import tango.util.digest.Digest;

final class Ripemd256 : MerkleDamgard
{
    private uint[8] context;

    private enum uint padChar = 128;

    private enum uint[8] initial = [1732584193,-271733879u,-1732584194u,271733878,1985229328,-19088744u,-1985229329u,19088743];

    this()
{
}
    override uint digestSize()
{
return 32;
}

    override void reset()
{
super.reset();
context[] = initial[];
}

    override void createDigest(ubyte[] buf);

    protected override uint blockSize()
{
return 64;
}


    protected override uint addSize()
{
return 8;
}


    protected override void padMessage(ubyte[] at)
{
at[0] = padChar;
at[1..at.length] = 0;
}


    protected override void padLength(ubyte[] at, ulong length)
{
length <<= 3;
littleEndian64((cast(ubyte*)&length)[0..8],cast(ulong[])at);
}


    protected override void transform(const(ubyte[]) input);


}

debug (UnitTest)
{
    }
