// D import file generated from 'tango/util/digest/Sha01.d'
module tango.util.digest.Sha01;
private import tango.core.ByteSwap;

private import tango.util.digest.MerkleDamgard;

package abstract class Sha01 : MerkleDamgard
{
    protected uint[5] context;

    private static enum ubyte padChar = 128;


    package static enum uint mask = 15;


    final override uint digestSize()
{
return 20;
}

    final protected override void reset()
{
super.reset();
context[] = initial[];
}



    final protected override void createDigest(ubyte[] buf);



    final protected override uint blockSize()
{
return 64;
}



    final protected override uint addSize()
{
return 8;
}



    final protected override void padMessage(ubyte[] data)
{
data[0] = padChar;
data[1..$] = 0;
}



    final protected override void padLength(ubyte[] data, ulong length)
{
length <<= 3;
{
for (int j = cast(int)data.length - 1;
 j >= 0; j--)
{
data[$ - j - 1] = cast(ubyte)(length >> j * data.length);
}
}
}



    protected static uint f(uint t, uint B, uint C, uint D)
{
if (t < 20)
return B & C | ~B & D;
else
if (t < 40)
return B ^ C ^ D;
else
if (t < 60)
return B & C | B & D | C & D;
else
return B ^ C ^ D;
}


    protected enum uint[] K = [1518500249,1859775393,-1894007588u,-899497514u];

    private enum uint[5] initial = [1732584193,-271733879u,-1732584194u,271733878,-1009589776u];

}


