// D import file generated from 'tango/util/log/AppendFiles.d'
module tango.util.log.AppendFiles;
private import tango.time.Time;

private 
{
    import Path = tango.io.Path;
    import tango.io.device.File;
}
private import tango.io.model.IFile;

private 
{
    import tango.util.log.Log;
    import tango.util.log.AppendFile;
}
public class AppendFiles : Filer
{
    private Mask mask_;

    private const(char)[][] paths;

    private int index;

    private 
{
    long maxSize;
    long fileSize;
}
    this(const(char)[] path, int count, long maxSize, Appender.Layout how = null)
{
--count;
assert(path);
assert(count > 0 && count < 1000);
mask_ = register(path);
auto c = Path.parse(path.dup);
char[3] x;
Time mostRecent;
{
for (int i = 0;
 i <= count; ++i)
{
{
x[0] = cast(char)('0' + i / 100);
x[1] = cast(char)('0' + i / 10 % 10);
x[2] = cast(char)('0' + i % 10);
auto p = c.toString()[0..$ - c.suffix.length] ~ x ~ c.suffix;
paths ~= p;
if (Path.exists(p))
{
auto modified = Path.modified(p);
if (modified > mostRecent)
{
mostRecent = modified;
index = i;
}
}
}
}
}
this.maxSize = maxSize;
--index;
nextFile(false);
layout(how);
}
    const final override @property Mask mask()
{
return mask_;
}

    const final override @property const(char)[] name()
{
return this.classinfo.name;
}

    final override void append(LogEvent event);

    private void nextFile(bool reset)
{
if (++index >= paths.length)
index = 0;
close();
auto style = File.WriteAppending;
style.share = File.Share.Read;
auto conduit = new File(paths[index],style);
configure(conduit);
if (reset)
conduit.truncate(fileSize = 0);
else
fileSize = conduit.length;
}

}

debug (AppendFiles)
{
    void main()
{
Log.root.add(new AppendFiles("foo",5,6));
auto log = Log.lookup("fu.bar");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
log.trace("hello {}","world");
}
}
