// D import file generated from 'tango/util/uuid/Uuid.d'
module tango.util.uuid.Uuid;
import tango.core.Exception;
import Integer = tango.text.convert.Integer;
private union UuidData
{
    uint[4] ui;
    ubyte[16] ub;
}

struct Uuid
{
    private UuidData _data;

    public static Uuid opCall(const(ubyte[]) data);


    public static Uuid parse(const(char[]) value);


    public static bool tryParse(const(char[]) value, out Uuid uuid);


    public static template random(Random)
{
Uuid random(Random generator)
{
Uuid u;
with (u)
{
_data.ui[0] = generator.natural();
_data.ui[1] = generator.natural();
_data.ui[2] = generator.natural();
_data.ui[3] = generator.natural();
_data.ub[6] &= 79;
_data.ub[6] |= 64;
_data.ub[8] &= 191;
_data.ub[8] |= 128;
}
return u;
}
}


    public static template byName(Digest)
{
Uuid byName(Uuid namespace, const(char[]) name, Digest digest, ubyte uuidVersion)
{
auto nameBytes = namespace.toBytes();
nameBytes ~= cast(ubyte[])name;
digest.update(nameBytes);
nameBytes = digest.binaryDigest();
nameBytes[6] = cast(ubyte)(uuidVersion << 4 | nameBytes[6] & 15);
nameBytes[8] |= 128;
nameBytes[8] &= 191;
return Uuid(nameBytes[0..16]);
}
}


    @property public static Uuid empty()
{
Uuid uuid;
uuid._data.ui[] = 0;
return uuid;
}



    public const ubyte[] toBytes()
{
return _data.ub.dup;
}


    public const ubyte format()
{
return cast(ubyte)(_data.ub[6] >> 4);
}


    public const(char[]) toString();

    public const bool opEquals(ref const(Uuid) other)
{
return _data.ui[0] == other._data.ui[0] && _data.ui[1] == other._data.ui[1] && _data.ui[2] == other._data.ui[2] && _data.ui[3] == other._data.ui[3];
}


    public const hash_t toHash();


}
debug (UnitTest)
{
    import tango.math.random.Kiss;
                import tango.util.digest.Sha1;
        import tango.util.digest.Md5;
    }
interface UuidGen
{
    Uuid next();
}
template RandomGen(TRandom)
{
class RandomGen : UuidGen
{
    TRandom random;
    this(TRandom random)
{
this.random = random;
}
    Uuid next()
{
return Uuid.random(random);
}
}
}
