// D import file generated from 'tango/text/UnicodeData.d'
module tango.text.UnicodeData;
struct UnicodeData
{
    enum GeneralCategory 
{
Lu = 1,
Ll = 1 << 1,
Lt = 1 << 2,
Lm = 1 << 3,
Lo = 1 << 4,
Mn = 1 << 5,
Mc = 1 << 6,
Me = 1 << 7,
Nd = 1 << 8,
Nl = 1 << 9,
No = 1 << 10,
Pc = 1 << 11,
Pd = 1 << 12,
Ps = 1 << 13,
Pe = 1 << 14,
Pi = 1 << 15,
Pf = 1 << 16,
Po = 1 << 17,
Sm = 1 << 18,
Sc = 1 << 19,
Sk = 1 << 20,
So = 1 << 21,
Zs = 1 << 22,
Zl = 1 << 23,
Zp = 1 << 24,
Cc = 1 << 25,
Cf = 1 << 26,
Cs = 1 << 27,
Co = 1 << 28,
Cn = 1 << 29,
SpecialMapping = 1 << 30,
}
    enum BidiClass 
{
L,
LRE,
LRO,
R,
AL,
RLE,
RLO,
PDF,
EN,
ES,
ET,
AN,
CS,
NSM,
BN,
B,
S,
WS,
ON,
}
    enum DecompositionType 
{
None,
Font,
NoBreak,
Initial,
Medial,
Final,
Isolated,
Circle,
Super,
Sub,
Vertical,
Wide,
Narrow,
Small,
Square,
Fraction,
Compat,
}
    enum BidiMirrored 
{
Y,
N,
}
    dchar code;
    GeneralCategory generalCategory;
    dchar simpleUpperCaseMapping;
    dchar simpleLowerCaseMapping;
    dchar simpleTitleCaseMapping;
}
struct SpecialCaseData
{
    dchar code;
    dchar[] upperCaseMapping;
    dchar[] lowerCaseMapping;
    dchar[] titleCaseMapping;
}
struct FoldingCaseData
{
    dchar code;
    dchar[] mapping;
}
private template binary_search(T)
{
ptrdiff_t binary_search(T[] array, dchar code)
{
size_t lo = 0;
size_t hi = array.length;
while (lo < hi)
{
auto mid = lo + (hi - lo) / 2;
if (code > array[mid].code)
lo = mid + 1;
else
if (code < array[mid].code)
hi = mid;
else
return mid;
}
return -1;
}
}

UnicodeData* getUnicodeData(dchar code)
{
if (code >= 0 && code <= 879)
return &internalUnicodeData[cast(size_t)code - 0];
auto idx = binary_search(internalUnicodeData,code);
return idx >= 0 ? &internalUnicodeData[idx] : null;
}
SpecialCaseData* getSpecialCaseData(dchar code)
{
auto idx = binary_search(internalSpecialCaseData,code);
return idx >= 0 ? &internalSpecialCaseData[idx] : null;
}
FoldingCaseData* getFoldingCaseData(dchar code)
{
if (code >= 65 && code <= 90)
return &internalFoldingCaseData[cast(size_t)code - 65];
auto idx = binary_search(internalFoldingCaseData,code);
return idx >= 0 ? &internalFoldingCaseData[idx] : null;
}
private 
{
    const Lu = UnicodeData.GeneralCategory.Lu;
    const Ll = UnicodeData.GeneralCategory.Ll;
    const Lt = UnicodeData.GeneralCategory.Lt;
    const Lm = UnicodeData.GeneralCategory.Lm;
    const Lo = UnicodeData.GeneralCategory.Lo;
    const Mn = UnicodeData.GeneralCategory.Mn;
    const Mc = UnicodeData.GeneralCategory.Mc;
    const Me = UnicodeData.GeneralCategory.Me;
    const Nd = UnicodeData.GeneralCategory.Nd;
    const Nl = UnicodeData.GeneralCategory.Nl;
    const No = UnicodeData.GeneralCategory.No;
    const Pc = UnicodeData.GeneralCategory.Pc;
    const Pd = UnicodeData.GeneralCategory.Pd;
    const Ps = UnicodeData.GeneralCategory.Ps;
    const Pe = UnicodeData.GeneralCategory.Pe;
    const Pi = UnicodeData.GeneralCategory.Pi;
    const Pf = UnicodeData.GeneralCategory.Pf;
    const Po = UnicodeData.GeneralCategory.Po;
    const Sm = UnicodeData.GeneralCategory.Sm;
    const Sc = UnicodeData.GeneralCategory.Sc;
    const Sk = UnicodeData.GeneralCategory.Sk;
    const So = UnicodeData.GeneralCategory.So;
    const Zs = UnicodeData.GeneralCategory.Zs;
    const Zl = UnicodeData.GeneralCategory.Zl;
    const Zp = UnicodeData.GeneralCategory.Zp;
    const Cc = UnicodeData.GeneralCategory.Cc;
    const Cf = UnicodeData.GeneralCategory.Cf;
    const Cs = UnicodeData.GeneralCategory.Cs;
    const Co = UnicodeData.GeneralCategory.Co;
    const Cn = UnicodeData.GeneralCategory.Cn;
    const SM = UnicodeData.GeneralCategory.SpecialMapping;
}
private 
{
    UnicodeData[] internalUnicodeData = [{0,Cc,0,0,0},{1,Cc,1,1,1},{2,Cc,2,2,2},{3,Cc,3,3,3},{4,Cc,4,4,4},{5,Cc,5,5,5},{6,Cc,6,6,6},{7,Cc,7,7,7},{8,Cc,8,8,8},{9,Cc,9,9,9},{10,Cc,10,10,10},{11,Cc,11,11,11},{12,Cc,12,12,12},{13,Cc,13,13,13},{14,Cc,14,14,14},{15,Cc,15,15,15},{16,Cc,16,16,16},{17,Cc,17,17,17},{18,Cc,18,18,18},{19,Cc,19,19,19},{20,Cc,20,20,20},{21,Cc,21,21,21},{22,Cc,22,22,22},{23,Cc,23,23,23},{24,Cc,24,24,24},{25,Cc,25,25,25},{26,Cc,26,26,26},{27,Cc,27,27,27},{28,Cc,28,28,28},{29,Cc,29,29,29},{30,Cc,30,30,30},{31,Cc,31,31,31},{32,Zs,32,32,32},{33,Po,33,33,33},{34,Po,34,34,34},{35,Po,35,35,35},{36,Sc,36,36,36},{37,Po,37,37,37},{38,Po,38,38,38},{39,Po,39,39,39},{40,Ps,40,40,40},{41,Pe,41,41,41},{42,Po,42,42,42},{43,Sm,43,43,43},{44,Po,44,44,44},{45,Pd,45,45,45},{46,Po,46,46,46},{47,Po,47,47,47},{48,Nd,48,48,48},{49,Nd,49,49,49},{50,Nd,50,50,50},{51,Nd,51,51,51},{52,Nd,52,52,52},{53,Nd,53,53,53},{54,Nd,54,54,54},{55,Nd,55,55,55},{56,Nd,56,56,56},{57,Nd,57,57,57},{58,Po,58,58,58},{59,Po,59,59,59},{60,Sm,60,60,60},{61,Sm,61,61,61},{62,Sm,62,62,62},{63,Po,63,63,63},{64,Po,64,64,64},{65,Lu,65,97,65},{66,Lu,66,98,66},{67,Lu,67,99,67},{68,Lu,68,100,68},{69,Lu,69,101,69},{70,Lu,70,102,70},{71,Lu,71,103,71},{72,Lu,72,104,72},{73,Lu,73,105,73},{74,Lu,74,106,74},{75,Lu,75,107,75},{76,Lu,76,108,76},{77,Lu,77,109,77},{78,Lu,78,110,78},{79,Lu,79,111,79},{80,Lu,80,112,80},{81,Lu,81,113,81},{82,Lu,82,114,82},{83,Lu,83,115,83},{84,Lu,84,116,84},{85,Lu,85,117,85},{86,Lu,86,118,86},{87,Lu,87,119,87},{88,Lu,88,120,88},{89,Lu,89,121,89},{90,Lu,90,122,90},{91,Ps,91,91,91},{92,Po,92,92,92},{93,Pe,93,93,93},{94,Sk,94,94,94},{95,Pc,95,95,95},{96,Sk,96,96,96},{97,Ll,65,97,65},{98,Ll,66,98,66},{99,Ll,67,99,67},{100,Ll,68,100,68},{101,Ll,69,101,69},{102,Ll,70,102,70},{103,Ll,71,103,71},{104,Ll,72,104,72},{105,Ll,73,105,73},{106,Ll,74,106,74},{107,Ll,75,107,75},{108,Ll,76,108,76},{109,Ll,77,109,77},{110,Ll,78,110,78},{111,Ll,79,111,79},{112,Ll,80,112,80},{113,Ll,81,113,81},{114,Ll,82,114,82},{115,Ll,83,115,83},{116,Ll,84,116,84},{117,Ll,85,117,85},{118,Ll,86,118,86},{119,Ll,87,119,87},{120,Ll,88,120,88},{121,Ll,89,121,89},{122,Ll,90,122,90},{123,Ps,123,123,123},{124,Sm,124,124,124},{125,Pe,125,125,125},{126,Sm,126,126,126},{127,Cc,127,127,127},{128,Cc,128,128,128},{129,Cc,129,129,129},{130,Cc,130,130,130},{131,Cc,131,131,131},{132,Cc,132,132,132},{133,Cc,133,133,133},{134,Cc,134,134,134},{135,Cc,135,135,135},{136,Cc,136,136,136},{137,Cc,137,137,137},{138,Cc,138,138,138},{139,Cc,139,139,139},{140,Cc,140,140,140},{141,Cc,141,141,141},{142,Cc,142,142,142},{143,Cc,143,143,143},{144,Cc,144,144,144},{145,Cc,145,145,145},{146,Cc,146,146,146},{147,Cc,147,147,147},{148,Cc,148,148,148},{149,Cc,149,149,149},{150,Cc,150,150,150},{151,Cc,151,151,151},{152,Cc,152,152,152},{153,Cc,153,153,153},{154,Cc,154,154,154},{155,Cc,155,155,155},{156,Cc,156,156,156},{157,Cc,157,157,157},{158,Cc,158,158,158},{159,Cc,159,159,159},{160,Zs,160,160,160},{161,Po,161,161,161},{162,Sc,162,162,162},{163,Sc,163,163,163},{164,Sc,164,164,164},{165,Sc,165,165,165},{166,So,166,166,166},{167,So,167,167,167},{168,Sk,168,168,168},{169,So,169,169,169},{170,Ll,170,170,170},{171,Pi,171,171,171},{172,Sm,172,172,172},{173,Cf,173,173,173},{174,So,174,174,174},{175,Sk,175,175,175},{176,So,176,176,176},{177,Sm,177,177,177},{178,No,178,178,178},{179,No,179,179,179},{180,Sk,180,180,180},{181,Ll,924,181,924},{182,So,182,182,182},{183,Po,183,183,183},{184,Sk,184,184,184},{185,No,185,185,185},{186,Ll,186,186,186},{187,Pf,187,187,187},{188,No,188,188,188},{189,No,189,189,189},{190,No,190,190,190},{191,Po,191,191,191},{192,Lu,192,224,192},{193,Lu,193,225,193},{194,Lu,194,226,194},{195,Lu,195,227,195},{196,Lu,196,228,196},{197,Lu,197,229,197},{198,Lu,198,230,198},{199,Lu,199,231,199},{200,Lu,200,232,200},{201,Lu,201,233,201},{202,Lu,202,234,202},{203,Lu,203,235,203},{204,Lu,204,236,204},{205,Lu,205,237,205},{206,Lu,206,238,206},{207,Lu,207,239,207},{208,Lu,208,240,208},{209,Lu,209,241,209},{210,Lu,210,242,210},{211,Lu,211,243,211},{212,Lu,212,244,212},{213,Lu,213,245,213},{214,Lu,214,246,214},{215,Sm,215,215,215},{216,Lu,216,248,216},{217,Lu,217,249,217},{218,Lu,218,250,218},{219,Lu,219,251,219},{220,Lu,220,252,220},{221,Lu,221,253,221},{222,Lu,222,254,222},{223,Ll | SM,223,223,223},{224,Ll,192,224,192},{225,Ll,193,225,193},{226,Ll,194,226,194},{227,Ll,195,227,195},{228,Ll,196,228,196},{229,Ll,197,229,197},{230,Ll,198,230,198},{231,Ll,199,231,199},{232,Ll,200,232,200},{233,Ll,201,233,201},{234,Ll,202,234,202},{235,Ll,203,235,203},{236,Ll,204,236,204},{237,Ll,205,237,205},{238,Ll,206,238,206},{239,Ll,207,239,207},{240,Ll,208,240,208},{241,Ll,209,241,209},{242,Ll,210,242,210},{243,Ll,211,243,211},{244,Ll,212,244,212},{245,Ll,213,245,213},{246,Ll,214,246,214},{247,Sm,247,247,247},{248,Ll,216,248,216},{249,Ll,217,249,217},{250,Ll,218,250,218},{251,Ll,219,251,219},{252,Ll,220,252,220},{253,Ll,221,253,221},{254,Ll,222,254,222},{255,Ll,376,255,376},{256,Lu,256,257,256},{257,Ll,256,257,256},{258,Lu,258,259,258},{259,Ll,258,259,258},{260,Lu,260,261,260},{261,Ll,260,261,260},{262,Lu,262,263,262},{263,Ll,262,263,262},{264,Lu,264,265,264},{265,Ll,264,265,264},{266,Lu,266,267,266},{267,Ll,266,267,266},{268,Lu,268,269,268},{269,Ll,268,269,268},{270,Lu,270,271,270},{271,Ll,270,271,270},{272,Lu,272,273,272},{273,Ll,272,273,272},{274,Lu,274,275,274},{275,Ll,274,275,274},{276,Lu,276,277,276},{277,Ll,276,277,276},{278,Lu,278,279,278},{279,Ll,278,279,278},{280,Lu,280,281,280},{281,Ll,280,281,280},{282,Lu,282,283,282},{283,Ll,282,283,282},{284,Lu,284,285,284},{285,Ll,284,285,284},{286,Lu,286,287,286},{287,Ll,286,287,286},{288,Lu,288,289,288},{289,Ll,288,289,288},{290,Lu,290,291,290},{291,Ll,290,291,290},{292,Lu,292,293,292},{293,Ll,292,293,292},{294,Lu,294,295,294},{295,Ll,294,295,294},{296,Lu,296,297,296},{297,Ll,296,297,296},{298,Lu,298,299,298},{299,Ll,298,299,298},{300,Lu,300,301,300},{301,Ll,300,301,300},{302,Lu,302,303,302},{303,Ll,302,303,302},{304,Lu | SM,304,105,304},{305,Ll,73,305,73},{306,Lu,306,307,306},{307,Ll,306,307,306},{308,Lu,308,309,308},{309,Ll,308,309,308},{310,Lu,310,311,310},{311,Ll,310,311,310},{312,Ll,312,312,312},{313,Lu,313,314,313},{314,Ll,313,314,313},{315,Lu,315,316,315},{316,Ll,315,316,315},{317,Lu,317,318,317},{318,Ll,317,318,317},{319,Lu,319,320,319},{320,Ll,319,320,319},{321,Lu,321,322,321},{322,Ll,321,322,321},{323,Lu,323,324,323},{324,Ll,323,324,323},{325,Lu,325,326,325},{326,Ll,325,326,325},{327,Lu,327,328,327},{328,Ll,327,328,327},{329,Ll | SM,329,329,329},{330,Lu,330,331,330},{331,Ll,330,331,330},{332,Lu,332,333,332},{333,Ll,332,333,332},{334,Lu,334,335,334},{335,Ll,334,335,334},{336,Lu,336,337,336},{337,Ll,336,337,336},{338,Lu,338,339,338},{339,Ll,338,339,338},{340,Lu,340,341,340},{341,Ll,340,341,340},{342,Lu,342,343,342},{343,Ll,342,343,342},{344,Lu,344,345,344},{345,Ll,344,345,344},{346,Lu,346,347,346},{347,Ll,346,347,346},{348,Lu,348,349,348},{349,Ll,348,349,348},{350,Lu,350,351,350},{351,Ll,350,351,350},{352,Lu,352,353,352},{353,Ll,352,353,352},{354,Lu,354,355,354},{355,Ll,354,355,354},{356,Lu,356,357,356},{357,Ll,356,357,356},{358,Lu,358,359,358},{359,Ll,358,359,358},{360,Lu,360,361,360},{361,Ll,360,361,360},{362,Lu,362,363,362},{363,Ll,362,363,362},{364,Lu,364,365,364},{365,Ll,364,365,364},{366,Lu,366,367,366},{367,Ll,366,367,366},{368,Lu,368,369,368},{369,Ll,368,369,368},{370,Lu,370,371,370},{371,Ll,370,371,370},{372,Lu,372,373,372},{373,Ll,372,373,372},{374,Lu,374,375,374},{375,Ll,374,375,374},{376,Lu,376,255,376},{377,Lu,377,378,377},{378,Ll,377,378,377},{379,Lu,379,380,379},{380,Ll,379,380,379},{381,Lu,381,382,381},{382,Ll,381,382,381},{383,Ll,83,383,83},{384,Ll,579,384,579},{385,Lu,385,595,385},{386,Lu,386,387,386},{387,Ll,386,387,386},{388,Lu,388,389,388},{389,Ll,388,389,388},{390,Lu,390,596,390},{391,Lu,391,392,391},{392,Ll,391,392,391},{393,Lu,393,598,393},{394,Lu,394,599,394},{395,Lu,395,396,395},{396,Ll,395,396,395},{397,Ll,397,397,397},{398,Lu,398,477,398},{399,Lu,399,601,399},{400,Lu,400,603,400},{401,Lu,401,402,401},{402,Ll,401,402,401},{403,Lu,403,608,403},{404,Lu,404,611,404},{405,Ll,502,405,502},{406,Lu,406,617,406},{407,Lu,407,616,407},{408,Lu,408,409,408},{409,Ll,408,409,408},{410,Ll,573,410,573},{411,Ll,411,411,411},{412,Lu,412,623,412},{413,Lu,413,626,413},{414,Ll,544,414,544},{415,Lu,415,629,415},{416,Lu,416,417,416},{417,Ll,416,417,416},{418,Lu,418,419,418},{419,Ll,418,419,418},{420,Lu,420,421,420},{421,Ll,420,421,420},{422,Lu,422,640,422},{423,Lu,423,424,423},{424,Ll,423,424,423},{425,Lu,425,643,425},{426,Ll,426,426,426},{427,Ll,427,427,427},{428,Lu,428,429,428},{429,Ll,428,429,428},{430,Lu,430,648,430},{431,Lu,431,432,431},{432,Ll,431,432,431},{433,Lu,433,650,433},{434,Lu,434,651,434},{435,Lu,435,436,435},{436,Ll,435,436,435},{437,Lu,437,438,437},{438,Ll,437,438,437},{439,Lu,439,658,439},{440,Lu,440,441,440},{441,Ll,440,441,440},{442,Ll,442,442,442},{443,Lo,443,443,443},{444,Lu,444,445,444},{445,Ll,444,445,444},{446,Ll,446,446,446},{447,Ll,503,447,503},{448,Lo,448,448,448},{449,Lo,449,449,449},{450,Lo,450,450,450},{451,Lo,451,451,451},{452,Lu,452,454,453},{453,Lt,452,454,453},{454,Ll,452,454,453},{455,Lu,455,457,456},{456,Lt,455,457,456},{457,Ll,455,457,456},{458,Lu,458,460,459},{459,Lt,458,460,459},{460,Ll,458,460,459},{461,Lu,461,462,461},{462,Ll,461,462,461},{463,Lu,463,464,463},{464,Ll,463,464,463},{465,Lu,465,466,465},{466,Ll,465,466,465},{467,Lu,467,468,467},{468,Ll,467,468,467},{469,Lu,469,470,469},{470,Ll,469,470,469},{471,Lu,471,472,471},{472,Ll,471,472,471},{473,Lu,473,474,473},{474,Ll,473,474,473},{475,Lu,475,476,475},{476,Ll,475,476,475},{477,Ll,398,477,398},{478,Lu,478,479,478},{479,Ll,478,479,478},{480,Lu,480,481,480},{481,Ll,480,481,480},{482,Lu,482,483,482},{483,Ll,482,483,482},{484,Lu,484,485,484},{485,Ll,484,485,484},{486,Lu,486,487,486},{487,Ll,486,487,486},{488,Lu,488,489,488},{489,Ll,488,489,488},{490,Lu,490,491,490},{491,Ll,490,491,490},{492,Lu,492,493,492},{493,Ll,492,493,492},{494,Lu,494,495,494},{495,Ll,494,495,494},{496,Ll | SM,496,496,496},{497,Lu,497,499,498},{498,Lt,497,499,498},{499,Ll,497,499,498},{500,Lu,500,501,500},{501,Ll,500,501,500},{502,Lu,502,405,502},{503,Lu,503,447,503},{504,Lu,504,505,504},{505,Ll,504,505,504},{506,Lu,506,507,506},{507,Ll,506,507,506},{508,Lu,508,509,508},{509,Ll,508,509,508},{510,Lu,510,511,510},{511,Ll,510,511,510},{512,Lu,512,513,512},{513,Ll,512,513,512},{514,Lu,514,515,514},{515,Ll,514,515,514},{516,Lu,516,517,516},{517,Ll,516,517,516},{518,Lu,518,519,518},{519,Ll,518,519,518},{520,Lu,520,521,520},{521,Ll,520,521,520},{522,Lu,522,523,522},{523,Ll,522,523,522},{524,Lu,524,525,524},{525,Ll,524,525,524},{526,Lu,526,527,526},{527,Ll,526,527,526},{528,Lu,528,529,528},{529,Ll,528,529,528},{530,Lu,530,531,530},{531,Ll,530,531,530},{532,Lu,532,533,532},{533,Ll,532,533,532},{534,Lu,534,535,534},{535,Ll,534,535,534},{536,Lu,536,537,536},{537,Ll,536,537,536},{538,Lu,538,539,538},{539,Ll,538,539,538},{540,Lu,540,541,540},{541,Ll,540,541,540},{542,Lu,542,543,542},{543,Ll,542,543,542},{544,Lu,544,414,544},{545,Ll,545,545,545},{546,Lu,546,547,546},{547,Ll,546,547,546},{548,Lu,548,549,548},{549,Ll,548,549,548},{550,Lu,550,551,550},{551,Ll,550,551,550},{552,Lu,552,553,552},{553,Ll,552,553,552},{554,Lu,554,555,554},{555,Ll,554,555,554},{556,Lu,556,557,556},{557,Ll,556,557,556},{558,Lu,558,559,558},{559,Ll,558,559,558},{560,Lu,560,561,560},{561,Ll,560,561,560},{562,Lu,562,563,562},{563,Ll,562,563,562},{564,Ll,564,564,564},{565,Ll,565,565,565},{566,Ll,566,566,566},{567,Ll,567,567,567},{568,Ll,568,568,568},{569,Ll,569,569,569},{570,Lu,570,11365,570},{571,Lu,571,572,571},{572,Ll,571,572,571},{573,Lu,573,410,573},{574,Lu,574,11366,574},{575,Ll,575,575,575},{576,Ll,576,576,576},{577,Lu,577,578,577},{578,Ll,577,578,577},{579,Lu,579,384,579},{580,Lu,580,649,580},{581,Lu,581,652,581},{582,Lu,582,583,582},{583,Ll,582,583,582},{584,Lu,584,585,584},{585,Ll,584,585,584},{586,Lu,586,587,586},{587,Ll,586,587,586},{588,Lu,588,589,588},{589,Ll,588,589,588},{590,Lu,590,591,590},{591,Ll,590,591,590},{592,Ll,592,592,592},{593,Ll,593,593,593},{594,Ll,594,594,594},{595,Ll,385,595,385},{596,Ll,390,596,390},{597,Ll,597,597,597},{598,Ll,393,598,393},{599,Ll,394,599,394},{600,Ll,600,600,600},{601,Ll,399,601,399},{602,Ll,602,602,602},{603,Ll,400,603,400},{604,Ll,604,604,604},{605,Ll,605,605,605},{606,Ll,606,606,606},{607,Ll,607,607,607},{608,Ll,403,608,403},{609,Ll,609,609,609},{610,Ll,610,610,610},{611,Ll,404,611,404},{612,Ll,612,612,612},{613,Ll,613,613,613},{614,Ll,614,614,614},{615,Ll,615,615,615},{616,Ll,407,616,407},{617,Ll,406,617,406},{618,Ll,618,618,618},{619,Ll,11362,619,11362},{620,Ll,620,620,620},{621,Ll,621,621,621},{622,Ll,622,622,622},{623,Ll,412,623,412},{624,Ll,624,624,624},{625,Ll,625,625,625},{626,Ll,413,626,413},{627,Ll,627,627,627},{628,Ll,628,628,628},{629,Ll,415,629,415},{630,Ll,630,630,630},{631,Ll,631,631,631},{632,Ll,632,632,632},{633,Ll,633,633,633},{634,Ll,634,634,634},{635,Ll,635,635,635},{636,Ll,636,636,636},{637,Ll,11364,637,11364},{638,Ll,638,638,638},{639,Ll,639,639,639},{640,Ll,422,640,422},{641,Ll,641,641,641},{642,Ll,642,642,642},{643,Ll,425,643,425},{644,Ll,644,644,644},{645,Ll,645,645,645},{646,Ll,646,646,646},{647,Ll,647,647,647},{648,Ll,430,648,430},{649,Ll,580,649,580},{650,Ll,433,650,433},{651,Ll,434,651,434},{652,Ll,581,652,581},{653,Ll,653,653,653},{654,Ll,654,654,654},{655,Ll,655,655,655},{656,Ll,656,656,656},{657,Ll,657,657,657},{658,Ll,439,658,439},{659,Ll,659,659,659},{660,Lo,660,660,660},{661,Ll,661,661,661},{662,Ll,662,662,662},{663,Ll,663,663,663},{664,Ll,664,664,664},{665,Ll,665,665,665},{666,Ll,666,666,666},{667,Ll,667,667,667},{668,Ll,668,668,668},{669,Ll,669,669,669},{670,Ll,670,670,670},{671,Ll,671,671,671},{672,Ll,672,672,672},{673,Ll,673,673,673},{674,Ll,674,674,674},{675,Ll,675,675,675},{676,Ll,676,676,676},{677,Ll,677,677,677},{678,Ll,678,678,678},{679,Ll,679,679,679},{680,Ll,680,680,680},{681,Ll,681,681,681},{682,Ll,682,682,682},{683,Ll,683,683,683},{684,Ll,684,684,684},{685,Ll,685,685,685},{686,Ll,686,686,686},{687,Ll,687,687,687},{688,Lm,688,688,688},{689,Lm,689,689,689},{690,Lm,690,690,690},{691,Lm,691,691,691},{692,Lm,692,692,692},{693,Lm,693,693,693},{694,Lm,694,694,694},{695,Lm,695,695,695},{696,Lm,696,696,696},{697,Lm,697,697,697},{698,Lm,698,698,698},{699,Lm,699,699,699},{700,Lm,700,700,700},{701,Lm,701,701,701},{702,Lm,702,702,702},{703,Lm,703,703,703},{704,Lm,704,704,704},{705,Lm,705,705,705},{706,Sk,706,706,706},{707,Sk,707,707,707},{708,Sk,708,708,708},{709,Sk,709,709,709},{710,Lm,710,710,710},{711,Lm,711,711,711},{712,Lm,712,712,712},{713,Lm,713,713,713},{714,Lm,714,714,714},{715,Lm,715,715,715},{716,Lm,716,716,716},{717,Lm,717,717,717},{718,Lm,718,718,718},{719,Lm,719,719,719},{720,Lm,720,720,720},{721,Lm,721,721,721},{722,Sk,722,722,722},{723,Sk,723,723,723},{724,Sk,724,724,724},{725,Sk,725,725,725},{726,Sk,726,726,726},{727,Sk,727,727,727},{728,Sk,728,728,728},{729,Sk,729,729,729},{730,Sk,730,730,730},{731,Sk,731,731,731},{732,Sk,732,732,732},{733,Sk,733,733,733},{734,Sk,734,734,734},{735,Sk,735,735,735},{736,Lm,736,736,736},{737,Lm,737,737,737},{738,Lm,738,738,738},{739,Lm,739,739,739},{740,Lm,740,740,740},{741,Sk,741,741,741},{742,Sk,742,742,742},{743,Sk,743,743,743},{744,Sk,744,744,744},{745,Sk,745,745,745},{746,Sk,746,746,746},{747,Sk,747,747,747},{748,Sk,748,748,748},{749,Sk,749,749,749},{750,Lm,750,750,750},{751,Sk,751,751,751},{752,Sk,752,752,752},{753,Sk,753,753,753},{754,Sk,754,754,754},{755,Sk,755,755,755},{756,Sk,756,756,756},{757,Sk,757,757,757},{758,Sk,758,758,758},{759,Sk,759,759,759},{760,Sk,760,760,760},{761,Sk,761,761,761},{762,Sk,762,762,762},{763,Sk,763,763,763},{764,Sk,764,764,764},{765,Sk,765,765,765},{766,Sk,766,766,766},{767,Sk,767,767,767},{768,Mn,768,768,768},{769,Mn,769,769,769},{770,Mn,770,770,770},{771,Mn,771,771,771},{772,Mn,772,772,772},{773,Mn,773,773,773},{774,Mn,774,774,774},{775,Mn,775,775,775},{776,Mn,776,776,776},{777,Mn,777,777,777},{778,Mn,778,778,778},{779,Mn,779,779,779},{780,Mn,780,780,780},{781,Mn,781,781,781},{782,Mn,782,782,782},{783,Mn,783,783,783},{784,Mn,784,784,784},{785,Mn,785,785,785},{786,Mn,786,786,786},{787,Mn,787,787,787},{788,Mn,788,788,788},{789,Mn,789,789,789},{790,Mn,790,790,790},{791,Mn,791,791,791},{792,Mn,792,792,792},{793,Mn,793,793,793},{794,Mn,794,794,794},{795,Mn,795,795,795},{796,Mn,796,796,796},{797,Mn,797,797,797},{798,Mn,798,798,798},{799,Mn,799,799,799},{800,Mn,800,800,800},{801,Mn,801,801,801},{802,Mn,802,802,802},{803,Mn,803,803,803},{804,Mn,804,804,804},{805,Mn,805,805,805},{806,Mn,806,806,806},{807,Mn,807,807,807},{808,Mn,808,808,808},{809,Mn,809,809,809},{810,Mn,810,810,810},{811,Mn,811,811,811},{812,Mn,812,812,812},{813,Mn,813,813,813},{814,Mn,814,814,814},{815,Mn,815,815,815},{816,Mn,816,816,816},{817,Mn,817,817,817},{818,Mn,818,818,818},{819,Mn,819,819,819},{820,Mn,820,820,820},{821,Mn,821,821,821},{822,Mn,822,822,822},{823,Mn,823,823,823},{824,Mn,824,824,824},{825,Mn,825,825,825},{826,Mn,826,826,826},{827,Mn,827,827,827},{828,Mn,828,828,828},{829,Mn,829,829,829},{830,Mn,830,830,830},{831,Mn,831,831,831},{832,Mn,832,832,832},{833,Mn,833,833,833},{834,Mn,834,834,834},{835,Mn,835,835,835},{836,Mn,836,836,836},{837,Mn,921,837,921},{838,Mn,838,838,838},{839,Mn,839,839,839},{840,Mn,840,840,840},{841,Mn,841,841,841},{842,Mn,842,842,842},{843,Mn,843,843,843},{844,Mn,844,844,844},{845,Mn,845,845,845},{846,Mn,846,846,846},{847,Mn,847,847,847},{848,Mn,848,848,848},{849,Mn,849,849,849},{850,Mn,850,850,850},{851,Mn,851,851,851},{852,Mn,852,852,852},{853,Mn,853,853,853},{854,Mn,854,854,854},{855,Mn,855,855,855},{856,Mn,856,856,856},{857,Mn,857,857,857},{858,Mn,858,858,858},{859,Mn,859,859,859},{860,Mn,860,860,860},{861,Mn,861,861,861},{862,Mn,862,862,862},{863,Mn,863,863,863},{864,Mn,864,864,864},{865,Mn,865,865,865},{866,Mn,866,866,866},{867,Mn,867,867,867},{868,Mn,868,868,868},{869,Mn,869,869,869},{870,Mn,870,870,870},{871,Mn,871,871,871},{872,Mn,872,872,872},{873,Mn,873,873,873},{874,Mn,874,874,874},{875,Mn,875,875,875},{876,Mn,876,876,876},{877,Mn,877,877,877},{878,Mn,878,878,878},{879,Mn,879,879,879},{884,Sk,884,884,884},{885,Sk,885,885,885},{890,Lm,890,890,890},{891,Ll,1021,891,1021},{892,Ll,1022,892,1022},{893,Ll,1023,893,1023},{894,Po,894,894,894},{900,Sk,900,900,900},{901,Sk,901,901,901},{902,Lu,902,940,902},{903,Po,903,903,903},{904,Lu,904,941,904},{905,Lu,905,942,905},{906,Lu,906,943,906},{908,Lu,908,972,908},{910,Lu,910,973,910},{911,Lu,911,974,911},{912,Ll | SM,912,912,912},{913,Lu,913,945,913},{914,Lu,914,946,914},{915,Lu,915,947,915},{916,Lu,916,948,916},{917,Lu,917,949,917},{918,Lu,918,950,918},{919,Lu,919,951,919},{920,Lu,920,952,920},{921,Lu,921,953,921},{922,Lu,922,954,922},{923,Lu,923,955,923},{924,Lu,924,956,924},{925,Lu,925,957,925},{926,Lu,926,958,926},{927,Lu,927,959,927},{928,Lu,928,960,928},{929,Lu,929,961,929},{931,Lu,931,963,931},{932,Lu,932,964,932},{933,Lu,933,965,933},{934,Lu,934,966,934},{935,Lu,935,967,935},{936,Lu,936,968,936},{937,Lu,937,969,937},{938,Lu,938,970,938},{939,Lu,939,971,939},{940,Ll,902,940,902},{941,Ll,904,941,904},{942,Ll,905,942,905},{943,Ll,906,943,906},{944,Ll | SM,944,944,944},{945,Ll,913,945,913},{946,Ll,914,946,914},{947,Ll,915,947,915},{948,Ll,916,948,916},{949,Ll,917,949,917},{950,Ll,918,950,918},{951,Ll,919,951,919},{952,Ll,920,952,920},{953,Ll,921,953,921},{954,Ll,922,954,922},{955,Ll,923,955,923},{956,Ll,924,956,924},{957,Ll,925,957,925},{958,Ll,926,958,926},{959,Ll,927,959,927},{960,Ll,928,960,928},{961,Ll,929,961,929},{962,Ll,931,962,931},{963,Ll,931,963,931},{964,Ll,932,964,932},{965,Ll,933,965,933},{966,Ll,934,966,934},{967,Ll,935,967,935},{968,Ll,936,968,936},{969,Ll,937,969,937},{970,Ll,938,970,938},{971,Ll,939,971,939},{972,Ll,908,972,908},{973,Ll,910,973,910},{974,Ll,911,974,911},{976,Ll,914,976,914},{977,Ll,920,977,920},{978,Lu,978,978,978},{979,Lu,979,979,979},{980,Lu,980,980,980},{981,Ll,934,981,934},{982,Ll,928,982,928},{983,Ll,983,983,983},{984,Lu,984,985,984},{985,Ll,984,985,984},{986,Lu,986,987,986},{987,Ll,986,987,986},{988,Lu,988,989,988},{989,Ll,988,989,988},{990,Lu,990,991,990},{991,Ll,990,991,990},{992,Lu,992,993,992},{993,Ll,992,993,992},{994,Lu,994,995,994},{995,Ll,994,995,994},{996,Lu,996,997,996},{997,Ll,996,997,996},{998,Lu,998,999,998},{999,Ll,998,999,998},{1000,Lu,1000,1001,1000},{1001,Ll,1000,1001,1000},{1002,Lu,1002,1003,1002},{1003,Ll,1002,1003,1002},{1004,Lu,1004,1005,1004},{1005,Ll,1004,1005,1004},{1006,Lu,1006,1007,1006},{1007,Ll,1006,1007,1006},{1008,Ll,922,1008,922},{1009,Ll,929,1009,929},{1010,Ll,1017,1010,1017},{1011,Ll,1011,1011,1011},{1012,Lu,1012,952,1012},{1013,Ll,917,1013,917},{1014,Sm,1014,1014,1014},{1015,Lu,1015,1016,1015},{1016,Ll,1015,1016,1015},{1017,Lu,1017,1010,1017},{1018,Lu,1018,1019,1018},{1019,Ll,1018,1019,1018},{1020,Ll,1020,1020,1020},{1021,Lu,1021,891,1021},{1022,Lu,1022,892,1022},{1023,Lu,1023,893,1023},{1024,Lu,1024,1104,1024},{1025,Lu,1025,1105,1025},{1026,Lu,1026,1106,1026},{1027,Lu,1027,1107,1027},{1028,Lu,1028,1108,1028},{1029,Lu,1029,1109,1029},{1030,Lu,1030,1110,1030},{1031,Lu,1031,1111,1031},{1032,Lu,1032,1112,1032},{1033,Lu,1033,1113,1033},{1034,Lu,1034,1114,1034},{1035,Lu,1035,1115,1035},{1036,Lu,1036,1116,1036},{1037,Lu,1037,1117,1037},{1038,Lu,1038,1118,1038},{1039,Lu,1039,1119,1039},{1040,Lu,1040,1072,1040},{1041,Lu,1041,1073,1041},{1042,Lu,1042,1074,1042},{1043,Lu,1043,1075,1043},{1044,Lu,1044,1076,1044},{1045,Lu,1045,1077,1045},{1046,Lu,1046,1078,1046},{1047,Lu,1047,1079,1047},{1048,Lu,1048,1080,1048},{1049,Lu,1049,1081,1049},{1050,Lu,1050,1082,1050},{1051,Lu,1051,1083,1051},{1052,Lu,1052,1084,1052},{1053,Lu,1053,1085,1053},{1054,Lu,1054,1086,1054},{1055,Lu,1055,1087,1055},{1056,Lu,1056,1088,1056},{1057,Lu,1057,1089,1057},{1058,Lu,1058,1090,1058},{1059,Lu,1059,1091,1059},{1060,Lu,1060,1092,1060},{1061,Lu,1061,1093,1061},{1062,Lu,1062,1094,1062},{1063,Lu,1063,1095,1063},{1064,Lu,1064,1096,1064},{1065,Lu,1065,1097,1065},{1066,Lu,1066,1098,1066},{1067,Lu,1067,1099,1067},{1068,Lu,1068,1100,1068},{1069,Lu,1069,1101,1069},{1070,Lu,1070,1102,1070},{1071,Lu,1071,1103,1071},{1072,Ll,1040,1072,1040},{1073,Ll,1041,1073,1041},{1074,Ll,1042,1074,1042},{1075,Ll,1043,1075,1043},{1076,Ll,1044,1076,1044},{1077,Ll,1045,1077,1045},{1078,Ll,1046,1078,1046},{1079,Ll,1047,1079,1047},{1080,Ll,1048,1080,1048},{1081,Ll,1049,1081,1049},{1082,Ll,1050,1082,1050},{1083,Ll,1051,1083,1051},{1084,Ll,1052,1084,1052},{1085,Ll,1053,1085,1053},{1086,Ll,1054,1086,1054},{1087,Ll,1055,1087,1055},{1088,Ll,1056,1088,1056},{1089,Ll,1057,1089,1057},{1090,Ll,1058,1090,1058},{1091,Ll,1059,1091,1059},{1092,Ll,1060,1092,1060},{1093,Ll,1061,1093,1061},{1094,Ll,1062,1094,1062},{1095,Ll,1063,1095,1063},{1096,Ll,1064,1096,1064},{1097,Ll,1065,1097,1065},{1098,Ll,1066,1098,1066},{1099,Ll,1067,1099,1067},{1100,Ll,1068,1100,1068},{1101,Ll,1069,1101,1069},{1102,Ll,1070,1102,1070},{1103,Ll,1071,1103,1071},{1104,Ll,1024,1104,1024},{1105,Ll,1025,1105,1025},{1106,Ll,1026,1106,1026},{1107,Ll,1027,1107,1027},{1108,Ll,1028,1108,1028},{1109,Ll,1029,1109,1029},{1110,Ll,1030,1110,1030},{1111,Ll,1031,1111,1031},{1112,Ll,1032,1112,1032},{1113,Ll,1033,1113,1033},{1114,Ll,1034,1114,1034},{1115,Ll,1035,1115,1035},{1116,Ll,1036,1116,1036},{1117,Ll,1037,1117,1037},{1118,Ll,1038,1118,1038},{1119,Ll,1039,1119,1039},{1120,Lu,1120,1121,1120},{1121,Ll,1120,1121,1120},{1122,Lu,1122,1123,1122},{1123,Ll,1122,1123,1122},{1124,Lu,1124,1125,1124},{1125,Ll,1124,1125,1124},{1126,Lu,1126,1127,1126},{1127,Ll,1126,1127,1126},{1128,Lu,1128,1129,1128},{1129,Ll,1128,1129,1128},{1130,Lu,1130,1131,1130},{1131,Ll,1130,1131,1130},{1132,Lu,1132,1133,1132},{1133,Ll,1132,1133,1132},{1134,Lu,1134,1135,1134},{1135,Ll,1134,1135,1134},{1136,Lu,1136,1137,1136},{1137,Ll,1136,1137,1136},{1138,Lu,1138,1139,1138},{1139,Ll,1138,1139,1138},{1140,Lu,1140,1141,1140},{1141,Ll,1140,1141,1140},{1142,Lu,1142,1143,1142},{1143,Ll,1142,1143,1142},{1144,Lu,1144,1145,1144},{1145,Ll,1144,1145,1144},{1146,Lu,1146,1147,1146},{1147,Ll,1146,1147,1146},{1148,Lu,1148,1149,1148},{1149,Ll,1148,1149,1148},{1150,Lu,1150,1151,1150},{1151,Ll,1150,1151,1150},{1152,Lu,1152,1153,1152},{1153,Ll,1152,1153,1152},{1154,So,1154,1154,1154},{1155,Mn,1155,1155,1155},{1156,Mn,1156,1156,1156},{1157,Mn,1157,1157,1157},{1158,Mn,1158,1158,1158},{1160,Me,1160,1160,1160},{1161,Me,1161,1161,1161},{1162,Lu,1162,1163,1162},{1163,Ll,1162,1163,1162},{1164,Lu,1164,1165,1164},{1165,Ll,1164,1165,1164},{1166,Lu,1166,1167,1166},{1167,Ll,1166,1167,1166},{1168,Lu,1168,1169,1168},{1169,Ll,1168,1169,1168},{1170,Lu,1170,1171,1170},{1171,Ll,1170,1171,1170},{1172,Lu,1172,1173,1172},{1173,Ll,1172,1173,1172},{1174,Lu,1174,1175,1174},{1175,Ll,1174,1175,1174},{1176,Lu,1176,1177,1176},{1177,Ll,1176,1177,1176},{1178,Lu,1178,1179,1178},{1179,Ll,1178,1179,1178},{1180,Lu,1180,1181,1180},{1181,Ll,1180,1181,1180},{1182,Lu,1182,1183,1182},{1183,Ll,1182,1183,1182},{1184,Lu,1184,1185,1184},{1185,Ll,1184,1185,1184},{1186,Lu,1186,1187,1186},{1187,Ll,1186,1187,1186},{1188,Lu,1188,1189,1188},{1189,Ll,1188,1189,1188},{1190,Lu,1190,1191,1190},{1191,Ll,1190,1191,1190},{1192,Lu,1192,1193,1192},{1193,Ll,1192,1193,1192},{1194,Lu,1194,1195,1194},{1195,Ll,1194,1195,1194},{1196,Lu,1196,1197,1196},{1197,Ll,1196,1197,1196},{1198,Lu,1198,1199,1198},{1199,Ll,1198,1199,1198},{1200,Lu,1200,1201,1200},{1201,Ll,1200,1201,1200},{1202,Lu,1202,1203,1202},{1203,Ll,1202,1203,1202},{1204,Lu,1204,1205,1204},{1205,Ll,1204,1205,1204},{1206,Lu,1206,1207,1206},{1207,Ll,1206,1207,1206},{1208,Lu,1208,1209,1208},{1209,Ll,1208,1209,1208},{1210,Lu,1210,1211,1210},{1211,Ll,1210,1211,1210},{1212,Lu,1212,1213,1212},{1213,Ll,1212,1213,1212},{1214,Lu,1214,1215,1214},{1215,Ll,1214,1215,1214},{1216,Lu,1216,1231,1216},{1217,Lu,1217,1218,1217},{1218,Ll,1217,1218,1217},{1219,Lu,1219,1220,1219},{1220,Ll,1219,1220,1219},{1221,Lu,1221,1222,1221},{1222,Ll,1221,1222,1221},{1223,Lu,1223,1224,1223},{1224,Ll,1223,1224,1223},{1225,Lu,1225,1226,1225},{1226,Ll,1225,1226,1225},{1227,Lu,1227,1228,1227},{1228,Ll,1227,1228,1227},{1229,Lu,1229,1230,1229},{1230,Ll,1229,1230,1229},{1231,Ll,1216,1231,1216},{1232,Lu,1232,1233,1232},{1233,Ll,1232,1233,1232},{1234,Lu,1234,1235,1234},{1235,Ll,1234,1235,1234},{1236,Lu,1236,1237,1236},{1237,Ll,1236,1237,1236},{1238,Lu,1238,1239,1238},{1239,Ll,1238,1239,1238},{1240,Lu,1240,1241,1240},{1241,Ll,1240,1241,1240},{1242,Lu,1242,1243,1242},{1243,Ll,1242,1243,1242},{1244,Lu,1244,1245,1244},{1245,Ll,1244,1245,1244},{1246,Lu,1246,1247,1246},{1247,Ll,1246,1247,1246},{1248,Lu,1248,1249,1248},{1249,Ll,1248,1249,1248},{1250,Lu,1250,1251,1250},{1251,Ll,1250,1251,1250},{1252,Lu,1252,1253,1252},{1253,Ll,1252,1253,1252},{1254,Lu,1254,1255,1254},{1255,Ll,1254,1255,1254},{1256,Lu,1256,1257,1256},{1257,Ll,1256,1257,1256},{1258,Lu,1258,1259,1258},{1259,Ll,1258,1259,1258},{1260,Lu,1260,1261,1260},{1261,Ll,1260,1261,1260},{1262,Lu,1262,1263,1262},{1263,Ll,1262,1263,1262},{1264,Lu,1264,1265,1264},{1265,Ll,1264,1265,1264},{1266,Lu,1266,1267,1266},{1267,Ll,1266,1267,1266},{1268,Lu,1268,1269,1268},{1269,Ll,1268,1269,1268},{1270,Lu,1270,1271,1270},{1271,Ll,1270,1271,1270},{1272,Lu,1272,1273,1272},{1273,Ll,1272,1273,1272},{1274,Lu,1274,1275,1274},{1275,Ll,1274,1275,1274},{1276,Lu,1276,1277,1276},{1277,Ll,1276,1277,1276},{1278,Lu,1278,1279,1278},{1279,Ll,1278,1279,1278},{1280,Lu,1280,1281,1280},{1281,Ll,1280,1281,1280},{1282,Lu,1282,1283,1282},{1283,Ll,1282,1283,1282},{1284,Lu,1284,1285,1284},{1285,Ll,1284,1285,1284},{1286,Lu,1286,1287,1286},{1287,Ll,1286,1287,1286},{1288,Lu,1288,1289,1288},{1289,Ll,1288,1289,1288},{1290,Lu,1290,1291,1290},{1291,Ll,1290,1291,1290},{1292,Lu,1292,1293,1292},{1293,Ll,1292,1293,1292},{1294,Lu,1294,1295,1294},{1295,Ll,1294,1295,1294},{1296,Lu,1296,1297,1296},{1297,Ll,1296,1297,1296},{1298,Lu,1298,1299,1298},{1299,Ll,1298,1299,1298},{1329,Lu,1329,1377,1329},{1330,Lu,1330,1378,1330},{1331,Lu,1331,1379,1331},{1332,Lu,1332,1380,1332},{1333,Lu,1333,1381,1333},{1334,Lu,1334,1382,1334},{1335,Lu,1335,1383,1335},{1336,Lu,1336,1384,1336},{1337,Lu,1337,1385,1337},{1338,Lu,1338,1386,1338},{1339,Lu,1339,1387,1339},{1340,Lu,1340,1388,1340},{1341,Lu,1341,1389,1341},{1342,Lu,1342,1390,1342},{1343,Lu,1343,1391,1343},{1344,Lu,1344,1392,1344},{1345,Lu,1345,1393,1345},{1346,Lu,1346,1394,1346},{1347,Lu,1347,1395,1347},{1348,Lu,1348,1396,1348},{1349,Lu,1349,1397,1349},{1350,Lu,1350,1398,1350},{1351,Lu,1351,1399,1351},{1352,Lu,1352,1400,1352},{1353,Lu,1353,1401,1353},{1354,Lu,1354,1402,1354},{1355,Lu,1355,1403,1355},{1356,Lu,1356,1404,1356},{1357,Lu,1357,1405,1357},{1358,Lu,1358,1406,1358},{1359,Lu,1359,1407,1359},{1360,Lu,1360,1408,1360},{1361,Lu,1361,1409,1361},{1362,Lu,1362,1410,1362},{1363,Lu,1363,1411,1363},{1364,Lu,1364,1412,1364},{1365,Lu,1365,1413,1365},{1366,Lu,1366,1414,1366},{1369,Lm,1369,1369,1369},{1370,Po,1370,1370,1370},{1371,Po,1371,1371,1371},{1372,Po,1372,1372,1372},{1373,Po,1373,1373,1373},{1374,Po,1374,1374,1374},{1375,Po,1375,1375,1375},{1377,Ll,1329,1377,1329},{1378,Ll,1330,1378,1330},{1379,Ll,1331,1379,1331},{1380,Ll,1332,1380,1332},{1381,Ll,1333,1381,1333},{1382,Ll,1334,1382,1334},{1383,Ll,1335,1383,1335},{1384,Ll,1336,1384,1336},{1385,Ll,1337,1385,1337},{1386,Ll,1338,1386,1338},{1387,Ll,1339,1387,1339},{1388,Ll,1340,1388,1340},{1389,Ll,1341,1389,1341},{1390,Ll,1342,1390,1342},{1391,Ll,1343,1391,1343},{1392,Ll,1344,1392,1344},{1393,Ll,1345,1393,1345},{1394,Ll,1346,1394,1346},{1395,Ll,1347,1395,1347},{1396,Ll,1348,1396,1348},{1397,Ll,1349,1397,1349},{1398,Ll,1350,1398,1350},{1399,Ll,1351,1399,1351},{1400,Ll,1352,1400,1352},{1401,Ll,1353,1401,1353},{1402,Ll,1354,1402,1354},{1403,Ll,1355,1403,1355},{1404,Ll,1356,1404,1356},{1405,Ll,1357,1405,1357},{1406,Ll,1358,1406,1358},{1407,Ll,1359,1407,1359},{1408,Ll,1360,1408,1360},{1409,Ll,1361,1409,1361},{1410,Ll,1362,1410,1362},{1411,Ll,1363,1411,1363},{1412,Ll,1364,1412,1364},{1413,Ll,1365,1413,1365},{1414,Ll,1366,1414,1366},{1415,Ll | SM,1415,1415,1415},{1417,Po,1417,1417,1417},{1418,Pd,1418,1418,1418},{1425,Mn,1425,1425,1425},{1426,Mn,1426,1426,1426},{1427,Mn,1427,1427,1427},{1428,Mn,1428,1428,1428},{1429,Mn,1429,1429,1429},{1430,Mn,1430,1430,1430},{1431,Mn,1431,1431,1431},{1432,Mn,1432,1432,1432},{1433,Mn,1433,1433,1433},{1434,Mn,1434,1434,1434},{1435,Mn,1435,1435,1435},{1436,Mn,1436,1436,1436},{1437,Mn,1437,1437,1437},{1438,Mn,1438,1438,1438},{1439,Mn,1439,1439,1439},{1440,Mn,1440,1440,1440},{1441,Mn,1441,1441,1441},{1442,Mn,1442,1442,1442},{1443,Mn,1443,1443,1443},{1444,Mn,1444,1444,1444},{1445,Mn,1445,1445,1445},{1446,Mn,1446,1446,1446},{1447,Mn,1447,1447,1447},{1448,Mn,1448,1448,1448},{1449,Mn,1449,1449,1449},{1450,Mn,1450,1450,1450},{1451,Mn,1451,1451,1451},{1452,Mn,1452,1452,1452},{1453,Mn,1453,1453,1453},{1454,Mn,1454,1454,1454},{1455,Mn,1455,1455,1455},{1456,Mn,1456,1456,1456},{1457,Mn,1457,1457,1457},{1458,Mn,1458,1458,1458},{1459,Mn,1459,1459,1459},{1460,Mn,1460,1460,1460},{1461,Mn,1461,1461,1461},{1462,Mn,1462,1462,1462},{1463,Mn,1463,1463,1463},{1464,Mn,1464,1464,1464},{1465,Mn,1465,1465,1465},{1466,Mn,1466,1466,1466},{1467,Mn,1467,1467,1467},{1468,Mn,1468,1468,1468},{1469,Mn,1469,1469,1469},{1470,Po,1470,1470,1470},{1471,Mn,1471,1471,1471},{1472,Po,1472,1472,1472},{1473,Mn,1473,1473,1473},{1474,Mn,1474,1474,1474},{1475,Po,1475,1475,1475},{1476,Mn,1476,1476,1476},{1477,Mn,1477,1477,1477},{1478,Po,1478,1478,1478},{1479,Mn,1479,1479,1479},{1488,Lo,1488,1488,1488},{1489,Lo,1489,1489,1489},{1490,Lo,1490,1490,1490},{1491,Lo,1491,1491,1491},{1492,Lo,1492,1492,1492},{1493,Lo,1493,1493,1493},{1494,Lo,1494,1494,1494},{1495,Lo,1495,1495,1495},{1496,Lo,1496,1496,1496},{1497,Lo,1497,1497,1497},{1498,Lo,1498,1498,1498},{1499,Lo,1499,1499,1499},{1500,Lo,1500,1500,1500},{1501,Lo,1501,1501,1501},{1502,Lo,1502,1502,1502},{1503,Lo,1503,1503,1503},{1504,Lo,1504,1504,1504},{1505,Lo,1505,1505,1505},{1506,Lo,1506,1506,1506},{1507,Lo,1507,1507,1507},{1508,Lo,1508,1508,1508},{1509,Lo,1509,1509,1509},{1510,Lo,1510,1510,1510},{1511,Lo,1511,1511,1511},{1512,Lo,1512,1512,1512},{1513,Lo,1513,1513,1513},{1514,Lo,1514,1514,1514},{1520,Lo,1520,1520,1520},{1521,Lo,1521,1521,1521},{1522,Lo,1522,1522,1522},{1523,Po,1523,1523,1523},{1524,Po,1524,1524,1524},{1536,Cf,1536,1536,1536},{1537,Cf,1537,1537,1537},{1538,Cf,1538,1538,1538},{1539,Cf,1539,1539,1539},{1547,Sc,1547,1547,1547},{1548,Po,1548,1548,1548},{1549,Po,1549,1549,1549},{1550,So,1550,1550,1550},{1551,So,1551,1551,1551},{1552,Mn,1552,1552,1552},{1553,Mn,1553,1553,1553},{1554,Mn,1554,1554,1554},{1555,Mn,1555,1555,1555},{1556,Mn,1556,1556,1556},{1557,Mn,1557,1557,1557},{1563,Po,1563,1563,1563},{1566,Po,1566,1566,1566},{1567,Po,1567,1567,1567},{1569,Lo,1569,1569,1569},{1570,Lo,1570,1570,1570},{1571,Lo,1571,1571,1571},{1572,Lo,1572,1572,1572},{1573,Lo,1573,1573,1573},{1574,Lo,1574,1574,1574},{1575,Lo,1575,1575,1575},{1576,Lo,1576,1576,1576},{1577,Lo,1577,1577,1577},{1578,Lo,1578,1578,1578},{1579,Lo,1579,1579,1579},{1580,Lo,1580,1580,1580},{1581,Lo,1581,1581,1581},{1582,Lo,1582,1582,1582},{1583,Lo,1583,1583,1583},{1584,Lo,1584,1584,1584},{1585,Lo,1585,1585,1585},{1586,Lo,1586,1586,1586},{1587,Lo,1587,1587,1587},{1588,Lo,1588,1588,1588},{1589,Lo,1589,1589,1589},{1590,Lo,1590,1590,1590},{1591,Lo,1591,1591,1591},{1592,Lo,1592,1592,1592},{1593,Lo,1593,1593,1593},{1594,Lo,1594,1594,1594},{1600,Lm,1600,1600,1600},{1601,Lo,1601,1601,1601},{1602,Lo,1602,1602,1602},{1603,Lo,1603,1603,1603},{1604,Lo,1604,1604,1604},{1605,Lo,1605,1605,1605},{1606,Lo,1606,1606,1606},{1607,Lo,1607,1607,1607},{1608,Lo,1608,1608,1608},{1609,Lo,1609,1609,1609},{1610,Lo,1610,1610,1610},{1611,Mn,1611,1611,1611},{1612,Mn,1612,1612,1612},{1613,Mn,1613,1613,1613},{1614,Mn,1614,1614,1614},{1615,Mn,1615,1615,1615},{1616,Mn,1616,1616,1616},{1617,Mn,1617,1617,1617},{1618,Mn,1618,1618,1618},{1619,Mn,1619,1619,1619},{1620,Mn,1620,1620,1620},{1621,Mn,1621,1621,1621},{1622,Mn,1622,1622,1622},{1623,Mn,1623,1623,1623},{1624,Mn,1624,1624,1624},{1625,Mn,1625,1625,1625},{1626,Mn,1626,1626,1626},{1627,Mn,1627,1627,1627},{1628,Mn,1628,1628,1628},{1629,Mn,1629,1629,1629},{1630,Mn,1630,1630,1630},{1632,Nd,1632,1632,1632},{1633,Nd,1633,1633,1633},{1634,Nd,1634,1634,1634},{1635,Nd,1635,1635,1635},{1636,Nd,1636,1636,1636},{1637,Nd,1637,1637,1637},{1638,Nd,1638,1638,1638},{1639,Nd,1639,1639,1639},{1640,Nd,1640,1640,1640},{1641,Nd,1641,1641,1641},{1642,Po,1642,1642,1642},{1643,Po,1643,1643,1643},{1644,Po,1644,1644,1644},{1645,Po,1645,1645,1645},{1646,Lo,1646,1646,1646},{1647,Lo,1647,1647,1647},{1648,Mn,1648,1648,1648},{1649,Lo,1649,1649,1649},{1650,Lo,1650,1650,1650},{1651,Lo,1651,1651,1651},{1652,Lo,1652,1652,1652},{1653,Lo,1653,1653,1653},{1654,Lo,1654,1654,1654},{1655,Lo,1655,1655,1655},{1656,Lo,1656,1656,1656},{1657,Lo,1657,1657,1657},{1658,Lo,1658,1658,1658},{1659,Lo,1659,1659,1659},{1660,Lo,1660,1660,1660},{1661,Lo,1661,1661,1661},{1662,Lo,1662,1662,1662},{1663,Lo,1663,1663,1663},{1664,Lo,1664,1664,1664},{1665,Lo,1665,1665,1665},{1666,Lo,1666,1666,1666},{1667,Lo,1667,1667,1667},{1668,Lo,1668,1668,1668},{1669,Lo,1669,1669,1669},{1670,Lo,1670,1670,1670},{1671,Lo,1671,1671,1671},{1672,Lo,1672,1672,1672},{1673,Lo,1673,1673,1673},{1674,Lo,1674,1674,1674},{1675,Lo,1675,1675,1675},{1676,Lo,1676,1676,1676},{1677,Lo,1677,1677,1677},{1678,Lo,1678,1678,1678},{1679,Lo,1679,1679,1679},{1680,Lo,1680,1680,1680},{1681,Lo,1681,1681,1681},{1682,Lo,1682,1682,1682},{1683,Lo,1683,1683,1683},{1684,Lo,1684,1684,1684},{1685,Lo,1685,1685,1685},{1686,Lo,1686,1686,1686},{1687,Lo,1687,1687,1687},{1688,Lo,1688,1688,1688},{1689,Lo,1689,1689,1689},{1690,Lo,1690,1690,1690},{1691,Lo,1691,1691,1691},{1692,Lo,1692,1692,1692},{1693,Lo,1693,1693,1693},{1694,Lo,1694,1694,1694},{1695,Lo,1695,1695,1695},{1696,Lo,1696,1696,1696},{1697,Lo,1697,1697,1697},{1698,Lo,1698,1698,1698},{1699,Lo,1699,1699,1699},{1700,Lo,1700,1700,1700},{1701,Lo,1701,1701,1701},{1702,Lo,1702,1702,1702},{1703,Lo,1703,1703,1703},{1704,Lo,1704,1704,1704},{1705,Lo,1705,1705,1705},{1706,Lo,1706,1706,1706},{1707,Lo,1707,1707,1707},{1708,Lo,1708,1708,1708},{1709,Lo,1709,1709,1709},{1710,Lo,1710,1710,1710},{1711,Lo,1711,1711,1711},{1712,Lo,1712,1712,1712},{1713,Lo,1713,1713,1713},{1714,Lo,1714,1714,1714},{1715,Lo,1715,1715,1715},{1716,Lo,1716,1716,1716},{1717,Lo,1717,1717,1717},{1718,Lo,1718,1718,1718},{1719,Lo,1719,1719,1719},{1720,Lo,1720,1720,1720},{1721,Lo,1721,1721,1721},{1722,Lo,1722,1722,1722},{1723,Lo,1723,1723,1723},{1724,Lo,1724,1724,1724},{1725,Lo,1725,1725,1725},{1726,Lo,1726,1726,1726},{1727,Lo,1727,1727,1727},{1728,Lo,1728,1728,1728},{1729,Lo,1729,1729,1729},{1730,Lo,1730,1730,1730},{1731,Lo,1731,1731,1731},{1732,Lo,1732,1732,1732},{1733,Lo,1733,1733,1733},{1734,Lo,1734,1734,1734},{1735,Lo,1735,1735,1735},{1736,Lo,1736,1736,1736},{1737,Lo,1737,1737,1737},{1738,Lo,1738,1738,1738},{1739,Lo,1739,1739,1739},{1740,Lo,1740,1740,1740},{1741,Lo,1741,1741,1741},{1742,Lo,1742,1742,1742},{1743,Lo,1743,1743,1743},{1744,Lo,1744,1744,1744},{1745,Lo,1745,1745,1745},{1746,Lo,1746,1746,1746},{1747,Lo,1747,1747,1747},{1748,Po,1748,1748,1748},{1749,Lo,1749,1749,1749},{1750,Mn,1750,1750,1750},{1751,Mn,1751,1751,1751},{1752,Mn,1752,1752,1752},{1753,Mn,1753,1753,1753},{1754,Mn,1754,1754,1754},{1755,Mn,1755,1755,1755},{1756,Mn,1756,1756,1756},{1757,Cf,1757,1757,1757},{1758,Me,1758,1758,1758},{1759,Mn,1759,1759,1759},{1760,Mn,1760,1760,1760},{1761,Mn,1761,1761,1761},{1762,Mn,1762,1762,1762},{1763,Mn,1763,1763,1763},{1764,Mn,1764,1764,1764},{1765,Lm,1765,1765,1765},{1766,Lm,1766,1766,1766},{1767,Mn,1767,1767,1767},{1768,Mn,1768,1768,1768},{1769,So,1769,1769,1769},{1770,Mn,1770,1770,1770},{1771,Mn,1771,1771,1771},{1772,Mn,1772,1772,1772},{1773,Mn,1773,1773,1773},{1774,Lo,1774,1774,1774},{1775,Lo,1775,1775,1775},{1776,Nd,1776,1776,1776},{1777,Nd,1777,1777,1777},{1778,Nd,1778,1778,1778},{1779,Nd,1779,1779,1779},{1780,Nd,1780,1780,1780},{1781,Nd,1781,1781,1781},{1782,Nd,1782,1782,1782},{1783,Nd,1783,1783,1783},{1784,Nd,1784,1784,1784},{1785,Nd,1785,1785,1785},{1786,Lo,1786,1786,1786},{1787,Lo,1787,1787,1787},{1788,Lo,1788,1788,1788},{1789,So,1789,1789,1789},{1790,So,1790,1790,1790},{1791,Lo,1791,1791,1791},{1792,Po,1792,1792,1792},{1793,Po,1793,1793,1793},{1794,Po,1794,1794,1794},{1795,Po,1795,1795,1795},{1796,Po,1796,1796,1796},{1797,Po,1797,1797,1797},{1798,Po,1798,1798,1798},{1799,Po,1799,1799,1799},{1800,Po,1800,1800,1800},{1801,Po,1801,1801,1801},{1802,Po,1802,1802,1802},{1803,Po,1803,1803,1803},{1804,Po,1804,1804,1804},{1805,Po,1805,1805,1805},{1807,Cf,1807,1807,1807},{1808,Lo,1808,1808,1808},{1809,Mn,1809,1809,1809},{1810,Lo,1810,1810,1810},{1811,Lo,1811,1811,1811},{1812,Lo,1812,1812,1812},{1813,Lo,1813,1813,1813},{1814,Lo,1814,1814,1814},{1815,Lo,1815,1815,1815},{1816,Lo,1816,1816,1816},{1817,Lo,1817,1817,1817},{1818,Lo,1818,1818,1818},{1819,Lo,1819,1819,1819},{1820,Lo,1820,1820,1820},{1821,Lo,1821,1821,1821},{1822,Lo,1822,1822,1822},{1823,Lo,1823,1823,1823},{1824,Lo,1824,1824,1824},{1825,Lo,1825,1825,1825},{1826,Lo,1826,1826,1826},{1827,Lo,1827,1827,1827},{1828,Lo,1828,1828,1828},{1829,Lo,1829,1829,1829},{1830,Lo,1830,1830,1830},{1831,Lo,1831,1831,1831},{1832,Lo,1832,1832,1832},{1833,Lo,1833,1833,1833},{1834,Lo,1834,1834,1834},{1835,Lo,1835,1835,1835},{1836,Lo,1836,1836,1836},{1837,Lo,1837,1837,1837},{1838,Lo,1838,1838,1838},{1839,Lo,1839,1839,1839},{1840,Mn,1840,1840,1840},{1841,Mn,1841,1841,1841},{1842,Mn,1842,1842,1842},{1843,Mn,1843,1843,1843},{1844,Mn,1844,1844,1844},{1845,Mn,1845,1845,1845},{1846,Mn,1846,1846,1846},{1847,Mn,1847,1847,1847},{1848,Mn,1848,1848,1848},{1849,Mn,1849,1849,1849},{1850,Mn,1850,1850,1850},{1851,Mn,1851,1851,1851},{1852,Mn,1852,1852,1852},{1853,Mn,1853,1853,1853},{1854,Mn,1854,1854,1854},{1855,Mn,1855,1855,1855},{1856,Mn,1856,1856,1856},{1857,Mn,1857,1857,1857},{1858,Mn,1858,1858,1858},{1859,Mn,1859,1859,1859},{1860,Mn,1860,1860,1860},{1861,Mn,1861,1861,1861},{1862,Mn,1862,1862,1862},{1863,Mn,1863,1863,1863},{1864,Mn,1864,1864,1864},{1865,Mn,1865,1865,1865},{1866,Mn,1866,1866,1866},{1869,Lo,1869,1869,1869},{1870,Lo,1870,1870,1870},{1871,Lo,1871,1871,1871},{1872,Lo,1872,1872,1872},{1873,Lo,1873,1873,1873},{1874,Lo,1874,1874,1874},{1875,Lo,1875,1875,1875},{1876,Lo,1876,1876,1876},{1877,Lo,1877,1877,1877},{1878,Lo,1878,1878,1878},{1879,Lo,1879,1879,1879},{1880,Lo,1880,1880,1880},{1881,Lo,1881,1881,1881},{1882,Lo,1882,1882,1882},{1883,Lo,1883,1883,1883},{1884,Lo,1884,1884,1884},{1885,Lo,1885,1885,1885},{1886,Lo,1886,1886,1886},{1887,Lo,1887,1887,1887},{1888,Lo,1888,1888,1888},{1889,Lo,1889,1889,1889},{1890,Lo,1890,1890,1890},{1891,Lo,1891,1891,1891},{1892,Lo,1892,1892,1892},{1893,Lo,1893,1893,1893},{1894,Lo,1894,1894,1894},{1895,Lo,1895,1895,1895},{1896,Lo,1896,1896,1896},{1897,Lo,1897,1897,1897},{1898,Lo,1898,1898,1898},{1899,Lo,1899,1899,1899},{1900,Lo,1900,1900,1900},{1901,Lo,1901,1901,1901},{1920,Lo,1920,1920,1920},{1921,Lo,1921,1921,1921},{1922,Lo,1922,1922,1922},{1923,Lo,1923,1923,1923},{1924,Lo,1924,1924,1924},{1925,Lo,1925,1925,1925},{1926,Lo,1926,1926,1926},{1927,Lo,1927,1927,1927},{1928,Lo,1928,1928,1928},{1929,Lo,1929,1929,1929},{1930,Lo,1930,1930,1930},{1931,Lo,1931,1931,1931},{1932,Lo,1932,1932,1932},{1933,Lo,1933,1933,1933},{1934,Lo,1934,1934,1934},{1935,Lo,1935,1935,1935},{1936,Lo,1936,1936,1936},{1937,Lo,1937,1937,1937},{1938,Lo,1938,1938,1938},{1939,Lo,1939,1939,1939},{1940,Lo,1940,1940,1940},{1941,Lo,1941,1941,1941},{1942,Lo,1942,1942,1942},{1943,Lo,1943,1943,1943},{1944,Lo,1944,1944,1944},{1945,Lo,1945,1945,1945},{1946,Lo,1946,1946,1946},{1947,Lo,1947,1947,1947},{1948,Lo,1948,1948,1948},{1949,Lo,1949,1949,1949},{1950,Lo,1950,1950,1950},{1951,Lo,1951,1951,1951},{1952,Lo,1952,1952,1952},{1953,Lo,1953,1953,1953},{1954,Lo,1954,1954,1954},{1955,Lo,1955,1955,1955},{1956,Lo,1956,1956,1956},{1957,Lo,1957,1957,1957},{1958,Mn,1958,1958,1958},{1959,Mn,1959,1959,1959},{1960,Mn,1960,1960,1960},{1961,Mn,1961,1961,1961},{1962,Mn,1962,1962,1962},{1963,Mn,1963,1963,1963},{1964,Mn,1964,1964,1964},{1965,Mn,1965,1965,1965},{1966,Mn,1966,1966,1966},{1967,Mn,1967,1967,1967},{1968,Mn,1968,1968,1968},{1969,Lo,1969,1969,1969},{1984,Nd,1984,1984,1984},{1985,Nd,1985,1985,1985},{1986,Nd,1986,1986,1986},{1987,Nd,1987,1987,1987},{1988,Nd,1988,1988,1988},{1989,Nd,1989,1989,1989},{1990,Nd,1990,1990,1990},{1991,Nd,1991,1991,1991},{1992,Nd,1992,1992,1992},{1993,Nd,1993,1993,1993},{1994,Lo,1994,1994,1994},{1995,Lo,1995,1995,1995},{1996,Lo,1996,1996,1996},{1997,Lo,1997,1997,1997},{1998,Lo,1998,1998,1998},{1999,Lo,1999,1999,1999},{2000,Lo,2000,2000,2000},{2001,Lo,2001,2001,2001},{2002,Lo,2002,2002,2002},{2003,Lo,2003,2003,2003},{2004,Lo,2004,2004,2004},{2005,Lo,2005,2005,2005},{2006,Lo,2006,2006,2006},{2007,Lo,2007,2007,2007},{2008,Lo,2008,2008,2008},{2009,Lo,2009,2009,2009},{2010,Lo,2010,2010,2010},{2011,Lo,2011,2011,2011},{2012,Lo,2012,2012,2012},{2013,Lo,2013,2013,2013},{2014,Lo,2014,2014,2014},{2015,Lo,2015,2015,2015},{2016,Lo,2016,2016,2016},{2017,Lo,2017,2017,2017},{2018,Lo,2018,2018,2018},{2019,Lo,2019,2019,2019},{2020,Lo,2020,2020,2020},{2021,Lo,2021,2021,2021},{2022,Lo,2022,2022,2022},{2023,Lo,2023,2023,2023},{2024,Lo,2024,2024,2024},{2025,Lo,2025,2025,2025},{2026,Lo,2026,2026,2026},{2027,Mn,2027,2027,2027},{2028,Mn,2028,2028,2028},{2029,Mn,2029,2029,2029},{2030,Mn,2030,2030,2030},{2031,Mn,2031,2031,2031},{2032,Mn,2032,2032,2032},{2033,Mn,2033,2033,2033},{2034,Mn,2034,2034,2034},{2035,Mn,2035,2035,2035},{2036,Lm,2036,2036,2036},{2037,Lm,2037,2037,2037},{2038,So,2038,2038,2038},{2039,Po,2039,2039,2039},{2040,Po,2040,2040,2040},{2041,Po,2041,2041,2041},{2042,Lm,2042,2042,2042},{2305,Mn,2305,2305,2305},{2306,Mn,2306,2306,2306},{2307,Mc,2307,2307,2307},{2308,Lo,2308,2308,2308},{2309,Lo,2309,2309,2309},{2310,Lo,2310,2310,2310},{2311,Lo,2311,2311,2311},{2312,Lo,2312,2312,2312},{2313,Lo,2313,2313,2313},{2314,Lo,2314,2314,2314},{2315,Lo,2315,2315,2315},{2316,Lo,2316,2316,2316},{2317,Lo,2317,2317,2317},{2318,Lo,2318,2318,2318},{2319,Lo,2319,2319,2319},{2320,Lo,2320,2320,2320},{2321,Lo,2321,2321,2321},{2322,Lo,2322,2322,2322},{2323,Lo,2323,2323,2323},{2324,Lo,2324,2324,2324},{2325,Lo,2325,2325,2325},{2326,Lo,2326,2326,2326},{2327,Lo,2327,2327,2327},{2328,Lo,2328,2328,2328},{2329,Lo,2329,2329,2329},{2330,Lo,2330,2330,2330},{2331,Lo,2331,2331,2331},{2332,Lo,2332,2332,2332},{2333,Lo,2333,2333,2333},{2334,Lo,2334,2334,2334},{2335,Lo,2335,2335,2335},{2336,Lo,2336,2336,2336},{2337,Lo,2337,2337,2337},{2338,Lo,2338,2338,2338},{2339,Lo,2339,2339,2339},{2340,Lo,2340,2340,2340},{2341,Lo,2341,2341,2341},{2342,Lo,2342,2342,2342},{2343,Lo,2343,2343,2343},{2344,Lo,2344,2344,2344},{2345,Lo,2345,2345,2345},{2346,Lo,2346,2346,2346},{2347,Lo,2347,2347,2347},{2348,Lo,2348,2348,2348},{2349,Lo,2349,2349,2349},{2350,Lo,2350,2350,2350},{2351,Lo,2351,2351,2351},{2352,Lo,2352,2352,2352},{2353,Lo,2353,2353,2353},{2354,Lo,2354,2354,2354},{2355,Lo,2355,2355,2355},{2356,Lo,2356,2356,2356},{2357,Lo,2357,2357,2357},{2358,Lo,2358,2358,2358},{2359,Lo,2359,2359,2359},{2360,Lo,2360,2360,2360},{2361,Lo,2361,2361,2361},{2364,Mn,2364,2364,2364},{2365,Lo,2365,2365,2365},{2366,Mc,2366,2366,2366},{2367,Mc,2367,2367,2367},{2368,Mc,2368,2368,2368},{2369,Mn,2369,2369,2369},{2370,Mn,2370,2370,2370},{2371,Mn,2371,2371,2371},{2372,Mn,2372,2372,2372},{2373,Mn,2373,2373,2373},{2374,Mn,2374,2374,2374},{2375,Mn,2375,2375,2375},{2376,Mn,2376,2376,2376},{2377,Mc,2377,2377,2377},{2378,Mc,2378,2378,2378},{2379,Mc,2379,2379,2379},{2380,Mc,2380,2380,2380},{2381,Mn,2381,2381,2381},{2384,Lo,2384,2384,2384},{2385,Mn,2385,2385,2385},{2386,Mn,2386,2386,2386},{2387,Mn,2387,2387,2387},{2388,Mn,2388,2388,2388},{2392,Lo,2392,2392,2392},{2393,Lo,2393,2393,2393},{2394,Lo,2394,2394,2394},{2395,Lo,2395,2395,2395},{2396,Lo,2396,2396,2396},{2397,Lo,2397,2397,2397},{2398,Lo,2398,2398,2398},{2399,Lo,2399,2399,2399},{2400,Lo,2400,2400,2400},{2401,Lo,2401,2401,2401},{2402,Mn,2402,2402,2402},{2403,Mn,2403,2403,2403},{2404,Po,2404,2404,2404},{2405,Po,2405,2405,2405},{2406,Nd,2406,2406,2406},{2407,Nd,2407,2407,2407},{2408,Nd,2408,2408,2408},{2409,Nd,2409,2409,2409},{2410,Nd,2410,2410,2410},{2411,Nd,2411,2411,2411},{2412,Nd,2412,2412,2412},{2413,Nd,2413,2413,2413},{2414,Nd,2414,2414,2414},{2415,Nd,2415,2415,2415},{2416,Po,2416,2416,2416},{2427,Lo,2427,2427,2427},{2428,Lo,2428,2428,2428},{2429,Lo,2429,2429,2429},{2430,Lo,2430,2430,2430},{2431,Lo,2431,2431,2431},{2433,Mn,2433,2433,2433},{2434,Mc,2434,2434,2434},{2435,Mc,2435,2435,2435},{2437,Lo,2437,2437,2437},{2438,Lo,2438,2438,2438},{2439,Lo,2439,2439,2439},{2440,Lo,2440,2440,2440},{2441,Lo,2441,2441,2441},{2442,Lo,2442,2442,2442},{2443,Lo,2443,2443,2443},{2444,Lo,2444,2444,2444},{2447,Lo,2447,2447,2447},{2448,Lo,2448,2448,2448},{2451,Lo,2451,2451,2451},{2452,Lo,2452,2452,2452},{2453,Lo,2453,2453,2453},{2454,Lo,2454,2454,2454},{2455,Lo,2455,2455,2455},{2456,Lo,2456,2456,2456},{2457,Lo,2457,2457,2457},{2458,Lo,2458,2458,2458},{2459,Lo,2459,2459,2459},{2460,Lo,2460,2460,2460},{2461,Lo,2461,2461,2461},{2462,Lo,2462,2462,2462},{2463,Lo,2463,2463,2463},{2464,Lo,2464,2464,2464},{2465,Lo,2465,2465,2465},{2466,Lo,2466,2466,2466},{2467,Lo,2467,2467,2467},{2468,Lo,2468,2468,2468},{2469,Lo,2469,2469,2469},{2470,Lo,2470,2470,2470},{2471,Lo,2471,2471,2471},{2472,Lo,2472,2472,2472},{2474,Lo,2474,2474,2474},{2475,Lo,2475,2475,2475},{2476,Lo,2476,2476,2476},{2477,Lo,2477,2477,2477},{2478,Lo,2478,2478,2478},{2479,Lo,2479,2479,2479},{2480,Lo,2480,2480,2480},{2482,Lo,2482,2482,2482},{2486,Lo,2486,2486,2486},{2487,Lo,2487,2487,2487},{2488,Lo,2488,2488,2488},{2489,Lo,2489,2489,2489},{2492,Mn,2492,2492,2492},{2493,Lo,2493,2493,2493},{2494,Mc,2494,2494,2494},{2495,Mc,2495,2495,2495},{2496,Mc,2496,2496,2496},{2497,Mn,2497,2497,2497},{2498,Mn,2498,2498,2498},{2499,Mn,2499,2499,2499},{2500,Mn,2500,2500,2500},{2503,Mc,2503,2503,2503},{2504,Mc,2504,2504,2504},{2507,Mc,2507,2507,2507},{2508,Mc,2508,2508,2508},{2509,Mn,2509,2509,2509},{2510,Lo,2510,2510,2510},{2519,Mc,2519,2519,2519},{2524,Lo,2524,2524,2524},{2525,Lo,2525,2525,2525},{2527,Lo,2527,2527,2527},{2528,Lo,2528,2528,2528},{2529,Lo,2529,2529,2529},{2530,Mn,2530,2530,2530},{2531,Mn,2531,2531,2531},{2534,Nd,2534,2534,2534},{2535,Nd,2535,2535,2535},{2536,Nd,2536,2536,2536},{2537,Nd,2537,2537,2537},{2538,Nd,2538,2538,2538},{2539,Nd,2539,2539,2539},{2540,Nd,2540,2540,2540},{2541,Nd,2541,2541,2541},{2542,Nd,2542,2542,2542},{2543,Nd,2543,2543,2543},{2544,Lo,2544,2544,2544},{2545,Lo,2545,2545,2545},{2546,Sc,2546,2546,2546},{2547,Sc,2547,2547,2547},{2548,No,2548,2548,2548},{2549,No,2549,2549,2549},{2550,No,2550,2550,2550},{2551,No,2551,2551,2551},{2552,No,2552,2552,2552},{2553,No,2553,2553,2553},{2554,So,2554,2554,2554},{2561,Mn,2561,2561,2561},{2562,Mn,2562,2562,2562},{2563,Mc,2563,2563,2563},{2565,Lo,2565,2565,2565},{2566,Lo,2566,2566,2566},{2567,Lo,2567,2567,2567},{2568,Lo,2568,2568,2568},{2569,Lo,2569,2569,2569},{2570,Lo,2570,2570,2570},{2575,Lo,2575,2575,2575},{2576,Lo,2576,2576,2576},{2579,Lo,2579,2579,2579},{2580,Lo,2580,2580,2580},{2581,Lo,2581,2581,2581},{2582,Lo,2582,2582,2582},{2583,Lo,2583,2583,2583},{2584,Lo,2584,2584,2584},{2585,Lo,2585,2585,2585},{2586,Lo,2586,2586,2586},{2587,Lo,2587,2587,2587},{2588,Lo,2588,2588,2588},{2589,Lo,2589,2589,2589},{2590,Lo,2590,2590,2590},{2591,Lo,2591,2591,2591},{2592,Lo,2592,2592,2592},{2593,Lo,2593,2593,2593},{2594,Lo,2594,2594,2594},{2595,Lo,2595,2595,2595},{2596,Lo,2596,2596,2596},{2597,Lo,2597,2597,2597},{2598,Lo,2598,2598,2598},{2599,Lo,2599,2599,2599},{2600,Lo,2600,2600,2600},{2602,Lo,2602,2602,2602},{2603,Lo,2603,2603,2603},{2604,Lo,2604,2604,2604},{2605,Lo,2605,2605,2605},{2606,Lo,2606,2606,2606},{2607,Lo,2607,2607,2607},{2608,Lo,2608,2608,2608},{2610,Lo,2610,2610,2610},{2611,Lo,2611,2611,2611},{2613,Lo,2613,2613,2613},{2614,Lo,2614,2614,2614},{2616,Lo,2616,2616,2616},{2617,Lo,2617,2617,2617},{2620,Mn,2620,2620,2620},{2622,Mc,2622,2622,2622},{2623,Mc,2623,2623,2623},{2624,Mc,2624,2624,2624},{2625,Mn,2625,2625,2625},{2626,Mn,2626,2626,2626},{2631,Mn,2631,2631,2631},{2632,Mn,2632,2632,2632},{2635,Mn,2635,2635,2635},{2636,Mn,2636,2636,2636},{2637,Mn,2637,2637,2637},{2649,Lo,2649,2649,2649},{2650,Lo,2650,2650,2650},{2651,Lo,2651,2651,2651},{2652,Lo,2652,2652,2652},{2654,Lo,2654,2654,2654},{2662,Nd,2662,2662,2662},{2663,Nd,2663,2663,2663},{2664,Nd,2664,2664,2664},{2665,Nd,2665,2665,2665},{2666,Nd,2666,2666,2666},{2667,Nd,2667,2667,2667},{2668,Nd,2668,2668,2668},{2669,Nd,2669,2669,2669},{2670,Nd,2670,2670,2670},{2671,Nd,2671,2671,2671},{2672,Mn,2672,2672,2672},{2673,Mn,2673,2673,2673},{2674,Lo,2674,2674,2674},{2675,Lo,2675,2675,2675},{2676,Lo,2676,2676,2676},{2689,Mn,2689,2689,2689},{2690,Mn,2690,2690,2690},{2691,Mc,2691,2691,2691},{2693,Lo,2693,2693,2693},{2694,Lo,2694,2694,2694},{2695,Lo,2695,2695,2695},{2696,Lo,2696,2696,2696},{2697,Lo,2697,2697,2697},{2698,Lo,2698,2698,2698},{2699,Lo,2699,2699,2699},{2700,Lo,2700,2700,2700},{2701,Lo,2701,2701,2701},{2703,Lo,2703,2703,2703},{2704,Lo,2704,2704,2704},{2705,Lo,2705,2705,2705},{2707,Lo,2707,2707,2707},{2708,Lo,2708,2708,2708},{2709,Lo,2709,2709,2709},{2710,Lo,2710,2710,2710},{2711,Lo,2711,2711,2711},{2712,Lo,2712,2712,2712},{2713,Lo,2713,2713,2713},{2714,Lo,2714,2714,2714},{2715,Lo,2715,2715,2715},{2716,Lo,2716,2716,2716},{2717,Lo,2717,2717,2717},{2718,Lo,2718,2718,2718},{2719,Lo,2719,2719,2719},{2720,Lo,2720,2720,2720},{2721,Lo,2721,2721,2721},{2722,Lo,2722,2722,2722},{2723,Lo,2723,2723,2723},{2724,Lo,2724,2724,2724},{2725,Lo,2725,2725,2725},{2726,Lo,2726,2726,2726},{2727,Lo,2727,2727,2727},{2728,Lo,2728,2728,2728},{2730,Lo,2730,2730,2730},{2731,Lo,2731,2731,2731},{2732,Lo,2732,2732,2732},{2733,Lo,2733,2733,2733},{2734,Lo,2734,2734,2734},{2735,Lo,2735,2735,2735},{2736,Lo,2736,2736,2736},{2738,Lo,2738,2738,2738},{2739,Lo,2739,2739,2739},{2741,Lo,2741,2741,2741},{2742,Lo,2742,2742,2742},{2743,Lo,2743,2743,2743},{2744,Lo,2744,2744,2744},{2745,Lo,2745,2745,2745},{2748,Mn,2748,2748,2748},{2749,Lo,2749,2749,2749},{2750,Mc,2750,2750,2750},{2751,Mc,2751,2751,2751},{2752,Mc,2752,2752,2752},{2753,Mn,2753,2753,2753},{2754,Mn,2754,2754,2754},{2755,Mn,2755,2755,2755},{2756,Mn,2756,2756,2756},{2757,Mn,2757,2757,2757},{2759,Mn,2759,2759,2759},{2760,Mn,2760,2760,2760},{2761,Mc,2761,2761,2761},{2763,Mc,2763,2763,2763},{2764,Mc,2764,2764,2764},{2765,Mn,2765,2765,2765},{2768,Lo,2768,2768,2768},{2784,Lo,2784,2784,2784},{2785,Lo,2785,2785,2785},{2786,Mn,2786,2786,2786},{2787,Mn,2787,2787,2787},{2790,Nd,2790,2790,2790},{2791,Nd,2791,2791,2791},{2792,Nd,2792,2792,2792},{2793,Nd,2793,2793,2793},{2794,Nd,2794,2794,2794},{2795,Nd,2795,2795,2795},{2796,Nd,2796,2796,2796},{2797,Nd,2797,2797,2797},{2798,Nd,2798,2798,2798},{2799,Nd,2799,2799,2799},{2801,Sc,2801,2801,2801},{2817,Mn,2817,2817,2817},{2818,Mc,2818,2818,2818},{2819,Mc,2819,2819,2819},{2821,Lo,2821,2821,2821},{2822,Lo,2822,2822,2822},{2823,Lo,2823,2823,2823},{2824,Lo,2824,2824,2824},{2825,Lo,2825,2825,2825},{2826,Lo,2826,2826,2826},{2827,Lo,2827,2827,2827},{2828,Lo,2828,2828,2828},{2831,Lo,2831,2831,2831},{2832,Lo,2832,2832,2832},{2835,Lo,2835,2835,2835},{2836,Lo,2836,2836,2836},{2837,Lo,2837,2837,2837},{2838,Lo,2838,2838,2838},{2839,Lo,2839,2839,2839},{2840,Lo,2840,2840,2840},{2841,Lo,2841,2841,2841},{2842,Lo,2842,2842,2842},{2843,Lo,2843,2843,2843},{2844,Lo,2844,2844,2844},{2845,Lo,2845,2845,2845},{2846,Lo,2846,2846,2846},{2847,Lo,2847,2847,2847},{2848,Lo,2848,2848,2848},{2849,Lo,2849,2849,2849},{2850,Lo,2850,2850,2850},{2851,Lo,2851,2851,2851},{2852,Lo,2852,2852,2852},{2853,Lo,2853,2853,2853},{2854,Lo,2854,2854,2854},{2855,Lo,2855,2855,2855},{2856,Lo,2856,2856,2856},{2858,Lo,2858,2858,2858},{2859,Lo,2859,2859,2859},{2860,Lo,2860,2860,2860},{2861,Lo,2861,2861,2861},{2862,Lo,2862,2862,2862},{2863,Lo,2863,2863,2863},{2864,Lo,2864,2864,2864},{2866,Lo,2866,2866,2866},{2867,Lo,2867,2867,2867},{2869,Lo,2869,2869,2869},{2870,Lo,2870,2870,2870},{2871,Lo,2871,2871,2871},{2872,Lo,2872,2872,2872},{2873,Lo,2873,2873,2873},{2876,Mn,2876,2876,2876},{2877,Lo,2877,2877,2877},{2878,Mc,2878,2878,2878},{2879,Mn,2879,2879,2879},{2880,Mc,2880,2880,2880},{2881,Mn,2881,2881,2881},{2882,Mn,2882,2882,2882},{2883,Mn,2883,2883,2883},{2887,Mc,2887,2887,2887},{2888,Mc,2888,2888,2888},{2891,Mc,2891,2891,2891},{2892,Mc,2892,2892,2892},{2893,Mn,2893,2893,2893},{2902,Mn,2902,2902,2902},{2903,Mc,2903,2903,2903},{2908,Lo,2908,2908,2908},{2909,Lo,2909,2909,2909},{2911,Lo,2911,2911,2911},{2912,Lo,2912,2912,2912},{2913,Lo,2913,2913,2913},{2918,Nd,2918,2918,2918},{2919,Nd,2919,2919,2919},{2920,Nd,2920,2920,2920},{2921,Nd,2921,2921,2921},{2922,Nd,2922,2922,2922},{2923,Nd,2923,2923,2923},{2924,Nd,2924,2924,2924},{2925,Nd,2925,2925,2925},{2926,Nd,2926,2926,2926},{2927,Nd,2927,2927,2927},{2928,So,2928,2928,2928},{2929,Lo,2929,2929,2929},{2946,Mn,2946,2946,2946},{2947,Lo,2947,2947,2947},{2949,Lo,2949,2949,2949},{2950,Lo,2950,2950,2950},{2951,Lo,2951,2951,2951},{2952,Lo,2952,2952,2952},{2953,Lo,2953,2953,2953},{2954,Lo,2954,2954,2954},{2958,Lo,2958,2958,2958},{2959,Lo,2959,2959,2959},{2960,Lo,2960,2960,2960},{2962,Lo,2962,2962,2962},{2963,Lo,2963,2963,2963},{2964,Lo,2964,2964,2964},{2965,Lo,2965,2965,2965},{2969,Lo,2969,2969,2969},{2970,Lo,2970,2970,2970},{2972,Lo,2972,2972,2972},{2974,Lo,2974,2974,2974},{2975,Lo,2975,2975,2975},{2979,Lo,2979,2979,2979},{2980,Lo,2980,2980,2980},{2984,Lo,2984,2984,2984},{2985,Lo,2985,2985,2985},{2986,Lo,2986,2986,2986},{2990,Lo,2990,2990,2990},{2991,Lo,2991,2991,2991},{2992,Lo,2992,2992,2992},{2993,Lo,2993,2993,2993},{2994,Lo,2994,2994,2994},{2995,Lo,2995,2995,2995},{2996,Lo,2996,2996,2996},{2997,Lo,2997,2997,2997},{2998,Lo,2998,2998,2998},{2999,Lo,2999,2999,2999},{3000,Lo,3000,3000,3000},{3001,Lo,3001,3001,3001},{3006,Mc,3006,3006,3006},{3007,Mc,3007,3007,3007},{3008,Mn,3008,3008,3008},{3009,Mc,3009,3009,3009},{3010,Mc,3010,3010,3010},{3014,Mc,3014,3014,3014},{3015,Mc,3015,3015,3015},{3016,Mc,3016,3016,3016},{3018,Mc,3018,3018,3018},{3019,Mc,3019,3019,3019},{3020,Mc,3020,3020,3020},{3021,Mn,3021,3021,3021},{3031,Mc,3031,3031,3031},{3046,Nd,3046,3046,3046},{3047,Nd,3047,3047,3047},{3048,Nd,3048,3048,3048},{3049,Nd,3049,3049,3049},{3050,Nd,3050,3050,3050},{3051,Nd,3051,3051,3051},{3052,Nd,3052,3052,3052},{3053,Nd,3053,3053,3053},{3054,Nd,3054,3054,3054},{3055,Nd,3055,3055,3055},{3056,No,3056,3056,3056},{3057,No,3057,3057,3057},{3058,No,3058,3058,3058},{3059,So,3059,3059,3059},{3060,So,3060,3060,3060},{3061,So,3061,3061,3061},{3062,So,3062,3062,3062},{3063,So,3063,3063,3063},{3064,So,3064,3064,3064},{3065,Sc,3065,3065,3065},{3066,So,3066,3066,3066},{3073,Mc,3073,3073,3073},{3074,Mc,3074,3074,3074},{3075,Mc,3075,3075,3075},{3077,Lo,3077,3077,3077},{3078,Lo,3078,3078,3078},{3079,Lo,3079,3079,3079},{3080,Lo,3080,3080,3080},{3081,Lo,3081,3081,3081},{3082,Lo,3082,3082,3082},{3083,Lo,3083,3083,3083},{3084,Lo,3084,3084,3084},{3086,Lo,3086,3086,3086},{3087,Lo,3087,3087,3087},{3088,Lo,3088,3088,3088},{3090,Lo,3090,3090,3090},{3091,Lo,3091,3091,3091},{3092,Lo,3092,3092,3092},{3093,Lo,3093,3093,3093},{3094,Lo,3094,3094,3094},{3095,Lo,3095,3095,3095},{3096,Lo,3096,3096,3096},{3097,Lo,3097,3097,3097},{3098,Lo,3098,3098,3098},{3099,Lo,3099,3099,3099},{3100,Lo,3100,3100,3100},{3101,Lo,3101,3101,3101},{3102,Lo,3102,3102,3102},{3103,Lo,3103,3103,3103},{3104,Lo,3104,3104,3104},{3105,Lo,3105,3105,3105},{3106,Lo,3106,3106,3106},{3107,Lo,3107,3107,3107},{3108,Lo,3108,3108,3108},{3109,Lo,3109,3109,3109},{3110,Lo,3110,3110,3110},{3111,Lo,3111,3111,3111},{3112,Lo,3112,3112,3112},{3114,Lo,3114,3114,3114},{3115,Lo,3115,3115,3115},{3116,Lo,3116,3116,3116},{3117,Lo,3117,3117,3117},{3118,Lo,3118,3118,3118},{3119,Lo,3119,3119,3119},{3120,Lo,3120,3120,3120},{3121,Lo,3121,3121,3121},{3122,Lo,3122,3122,3122},{3123,Lo,3123,3123,3123},{3125,Lo,3125,3125,3125},{3126,Lo,3126,3126,3126},{3127,Lo,3127,3127,3127},{3128,Lo,3128,3128,3128},{3129,Lo,3129,3129,3129},{3134,Mn,3134,3134,3134},{3135,Mn,3135,3135,3135},{3136,Mn,3136,3136,3136},{3137,Mc,3137,3137,3137},{3138,Mc,3138,3138,3138},{3139,Mc,3139,3139,3139},{3140,Mc,3140,3140,3140},{3142,Mn,3142,3142,3142},{3143,Mn,3143,3143,3143},{3144,Mn,3144,3144,3144},{3146,Mn,3146,3146,3146},{3147,Mn,3147,3147,3147},{3148,Mn,3148,3148,3148},{3149,Mn,3149,3149,3149},{3157,Mn,3157,3157,3157},{3158,Mn,3158,3158,3158},{3168,Lo,3168,3168,3168},{3169,Lo,3169,3169,3169},{3174,Nd,3174,3174,3174},{3175,Nd,3175,3175,3175},{3176,Nd,3176,3176,3176},{3177,Nd,3177,3177,3177},{3178,Nd,3178,3178,3178},{3179,Nd,3179,3179,3179},{3180,Nd,3180,3180,3180},{3181,Nd,3181,3181,3181},{3182,Nd,3182,3182,3182},{3183,Nd,3183,3183,3183},{3202,Mc,3202,3202,3202},{3203,Mc,3203,3203,3203},{3205,Lo,3205,3205,3205},{3206,Lo,3206,3206,3206},{3207,Lo,3207,3207,3207},{3208,Lo,3208,3208,3208},{3209,Lo,3209,3209,3209},{3210,Lo,3210,3210,3210},{3211,Lo,3211,3211,3211},{3212,Lo,3212,3212,3212},{3214,Lo,3214,3214,3214},{3215,Lo,3215,3215,3215},{3216,Lo,3216,3216,3216},{3218,Lo,3218,3218,3218},{3219,Lo,3219,3219,3219},{3220,Lo,3220,3220,3220},{3221,Lo,3221,3221,3221},{3222,Lo,3222,3222,3222},{3223,Lo,3223,3223,3223},{3224,Lo,3224,3224,3224},{3225,Lo,3225,3225,3225},{3226,Lo,3226,3226,3226},{3227,Lo,3227,3227,3227},{3228,Lo,3228,3228,3228},{3229,Lo,3229,3229,3229},{3230,Lo,3230,3230,3230},{3231,Lo,3231,3231,3231},{3232,Lo,3232,3232,3232},{3233,Lo,3233,3233,3233},{3234,Lo,3234,3234,3234},{3235,Lo,3235,3235,3235},{3236,Lo,3236,3236,3236},{3237,Lo,3237,3237,3237},{3238,Lo,3238,3238,3238},{3239,Lo,3239,3239,3239},{3240,Lo,3240,3240,3240},{3242,Lo,3242,3242,3242},{3243,Lo,3243,3243,3243},{3244,Lo,3244,3244,3244},{3245,Lo,3245,3245,3245},{3246,Lo,3246,3246,3246},{3247,Lo,3247,3247,3247},{3248,Lo,3248,3248,3248},{3249,Lo,3249,3249,3249},{3250,Lo,3250,3250,3250},{3251,Lo,3251,3251,3251},{3253,Lo,3253,3253,3253},{3254,Lo,3254,3254,3254},{3255,Lo,3255,3255,3255},{3256,Lo,3256,3256,3256},{3257,Lo,3257,3257,3257},{3260,Mn,3260,3260,3260},{3261,Lo,3261,3261,3261},{3262,Mc,3262,3262,3262},{3263,Mn,3263,3263,3263},{3264,Mc,3264,3264,3264},{3265,Mc,3265,3265,3265},{3266,Mc,3266,3266,3266},{3267,Mc,3267,3267,3267},{3268,Mc,3268,3268,3268},{3270,Mn,3270,3270,3270},{3271,Mc,3271,3271,3271},{3272,Mc,3272,3272,3272},{3274,Mc,3274,3274,3274},{3275,Mc,3275,3275,3275},{3276,Mn,3276,3276,3276},{3277,Mn,3277,3277,3277},{3285,Mc,3285,3285,3285},{3286,Mc,3286,3286,3286},{3294,Lo,3294,3294,3294},{3296,Lo,3296,3296,3296},{3297,Lo,3297,3297,3297},{3298,Mn,3298,3298,3298},{3299,Mn,3299,3299,3299},{3302,Nd,3302,3302,3302},{3303,Nd,3303,3303,3303},{3304,Nd,3304,3304,3304},{3305,Nd,3305,3305,3305},{3306,Nd,3306,3306,3306},{3307,Nd,3307,3307,3307},{3308,Nd,3308,3308,3308},{3309,Nd,3309,3309,3309},{3310,Nd,3310,3310,3310},{3311,Nd,3311,3311,3311},{3313,So,3313,3313,3313},{3314,So,3314,3314,3314},{3330,Mc,3330,3330,3330},{3331,Mc,3331,3331,3331},{3333,Lo,3333,3333,3333},{3334,Lo,3334,3334,3334},{3335,Lo,3335,3335,3335},{3336,Lo,3336,3336,3336},{3337,Lo,3337,3337,3337},{3338,Lo,3338,3338,3338},{3339,Lo,3339,3339,3339},{3340,Lo,3340,3340,3340},{3342,Lo,3342,3342,3342},{3343,Lo,3343,3343,3343},{3344,Lo,3344,3344,3344},{3346,Lo,3346,3346,3346},{3347,Lo,3347,3347,3347},{3348,Lo,3348,3348,3348},{3349,Lo,3349,3349,3349},{3350,Lo,3350,3350,3350},{3351,Lo,3351,3351,3351},{3352,Lo,3352,3352,3352},{3353,Lo,3353,3353,3353},{3354,Lo,3354,3354,3354},{3355,Lo,3355,3355,3355},{3356,Lo,3356,3356,3356},{3357,Lo,3357,3357,3357},{3358,Lo,3358,3358,3358},{3359,Lo,3359,3359,3359},{3360,Lo,3360,3360,3360},{3361,Lo,3361,3361,3361},{3362,Lo,3362,3362,3362},{3363,Lo,3363,3363,3363},{3364,Lo,3364,3364,3364},{3365,Lo,3365,3365,3365},{3366,Lo,3366,3366,3366},{3367,Lo,3367,3367,3367},{3368,Lo,3368,3368,3368},{3370,Lo,3370,3370,3370},{3371,Lo,3371,3371,3371},{3372,Lo,3372,3372,3372},{3373,Lo,3373,3373,3373},{3374,Lo,3374,3374,3374},{3375,Lo,3375,3375,3375},{3376,Lo,3376,3376,3376},{3377,Lo,3377,3377,3377},{3378,Lo,3378,3378,3378},{3379,Lo,3379,3379,3379},{3380,Lo,3380,3380,3380},{3381,Lo,3381,3381,3381},{3382,Lo,3382,3382,3382},{3383,Lo,3383,3383,3383},{3384,Lo,3384,3384,3384},{3385,Lo,3385,3385,3385},{3390,Mc,3390,3390,3390},{3391,Mc,3391,3391,3391},{3392,Mc,3392,3392,3392},{3393,Mn,3393,3393,3393},{3394,Mn,3394,3394,3394},{3395,Mn,3395,3395,3395},{3398,Mc,3398,3398,3398},{3399,Mc,3399,3399,3399},{3400,Mc,3400,3400,3400},{3402,Mc,3402,3402,3402},{3403,Mc,3403,3403,3403},{3404,Mc,3404,3404,3404},{3405,Mn,3405,3405,3405},{3415,Mc,3415,3415,3415},{3424,Lo,3424,3424,3424},{3425,Lo,3425,3425,3425},{3430,Nd,3430,3430,3430},{3431,Nd,3431,3431,3431},{3432,Nd,3432,3432,3432},{3433,Nd,3433,3433,3433},{3434,Nd,3434,3434,3434},{3435,Nd,3435,3435,3435},{3436,Nd,3436,3436,3436},{3437,Nd,3437,3437,3437},{3438,Nd,3438,3438,3438},{3439,Nd,3439,3439,3439},{3458,Mc,3458,3458,3458},{3459,Mc,3459,3459,3459},{3461,Lo,3461,3461,3461},{3462,Lo,3462,3462,3462},{3463,Lo,3463,3463,3463},{3464,Lo,3464,3464,3464},{3465,Lo,3465,3465,3465},{3466,Lo,3466,3466,3466},{3467,Lo,3467,3467,3467},{3468,Lo,3468,3468,3468},{3469,Lo,3469,3469,3469},{3470,Lo,3470,3470,3470},{3471,Lo,3471,3471,3471},{3472,Lo,3472,3472,3472},{3473,Lo,3473,3473,3473},{3474,Lo,3474,3474,3474},{3475,Lo,3475,3475,3475},{3476,Lo,3476,3476,3476},{3477,Lo,3477,3477,3477},{3478,Lo,3478,3478,3478},{3482,Lo,3482,3482,3482},{3483,Lo,3483,3483,3483},{3484,Lo,3484,3484,3484},{3485,Lo,3485,3485,3485},{3486,Lo,3486,3486,3486},{3487,Lo,3487,3487,3487},{3488,Lo,3488,3488,3488},{3489,Lo,3489,3489,3489},{3490,Lo,3490,3490,3490},{3491,Lo,3491,3491,3491},{3492,Lo,3492,3492,3492},{3493,Lo,3493,3493,3493},{3494,Lo,3494,3494,3494},{3495,Lo,3495,3495,3495},{3496,Lo,3496,3496,3496},{3497,Lo,3497,3497,3497},{3498,Lo,3498,3498,3498},{3499,Lo,3499,3499,3499},{3500,Lo,3500,3500,3500},{3501,Lo,3501,3501,3501},{3502,Lo,3502,3502,3502},{3503,Lo,3503,3503,3503},{3504,Lo,3504,3504,3504},{3505,Lo,3505,3505,3505},{3507,Lo,3507,3507,3507},{3508,Lo,3508,3508,3508},{3509,Lo,3509,3509,3509},{3510,Lo,3510,3510,3510},{3511,Lo,3511,3511,3511},{3512,Lo,3512,3512,3512},{3513,Lo,3513,3513,3513},{3514,Lo,3514,3514,3514},{3515,Lo,3515,3515,3515},{3517,Lo,3517,3517,3517},{3520,Lo,3520,3520,3520},{3521,Lo,3521,3521,3521},{3522,Lo,3522,3522,3522},{3523,Lo,3523,3523,3523},{3524,Lo,3524,3524,3524},{3525,Lo,3525,3525,3525},{3526,Lo,3526,3526,3526},{3530,Mn,3530,3530,3530},{3535,Mc,3535,3535,3535},{3536,Mc,3536,3536,3536},{3537,Mc,3537,3537,3537},{3538,Mn,3538,3538,3538},{3539,Mn,3539,3539,3539},{3540,Mn,3540,3540,3540},{3542,Mn,3542,3542,3542},{3544,Mc,3544,3544,3544},{3545,Mc,3545,3545,3545},{3546,Mc,3546,3546,3546},{3547,Mc,3547,3547,3547},{3548,Mc,3548,3548,3548},{3549,Mc,3549,3549,3549},{3550,Mc,3550,3550,3550},{3551,Mc,3551,3551,3551},{3570,Mc,3570,3570,3570},{3571,Mc,3571,3571,3571},{3572,Po,3572,3572,3572},{3585,Lo,3585,3585,3585},{3586,Lo,3586,3586,3586},{3587,Lo,3587,3587,3587},{3588,Lo,3588,3588,3588},{3589,Lo,3589,3589,3589},{3590,Lo,3590,3590,3590},{3591,Lo,3591,3591,3591},{3592,Lo,3592,3592,3592},{3593,Lo,3593,3593,3593},{3594,Lo,3594,3594,3594},{3595,Lo,3595,3595,3595},{3596,Lo,3596,3596,3596},{3597,Lo,3597,3597,3597},{3598,Lo,3598,3598,3598},{3599,Lo,3599,3599,3599},{3600,Lo,3600,3600,3600},{3601,Lo,3601,3601,3601},{3602,Lo,3602,3602,3602},{3603,Lo,3603,3603,3603},{3604,Lo,3604,3604,3604},{3605,Lo,3605,3605,3605},{3606,Lo,3606,3606,3606},{3607,Lo,3607,3607,3607},{3608,Lo,3608,3608,3608},{3609,Lo,3609,3609,3609},{3610,Lo,3610,3610,3610},{3611,Lo,3611,3611,3611},{3612,Lo,3612,3612,3612},{3613,Lo,3613,3613,3613},{3614,Lo,3614,3614,3614},{3615,Lo,3615,3615,3615},{3616,Lo,3616,3616,3616},{3617,Lo,3617,3617,3617},{3618,Lo,3618,3618,3618},{3619,Lo,3619,3619,3619},{3620,Lo,3620,3620,3620},{3621,Lo,3621,3621,3621},{3622,Lo,3622,3622,3622},{3623,Lo,3623,3623,3623},{3624,Lo,3624,3624,3624},{3625,Lo,3625,3625,3625},{3626,Lo,3626,3626,3626},{3627,Lo,3627,3627,3627},{3628,Lo,3628,3628,3628},{3629,Lo,3629,3629,3629},{3630,Lo,3630,3630,3630},{3631,Lo,3631,3631,3631},{3632,Lo,3632,3632,3632},{3633,Mn,3633,3633,3633},{3634,Lo,3634,3634,3634},{3635,Lo,3635,3635,3635},{3636,Mn,3636,3636,3636},{3637,Mn,3637,3637,3637},{3638,Mn,3638,3638,3638},{3639,Mn,3639,3639,3639},{3640,Mn,3640,3640,3640},{3641,Mn,3641,3641,3641},{3642,Mn,3642,3642,3642},{3647,Sc,3647,3647,3647},{3648,Lo,3648,3648,3648},{3649,Lo,3649,3649,3649},{3650,Lo,3650,3650,3650},{3651,Lo,3651,3651,3651},{3652,Lo,3652,3652,3652},{3653,Lo,3653,3653,3653},{3654,Lm,3654,3654,3654},{3655,Mn,3655,3655,3655},{3656,Mn,3656,3656,3656},{3657,Mn,3657,3657,3657},{3658,Mn,3658,3658,3658},{3659,Mn,3659,3659,3659},{3660,Mn,3660,3660,3660},{3661,Mn,3661,3661,3661},{3662,Mn,3662,3662,3662},{3663,Po,3663,3663,3663},{3664,Nd,3664,3664,3664},{3665,Nd,3665,3665,3665},{3666,Nd,3666,3666,3666},{3667,Nd,3667,3667,3667},{3668,Nd,3668,3668,3668},{3669,Nd,3669,3669,3669},{3670,Nd,3670,3670,3670},{3671,Nd,3671,3671,3671},{3672,Nd,3672,3672,3672},{3673,Nd,3673,3673,3673},{3674,Po,3674,3674,3674},{3675,Po,3675,3675,3675},{3713,Lo,3713,3713,3713},{3714,Lo,3714,3714,3714},{3716,Lo,3716,3716,3716},{3719,Lo,3719,3719,3719},{3720,Lo,3720,3720,3720},{3722,Lo,3722,3722,3722},{3725,Lo,3725,3725,3725},{3732,Lo,3732,3732,3732},{3733,Lo,3733,3733,3733},{3734,Lo,3734,3734,3734},{3735,Lo,3735,3735,3735},{3737,Lo,3737,3737,3737},{3738,Lo,3738,3738,3738},{3739,Lo,3739,3739,3739},{3740,Lo,3740,3740,3740},{3741,Lo,3741,3741,3741},{3742,Lo,3742,3742,3742},{3743,Lo,3743,3743,3743},{3745,Lo,3745,3745,3745},{3746,Lo,3746,3746,3746},{3747,Lo,3747,3747,3747},{3749,Lo,3749,3749,3749},{3751,Lo,3751,3751,3751},{3754,Lo,3754,3754,3754},{3755,Lo,3755,3755,3755},{3757,Lo,3757,3757,3757},{3758,Lo,3758,3758,3758},{3759,Lo,3759,3759,3759},{3760,Lo,3760,3760,3760},{3761,Mn,3761,3761,3761},{3762,Lo,3762,3762,3762},{3763,Lo,3763,3763,3763},{3764,Mn,3764,3764,3764},{3765,Mn,3765,3765,3765},{3766,Mn,3766,3766,3766},{3767,Mn,3767,3767,3767},{3768,Mn,3768,3768,3768},{3769,Mn,3769,3769,3769},{3771,Mn,3771,3771,3771},{3772,Mn,3772,3772,3772},{3773,Lo,3773,3773,3773},{3776,Lo,3776,3776,3776},{3777,Lo,3777,3777,3777},{3778,Lo,3778,3778,3778},{3779,Lo,3779,3779,3779},{3780,Lo,3780,3780,3780},{3782,Lm,3782,3782,3782},{3784,Mn,3784,3784,3784},{3785,Mn,3785,3785,3785},{3786,Mn,3786,3786,3786},{3787,Mn,3787,3787,3787},{3788,Mn,3788,3788,3788},{3789,Mn,3789,3789,3789},{3792,Nd,3792,3792,3792},{3793,Nd,3793,3793,3793},{3794,Nd,3794,3794,3794},{3795,Nd,3795,3795,3795},{3796,Nd,3796,3796,3796},{3797,Nd,3797,3797,3797},{3798,Nd,3798,3798,3798},{3799,Nd,3799,3799,3799},{3800,Nd,3800,3800,3800},{3801,Nd,3801,3801,3801},{3804,Lo,3804,3804,3804},{3805,Lo,3805,3805,3805},{3840,Lo,3840,3840,3840},{3841,So,3841,3841,3841},{3842,So,3842,3842,3842},{3843,So,3843,3843,3843},{3844,Po,3844,3844,3844},{3845,Po,3845,3845,3845},{3846,Po,3846,3846,3846},{3847,Po,3847,3847,3847},{3848,Po,3848,3848,3848},{3849,Po,3849,3849,3849},{3850,Po,3850,3850,3850},{3851,Po,3851,3851,3851},{3852,Po,3852,3852,3852},{3853,Po,3853,3853,3853},{3854,Po,3854,3854,3854},{3855,Po,3855,3855,3855},{3856,Po,3856,3856,3856},{3857,Po,3857,3857,3857},{3858,Po,3858,3858,3858},{3859,So,3859,3859,3859},{3860,So,3860,3860,3860},{3861,So,3861,3861,3861},{3862,So,3862,3862,3862},{3863,So,3863,3863,3863},{3864,Mn,3864,3864,3864},{3865,Mn,3865,3865,3865},{3866,So,3866,3866,3866},{3867,So,3867,3867,3867},{3868,So,3868,3868,3868},{3869,So,3869,3869,3869},{3870,So,3870,3870,3870},{3871,So,3871,3871,3871},{3872,Nd,3872,3872,3872},{3873,Nd,3873,3873,3873},{3874,Nd,3874,3874,3874},{3875,Nd,3875,3875,3875},{3876,Nd,3876,3876,3876},{3877,Nd,3877,3877,3877},{3878,Nd,3878,3878,3878},{3879,Nd,3879,3879,3879},{3880,Nd,3880,3880,3880},{3881,Nd,3881,3881,3881},{3882,No,3882,3882,3882},{3883,No,3883,3883,3883},{3884,No,3884,3884,3884},{3885,No,3885,3885,3885},{3886,No,3886,3886,3886},{3887,No,3887,3887,3887},{3888,No,3888,3888,3888},{3889,No,3889,3889,3889},{3890,No,3890,3890,3890},{3891,No,3891,3891,3891},{3892,So,3892,3892,3892},{3893,Mn,3893,3893,3893},{3894,So,3894,3894,3894},{3895,Mn,3895,3895,3895},{3896,So,3896,3896,3896},{3897,Mn,3897,3897,3897},{3898,Ps,3898,3898,3898},{3899,Pe,3899,3899,3899},{3900,Ps,3900,3900,3900},{3901,Pe,3901,3901,3901},{3902,Mc,3902,3902,3902},{3903,Mc,3903,3903,3903},{3904,Lo,3904,3904,3904},{3905,Lo,3905,3905,3905},{3906,Lo,3906,3906,3906},{3907,Lo,3907,3907,3907},{3908,Lo,3908,3908,3908},{3909,Lo,3909,3909,3909},{3910,Lo,3910,3910,3910},{3911,Lo,3911,3911,3911},{3913,Lo,3913,3913,3913},{3914,Lo,3914,3914,3914},{3915,Lo,3915,3915,3915},{3916,Lo,3916,3916,3916},{3917,Lo,3917,3917,3917},{3918,Lo,3918,3918,3918},{3919,Lo,3919,3919,3919},{3920,Lo,3920,3920,3920},{3921,Lo,3921,3921,3921},{3922,Lo,3922,3922,3922},{3923,Lo,3923,3923,3923},{3924,Lo,3924,3924,3924},{3925,Lo,3925,3925,3925},{3926,Lo,3926,3926,3926},{3927,Lo,3927,3927,3927},{3928,Lo,3928,3928,3928},{3929,Lo,3929,3929,3929},{3930,Lo,3930,3930,3930},{3931,Lo,3931,3931,3931},{3932,Lo,3932,3932,3932},{3933,Lo,3933,3933,3933},{3934,Lo,3934,3934,3934},{3935,Lo,3935,3935,3935},{3936,Lo,3936,3936,3936},{3937,Lo,3937,3937,3937},{3938,Lo,3938,3938,3938},{3939,Lo,3939,3939,3939},{3940,Lo,3940,3940,3940},{3941,Lo,3941,3941,3941},{3942,Lo,3942,3942,3942},{3943,Lo,3943,3943,3943},{3944,Lo,3944,3944,3944},{3945,Lo,3945,3945,3945},{3946,Lo,3946,3946,3946},{3953,Mn,3953,3953,3953},{3954,Mn,3954,3954,3954},{3955,Mn,3955,3955,3955},{3956,Mn,3956,3956,3956},{3957,Mn,3957,3957,3957},{3958,Mn,3958,3958,3958},{3959,Mn,3959,3959,3959},{3960,Mn,3960,3960,3960},{3961,Mn,3961,3961,3961},{3962,Mn,3962,3962,3962},{3963,Mn,3963,3963,3963},{3964,Mn,3964,3964,3964},{3965,Mn,3965,3965,3965},{3966,Mn,3966,3966,3966},{3967,Mc,3967,3967,3967},{3968,Mn,3968,3968,3968},{3969,Mn,3969,3969,3969},{3970,Mn,3970,3970,3970},{3971,Mn,3971,3971,3971},{3972,Mn,3972,3972,3972},{3973,Po,3973,3973,3973},{3974,Mn,3974,3974,3974},{3975,Mn,3975,3975,3975},{3976,Lo,3976,3976,3976},{3977,Lo,3977,3977,3977},{3978,Lo,3978,3978,3978},{3979,Lo,3979,3979,3979},{3984,Mn,3984,3984,3984},{3985,Mn,3985,3985,3985},{3986,Mn,3986,3986,3986},{3987,Mn,3987,3987,3987},{3988,Mn,3988,3988,3988},{3989,Mn,3989,3989,3989},{3990,Mn,3990,3990,3990},{3991,Mn,3991,3991,3991},{3993,Mn,3993,3993,3993},{3994,Mn,3994,3994,3994},{3995,Mn,3995,3995,3995},{3996,Mn,3996,3996,3996},{3997,Mn,3997,3997,3997},{3998,Mn,3998,3998,3998},{3999,Mn,3999,3999,3999},{4000,Mn,4000,4000,4000},{4001,Mn,4001,4001,4001},{4002,Mn,4002,4002,4002},{4003,Mn,4003,4003,4003},{4004,Mn,4004,4004,4004},{4005,Mn,4005,4005,4005},{4006,Mn,4006,4006,4006},{4007,Mn,4007,4007,4007},{4008,Mn,4008,4008,4008},{4009,Mn,4009,4009,4009},{4010,Mn,4010,4010,4010},{4011,Mn,4011,4011,4011},{4012,Mn,4012,4012,4012},{4013,Mn,4013,4013,4013},{4014,Mn,4014,4014,4014},{4015,Mn,4015,4015,4015},{4016,Mn,4016,4016,4016},{4017,Mn,4017,4017,4017},{4018,Mn,4018,4018,4018},{4019,Mn,4019,4019,4019},{4020,Mn,4020,4020,4020},{4021,Mn,4021,4021,4021},{4022,Mn,4022,4022,4022},{4023,Mn,4023,4023,4023},{4024,Mn,4024,4024,4024},{4025,Mn,4025,4025,4025},{4026,Mn,4026,4026,4026},{4027,Mn,4027,4027,4027},{4028,Mn,4028,4028,4028},{4030,So,4030,4030,4030},{4031,So,4031,4031,4031},{4032,So,4032,4032,4032},{4033,So,4033,4033,4033},{4034,So,4034,4034,4034},{4035,So,4035,4035,4035},{4036,So,4036,4036,4036},{4037,So,4037,4037,4037},{4038,Mn,4038,4038,4038},{4039,So,4039,4039,4039},{4040,So,4040,4040,4040},{4041,So,4041,4041,4041},{4042,So,4042,4042,4042},{4043,So,4043,4043,4043},{4044,So,4044,4044,4044},{4047,So,4047,4047,4047},{4048,Po,4048,4048,4048},{4049,Po,4049,4049,4049},{4096,Lo,4096,4096,4096},{4097,Lo,4097,4097,4097},{4098,Lo,4098,4098,4098},{4099,Lo,4099,4099,4099},{4100,Lo,4100,4100,4100},{4101,Lo,4101,4101,4101},{4102,Lo,4102,4102,4102},{4103,Lo,4103,4103,4103},{4104,Lo,4104,4104,4104},{4105,Lo,4105,4105,4105},{4106,Lo,4106,4106,4106},{4107,Lo,4107,4107,4107},{4108,Lo,4108,4108,4108},{4109,Lo,4109,4109,4109},{4110,Lo,4110,4110,4110},{4111,Lo,4111,4111,4111},{4112,Lo,4112,4112,4112},{4113,Lo,4113,4113,4113},{4114,Lo,4114,4114,4114},{4115,Lo,4115,4115,4115},{4116,Lo,4116,4116,4116},{4117,Lo,4117,4117,4117},{4118,Lo,4118,4118,4118},{4119,Lo,4119,4119,4119},{4120,Lo,4120,4120,4120},{4121,Lo,4121,4121,4121},{4122,Lo,4122,4122,4122},{4123,Lo,4123,4123,4123},{4124,Lo,4124,4124,4124},{4125,Lo,4125,4125,4125},{4126,Lo,4126,4126,4126},{4127,Lo,4127,4127,4127},{4128,Lo,4128,4128,4128},{4129,Lo,4129,4129,4129},{4131,Lo,4131,4131,4131},{4132,Lo,4132,4132,4132},{4133,Lo,4133,4133,4133},{4134,Lo,4134,4134,4134},{4135,Lo,4135,4135,4135},{4137,Lo,4137,4137,4137},{4138,Lo,4138,4138,4138},{4140,Mc,4140,4140,4140},{4141,Mn,4141,4141,4141},{4142,Mn,4142,4142,4142},{4143,Mn,4143,4143,4143},{4144,Mn,4144,4144,4144},{4145,Mc,4145,4145,4145},{4146,Mn,4146,4146,4146},{4150,Mn,4150,4150,4150},{4151,Mn,4151,4151,4151},{4152,Mc,4152,4152,4152},{4153,Mn,4153,4153,4153},{4160,Nd,4160,4160,4160},{4161,Nd,4161,4161,4161},{4162,Nd,4162,4162,4162},{4163,Nd,4163,4163,4163},{4164,Nd,4164,4164,4164},{4165,Nd,4165,4165,4165},{4166,Nd,4166,4166,4166},{4167,Nd,4167,4167,4167},{4168,Nd,4168,4168,4168},{4169,Nd,4169,4169,4169},{4170,Po,4170,4170,4170},{4171,Po,4171,4171,4171},{4172,Po,4172,4172,4172},{4173,Po,4173,4173,4173},{4174,Po,4174,4174,4174},{4175,Po,4175,4175,4175},{4176,Lo,4176,4176,4176},{4177,Lo,4177,4177,4177},{4178,Lo,4178,4178,4178},{4179,Lo,4179,4179,4179},{4180,Lo,4180,4180,4180},{4181,Lo,4181,4181,4181},{4182,Mc,4182,4182,4182},{4183,Mc,4183,4183,4183},{4184,Mn,4184,4184,4184},{4185,Mn,4185,4185,4185},{4256,Lu,4256,11520,4256},{4257,Lu,4257,11521,4257},{4258,Lu,4258,11522,4258},{4259,Lu,4259,11523,4259},{4260,Lu,4260,11524,4260},{4261,Lu,4261,11525,4261},{4262,Lu,4262,11526,4262},{4263,Lu,4263,11527,4263},{4264,Lu,4264,11528,4264},{4265,Lu,4265,11529,4265},{4266,Lu,4266,11530,4266},{4267,Lu,4267,11531,4267},{4268,Lu,4268,11532,4268},{4269,Lu,4269,11533,4269},{4270,Lu,4270,11534,4270},{4271,Lu,4271,11535,4271},{4272,Lu,4272,11536,4272},{4273,Lu,4273,11537,4273},{4274,Lu,4274,11538,4274},{4275,Lu,4275,11539,4275},{4276,Lu,4276,11540,4276},{4277,Lu,4277,11541,4277},{4278,Lu,4278,11542,4278},{4279,Lu,4279,11543,4279},{4280,Lu,4280,11544,4280},{4281,Lu,4281,11545,4281},{4282,Lu,4282,11546,4282},{4283,Lu,4283,11547,4283},{4284,Lu,4284,11548,4284},{4285,Lu,4285,11549,4285},{4286,Lu,4286,11550,4286},{4287,Lu,4287,11551,4287},{4288,Lu,4288,11552,4288},{4289,Lu,4289,11553,4289},{4290,Lu,4290,11554,4290},{4291,Lu,4291,11555,4291},{4292,Lu,4292,11556,4292},{4293,Lu,4293,11557,4293},{4304,Lo,4304,4304,4304},{4305,Lo,4305,4305,4305},{4306,Lo,4306,4306,4306},{4307,Lo,4307,4307,4307},{4308,Lo,4308,4308,4308},{4309,Lo,4309,4309,4309},{4310,Lo,4310,4310,4310},{4311,Lo,4311,4311,4311},{4312,Lo,4312,4312,4312},{4313,Lo,4313,4313,4313},{4314,Lo,4314,4314,4314},{4315,Lo,4315,4315,4315},{4316,Lo,4316,4316,4316},{4317,Lo,4317,4317,4317},{4318,Lo,4318,4318,4318},{4319,Lo,4319,4319,4319},{4320,Lo,4320,4320,4320},{4321,Lo,4321,4321,4321},{4322,Lo,4322,4322,4322},{4323,Lo,4323,4323,4323},{4324,Lo,4324,4324,4324},{4325,Lo,4325,4325,4325},{4326,Lo,4326,4326,4326},{4327,Lo,4327,4327,4327},{4328,Lo,4328,4328,4328},{4329,Lo,4329,4329,4329},{4330,Lo,4330,4330,4330},{4331,Lo,4331,4331,4331},{4332,Lo,4332,4332,4332},{4333,Lo,4333,4333,4333},{4334,Lo,4334,4334,4334},{4335,Lo,4335,4335,4335},{4336,Lo,4336,4336,4336},{4337,Lo,4337,4337,4337},{4338,Lo,4338,4338,4338},{4339,Lo,4339,4339,4339},{4340,Lo,4340,4340,4340},{4341,Lo,4341,4341,4341},{4342,Lo,4342,4342,4342},{4343,Lo,4343,4343,4343},{4344,Lo,4344,4344,4344},{4345,Lo,4345,4345,4345},{4346,Lo,4346,4346,4346},{4347,Po,4347,4347,4347},{4348,Lm,4348,4348,4348},{4352,Lo,4352,4352,4352},{4353,Lo,4353,4353,4353},{4354,Lo,4354,4354,4354},{4355,Lo,4355,4355,4355},{4356,Lo,4356,4356,4356},{4357,Lo,4357,4357,4357},{4358,Lo,4358,4358,4358},{4359,Lo,4359,4359,4359},{4360,Lo,4360,4360,4360},{4361,Lo,4361,4361,4361},{4362,Lo,4362,4362,4362},{4363,Lo,4363,4363,4363},{4364,Lo,4364,4364,4364},{4365,Lo,4365,4365,4365},{4366,Lo,4366,4366,4366},{4367,Lo,4367,4367,4367},{4368,Lo,4368,4368,4368},{4369,Lo,4369,4369,4369},{4370,Lo,4370,4370,4370},{4371,Lo,4371,4371,4371},{4372,Lo,4372,4372,4372},{4373,Lo,4373,4373,4373},{4374,Lo,4374,4374,4374},{4375,Lo,4375,4375,4375},{4376,Lo,4376,4376,4376},{4377,Lo,4377,4377,4377},{4378,Lo,4378,4378,4378},{4379,Lo,4379,4379,4379},{4380,Lo,4380,4380,4380},{4381,Lo,4381,4381,4381},{4382,Lo,4382,4382,4382},{4383,Lo,4383,4383,4383},{4384,Lo,4384,4384,4384},{4385,Lo,4385,4385,4385},{4386,Lo,4386,4386,4386},{4387,Lo,4387,4387,4387},{4388,Lo,4388,4388,4388},{4389,Lo,4389,4389,4389},{4390,Lo,4390,4390,4390},{4391,Lo,4391,4391,4391},{4392,Lo,4392,4392,4392},{4393,Lo,4393,4393,4393},{4394,Lo,4394,4394,4394},{4395,Lo,4395,4395,4395},{4396,Lo,4396,4396,4396},{4397,Lo,4397,4397,4397},{4398,Lo,4398,4398,4398},{4399,Lo,4399,4399,4399},{4400,Lo,4400,4400,4400},{4401,Lo,4401,4401,4401},{4402,Lo,4402,4402,4402},{4403,Lo,4403,4403,4403},{4404,Lo,4404,4404,4404},{4405,Lo,4405,4405,4405},{4406,Lo,4406,4406,4406},{4407,Lo,4407,4407,4407},{4408,Lo,4408,4408,4408},{4409,Lo,4409,4409,4409},{4410,Lo,4410,4410,4410},{4411,Lo,4411,4411,4411},{4412,Lo,4412,4412,4412},{4413,Lo,4413,4413,4413},{4414,Lo,4414,4414,4414},{4415,Lo,4415,4415,4415},{4416,Lo,4416,4416,4416},{4417,Lo,4417,4417,4417},{4418,Lo,4418,4418,4418},{4419,Lo,4419,4419,4419},{4420,Lo,4420,4420,4420},{4421,Lo,4421,4421,4421},{4422,Lo,4422,4422,4422},{4423,Lo,4423,4423,4423},{4424,Lo,4424,4424,4424},{4425,Lo,4425,4425,4425},{4426,Lo,4426,4426,4426},{4427,Lo,4427,4427,4427},{4428,Lo,4428,4428,4428},{4429,Lo,4429,4429,4429},{4430,Lo,4430,4430,4430},{4431,Lo,4431,4431,4431},{4432,Lo,4432,4432,4432},{4433,Lo,4433,4433,4433},{4434,Lo,4434,4434,4434},{4435,Lo,4435,4435,4435},{4436,Lo,4436,4436,4436},{4437,Lo,4437,4437,4437},{4438,Lo,4438,4438,4438},{4439,Lo,4439,4439,4439},{4440,Lo,4440,4440,4440},{4441,Lo,4441,4441,4441},{4447,Lo,4447,4447,4447},{4448,Lo,4448,4448,4448},{4449,Lo,4449,4449,4449},{4450,Lo,4450,4450,4450},{4451,Lo,4451,4451,4451},{4452,Lo,4452,4452,4452},{4453,Lo,4453,4453,4453},{4454,Lo,4454,4454,4454},{4455,Lo,4455,4455,4455},{4456,Lo,4456,4456,4456},{4457,Lo,4457,4457,4457},{4458,Lo,4458,4458,4458},{4459,Lo,4459,4459,4459},{4460,Lo,4460,4460,4460},{4461,Lo,4461,4461,4461},{4462,Lo,4462,4462,4462},{4463,Lo,4463,4463,4463},{4464,Lo,4464,4464,4464},{4465,Lo,4465,4465,4465},{4466,Lo,4466,4466,4466},{4467,Lo,4467,4467,4467},{4468,Lo,4468,4468,4468},{4469,Lo,4469,4469,4469},{4470,Lo,4470,4470,4470},{4471,Lo,4471,4471,4471},{4472,Lo,4472,4472,4472},{4473,Lo,4473,4473,4473},{4474,Lo,4474,4474,4474},{4475,Lo,4475,4475,4475},{4476,Lo,4476,4476,4476},{4477,Lo,4477,4477,4477},{4478,Lo,4478,4478,4478},{4479,Lo,4479,4479,4479},{4480,Lo,4480,4480,4480},{4481,Lo,4481,4481,4481},{4482,Lo,4482,4482,4482},{4483,Lo,4483,4483,4483},{4484,Lo,4484,4484,4484},{4485,Lo,4485,4485,4485},{4486,Lo,4486,4486,4486},{4487,Lo,4487,4487,4487},{4488,Lo,4488,4488,4488},{4489,Lo,4489,4489,4489},{4490,Lo,4490,4490,4490},{4491,Lo,4491,4491,4491},{4492,Lo,4492,4492,4492},{4493,Lo,4493,4493,4493},{4494,Lo,4494,4494,4494},{4495,Lo,4495,4495,4495},{4496,Lo,4496,4496,4496},{4497,Lo,4497,4497,4497},{4498,Lo,4498,4498,4498},{4499,Lo,4499,4499,4499},{4500,Lo,4500,4500,4500},{4501,Lo,4501,4501,4501},{4502,Lo,4502,4502,4502},{4503,Lo,4503,4503,4503},{4504,Lo,4504,4504,4504},{4505,Lo,4505,4505,4505},{4506,Lo,4506,4506,4506},{4507,Lo,4507,4507,4507},{4508,Lo,4508,4508,4508},{4509,Lo,4509,4509,4509},{4510,Lo,4510,4510,4510},{4511,Lo,4511,4511,4511},{4512,Lo,4512,4512,4512},{4513,Lo,4513,4513,4513},{4514,Lo,4514,4514,4514},{4520,Lo,4520,4520,4520},{4521,Lo,4521,4521,4521},{4522,Lo,4522,4522,4522},{4523,Lo,4523,4523,4523},{4524,Lo,4524,4524,4524},{4525,Lo,4525,4525,4525},{4526,Lo,4526,4526,4526},{4527,Lo,4527,4527,4527},{4528,Lo,4528,4528,4528},{4529,Lo,4529,4529,4529},{4530,Lo,4530,4530,4530},{4531,Lo,4531,4531,4531},{4532,Lo,4532,4532,4532},{4533,Lo,4533,4533,4533},{4534,Lo,4534,4534,4534},{4535,Lo,4535,4535,4535},{4536,Lo,4536,4536,4536},{4537,Lo,4537,4537,4537},{4538,Lo,4538,4538,4538},{4539,Lo,4539,4539,4539},{4540,Lo,4540,4540,4540},{4541,Lo,4541,4541,4541},{4542,Lo,4542,4542,4542},{4543,Lo,4543,4543,4543},{4544,Lo,4544,4544,4544},{4545,Lo,4545,4545,4545},{4546,Lo,4546,4546,4546},{4547,Lo,4547,4547,4547},{4548,Lo,4548,4548,4548},{4549,Lo,4549,4549,4549},{4550,Lo,4550,4550,4550},{4551,Lo,4551,4551,4551},{4552,Lo,4552,4552,4552},{4553,Lo,4553,4553,4553},{4554,Lo,4554,4554,4554},{4555,Lo,4555,4555,4555},{4556,Lo,4556,4556,4556},{4557,Lo,4557,4557,4557},{4558,Lo,4558,4558,4558},{4559,Lo,4559,4559,4559},{4560,Lo,4560,4560,4560},{4561,Lo,4561,4561,4561},{4562,Lo,4562,4562,4562},{4563,Lo,4563,4563,4563},{4564,Lo,4564,4564,4564},{4565,Lo,4565,4565,4565},{4566,Lo,4566,4566,4566},{4567,Lo,4567,4567,4567},{4568,Lo,4568,4568,4568},{4569,Lo,4569,4569,4569},{4570,Lo,4570,4570,4570},{4571,Lo,4571,4571,4571},{4572,Lo,4572,4572,4572},{4573,Lo,4573,4573,4573},{4574,Lo,4574,4574,4574},{4575,Lo,4575,4575,4575},{4576,Lo,4576,4576,4576},{4577,Lo,4577,4577,4577},{4578,Lo,4578,4578,4578},{4579,Lo,4579,4579,4579},{4580,Lo,4580,4580,4580},{4581,Lo,4581,4581,4581},{4582,Lo,4582,4582,4582},{4583,Lo,4583,4583,4583},{4584,Lo,4584,4584,4584},{4585,Lo,4585,4585,4585},{4586,Lo,4586,4586,4586},{4587,Lo,4587,4587,4587},{4588,Lo,4588,4588,4588},{4589,Lo,4589,4589,4589},{4590,Lo,4590,4590,4590},{4591,Lo,4591,4591,4591},{4592,Lo,4592,4592,4592},{4593,Lo,4593,4593,4593},{4594,Lo,4594,4594,4594},{4595,Lo,4595,4595,4595},{4596,Lo,4596,4596,4596},{4597,Lo,4597,4597,4597},{4598,Lo,4598,4598,4598},{4599,Lo,4599,4599,4599},{4600,Lo,4600,4600,4600},{4601,Lo,4601,4601,4601},{4608,Lo,4608,4608,4608},{4609,Lo,4609,4609,4609},{4610,Lo,4610,4610,4610},{4611,Lo,4611,4611,4611},{4612,Lo,4612,4612,4612},{4613,Lo,4613,4613,4613},{4614,Lo,4614,4614,4614},{4615,Lo,4615,4615,4615},{4616,Lo,4616,4616,4616},{4617,Lo,4617,4617,4617},{4618,Lo,4618,4618,4618},{4619,Lo,4619,4619,4619},{4620,Lo,4620,4620,4620},{4621,Lo,4621,4621,4621},{4622,Lo,4622,4622,4622},{4623,Lo,4623,4623,4623},{4624,Lo,4624,4624,4624},{4625,Lo,4625,4625,4625},{4626,Lo,4626,4626,4626},{4627,Lo,4627,4627,4627},{4628,Lo,4628,4628,4628},{4629,Lo,4629,4629,4629},{4630,Lo,4630,4630,4630},{4631,Lo,4631,4631,4631},{4632,Lo,4632,4632,4632},{4633,Lo,4633,4633,4633},{4634,Lo,4634,4634,4634},{4635,Lo,4635,4635,4635},{4636,Lo,4636,4636,4636},{4637,Lo,4637,4637,4637},{4638,Lo,4638,4638,4638},{4639,Lo,4639,4639,4639},{4640,Lo,4640,4640,4640},{4641,Lo,4641,4641,4641},{4642,Lo,4642,4642,4642},{4643,Lo,4643,4643,4643},{4644,Lo,4644,4644,4644},{4645,Lo,4645,4645,4645},{4646,Lo,4646,4646,4646},{4647,Lo,4647,4647,4647},{4648,Lo,4648,4648,4648},{4649,Lo,4649,4649,4649},{4650,Lo,4650,4650,4650},{4651,Lo,4651,4651,4651},{4652,Lo,4652,4652,4652},{4653,Lo,4653,4653,4653},{4654,Lo,4654,4654,4654},{4655,Lo,4655,4655,4655},{4656,Lo,4656,4656,4656},{4657,Lo,4657,4657,4657},{4658,Lo,4658,4658,4658},{4659,Lo,4659,4659,4659},{4660,Lo,4660,4660,4660},{4661,Lo,4661,4661,4661},{4662,Lo,4662,4662,4662},{4663,Lo,4663,4663,4663},{4664,Lo,4664,4664,4664},{4665,Lo,4665,4665,4665},{4666,Lo,4666,4666,4666},{4667,Lo,4667,4667,4667},{4668,Lo,4668,4668,4668},{4669,Lo,4669,4669,4669},{4670,Lo,4670,4670,4670},{4671,Lo,4671,4671,4671},{4672,Lo,4672,4672,4672},{4673,Lo,4673,4673,4673},{4674,Lo,4674,4674,4674},{4675,Lo,4675,4675,4675},{4676,Lo,4676,4676,4676},{4677,Lo,4677,4677,4677},{4678,Lo,4678,4678,4678},{4679,Lo,4679,4679,4679},{4680,Lo,4680,4680,4680},{4682,Lo,4682,4682,4682},{4683,Lo,4683,4683,4683},{4684,Lo,4684,4684,4684},{4685,Lo,4685,4685,4685},{4688,Lo,4688,4688,4688},{4689,Lo,4689,4689,4689},{4690,Lo,4690,4690,4690},{4691,Lo,4691,4691,4691},{4692,Lo,4692,4692,4692},{4693,Lo,4693,4693,4693},{4694,Lo,4694,4694,4694},{4696,Lo,4696,4696,4696},{4698,Lo,4698,4698,4698},{4699,Lo,4699,4699,4699},{4700,Lo,4700,4700,4700},{4701,Lo,4701,4701,4701},{4704,Lo,4704,4704,4704},{4705,Lo,4705,4705,4705},{4706,Lo,4706,4706,4706},{4707,Lo,4707,4707,4707},{4708,Lo,4708,4708,4708},{4709,Lo,4709,4709,4709},{4710,Lo,4710,4710,4710},{4711,Lo,4711,4711,4711},{4712,Lo,4712,4712,4712},{4713,Lo,4713,4713,4713},{4714,Lo,4714,4714,4714},{4715,Lo,4715,4715,4715},{4716,Lo,4716,4716,4716},{4717,Lo,4717,4717,4717},{4718,Lo,4718,4718,4718},{4719,Lo,4719,4719,4719},{4720,Lo,4720,4720,4720},{4721,Lo,4721,4721,4721},{4722,Lo,4722,4722,4722},{4723,Lo,4723,4723,4723},{4724,Lo,4724,4724,4724},{4725,Lo,4725,4725,4725},{4726,Lo,4726,4726,4726},{4727,Lo,4727,4727,4727},{4728,Lo,4728,4728,4728},{4729,Lo,4729,4729,4729},{4730,Lo,4730,4730,4730},{4731,Lo,4731,4731,4731},{4732,Lo,4732,4732,4732},{4733,Lo,4733,4733,4733},{4734,Lo,4734,4734,4734},{4735,Lo,4735,4735,4735},{4736,Lo,4736,4736,4736},{4737,Lo,4737,4737,4737},{4738,Lo,4738,4738,4738},{4739,Lo,4739,4739,4739},{4740,Lo,4740,4740,4740},{4741,Lo,4741,4741,4741},{4742,Lo,4742,4742,4742},{4743,Lo,4743,4743,4743},{4744,Lo,4744,4744,4744},{4746,Lo,4746,4746,4746},{4747,Lo,4747,4747,4747},{4748,Lo,4748,4748,4748},{4749,Lo,4749,4749,4749},{4752,Lo,4752,4752,4752},{4753,Lo,4753,4753,4753},{4754,Lo,4754,4754,4754},{4755,Lo,4755,4755,4755},{4756,Lo,4756,4756,4756},{4757,Lo,4757,4757,4757},{4758,Lo,4758,4758,4758},{4759,Lo,4759,4759,4759},{4760,Lo,4760,4760,4760},{4761,Lo,4761,4761,4761},{4762,Lo,4762,4762,4762},{4763,Lo,4763,4763,4763},{4764,Lo,4764,4764,4764},{4765,Lo,4765,4765,4765},{4766,Lo,4766,4766,4766},{4767,Lo,4767,4767,4767},{4768,Lo,4768,4768,4768},{4769,Lo,4769,4769,4769},{4770,Lo,4770,4770,4770},{4771,Lo,4771,4771,4771},{4772,Lo,4772,4772,4772},{4773,Lo,4773,4773,4773},{4774,Lo,4774,4774,4774},{4775,Lo,4775,4775,4775},{4776,Lo,4776,4776,4776},{4777,Lo,4777,4777,4777},{4778,Lo,4778,4778,4778},{4779,Lo,4779,4779,4779},{4780,Lo,4780,4780,4780},{4781,Lo,4781,4781,4781},{4782,Lo,4782,4782,4782},{4783,Lo,4783,4783,4783},{4784,Lo,4784,4784,4784},{4786,Lo,4786,4786,4786},{4787,Lo,4787,4787,4787},{4788,Lo,4788,4788,4788},{4789,Lo,4789,4789,4789},{4792,Lo,4792,4792,4792},{4793,Lo,4793,4793,4793},{4794,Lo,4794,4794,4794},{4795,Lo,4795,4795,4795},{4796,Lo,4796,4796,4796},{4797,Lo,4797,4797,4797},{4798,Lo,4798,4798,4798},{4800,Lo,4800,4800,4800},{4802,Lo,4802,4802,4802},{4803,Lo,4803,4803,4803},{4804,Lo,4804,4804,4804},{4805,Lo,4805,4805,4805},{4808,Lo,4808,4808,4808},{4809,Lo,4809,4809,4809},{4810,Lo,4810,4810,4810},{4811,Lo,4811,4811,4811},{4812,Lo,4812,4812,4812},{4813,Lo,4813,4813,4813},{4814,Lo,4814,4814,4814},{4815,Lo,4815,4815,4815},{4816,Lo,4816,4816,4816},{4817,Lo,4817,4817,4817},{4818,Lo,4818,4818,4818},{4819,Lo,4819,4819,4819},{4820,Lo,4820,4820,4820},{4821,Lo,4821,4821,4821},{4822,Lo,4822,4822,4822},{4824,Lo,4824,4824,4824},{4825,Lo,4825,4825,4825},{4826,Lo,4826,4826,4826},{4827,Lo,4827,4827,4827},{4828,Lo,4828,4828,4828},{4829,Lo,4829,4829,4829},{4830,Lo,4830,4830,4830},{4831,Lo,4831,4831,4831},{4832,Lo,4832,4832,4832},{4833,Lo,4833,4833,4833},{4834,Lo,4834,4834,4834},{4835,Lo,4835,4835,4835},{4836,Lo,4836,4836,4836},{4837,Lo,4837,4837,4837},{4838,Lo,4838,4838,4838},{4839,Lo,4839,4839,4839},{4840,Lo,4840,4840,4840},{4841,Lo,4841,4841,4841},{4842,Lo,4842,4842,4842},{4843,Lo,4843,4843,4843},{4844,Lo,4844,4844,4844},{4845,Lo,4845,4845,4845},{4846,Lo,4846,4846,4846},{4847,Lo,4847,4847,4847},{4848,Lo,4848,4848,4848},{4849,Lo,4849,4849,4849},{4850,Lo,4850,4850,4850},{4851,Lo,4851,4851,4851},{4852,Lo,4852,4852,4852},{4853,Lo,4853,4853,4853},{4854,Lo,4854,4854,4854},{4855,Lo,4855,4855,4855},{4856,Lo,4856,4856,4856},{4857,Lo,4857,4857,4857},{4858,Lo,4858,4858,4858},{4859,Lo,4859,4859,4859},{4860,Lo,4860,4860,4860},{4861,Lo,4861,4861,4861},{4862,Lo,4862,4862,4862},{4863,Lo,4863,4863,4863},{4864,Lo,4864,4864,4864},{4865,Lo,4865,4865,4865},{4866,Lo,4866,4866,4866},{4867,Lo,4867,4867,4867},{4868,Lo,4868,4868,4868},{4869,Lo,4869,4869,4869},{4870,Lo,4870,4870,4870},{4871,Lo,4871,4871,4871},{4872,Lo,4872,4872,4872},{4873,Lo,4873,4873,4873},{4874,Lo,4874,4874,4874},{4875,Lo,4875,4875,4875},{4876,Lo,4876,4876,4876},{4877,Lo,4877,4877,4877},{4878,Lo,4878,4878,4878},{4879,Lo,4879,4879,4879},{4880,Lo,4880,4880,4880},{4882,Lo,4882,4882,4882},{4883,Lo,4883,4883,4883},{4884,Lo,4884,4884,4884},{4885,Lo,4885,4885,4885},{4888,Lo,4888,4888,4888},{4889,Lo,4889,4889,4889},{4890,Lo,4890,4890,4890},{4891,Lo,4891,4891,4891},{4892,Lo,4892,4892,4892},{4893,Lo,4893,4893,4893},{4894,Lo,4894,4894,4894},{4895,Lo,4895,4895,4895},{4896,Lo,4896,4896,4896},{4897,Lo,4897,4897,4897},{4898,Lo,4898,4898,4898},{4899,Lo,4899,4899,4899},{4900,Lo,4900,4900,4900},{4901,Lo,4901,4901,4901},{4902,Lo,4902,4902,4902},{4903,Lo,4903,4903,4903},{4904,Lo,4904,4904,4904},{4905,Lo,4905,4905,4905},{4906,Lo,4906,4906,4906},{4907,Lo,4907,4907,4907},{4908,Lo,4908,4908,4908},{4909,Lo,4909,4909,4909},{4910,Lo,4910,4910,4910},{4911,Lo,4911,4911,4911},{4912,Lo,4912,4912,4912},{4913,Lo,4913,4913,4913},{4914,Lo,4914,4914,4914},{4915,Lo,4915,4915,4915},{4916,Lo,4916,4916,4916},{4917,Lo,4917,4917,4917},{4918,Lo,4918,4918,4918},{4919,Lo,4919,4919,4919},{4920,Lo,4920,4920,4920},{4921,Lo,4921,4921,4921},{4922,Lo,4922,4922,4922},{4923,Lo,4923,4923,4923},{4924,Lo,4924,4924,4924},{4925,Lo,4925,4925,4925},{4926,Lo,4926,4926,4926},{4927,Lo,4927,4927,4927},{4928,Lo,4928,4928,4928},{4929,Lo,4929,4929,4929},{4930,Lo,4930,4930,4930},{4931,Lo,4931,4931,4931},{4932,Lo,4932,4932,4932},{4933,Lo,4933,4933,4933},{4934,Lo,4934,4934,4934},{4935,Lo,4935,4935,4935},{4936,Lo,4936,4936,4936},{4937,Lo,4937,4937,4937},{4938,Lo,4938,4938,4938},{4939,Lo,4939,4939,4939},{4940,Lo,4940,4940,4940},{4941,Lo,4941,4941,4941},{4942,Lo,4942,4942,4942},{4943,Lo,4943,4943,4943},{4944,Lo,4944,4944,4944},{4945,Lo,4945,4945,4945},{4946,Lo,4946,4946,4946},{4947,Lo,4947,4947,4947},{4948,Lo,4948,4948,4948},{4949,Lo,4949,4949,4949},{4950,Lo,4950,4950,4950},{4951,Lo,4951,4951,4951},{4952,Lo,4952,4952,4952},{4953,Lo,4953,4953,4953},{4954,Lo,4954,4954,4954},{4959,Mn,4959,4959,4959},{4960,So,4960,4960,4960},{4961,Po,4961,4961,4961},{4962,Po,4962,4962,4962},{4963,Po,4963,4963,4963},{4964,Po,4964,4964,4964},{4965,Po,4965,4965,4965},{4966,Po,4966,4966,4966},{4967,Po,4967,4967,4967},{4968,Po,4968,4968,4968},{4969,No,4969,4969,4969},{4970,No,4970,4970,4970},{4971,No,4971,4971,4971},{4972,No,4972,4972,4972},{4973,No,4973,4973,4973},{4974,No,4974,4974,4974},{4975,No,4975,4975,4975},{4976,No,4976,4976,4976},{4977,No,4977,4977,4977},{4978,No,4978,4978,4978},{4979,No,4979,4979,4979},{4980,No,4980,4980,4980},{4981,No,4981,4981,4981},{4982,No,4982,4982,4982},{4983,No,4983,4983,4983},{4984,No,4984,4984,4984},{4985,No,4985,4985,4985},{4986,No,4986,4986,4986},{4987,No,4987,4987,4987},{4988,No,4988,4988,4988},{4992,Lo,4992,4992,4992},{4993,Lo,4993,4993,4993},{4994,Lo,4994,4994,4994},{4995,Lo,4995,4995,4995},{4996,Lo,4996,4996,4996},{4997,Lo,4997,4997,4997},{4998,Lo,4998,4998,4998},{4999,Lo,4999,4999,4999},{5000,Lo,5000,5000,5000},{5001,Lo,5001,5001,5001},{5002,Lo,5002,5002,5002},{5003,Lo,5003,5003,5003},{5004,Lo,5004,5004,5004},{5005,Lo,5005,5005,5005},{5006,Lo,5006,5006,5006},{5007,Lo,5007,5007,5007},{5008,So,5008,5008,5008},{5009,So,5009,5009,5009},{5010,So,5010,5010,5010},{5011,So,5011,5011,5011},{5012,So,5012,5012,5012},{5013,So,5013,5013,5013},{5014,So,5014,5014,5014},{5015,So,5015,5015,5015},{5016,So,5016,5016,5016},{5017,So,5017,5017,5017},{5024,Lo,5024,5024,5024},{5025,Lo,5025,5025,5025},{5026,Lo,5026,5026,5026},{5027,Lo,5027,5027,5027},{5028,Lo,5028,5028,5028},{5029,Lo,5029,5029,5029},{5030,Lo,5030,5030,5030},{5031,Lo,5031,5031,5031},{5032,Lo,5032,5032,5032},{5033,Lo,5033,5033,5033},{5034,Lo,5034,5034,5034},{5035,Lo,5035,5035,5035},{5036,Lo,5036,5036,5036},{5037,Lo,5037,5037,5037},{5038,Lo,5038,5038,5038},{5039,Lo,5039,5039,5039},{5040,Lo,5040,5040,5040},{5041,Lo,5041,5041,5041},{5042,Lo,5042,5042,5042},{5043,Lo,5043,5043,5043},{5044,Lo,5044,5044,5044},{5045,Lo,5045,5045,5045},{5046,Lo,5046,5046,5046},{5047,Lo,5047,5047,5047},{5048,Lo,5048,5048,5048},{5049,Lo,5049,5049,5049},{5050,Lo,5050,5050,5050},{5051,Lo,5051,5051,5051},{5052,Lo,5052,5052,5052},{5053,Lo,5053,5053,5053},{5054,Lo,5054,5054,5054},{5055,Lo,5055,5055,5055},{5056,Lo,5056,5056,5056},{5057,Lo,5057,5057,5057},{5058,Lo,5058,5058,5058},{5059,Lo,5059,5059,5059},{5060,Lo,5060,5060,5060},{5061,Lo,5061,5061,5061},{5062,Lo,5062,5062,5062},{5063,Lo,5063,5063,5063},{5064,Lo,5064,5064,5064},{5065,Lo,5065,5065,5065},{5066,Lo,5066,5066,5066},{5067,Lo,5067,5067,5067},{5068,Lo,5068,5068,5068},{5069,Lo,5069,5069,5069},{5070,Lo,5070,5070,5070},{5071,Lo,5071,5071,5071},{5072,Lo,5072,5072,5072},{5073,Lo,5073,5073,5073},{5074,Lo,5074,5074,5074},{5075,Lo,5075,5075,5075},{5076,Lo,5076,5076,5076},{5077,Lo,5077,5077,5077},{5078,Lo,5078,5078,5078},{5079,Lo,5079,5079,5079},{5080,Lo,5080,5080,5080},{5081,Lo,5081,5081,5081},{5082,Lo,5082,5082,5082},{5083,Lo,5083,5083,5083},{5084,Lo,5084,5084,5084},{5085,Lo,5085,5085,5085},{5086,Lo,5086,5086,5086},{5087,Lo,5087,5087,5087},{5088,Lo,5088,5088,5088},{5089,Lo,5089,5089,5089},{5090,Lo,5090,5090,5090},{5091,Lo,5091,5091,5091},{5092,Lo,5092,5092,5092},{5093,Lo,5093,5093,5093},{5094,Lo,5094,5094,5094},{5095,Lo,5095,5095,5095},{5096,Lo,5096,5096,5096},{5097,Lo,5097,5097,5097},{5098,Lo,5098,5098,5098},{5099,Lo,5099,5099,5099},{5100,Lo,5100,5100,5100},{5101,Lo,5101,5101,5101},{5102,Lo,5102,5102,5102},{5103,Lo,5103,5103,5103},{5104,Lo,5104,5104,5104},{5105,Lo,5105,5105,5105},{5106,Lo,5106,5106,5106},{5107,Lo,5107,5107,5107},{5108,Lo,5108,5108,5108},{5121,Lo,5121,5121,5121},{5122,Lo,5122,5122,5122},{5123,Lo,5123,5123,5123},{5124,Lo,5124,5124,5124},{5125,Lo,5125,5125,5125},{5126,Lo,5126,5126,5126},{5127,Lo,5127,5127,5127},{5128,Lo,5128,5128,5128},{5129,Lo,5129,5129,5129},{5130,Lo,5130,5130,5130},{5131,Lo,5131,5131,5131},{5132,Lo,5132,5132,5132},{5133,Lo,5133,5133,5133},{5134,Lo,5134,5134,5134},{5135,Lo,5135,5135,5135},{5136,Lo,5136,5136,5136},{5137,Lo,5137,5137,5137},{5138,Lo,5138,5138,5138},{5139,Lo,5139,5139,5139},{5140,Lo,5140,5140,5140},{5141,Lo,5141,5141,5141},{5142,Lo,5142,5142,5142},{5143,Lo,5143,5143,5143},{5144,Lo,5144,5144,5144},{5145,Lo,5145,5145,5145},{5146,Lo,5146,5146,5146},{5147,Lo,5147,5147,5147},{5148,Lo,5148,5148,5148},{5149,Lo,5149,5149,5149},{5150,Lo,5150,5150,5150},{5151,Lo,5151,5151,5151},{5152,Lo,5152,5152,5152},{5153,Lo,5153,5153,5153},{5154,Lo,5154,5154,5154},{5155,Lo,5155,5155,5155},{5156,Lo,5156,5156,5156},{5157,Lo,5157,5157,5157},{5158,Lo,5158,5158,5158},{5159,Lo,5159,5159,5159},{5160,Lo,5160,5160,5160},{5161,Lo,5161,5161,5161},{5162,Lo,5162,5162,5162},{5163,Lo,5163,5163,5163},{5164,Lo,5164,5164,5164},{5165,Lo,5165,5165,5165},{5166,Lo,5166,5166,5166},{5167,Lo,5167,5167,5167},{5168,Lo,5168,5168,5168},{5169,Lo,5169,5169,5169},{5170,Lo,5170,5170,5170},{5171,Lo,5171,5171,5171},{5172,Lo,5172,5172,5172},{5173,Lo,5173,5173,5173},{5174,Lo,5174,5174,5174},{5175,Lo,5175,5175,5175},{5176,Lo,5176,5176,5176},{5177,Lo,5177,5177,5177},{5178,Lo,5178,5178,5178},{5179,Lo,5179,5179,5179},{5180,Lo,5180,5180,5180},{5181,Lo,5181,5181,5181},{5182,Lo,5182,5182,5182},{5183,Lo,5183,5183,5183},{5184,Lo,5184,5184,5184},{5185,Lo,5185,5185,5185},{5186,Lo,5186,5186,5186},{5187,Lo,5187,5187,5187},{5188,Lo,5188,5188,5188},{5189,Lo,5189,5189,5189},{5190,Lo,5190,5190,5190},{5191,Lo,5191,5191,5191},{5192,Lo,5192,5192,5192},{5193,Lo,5193,5193,5193},{5194,Lo,5194,5194,5194},{5195,Lo,5195,5195,5195},{5196,Lo,5196,5196,5196},{5197,Lo,5197,5197,5197},{5198,Lo,5198,5198,5198},{5199,Lo,5199,5199,5199},{5200,Lo,5200,5200,5200},{5201,Lo,5201,5201,5201},{5202,Lo,5202,5202,5202},{5203,Lo,5203,5203,5203},{5204,Lo,5204,5204,5204},{5205,Lo,5205,5205,5205},{5206,Lo,5206,5206,5206},{5207,Lo,5207,5207,5207},{5208,Lo,5208,5208,5208},{5209,Lo,5209,5209,5209},{5210,Lo,5210,5210,5210},{5211,Lo,5211,5211,5211},{5212,Lo,5212,5212,5212},{5213,Lo,5213,5213,5213},{5214,Lo,5214,5214,5214},{5215,Lo,5215,5215,5215},{5216,Lo,5216,5216,5216},{5217,Lo,5217,5217,5217},{5218,Lo,5218,5218,5218},{5219,Lo,5219,5219,5219},{5220,Lo,5220,5220,5220},{5221,Lo,5221,5221,5221},{5222,Lo,5222,5222,5222},{5223,Lo,5223,5223,5223},{5224,Lo,5224,5224,5224},{5225,Lo,5225,5225,5225},{5226,Lo,5226,5226,5226},{5227,Lo,5227,5227,5227},{5228,Lo,5228,5228,5228},{5229,Lo,5229,5229,5229},{5230,Lo,5230,5230,5230},{5231,Lo,5231,5231,5231},{5232,Lo,5232,5232,5232},{5233,Lo,5233,5233,5233},{5234,Lo,5234,5234,5234},{5235,Lo,5235,5235,5235},{5236,Lo,5236,5236,5236},{5237,Lo,5237,5237,5237},{5238,Lo,5238,5238,5238},{5239,Lo,5239,5239,5239},{5240,Lo,5240,5240,5240},{5241,Lo,5241,5241,5241},{5242,Lo,5242,5242,5242},{5243,Lo,5243,5243,5243},{5244,Lo,5244,5244,5244},{5245,Lo,5245,5245,5245},{5246,Lo,5246,5246,5246},{5247,Lo,5247,5247,5247},{5248,Lo,5248,5248,5248},{5249,Lo,5249,5249,5249},{5250,Lo,5250,5250,5250},{5251,Lo,5251,5251,5251},{5252,Lo,5252,5252,5252},{5253,Lo,5253,5253,5253},{5254,Lo,5254,5254,5254},{5255,Lo,5255,5255,5255},{5256,Lo,5256,5256,5256},{5257,Lo,5257,5257,5257},{5258,Lo,5258,5258,5258},{5259,Lo,5259,5259,5259},{5260,Lo,5260,5260,5260},{5261,Lo,5261,5261,5261},{5262,Lo,5262,5262,5262},{5263,Lo,5263,5263,5263},{5264,Lo,5264,5264,5264},{5265,Lo,5265,5265,5265},{5266,Lo,5266,5266,5266},{5267,Lo,5267,5267,5267},{5268,Lo,5268,5268,5268},{5269,Lo,5269,5269,5269},{5270,Lo,5270,5270,5270},{5271,Lo,5271,5271,5271},{5272,Lo,5272,5272,5272},{5273,Lo,5273,5273,5273},{5274,Lo,5274,5274,5274},{5275,Lo,5275,5275,5275},{5276,Lo,5276,5276,5276},{5277,Lo,5277,5277,5277},{5278,Lo,5278,5278,5278},{5279,Lo,5279,5279,5279},{5280,Lo,5280,5280,5280},{5281,Lo,5281,5281,5281},{5282,Lo,5282,5282,5282},{5283,Lo,5283,5283,5283},{5284,Lo,5284,5284,5284},{5285,Lo,5285,5285,5285},{5286,Lo,5286,5286,5286},{5287,Lo,5287,5287,5287},{5288,Lo,5288,5288,5288},{5289,Lo,5289,5289,5289},{5290,Lo,5290,5290,5290},{5291,Lo,5291,5291,5291},{5292,Lo,5292,5292,5292},{5293,Lo,5293,5293,5293},{5294,Lo,5294,5294,5294},{5295,Lo,5295,5295,5295},{5296,Lo,5296,5296,5296},{5297,Lo,5297,5297,5297},{5298,Lo,5298,5298,5298},{5299,Lo,5299,5299,5299},{5300,Lo,5300,5300,5300},{5301,Lo,5301,5301,5301},{5302,Lo,5302,5302,5302},{5303,Lo,5303,5303,5303},{5304,Lo,5304,5304,5304},{5305,Lo,5305,5305,5305},{5306,Lo,5306,5306,5306},{5307,Lo,5307,5307,5307},{5308,Lo,5308,5308,5308},{5309,Lo,5309,5309,5309},{5310,Lo,5310,5310,5310},{5311,Lo,5311,5311,5311},{5312,Lo,5312,5312,5312},{5313,Lo,5313,5313,5313},{5314,Lo,5314,5314,5314},{5315,Lo,5315,5315,5315},{5316,Lo,5316,5316,5316},{5317,Lo,5317,5317,5317},{5318,Lo,5318,5318,5318},{5319,Lo,5319,5319,5319},{5320,Lo,5320,5320,5320},{5321,Lo,5321,5321,5321},{5322,Lo,5322,5322,5322},{5323,Lo,5323,5323,5323},{5324,Lo,5324,5324,5324},{5325,Lo,5325,5325,5325},{5326,Lo,5326,5326,5326},{5327,Lo,5327,5327,5327},{5328,Lo,5328,5328,5328},{5329,Lo,5329,5329,5329},{5330,Lo,5330,5330,5330},{5331,Lo,5331,5331,5331},{5332,Lo,5332,5332,5332},{5333,Lo,5333,5333,5333},{5334,Lo,5334,5334,5334},{5335,Lo,5335,5335,5335},{5336,Lo,5336,5336,5336},{5337,Lo,5337,5337,5337},{5338,Lo,5338,5338,5338},{5339,Lo,5339,5339,5339},{5340,Lo,5340,5340,5340},{5341,Lo,5341,5341,5341},{5342,Lo,5342,5342,5342},{5343,Lo,5343,5343,5343},{5344,Lo,5344,5344,5344},{5345,Lo,5345,5345,5345},{5346,Lo,5346,5346,5346},{5347,Lo,5347,5347,5347},{5348,Lo,5348,5348,5348},{5349,Lo,5349,5349,5349},{5350,Lo,5350,5350,5350},{5351,Lo,5351,5351,5351},{5352,Lo,5352,5352,5352},{5353,Lo,5353,5353,5353},{5354,Lo,5354,5354,5354},{5355,Lo,5355,5355,5355},{5356,Lo,5356,5356,5356},{5357,Lo,5357,5357,5357},{5358,Lo,5358,5358,5358},{5359,Lo,5359,5359,5359},{5360,Lo,5360,5360,5360},{5361,Lo,5361,5361,5361},{5362,Lo,5362,5362,5362},{5363,Lo,5363,5363,5363},{5364,Lo,5364,5364,5364},{5365,Lo,5365,5365,5365},{5366,Lo,5366,5366,5366},{5367,Lo,5367,5367,5367},{5368,Lo,5368,5368,5368},{5369,Lo,5369,5369,5369},{5370,Lo,5370,5370,5370},{5371,Lo,5371,5371,5371},{5372,Lo,5372,5372,5372},{5373,Lo,5373,5373,5373},{5374,Lo,5374,5374,5374},{5375,Lo,5375,5375,5375},{5376,Lo,5376,5376,5376},{5377,Lo,5377,5377,5377},{5378,Lo,5378,5378,5378},{5379,Lo,5379,5379,5379},{5380,Lo,5380,5380,5380},{5381,Lo,5381,5381,5381},{5382,Lo,5382,5382,5382},{5383,Lo,5383,5383,5383},{5384,Lo,5384,5384,5384},{5385,Lo,5385,5385,5385},{5386,Lo,5386,5386,5386},{5387,Lo,5387,5387,5387},{5388,Lo,5388,5388,5388},{5389,Lo,5389,5389,5389},{5390,Lo,5390,5390,5390},{5391,Lo,5391,5391,5391},{5392,Lo,5392,5392,5392},{5393,Lo,5393,5393,5393},{5394,Lo,5394,5394,5394},{5395,Lo,5395,5395,5395},{5396,Lo,5396,5396,5396},{5397,Lo,5397,5397,5397},{5398,Lo,5398,5398,5398},{5399,Lo,5399,5399,5399},{5400,Lo,5400,5400,5400},{5401,Lo,5401,5401,5401},{5402,Lo,5402,5402,5402},{5403,Lo,5403,5403,5403},{5404,Lo,5404,5404,5404},{5405,Lo,5405,5405,5405},{5406,Lo,5406,5406,5406},{5407,Lo,5407,5407,5407},{5408,Lo,5408,5408,5408},{5409,Lo,5409,5409,5409},{5410,Lo,5410,5410,5410},{5411,Lo,5411,5411,5411},{5412,Lo,5412,5412,5412},{5413,Lo,5413,5413,5413},{5414,Lo,5414,5414,5414},{5415,Lo,5415,5415,5415},{5416,Lo,5416,5416,5416},{5417,Lo,5417,5417,5417},{5418,Lo,5418,5418,5418},{5419,Lo,5419,5419,5419},{5420,Lo,5420,5420,5420},{5421,Lo,5421,5421,5421},{5422,Lo,5422,5422,5422},{5423,Lo,5423,5423,5423},{5424,Lo,5424,5424,5424},{5425,Lo,5425,5425,5425},{5426,Lo,5426,5426,5426},{5427,Lo,5427,5427,5427},{5428,Lo,5428,5428,5428},{5429,Lo,5429,5429,5429},{5430,Lo,5430,5430,5430},{5431,Lo,5431,5431,5431},{5432,Lo,5432,5432,5432},{5433,Lo,5433,5433,5433},{5434,Lo,5434,5434,5434},{5435,Lo,5435,5435,5435},{5436,Lo,5436,5436,5436},{5437,Lo,5437,5437,5437},{5438,Lo,5438,5438,5438},{5439,Lo,5439,5439,5439},{5440,Lo,5440,5440,5440},{5441,Lo,5441,5441,5441},{5442,Lo,5442,5442,5442},{5443,Lo,5443,5443,5443},{5444,Lo,5444,5444,5444},{5445,Lo,5445,5445,5445},{5446,Lo,5446,5446,5446},{5447,Lo,5447,5447,5447},{5448,Lo,5448,5448,5448},{5449,Lo,5449,5449,5449},{5450,Lo,5450,5450,5450},{5451,Lo,5451,5451,5451},{5452,Lo,5452,5452,5452},{5453,Lo,5453,5453,5453},{5454,Lo,5454,5454,5454},{5455,Lo,5455,5455,5455},{5456,Lo,5456,5456,5456},{5457,Lo,5457,5457,5457},{5458,Lo,5458,5458,5458},{5459,Lo,5459,5459,5459},{5460,Lo,5460,5460,5460},{5461,Lo,5461,5461,5461},{5462,Lo,5462,5462,5462},{5463,Lo,5463,5463,5463},{5464,Lo,5464,5464,5464},{5465,Lo,5465,5465,5465},{5466,Lo,5466,5466,5466},{5467,Lo,5467,5467,5467},{5468,Lo,5468,5468,5468},{5469,Lo,5469,5469,5469},{5470,Lo,5470,5470,5470},{5471,Lo,5471,5471,5471},{5472,Lo,5472,5472,5472},{5473,Lo,5473,5473,5473},{5474,Lo,5474,5474,5474},{5475,Lo,5475,5475,5475},{5476,Lo,5476,5476,5476},{5477,Lo,5477,5477,5477},{5478,Lo,5478,5478,5478},{5479,Lo,5479,5479,5479},{5480,Lo,5480,5480,5480},{5481,Lo,5481,5481,5481},{5482,Lo,5482,5482,5482},{5483,Lo,5483,5483,5483},{5484,Lo,5484,5484,5484},{5485,Lo,5485,5485,5485},{5486,Lo,5486,5486,5486},{5487,Lo,5487,5487,5487},{5488,Lo,5488,5488,5488},{5489,Lo,5489,5489,5489},{5490,Lo,5490,5490,5490},{5491,Lo,5491,5491,5491},{5492,Lo,5492,5492,5492},{5493,Lo,5493,5493,5493},{5494,Lo,5494,5494,5494},{5495,Lo,5495,5495,5495},{5496,Lo,5496,5496,5496},{5497,Lo,5497,5497,5497},{5498,Lo,5498,5498,5498},{5499,Lo,5499,5499,5499},{5500,Lo,5500,5500,5500},{5501,Lo,5501,5501,5501},{5502,Lo,5502,5502,5502},{5503,Lo,5503,5503,5503},{5504,Lo,5504,5504,5504},{5505,Lo,5505,5505,5505},{5506,Lo,5506,5506,5506},{5507,Lo,5507,5507,5507},{5508,Lo,5508,5508,5508},{5509,Lo,5509,5509,5509},{5510,Lo,5510,5510,5510},{5511,Lo,5511,5511,5511},{5512,Lo,5512,5512,5512},{5513,Lo,5513,5513,5513},{5514,Lo,5514,5514,5514},{5515,Lo,5515,5515,5515},{5516,Lo,5516,5516,5516},{5517,Lo,5517,5517,5517},{5518,Lo,5518,5518,5518},{5519,Lo,5519,5519,5519},{5520,Lo,5520,5520,5520},{5521,Lo,5521,5521,5521},{5522,Lo,5522,5522,5522},{5523,Lo,5523,5523,5523},{5524,Lo,5524,5524,5524},{5525,Lo,5525,5525,5525},{5526,Lo,5526,5526,5526},{5527,Lo,5527,5527,5527},{5528,Lo,5528,5528,5528},{5529,Lo,5529,5529,5529},{5530,Lo,5530,5530,5530},{5531,Lo,5531,5531,5531},{5532,Lo,5532,5532,5532},{5533,Lo,5533,5533,5533},{5534,Lo,5534,5534,5534},{5535,Lo,5535,5535,5535},{5536,Lo,5536,5536,5536},{5537,Lo,5537,5537,5537},{5538,Lo,5538,5538,5538},{5539,Lo,5539,5539,5539},{5540,Lo,5540,5540,5540},{5541,Lo,5541,5541,5541},{5542,Lo,5542,5542,5542},{5543,Lo,5543,5543,5543},{5544,Lo,5544,5544,5544},{5545,Lo,5545,5545,5545},{5546,Lo,5546,5546,5546},{5547,Lo,5547,5547,5547},{5548,Lo,5548,5548,5548},{5549,Lo,5549,5549,5549},{5550,Lo,5550,5550,5550},{5551,Lo,5551,5551,5551},{5552,Lo,5552,5552,5552},{5553,Lo,5553,5553,5553},{5554,Lo,5554,5554,5554},{5555,Lo,5555,5555,5555},{5556,Lo,5556,5556,5556},{5557,Lo,5557,5557,5557},{5558,Lo,5558,5558,5558},{5559,Lo,5559,5559,5559},{5560,Lo,5560,5560,5560},{5561,Lo,5561,5561,5561},{5562,Lo,5562,5562,5562},{5563,Lo,5563,5563,5563},{5564,Lo,5564,5564,5564},{5565,Lo,5565,5565,5565},{5566,Lo,5566,5566,5566},{5567,Lo,5567,5567,5567},{5568,Lo,5568,5568,5568},{5569,Lo,5569,5569,5569},{5570,Lo,5570,5570,5570},{5571,Lo,5571,5571,5571},{5572,Lo,5572,5572,5572},{5573,Lo,5573,5573,5573},{5574,Lo,5574,5574,5574},{5575,Lo,5575,5575,5575},{5576,Lo,5576,5576,5576},{5577,Lo,5577,5577,5577},{5578,Lo,5578,5578,5578},{5579,Lo,5579,5579,5579},{5580,Lo,5580,5580,5580},{5581,Lo,5581,5581,5581},{5582,Lo,5582,5582,5582},{5583,Lo,5583,5583,5583},{5584,Lo,5584,5584,5584},{5585,Lo,5585,5585,5585},{5586,Lo,5586,5586,5586},{5587,Lo,5587,5587,5587},{5588,Lo,5588,5588,5588},{5589,Lo,5589,5589,5589},{5590,Lo,5590,5590,5590},{5591,Lo,5591,5591,5591},{5592,Lo,5592,5592,5592},{5593,Lo,5593,5593,5593},{5594,Lo,5594,5594,5594},{5595,Lo,5595,5595,5595},{5596,Lo,5596,5596,5596},{5597,Lo,5597,5597,5597},{5598,Lo,5598,5598,5598},{5599,Lo,5599,5599,5599},{5600,Lo,5600,5600,5600},{5601,Lo,5601,5601,5601},{5602,Lo,5602,5602,5602},{5603,Lo,5603,5603,5603},{5604,Lo,5604,5604,5604},{5605,Lo,5605,5605,5605},{5606,Lo,5606,5606,5606},{5607,Lo,5607,5607,5607},{5608,Lo,5608,5608,5608},{5609,Lo,5609,5609,5609},{5610,Lo,5610,5610,5610},{5611,Lo,5611,5611,5611},{5612,Lo,5612,5612,5612},{5613,Lo,5613,5613,5613},{5614,Lo,5614,5614,5614},{5615,Lo,5615,5615,5615},{5616,Lo,5616,5616,5616},{5617,Lo,5617,5617,5617},{5618,Lo,5618,5618,5618},{5619,Lo,5619,5619,5619},{5620,Lo,5620,5620,5620},{5621,Lo,5621,5621,5621},{5622,Lo,5622,5622,5622},{5623,Lo,5623,5623,5623},{5624,Lo,5624,5624,5624},{5625,Lo,5625,5625,5625},{5626,Lo,5626,5626,5626},{5627,Lo,5627,5627,5627},{5628,Lo,5628,5628,5628},{5629,Lo,5629,5629,5629},{5630,Lo,5630,5630,5630},{5631,Lo,5631,5631,5631},{5632,Lo,5632,5632,5632},{5633,Lo,5633,5633,5633},{5634,Lo,5634,5634,5634},{5635,Lo,5635,5635,5635},{5636,Lo,5636,5636,5636},{5637,Lo,5637,5637,5637},{5638,Lo,5638,5638,5638},{5639,Lo,5639,5639,5639},{5640,Lo,5640,5640,5640},{5641,Lo,5641,5641,5641},{5642,Lo,5642,5642,5642},{5643,Lo,5643,5643,5643},{5644,Lo,5644,5644,5644},{5645,Lo,5645,5645,5645},{5646,Lo,5646,5646,5646},{5647,Lo,5647,5647,5647},{5648,Lo,5648,5648,5648},{5649,Lo,5649,5649,5649},{5650,Lo,5650,5650,5650},{5651,Lo,5651,5651,5651},{5652,Lo,5652,5652,5652},{5653,Lo,5653,5653,5653},{5654,Lo,5654,5654,5654},{5655,Lo,5655,5655,5655},{5656,Lo,5656,5656,5656},{5657,Lo,5657,5657,5657},{5658,Lo,5658,5658,5658},{5659,Lo,5659,5659,5659},{5660,Lo,5660,5660,5660},{5661,Lo,5661,5661,5661},{5662,Lo,5662,5662,5662},{5663,Lo,5663,5663,5663},{5664,Lo,5664,5664,5664},{5665,Lo,5665,5665,5665},{5666,Lo,5666,5666,5666},{5667,Lo,5667,5667,5667},{5668,Lo,5668,5668,5668},{5669,Lo,5669,5669,5669},{5670,Lo,5670,5670,5670},{5671,Lo,5671,5671,5671},{5672,Lo,5672,5672,5672},{5673,Lo,5673,5673,5673},{5674,Lo,5674,5674,5674},{5675,Lo,5675,5675,5675},{5676,Lo,5676,5676,5676},{5677,Lo,5677,5677,5677},{5678,Lo,5678,5678,5678},{5679,Lo,5679,5679,5679},{5680,Lo,5680,5680,5680},{5681,Lo,5681,5681,5681},{5682,Lo,5682,5682,5682},{5683,Lo,5683,5683,5683},{5684,Lo,5684,5684,5684},{5685,Lo,5685,5685,5685},{5686,Lo,5686,5686,5686},{5687,Lo,5687,5687,5687},{5688,Lo,5688,5688,5688},{5689,Lo,5689,5689,5689},{5690,Lo,5690,5690,5690},{5691,Lo,5691,5691,5691},{5692,Lo,5692,5692,5692},{5693,Lo,5693,5693,5693},{5694,Lo,5694,5694,5694},{5695,Lo,5695,5695,5695},{5696,Lo,5696,5696,5696},{5697,Lo,5697,5697,5697},{5698,Lo,5698,5698,5698},{5699,Lo,5699,5699,5699},{5700,Lo,5700,5700,5700},{5701,Lo,5701,5701,5701},{5702,Lo,5702,5702,5702},{5703,Lo,5703,5703,5703},{5704,Lo,5704,5704,5704},{5705,Lo,5705,5705,5705},{5706,Lo,5706,5706,5706},{5707,Lo,5707,5707,5707},{5708,Lo,5708,5708,5708},{5709,Lo,5709,5709,5709},{5710,Lo,5710,5710,5710},{5711,Lo,5711,5711,5711},{5712,Lo,5712,5712,5712},{5713,Lo,5713,5713,5713},{5714,Lo,5714,5714,5714},{5715,Lo,5715,5715,5715},{5716,Lo,5716,5716,5716},{5717,Lo,5717,5717,5717},{5718,Lo,5718,5718,5718},{5719,Lo,5719,5719,5719},{5720,Lo,5720,5720,5720},{5721,Lo,5721,5721,5721},{5722,Lo,5722,5722,5722},{5723,Lo,5723,5723,5723},{5724,Lo,5724,5724,5724},{5725,Lo,5725,5725,5725},{5726,Lo,5726,5726,5726},{5727,Lo,5727,5727,5727},{5728,Lo,5728,5728,5728},{5729,Lo,5729,5729,5729},{5730,Lo,5730,5730,5730},{5731,Lo,5731,5731,5731},{5732,Lo,5732,5732,5732},{5733,Lo,5733,5733,5733},{5734,Lo,5734,5734,5734},{5735,Lo,5735,5735,5735},{5736,Lo,5736,5736,5736},{5737,Lo,5737,5737,5737},{5738,Lo,5738,5738,5738},{5739,Lo,5739,5739,5739},{5740,Lo,5740,5740,5740},{5741,Po,5741,5741,5741},{5742,Po,5742,5742,5742},{5743,Lo,5743,5743,5743},{5744,Lo,5744,5744,5744},{5745,Lo,5745,5745,5745},{5746,Lo,5746,5746,5746},{5747,Lo,5747,5747,5747},{5748,Lo,5748,5748,5748},{5749,Lo,5749,5749,5749},{5750,Lo,5750,5750,5750},{5760,Zs,5760,5760,5760},{5761,Lo,5761,5761,5761},{5762,Lo,5762,5762,5762},{5763,Lo,5763,5763,5763},{5764,Lo,5764,5764,5764},{5765,Lo,5765,5765,5765},{5766,Lo,5766,5766,5766},{5767,Lo,5767,5767,5767},{5768,Lo,5768,5768,5768},{5769,Lo,5769,5769,5769},{5770,Lo,5770,5770,5770},{5771,Lo,5771,5771,5771},{5772,Lo,5772,5772,5772},{5773,Lo,5773,5773,5773},{5774,Lo,5774,5774,5774},{5775,Lo,5775,5775,5775},{5776,Lo,5776,5776,5776},{5777,Lo,5777,5777,5777},{5778,Lo,5778,5778,5778},{5779,Lo,5779,5779,5779},{5780,Lo,5780,5780,5780},{5781,Lo,5781,5781,5781},{5782,Lo,5782,5782,5782},{5783,Lo,5783,5783,5783},{5784,Lo,5784,5784,5784},{5785,Lo,5785,5785,5785},{5786,Lo,5786,5786,5786},{5787,Ps,5787,5787,5787},{5788,Pe,5788,5788,5788},{5792,Lo,5792,5792,5792},{5793,Lo,5793,5793,5793},{5794,Lo,5794,5794,5794},{5795,Lo,5795,5795,5795},{5796,Lo,5796,5796,5796},{5797,Lo,5797,5797,5797},{5798,Lo,5798,5798,5798},{5799,Lo,5799,5799,5799},{5800,Lo,5800,5800,5800},{5801,Lo,5801,5801,5801},{5802,Lo,5802,5802,5802},{5803,Lo,5803,5803,5803},{5804,Lo,5804,5804,5804},{5805,Lo,5805,5805,5805},{5806,Lo,5806,5806,5806},{5807,Lo,5807,5807,5807},{5808,Lo,5808,5808,5808},{5809,Lo,5809,5809,5809},{5810,Lo,5810,5810,5810},{5811,Lo,5811,5811,5811},{5812,Lo,5812,5812,5812},{5813,Lo,5813,5813,5813},{5814,Lo,5814,5814,5814},{5815,Lo,5815,5815,5815},{5816,Lo,5816,5816,5816},{5817,Lo,5817,5817,5817},{5818,Lo,5818,5818,5818},{5819,Lo,5819,5819,5819},{5820,Lo,5820,5820,5820},{5821,Lo,5821,5821,5821},{5822,Lo,5822,5822,5822},{5823,Lo,5823,5823,5823},{5824,Lo,5824,5824,5824},{5825,Lo,5825,5825,5825},{5826,Lo,5826,5826,5826},{5827,Lo,5827,5827,5827},{5828,Lo,5828,5828,5828},{5829,Lo,5829,5829,5829},{5830,Lo,5830,5830,5830},{5831,Lo,5831,5831,5831},{5832,Lo,5832,5832,5832},{5833,Lo,5833,5833,5833},{5834,Lo,5834,5834,5834},{5835,Lo,5835,5835,5835},{5836,Lo,5836,5836,5836},{5837,Lo,5837,5837,5837},{5838,Lo,5838,5838,5838},{5839,Lo,5839,5839,5839},{5840,Lo,5840,5840,5840},{5841,Lo,5841,5841,5841},{5842,Lo,5842,5842,5842},{5843,Lo,5843,5843,5843},{5844,Lo,5844,5844,5844},{5845,Lo,5845,5845,5845},{5846,Lo,5846,5846,5846},{5847,Lo,5847,5847,5847},{5848,Lo,5848,5848,5848},{5849,Lo,5849,5849,5849},{5850,Lo,5850,5850,5850},{5851,Lo,5851,5851,5851},{5852,Lo,5852,5852,5852},{5853,Lo,5853,5853,5853},{5854,Lo,5854,5854,5854},{5855,Lo,5855,5855,5855},{5856,Lo,5856,5856,5856},{5857,Lo,5857,5857,5857},{5858,Lo,5858,5858,5858},{5859,Lo,5859,5859,5859},{5860,Lo,5860,5860,5860},{5861,Lo,5861,5861,5861},{5862,Lo,5862,5862,5862},{5863,Lo,5863,5863,5863},{5864,Lo,5864,5864,5864},{5865,Lo,5865,5865,5865},{5866,Lo,5866,5866,5866},{5867,Po,5867,5867,5867},{5868,Po,5868,5868,5868},{5869,Po,5869,5869,5869},{5870,Nl,5870,5870,5870},{5871,Nl,5871,5871,5871},{5872,Nl,5872,5872,5872},{5888,Lo,5888,5888,5888},{5889,Lo,5889,5889,5889},{5890,Lo,5890,5890,5890},{5891,Lo,5891,5891,5891},{5892,Lo,5892,5892,5892},{5893,Lo,5893,5893,5893},{5894,Lo,5894,5894,5894},{5895,Lo,5895,5895,5895},{5896,Lo,5896,5896,5896},{5897,Lo,5897,5897,5897},{5898,Lo,5898,5898,5898},{5899,Lo,5899,5899,5899},{5900,Lo,5900,5900,5900},{5902,Lo,5902,5902,5902},{5903,Lo,5903,5903,5903},{5904,Lo,5904,5904,5904},{5905,Lo,5905,5905,5905},{5906,Mn,5906,5906,5906},{5907,Mn,5907,5907,5907},{5908,Mn,5908,5908,5908},{5920,Lo,5920,5920,5920},{5921,Lo,5921,5921,5921},{5922,Lo,5922,5922,5922},{5923,Lo,5923,5923,5923},{5924,Lo,5924,5924,5924},{5925,Lo,5925,5925,5925},{5926,Lo,5926,5926,5926},{5927,Lo,5927,5927,5927},{5928,Lo,5928,5928,5928},{5929,Lo,5929,5929,5929},{5930,Lo,5930,5930,5930},{5931,Lo,5931,5931,5931},{5932,Lo,5932,5932,5932},{5933,Lo,5933,5933,5933},{5934,Lo,5934,5934,5934},{5935,Lo,5935,5935,5935},{5936,Lo,5936,5936,5936},{5937,Lo,5937,5937,5937},{5938,Mn,5938,5938,5938},{5939,Mn,5939,5939,5939},{5940,Mn,5940,5940,5940},{5941,Po,5941,5941,5941},{5942,Po,5942,5942,5942},{5952,Lo,5952,5952,5952},{5953,Lo,5953,5953,5953},{5954,Lo,5954,5954,5954},{5955,Lo,5955,5955,5955},{5956,Lo,5956,5956,5956},{5957,Lo,5957,5957,5957},{5958,Lo,5958,5958,5958},{5959,Lo,5959,5959,5959},{5960,Lo,5960,5960,5960},{5961,Lo,5961,5961,5961},{5962,Lo,5962,5962,5962},{5963,Lo,5963,5963,5963},{5964,Lo,5964,5964,5964},{5965,Lo,5965,5965,5965},{5966,Lo,5966,5966,5966},{5967,Lo,5967,5967,5967},{5968,Lo,5968,5968,5968},{5969,Lo,5969,5969,5969},{5970,Mn,5970,5970,5970},{5971,Mn,5971,5971,5971},{5984,Lo,5984,5984,5984},{5985,Lo,5985,5985,5985},{5986,Lo,5986,5986,5986},{5987,Lo,5987,5987,5987},{5988,Lo,5988,5988,5988},{5989,Lo,5989,5989,5989},{5990,Lo,5990,5990,5990},{5991,Lo,5991,5991,5991},{5992,Lo,5992,5992,5992},{5993,Lo,5993,5993,5993},{5994,Lo,5994,5994,5994},{5995,Lo,5995,5995,5995},{5996,Lo,5996,5996,5996},{5998,Lo,5998,5998,5998},{5999,Lo,5999,5999,5999},{6000,Lo,6000,6000,6000},{6002,Mn,6002,6002,6002},{6003,Mn,6003,6003,6003},{6016,Lo,6016,6016,6016},{6017,Lo,6017,6017,6017},{6018,Lo,6018,6018,6018},{6019,Lo,6019,6019,6019},{6020,Lo,6020,6020,6020},{6021,Lo,6021,6021,6021},{6022,Lo,6022,6022,6022},{6023,Lo,6023,6023,6023},{6024,Lo,6024,6024,6024},{6025,Lo,6025,6025,6025},{6026,Lo,6026,6026,6026},{6027,Lo,6027,6027,6027},{6028,Lo,6028,6028,6028},{6029,Lo,6029,6029,6029},{6030,Lo,6030,6030,6030},{6031,Lo,6031,6031,6031},{6032,Lo,6032,6032,6032},{6033,Lo,6033,6033,6033},{6034,Lo,6034,6034,6034},{6035,Lo,6035,6035,6035},{6036,Lo,6036,6036,6036},{6037,Lo,6037,6037,6037},{6038,Lo,6038,6038,6038},{6039,Lo,6039,6039,6039},{6040,Lo,6040,6040,6040},{6041,Lo,6041,6041,6041},{6042,Lo,6042,6042,6042},{6043,Lo,6043,6043,6043},{6044,Lo,6044,6044,6044},{6045,Lo,6045,6045,6045},{6046,Lo,6046,6046,6046},{6047,Lo,6047,6047,6047},{6048,Lo,6048,6048,6048},{6049,Lo,6049,6049,6049},{6050,Lo,6050,6050,6050},{6051,Lo,6051,6051,6051},{6052,Lo,6052,6052,6052},{6053,Lo,6053,6053,6053},{6054,Lo,6054,6054,6054},{6055,Lo,6055,6055,6055},{6056,Lo,6056,6056,6056},{6057,Lo,6057,6057,6057},{6058,Lo,6058,6058,6058},{6059,Lo,6059,6059,6059},{6060,Lo,6060,6060,6060},{6061,Lo,6061,6061,6061},{6062,Lo,6062,6062,6062},{6063,Lo,6063,6063,6063},{6064,Lo,6064,6064,6064},{6065,Lo,6065,6065,6065},{6066,Lo,6066,6066,6066},{6067,Lo,6067,6067,6067},{6068,Cf,6068,6068,6068},{6069,Cf,6069,6069,6069},{6070,Mc,6070,6070,6070},{6071,Mn,6071,6071,6071},{6072,Mn,6072,6072,6072},{6073,Mn,6073,6073,6073},{6074,Mn,6074,6074,6074},{6075,Mn,6075,6075,6075},{6076,Mn,6076,6076,6076},{6077,Mn,6077,6077,6077},{6078,Mc,6078,6078,6078},{6079,Mc,6079,6079,6079},{6080,Mc,6080,6080,6080},{6081,Mc,6081,6081,6081},{6082,Mc,6082,6082,6082},{6083,Mc,6083,6083,6083},{6084,Mc,6084,6084,6084},{6085,Mc,6085,6085,6085},{6086,Mn,6086,6086,6086},{6087,Mc,6087,6087,6087},{6088,Mc,6088,6088,6088},{6089,Mn,6089,6089,6089},{6090,Mn,6090,6090,6090},{6091,Mn,6091,6091,6091},{6092,Mn,6092,6092,6092},{6093,Mn,6093,6093,6093},{6094,Mn,6094,6094,6094},{6095,Mn,6095,6095,6095},{6096,Mn,6096,6096,6096},{6097,Mn,6097,6097,6097},{6098,Mn,6098,6098,6098},{6099,Mn,6099,6099,6099},{6100,Po,6100,6100,6100},{6101,Po,6101,6101,6101},{6102,Po,6102,6102,6102},{6103,Lm,6103,6103,6103},{6104,Po,6104,6104,6104},{6105,Po,6105,6105,6105},{6106,Po,6106,6106,6106},{6107,Sc,6107,6107,6107},{6108,Lo,6108,6108,6108},{6109,Mn,6109,6109,6109},{6112,Nd,6112,6112,6112},{6113,Nd,6113,6113,6113},{6114,Nd,6114,6114,6114},{6115,Nd,6115,6115,6115},{6116,Nd,6116,6116,6116},{6117,Nd,6117,6117,6117},{6118,Nd,6118,6118,6118},{6119,Nd,6119,6119,6119},{6120,Nd,6120,6120,6120},{6121,Nd,6121,6121,6121},{6128,No,6128,6128,6128},{6129,No,6129,6129,6129},{6130,No,6130,6130,6130},{6131,No,6131,6131,6131},{6132,No,6132,6132,6132},{6133,No,6133,6133,6133},{6134,No,6134,6134,6134},{6135,No,6135,6135,6135},{6136,No,6136,6136,6136},{6137,No,6137,6137,6137},{6144,Po,6144,6144,6144},{6145,Po,6145,6145,6145},{6146,Po,6146,6146,6146},{6147,Po,6147,6147,6147},{6148,Po,6148,6148,6148},{6149,Po,6149,6149,6149},{6150,Pd,6150,6150,6150},{6151,Po,6151,6151,6151},{6152,Po,6152,6152,6152},{6153,Po,6153,6153,6153},{6154,Po,6154,6154,6154},{6155,Mn,6155,6155,6155},{6156,Mn,6156,6156,6156},{6157,Mn,6157,6157,6157},{6158,Zs,6158,6158,6158},{6160,Nd,6160,6160,6160},{6161,Nd,6161,6161,6161},{6162,Nd,6162,6162,6162},{6163,Nd,6163,6163,6163},{6164,Nd,6164,6164,6164},{6165,Nd,6165,6165,6165},{6166,Nd,6166,6166,6166},{6167,Nd,6167,6167,6167},{6168,Nd,6168,6168,6168},{6169,Nd,6169,6169,6169},{6176,Lo,6176,6176,6176},{6177,Lo,6177,6177,6177},{6178,Lo,6178,6178,6178},{6179,Lo,6179,6179,6179},{6180,Lo,6180,6180,6180},{6181,Lo,6181,6181,6181},{6182,Lo,6182,6182,6182},{6183,Lo,6183,6183,6183},{6184,Lo,6184,6184,6184},{6185,Lo,6185,6185,6185},{6186,Lo,6186,6186,6186},{6187,Lo,6187,6187,6187},{6188,Lo,6188,6188,6188},{6189,Lo,6189,6189,6189},{6190,Lo,6190,6190,6190},{6191,Lo,6191,6191,6191},{6192,Lo,6192,6192,6192},{6193,Lo,6193,6193,6193},{6194,Lo,6194,6194,6194},{6195,Lo,6195,6195,6195},{6196,Lo,6196,6196,6196},{6197,Lo,6197,6197,6197},{6198,Lo,6198,6198,6198},{6199,Lo,6199,6199,6199},{6200,Lo,6200,6200,6200},{6201,Lo,6201,6201,6201},{6202,Lo,6202,6202,6202},{6203,Lo,6203,6203,6203},{6204,Lo,6204,6204,6204},{6205,Lo,6205,6205,6205},{6206,Lo,6206,6206,6206},{6207,Lo,6207,6207,6207},{6208,Lo,6208,6208,6208},{6209,Lo,6209,6209,6209},{6210,Lo,6210,6210,6210},{6211,Lm,6211,6211,6211},{6212,Lo,6212,6212,6212},{6213,Lo,6213,6213,6213},{6214,Lo,6214,6214,6214},{6215,Lo,6215,6215,6215},{6216,Lo,6216,6216,6216},{6217,Lo,6217,6217,6217},{6218,Lo,6218,6218,6218},{6219,Lo,6219,6219,6219},{6220,Lo,6220,6220,6220},{6221,Lo,6221,6221,6221},{6222,Lo,6222,6222,6222},{6223,Lo,6223,6223,6223},{6224,Lo,6224,6224,6224},{6225,Lo,6225,6225,6225},{6226,Lo,6226,6226,6226},{6227,Lo,6227,6227,6227},{6228,Lo,6228,6228,6228},{6229,Lo,6229,6229,6229},{6230,Lo,6230,6230,6230},{6231,Lo,6231,6231,6231},{6232,Lo,6232,6232,6232},{6233,Lo,6233,6233,6233},{6234,Lo,6234,6234,6234},{6235,Lo,6235,6235,6235},{6236,Lo,6236,6236,6236},{6237,Lo,6237,6237,6237},{6238,Lo,6238,6238,6238},{6239,Lo,6239,6239,6239},{6240,Lo,6240,6240,6240},{6241,Lo,6241,6241,6241},{6242,Lo,6242,6242,6242},{6243,Lo,6243,6243,6243},{6244,Lo,6244,6244,6244},{6245,Lo,6245,6245,6245},{6246,Lo,6246,6246,6246},{6247,Lo,6247,6247,6247},{6248,Lo,6248,6248,6248},{6249,Lo,6249,6249,6249},{6250,Lo,6250,6250,6250},{6251,Lo,6251,6251,6251},{6252,Lo,6252,6252,6252},{6253,Lo,6253,6253,6253},{6254,Lo,6254,6254,6254},{6255,Lo,6255,6255,6255},{6256,Lo,6256,6256,6256},{6257,Lo,6257,6257,6257},{6258,Lo,6258,6258,6258},{6259,Lo,6259,6259,6259},{6260,Lo,6260,6260,6260},{6261,Lo,6261,6261,6261},{6262,Lo,6262,6262,6262},{6263,Lo,6263,6263,6263},{6272,Lo,6272,6272,6272},{6273,Lo,6273,6273,6273},{6274,Lo,6274,6274,6274},{6275,Lo,6275,6275,6275},{6276,Lo,6276,6276,6276},{6277,Lo,6277,6277,6277},{6278,Lo,6278,6278,6278},{6279,Lo,6279,6279,6279},{6280,Lo,6280,6280,6280},{6281,Lo,6281,6281,6281},{6282,Lo,6282,6282,6282},{6283,Lo,6283,6283,6283},{6284,Lo,6284,6284,6284},{6285,Lo,6285,6285,6285},{6286,Lo,6286,6286,6286},{6287,Lo,6287,6287,6287},{6288,Lo,6288,6288,6288},{6289,Lo,6289,6289,6289},{6290,Lo,6290,6290,6290},{6291,Lo,6291,6291,6291},{6292,Lo,6292,6292,6292},{6293,Lo,6293,6293,6293},{6294,Lo,6294,6294,6294},{6295,Lo,6295,6295,6295},{6296,Lo,6296,6296,6296},{6297,Lo,6297,6297,6297},{6298,Lo,6298,6298,6298},{6299,Lo,6299,6299,6299},{6300,Lo,6300,6300,6300},{6301,Lo,6301,6301,6301},{6302,Lo,6302,6302,6302},{6303,Lo,6303,6303,6303},{6304,Lo,6304,6304,6304},{6305,Lo,6305,6305,6305},{6306,Lo,6306,6306,6306},{6307,Lo,6307,6307,6307},{6308,Lo,6308,6308,6308},{6309,Lo,6309,6309,6309},{6310,Lo,6310,6310,6310},{6311,Lo,6311,6311,6311},{6312,Lo,6312,6312,6312},{6313,Mn,6313,6313,6313},{6400,Lo,6400,6400,6400},{6401,Lo,6401,6401,6401},{6402,Lo,6402,6402,6402},{6403,Lo,6403,6403,6403},{6404,Lo,6404,6404,6404},{6405,Lo,6405,6405,6405},{6406,Lo,6406,6406,6406},{6407,Lo,6407,6407,6407},{6408,Lo,6408,6408,6408},{6409,Lo,6409,6409,6409},{6410,Lo,6410,6410,6410},{6411,Lo,6411,6411,6411},{6412,Lo,6412,6412,6412},{6413,Lo,6413,6413,6413},{6414,Lo,6414,6414,6414},{6415,Lo,6415,6415,6415},{6416,Lo,6416,6416,6416},{6417,Lo,6417,6417,6417},{6418,Lo,6418,6418,6418},{6419,Lo,6419,6419,6419},{6420,Lo,6420,6420,6420},{6421,Lo,6421,6421,6421},{6422,Lo,6422,6422,6422},{6423,Lo,6423,6423,6423},{6424,Lo,6424,6424,6424},{6425,Lo,6425,6425,6425},{6426,Lo,6426,6426,6426},{6427,Lo,6427,6427,6427},{6428,Lo,6428,6428,6428},{6432,Mn,6432,6432,6432},{6433,Mn,6433,6433,6433},{6434,Mn,6434,6434,6434},{6435,Mc,6435,6435,6435},{6436,Mc,6436,6436,6436},{6437,Mc,6437,6437,6437},{6438,Mc,6438,6438,6438},{6439,Mn,6439,6439,6439},{6440,Mn,6440,6440,6440},{6441,Mc,6441,6441,6441},{6442,Mc,6442,6442,6442},{6443,Mc,6443,6443,6443},{6448,Mc,6448,6448,6448},{6449,Mc,6449,6449,6449},{6450,Mn,6450,6450,6450},{6451,Mc,6451,6451,6451},{6452,Mc,6452,6452,6452},{6453,Mc,6453,6453,6453},{6454,Mc,6454,6454,6454},{6455,Mc,6455,6455,6455},{6456,Mc,6456,6456,6456},{6457,Mn,6457,6457,6457},{6458,Mn,6458,6458,6458},{6459,Mn,6459,6459,6459},{6464,So,6464,6464,6464},{6468,Po,6468,6468,6468},{6469,Po,6469,6469,6469},{6470,Nd,6470,6470,6470},{6471,Nd,6471,6471,6471},{6472,Nd,6472,6472,6472},{6473,Nd,6473,6473,6473},{6474,Nd,6474,6474,6474},{6475,Nd,6475,6475,6475},{6476,Nd,6476,6476,6476},{6477,Nd,6477,6477,6477},{6478,Nd,6478,6478,6478},{6479,Nd,6479,6479,6479},{6480,Lo,6480,6480,6480},{6481,Lo,6481,6481,6481},{6482,Lo,6482,6482,6482},{6483,Lo,6483,6483,6483},{6484,Lo,6484,6484,6484},{6485,Lo,6485,6485,6485},{6486,Lo,6486,6486,6486},{6487,Lo,6487,6487,6487},{6488,Lo,6488,6488,6488},{6489,Lo,6489,6489,6489},{6490,Lo,6490,6490,6490},{6491,Lo,6491,6491,6491},{6492,Lo,6492,6492,6492},{6493,Lo,6493,6493,6493},{6494,Lo,6494,6494,6494},{6495,Lo,6495,6495,6495},{6496,Lo,6496,6496,6496},{6497,Lo,6497,6497,6497},{6498,Lo,6498,6498,6498},{6499,Lo,6499,6499,6499},{6500,Lo,6500,6500,6500},{6501,Lo,6501,6501,6501},{6502,Lo,6502,6502,6502},{6503,Lo,6503,6503,6503},{6504,Lo,6504,6504,6504},{6505,Lo,6505,6505,6505},{6506,Lo,6506,6506,6506},{6507,Lo,6507,6507,6507},{6508,Lo,6508,6508,6508},{6509,Lo,6509,6509,6509},{6512,Lo,6512,6512,6512},{6513,Lo,6513,6513,6513},{6514,Lo,6514,6514,6514},{6515,Lo,6515,6515,6515},{6516,Lo,6516,6516,6516},{6528,Lo,6528,6528,6528},{6529,Lo,6529,6529,6529},{6530,Lo,6530,6530,6530},{6531,Lo,6531,6531,6531},{6532,Lo,6532,6532,6532},{6533,Lo,6533,6533,6533},{6534,Lo,6534,6534,6534},{6535,Lo,6535,6535,6535},{6536,Lo,6536,6536,6536},{6537,Lo,6537,6537,6537},{6538,Lo,6538,6538,6538},{6539,Lo,6539,6539,6539},{6540,Lo,6540,6540,6540},{6541,Lo,6541,6541,6541},{6542,Lo,6542,6542,6542},{6543,Lo,6543,6543,6543},{6544,Lo,6544,6544,6544},{6545,Lo,6545,6545,6545},{6546,Lo,6546,6546,6546},{6547,Lo,6547,6547,6547},{6548,Lo,6548,6548,6548},{6549,Lo,6549,6549,6549},{6550,Lo,6550,6550,6550},{6551,Lo,6551,6551,6551},{6552,Lo,6552,6552,6552},{6553,Lo,6553,6553,6553},{6554,Lo,6554,6554,6554},{6555,Lo,6555,6555,6555},{6556,Lo,6556,6556,6556},{6557,Lo,6557,6557,6557},{6558,Lo,6558,6558,6558},{6559,Lo,6559,6559,6559},{6560,Lo,6560,6560,6560},{6561,Lo,6561,6561,6561},{6562,Lo,6562,6562,6562},{6563,Lo,6563,6563,6563},{6564,Lo,6564,6564,6564},{6565,Lo,6565,6565,6565},{6566,Lo,6566,6566,6566},{6567,Lo,6567,6567,6567},{6568,Lo,6568,6568,6568},{6569,Lo,6569,6569,6569},{6576,Mc,6576,6576,6576},{6577,Mc,6577,6577,6577},{6578,Mc,6578,6578,6578},{6579,Mc,6579,6579,6579},{6580,Mc,6580,6580,6580},{6581,Mc,6581,6581,6581},{6582,Mc,6582,6582,6582},{6583,Mc,6583,6583,6583},{6584,Mc,6584,6584,6584},{6585,Mc,6585,6585,6585},{6586,Mc,6586,6586,6586},{6587,Mc,6587,6587,6587},{6588,Mc,6588,6588,6588},{6589,Mc,6589,6589,6589},{6590,Mc,6590,6590,6590},{6591,Mc,6591,6591,6591},{6592,Mc,6592,6592,6592},{6593,Lo,6593,6593,6593},{6594,Lo,6594,6594,6594},{6595,Lo,6595,6595,6595},{6596,Lo,6596,6596,6596},{6597,Lo,6597,6597,6597},{6598,Lo,6598,6598,6598},{6599,Lo,6599,6599,6599},{6600,Mc,6600,6600,6600},{6601,Mc,6601,6601,6601},{6608,Nd,6608,6608,6608},{6609,Nd,6609,6609,6609},{6610,Nd,6610,6610,6610},{6611,Nd,6611,6611,6611},{6612,Nd,6612,6612,6612},{6613,Nd,6613,6613,6613},{6614,Nd,6614,6614,6614},{6615,Nd,6615,6615,6615},{6616,Nd,6616,6616,6616},{6617,Nd,6617,6617,6617},{6622,Po,6622,6622,6622},{6623,Po,6623,6623,6623},{6624,So,6624,6624,6624},{6625,So,6625,6625,6625},{6626,So,6626,6626,6626},{6627,So,6627,6627,6627},{6628,So,6628,6628,6628},{6629,So,6629,6629,6629},{6630,So,6630,6630,6630},{6631,So,6631,6631,6631},{6632,So,6632,6632,6632},{6633,So,6633,6633,6633},{6634,So,6634,6634,6634},{6635,So,6635,6635,6635},{6636,So,6636,6636,6636},{6637,So,6637,6637,6637},{6638,So,6638,6638,6638},{6639,So,6639,6639,6639},{6640,So,6640,6640,6640},{6641,So,6641,6641,6641},{6642,So,6642,6642,6642},{6643,So,6643,6643,6643},{6644,So,6644,6644,6644},{6645,So,6645,6645,6645},{6646,So,6646,6646,6646},{6647,So,6647,6647,6647},{6648,So,6648,6648,6648},{6649,So,6649,6649,6649},{6650,So,6650,6650,6650},{6651,So,6651,6651,6651},{6652,So,6652,6652,6652},{6653,So,6653,6653,6653},{6654,So,6654,6654,6654},{6655,So,6655,6655,6655},{6656,Lo,6656,6656,6656},{6657,Lo,6657,6657,6657},{6658,Lo,6658,6658,6658},{6659,Lo,6659,6659,6659},{6660,Lo,6660,6660,6660},{6661,Lo,6661,6661,6661},{6662,Lo,6662,6662,6662},{6663,Lo,6663,6663,6663},{6664,Lo,6664,6664,6664},{6665,Lo,6665,6665,6665},{6666,Lo,6666,6666,6666},{6667,Lo,6667,6667,6667},{6668,Lo,6668,6668,6668},{6669,Lo,6669,6669,6669},{6670,Lo,6670,6670,6670},{6671,Lo,6671,6671,6671},{6672,Lo,6672,6672,6672},{6673,Lo,6673,6673,6673},{6674,Lo,6674,6674,6674},{6675,Lo,6675,6675,6675},{6676,Lo,6676,6676,6676},{6677,Lo,6677,6677,6677},{6678,Lo,6678,6678,6678},{6679,Mn,6679,6679,6679},{6680,Mn,6680,6680,6680},{6681,Mc,6681,6681,6681},{6682,Mc,6682,6682,6682},{6683,Mc,6683,6683,6683},{6686,Po,6686,6686,6686},{6687,Po,6687,6687,6687},{6912,Mn,6912,6912,6912},{6913,Mn,6913,6913,6913},{6914,Mn,6914,6914,6914},{6915,Mn,6915,6915,6915},{6916,Mc,6916,6916,6916},{6917,Lo,6917,6917,6917},{6918,Lo,6918,6918,6918},{6919,Lo,6919,6919,6919},{6920,Lo,6920,6920,6920},{6921,Lo,6921,6921,6921},{6922,Lo,6922,6922,6922},{6923,Lo,6923,6923,6923},{6924,Lo,6924,6924,6924},{6925,Lo,6925,6925,6925},{6926,Lo,6926,6926,6926},{6927,Lo,6927,6927,6927},{6928,Lo,6928,6928,6928},{6929,Lo,6929,6929,6929},{6930,Lo,6930,6930,6930},{6931,Lo,6931,6931,6931},{6932,Lo,6932,6932,6932},{6933,Lo,6933,6933,6933},{6934,Lo,6934,6934,6934},{6935,Lo,6935,6935,6935},{6936,Lo,6936,6936,6936},{6937,Lo,6937,6937,6937},{6938,Lo,6938,6938,6938},{6939,Lo,6939,6939,6939},{6940,Lo,6940,6940,6940},{6941,Lo,6941,6941,6941},{6942,Lo,6942,6942,6942},{6943,Lo,6943,6943,6943},{6944,Lo,6944,6944,6944},{6945,Lo,6945,6945,6945},{6946,Lo,6946,6946,6946},{6947,Lo,6947,6947,6947},{6948,Lo,6948,6948,6948},{6949,Lo,6949,6949,6949},{6950,Lo,6950,6950,6950},{6951,Lo,6951,6951,6951},{6952,Lo,6952,6952,6952},{6953,Lo,6953,6953,6953},{6954,Lo,6954,6954,6954},{6955,Lo,6955,6955,6955},{6956,Lo,6956,6956,6956},{6957,Lo,6957,6957,6957},{6958,Lo,6958,6958,6958},{6959,Lo,6959,6959,6959},{6960,Lo,6960,6960,6960},{6961,Lo,6961,6961,6961},{6962,Lo,6962,6962,6962},{6963,Lo,6963,6963,6963},{6964,Mn,6964,6964,6964},{6965,Mc,6965,6965,6965},{6966,Mn,6966,6966,6966},{6967,Mn,6967,6967,6967},{6968,Mn,6968,6968,6968},{6969,Mn,6969,6969,6969},{6970,Mn,6970,6970,6970},{6971,Mc,6971,6971,6971},{6972,Mn,6972,6972,6972},{6973,Mc,6973,6973,6973},{6974,Mc,6974,6974,6974},{6975,Mc,6975,6975,6975},{6976,Mc,6976,6976,6976},{6977,Mc,6977,6977,6977},{6978,Mn,6978,6978,6978},{6979,Mc,6979,6979,6979},{6980,Mc,6980,6980,6980},{6981,Lo,6981,6981,6981},{6982,Lo,6982,6982,6982},{6983,Lo,6983,6983,6983},{6984,Lo,6984,6984,6984},{6985,Lo,6985,6985,6985},{6986,Lo,6986,6986,6986},{6987,Lo,6987,6987,6987},{6992,Nd,6992,6992,6992},{6993,Nd,6993,6993,6993},{6994,Nd,6994,6994,6994},{6995,Nd,6995,6995,6995},{6996,Nd,6996,6996,6996},{6997,Nd,6997,6997,6997},{6998,Nd,6998,6998,6998},{6999,Nd,6999,6999,6999},{7000,Nd,7000,7000,7000},{7001,Nd,7001,7001,7001},{7002,Po,7002,7002,7002},{7003,Po,7003,7003,7003},{7004,Po,7004,7004,7004},{7005,Po,7005,7005,7005},{7006,Po,7006,7006,7006},{7007,Po,7007,7007,7007},{7008,Po,7008,7008,7008},{7009,So,7009,7009,7009},{7010,So,7010,7010,7010},{7011,So,7011,7011,7011},{7012,So,7012,7012,7012},{7013,So,7013,7013,7013},{7014,So,7014,7014,7014},{7015,So,7015,7015,7015},{7016,So,7016,7016,7016},{7017,So,7017,7017,7017},{7018,So,7018,7018,7018},{7019,Mn,7019,7019,7019},{7020,Mn,7020,7020,7020},{7021,Mn,7021,7021,7021},{7022,Mn,7022,7022,7022},{7023,Mn,7023,7023,7023},{7024,Mn,7024,7024,7024},{7025,Mn,7025,7025,7025},{7026,Mn,7026,7026,7026},{7027,Mn,7027,7027,7027},{7028,So,7028,7028,7028},{7029,So,7029,7029,7029},{7030,So,7030,7030,7030},{7031,So,7031,7031,7031},{7032,So,7032,7032,7032},{7033,So,7033,7033,7033},{7034,So,7034,7034,7034},{7035,So,7035,7035,7035},{7036,So,7036,7036,7036},{7424,Ll,7424,7424,7424},{7425,Ll,7425,7425,7425},{7426,Ll,7426,7426,7426},{7427,Ll,7427,7427,7427},{7428,Ll,7428,7428,7428},{7429,Ll,7429,7429,7429},{7430,Ll,7430,7430,7430},{7431,Ll,7431,7431,7431},{7432,Ll,7432,7432,7432},{7433,Ll,7433,7433,7433},{7434,Ll,7434,7434,7434},{7435,Ll,7435,7435,7435},{7436,Ll,7436,7436,7436},{7437,Ll,7437,7437,7437},{7438,Ll,7438,7438,7438},{7439,Ll,7439,7439,7439},{7440,Ll,7440,7440,7440},{7441,Ll,7441,7441,7441},{7442,Ll,7442,7442,7442},{7443,Ll,7443,7443,7443},{7444,Ll,7444,7444,7444},{7445,Ll,7445,7445,7445},{7446,Ll,7446,7446,7446},{7447,Ll,7447,7447,7447},{7448,Ll,7448,7448,7448},{7449,Ll,7449,7449,7449},{7450,Ll,7450,7450,7450},{7451,Ll,7451,7451,7451},{7452,Ll,7452,7452,7452},{7453,Ll,7453,7453,7453},{7454,Ll,7454,7454,7454},{7455,Ll,7455,7455,7455},{7456,Ll,7456,7456,7456},{7457,Ll,7457,7457,7457},{7458,Ll,7458,7458,7458},{7459,Ll,7459,7459,7459},{7460,Ll,7460,7460,7460},{7461,Ll,7461,7461,7461},{7462,Ll,7462,7462,7462},{7463,Ll,7463,7463,7463},{7464,Ll,7464,7464,7464},{7465,Ll,7465,7465,7465},{7466,Ll,7466,7466,7466},{7467,Ll,7467,7467,7467},{7468,Lm,7468,7468,7468},{7469,Lm,7469,7469,7469},{7470,Lm,7470,7470,7470},{7471,Lm,7471,7471,7471},{7472,Lm,7472,7472,7472},{7473,Lm,7473,7473,7473},{7474,Lm,7474,7474,7474},{7475,Lm,7475,7475,7475},{7476,Lm,7476,7476,7476},{7477,Lm,7477,7477,7477},{7478,Lm,7478,7478,7478},{7479,Lm,7479,7479,7479},{7480,Lm,7480,7480,7480},{7481,Lm,7481,7481,7481},{7482,Lm,7482,7482,7482},{7483,Lm,7483,7483,7483},{7484,Lm,7484,7484,7484},{7485,Lm,7485,7485,7485},{7486,Lm,7486,7486,7486},{7487,Lm,7487,7487,7487},{7488,Lm,7488,7488,7488},{7489,Lm,7489,7489,7489},{7490,Lm,7490,7490,7490},{7491,Lm,7491,7491,7491},{7492,Lm,7492,7492,7492},{7493,Lm,7493,7493,7493},{7494,Lm,7494,7494,7494},{7495,Lm,7495,7495,7495},{7496,Lm,7496,7496,7496},{7497,Lm,7497,7497,7497},{7498,Lm,7498,7498,7498},{7499,Lm,7499,7499,7499},{7500,Lm,7500,7500,7500},{7501,Lm,7501,7501,7501},{7502,Lm,7502,7502,7502},{7503,Lm,7503,7503,7503},{7504,Lm,7504,7504,7504},{7505,Lm,7505,7505,7505},{7506,Lm,7506,7506,7506},{7507,Lm,7507,7507,7507},{7508,Lm,7508,7508,7508},{7509,Lm,7509,7509,7509},{7510,Lm,7510,7510,7510},{7511,Lm,7511,7511,7511},{7512,Lm,7512,7512,7512},{7513,Lm,7513,7513,7513},{7514,Lm,7514,7514,7514},{7515,Lm,7515,7515,7515},{7516,Lm,7516,7516,7516},{7517,Lm,7517,7517,7517},{7518,Lm,7518,7518,7518},{7519,Lm,7519,7519,7519},{7520,Lm,7520,7520,7520},{7521,Lm,7521,7521,7521},{7522,Ll,7522,7522,7522},{7523,Ll,7523,7523,7523},{7524,Ll,7524,7524,7524},{7525,Ll,7525,7525,7525},{7526,Ll,7526,7526,7526},{7527,Ll,7527,7527,7527},{7528,Ll,7528,7528,7528},{7529,Ll,7529,7529,7529},{7530,Ll,7530,7530,7530},{7531,Ll,7531,7531,7531},{7532,Ll,7532,7532,7532},{7533,Ll,7533,7533,7533},{7534,Ll,7534,7534,7534},{7535,Ll,7535,7535,7535},{7536,Ll,7536,7536,7536},{7537,Ll,7537,7537,7537},{7538,Ll,7538,7538,7538},{7539,Ll,7539,7539,7539},{7540,Ll,7540,7540,7540},{7541,Ll,7541,7541,7541},{7542,Ll,7542,7542,7542},{7543,Ll,7543,7543,7543},{7544,Lm,7544,7544,7544},{7545,Ll,7545,7545,7545},{7546,Ll,7546,7546,7546},{7547,Ll,7547,7547,7547},{7548,Ll,7548,7548,7548},{7549,Ll,11363,7549,11363},{7550,Ll,7550,7550,7550},{7551,Ll,7551,7551,7551},{7552,Ll,7552,7552,7552},{7553,Ll,7553,7553,7553},{7554,Ll,7554,7554,7554},{7555,Ll,7555,7555,7555},{7556,Ll,7556,7556,7556},{7557,Ll,7557,7557,7557},{7558,Ll,7558,7558,7558},{7559,Ll,7559,7559,7559},{7560,Ll,7560,7560,7560},{7561,Ll,7561,7561,7561},{7562,Ll,7562,7562,7562},{7563,Ll,7563,7563,7563},{7564,Ll,7564,7564,7564},{7565,Ll,7565,7565,7565},{7566,Ll,7566,7566,7566},{7567,Ll,7567,7567,7567},{7568,Ll,7568,7568,7568},{7569,Ll,7569,7569,7569},{7570,Ll,7570,7570,7570},{7571,Ll,7571,7571,7571},{7572,Ll,7572,7572,7572},{7573,Ll,7573,7573,7573},{7574,Ll,7574,7574,7574},{7575,Ll,7575,7575,7575},{7576,Ll,7576,7576,7576},{7577,Ll,7577,7577,7577},{7578,Ll,7578,7578,7578},{7579,Lm,7579,7579,7579},{7580,Lm,7580,7580,7580},{7581,Lm,7581,7581,7581},{7582,Lm,7582,7582,7582},{7583,Lm,7583,7583,7583},{7584,Lm,7584,7584,7584},{7585,Lm,7585,7585,7585},{7586,Lm,7586,7586,7586},{7587,Lm,7587,7587,7587},{7588,Lm,7588,7588,7588},{7589,Lm,7589,7589,7589},{7590,Lm,7590,7590,7590},{7591,Lm,7591,7591,7591},{7592,Lm,7592,7592,7592},{7593,Lm,7593,7593,7593},{7594,Lm,7594,7594,7594},{7595,Lm,7595,7595,7595},{7596,Lm,7596,7596,7596},{7597,Lm,7597,7597,7597},{7598,Lm,7598,7598,7598},{7599,Lm,7599,7599,7599},{7600,Lm,7600,7600,7600},{7601,Lm,7601,7601,7601},{7602,Lm,7602,7602,7602},{7603,Lm,7603,7603,7603},{7604,Lm,7604,7604,7604},{7605,Lm,7605,7605,7605},{7606,Lm,7606,7606,7606},{7607,Lm,7607,7607,7607},{7608,Lm,7608,7608,7608},{7609,Lm,7609,7609,7609},{7610,Lm,7610,7610,7610},{7611,Lm,7611,7611,7611},{7612,Lm,7612,7612,7612},{7613,Lm,7613,7613,7613},{7614,Lm,7614,7614,7614},{7615,Lm,7615,7615,7615},{7616,Mn,7616,7616,7616},{7617,Mn,7617,7617,7617},{7618,Mn,7618,7618,7618},{7619,Mn,7619,7619,7619},{7620,Mn,7620,7620,7620},{7621,Mn,7621,7621,7621},{7622,Mn,7622,7622,7622},{7623,Mn,7623,7623,7623},{7624,Mn,7624,7624,7624},{7625,Mn,7625,7625,7625},{7626,Mn,7626,7626,7626},{7678,Mn,7678,7678,7678},{7679,Mn,7679,7679,7679},{7680,Lu,7680,7681,7680},{7681,Ll,7680,7681,7680},{7682,Lu,7682,7683,7682},{7683,Ll,7682,7683,7682},{7684,Lu,7684,7685,7684},{7685,Ll,7684,7685,7684},{7686,Lu,7686,7687,7686},{7687,Ll,7686,7687,7686},{7688,Lu,7688,7689,7688},{7689,Ll,7688,7689,7688},{7690,Lu,7690,7691,7690},{7691,Ll,7690,7691,7690},{7692,Lu,7692,7693,7692},{7693,Ll,7692,7693,7692},{7694,Lu,7694,7695,7694},{7695,Ll,7694,7695,7694},{7696,Lu,7696,7697,7696},{7697,Ll,7696,7697,7696},{7698,Lu,7698,7699,7698},{7699,Ll,7698,7699,7698},{7700,Lu,7700,7701,7700},{7701,Ll,7700,7701,7700},{7702,Lu,7702,7703,7702},{7703,Ll,7702,7703,7702},{7704,Lu,7704,7705,7704},{7705,Ll,7704,7705,7704},{7706,Lu,7706,7707,7706},{7707,Ll,7706,7707,7706},{7708,Lu,7708,7709,7708},{7709,Ll,7708,7709,7708},{7710,Lu,7710,7711,7710},{7711,Ll,7710,7711,7710},{7712,Lu,7712,7713,7712},{7713,Ll,7712,7713,7712},{7714,Lu,7714,7715,7714},{7715,Ll,7714,7715,7714},{7716,Lu,7716,7717,7716},{7717,Ll,7716,7717,7716},{7718,Lu,7718,7719,7718},{7719,Ll,7718,7719,7718},{7720,Lu,7720,7721,7720},{7721,Ll,7720,7721,7720},{7722,Lu,7722,7723,7722},{7723,Ll,7722,7723,7722},{7724,Lu,7724,7725,7724},{7725,Ll,7724,7725,7724},{7726,Lu,7726,7727,7726},{7727,Ll,7726,7727,7726},{7728,Lu,7728,7729,7728},{7729,Ll,7728,7729,7728},{7730,Lu,7730,7731,7730},{7731,Ll,7730,7731,7730},{7732,Lu,7732,7733,7732},{7733,Ll,7732,7733,7732},{7734,Lu,7734,7735,7734},{7735,Ll,7734,7735,7734},{7736,Lu,7736,7737,7736},{7737,Ll,7736,7737,7736},{7738,Lu,7738,7739,7738},{7739,Ll,7738,7739,7738},{7740,Lu,7740,7741,7740},{7741,Ll,7740,7741,7740},{7742,Lu,7742,7743,7742},{7743,Ll,7742,7743,7742},{7744,Lu,7744,7745,7744},{7745,Ll,7744,7745,7744},{7746,Lu,7746,7747,7746},{7747,Ll,7746,7747,7746},{7748,Lu,7748,7749,7748},{7749,Ll,7748,7749,7748},{7750,Lu,7750,7751,7750},{7751,Ll,7750,7751,7750},{7752,Lu,7752,7753,7752},{7753,Ll,7752,7753,7752},{7754,Lu,7754,7755,7754},{7755,Ll,7754,7755,7754},{7756,Lu,7756,7757,7756},{7757,Ll,7756,7757,7756},{7758,Lu,7758,7759,7758},{7759,Ll,7758,7759,7758},{7760,Lu,7760,7761,7760},{7761,Ll,7760,7761,7760},{7762,Lu,7762,7763,7762},{7763,Ll,7762,7763,7762},{7764,Lu,7764,7765,7764},{7765,Ll,7764,7765,7764},{7766,Lu,7766,7767,7766},{7767,Ll,7766,7767,7766},{7768,Lu,7768,7769,7768},{7769,Ll,7768,7769,7768},{7770,Lu,7770,7771,7770},{7771,Ll,7770,7771,7770},{7772,Lu,7772,7773,7772},{7773,Ll,7772,7773,7772},{7774,Lu,7774,7775,7774},{7775,Ll,7774,7775,7774},{7776,Lu,7776,7777,7776},{7777,Ll,7776,7777,7776},{7778,Lu,7778,7779,7778},{7779,Ll,7778,7779,7778},{7780,Lu,7780,7781,7780},{7781,Ll,7780,7781,7780},{7782,Lu,7782,7783,7782},{7783,Ll,7782,7783,7782},{7784,Lu,7784,7785,7784},{7785,Ll,7784,7785,7784},{7786,Lu,7786,7787,7786},{7787,Ll,7786,7787,7786},{7788,Lu,7788,7789,7788},{7789,Ll,7788,7789,7788},{7790,Lu,7790,7791,7790},{7791,Ll,7790,7791,7790},{7792,Lu,7792,7793,7792},{7793,Ll,7792,7793,7792},{7794,Lu,7794,7795,7794},{7795,Ll,7794,7795,7794},{7796,Lu,7796,7797,7796},{7797,Ll,7796,7797,7796},{7798,Lu,7798,7799,7798},{7799,Ll,7798,7799,7798},{7800,Lu,7800,7801,7800},{7801,Ll,7800,7801,7800},{7802,Lu,7802,7803,7802},{7803,Ll,7802,7803,7802},{7804,Lu,7804,7805,7804},{7805,Ll,7804,7805,7804},{7806,Lu,7806,7807,7806},{7807,Ll,7806,7807,7806},{7808,Lu,7808,7809,7808},{7809,Ll,7808,7809,7808},{7810,Lu,7810,7811,7810},{7811,Ll,7810,7811,7810},{7812,Lu,7812,7813,7812},{7813,Ll,7812,7813,7812},{7814,Lu,7814,7815,7814},{7815,Ll,7814,7815,7814},{7816,Lu,7816,7817,7816},{7817,Ll,7816,7817,7816},{7818,Lu,7818,7819,7818},{7819,Ll,7818,7819,7818},{7820,Lu,7820,7821,7820},{7821,Ll,7820,7821,7820},{7822,Lu,7822,7823,7822},{7823,Ll,7822,7823,7822},{7824,Lu,7824,7825,7824},{7825,Ll,7824,7825,7824},{7826,Lu,7826,7827,7826},{7827,Ll,7826,7827,7826},{7828,Lu,7828,7829,7828},{7829,Ll,7828,7829,7828},{7830,Ll | SM,7830,7830,7830},{7831,Ll | SM,7831,7831,7831},{7832,Ll | SM,7832,7832,7832},{7833,Ll | SM,7833,7833,7833},{7834,Ll | SM,7834,7834,7834},{7835,Ll,7776,7835,7776},{7840,Lu,7840,7841,7840},{7841,Ll,7840,7841,7840},{7842,Lu,7842,7843,7842},{7843,Ll,7842,7843,7842},{7844,Lu,7844,7845,7844},{7845,Ll,7844,7845,7844},{7846,Lu,7846,7847,7846},{7847,Ll,7846,7847,7846},{7848,Lu,7848,7849,7848},{7849,Ll,7848,7849,7848},{7850,Lu,7850,7851,7850},{7851,Ll,7850,7851,7850},{7852,Lu,7852,7853,7852},{7853,Ll,7852,7853,7852},{7854,Lu,7854,7855,7854},{7855,Ll,7854,7855,7854},{7856,Lu,7856,7857,7856},{7857,Ll,7856,7857,7856},{7858,Lu,7858,7859,7858},{7859,Ll,7858,7859,7858},{7860,Lu,7860,7861,7860},{7861,Ll,7860,7861,7860},{7862,Lu,7862,7863,7862},{7863,Ll,7862,7863,7862},{7864,Lu,7864,7865,7864},{7865,Ll,7864,7865,7864},{7866,Lu,7866,7867,7866},{7867,Ll,7866,7867,7866},{7868,Lu,7868,7869,7868},{7869,Ll,7868,7869,7868},{7870,Lu,7870,7871,7870},{7871,Ll,7870,7871,7870},{7872,Lu,7872,7873,7872},{7873,Ll,7872,7873,7872},{7874,Lu,7874,7875,7874},{7875,Ll,7874,7875,7874},{7876,Lu,7876,7877,7876},{7877,Ll,7876,7877,7876},{7878,Lu,7878,7879,7878},{7879,Ll,7878,7879,7878},{7880,Lu,7880,7881,7880},{7881,Ll,7880,7881,7880},{7882,Lu,7882,7883,7882},{7883,Ll,7882,7883,7882},{7884,Lu,7884,7885,7884},{7885,Ll,7884,7885,7884},{7886,Lu,7886,7887,7886},{7887,Ll,7886,7887,7886},{7888,Lu,7888,7889,7888},{7889,Ll,7888,7889,7888},{7890,Lu,7890,7891,7890},{7891,Ll,7890,7891,7890},{7892,Lu,7892,7893,7892},{7893,Ll,7892,7893,7892},{7894,Lu,7894,7895,7894},{7895,Ll,7894,7895,7894},{7896,Lu,7896,7897,7896},{7897,Ll,7896,7897,7896},{7898,Lu,7898,7899,7898},{7899,Ll,7898,7899,7898},{7900,Lu,7900,7901,7900},{7901,Ll,7900,7901,7900},{7902,Lu,7902,7903,7902},{7903,Ll,7902,7903,7902},{7904,Lu,7904,7905,7904},{7905,Ll,7904,7905,7904},{7906,Lu,7906,7907,7906},{7907,Ll,7906,7907,7906},{7908,Lu,7908,7909,7908},{7909,Ll,7908,7909,7908},{7910,Lu,7910,7911,7910},{7911,Ll,7910,7911,7910},{7912,Lu,7912,7913,7912},{7913,Ll,7912,7913,7912},{7914,Lu,7914,7915,7914},{7915,Ll,7914,7915,7914},{7916,Lu,7916,7917,7916},{7917,Ll,7916,7917,7916},{7918,Lu,7918,7919,7918},{7919,Ll,7918,7919,7918},{7920,Lu,7920,7921,7920},{7921,Ll,7920,7921,7920},{7922,Lu,7922,7923,7922},{7923,Ll,7922,7923,7922},{7924,Lu,7924,7925,7924},{7925,Ll,7924,7925,7924},{7926,Lu,7926,7927,7926},{7927,Ll,7926,7927,7926},{7928,Lu,7928,7929,7928},{7929,Ll,7928,7929,7928},{7936,Ll,7944,7936,7944},{7937,Ll,7945,7937,7945},{7938,Ll,7946,7938,7946},{7939,Ll,7947,7939,7947},{7940,Ll,7948,7940,7948},{7941,Ll,7949,7941,7949},{7942,Ll,7950,7942,7950},{7943,Ll,7951,7943,7951},{7944,Lu,7944,7936,7944},{7945,Lu,7945,7937,7945},{7946,Lu,7946,7938,7946},{7947,Lu,7947,7939,7947},{7948,Lu,7948,7940,7948},{7949,Lu,7949,7941,7949},{7950,Lu,7950,7942,7950},{7951,Lu,7951,7943,7951},{7952,Ll,7960,7952,7960},{7953,Ll,7961,7953,7961},{7954,Ll,7962,7954,7962},{7955,Ll,7963,7955,7963},{7956,Ll,7964,7956,7964},{7957,Ll,7965,7957,7965},{7960,Lu,7960,7952,7960},{7961,Lu,7961,7953,7961},{7962,Lu,7962,7954,7962},{7963,Lu,7963,7955,7963},{7964,Lu,7964,7956,7964},{7965,Lu,7965,7957,7965},{7968,Ll,7976,7968,7976},{7969,Ll,7977,7969,7977},{7970,Ll,7978,7970,7978},{7971,Ll,7979,7971,7979},{7972,Ll,7980,7972,7980},{7973,Ll,7981,7973,7981},{7974,Ll,7982,7974,7982},{7975,Ll,7983,7975,7983},{7976,Lu,7976,7968,7976},{7977,Lu,7977,7969,7977},{7978,Lu,7978,7970,7978},{7979,Lu,7979,7971,7979},{7980,Lu,7980,7972,7980},{7981,Lu,7981,7973,7981},{7982,Lu,7982,7974,7982},{7983,Lu,7983,7975,7983},{7984,Ll,7992,7984,7992},{7985,Ll,7993,7985,7993},{7986,Ll,7994,7986,7994},{7987,Ll,7995,7987,7995},{7988,Ll,7996,7988,7996},{7989,Ll,7997,7989,7997},{7990,Ll,7998,7990,7998},{7991,Ll,7999,7991,7999},{7992,Lu,7992,7984,7992},{7993,Lu,7993,7985,7993},{7994,Lu,7994,7986,7994},{7995,Lu,7995,7987,7995},{7996,Lu,7996,7988,7996},{7997,Lu,7997,7989,7997},{7998,Lu,7998,7990,7998},{7999,Lu,7999,7991,7999},{8000,Ll,8008,8000,8008},{8001,Ll,8009,8001,8009},{8002,Ll,8010,8002,8010},{8003,Ll,8011,8003,8011},{8004,Ll,8012,8004,8012},{8005,Ll,8013,8005,8013},{8008,Lu,8008,8000,8008},{8009,Lu,8009,8001,8009},{8010,Lu,8010,8002,8010},{8011,Lu,8011,8003,8011},{8012,Lu,8012,8004,8012},{8013,Lu,8013,8005,8013},{8016,Ll | SM,8016,8016,8016},{8017,Ll,8025,8017,8025},{8018,Ll | SM,8018,8018,8018},{8019,Ll,8027,8019,8027},{8020,Ll | SM,8020,8020,8020},{8021,Ll,8029,8021,8029},{8022,Ll | SM,8022,8022,8022},{8023,Ll,8031,8023,8031},{8025,Lu,8025,8017,8025},{8027,Lu,8027,8019,8027},{8029,Lu,8029,8021,8029},{8031,Lu,8031,8023,8031},{8032,Ll,8040,8032,8040},{8033,Ll,8041,8033,8041},{8034,Ll,8042,8034,8042},{8035,Ll,8043,8035,8043},{8036,Ll,8044,8036,8044},{8037,Ll,8045,8037,8045},{8038,Ll,8046,8038,8046},{8039,Ll,8047,8039,8047},{8040,Lu,8040,8032,8040},{8041,Lu,8041,8033,8041},{8042,Lu,8042,8034,8042},{8043,Lu,8043,8035,8043},{8044,Lu,8044,8036,8044},{8045,Lu,8045,8037,8045},{8046,Lu,8046,8038,8046},{8047,Lu,8047,8039,8047},{8048,Ll,8122,8048,8122},{8049,Ll,8123,8049,8123},{8050,Ll,8136,8050,8136},{8051,Ll,8137,8051,8137},{8052,Ll,8138,8052,8138},{8053,Ll,8139,8053,8139},{8054,Ll,8154,8054,8154},{8055,Ll,8155,8055,8155},{8056,Ll,8184,8056,8184},{8057,Ll,8185,8057,8185},{8058,Ll,8170,8058,8170},{8059,Ll,8171,8059,8171},{8060,Ll,8186,8060,8186},{8061,Ll,8187,8061,8187},{8064,Ll | SM,8072,8064,8072},{8065,Ll | SM,8073,8065,8073},{8066,Ll | SM,8074,8066,8074},{8067,Ll | SM,8075,8067,8075},{8068,Ll | SM,8076,8068,8076},{8069,Ll | SM,8077,8069,8077},{8070,Ll | SM,8078,8070,8078},{8071,Ll | SM,8079,8071,8079},{8072,Lt | SM,8072,8064,8072},{8073,Lt | SM,8073,8065,8073},{8074,Lt | SM,8074,8066,8074},{8075,Lt | SM,8075,8067,8075},{8076,Lt | SM,8076,8068,8076},{8077,Lt | SM,8077,8069,8077},{8078,Lt | SM,8078,8070,8078},{8079,Lt | SM,8079,8071,8079},{8080,Ll | SM,8088,8080,8088},{8081,Ll | SM,8089,8081,8089},{8082,Ll | SM,8090,8082,8090},{8083,Ll | SM,8091,8083,8091},{8084,Ll | SM,8092,8084,8092},{8085,Ll | SM,8093,8085,8093},{8086,Ll | SM,8094,8086,8094},{8087,Ll | SM,8095,8087,8095},{8088,Lt | SM,8088,8080,8088},{8089,Lt | SM,8089,8081,8089},{8090,Lt | SM,8090,8082,8090},{8091,Lt | SM,8091,8083,8091},{8092,Lt | SM,8092,8084,8092},{8093,Lt | SM,8093,8085,8093},{8094,Lt | SM,8094,8086,8094},{8095,Lt | SM,8095,8087,8095},{8096,Ll | SM,8104,8096,8104},{8097,Ll | SM,8105,8097,8105},{8098,Ll | SM,8106,8098,8106},{8099,Ll | SM,8107,8099,8107},{8100,Ll | SM,8108,8100,8108},{8101,Ll | SM,8109,8101,8109},{8102,Ll | SM,8110,8102,8110},{8103,Ll | SM,8111,8103,8111},{8104,Lt | SM,8104,8096,8104},{8105,Lt | SM,8105,8097,8105},{8106,Lt | SM,8106,8098,8106},{8107,Lt | SM,8107,8099,8107},{8108,Lt | SM,8108,8100,8108},{8109,Lt | SM,8109,8101,8109},{8110,Lt | SM,8110,8102,8110},{8111,Lt | SM,8111,8103,8111},{8112,Ll,8120,8112,8120},{8113,Ll,8121,8113,8121},{8114,Ll | SM,8114,8114,8114},{8115,Ll | SM,8124,8115,8124},{8116,Ll | SM,8116,8116,8116},{8118,Ll | SM,8118,8118,8118},{8119,Ll | SM,8119,8119,8119},{8120,Lu,8120,8112,8120},{8121,Lu,8121,8113,8121},{8122,Lu,8122,8048,8122},{8123,Lu,8123,8049,8123},{8124,Lt | SM,8124,8115,8124},{8125,Sk,8125,8125,8125},{8126,Ll,921,8126,921},{8127,Sk,8127,8127,8127},{8128,Sk,8128,8128,8128},{8129,Sk,8129,8129,8129},{8130,Ll | SM,8130,8130,8130},{8131,Ll | SM,8140,8131,8140},{8132,Ll | SM,8132,8132,8132},{8134,Ll | SM,8134,8134,8134},{8135,Ll | SM,8135,8135,8135},{8136,Lu,8136,8050,8136},{8137,Lu,8137,8051,8137},{8138,Lu,8138,8052,8138},{8139,Lu,8139,8053,8139},{8140,Lt | SM,8140,8131,8140},{8141,Sk,8141,8141,8141},{8142,Sk,8142,8142,8142},{8143,Sk,8143,8143,8143},{8144,Ll,8152,8144,8152},{8145,Ll,8153,8145,8153},{8146,Ll | SM,8146,8146,8146},{8147,Ll | SM,8147,8147,8147},{8150,Ll | SM,8150,8150,8150},{8151,Ll | SM,8151,8151,8151},{8152,Lu,8152,8144,8152},{8153,Lu,8153,8145,8153},{8154,Lu,8154,8054,8154},{8155,Lu,8155,8055,8155},{8157,Sk,8157,8157,8157},{8158,Sk,8158,8158,8158},{8159,Sk,8159,8159,8159},{8160,Ll,8168,8160,8168},{8161,Ll,8169,8161,8169},{8162,Ll | SM,8162,8162,8162},{8163,Ll | SM,8163,8163,8163},{8164,Ll | SM,8164,8164,8164},{8165,Ll,8172,8165,8172},{8166,Ll | SM,8166,8166,8166},{8167,Ll | SM,8167,8167,8167},{8168,Lu,8168,8160,8168},{8169,Lu,8169,8161,8169},{8170,Lu,8170,8058,8170},{8171,Lu,8171,8059,8171},{8172,Lu,8172,8165,8172},{8173,Sk,8173,8173,8173},{8174,Sk,8174,8174,8174},{8175,Sk,8175,8175,8175},{8178,Ll | SM,8178,8178,8178},{8179,Ll | SM,8188,8179,8188},{8180,Ll | SM,8180,8180,8180},{8182,Ll | SM,8182,8182,8182},{8183,Ll | SM,8183,8183,8183},{8184,Lu,8184,8056,8184},{8185,Lu,8185,8057,8185},{8186,Lu,8186,8060,8186},{8187,Lu,8187,8061,8187},{8188,Lt | SM,8188,8179,8188},{8189,Sk,8189,8189,8189},{8190,Sk,8190,8190,8190},{8192,Zs,8192,8192,8192},{8193,Zs,8193,8193,8193},{8194,Zs,8194,8194,8194},{8195,Zs,8195,8195,8195},{8196,Zs,8196,8196,8196},{8197,Zs,8197,8197,8197},{8198,Zs,8198,8198,8198},{8199,Zs,8199,8199,8199},{8200,Zs,8200,8200,8200},{8201,Zs,8201,8201,8201},{8202,Zs,8202,8202,8202},{8203,Cf,8203,8203,8203},{8204,Cf,8204,8204,8204},{8205,Cf,8205,8205,8205},{8206,Cf,8206,8206,8206},{8207,Cf,8207,8207,8207},{8208,Pd,8208,8208,8208},{8209,Pd,8209,8209,8209},{8210,Pd,8210,8210,8210},{8211,Pd,8211,8211,8211},{8212,Pd,8212,8212,8212},{8213,Pd,8213,8213,8213},{8214,Po,8214,8214,8214},{8215,Po,8215,8215,8215},{8216,Pi,8216,8216,8216},{8217,Pf,8217,8217,8217},{8218,Ps,8218,8218,8218},{8219,Pi,8219,8219,8219},{8220,Pi,8220,8220,8220},{8221,Pf,8221,8221,8221},{8222,Ps,8222,8222,8222},{8223,Pi,8223,8223,8223},{8224,Po,8224,8224,8224},{8225,Po,8225,8225,8225},{8226,Po,8226,8226,8226},{8227,Po,8227,8227,8227},{8228,Po,8228,8228,8228},{8229,Po,8229,8229,8229},{8230,Po,8230,8230,8230},{8231,Po,8231,8231,8231},{8232,Zl,8232,8232,8232},{8233,Zp,8233,8233,8233},{8234,Cf,8234,8234,8234},{8235,Cf,8235,8235,8235},{8236,Cf,8236,8236,8236},{8237,Cf,8237,8237,8237},{8238,Cf,8238,8238,8238},{8239,Zs,8239,8239,8239},{8240,Po,8240,8240,8240},{8241,Po,8241,8241,8241},{8242,Po,8242,8242,8242},{8243,Po,8243,8243,8243},{8244,Po,8244,8244,8244},{8245,Po,8245,8245,8245},{8246,Po,8246,8246,8246},{8247,Po,8247,8247,8247},{8248,Po,8248,8248,8248},{8249,Pi,8249,8249,8249},{8250,Pf,8250,8250,8250},{8251,Po,8251,8251,8251},{8252,Po,8252,8252,8252},{8253,Po,8253,8253,8253},{8254,Po,8254,8254,8254},{8255,Pc,8255,8255,8255},{8256,Pc,8256,8256,8256},{8257,Po,8257,8257,8257},{8258,Po,8258,8258,8258},{8259,Po,8259,8259,8259},{8260,Sm,8260,8260,8260},{8261,Ps,8261,8261,8261},{8262,Pe,8262,8262,8262},{8263,Po,8263,8263,8263},{8264,Po,8264,8264,8264},{8265,Po,8265,8265,8265},{8266,Po,8266,8266,8266},{8267,Po,8267,8267,8267},{8268,Po,8268,8268,8268},{8269,Po,8269,8269,8269},{8270,Po,8270,8270,8270},{8271,Po,8271,8271,8271},{8272,Po,8272,8272,8272},{8273,Po,8273,8273,8273},{8274,Sm,8274,8274,8274},{8275,Po,8275,8275,8275},{8276,Pc,8276,8276,8276},{8277,Po,8277,8277,8277},{8278,Po,8278,8278,8278},{8279,Po,8279,8279,8279},{8280,Po,8280,8280,8280},{8281,Po,8281,8281,8281},{8282,Po,8282,8282,8282},{8283,Po,8283,8283,8283},{8284,Po,8284,8284,8284},{8285,Po,8285,8285,8285},{8286,Po,8286,8286,8286},{8287,Zs,8287,8287,8287},{8288,Cf,8288,8288,8288},{8289,Cf,8289,8289,8289},{8290,Cf,8290,8290,8290},{8291,Cf,8291,8291,8291},{8298,Cf,8298,8298,8298},{8299,Cf,8299,8299,8299},{8300,Cf,8300,8300,8300},{8301,Cf,8301,8301,8301},{8302,Cf,8302,8302,8302},{8303,Cf,8303,8303,8303},{8304,No,8304,8304,8304},{8305,Ll,8305,8305,8305},{8308,No,8308,8308,8308},{8309,No,8309,8309,8309},{8310,No,8310,8310,8310},{8311,No,8311,8311,8311},{8312,No,8312,8312,8312},{8313,No,8313,8313,8313},{8314,Sm,8314,8314,8314},{8315,Sm,8315,8315,8315},{8316,Sm,8316,8316,8316},{8317,Ps,8317,8317,8317},{8318,Pe,8318,8318,8318},{8319,Ll,8319,8319,8319},{8320,No,8320,8320,8320},{8321,No,8321,8321,8321},{8322,No,8322,8322,8322},{8323,No,8323,8323,8323},{8324,No,8324,8324,8324},{8325,No,8325,8325,8325},{8326,No,8326,8326,8326},{8327,No,8327,8327,8327},{8328,No,8328,8328,8328},{8329,No,8329,8329,8329},{8330,Sm,8330,8330,8330},{8331,Sm,8331,8331,8331},{8332,Sm,8332,8332,8332},{8333,Ps,8333,8333,8333},{8334,Pe,8334,8334,8334},{8336,Lm,8336,8336,8336},{8337,Lm,8337,8337,8337},{8338,Lm,8338,8338,8338},{8339,Lm,8339,8339,8339},{8340,Lm,8340,8340,8340},{8352,Sc,8352,8352,8352},{8353,Sc,8353,8353,8353},{8354,Sc,8354,8354,8354},{8355,Sc,8355,8355,8355},{8356,Sc,8356,8356,8356},{8357,Sc,8357,8357,8357},{8358,Sc,8358,8358,8358},{8359,Sc,8359,8359,8359},{8360,Sc,8360,8360,8360},{8361,Sc,8361,8361,8361},{8362,Sc,8362,8362,8362},{8363,Sc,8363,8363,8363},{8364,Sc,8364,8364,8364},{8365,Sc,8365,8365,8365},{8366,Sc,8366,8366,8366},{8367,Sc,8367,8367,8367},{8368,Sc,8368,8368,8368},{8369,Sc,8369,8369,8369},{8370,Sc,8370,8370,8370},{8371,Sc,8371,8371,8371},{8372,Sc,8372,8372,8372},{8373,Sc,8373,8373,8373},{8400,Mn,8400,8400,8400},{8401,Mn,8401,8401,8401},{8402,Mn,8402,8402,8402},{8403,Mn,8403,8403,8403},{8404,Mn,8404,8404,8404},{8405,Mn,8405,8405,8405},{8406,Mn,8406,8406,8406},{8407,Mn,8407,8407,8407},{8408,Mn,8408,8408,8408},{8409,Mn,8409,8409,8409},{8410,Mn,8410,8410,8410},{8411,Mn,8411,8411,8411},{8412,Mn,8412,8412,8412},{8413,Me,8413,8413,8413},{8414,Me,8414,8414,8414},{8415,Me,8415,8415,8415},{8416,Me,8416,8416,8416},{8417,Mn,8417,8417,8417},{8418,Me,8418,8418,8418},{8419,Me,8419,8419,8419},{8420,Me,8420,8420,8420},{8421,Mn,8421,8421,8421},{8422,Mn,8422,8422,8422},{8423,Mn,8423,8423,8423},{8424,Mn,8424,8424,8424},{8425,Mn,8425,8425,8425},{8426,Mn,8426,8426,8426},{8427,Mn,8427,8427,8427},{8428,Mn,8428,8428,8428},{8429,Mn,8429,8429,8429},{8430,Mn,8430,8430,8430},{8431,Mn,8431,8431,8431},{8448,So,8448,8448,8448},{8449,So,8449,8449,8449},{8450,Lu,8450,8450,8450},{8451,So,8451,8451,8451},{8452,So,8452,8452,8452},{8453,So,8453,8453,8453},{8454,So,8454,8454,8454},{8455,Lu,8455,8455,8455},{8456,So,8456,8456,8456},{8457,So,8457,8457,8457},{8458,Ll,8458,8458,8458},{8459,Lu,8459,8459,8459},{8460,Lu,8460,8460,8460},{8461,Lu,8461,8461,8461},{8462,Ll,8462,8462,8462},{8463,Ll,8463,8463,8463},{8464,Lu,8464,8464,8464},{8465,Lu,8465,8465,8465},{8466,Lu,8466,8466,8466},{8467,Ll,8467,8467,8467},{8468,So,8468,8468,8468},{8469,Lu,8469,8469,8469},{8470,So,8470,8470,8470},{8471,So,8471,8471,8471},{8472,So,8472,8472,8472},{8473,Lu,8473,8473,8473},{8474,Lu,8474,8474,8474},{8475,Lu,8475,8475,8475},{8476,Lu,8476,8476,8476},{8477,Lu,8477,8477,8477},{8478,So,8478,8478,8478},{8479,So,8479,8479,8479},{8480,So,8480,8480,8480},{8481,So,8481,8481,8481},{8482,So,8482,8482,8482},{8483,So,8483,8483,8483},{8484,Lu,8484,8484,8484},{8485,So,8485,8485,8485},{8486,Lu,8486,969,8486},{8487,So,8487,8487,8487},{8488,Lu,8488,8488,8488},{8489,So,8489,8489,8489},{8490,Lu,8490,107,8490},{8491,Lu,8491,229,8491},{8492,Lu,8492,8492,8492},{8493,Lu,8493,8493,8493},{8494,So,8494,8494,8494},{8495,Ll,8495,8495,8495},{8496,Lu,8496,8496,8496},{8497,Lu,8497,8497,8497},{8498,Lu,8498,8526,8498},{8499,Lu,8499,8499,8499},{8500,Ll,8500,8500,8500},{8501,Lo,8501,8501,8501},{8502,Lo,8502,8502,8502},{8503,Lo,8503,8503,8503},{8504,Lo,8504,8504,8504},{8505,Ll,8505,8505,8505},{8506,So,8506,8506,8506},{8507,So,8507,8507,8507},{8508,Ll,8508,8508,8508},{8509,Ll,8509,8509,8509},{8510,Lu,8510,8510,8510},{8511,Lu,8511,8511,8511},{8512,Sm,8512,8512,8512},{8513,Sm,8513,8513,8513},{8514,Sm,8514,8514,8514},{8515,Sm,8515,8515,8515},{8516,Sm,8516,8516,8516},{8517,Lu,8517,8517,8517},{8518,Ll,8518,8518,8518},{8519,Ll,8519,8519,8519},{8520,Ll,8520,8520,8520},{8521,Ll,8521,8521,8521},{8522,So,8522,8522,8522},{8523,Sm,8523,8523,8523},{8524,So,8524,8524,8524},{8525,So,8525,8525,8525},{8526,Ll,8498,8526,8498},{8531,No,8531,8531,8531},{8532,No,8532,8532,8532},{8533,No,8533,8533,8533},{8534,No,8534,8534,8534},{8535,No,8535,8535,8535},{8536,No,8536,8536,8536},{8537,No,8537,8537,8537},{8538,No,8538,8538,8538},{8539,No,8539,8539,8539},{8540,No,8540,8540,8540},{8541,No,8541,8541,8541},{8542,No,8542,8542,8542},{8543,No,8543,8543,8543},{8544,Nl,8544,8560,8544},{8545,Nl,8545,8561,8545},{8546,Nl,8546,8562,8546},{8547,Nl,8547,8563,8547},{8548,Nl,8548,8564,8548},{8549,Nl,8549,8565,8549},{8550,Nl,8550,8566,8550},{8551,Nl,8551,8567,8551},{8552,Nl,8552,8568,8552},{8553,Nl,8553,8569,8553},{8554,Nl,8554,8570,8554},{8555,Nl,8555,8571,8555},{8556,Nl,8556,8572,8556},{8557,Nl,8557,8573,8557},{8558,Nl,8558,8574,8558},{8559,Nl,8559,8575,8559},{8560,Nl,8544,8560,8544},{8561,Nl,8545,8561,8545},{8562,Nl,8546,8562,8546},{8563,Nl,8547,8563,8547},{8564,Nl,8548,8564,8548},{8565,Nl,8549,8565,8549},{8566,Nl,8550,8566,8550},{8567,Nl,8551,8567,8551},{8568,Nl,8552,8568,8552},{8569,Nl,8553,8569,8553},{8570,Nl,8554,8570,8554},{8571,Nl,8555,8571,8555},{8572,Nl,8556,8572,8556},{8573,Nl,8557,8573,8557},{8574,Nl,8558,8574,8558},{8575,Nl,8559,8575,8559},{8576,Nl,8576,8576,8576},{8577,Nl,8577,8577,8577},{8578,Nl,8578,8578,8578},{8579,Lu,8579,8580,8579},{8580,Ll,8579,8580,8579},{8592,Sm,8592,8592,8592},{8593,Sm,8593,8593,8593},{8594,Sm,8594,8594,8594},{8595,Sm,8595,8595,8595},{8596,Sm,8596,8596,8596},{8597,So,8597,8597,8597},{8598,So,8598,8598,8598},{8599,So,8599,8599,8599},{8600,So,8600,8600,8600},{8601,So,8601,8601,8601},{8602,Sm,8602,8602,8602},{8603,Sm,8603,8603,8603},{8604,So,8604,8604,8604},{8605,So,8605,8605,8605},{8606,So,8606,8606,8606},{8607,So,8607,8607,8607},{8608,Sm,8608,8608,8608},{8609,So,8609,8609,8609},{8610,So,8610,8610,8610},{8611,Sm,8611,8611,8611},{8612,So,8612,8612,8612},{8613,So,8613,8613,8613},{8614,Sm,8614,8614,8614},{8615,So,8615,8615,8615},{8616,So,8616,8616,8616},{8617,So,8617,8617,8617},{8618,So,8618,8618,8618},{8619,So,8619,8619,8619},{8620,So,8620,8620,8620},{8621,So,8621,8621,8621},{8622,Sm,8622,8622,8622},{8623,So,8623,8623,8623},{8624,So,8624,8624,8624},{8625,So,8625,8625,8625},{8626,So,8626,8626,8626},{8627,So,8627,8627,8627},{8628,So,8628,8628,8628},{8629,So,8629,8629,8629},{8630,So,8630,8630,8630},{8631,So,8631,8631,8631},{8632,So,8632,8632,8632},{8633,So,8633,8633,8633},{8634,So,8634,8634,8634},{8635,So,8635,8635,8635},{8636,So,8636,8636,8636},{8637,So,8637,8637,8637},{8638,So,8638,8638,8638},{8639,So,8639,8639,8639},{8640,So,8640,8640,8640},{8641,So,8641,8641,8641},{8642,So,8642,8642,8642},{8643,So,8643,8643,8643},{8644,So,8644,8644,8644},{8645,So,8645,8645,8645},{8646,So,8646,8646,8646},{8647,So,8647,8647,8647},{8648,So,8648,8648,8648},{8649,So,8649,8649,8649},{8650,So,8650,8650,8650},{8651,So,8651,8651,8651},{8652,So,8652,8652,8652},{8653,So,8653,8653,8653},{8654,Sm,8654,8654,8654},{8655,Sm,8655,8655,8655},{8656,So,8656,8656,8656},{8657,So,8657,8657,8657},{8658,Sm,8658,8658,8658},{8659,So,8659,8659,8659},{8660,Sm,8660,8660,8660},{8661,So,8661,8661,8661},{8662,So,8662,8662,8662},{8663,So,8663,8663,8663},{8664,So,8664,8664,8664},{8665,So,8665,8665,8665},{8666,So,8666,8666,8666},{8667,So,8667,8667,8667},{8668,So,8668,8668,8668},{8669,So,8669,8669,8669},{8670,So,8670,8670,8670},{8671,So,8671,8671,8671},{8672,So,8672,8672,8672},{8673,So,8673,8673,8673},{8674,So,8674,8674,8674},{8675,So,8675,8675,8675},{8676,So,8676,8676,8676},{8677,So,8677,8677,8677},{8678,So,8678,8678,8678},{8679,So,8679,8679,8679},{8680,So,8680,8680,8680},{8681,So,8681,8681,8681},{8682,So,8682,8682,8682},{8683,So,8683,8683,8683},{8684,So,8684,8684,8684},{8685,So,8685,8685,8685},{8686,So,8686,8686,8686},{8687,So,8687,8687,8687},{8688,So,8688,8688,8688},{8689,So,8689,8689,8689},{8690,So,8690,8690,8690},{8691,So,8691,8691,8691},{8692,Sm,8692,8692,8692},{8693,Sm,8693,8693,8693},{8694,Sm,8694,8694,8694},{8695,Sm,8695,8695,8695},{8696,Sm,8696,8696,8696},{8697,Sm,8697,8697,8697},{8698,Sm,8698,8698,8698},{8699,Sm,8699,8699,8699},{8700,Sm,8700,8700,8700},{8701,Sm,8701,8701,8701},{8702,Sm,8702,8702,8702},{8703,Sm,8703,8703,8703},{8704,Sm,8704,8704,8704},{8705,Sm,8705,8705,8705},{8706,Sm,8706,8706,8706},{8707,Sm,8707,8707,8707},{8708,Sm,8708,8708,8708},{8709,Sm,8709,8709,8709},{8710,Sm,8710,8710,8710},{8711,Sm,8711,8711,8711},{8712,Sm,8712,8712,8712},{8713,Sm,8713,8713,8713},{8714,Sm,8714,8714,8714},{8715,Sm,8715,8715,8715},{8716,Sm,8716,8716,8716},{8717,Sm,8717,8717,8717},{8718,Sm,8718,8718,8718},{8719,Sm,8719,8719,8719},{8720,Sm,8720,8720,8720},{8721,Sm,8721,8721,8721},{8722,Sm,8722,8722,8722},{8723,Sm,8723,8723,8723},{8724,Sm,8724,8724,8724},{8725,Sm,8725,8725,8725},{8726,Sm,8726,8726,8726},{8727,Sm,8727,8727,8727},{8728,Sm,8728,8728,8728},{8729,Sm,8729,8729,8729},{8730,Sm,8730,8730,8730},{8731,Sm,8731,8731,8731},{8732,Sm,8732,8732,8732},{8733,Sm,8733,8733,8733},{8734,Sm,8734,8734,8734},{8735,Sm,8735,8735,8735},{8736,Sm,8736,8736,8736},{8737,Sm,8737,8737,8737},{8738,Sm,8738,8738,8738},{8739,Sm,8739,8739,8739},{8740,Sm,8740,8740,8740},{8741,Sm,8741,8741,8741},{8742,Sm,8742,8742,8742},{8743,Sm,8743,8743,8743},{8744,Sm,8744,8744,8744},{8745,Sm,8745,8745,8745},{8746,Sm,8746,8746,8746},{8747,Sm,8747,8747,8747},{8748,Sm,8748,8748,8748},{8749,Sm,8749,8749,8749},{8750,Sm,8750,8750,8750},{8751,Sm,8751,8751,8751},{8752,Sm,8752,8752,8752},{8753,Sm,8753,8753,8753},{8754,Sm,8754,8754,8754},{8755,Sm,8755,8755,8755},{8756,Sm,8756,8756,8756},{8757,Sm,8757,8757,8757},{8758,Sm,8758,8758,8758},{8759,Sm,8759,8759,8759},{8760,Sm,8760,8760,8760},{8761,Sm,8761,8761,8761},{8762,Sm,8762,8762,8762},{8763,Sm,8763,8763,8763},{8764,Sm,8764,8764,8764},{8765,Sm,8765,8765,8765},{8766,Sm,8766,8766,8766},{8767,Sm,8767,8767,8767},{8768,Sm,8768,8768,8768},{8769,Sm,8769,8769,8769},{8770,Sm,8770,8770,8770},{8771,Sm,8771,8771,8771},{8772,Sm,8772,8772,8772},{8773,Sm,8773,8773,8773},{8774,Sm,8774,8774,8774},{8775,Sm,8775,8775,8775},{8776,Sm,8776,8776,8776},{8777,Sm,8777,8777,8777},{8778,Sm,8778,8778,8778},{8779,Sm,8779,8779,8779},{8780,Sm,8780,8780,8780},{8781,Sm,8781,8781,8781},{8782,Sm,8782,8782,8782},{8783,Sm,8783,8783,8783},{8784,Sm,8784,8784,8784},{8785,Sm,8785,8785,8785},{8786,Sm,8786,8786,8786},{8787,Sm,8787,8787,8787},{8788,Sm,8788,8788,8788},{8789,Sm,8789,8789,8789},{8790,Sm,8790,8790,8790},{8791,Sm,8791,8791,8791},{8792,Sm,8792,8792,8792},{8793,Sm,8793,8793,8793},{8794,Sm,8794,8794,8794},{8795,Sm,8795,8795,8795},{8796,Sm,8796,8796,8796},{8797,Sm,8797,8797,8797},{8798,Sm,8798,8798,8798},{8799,Sm,8799,8799,8799},{8800,Sm,8800,8800,8800},{8801,Sm,8801,8801,8801},{8802,Sm,8802,8802,8802},{8803,Sm,8803,8803,8803},{8804,Sm,8804,8804,8804},{8805,Sm,8805,8805,8805},{8806,Sm,8806,8806,8806},{8807,Sm,8807,8807,8807},{8808,Sm,8808,8808,8808},{8809,Sm,8809,8809,8809},{8810,Sm,8810,8810,8810},{8811,Sm,8811,8811,8811},{8812,Sm,8812,8812,8812},{8813,Sm,8813,8813,8813},{8814,Sm,8814,8814,8814},{8815,Sm,8815,8815,8815},{8816,Sm,8816,8816,8816},{8817,Sm,8817,8817,8817},{8818,Sm,8818,8818,8818},{8819,Sm,8819,8819,8819},{8820,Sm,8820,8820,8820},{8821,Sm,8821,8821,8821},{8822,Sm,8822,8822,8822},{8823,Sm,8823,8823,8823},{8824,Sm,8824,8824,8824},{8825,Sm,8825,8825,8825},{8826,Sm,8826,8826,8826},{8827,Sm,8827,8827,8827},{8828,Sm,8828,8828,8828},{8829,Sm,8829,8829,8829},{8830,Sm,8830,8830,8830},{8831,Sm,8831,8831,8831},{8832,Sm,8832,8832,8832},{8833,Sm,8833,8833,8833},{8834,Sm,8834,8834,8834},{8835,Sm,8835,8835,8835},{8836,Sm,8836,8836,8836},{8837,Sm,8837,8837,8837},{8838,Sm,8838,8838,8838},{8839,Sm,8839,8839,8839},{8840,Sm,8840,8840,8840},{8841,Sm,8841,8841,8841},{8842,Sm,8842,8842,8842},{8843,Sm,8843,8843,8843},{8844,Sm,8844,8844,8844},{8845,Sm,8845,8845,8845},{8846,Sm,8846,8846,8846},{8847,Sm,8847,8847,8847},{8848,Sm,8848,8848,8848},{8849,Sm,8849,8849,8849},{8850,Sm,8850,8850,8850},{8851,Sm,8851,8851,8851},{8852,Sm,8852,8852,8852},{8853,Sm,8853,8853,8853},{8854,Sm,8854,8854,8854},{8855,Sm,8855,8855,8855},{8856,Sm,8856,8856,8856},{8857,Sm,8857,8857,8857},{8858,Sm,8858,8858,8858},{8859,Sm,8859,8859,8859},{8860,Sm,8860,8860,8860},{8861,Sm,8861,8861,8861},{8862,Sm,8862,8862,8862},{8863,Sm,8863,8863,8863},{8864,Sm,8864,8864,8864},{8865,Sm,8865,8865,8865},{8866,Sm,8866,8866,8866},{8867,Sm,8867,8867,8867},{8868,Sm,8868,8868,8868},{8869,Sm,8869,8869,8869},{8870,Sm,8870,8870,8870},{8871,Sm,8871,8871,8871},{8872,Sm,8872,8872,8872},{8873,Sm,8873,8873,8873},{8874,Sm,8874,8874,8874},{8875,Sm,8875,8875,8875},{8876,Sm,8876,8876,8876},{8877,Sm,8877,8877,8877},{8878,Sm,8878,8878,8878},{8879,Sm,8879,8879,8879},{8880,Sm,8880,8880,8880},{8881,Sm,8881,8881,8881},{8882,Sm,8882,8882,8882},{8883,Sm,8883,8883,8883},{8884,Sm,8884,8884,8884},{8885,Sm,8885,8885,8885},{8886,Sm,8886,8886,8886},{8887,Sm,8887,8887,8887},{8888,Sm,8888,8888,8888},{8889,Sm,8889,8889,8889},{8890,Sm,8890,8890,8890},{8891,Sm,8891,8891,8891},{8892,Sm,8892,8892,8892},{8893,Sm,8893,8893,8893},{8894,Sm,8894,8894,8894},{8895,Sm,8895,8895,8895},{8896,Sm,8896,8896,8896},{8897,Sm,8897,8897,8897},{8898,Sm,8898,8898,8898},{8899,Sm,8899,8899,8899},{8900,Sm,8900,8900,8900},{8901,Sm,8901,8901,8901},{8902,Sm,8902,8902,8902},{8903,Sm,8903,8903,8903},{8904,Sm,8904,8904,8904},{8905,Sm,8905,8905,8905},{8906,Sm,8906,8906,8906},{8907,Sm,8907,8907,8907},{8908,Sm,8908,8908,8908},{8909,Sm,8909,8909,8909},{8910,Sm,8910,8910,8910},{8911,Sm,8911,8911,8911},{8912,Sm,8912,8912,8912},{8913,Sm,8913,8913,8913},{8914,Sm,8914,8914,8914},{8915,Sm,8915,8915,8915},{8916,Sm,8916,8916,8916},{8917,Sm,8917,8917,8917},{8918,Sm,8918,8918,8918},{8919,Sm,8919,8919,8919},{8920,Sm,8920,8920,8920},{8921,Sm,8921,8921,8921},{8922,Sm,8922,8922,8922},{8923,Sm,8923,8923,8923},{8924,Sm,8924,8924,8924},{8925,Sm,8925,8925,8925},{8926,Sm,8926,8926,8926},{8927,Sm,8927,8927,8927},{8928,Sm,8928,8928,8928},{8929,Sm,8929,8929,8929},{8930,Sm,8930,8930,8930},{8931,Sm,8931,8931,8931},{8932,Sm,8932,8932,8932},{8933,Sm,8933,8933,8933},{8934,Sm,8934,8934,8934},{8935,Sm,8935,8935,8935},{8936,Sm,8936,8936,8936},{8937,Sm,8937,8937,8937},{8938,Sm,8938,8938,8938},{8939,Sm,8939,8939,8939},{8940,Sm,8940,8940,8940},{8941,Sm,8941,8941,8941},{8942,Sm,8942,8942,8942},{8943,Sm,8943,8943,8943},{8944,Sm,8944,8944,8944},{8945,Sm,8945,8945,8945},{8946,Sm,8946,8946,8946},{8947,Sm,8947,8947,8947},{8948,Sm,8948,8948,8948},{8949,Sm,8949,8949,8949},{8950,Sm,8950,8950,8950},{8951,Sm,8951,8951,8951},{8952,Sm,8952,8952,8952},{8953,Sm,8953,8953,8953},{8954,Sm,8954,8954,8954},{8955,Sm,8955,8955,8955},{8956,Sm,8956,8956,8956},{8957,Sm,8957,8957,8957},{8958,Sm,8958,8958,8958},{8959,Sm,8959,8959,8959},{8960,So,8960,8960,8960},{8961,So,8961,8961,8961},{8962,So,8962,8962,8962},{8963,So,8963,8963,8963},{8964,So,8964,8964,8964},{8965,So,8965,8965,8965},{8966,So,8966,8966,8966},{8967,So,8967,8967,8967},{8968,Sm,8968,8968,8968},{8969,Sm,8969,8969,8969},{8970,Sm,8970,8970,8970},{8971,Sm,8971,8971,8971},{8972,So,8972,8972,8972},{8973,So,8973,8973,8973},{8974,So,8974,8974,8974},{8975,So,8975,8975,8975},{8976,So,8976,8976,8976},{8977,So,8977,8977,8977},{8978,So,8978,8978,8978},{8979,So,8979,8979,8979},{8980,So,8980,8980,8980},{8981,So,8981,8981,8981},{8982,So,8982,8982,8982},{8983,So,8983,8983,8983},{8984,So,8984,8984,8984},{8985,So,8985,8985,8985},{8986,So,8986,8986,8986},{8987,So,8987,8987,8987},{8988,So,8988,8988,8988},{8989,So,8989,8989,8989},{8990,So,8990,8990,8990},{8991,So,8991,8991,8991},{8992,Sm,8992,8992,8992},{8993,Sm,8993,8993,8993},{8994,So,8994,8994,8994},{8995,So,8995,8995,8995},{8996,So,8996,8996,8996},{8997,So,8997,8997,8997},{8998,So,8998,8998,8998},{8999,So,8999,8999,8999},{9000,So,9000,9000,9000},{9001,Ps,9001,9001,9001},{9002,Pe,9002,9002,9002},{9003,So,9003,9003,9003},{9004,So,9004,9004,9004},{9005,So,9005,9005,9005},{9006,So,9006,9006,9006},{9007,So,9007,9007,9007},{9008,So,9008,9008,9008},{9009,So,9009,9009,9009},{9010,So,9010,9010,9010},{9011,So,9011,9011,9011},{9012,So,9012,9012,9012},{9013,So,9013,9013,9013},{9014,So,9014,9014,9014},{9015,So,9015,9015,9015},{9016,So,9016,9016,9016},{9017,So,9017,9017,9017},{9018,So,9018,9018,9018},{9019,So,9019,9019,9019},{9020,So,9020,9020,9020},{9021,So,9021,9021,9021},{9022,So,9022,9022,9022},{9023,So,9023,9023,9023},{9024,So,9024,9024,9024},{9025,So,9025,9025,9025},{9026,So,9026,9026,9026},{9027,So,9027,9027,9027},{9028,So,9028,9028,9028},{9029,So,9029,9029,9029},{9030,So,9030,9030,9030},{9031,So,9031,9031,9031},{9032,So,9032,9032,9032},{9033,So,9033,9033,9033},{9034,So,9034,9034,9034},{9035,So,9035,9035,9035},{9036,So,9036,9036,9036},{9037,So,9037,9037,9037},{9038,So,9038,9038,9038},{9039,So,9039,9039,9039},{9040,So,9040,9040,9040},{9041,So,9041,9041,9041},{9042,So,9042,9042,9042},{9043,So,9043,9043,9043},{9044,So,9044,9044,9044},{9045,So,9045,9045,9045},{9046,So,9046,9046,9046},{9047,So,9047,9047,9047},{9048,So,9048,9048,9048},{9049,So,9049,9049,9049},{9050,So,9050,9050,9050},{9051,So,9051,9051,9051},{9052,So,9052,9052,9052},{9053,So,9053,9053,9053},{9054,So,9054,9054,9054},{9055,So,9055,9055,9055},{9056,So,9056,9056,9056},{9057,So,9057,9057,9057},{9058,So,9058,9058,9058},{9059,So,9059,9059,9059},{9060,So,9060,9060,9060},{9061,So,9061,9061,9061},{9062,So,9062,9062,9062},{9063,So,9063,9063,9063},{9064,So,9064,9064,9064},{9065,So,9065,9065,9065},{9066,So,9066,9066,9066},{9067,So,9067,9067,9067},{9068,So,9068,9068,9068},{9069,So,9069,9069,9069},{9070,So,9070,9070,9070},{9071,So,9071,9071,9071},{9072,So,9072,9072,9072},{9073,So,9073,9073,9073},{9074,So,9074,9074,9074},{9075,So,9075,9075,9075},{9076,So,9076,9076,9076},{9077,So,9077,9077,9077},{9078,So,9078,9078,9078},{9079,So,9079,9079,9079},{9080,So,9080,9080,9080},{9081,So,9081,9081,9081},{9082,So,9082,9082,9082},{9083,So,9083,9083,9083},{9084,Sm,9084,9084,9084},{9085,So,9085,9085,9085},{9086,So,9086,9086,9086},{9087,So,9087,9087,9087},{9088,So,9088,9088,9088},{9089,So,9089,9089,9089},{9090,So,9090,9090,9090},{9091,So,9091,9091,9091},{9092,So,9092,9092,9092},{9093,So,9093,9093,9093},{9094,So,9094,9094,9094},{9095,So,9095,9095,9095},{9096,So,9096,9096,9096},{9097,So,9097,9097,9097},{9098,So,9098,9098,9098},{9099,So,9099,9099,9099},{9100,So,9100,9100,9100},{9101,So,9101,9101,9101},{9102,So,9102,9102,9102},{9103,So,9103,9103,9103},{9104,So,9104,9104,9104},{9105,So,9105,9105,9105},{9106,So,9106,9106,9106},{9107,So,9107,9107,9107},{9108,So,9108,9108,9108},{9109,So,9109,9109,9109},{9110,So,9110,9110,9110},{9111,So,9111,9111,9111},{9112,So,9112,9112,9112},{9113,So,9113,9113,9113},{9114,So,9114,9114,9114},{9115,Sm,9115,9115,9115},{9116,Sm,9116,9116,9116},{9117,Sm,9117,9117,9117},{9118,Sm,9118,9118,9118},{9119,Sm,9119,9119,9119},{9120,Sm,9120,9120,9120},{9121,Sm,9121,9121,9121},{9122,Sm,9122,9122,9122},{9123,Sm,9123,9123,9123},{9124,Sm,9124,9124,9124},{9125,Sm,9125,9125,9125},{9126,Sm,9126,9126,9126},{9127,Sm,9127,9127,9127},{9128,Sm,9128,9128,9128},{9129,Sm,9129,9129,9129},{9130,Sm,9130,9130,9130},{9131,Sm,9131,9131,9131},{9132,Sm,9132,9132,9132},{9133,Sm,9133,9133,9133},{9134,Sm,9134,9134,9134},{9135,Sm,9135,9135,9135},{9136,Sm,9136,9136,9136},{9137,Sm,9137,9137,9137},{9138,Sm,9138,9138,9138},{9139,Sm,9139,9139,9139},{9140,So,9140,9140,9140},{9141,So,9141,9141,9141},{9142,So,9142,9142,9142},{9143,So,9143,9143,9143},{9144,So,9144,9144,9144},{9145,So,9145,9145,9145},{9146,So,9146,9146,9146},{9147,So,9147,9147,9147},{9148,So,9148,9148,9148},{9149,So,9149,9149,9149},{9150,So,9150,9150,9150},{9151,So,9151,9151,9151},{9152,So,9152,9152,9152},{9153,So,9153,9153,9153},{9154,So,9154,9154,9154},{9155,So,9155,9155,9155},{9156,So,9156,9156,9156},{9157,So,9157,9157,9157},{9158,So,9158,9158,9158},{9159,So,9159,9159,9159},{9160,So,9160,9160,9160},{9161,So,9161,9161,9161},{9162,So,9162,9162,9162},{9163,So,9163,9163,9163},{9164,So,9164,9164,9164},{9165,So,9165,9165,9165},{9166,So,9166,9166,9166},{9167,So,9167,9167,9167},{9168,So,9168,9168,9168},{9169,So,9169,9169,9169},{9170,So,9170,9170,9170},{9171,So,9171,9171,9171},{9172,So,9172,9172,9172},{9173,So,9173,9173,9173},{9174,So,9174,9174,9174},{9175,So,9175,9175,9175},{9176,So,9176,9176,9176},{9177,So,9177,9177,9177},{9178,So,9178,9178,9178},{9179,So,9179,9179,9179},{9180,Sm,9180,9180,9180},{9181,Sm,9181,9181,9181},{9182,Sm,9182,9182,9182},{9183,Sm,9183,9183,9183},{9184,Sm,9184,9184,9184},{9185,Sm,9185,9185,9185},{9186,So,9186,9186,9186},{9187,So,9187,9187,9187},{9188,So,9188,9188,9188},{9189,So,9189,9189,9189},{9190,So,9190,9190,9190},{9191,So,9191,9191,9191},{9216,So,9216,9216,9216},{9217,So,9217,9217,9217},{9218,So,9218,9218,9218},{9219,So,9219,9219,9219},{9220,So,9220,9220,9220},{9221,So,9221,9221,9221},{9222,So,9222,9222,9222},{9223,So,9223,9223,9223},{9224,So,9224,9224,9224},{9225,So,9225,9225,9225},{9226,So,9226,9226,9226},{9227,So,9227,9227,9227},{9228,So,9228,9228,9228},{9229,So,9229,9229,9229},{9230,So,9230,9230,9230},{9231,So,9231,9231,9231},{9232,So,9232,9232,9232},{9233,So,9233,9233,9233},{9234,So,9234,9234,9234},{9235,So,9235,9235,9235},{9236,So,9236,9236,9236},{9237,So,9237,9237,9237},{9238,So,9238,9238,9238},{9239,So,9239,9239,9239},{9240,So,9240,9240,9240},{9241,So,9241,9241,9241},{9242,So,9242,9242,9242},{9243,So,9243,9243,9243},{9244,So,9244,9244,9244},{9245,So,9245,9245,9245},{9246,So,9246,9246,9246},{9247,So,9247,9247,9247},{9248,So,9248,9248,9248},{9249,So,9249,9249,9249},{9250,So,9250,9250,9250},{9251,So,9251,9251,9251},{9252,So,9252,9252,9252},{9253,So,9253,9253,9253},{9254,So,9254,9254,9254},{9280,So,9280,9280,9280},{9281,So,9281,9281,9281},{9282,So,9282,9282,9282},{9283,So,9283,9283,9283},{9284,So,9284,9284,9284},{9285,So,9285,9285,9285},{9286,So,9286,9286,9286},{9287,So,9287,9287,9287},{9288,So,9288,9288,9288},{9289,So,9289,9289,9289},{9290,So,9290,9290,9290},{9312,No,9312,9312,9312},{9313,No,9313,9313,9313},{9314,No,9314,9314,9314},{9315,No,9315,9315,9315},{9316,No,9316,9316,9316},{9317,No,9317,9317,9317},{9318,No,9318,9318,9318},{9319,No,9319,9319,9319},{9320,No,9320,9320,9320},{9321,No,9321,9321,9321},{9322,No,9322,9322,9322},{9323,No,9323,9323,9323},{9324,No,9324,9324,9324},{9325,No,9325,9325,9325},{9326,No,9326,9326,9326},{9327,No,9327,9327,9327},{9328,No,9328,9328,9328},{9329,No,9329,9329,9329},{9330,No,9330,9330,9330},{9331,No,9331,9331,9331},{9332,No,9332,9332,9332},{9333,No,9333,9333,9333},{9334,No,9334,9334,9334},{9335,No,9335,9335,9335},{9336,No,9336,9336,9336},{9337,No,9337,9337,9337},{9338,No,9338,9338,9338},{9339,No,9339,9339,9339},{9340,No,9340,9340,9340},{9341,No,9341,9341,9341},{9342,No,9342,9342,9342},{9343,No,9343,9343,9343},{9344,No,9344,9344,9344},{9345,No,9345,9345,9345},{9346,No,9346,9346,9346},{9347,No,9347,9347,9347},{9348,No,9348,9348,9348},{9349,No,9349,9349,9349},{9350,No,9350,9350,9350},{9351,No,9351,9351,9351},{9352,No,9352,9352,9352},{9353,No,9353,9353,9353},{9354,No,9354,9354,9354},{9355,No,9355,9355,9355},{9356,No,9356,9356,9356},{9357,No,9357,9357,9357},{9358,No,9358,9358,9358},{9359,No,9359,9359,9359},{9360,No,9360,9360,9360},{9361,No,9361,9361,9361},{9362,No,9362,9362,9362},{9363,No,9363,9363,9363},{9364,No,9364,9364,9364},{9365,No,9365,9365,9365},{9366,No,9366,9366,9366},{9367,No,9367,9367,9367},{9368,No,9368,9368,9368},{9369,No,9369,9369,9369},{9370,No,9370,9370,9370},{9371,No,9371,9371,9371},{9372,So,9372,9372,9372},{9373,So,9373,9373,9373},{9374,So,9374,9374,9374},{9375,So,9375,9375,9375},{9376,So,9376,9376,9376},{9377,So,9377,9377,9377},{9378,So,9378,9378,9378},{9379,So,9379,9379,9379},{9380,So,9380,9380,9380},{9381,So,9381,9381,9381},{9382,So,9382,9382,9382},{9383,So,9383,9383,9383},{9384,So,9384,9384,9384},{9385,So,9385,9385,9385},{9386,So,9386,9386,9386},{9387,So,9387,9387,9387},{9388,So,9388,9388,9388},{9389,So,9389,9389,9389},{9390,So,9390,9390,9390},{9391,So,9391,9391,9391},{9392,So,9392,9392,9392},{9393,So,9393,9393,9393},{9394,So,9394,9394,9394},{9395,So,9395,9395,9395},{9396,So,9396,9396,9396},{9397,So,9397,9397,9397},{9398,So,9398,9424,9398},{9399,So,9399,9425,9399},{9400,So,9400,9426,9400},{9401,So,9401,9427,9401},{9402,So,9402,9428,9402},{9403,So,9403,9429,9403},{9404,So,9404,9430,9404},{9405,So,9405,9431,9405},{9406,So,9406,9432,9406},{9407,So,9407,9433,9407},{9408,So,9408,9434,9408},{9409,So,9409,9435,9409},{9410,So,9410,9436,9410},{9411,So,9411,9437,9411},{9412,So,9412,9438,9412},{9413,So,9413,9439,9413},{9414,So,9414,9440,9414},{9415,So,9415,9441,9415},{9416,So,9416,9442,9416},{9417,So,9417,9443,9417},{9418,So,9418,9444,9418},{9419,So,9419,9445,9419},{9420,So,9420,9446,9420},{9421,So,9421,9447,9421},{9422,So,9422,9448,9422},{9423,So,9423,9449,9423},{9424,So,9398,9424,9398},{9425,So,9399,9425,9399},{9426,So,9400,9426,9400},{9427,So,9401,9427,9401},{9428,So,9402,9428,9402},{9429,So,9403,9429,9403},{9430,So,9404,9430,9404},{9431,So,9405,9431,9405},{9432,So,9406,9432,9406},{9433,So,9407,9433,9407},{9434,So,9408,9434,9408},{9435,So,9409,9435,9409},{9436,So,9410,9436,9410},{9437,So,9411,9437,9411},{9438,So,9412,9438,9412},{9439,So,9413,9439,9413},{9440,So,9414,9440,9414},{9441,So,9415,9441,9415},{9442,So,9416,9442,9416},{9443,So,9417,9443,9417},{9444,So,9418,9444,9418},{9445,So,9419,9445,9419},{9446,So,9420,9446,9420},{9447,So,9421,9447,9421},{9448,So,9422,9448,9422},{9449,So,9423,9449,9423},{9450,No,9450,9450,9450},{9451,No,9451,9451,9451},{9452,No,9452,9452,9452},{9453,No,9453,9453,9453},{9454,No,9454,9454,9454},{9455,No,9455,9455,9455},{9456,No,9456,9456,9456},{9457,No,9457,9457,9457},{9458,No,9458,9458,9458},{9459,No,9459,9459,9459},{9460,No,9460,9460,9460},{9461,No,9461,9461,9461},{9462,No,9462,9462,9462},{9463,No,9463,9463,9463},{9464,No,9464,9464,9464},{9465,No,9465,9465,9465},{9466,No,9466,9466,9466},{9467,No,9467,9467,9467},{9468,No,9468,9468,9468},{9469,No,9469,9469,9469},{9470,No,9470,9470,9470},{9471,No,9471,9471,9471},{9472,So,9472,9472,9472},{9473,So,9473,9473,9473},{9474,So,9474,9474,9474},{9475,So,9475,9475,9475},{9476,So,9476,9476,9476},{9477,So,9477,9477,9477},{9478,So,9478,9478,9478},{9479,So,9479,9479,9479},{9480,So,9480,9480,9480},{9481,So,9481,9481,9481},{9482,So,9482,9482,9482},{9483,So,9483,9483,9483},{9484,So,9484,9484,9484},{9485,So,9485,9485,9485},{9486,So,9486,9486,9486},{9487,So,9487,9487,9487},{9488,So,9488,9488,9488},{9489,So,9489,9489,9489},{9490,So,9490,9490,9490},{9491,So,9491,9491,9491},{9492,So,9492,9492,9492},{9493,So,9493,9493,9493},{9494,So,9494,9494,9494},{9495,So,9495,9495,9495},{9496,So,9496,9496,9496},{9497,So,9497,9497,9497},{9498,So,9498,9498,9498},{9499,So,9499,9499,9499},{9500,So,9500,9500,9500},{9501,So,9501,9501,9501},{9502,So,9502,9502,9502},{9503,So,9503,9503,9503},{9504,So,9504,9504,9504},{9505,So,9505,9505,9505},{9506,So,9506,9506,9506},{9507,So,9507,9507,9507},{9508,So,9508,9508,9508},{9509,So,9509,9509,9509},{9510,So,9510,9510,9510},{9511,So,9511,9511,9511},{9512,So,9512,9512,9512},{9513,So,9513,9513,9513},{9514,So,9514,9514,9514},{9515,So,9515,9515,9515},{9516,So,9516,9516,9516},{9517,So,9517,9517,9517},{9518,So,9518,9518,9518},{9519,So,9519,9519,9519},{9520,So,9520,9520,9520},{9521,So,9521,9521,9521},{9522,So,9522,9522,9522},{9523,So,9523,9523,9523},{9524,So,9524,9524,9524},{9525,So,9525,9525,9525},{9526,So,9526,9526,9526},{9527,So,9527,9527,9527},{9528,So,9528,9528,9528},{9529,So,9529,9529,9529},{9530,So,9530,9530,9530},{9531,So,9531,9531,9531},{9532,So,9532,9532,9532},{9533,So,9533,9533,9533},{9534,So,9534,9534,9534},{9535,So,9535,9535,9535},{9536,So,9536,9536,9536},{9537,So,9537,9537,9537},{9538,So,9538,9538,9538},{9539,So,9539,9539,9539},{9540,So,9540,9540,9540},{9541,So,9541,9541,9541},{9542,So,9542,9542,9542},{9543,So,9543,9543,9543},{9544,So,9544,9544,9544},{9545,So,9545,9545,9545},{9546,So,9546,9546,9546},{9547,So,9547,9547,9547},{9548,So,9548,9548,9548},{9549,So,9549,9549,9549},{9550,So,9550,9550,9550},{9551,So,9551,9551,9551},{9552,So,9552,9552,9552},{9553,So,9553,9553,9553},{9554,So,9554,9554,9554},{9555,So,9555,9555,9555},{9556,So,9556,9556,9556},{9557,So,9557,9557,9557},{9558,So,9558,9558,9558},{9559,So,9559,9559,9559},{9560,So,9560,9560,9560},{9561,So,9561,9561,9561},{9562,So,9562,9562,9562},{9563,So,9563,9563,9563},{9564,So,9564,9564,9564},{9565,So,9565,9565,9565},{9566,So,9566,9566,9566},{9567,So,9567,9567,9567},{9568,So,9568,9568,9568},{9569,So,9569,9569,9569},{9570,So,9570,9570,9570},{9571,So,9571,9571,9571},{9572,So,9572,9572,9572},{9573,So,9573,9573,9573},{9574,So,9574,9574,9574},{9575,So,9575,9575,9575},{9576,So,9576,9576,9576},{9577,So,9577,9577,9577},{9578,So,9578,9578,9578},{9579,So,9579,9579,9579},{9580,So,9580,9580,9580},{9581,So,9581,9581,9581},{9582,So,9582,9582,9582},{9583,So,9583,9583,9583},{9584,So,9584,9584,9584},{9585,So,9585,9585,9585},{9586,So,9586,9586,9586},{9587,So,9587,9587,9587},{9588,So,9588,9588,9588},{9589,So,9589,9589,9589},{9590,So,9590,9590,9590},{9591,So,9591,9591,9591},{9592,So,9592,9592,9592},{9593,So,9593,9593,9593},{9594,So,9594,9594,9594},{9595,So,9595,9595,9595},{9596,So,9596,9596,9596},{9597,So,9597,9597,9597},{9598,So,9598,9598,9598},{9599,So,9599,9599,9599},{9600,So,9600,9600,9600},{9601,So,9601,9601,9601},{9602,So,9602,9602,9602},{9603,So,9603,9603,9603},{9604,So,9604,9604,9604},{9605,So,9605,9605,9605},{9606,So,9606,9606,9606},{9607,So,9607,9607,9607},{9608,So,9608,9608,9608},{9609,So,9609,9609,9609},{9610,So,9610,9610,9610},{9611,So,9611,9611,9611},{9612,So,9612,9612,9612},{9613,So,9613,9613,9613},{9614,So,9614,9614,9614},{9615,So,9615,9615,9615},{9616,So,9616,9616,9616},{9617,So,9617,9617,9617},{9618,So,9618,9618,9618},{9619,So,9619,9619,9619},{9620,So,9620,9620,9620},{9621,So,9621,9621,9621},{9622,So,9622,9622,9622},{9623,So,9623,9623,9623},{9624,So,9624,9624,9624},{9625,So,9625,9625,9625},{9626,So,9626,9626,9626},{9627,So,9627,9627,9627},{9628,So,9628,9628,9628},{9629,So,9629,9629,9629},{9630,So,9630,9630,9630},{9631,So,9631,9631,9631},{9632,So,9632,9632,9632},{9633,So,9633,9633,9633},{9634,So,9634,9634,9634},{9635,So,9635,9635,9635},{9636,So,9636,9636,9636},{9637,So,9637,9637,9637},{9638,So,9638,9638,9638},{9639,So,9639,9639,9639},{9640,So,9640,9640,9640},{9641,So,9641,9641,9641},{9642,So,9642,9642,9642},{9643,So,9643,9643,9643},{9644,So,9644,9644,9644},{9645,So,9645,9645,9645},{9646,So,9646,9646,9646},{9647,So,9647,9647,9647},{9648,So,9648,9648,9648},{9649,So,9649,9649,9649},{9650,So,9650,9650,9650},{9651,So,9651,9651,9651},{9652,So,9652,9652,9652},{9653,So,9653,9653,9653},{9654,So,9654,9654,9654},{9655,Sm,9655,9655,9655},{9656,So,9656,9656,9656},{9657,So,9657,9657,9657},{9658,So,9658,9658,9658},{9659,So,9659,9659,9659},{9660,So,9660,9660,9660},{9661,So,9661,9661,9661},{9662,So,9662,9662,9662},{9663,So,9663,9663,9663},{9664,So,9664,9664,9664},{9665,Sm,9665,9665,9665},{9666,So,9666,9666,9666},{9667,So,9667,9667,9667},{9668,So,9668,9668,9668},{9669,So,9669,9669,9669},{9670,So,9670,9670,9670},{9671,So,9671,9671,9671},{9672,So,9672,9672,9672},{9673,So,9673,9673,9673},{9674,So,9674,9674,9674},{9675,So,9675,9675,9675},{9676,So,9676,9676,9676},{9677,So,9677,9677,9677},{9678,So,9678,9678,9678},{9679,So,9679,9679,9679},{9680,So,9680,9680,9680},{9681,So,9681,9681,9681},{9682,So,9682,9682,9682},{9683,So,9683,9683,9683},{9684,So,9684,9684,9684},{9685,So,9685,9685,9685},{9686,So,9686,9686,9686},{9687,So,9687,9687,9687},{9688,So,9688,9688,9688},{9689,So,9689,9689,9689},{9690,So,9690,9690,9690},{9691,So,9691,9691,9691},{9692,So,9692,9692,9692},{9693,So,9693,9693,9693},{9694,So,9694,9694,9694},{9695,So,9695,9695,9695},{9696,So,9696,9696,9696},{9697,So,9697,9697,9697},{9698,So,9698,9698,9698},{9699,So,9699,9699,9699},{9700,So,9700,9700,9700},{9701,So,9701,9701,9701},{9702,So,9702,9702,9702},{9703,So,9703,9703,9703},{9704,So,9704,9704,9704},{9705,So,9705,9705,9705},{9706,So,9706,9706,9706},{9707,So,9707,9707,9707},{9708,So,9708,9708,9708},{9709,So,9709,9709,9709},{9710,So,9710,9710,9710},{9711,So,9711,9711,9711},{9712,So,9712,9712,9712},{9713,So,9713,9713,9713},{9714,So,9714,9714,9714},{9715,So,9715,9715,9715},{9716,So,9716,9716,9716},{9717,So,9717,9717,9717},{9718,So,9718,9718,9718},{9719,So,9719,9719,9719},{9720,Sm,9720,9720,9720},{9721,Sm,9721,9721,9721},{9722,Sm,9722,9722,9722},{9723,Sm,9723,9723,9723},{9724,Sm,9724,9724,9724},{9725,Sm,9725,9725,9725},{9726,Sm,9726,9726,9726},{9727,Sm,9727,9727,9727},{9728,So,9728,9728,9728},{9729,So,9729,9729,9729},{9730,So,9730,9730,9730},{9731,So,9731,9731,9731},{9732,So,9732,9732,9732},{9733,So,9733,9733,9733},{9734,So,9734,9734,9734},{9735,So,9735,9735,9735},{9736,So,9736,9736,9736},{9737,So,9737,9737,9737},{9738,So,9738,9738,9738},{9739,So,9739,9739,9739},{9740,So,9740,9740,9740},{9741,So,9741,9741,9741},{9742,So,9742,9742,9742},{9743,So,9743,9743,9743},{9744,So,9744,9744,9744},{9745,So,9745,9745,9745},{9746,So,9746,9746,9746},{9747,So,9747,9747,9747},{9748,So,9748,9748,9748},{9749,So,9749,9749,9749},{9750,So,9750,9750,9750},{9751,So,9751,9751,9751},{9752,So,9752,9752,9752},{9753,So,9753,9753,9753},{9754,So,9754,9754,9754},{9755,So,9755,9755,9755},{9756,So,9756,9756,9756},{9757,So,9757,9757,9757},{9758,So,9758,9758,9758},{9759,So,9759,9759,9759},{9760,So,9760,9760,9760},{9761,So,9761,9761,9761},{9762,So,9762,9762,9762},{9763,So,9763,9763,9763},{9764,So,9764,9764,9764},{9765,So,9765,9765,9765},{9766,So,9766,9766,9766},{9767,So,9767,9767,9767},{9768,So,9768,9768,9768},{9769,So,9769,9769,9769},{9770,So,9770,9770,9770},{9771,So,9771,9771,9771},{9772,So,9772,9772,9772},{9773,So,9773,9773,9773},{9774,So,9774,9774,9774},{9775,So,9775,9775,9775},{9776,So,9776,9776,9776},{9777,So,9777,9777,9777},{9778,So,9778,9778,9778},{9779,So,9779,9779,9779},{9780,So,9780,9780,9780},{9781,So,9781,9781,9781},{9782,So,9782,9782,9782},{9783,So,9783,9783,9783},{9784,So,9784,9784,9784},{9785,So,9785,9785,9785},{9786,So,9786,9786,9786},{9787,So,9787,9787,9787},{9788,So,9788,9788,9788},{9789,So,9789,9789,9789},{9790,So,9790,9790,9790},{9791,So,9791,9791,9791},{9792,So,9792,9792,9792},{9793,So,9793,9793,9793},{9794,So,9794,9794,9794},{9795,So,9795,9795,9795},{9796,So,9796,9796,9796},{9797,So,9797,9797,9797},{9798,So,9798,9798,9798},{9799,So,9799,9799,9799},{9800,So,9800,9800,9800},{9801,So,9801,9801,9801},{9802,So,9802,9802,9802},{9803,So,9803,9803,9803},{9804,So,9804,9804,9804},{9805,So,9805,9805,9805},{9806,So,9806,9806,9806},{9807,So,9807,9807,9807},{9808,So,9808,9808,9808},{9809,So,9809,9809,9809},{9810,So,9810,9810,9810},{9811,So,9811,9811,9811},{9812,So,9812,9812,9812},{9813,So,9813,9813,9813},{9814,So,9814,9814,9814},{9815,So,9815,9815,9815},{9816,So,9816,9816,9816},{9817,So,9817,9817,9817},{9818,So,9818,9818,9818},{9819,So,9819,9819,9819},{9820,So,9820,9820,9820},{9821,So,9821,9821,9821},{9822,So,9822,9822,9822},{9823,So,9823,9823,9823},{9824,So,9824,9824,9824},{9825,So,9825,9825,9825},{9826,So,9826,9826,9826},{9827,So,9827,9827,9827},{9828,So,9828,9828,9828},{9829,So,9829,9829,9829},{9830,So,9830,9830,9830},{9831,So,9831,9831,9831},{9832,So,9832,9832,9832},{9833,So,9833,9833,9833},{9834,So,9834,9834,9834},{9835,So,9835,9835,9835},{9836,So,9836,9836,9836},{9837,So,9837,9837,9837},{9838,So,9838,9838,9838},{9839,Sm,9839,9839,9839},{9840,So,9840,9840,9840},{9841,So,9841,9841,9841},{9842,So,9842,9842,9842},{9843,So,9843,9843,9843},{9844,So,9844,9844,9844},{9845,So,9845,9845,9845},{9846,So,9846,9846,9846},{9847,So,9847,9847,9847},{9848,So,9848,9848,9848},{9849,So,9849,9849,9849},{9850,So,9850,9850,9850},{9851,So,9851,9851,9851},{9852,So,9852,9852,9852},{9853,So,9853,9853,9853},{9854,So,9854,9854,9854},{9855,So,9855,9855,9855},{9856,So,9856,9856,9856},{9857,So,9857,9857,9857},{9858,So,9858,9858,9858},{9859,So,9859,9859,9859},{9860,So,9860,9860,9860},{9861,So,9861,9861,9861},{9862,So,9862,9862,9862},{9863,So,9863,9863,9863},{9864,So,9864,9864,9864},{9865,So,9865,9865,9865},{9866,So,9866,9866,9866},{9867,So,9867,9867,9867},{9868,So,9868,9868,9868},{9869,So,9869,9869,9869},{9870,So,9870,9870,9870},{9871,So,9871,9871,9871},{9872,So,9872,9872,9872},{9873,So,9873,9873,9873},{9874,So,9874,9874,9874},{9875,So,9875,9875,9875},{9876,So,9876,9876,9876},{9877,So,9877,9877,9877},{9878,So,9878,9878,9878},{9879,So,9879,9879,9879},{9880,So,9880,9880,9880},{9881,So,9881,9881,9881},{9882,So,9882,9882,9882},{9883,So,9883,9883,9883},{9884,So,9884,9884,9884},{9888,So,9888,9888,9888},{9889,So,9889,9889,9889},{9890,So,9890,9890,9890},{9891,So,9891,9891,9891},{9892,So,9892,9892,9892},{9893,So,9893,9893,9893},{9894,So,9894,9894,9894},{9895,So,9895,9895,9895},{9896,So,9896,9896,9896},{9897,So,9897,9897,9897},{9898,So,9898,9898,9898},{9899,So,9899,9899,9899},{9900,So,9900,9900,9900},{9901,So,9901,9901,9901},{9902,So,9902,9902,9902},{9903,So,9903,9903,9903},{9904,So,9904,9904,9904},{9905,So,9905,9905,9905},{9906,So,9906,9906,9906},{9985,So,9985,9985,9985},{9986,So,9986,9986,9986},{9987,So,9987,9987,9987},{9988,So,9988,9988,9988},{9990,So,9990,9990,9990},{9991,So,9991,9991,9991},{9992,So,9992,9992,9992},{9993,So,9993,9993,9993},{9996,So,9996,9996,9996},{9997,So,9997,9997,9997},{9998,So,9998,9998,9998},{9999,So,9999,9999,9999},{10000,So,10000,10000,10000},{10001,So,10001,10001,10001},{10002,So,10002,10002,10002},{10003,So,10003,10003,10003},{10004,So,10004,10004,10004},{10005,So,10005,10005,10005},{10006,So,10006,10006,10006},{10007,So,10007,10007,10007},{10008,So,10008,10008,10008},{10009,So,10009,10009,10009},{10010,So,10010,10010,10010},{10011,So,10011,10011,10011},{10012,So,10012,10012,10012},{10013,So,10013,10013,10013},{10014,So,10014,10014,10014},{10015,So,10015,10015,10015},{10016,So,10016,10016,10016},{10017,So,10017,10017,10017},{10018,So,10018,10018,10018},{10019,So,10019,10019,10019},{10020,So,10020,10020,10020},{10021,So,10021,10021,10021},{10022,So,10022,10022,10022},{10023,So,10023,10023,10023},{10025,So,10025,10025,10025},{10026,So,10026,10026,10026},{10027,So,10027,10027,10027},{10028,So,10028,10028,10028},{10029,So,10029,10029,10029},{10030,So,10030,10030,10030},{10031,So,10031,10031,10031},{10032,So,10032,10032,10032},{10033,So,10033,10033,10033},{10034,So,10034,10034,10034},{10035,So,10035,10035,10035},{10036,So,10036,10036,10036},{10037,So,10037,10037,10037},{10038,So,10038,10038,10038},{10039,So,10039,10039,10039},{10040,So,10040,10040,10040},{10041,So,10041,10041,10041},{10042,So,10042,10042,10042},{10043,So,10043,10043,10043},{10044,So,10044,10044,10044},{10045,So,10045,10045,10045},{10046,So,10046,10046,10046},{10047,So,10047,10047,10047},{10048,So,10048,10048,10048},{10049,So,10049,10049,10049},{10050,So,10050,10050,10050},{10051,So,10051,10051,10051},{10052,So,10052,10052,10052},{10053,So,10053,10053,10053},{10054,So,10054,10054,10054},{10055,So,10055,10055,10055},{10056,So,10056,10056,10056},{10057,So,10057,10057,10057},{10058,So,10058,10058,10058},{10059,So,10059,10059,10059},{10061,So,10061,10061,10061},{10063,So,10063,10063,10063},{10064,So,10064,10064,10064},{10065,So,10065,10065,10065},{10066,So,10066,10066,10066},{10070,So,10070,10070,10070},{10072,So,10072,10072,10072},{10073,So,10073,10073,10073},{10074,So,10074,10074,10074},{10075,So,10075,10075,10075},{10076,So,10076,10076,10076},{10077,So,10077,10077,10077},{10078,So,10078,10078,10078},{10081,So,10081,10081,10081},{10082,So,10082,10082,10082},{10083,So,10083,10083,10083},{10084,So,10084,10084,10084},{10085,So,10085,10085,10085},{10086,So,10086,10086,10086},{10087,So,10087,10087,10087},{10088,Ps,10088,10088,10088},{10089,Pe,10089,10089,10089},{10090,Ps,10090,10090,10090},{10091,Pe,10091,10091,10091},{10092,Ps,10092,10092,10092},{10093,Pe,10093,10093,10093},{10094,Ps,10094,10094,10094},{10095,Pe,10095,10095,10095},{10096,Ps,10096,10096,10096},{10097,Pe,10097,10097,10097},{10098,Ps,10098,10098,10098},{10099,Pe,10099,10099,10099},{10100,Ps,10100,10100,10100},{10101,Pe,10101,10101,10101},{10102,No,10102,10102,10102},{10103,No,10103,10103,10103},{10104,No,10104,10104,10104},{10105,No,10105,10105,10105},{10106,No,10106,10106,10106},{10107,No,10107,10107,10107},{10108,No,10108,10108,10108},{10109,No,10109,10109,10109},{10110,No,10110,10110,10110},{10111,No,10111,10111,10111},{10112,No,10112,10112,10112},{10113,No,10113,10113,10113},{10114,No,10114,10114,10114},{10115,No,10115,10115,10115},{10116,No,10116,10116,10116},{10117,No,10117,10117,10117},{10118,No,10118,10118,10118},{10119,No,10119,10119,10119},{10120,No,10120,10120,10120},{10121,No,10121,10121,10121},{10122,No,10122,10122,10122},{10123,No,10123,10123,10123},{10124,No,10124,10124,10124},{10125,No,10125,10125,10125},{10126,No,10126,10126,10126},{10127,No,10127,10127,10127},{10128,No,10128,10128,10128},{10129,No,10129,10129,10129},{10130,No,10130,10130,10130},{10131,No,10131,10131,10131},{10132,So,10132,10132,10132},{10136,So,10136,10136,10136},{10137,So,10137,10137,10137},{10138,So,10138,10138,10138},{10139,So,10139,10139,10139},{10140,So,10140,10140,10140},{10141,So,10141,10141,10141},{10142,So,10142,10142,10142},{10143,So,10143,10143,10143},{10144,So,10144,10144,10144},{10145,So,10145,10145,10145},{10146,So,10146,10146,10146},{10147,So,10147,10147,10147},{10148,So,10148,10148,10148},{10149,So,10149,10149,10149},{10150,So,10150,10150,10150},{10151,So,10151,10151,10151},{10152,So,10152,10152,10152},{10153,So,10153,10153,10153},{10154,So,10154,10154,10154},{10155,So,10155,10155,10155},{10156,So,10156,10156,10156},{10157,So,10157,10157,10157},{10158,So,10158,10158,10158},{10159,So,10159,10159,10159},{10161,So,10161,10161,10161},{10162,So,10162,10162,10162},{10163,So,10163,10163,10163},{10164,So,10164,10164,10164},{10165,So,10165,10165,10165},{10166,So,10166,10166,10166},{10167,So,10167,10167,10167},{10168,So,10168,10168,10168},{10169,So,10169,10169,10169},{10170,So,10170,10170,10170},{10171,So,10171,10171,10171},{10172,So,10172,10172,10172},{10173,So,10173,10173,10173},{10174,So,10174,10174,10174},{10176,Sm,10176,10176,10176},{10177,Sm,10177,10177,10177},{10178,Sm,10178,10178,10178},{10179,Sm,10179,10179,10179},{10180,Sm,10180,10180,10180},{10181,Ps,10181,10181,10181},{10182,Pe,10182,10182,10182},{10183,Sm,10183,10183,10183},{10184,Sm,10184,10184,10184},{10185,Sm,10185,10185,10185},{10186,Sm,10186,10186,10186},{10192,Sm,10192,10192,10192},{10193,Sm,10193,10193,10193},{10194,Sm,10194,10194,10194},{10195,Sm,10195,10195,10195},{10196,Sm,10196,10196,10196},{10197,Sm,10197,10197,10197},{10198,Sm,10198,10198,10198},{10199,Sm,10199,10199,10199},{10200,Sm,10200,10200,10200},{10201,Sm,10201,10201,10201},{10202,Sm,10202,10202,10202},{10203,Sm,10203,10203,10203},{10204,Sm,10204,10204,10204},{10205,Sm,10205,10205,10205},{10206,Sm,10206,10206,10206},{10207,Sm,10207,10207,10207},{10208,Sm,10208,10208,10208},{10209,Sm,10209,10209,10209},{10210,Sm,10210,10210,10210},{10211,Sm,10211,10211,10211},{10212,Sm,10212,10212,10212},{10213,Sm,10213,10213,10213},{10214,Ps,10214,10214,10214},{10215,Pe,10215,10215,10215},{10216,Ps,10216,10216,10216},{10217,Pe,10217,10217,10217},{10218,Ps,10218,10218,10218},{10219,Pe,10219,10219,10219},{10224,Sm,10224,10224,10224},{10225,Sm,10225,10225,10225},{10226,Sm,10226,10226,10226},{10227,Sm,10227,10227,10227},{10228,Sm,10228,10228,10228},{10229,Sm,10229,10229,10229},{10230,Sm,10230,10230,10230},{10231,Sm,10231,10231,10231},{10232,Sm,10232,10232,10232},{10233,Sm,10233,10233,10233},{10234,Sm,10234,10234,10234},{10235,Sm,10235,10235,10235},{10236,Sm,10236,10236,10236},{10237,Sm,10237,10237,10237},{10238,Sm,10238,10238,10238},{10239,Sm,10239,10239,10239},{10240,So,10240,10240,10240},{10241,So,10241,10241,10241},{10242,So,10242,10242,10242},{10243,So,10243,10243,10243},{10244,So,10244,10244,10244},{10245,So,10245,10245,10245},{10246,So,10246,10246,10246},{10247,So,10247,10247,10247},{10248,So,10248,10248,10248},{10249,So,10249,10249,10249},{10250,So,10250,10250,10250},{10251,So,10251,10251,10251},{10252,So,10252,10252,10252},{10253,So,10253,10253,10253},{10254,So,10254,10254,10254},{10255,So,10255,10255,10255},{10256,So,10256,10256,10256},{10257,So,10257,10257,10257},{10258,So,10258,10258,10258},{10259,So,10259,10259,10259},{10260,So,10260,10260,10260},{10261,So,10261,10261,10261},{10262,So,10262,10262,10262},{10263,So,10263,10263,10263},{10264,So,10264,10264,10264},{10265,So,10265,10265,10265},{10266,So,10266,10266,10266},{10267,So,10267,10267,10267},{10268,So,10268,10268,10268},{10269,So,10269,10269,10269},{10270,So,10270,10270,10270},{10271,So,10271,10271,10271},{10272,So,10272,10272,10272},{10273,So,10273,10273,10273},{10274,So,10274,10274,10274},{10275,So,10275,10275,10275},{10276,So,10276,10276,10276},{10277,So,10277,10277,10277},{10278,So,10278,10278,10278},{10279,So,10279,10279,10279},{10280,So,10280,10280,10280},{10281,So,10281,10281,10281},{10282,So,10282,10282,10282},{10283,So,10283,10283,10283},{10284,So,10284,10284,10284},{10285,So,10285,10285,10285},{10286,So,10286,10286,10286},{10287,So,10287,10287,10287},{10288,So,10288,10288,10288},{10289,So,10289,10289,10289},{10290,So,10290,10290,10290},{10291,So,10291,10291,10291},{10292,So,10292,10292,10292},{10293,So,10293,10293,10293},{10294,So,10294,10294,10294},{10295,So,10295,10295,10295},{10296,So,10296,10296,10296},{10297,So,10297,10297,10297},{10298,So,10298,10298,10298},{10299,So,10299,10299,10299},{10300,So,10300,10300,10300},{10301,So,10301,10301,10301},{10302,So,10302,10302,10302},{10303,So,10303,10303,10303},{10304,So,10304,10304,10304},{10305,So,10305,10305,10305},{10306,So,10306,10306,10306},{10307,So,10307,10307,10307},{10308,So,10308,10308,10308},{10309,So,10309,10309,10309},{10310,So,10310,10310,10310},{10311,So,10311,10311,10311},{10312,So,10312,10312,10312},{10313,So,10313,10313,10313},{10314,So,10314,10314,10314},{10315,So,10315,10315,10315},{10316,So,10316,10316,10316},{10317,So,10317,10317,10317},{10318,So,10318,10318,10318},{10319,So,10319,10319,10319},{10320,So,10320,10320,10320},{10321,So,10321,10321,10321},{10322,So,10322,10322,10322},{10323,So,10323,10323,10323},{10324,So,10324,10324,10324},{10325,So,10325,10325,10325},{10326,So,10326,10326,10326},{10327,So,10327,10327,10327},{10328,So,10328,10328,10328},{10329,So,10329,10329,10329},{10330,So,10330,10330,10330},{10331,So,10331,10331,10331},{10332,So,10332,10332,10332},{10333,So,10333,10333,10333},{10334,So,10334,10334,10334},{10335,So,10335,10335,10335},{10336,So,10336,10336,10336},{10337,So,10337,10337,10337},{10338,So,10338,10338,10338},{10339,So,10339,10339,10339},{10340,So,10340,10340,10340},{10341,So,10341,10341,10341},{10342,So,10342,10342,10342},{10343,So,10343,10343,10343},{10344,So,10344,10344,10344},{10345,So,10345,10345,10345},{10346,So,10346,10346,10346},{10347,So,10347,10347,10347},{10348,So,10348,10348,10348},{10349,So,10349,10349,10349},{10350,So,10350,10350,10350},{10351,So,10351,10351,10351},{10352,So,10352,10352,10352},{10353,So,10353,10353,10353},{10354,So,10354,10354,10354},{10355,So,10355,10355,10355},{10356,So,10356,10356,10356},{10357,So,10357,10357,10357},{10358,So,10358,10358,10358},{10359,So,10359,10359,10359},{10360,So,10360,10360,10360},{10361,So,10361,10361,10361},{10362,So,10362,10362,10362},{10363,So,10363,10363,10363},{10364,So,10364,10364,10364},{10365,So,10365,10365,10365},{10366,So,10366,10366,10366},{10367,So,10367,10367,10367},{10368,So,10368,10368,10368},{10369,So,10369,10369,10369},{10370,So,10370,10370,10370},{10371,So,10371,10371,10371},{10372,So,10372,10372,10372},{10373,So,10373,10373,10373},{10374,So,10374,10374,10374},{10375,So,10375,10375,10375},{10376,So,10376,10376,10376},{10377,So,10377,10377,10377},{10378,So,10378,10378,10378},{10379,So,10379,10379,10379},{10380,So,10380,10380,10380},{10381,So,10381,10381,10381},{10382,So,10382,10382,10382},{10383,So,10383,10383,10383},{10384,So,10384,10384,10384},{10385,So,10385,10385,10385},{10386,So,10386,10386,10386},{10387,So,10387,10387,10387},{10388,So,10388,10388,10388},{10389,So,10389,10389,10389},{10390,So,10390,10390,10390},{10391,So,10391,10391,10391},{10392,So,10392,10392,10392},{10393,So,10393,10393,10393},{10394,So,10394,10394,10394},{10395,So,10395,10395,10395},{10396,So,10396,10396,10396},{10397,So,10397,10397,10397},{10398,So,10398,10398,10398},{10399,So,10399,10399,10399},{10400,So,10400,10400,10400},{10401,So,10401,10401,10401},{10402,So,10402,10402,10402},{10403,So,10403,10403,10403},{10404,So,10404,10404,10404},{10405,So,10405,10405,10405},{10406,So,10406,10406,10406},{10407,So,10407,10407,10407},{10408,So,10408,10408,10408},{10409,So,10409,10409,10409},{10410,So,10410,10410,10410},{10411,So,10411,10411,10411},{10412,So,10412,10412,10412},{10413,So,10413,10413,10413},{10414,So,10414,10414,10414},{10415,So,10415,10415,10415},{10416,So,10416,10416,10416},{10417,So,10417,10417,10417},{10418,So,10418,10418,10418},{10419,So,10419,10419,10419},{10420,So,10420,10420,10420},{10421,So,10421,10421,10421},{10422,So,10422,10422,10422},{10423,So,10423,10423,10423},{10424,So,10424,10424,10424},{10425,So,10425,10425,10425},{10426,So,10426,10426,10426},{10427,So,10427,10427,10427},{10428,So,10428,10428,10428},{10429,So,10429,10429,10429},{10430,So,10430,10430,10430},{10431,So,10431,10431,10431},{10432,So,10432,10432,10432},{10433,So,10433,10433,10433},{10434,So,10434,10434,10434},{10435,So,10435,10435,10435},{10436,So,10436,10436,10436},{10437,So,10437,10437,10437},{10438,So,10438,10438,10438},{10439,So,10439,10439,10439},{10440,So,10440,10440,10440},{10441,So,10441,10441,10441},{10442,So,10442,10442,10442},{10443,So,10443,10443,10443},{10444,So,10444,10444,10444},{10445,So,10445,10445,10445},{10446,So,10446,10446,10446},{10447,So,10447,10447,10447},{10448,So,10448,10448,10448},{10449,So,10449,10449,10449},{10450,So,10450,10450,10450},{10451,So,10451,10451,10451},{10452,So,10452,10452,10452},{10453,So,10453,10453,10453},{10454,So,10454,10454,10454},{10455,So,10455,10455,10455},{10456,So,10456,10456,10456},{10457,So,10457,10457,10457},{10458,So,10458,10458,10458},{10459,So,10459,10459,10459},{10460,So,10460,10460,10460},{10461,So,10461,10461,10461},{10462,So,10462,10462,10462},{10463,So,10463,10463,10463},{10464,So,10464,10464,10464},{10465,So,10465,10465,10465},{10466,So,10466,10466,10466},{10467,So,10467,10467,10467},{10468,So,10468,10468,10468},{10469,So,10469,10469,10469},{10470,So,10470,10470,10470},{10471,So,10471,10471,10471},{10472,So,10472,10472,10472},{10473,So,10473,10473,10473},{10474,So,10474,10474,10474},{10475,So,10475,10475,10475},{10476,So,10476,10476,10476},{10477,So,10477,10477,10477},{10478,So,10478,10478,10478},{10479,So,10479,10479,10479},{10480,So,10480,10480,10480},{10481,So,10481,10481,10481},{10482,So,10482,10482,10482},{10483,So,10483,10483,10483},{10484,So,10484,10484,10484},{10485,So,10485,10485,10485},{10486,So,10486,10486,10486},{10487,So,10487,10487,10487},{10488,So,10488,10488,10488},{10489,So,10489,10489,10489},{10490,So,10490,10490,10490},{10491,So,10491,10491,10491},{10492,So,10492,10492,10492},{10493,So,10493,10493,10493},{10494,So,10494,10494,10494},{10495,So,10495,10495,10495},{10496,Sm,10496,10496,10496},{10497,Sm,10497,10497,10497},{10498,Sm,10498,10498,10498},{10499,Sm,10499,10499,10499},{10500,Sm,10500,10500,10500},{10501,Sm,10501,10501,10501},{10502,Sm,10502,10502,10502},{10503,Sm,10503,10503,10503},{10504,Sm,10504,10504,10504},{10505,Sm,10505,10505,10505},{10506,Sm,10506,10506,10506},{10507,Sm,10507,10507,10507},{10508,Sm,10508,10508,10508},{10509,Sm,10509,10509,10509},{10510,Sm,10510,10510,10510},{10511,Sm,10511,10511,10511},{10512,Sm,10512,10512,10512},{10513,Sm,10513,10513,10513},{10514,Sm,10514,10514,10514},{10515,Sm,10515,10515,10515},{10516,Sm,10516,10516,10516},{10517,Sm,10517,10517,10517},{10518,Sm,10518,10518,10518},{10519,Sm,10519,10519,10519},{10520,Sm,10520,10520,10520},{10521,Sm,10521,10521,10521},{10522,Sm,10522,10522,10522},{10523,Sm,10523,10523,10523},{10524,Sm,10524,10524,10524},{10525,Sm,10525,10525,10525},{10526,Sm,10526,10526,10526},{10527,Sm,10527,10527,10527},{10528,Sm,10528,10528,10528},{10529,Sm,10529,10529,10529},{10530,Sm,10530,10530,10530},{10531,Sm,10531,10531,10531},{10532,Sm,10532,10532,10532},{10533,Sm,10533,10533,10533},{10534,Sm,10534,10534,10534},{10535,Sm,10535,10535,10535},{10536,Sm,10536,10536,10536},{10537,Sm,10537,10537,10537},{10538,Sm,10538,10538,10538},{10539,Sm,10539,10539,10539},{10540,Sm,10540,10540,10540},{10541,Sm,10541,10541,10541},{10542,Sm,10542,10542,10542},{10543,Sm,10543,10543,10543},{10544,Sm,10544,10544,10544},{10545,Sm,10545,10545,10545},{10546,Sm,10546,10546,10546},{10547,Sm,10547,10547,10547},{10548,Sm,10548,10548,10548},{10549,Sm,10549,10549,10549},{10550,Sm,10550,10550,10550},{10551,Sm,10551,10551,10551},{10552,Sm,10552,10552,10552},{10553,Sm,10553,10553,10553},{10554,Sm,10554,10554,10554},{10555,Sm,10555,10555,10555},{10556,Sm,10556,10556,10556},{10557,Sm,10557,10557,10557},{10558,Sm,10558,10558,10558},{10559,Sm,10559,10559,10559},{10560,Sm,10560,10560,10560},{10561,Sm,10561,10561,10561},{10562,Sm,10562,10562,10562},{10563,Sm,10563,10563,10563},{10564,Sm,10564,10564,10564},{10565,Sm,10565,10565,10565},{10566,Sm,10566,10566,10566},{10567,Sm,10567,10567,10567},{10568,Sm,10568,10568,10568},{10569,Sm,10569,10569,10569},{10570,Sm,10570,10570,10570},{10571,Sm,10571,10571,10571},{10572,Sm,10572,10572,10572},{10573,Sm,10573,10573,10573},{10574,Sm,10574,10574,10574},{10575,Sm,10575,10575,10575},{10576,Sm,10576,10576,10576},{10577,Sm,10577,10577,10577},{10578,Sm,10578,10578,10578},{10579,Sm,10579,10579,10579},{10580,Sm,10580,10580,10580},{10581,Sm,10581,10581,10581},{10582,Sm,10582,10582,10582},{10583,Sm,10583,10583,10583},{10584,Sm,10584,10584,10584},{10585,Sm,10585,10585,10585},{10586,Sm,10586,10586,10586},{10587,Sm,10587,10587,10587},{10588,Sm,10588,10588,10588},{10589,Sm,10589,10589,10589},{10590,Sm,10590,10590,10590},{10591,Sm,10591,10591,10591},{10592,Sm,10592,10592,10592},{10593,Sm,10593,10593,10593},{10594,Sm,10594,10594,10594},{10595,Sm,10595,10595,10595},{10596,Sm,10596,10596,10596},{10597,Sm,10597,10597,10597},{10598,Sm,10598,10598,10598},{10599,Sm,10599,10599,10599},{10600,Sm,10600,10600,10600},{10601,Sm,10601,10601,10601},{10602,Sm,10602,10602,10602},{10603,Sm,10603,10603,10603},{10604,Sm,10604,10604,10604},{10605,Sm,10605,10605,10605},{10606,Sm,10606,10606,10606},{10607,Sm,10607,10607,10607},{10608,Sm,10608,10608,10608},{10609,Sm,10609,10609,10609},{10610,Sm,10610,10610,10610},{10611,Sm,10611,10611,10611},{10612,Sm,10612,10612,10612},{10613,Sm,10613,10613,10613},{10614,Sm,10614,10614,10614},{10615,Sm,10615,10615,10615},{10616,Sm,10616,10616,10616},{10617,Sm,10617,10617,10617},{10618,Sm,10618,10618,10618},{10619,Sm,10619,10619,10619},{10620,Sm,10620,10620,10620},{10621,Sm,10621,10621,10621},{10622,Sm,10622,10622,10622},{10623,Sm,10623,10623,10623},{10624,Sm,10624,10624,10624},{10625,Sm,10625,10625,10625},{10626,Sm,10626,10626,10626},{10627,Ps,10627,10627,10627},{10628,Pe,10628,10628,10628},{10629,Ps,10629,10629,10629},{10630,Pe,10630,10630,10630},{10631,Ps,10631,10631,10631},{10632,Pe,10632,10632,10632},{10633,Ps,10633,10633,10633},{10634,Pe,10634,10634,10634},{10635,Ps,10635,10635,10635},{10636,Pe,10636,10636,10636},{10637,Ps,10637,10637,10637},{10638,Pe,10638,10638,10638},{10639,Ps,10639,10639,10639},{10640,Pe,10640,10640,10640},{10641,Ps,10641,10641,10641},{10642,Pe,10642,10642,10642},{10643,Ps,10643,10643,10643},{10644,Pe,10644,10644,10644},{10645,Ps,10645,10645,10645},{10646,Pe,10646,10646,10646},{10647,Ps,10647,10647,10647},{10648,Pe,10648,10648,10648},{10649,Sm,10649,10649,10649},{10650,Sm,10650,10650,10650},{10651,Sm,10651,10651,10651},{10652,Sm,10652,10652,10652},{10653,Sm,10653,10653,10653},{10654,Sm,10654,10654,10654},{10655,Sm,10655,10655,10655},{10656,Sm,10656,10656,10656},{10657,Sm,10657,10657,10657},{10658,Sm,10658,10658,10658},{10659,Sm,10659,10659,10659},{10660,Sm,10660,10660,10660},{10661,Sm,10661,10661,10661},{10662,Sm,10662,10662,10662},{10663,Sm,10663,10663,10663},{10664,Sm,10664,10664,10664},{10665,Sm,10665,10665,10665},{10666,Sm,10666,10666,10666},{10667,Sm,10667,10667,10667},{10668,Sm,10668,10668,10668},{10669,Sm,10669,10669,10669},{10670,Sm,10670,10670,10670},{10671,Sm,10671,10671,10671},{10672,Sm,10672,10672,10672},{10673,Sm,10673,10673,10673},{10674,Sm,10674,10674,10674},{10675,Sm,10675,10675,10675},{10676,Sm,10676,10676,10676},{10677,Sm,10677,10677,10677},{10678,Sm,10678,10678,10678},{10679,Sm,10679,10679,10679},{10680,Sm,10680,10680,10680},{10681,Sm,10681,10681,10681},{10682,Sm,10682,10682,10682},{10683,Sm,10683,10683,10683},{10684,Sm,10684,10684,10684},{10685,Sm,10685,10685,10685},{10686,Sm,10686,10686,10686},{10687,Sm,10687,10687,10687},{10688,Sm,10688,10688,10688},{10689,Sm,10689,10689,10689},{10690,Sm,10690,10690,10690},{10691,Sm,10691,10691,10691},{10692,Sm,10692,10692,10692},{10693,Sm,10693,10693,10693},{10694,Sm,10694,10694,10694},{10695,Sm,10695,10695,10695},{10696,Sm,10696,10696,10696},{10697,Sm,10697,10697,10697},{10698,Sm,10698,10698,10698},{10699,Sm,10699,10699,10699},{10700,Sm,10700,10700,10700},{10701,Sm,10701,10701,10701},{10702,Sm,10702,10702,10702},{10703,Sm,10703,10703,10703},{10704,Sm,10704,10704,10704},{10705,Sm,10705,10705,10705},{10706,Sm,10706,10706,10706},{10707,Sm,10707,10707,10707},{10708,Sm,10708,10708,10708},{10709,Sm,10709,10709,10709},{10710,Sm,10710,10710,10710},{10711,Sm,10711,10711,10711},{10712,Ps,10712,10712,10712},{10713,Pe,10713,10713,10713},{10714,Ps,10714,10714,10714},{10715,Pe,10715,10715,10715},{10716,Sm,10716,10716,10716},{10717,Sm,10717,10717,10717},{10718,Sm,10718,10718,10718},{10719,Sm,10719,10719,10719},{10720,Sm,10720,10720,10720},{10721,Sm,10721,10721,10721},{10722,Sm,10722,10722,10722},{10723,Sm,10723,10723,10723},{10724,Sm,10724,10724,10724},{10725,Sm,10725,10725,10725},{10726,Sm,10726,10726,10726},{10727,Sm,10727,10727,10727},{10728,Sm,10728,10728,10728},{10729,Sm,10729,10729,10729},{10730,Sm,10730,10730,10730},{10731,Sm,10731,10731,10731},{10732,Sm,10732,10732,10732},{10733,Sm,10733,10733,10733},{10734,Sm,10734,10734,10734},{10735,Sm,10735,10735,10735},{10736,Sm,10736,10736,10736},{10737,Sm,10737,10737,10737},{10738,Sm,10738,10738,10738},{10739,Sm,10739,10739,10739},{10740,Sm,10740,10740,10740},{10741,Sm,10741,10741,10741},{10742,Sm,10742,10742,10742},{10743,Sm,10743,10743,10743},{10744,Sm,10744,10744,10744},{10745,Sm,10745,10745,10745},{10746,Sm,10746,10746,10746},{10747,Sm,10747,10747,10747},{10748,Ps,10748,10748,10748},{10749,Pe,10749,10749,10749},{10750,Sm,10750,10750,10750},{10751,Sm,10751,10751,10751},{10752,Sm,10752,10752,10752},{10753,Sm,10753,10753,10753},{10754,Sm,10754,10754,10754},{10755,Sm,10755,10755,10755},{10756,Sm,10756,10756,10756},{10757,Sm,10757,10757,10757},{10758,Sm,10758,10758,10758},{10759,Sm,10759,10759,10759},{10760,Sm,10760,10760,10760},{10761,Sm,10761,10761,10761},{10762,Sm,10762,10762,10762},{10763,Sm,10763,10763,10763},{10764,Sm,10764,10764,10764},{10765,Sm,10765,10765,10765},{10766,Sm,10766,10766,10766},{10767,Sm,10767,10767,10767},{10768,Sm,10768,10768,10768},{10769,Sm,10769,10769,10769},{10770,Sm,10770,10770,10770},{10771,Sm,10771,10771,10771},{10772,Sm,10772,10772,10772},{10773,Sm,10773,10773,10773},{10774,Sm,10774,10774,10774},{10775,Sm,10775,10775,10775},{10776,Sm,10776,10776,10776},{10777,Sm,10777,10777,10777},{10778,Sm,10778,10778,10778},{10779,Sm,10779,10779,10779},{10780,Sm,10780,10780,10780},{10781,Sm,10781,10781,10781},{10782,Sm,10782,10782,10782},{10783,Sm,10783,10783,10783},{10784,Sm,10784,10784,10784},{10785,Sm,10785,10785,10785},{10786,Sm,10786,10786,10786},{10787,Sm,10787,10787,10787},{10788,Sm,10788,10788,10788},{10789,Sm,10789,10789,10789},{10790,Sm,10790,10790,10790},{10791,Sm,10791,10791,10791},{10792,Sm,10792,10792,10792},{10793,Sm,10793,10793,10793},{10794,Sm,10794,10794,10794},{10795,Sm,10795,10795,10795},{10796,Sm,10796,10796,10796},{10797,Sm,10797,10797,10797},{10798,Sm,10798,10798,10798},{10799,Sm,10799,10799,10799},{10800,Sm,10800,10800,10800},{10801,Sm,10801,10801,10801},{10802,Sm,10802,10802,10802},{10803,Sm,10803,10803,10803},{10804,Sm,10804,10804,10804},{10805,Sm,10805,10805,10805},{10806,Sm,10806,10806,10806},{10807,Sm,10807,10807,10807},{10808,Sm,10808,10808,10808},{10809,Sm,10809,10809,10809},{10810,Sm,10810,10810,10810},{10811,Sm,10811,10811,10811},{10812,Sm,10812,10812,10812},{10813,Sm,10813,10813,10813},{10814,Sm,10814,10814,10814},{10815,Sm,10815,10815,10815},{10816,Sm,10816,10816,10816},{10817,Sm,10817,10817,10817},{10818,Sm,10818,10818,10818},{10819,Sm,10819,10819,10819},{10820,Sm,10820,10820,10820},{10821,Sm,10821,10821,10821},{10822,Sm,10822,10822,10822},{10823,Sm,10823,10823,10823},{10824,Sm,10824,10824,10824},{10825,Sm,10825,10825,10825},{10826,Sm,10826,10826,10826},{10827,Sm,10827,10827,10827},{10828,Sm,10828,10828,10828},{10829,Sm,10829,10829,10829},{10830,Sm,10830,10830,10830},{10831,Sm,10831,10831,10831},{10832,Sm,10832,10832,10832},{10833,Sm,10833,10833,10833},{10834,Sm,10834,10834,10834},{10835,Sm,10835,10835,10835},{10836,Sm,10836,10836,10836},{10837,Sm,10837,10837,10837},{10838,Sm,10838,10838,10838},{10839,Sm,10839,10839,10839},{10840,Sm,10840,10840,10840},{10841,Sm,10841,10841,10841},{10842,Sm,10842,10842,10842},{10843,Sm,10843,10843,10843},{10844,Sm,10844,10844,10844},{10845,Sm,10845,10845,10845},{10846,Sm,10846,10846,10846},{10847,Sm,10847,10847,10847},{10848,Sm,10848,10848,10848},{10849,Sm,10849,10849,10849},{10850,Sm,10850,10850,10850},{10851,Sm,10851,10851,10851},{10852,Sm,10852,10852,10852},{10853,Sm,10853,10853,10853},{10854,Sm,10854,10854,10854},{10855,Sm,10855,10855,10855},{10856,Sm,10856,10856,10856},{10857,Sm,10857,10857,10857},{10858,Sm,10858,10858,10858},{10859,Sm,10859,10859,10859},{10860,Sm,10860,10860,10860},{10861,Sm,10861,10861,10861},{10862,Sm,10862,10862,10862},{10863,Sm,10863,10863,10863},{10864,Sm,10864,10864,10864},{10865,Sm,10865,10865,10865},{10866,Sm,10866,10866,10866},{10867,Sm,10867,10867,10867},{10868,Sm,10868,10868,10868},{10869,Sm,10869,10869,10869},{10870,Sm,10870,10870,10870},{10871,Sm,10871,10871,10871},{10872,Sm,10872,10872,10872},{10873,Sm,10873,10873,10873},{10874,Sm,10874,10874,10874},{10875,Sm,10875,10875,10875},{10876,Sm,10876,10876,10876},{10877,Sm,10877,10877,10877},{10878,Sm,10878,10878,10878},{10879,Sm,10879,10879,10879},{10880,Sm,10880,10880,10880},{10881,Sm,10881,10881,10881},{10882,Sm,10882,10882,10882},{10883,Sm,10883,10883,10883},{10884,Sm,10884,10884,10884},{10885,Sm,10885,10885,10885},{10886,Sm,10886,10886,10886},{10887,Sm,10887,10887,10887},{10888,Sm,10888,10888,10888},{10889,Sm,10889,10889,10889},{10890,Sm,10890,10890,10890},{10891,Sm,10891,10891,10891},{10892,Sm,10892,10892,10892},{10893,Sm,10893,10893,10893},{10894,Sm,10894,10894,10894},{10895,Sm,10895,10895,10895},{10896,Sm,10896,10896,10896},{10897,Sm,10897,10897,10897},{10898,Sm,10898,10898,10898},{10899,Sm,10899,10899,10899},{10900,Sm,10900,10900,10900},{10901,Sm,10901,10901,10901},{10902,Sm,10902,10902,10902},{10903,Sm,10903,10903,10903},{10904,Sm,10904,10904,10904},{10905,Sm,10905,10905,10905},{10906,Sm,10906,10906,10906},{10907,Sm,10907,10907,10907},{10908,Sm,10908,10908,10908},{10909,Sm,10909,10909,10909},{10910,Sm,10910,10910,10910},{10911,Sm,10911,10911,10911},{10912,Sm,10912,10912,10912},{10913,Sm,10913,10913,10913},{10914,Sm,10914,10914,10914},{10915,Sm,10915,10915,10915},{10916,Sm,10916,10916,10916},{10917,Sm,10917,10917,10917},{10918,Sm,10918,10918,10918},{10919,Sm,10919,10919,10919},{10920,Sm,10920,10920,10920},{10921,Sm,10921,10921,10921},{10922,Sm,10922,10922,10922},{10923,Sm,10923,10923,10923},{10924,Sm,10924,10924,10924},{10925,Sm,10925,10925,10925},{10926,Sm,10926,10926,10926},{10927,Sm,10927,10927,10927},{10928,Sm,10928,10928,10928},{10929,Sm,10929,10929,10929},{10930,Sm,10930,10930,10930},{10931,Sm,10931,10931,10931},{10932,Sm,10932,10932,10932},{10933,Sm,10933,10933,10933},{10934,Sm,10934,10934,10934},{10935,Sm,10935,10935,10935},{10936,Sm,10936,10936,10936},{10937,Sm,10937,10937,10937},{10938,Sm,10938,10938,10938},{10939,Sm,10939,10939,10939},{10940,Sm,10940,10940,10940},{10941,Sm,10941,10941,10941},{10942,Sm,10942,10942,10942},{10943,Sm,10943,10943,10943},{10944,Sm,10944,10944,10944},{10945,Sm,10945,10945,10945},{10946,Sm,10946,10946,10946},{10947,Sm,10947,10947,10947},{10948,Sm,10948,10948,10948},{10949,Sm,10949,10949,10949},{10950,Sm,10950,10950,10950},{10951,Sm,10951,10951,10951},{10952,Sm,10952,10952,10952},{10953,Sm,10953,10953,10953},{10954,Sm,10954,10954,10954},{10955,Sm,10955,10955,10955},{10956,Sm,10956,10956,10956},{10957,Sm,10957,10957,10957},{10958,Sm,10958,10958,10958},{10959,Sm,10959,10959,10959},{10960,Sm,10960,10960,10960},{10961,Sm,10961,10961,10961},{10962,Sm,10962,10962,10962},{10963,Sm,10963,10963,10963},{10964,Sm,10964,10964,10964},{10965,Sm,10965,10965,10965},{10966,Sm,10966,10966,10966},{10967,Sm,10967,10967,10967},{10968,Sm,10968,10968,10968},{10969,Sm,10969,10969,10969},{10970,Sm,10970,10970,10970},{10971,Sm,10971,10971,10971},{10972,Sm,10972,10972,10972},{10973,Sm,10973,10973,10973},{10974,Sm,10974,10974,10974},{10975,Sm,10975,10975,10975},{10976,Sm,10976,10976,10976},{10977,Sm,10977,10977,10977},{10978,Sm,10978,10978,10978},{10979,Sm,10979,10979,10979},{10980,Sm,10980,10980,10980},{10981,Sm,10981,10981,10981},{10982,Sm,10982,10982,10982},{10983,Sm,10983,10983,10983},{10984,Sm,10984,10984,10984},{10985,Sm,10985,10985,10985},{10986,Sm,10986,10986,10986},{10987,Sm,10987,10987,10987},{10988,Sm,10988,10988,10988},{10989,Sm,10989,10989,10989},{10990,Sm,10990,10990,10990},{10991,Sm,10991,10991,10991},{10992,Sm,10992,10992,10992},{10993,Sm,10993,10993,10993},{10994,Sm,10994,10994,10994},{10995,Sm,10995,10995,10995},{10996,Sm,10996,10996,10996},{10997,Sm,10997,10997,10997},{10998,Sm,10998,10998,10998},{10999,Sm,10999,10999,10999},{11000,Sm,11000,11000,11000},{11001,Sm,11001,11001,11001},{11002,Sm,11002,11002,11002},{11003,Sm,11003,11003,11003},{11004,Sm,11004,11004,11004},{11005,Sm,11005,11005,11005},{11006,Sm,11006,11006,11006},{11007,Sm,11007,11007,11007},{11008,So,11008,11008,11008},{11009,So,11009,11009,11009},{11010,So,11010,11010,11010},{11011,So,11011,11011,11011},{11012,So,11012,11012,11012},{11013,So,11013,11013,11013},{11014,So,11014,11014,11014},{11015,So,11015,11015,11015},{11016,So,11016,11016,11016},{11017,So,11017,11017,11017},{11018,So,11018,11018,11018},{11019,So,11019,11019,11019},{11020,So,11020,11020,11020},{11021,So,11021,11021,11021},{11022,So,11022,11022,11022},{11023,So,11023,11023,11023},{11024,So,11024,11024,11024},{11025,So,11025,11025,11025},{11026,So,11026,11026,11026},{11027,So,11027,11027,11027},{11028,So,11028,11028,11028},{11029,So,11029,11029,11029},{11030,So,11030,11030,11030},{11031,So,11031,11031,11031},{11032,So,11032,11032,11032},{11033,So,11033,11033,11033},{11034,So,11034,11034,11034},{11040,So,11040,11040,11040},{11041,So,11041,11041,11041},{11042,So,11042,11042,11042},{11043,So,11043,11043,11043},{11264,Lu,11264,11312,11264},{11265,Lu,11265,11313,11265},{11266,Lu,11266,11314,11266},{11267,Lu,11267,11315,11267},{11268,Lu,11268,11316,11268},{11269,Lu,11269,11317,11269},{11270,Lu,11270,11318,11270},{11271,Lu,11271,11319,11271},{11272,Lu,11272,11320,11272},{11273,Lu,11273,11321,11273},{11274,Lu,11274,11322,11274},{11275,Lu,11275,11323,11275},{11276,Lu,11276,11324,11276},{11277,Lu,11277,11325,11277},{11278,Lu,11278,11326,11278},{11279,Lu,11279,11327,11279},{11280,Lu,11280,11328,11280},{11281,Lu,11281,11329,11281},{11282,Lu,11282,11330,11282},{11283,Lu,11283,11331,11283},{11284,Lu,11284,11332,11284},{11285,Lu,11285,11333,11285},{11286,Lu,11286,11334,11286},{11287,Lu,11287,11335,11287},{11288,Lu,11288,11336,11288},{11289,Lu,11289,11337,11289},{11290,Lu,11290,11338,11290},{11291,Lu,11291,11339,11291},{11292,Lu,11292,11340,11292},{11293,Lu,11293,11341,11293},{11294,Lu,11294,11342,11294},{11295,Lu,11295,11343,11295},{11296,Lu,11296,11344,11296},{11297,Lu,11297,11345,11297},{11298,Lu,11298,11346,11298},{11299,Lu,11299,11347,11299},{11300,Lu,11300,11348,11300},{11301,Lu,11301,11349,11301},{11302,Lu,11302,11350,11302},{11303,Lu,11303,11351,11303},{11304,Lu,11304,11352,11304},{11305,Lu,11305,11353,11305},{11306,Lu,11306,11354,11306},{11307,Lu,11307,11355,11307},{11308,Lu,11308,11356,11308},{11309,Lu,11309,11357,11309},{11310,Lu,11310,11358,11310},{11312,Ll,11264,11312,11264},{11313,Ll,11265,11313,11265},{11314,Ll,11266,11314,11266},{11315,Ll,11267,11315,11267},{11316,Ll,11268,11316,11268},{11317,Ll,11269,11317,11269},{11318,Ll,11270,11318,11270},{11319,Ll,11271,11319,11271},{11320,Ll,11272,11320,11272},{11321,Ll,11273,11321,11273},{11322,Ll,11274,11322,11274},{11323,Ll,11275,11323,11275},{11324,Ll,11276,11324,11276},{11325,Ll,11277,11325,11277},{11326,Ll,11278,11326,11278},{11327,Ll,11279,11327,11279},{11328,Ll,11280,11328,11280},{11329,Ll,11281,11329,11281},{11330,Ll,11282,11330,11282},{11331,Ll,11283,11331,11283},{11332,Ll,11284,11332,11284},{11333,Ll,11285,11333,11285},{11334,Ll,11286,11334,11286},{11335,Ll,11287,11335,11287},{11336,Ll,11288,11336,11288},{11337,Ll,11289,11337,11289},{11338,Ll,11290,11338,11290},{11339,Ll,11291,11339,11291},{11340,Ll,11292,11340,11292},{11341,Ll,11293,11341,11293},{11342,Ll,11294,11342,11294},{11343,Ll,11295,11343,11295},{11344,Ll,11296,11344,11296},{11345,Ll,11297,11345,11297},{11346,Ll,11298,11346,11298},{11347,Ll,11299,11347,11299},{11348,Ll,11300,11348,11300},{11349,Ll,11301,11349,11301},{11350,Ll,11302,11350,11302},{11351,Ll,11303,11351,11303},{11352,Ll,11304,11352,11304},{11353,Ll,11305,11353,11305},{11354,Ll,11306,11354,11306},{11355,Ll,11307,11355,11307},{11356,Ll,11308,11356,11308},{11357,Ll,11309,11357,11309},{11358,Ll,11310,11358,11310},{11360,Lu,11360,11361,11360},{11361,Ll,11360,11361,11360},{11362,Lu,11362,619,11362},{11363,Lu,11363,7549,11363},{11364,Lu,11364,637,11364},{11365,Ll,570,11365,570},{11366,Ll,574,11366,574},{11367,Lu,11367,11368,11367},{11368,Ll,11367,11368,11367},{11369,Lu,11369,11370,11369},{11370,Ll,11369,11370,11369},{11371,Lu,11371,11372,11371},{11372,Ll,11371,11372,11371},{11380,Ll,11380,11380,11380},{11381,Lu,11381,11382,11381},{11382,Ll,11381,11382,11381},{11383,Ll,11383,11383,11383},{11392,Lu,11392,11393,11392},{11393,Ll,11392,11393,11392},{11394,Lu,11394,11395,11394},{11395,Ll,11394,11395,11394},{11396,Lu,11396,11397,11396},{11397,Ll,11396,11397,11396},{11398,Lu,11398,11399,11398},{11399,Ll,11398,11399,11398},{11400,Lu,11400,11401,11400},{11401,Ll,11400,11401,11400},{11402,Lu,11402,11403,11402},{11403,Ll,11402,11403,11402},{11404,Lu,11404,11405,11404},{11405,Ll,11404,11405,11404},{11406,Lu,11406,11407,11406},{11407,Ll,11406,11407,11406},{11408,Lu,11408,11409,11408},{11409,Ll,11408,11409,11408},{11410,Lu,11410,11411,11410},{11411,Ll,11410,11411,11410},{11412,Lu,11412,11413,11412},{11413,Ll,11412,11413,11412},{11414,Lu,11414,11415,11414},{11415,Ll,11414,11415,11414},{11416,Lu,11416,11417,11416},{11417,Ll,11416,11417,11416},{11418,Lu,11418,11419,11418},{11419,Ll,11418,11419,11418},{11420,Lu,11420,11421,11420},{11421,Ll,11420,11421,11420},{11422,Lu,11422,11423,11422},{11423,Ll,11422,11423,11422},{11424,Lu,11424,11425,11424},{11425,Ll,11424,11425,11424},{11426,Lu,11426,11427,11426},{11427,Ll,11426,11427,11426},{11428,Lu,11428,11429,11428},{11429,Ll,11428,11429,11428},{11430,Lu,11430,11431,11430},{11431,Ll,11430,11431,11430},{11432,Lu,11432,11433,11432},{11433,Ll,11432,11433,11432},{11434,Lu,11434,11435,11434},{11435,Ll,11434,11435,11434},{11436,Lu,11436,11437,11436},{11437,Ll,11436,11437,11436},{11438,Lu,11438,11439,11438},{11439,Ll,11438,11439,11438},{11440,Lu,11440,11441,11440},{11441,Ll,11440,11441,11440},{11442,Lu,11442,11443,11442},{11443,Ll,11442,11443,11442},{11444,Lu,11444,11445,11444},{11445,Ll,11444,11445,11444},{11446,Lu,11446,11447,11446},{11447,Ll,11446,11447,11446},{11448,Lu,11448,11449,11448},{11449,Ll,11448,11449,11448},{11450,Lu,11450,11451,11450},{11451,Ll,11450,11451,11450},{11452,Lu,11452,11453,11452},{11453,Ll,11452,11453,11452},{11454,Lu,11454,11455,11454},{11455,Ll,11454,11455,11454},{11456,Lu,11456,11457,11456},{11457,Ll,11456,11457,11456},{11458,Lu,11458,11459,11458},{11459,Ll,11458,11459,11458},{11460,Lu,11460,11461,11460},{11461,Ll,11460,11461,11460},{11462,Lu,11462,11463,11462},{11463,Ll,11462,11463,11462},{11464,Lu,11464,11465,11464},{11465,Ll,11464,11465,11464},{11466,Lu,11466,11467,11466},{11467,Ll,11466,11467,11466},{11468,Lu,11468,11469,11468},{11469,Ll,11468,11469,11468},{11470,Lu,11470,11471,11470},{11471,Ll,11470,11471,11470},{11472,Lu,11472,11473,11472},{11473,Ll,11472,11473,11472},{11474,Lu,11474,11475,11474},{11475,Ll,11474,11475,11474},{11476,Lu,11476,11477,11476},{11477,Ll,11476,11477,11476},{11478,Lu,11478,11479,11478},{11479,Ll,11478,11479,11478},{11480,Lu,11480,11481,11480},{11481,Ll,11480,11481,11480},{11482,Lu,11482,11483,11482},{11483,Ll,11482,11483,11482},{11484,Lu,11484,11485,11484},{11485,Ll,11484,11485,11484},{11486,Lu,11486,11487,11486},{11487,Ll,11486,11487,11486},{11488,Lu,11488,11489,11488},{11489,Ll,11488,11489,11488},{11490,Lu,11490,11491,11490},{11491,Ll,11490,11491,11490},{11492,Ll,11492,11492,11492},{11493,So,11493,11493,11493},{11494,So,11494,11494,11494},{11495,So,11495,11495,11495},{11496,So,11496,11496,11496},{11497,So,11497,11497,11497},{11498,So,11498,11498,11498},{11513,Po,11513,11513,11513},{11514,Po,11514,11514,11514},{11515,Po,11515,11515,11515},{11516,Po,11516,11516,11516},{11517,No,11517,11517,11517},{11518,Po,11518,11518,11518},{11519,Po,11519,11519,11519},{11520,Ll,4256,11520,4256},{11521,Ll,4257,11521,4257},{11522,Ll,4258,11522,4258},{11523,Ll,4259,11523,4259},{11524,Ll,4260,11524,4260},{11525,Ll,4261,11525,4261},{11526,Ll,4262,11526,4262},{11527,Ll,4263,11527,4263},{11528,Ll,4264,11528,4264},{11529,Ll,4265,11529,4265},{11530,Ll,4266,11530,4266},{11531,Ll,4267,11531,4267},{11532,Ll,4268,11532,4268},{11533,Ll,4269,11533,4269},{11534,Ll,4270,11534,4270},{11535,Ll,4271,11535,4271},{11536,Ll,4272,11536,4272},{11537,Ll,4273,11537,4273},{11538,Ll,4274,11538,4274},{11539,Ll,4275,11539,4275},{11540,Ll,4276,11540,4276},{11541,Ll,4277,11541,4277},{11542,Ll,4278,11542,4278},{11543,Ll,4279,11543,4279},{11544,Ll,4280,11544,4280},{11545,Ll,4281,11545,4281},{11546,Ll,4282,11546,4282},{11547,Ll,4283,11547,4283},{11548,Ll,4284,11548,4284},{11549,Ll,4285,11549,4285},{11550,Ll,4286,11550,4286},{11551,Ll,4287,11551,4287},{11552,Ll,4288,11552,4288},{11553,Ll,4289,11553,4289},{11554,Ll,4290,11554,4290},{11555,Ll,4291,11555,4291},{11556,Ll,4292,11556,4292},{11557,Ll,4293,11557,4293},{11568,Lo,11568,11568,11568},{11569,Lo,11569,11569,11569},{11570,Lo,11570,11570,11570},{11571,Lo,11571,11571,11571},{11572,Lo,11572,11572,11572},{11573,Lo,11573,11573,11573},{11574,Lo,11574,11574,11574},{11575,Lo,11575,11575,11575},{11576,Lo,11576,11576,11576},{11577,Lo,11577,11577,11577},{11578,Lo,11578,11578,11578},{11579,Lo,11579,11579,11579},{11580,Lo,11580,11580,11580},{11581,Lo,11581,11581,11581},{11582,Lo,11582,11582,11582},{11583,Lo,11583,11583,11583},{11584,Lo,11584,11584,11584},{11585,Lo,11585,11585,11585},{11586,Lo,11586,11586,11586},{11587,Lo,11587,11587,11587},{11588,Lo,11588,11588,11588},{11589,Lo,11589,11589,11589},{11590,Lo,11590,11590,11590},{11591,Lo,11591,11591,11591},{11592,Lo,11592,11592,11592},{11593,Lo,11593,11593,11593},{11594,Lo,11594,11594,11594},{11595,Lo,11595,11595,11595},{11596,Lo,11596,11596,11596},{11597,Lo,11597,11597,11597},{11598,Lo,11598,11598,11598},{11599,Lo,11599,11599,11599},{11600,Lo,11600,11600,11600},{11601,Lo,11601,11601,11601},{11602,Lo,11602,11602,11602},{11603,Lo,11603,11603,11603},{11604,Lo,11604,11604,11604},{11605,Lo,11605,11605,11605},{11606,Lo,11606,11606,11606},{11607,Lo,11607,11607,11607},{11608,Lo,11608,11608,11608},{11609,Lo,11609,11609,11609},{11610,Lo,11610,11610,11610},{11611,Lo,11611,11611,11611},{11612,Lo,11612,11612,11612},{11613,Lo,11613,11613,11613},{11614,Lo,11614,11614,11614},{11615,Lo,11615,11615,11615},{11616,Lo,11616,11616,11616},{11617,Lo,11617,11617,11617},{11618,Lo,11618,11618,11618},{11619,Lo,11619,11619,11619},{11620,Lo,11620,11620,11620},{11621,Lo,11621,11621,11621},{11631,Lm,11631,11631,11631},{11648,Lo,11648,11648,11648},{11649,Lo,11649,11649,11649},{11650,Lo,11650,11650,11650},{11651,Lo,11651,11651,11651},{11652,Lo,11652,11652,11652},{11653,Lo,11653,11653,11653},{11654,Lo,11654,11654,11654},{11655,Lo,11655,11655,11655},{11656,Lo,11656,11656,11656},{11657,Lo,11657,11657,11657},{11658,Lo,11658,11658,11658},{11659,Lo,11659,11659,11659},{11660,Lo,11660,11660,11660},{11661,Lo,11661,11661,11661},{11662,Lo,11662,11662,11662},{11663,Lo,11663,11663,11663},{11664,Lo,11664,11664,11664},{11665,Lo,11665,11665,11665},{11666,Lo,11666,11666,11666},{11667,Lo,11667,11667,11667},{11668,Lo,11668,11668,11668},{11669,Lo,11669,11669,11669},{11670,Lo,11670,11670,11670},{11680,Lo,11680,11680,11680},{11681,Lo,11681,11681,11681},{11682,Lo,11682,11682,11682},{11683,Lo,11683,11683,11683},{11684,Lo,11684,11684,11684},{11685,Lo,11685,11685,11685},{11686,Lo,11686,11686,11686},{11688,Lo,11688,11688,11688},{11689,Lo,11689,11689,11689},{11690,Lo,11690,11690,11690},{11691,Lo,11691,11691,11691},{11692,Lo,11692,11692,11692},{11693,Lo,11693,11693,11693},{11694,Lo,11694,11694,11694},{11696,Lo,11696,11696,11696},{11697,Lo,11697,11697,11697},{11698,Lo,11698,11698,11698},{11699,Lo,11699,11699,11699},{11700,Lo,11700,11700,11700},{11701,Lo,11701,11701,11701},{11702,Lo,11702,11702,11702},{11704,Lo,11704,11704,11704},{11705,Lo,11705,11705,11705},{11706,Lo,11706,11706,11706},{11707,Lo,11707,11707,11707},{11708,Lo,11708,11708,11708},{11709,Lo,11709,11709,11709},{11710,Lo,11710,11710,11710},{11712,Lo,11712,11712,11712},{11713,Lo,11713,11713,11713},{11714,Lo,11714,11714,11714},{11715,Lo,11715,11715,11715},{11716,Lo,11716,11716,11716},{11717,Lo,11717,11717,11717},{11718,Lo,11718,11718,11718},{11720,Lo,11720,11720,11720},{11721,Lo,11721,11721,11721},{11722,Lo,11722,11722,11722},{11723,Lo,11723,11723,11723},{11724,Lo,11724,11724,11724},{11725,Lo,11725,11725,11725},{11726,Lo,11726,11726,11726},{11728,Lo,11728,11728,11728},{11729,Lo,11729,11729,11729},{11730,Lo,11730,11730,11730},{11731,Lo,11731,11731,11731},{11732,Lo,11732,11732,11732},{11733,Lo,11733,11733,11733},{11734,Lo,11734,11734,11734},{11736,Lo,11736,11736,11736},{11737,Lo,11737,11737,11737},{11738,Lo,11738,11738,11738},{11739,Lo,11739,11739,11739},{11740,Lo,11740,11740,11740},{11741,Lo,11741,11741,11741},{11742,Lo,11742,11742,11742},{11776,Po,11776,11776,11776},{11777,Po,11777,11777,11777},{11778,Pi,11778,11778,11778},{11779,Pf,11779,11779,11779},{11780,Pi,11780,11780,11780},{11781,Pf,11781,11781,11781},{11782,Po,11782,11782,11782},{11783,Po,11783,11783,11783},{11784,Po,11784,11784,11784},{11785,Pi,11785,11785,11785},{11786,Pf,11786,11786,11786},{11787,Po,11787,11787,11787},{11788,Pi,11788,11788,11788},{11789,Pf,11789,11789,11789},{11790,Po,11790,11790,11790},{11791,Po,11791,11791,11791},{11792,Po,11792,11792,11792},{11793,Po,11793,11793,11793},{11794,Po,11794,11794,11794},{11795,Po,11795,11795,11795},{11796,Po,11796,11796,11796},{11797,Po,11797,11797,11797},{11798,Po,11798,11798,11798},{11799,Pd,11799,11799,11799},{11804,Pi,11804,11804,11804},{11805,Pf,11805,11805,11805},{11904,So,11904,11904,11904},{11905,So,11905,11905,11905},{11906,So,11906,11906,11906},{11907,So,11907,11907,11907},{11908,So,11908,11908,11908},{11909,So,11909,11909,11909},{11910,So,11910,11910,11910},{11911,So,11911,11911,11911},{11912,So,11912,11912,11912},{11913,So,11913,11913,11913},{11914,So,11914,11914,11914},{11915,So,11915,11915,11915},{11916,So,11916,11916,11916},{11917,So,11917,11917,11917},{11918,So,11918,11918,11918},{11919,So,11919,11919,11919},{11920,So,11920,11920,11920},{11921,So,11921,11921,11921},{11922,So,11922,11922,11922},{11923,So,11923,11923,11923},{11924,So,11924,11924,11924},{11925,So,11925,11925,11925},{11926,So,11926,11926,11926},{11927,So,11927,11927,11927},{11928,So,11928,11928,11928},{11929,So,11929,11929,11929},{11931,So,11931,11931,11931},{11932,So,11932,11932,11932},{11933,So,11933,11933,11933},{11934,So,11934,11934,11934},{11935,So,11935,11935,11935},{11936,So,11936,11936,11936},{11937,So,11937,11937,11937},{11938,So,11938,11938,11938},{11939,So,11939,11939,11939},{11940,So,11940,11940,11940},{11941,So,11941,11941,11941},{11942,So,11942,11942,11942},{11943,So,11943,11943,11943},{11944,So,11944,11944,11944},{11945,So,11945,11945,11945},{11946,So,11946,11946,11946},{11947,So,11947,11947,11947},{11948,So,11948,11948,11948},{11949,So,11949,11949,11949},{11950,So,11950,11950,11950},{11951,So,11951,11951,11951},{11952,So,11952,11952,11952},{11953,So,11953,11953,11953},{11954,So,11954,11954,11954},{11955,So,11955,11955,11955},{11956,So,11956,11956,11956},{11957,So,11957,11957,11957},{11958,So,11958,11958,11958},{11959,So,11959,11959,11959},{11960,So,11960,11960,11960},{11961,So,11961,11961,11961},{11962,So,11962,11962,11962},{11963,So,11963,11963,11963},{11964,So,11964,11964,11964},{11965,So,11965,11965,11965},{11966,So,11966,11966,11966},{11967,So,11967,11967,11967},{11968,So,11968,11968,11968},{11969,So,11969,11969,11969},{11970,So,11970,11970,11970},{11971,So,11971,11971,11971},{11972,So,11972,11972,11972},{11973,So,11973,11973,11973},{11974,So,11974,11974,11974},{11975,So,11975,11975,11975},{11976,So,11976,11976,11976},{11977,So,11977,11977,11977},{11978,So,11978,11978,11978},{11979,So,11979,11979,11979},{11980,So,11980,11980,11980},{11981,So,11981,11981,11981},{11982,So,11982,11982,11982},{11983,So,11983,11983,11983},{11984,So,11984,11984,11984},{11985,So,11985,11985,11985},{11986,So,11986,11986,11986},{11987,So,11987,11987,11987},{11988,So,11988,11988,11988},{11989,So,11989,11989,11989},{11990,So,11990,11990,11990},{11991,So,11991,11991,11991},{11992,So,11992,11992,11992},{11993,So,11993,11993,11993},{11994,So,11994,11994,11994},{11995,So,11995,11995,11995},{11996,So,11996,11996,11996},{11997,So,11997,11997,11997},{11998,So,11998,11998,11998},{11999,So,11999,11999,11999},{12000,So,12000,12000,12000},{12001,So,12001,12001,12001},{12002,So,12002,12002,12002},{12003,So,12003,12003,12003},{12004,So,12004,12004,12004},{12005,So,12005,12005,12005},{12006,So,12006,12006,12006},{12007,So,12007,12007,12007},{12008,So,12008,12008,12008},{12009,So,12009,12009,12009},{12010,So,12010,12010,12010},{12011,So,12011,12011,12011},{12012,So,12012,12012,12012},{12013,So,12013,12013,12013},{12014,So,12014,12014,12014},{12015,So,12015,12015,12015},{12016,So,12016,12016,12016},{12017,So,12017,12017,12017},{12018,So,12018,12018,12018},{12019,So,12019,12019,12019},{12032,So,12032,12032,12032},{12033,So,12033,12033,12033},{12034,So,12034,12034,12034},{12035,So,12035,12035,12035},{12036,So,12036,12036,12036},{12037,So,12037,12037,12037},{12038,So,12038,12038,12038},{12039,So,12039,12039,12039},{12040,So,12040,12040,12040},{12041,So,12041,12041,12041},{12042,So,12042,12042,12042},{12043,So,12043,12043,12043},{12044,So,12044,12044,12044},{12045,So,12045,12045,12045},{12046,So,12046,12046,12046},{12047,So,12047,12047,12047},{12048,So,12048,12048,12048},{12049,So,12049,12049,12049},{12050,So,12050,12050,12050},{12051,So,12051,12051,12051},{12052,So,12052,12052,12052},{12053,So,12053,12053,12053},{12054,So,12054,12054,12054},{12055,So,12055,12055,12055},{12056,So,12056,12056,12056},{12057,So,12057,12057,12057},{12058,So,12058,12058,12058},{12059,So,12059,12059,12059},{12060,So,12060,12060,12060},{12061,So,12061,12061,12061},{12062,So,12062,12062,12062},{12063,So,12063,12063,12063},{12064,So,12064,12064,12064},{12065,So,12065,12065,12065},{12066,So,12066,12066,12066},{12067,So,12067,12067,12067},{12068,So,12068,12068,12068},{12069,So,12069,12069,12069},{12070,So,12070,12070,12070},{12071,So,12071,12071,12071},{12072,So,12072,12072,12072},{12073,So,12073,12073,12073},{12074,So,12074,12074,12074},{12075,So,12075,12075,12075},{12076,So,12076,12076,12076},{12077,So,12077,12077,12077},{12078,So,12078,12078,12078},{12079,So,12079,12079,12079},{12080,So,12080,12080,12080},{12081,So,12081,12081,12081},{12082,So,12082,12082,12082},{12083,So,12083,12083,12083},{12084,So,12084,12084,12084},{12085,So,12085,12085,12085},{12086,So,12086,12086,12086},{12087,So,12087,12087,12087},{12088,So,12088,12088,12088},{12089,So,12089,12089,12089},{12090,So,12090,12090,12090},{12091,So,12091,12091,12091},{12092,So,12092,12092,12092},{12093,So,12093,12093,12093},{12094,So,12094,12094,12094},{12095,So,12095,12095,12095},{12096,So,12096,12096,12096},{12097,So,12097,12097,12097},{12098,So,12098,12098,12098},{12099,So,12099,12099,12099},{12100,So,12100,12100,12100},{12101,So,12101,12101,12101},{12102,So,12102,12102,12102},{12103,So,12103,12103,12103},{12104,So,12104,12104,12104},{12105,So,12105,12105,12105},{12106,So,12106,12106,12106},{12107,So,12107,12107,12107},{12108,So,12108,12108,12108},{12109,So,12109,12109,12109},{12110,So,12110,12110,12110},{12111,So,12111,12111,12111},{12112,So,12112,12112,12112},{12113,So,12113,12113,12113},{12114,So,12114,12114,12114},{12115,So,12115,12115,12115},{12116,So,12116,12116,12116},{12117,So,12117,12117,12117},{12118,So,12118,12118,12118},{12119,So,12119,12119,12119},{12120,So,12120,12120,12120},{12121,So,12121,12121,12121},{12122,So,12122,12122,12122},{12123,So,12123,12123,12123},{12124,So,12124,12124,12124},{12125,So,12125,12125,12125},{12126,So,12126,12126,12126},{12127,So,12127,12127,12127},{12128,So,12128,12128,12128},{12129,So,12129,12129,12129},{12130,So,12130,12130,12130},{12131,So,12131,12131,12131},{12132,So,12132,12132,12132},{12133,So,12133,12133,12133},{12134,So,12134,12134,12134},{12135,So,12135,12135,12135},{12136,So,12136,12136,12136},{12137,So,12137,12137,12137},{12138,So,12138,12138,12138},{12139,So,12139,12139,12139},{12140,So,12140,12140,12140},{12141,So,12141,12141,12141},{12142,So,12142,12142,12142},{12143,So,12143,12143,12143},{12144,So,12144,12144,12144},{12145,So,12145,12145,12145},{12146,So,12146,12146,12146},{12147,So,12147,12147,12147},{12148,So,12148,12148,12148},{12149,So,12149,12149,12149},{12150,So,12150,12150,12150},{12151,So,12151,12151,12151},{12152,So,12152,12152,12152},{12153,So,12153,12153,12153},{12154,So,12154,12154,12154},{12155,So,12155,12155,12155},{12156,So,12156,12156,12156},{12157,So,12157,12157,12157},{12158,So,12158,12158,12158},{12159,So,12159,12159,12159},{12160,So,12160,12160,12160},{12161,So,12161,12161,12161},{12162,So,12162,12162,12162},{12163,So,12163,12163,12163},{12164,So,12164,12164,12164},{12165,So,12165,12165,12165},{12166,So,12166,12166,12166},{12167,So,12167,12167,12167},{12168,So,12168,12168,12168},{12169,So,12169,12169,12169},{12170,So,12170,12170,12170},{12171,So,12171,12171,12171},{12172,So,12172,12172,12172},{12173,So,12173,12173,12173},{12174,So,12174,12174,12174},{12175,So,12175,12175,12175},{12176,So,12176,12176,12176},{12177,So,12177,12177,12177},{12178,So,12178,12178,12178},{12179,So,12179,12179,12179},{12180,So,12180,12180,12180},{12181,So,12181,12181,12181},{12182,So,12182,12182,12182},{12183,So,12183,12183,12183},{12184,So,12184,12184,12184},{12185,So,12185,12185,12185},{12186,So,12186,12186,12186},{12187,So,12187,12187,12187},{12188,So,12188,12188,12188},{12189,So,12189,12189,12189},{12190,So,12190,12190,12190},{12191,So,12191,12191,12191},{12192,So,12192,12192,12192},{12193,So,12193,12193,12193},{12194,So,12194,12194,12194},{12195,So,12195,12195,12195},{12196,So,12196,12196,12196},{12197,So,12197,12197,12197},{12198,So,12198,12198,12198},{12199,So,12199,12199,12199},{12200,So,12200,12200,12200},{12201,So,12201,12201,12201},{12202,So,12202,12202,12202},{12203,So,12203,12203,12203},{12204,So,12204,12204,12204},{12205,So,12205,12205,12205},{12206,So,12206,12206,12206},{12207,So,12207,12207,12207},{12208,So,12208,12208,12208},{12209,So,12209,12209,12209},{12210,So,12210,12210,12210},{12211,So,12211,12211,12211},{12212,So,12212,12212,12212},{12213,So,12213,12213,12213},{12214,So,12214,12214,12214},{12215,So,12215,12215,12215},{12216,So,12216,12216,12216},{12217,So,12217,12217,12217},{12218,So,12218,12218,12218},{12219,So,12219,12219,12219},{12220,So,12220,12220,12220},{12221,So,12221,12221,12221},{12222,So,12222,12222,12222},{12223,So,12223,12223,12223},{12224,So,12224,12224,12224},{12225,So,12225,12225,12225},{12226,So,12226,12226,12226},{12227,So,12227,12227,12227},{12228,So,12228,12228,12228},{12229,So,12229,12229,12229},{12230,So,12230,12230,12230},{12231,So,12231,12231,12231},{12232,So,12232,12232,12232},{12233,So,12233,12233,12233},{12234,So,12234,12234,12234},{12235,So,12235,12235,12235},{12236,So,12236,12236,12236},{12237,So,12237,12237,12237},{12238,So,12238,12238,12238},{12239,So,12239,12239,12239},{12240,So,12240,12240,12240},{12241,So,12241,12241,12241},{12242,So,12242,12242,12242},{12243,So,12243,12243,12243},{12244,So,12244,12244,12244},{12245,So,12245,12245,12245},{12272,So,12272,12272,12272},{12273,So,12273,12273,12273},{12274,So,12274,12274,12274},{12275,So,12275,12275,12275},{12276,So,12276,12276,12276},{12277,So,12277,12277,12277},{12278,So,12278,12278,12278},{12279,So,12279,12279,12279},{12280,So,12280,12280,12280},{12281,So,12281,12281,12281},{12282,So,12282,12282,12282},{12283,So,12283,12283,12283},{12288,Zs,12288,12288,12288},{12289,Po,12289,12289,12289},{12290,Po,12290,12290,12290},{12291,Po,12291,12291,12291},{12292,So,12292,12292,12292},{12293,Lm,12293,12293,12293},{12294,Lo,12294,12294,12294},{12295,Nl,12295,12295,12295},{12296,Ps,12296,12296,12296},{12297,Pe,12297,12297,12297},{12298,Ps,12298,12298,12298},{12299,Pe,12299,12299,12299},{12300,Ps,12300,12300,12300},{12301,Pe,12301,12301,12301},{12302,Ps,12302,12302,12302},{12303,Pe,12303,12303,12303},{12304,Ps,12304,12304,12304},{12305,Pe,12305,12305,12305},{12306,So,12306,12306,12306},{12307,So,12307,12307,12307},{12308,Ps,12308,12308,12308},{12309,Pe,12309,12309,12309},{12310,Ps,12310,12310,12310},{12311,Pe,12311,12311,12311},{12312,Ps,12312,12312,12312},{12313,Pe,12313,12313,12313},{12314,Ps,12314,12314,12314},{12315,Pe,12315,12315,12315},{12316,Pd,12316,12316,12316},{12317,Ps,12317,12317,12317},{12318,Pe,12318,12318,12318},{12319,Pe,12319,12319,12319},{12320,So,12320,12320,12320},{12321,Nl,12321,12321,12321},{12322,Nl,12322,12322,12322},{12323,Nl,12323,12323,12323},{12324,Nl,12324,12324,12324},{12325,Nl,12325,12325,12325},{12326,Nl,12326,12326,12326},{12327,Nl,12327,12327,12327},{12328,Nl,12328,12328,12328},{12329,Nl,12329,12329,12329},{12330,Mn,12330,12330,12330},{12331,Mn,12331,12331,12331},{12332,Mn,12332,12332,12332},{12333,Mn,12333,12333,12333},{12334,Mn,12334,12334,12334},{12335,Mn,12335,12335,12335},{12336,Pd,12336,12336,12336},{12337,Lm,12337,12337,12337},{12338,Lm,12338,12338,12338},{12339,Lm,12339,12339,12339},{12340,Lm,12340,12340,12340},{12341,Lm,12341,12341,12341},{12342,So,12342,12342,12342},{12343,So,12343,12343,12343},{12344,Nl,12344,12344,12344},{12345,Nl,12345,12345,12345},{12346,Nl,12346,12346,12346},{12347,Lm,12347,12347,12347},{12348,Lo,12348,12348,12348},{12349,Po,12349,12349,12349},{12350,So,12350,12350,12350},{12351,So,12351,12351,12351},{12353,Lo,12353,12353,12353},{12354,Lo,12354,12354,12354},{12355,Lo,12355,12355,12355},{12356,Lo,12356,12356,12356},{12357,Lo,12357,12357,12357},{12358,Lo,12358,12358,12358},{12359,Lo,12359,12359,12359},{12360,Lo,12360,12360,12360},{12361,Lo,12361,12361,12361},{12362,Lo,12362,12362,12362},{12363,Lo,12363,12363,12363},{12364,Lo,12364,12364,12364},{12365,Lo,12365,12365,12365},{12366,Lo,12366,12366,12366},{12367,Lo,12367,12367,12367},{12368,Lo,12368,12368,12368},{12369,Lo,12369,12369,12369},{12370,Lo,12370,12370,12370},{12371,Lo,12371,12371,12371},{12372,Lo,12372,12372,12372},{12373,Lo,12373,12373,12373},{12374,Lo,12374,12374,12374},{12375,Lo,12375,12375,12375},{12376,Lo,12376,12376,12376},{12377,Lo,12377,12377,12377},{12378,Lo,12378,12378,12378},{12379,Lo,12379,12379,12379},{12380,Lo,12380,12380,12380},{12381,Lo,12381,12381,12381},{12382,Lo,12382,12382,12382},{12383,Lo,12383,12383,12383},{12384,Lo,12384,12384,12384},{12385,Lo,12385,12385,12385},{12386,Lo,12386,12386,12386},{12387,Lo,12387,12387,12387},{12388,Lo,12388,12388,12388},{12389,Lo,12389,12389,12389},{12390,Lo,12390,12390,12390},{12391,Lo,12391,12391,12391},{12392,Lo,12392,12392,12392},{12393,Lo,12393,12393,12393},{12394,Lo,12394,12394,12394},{12395,Lo,12395,12395,12395},{12396,Lo,12396,12396,12396},{12397,Lo,12397,12397,12397},{12398,Lo,12398,12398,12398},{12399,Lo,12399,12399,12399},{12400,Lo,12400,12400,12400},{12401,Lo,12401,12401,12401},{12402,Lo,12402,12402,12402},{12403,Lo,12403,12403,12403},{12404,Lo,12404,12404,12404},{12405,Lo,12405,12405,12405},{12406,Lo,12406,12406,12406},{12407,Lo,12407,12407,12407},{12408,Lo,12408,12408,12408},{12409,Lo,12409,12409,12409},{12410,Lo,12410,12410,12410},{12411,Lo,12411,12411,12411},{12412,Lo,12412,12412,12412},{12413,Lo,12413,12413,12413},{12414,Lo,12414,12414,12414},{12415,Lo,12415,12415,12415},{12416,Lo,12416,12416,12416},{12417,Lo,12417,12417,12417},{12418,Lo,12418,12418,12418},{12419,Lo,12419,12419,12419},{12420,Lo,12420,12420,12420},{12421,Lo,12421,12421,12421},{12422,Lo,12422,12422,12422},{12423,Lo,12423,12423,12423},{12424,Lo,12424,12424,12424},{12425,Lo,12425,12425,12425},{12426,Lo,12426,12426,12426},{12427,Lo,12427,12427,12427},{12428,Lo,12428,12428,12428},{12429,Lo,12429,12429,12429},{12430,Lo,12430,12430,12430},{12431,Lo,12431,12431,12431},{12432,Lo,12432,12432,12432},{12433,Lo,12433,12433,12433},{12434,Lo,12434,12434,12434},{12435,Lo,12435,12435,12435},{12436,Lo,12436,12436,12436},{12437,Lo,12437,12437,12437},{12438,Lo,12438,12438,12438},{12441,Mn,12441,12441,12441},{12442,Mn,12442,12442,12442},{12443,Sk,12443,12443,12443},{12444,Sk,12444,12444,12444},{12445,Lm,12445,12445,12445},{12446,Lm,12446,12446,12446},{12447,Lo,12447,12447,12447},{12448,Pd,12448,12448,12448},{12449,Lo,12449,12449,12449},{12450,Lo,12450,12450,12450},{12451,Lo,12451,12451,12451},{12452,Lo,12452,12452,12452},{12453,Lo,12453,12453,12453},{12454,Lo,12454,12454,12454},{12455,Lo,12455,12455,12455},{12456,Lo,12456,12456,12456},{12457,Lo,12457,12457,12457},{12458,Lo,12458,12458,12458},{12459,Lo,12459,12459,12459},{12460,Lo,12460,12460,12460},{12461,Lo,12461,12461,12461},{12462,Lo,12462,12462,12462},{12463,Lo,12463,12463,12463},{12464,Lo,12464,12464,12464},{12465,Lo,12465,12465,12465},{12466,Lo,12466,12466,12466},{12467,Lo,12467,12467,12467},{12468,Lo,12468,12468,12468},{12469,Lo,12469,12469,12469},{12470,Lo,12470,12470,12470},{12471,Lo,12471,12471,12471},{12472,Lo,12472,12472,12472},{12473,Lo,12473,12473,12473},{12474,Lo,12474,12474,12474},{12475,Lo,12475,12475,12475},{12476,Lo,12476,12476,12476},{12477,Lo,12477,12477,12477},{12478,Lo,12478,12478,12478},{12479,Lo,12479,12479,12479},{12480,Lo,12480,12480,12480},{12481,Lo,12481,12481,12481},{12482,Lo,12482,12482,12482},{12483,Lo,12483,12483,12483},{12484,Lo,12484,12484,12484},{12485,Lo,12485,12485,12485},{12486,Lo,12486,12486,12486},{12487,Lo,12487,12487,12487},{12488,Lo,12488,12488,12488},{12489,Lo,12489,12489,12489},{12490,Lo,12490,12490,12490},{12491,Lo,12491,12491,12491},{12492,Lo,12492,12492,12492},{12493,Lo,12493,12493,12493},{12494,Lo,12494,12494,12494},{12495,Lo,12495,12495,12495},{12496,Lo,12496,12496,12496},{12497,Lo,12497,12497,12497},{12498,Lo,12498,12498,12498},{12499,Lo,12499,12499,12499},{12500,Lo,12500,12500,12500},{12501,Lo,12501,12501,12501},{12502,Lo,12502,12502,12502},{12503,Lo,12503,12503,12503},{12504,Lo,12504,12504,12504},{12505,Lo,12505,12505,12505},{12506,Lo,12506,12506,12506},{12507,Lo,12507,12507,12507},{12508,Lo,12508,12508,12508},{12509,Lo,12509,12509,12509},{12510,Lo,12510,12510,12510},{12511,Lo,12511,12511,12511},{12512,Lo,12512,12512,12512},{12513,Lo,12513,12513,12513},{12514,Lo,12514,12514,12514},{12515,Lo,12515,12515,12515},{12516,Lo,12516,12516,12516},{12517,Lo,12517,12517,12517},{12518,Lo,12518,12518,12518},{12519,Lo,12519,12519,12519},{12520,Lo,12520,12520,12520},{12521,Lo,12521,12521,12521},{12522,Lo,12522,12522,12522},{12523,Lo,12523,12523,12523},{12524,Lo,12524,12524,12524},{12525,Lo,12525,12525,12525},{12526,Lo,12526,12526,12526},{12527,Lo,12527,12527,12527},{12528,Lo,12528,12528,12528},{12529,Lo,12529,12529,12529},{12530,Lo,12530,12530,12530},{12531,Lo,12531,12531,12531},{12532,Lo,12532,12532,12532},{12533,Lo,12533,12533,12533},{12534,Lo,12534,12534,12534},{12535,Lo,12535,12535,12535},{12536,Lo,12536,12536,12536},{12537,Lo,12537,12537,12537},{12538,Lo,12538,12538,12538},{12539,Po,12539,12539,12539},{12540,Lm,12540,12540,12540},{12541,Lm,12541,12541,12541},{12542,Lm,12542,12542,12542},{12543,Lo,12543,12543,12543},{12549,Lo,12549,12549,12549},{12550,Lo,12550,12550,12550},{12551,Lo,12551,12551,12551},{12552,Lo,12552,12552,12552},{12553,Lo,12553,12553,12553},{12554,Lo,12554,12554,12554},{12555,Lo,12555,12555,12555},{12556,Lo,12556,12556,12556},{12557,Lo,12557,12557,12557},{12558,Lo,12558,12558,12558},{12559,Lo,12559,12559,12559},{12560,Lo,12560,12560,12560},{12561,Lo,12561,12561,12561},{12562,Lo,12562,12562,12562},{12563,Lo,12563,12563,12563},{12564,Lo,12564,12564,12564},{12565,Lo,12565,12565,12565},{12566,Lo,12566,12566,12566},{12567,Lo,12567,12567,12567},{12568,Lo,12568,12568,12568},{12569,Lo,12569,12569,12569},{12570,Lo,12570,12570,12570},{12571,Lo,12571,12571,12571},{12572,Lo,12572,12572,12572},{12573,Lo,12573,12573,12573},{12574,Lo,12574,12574,12574},{12575,Lo,12575,12575,12575},{12576,Lo,12576,12576,12576},{12577,Lo,12577,12577,12577},{12578,Lo,12578,12578,12578},{12579,Lo,12579,12579,12579},{12580,Lo,12580,12580,12580},{12581,Lo,12581,12581,12581},{12582,Lo,12582,12582,12582},{12583,Lo,12583,12583,12583},{12584,Lo,12584,12584,12584},{12585,Lo,12585,12585,12585},{12586,Lo,12586,12586,12586},{12587,Lo,12587,12587,12587},{12588,Lo,12588,12588,12588},{12593,Lo,12593,12593,12593},{12594,Lo,12594,12594,12594},{12595,Lo,12595,12595,12595},{12596,Lo,12596,12596,12596},{12597,Lo,12597,12597,12597},{12598,Lo,12598,12598,12598},{12599,Lo,12599,12599,12599},{12600,Lo,12600,12600,12600},{12601,Lo,12601,12601,12601},{12602,Lo,12602,12602,12602},{12603,Lo,12603,12603,12603},{12604,Lo,12604,12604,12604},{12605,Lo,12605,12605,12605},{12606,Lo,12606,12606,12606},{12607,Lo,12607,12607,12607},{12608,Lo,12608,12608,12608},{12609,Lo,12609,12609,12609},{12610,Lo,12610,12610,12610},{12611,Lo,12611,12611,12611},{12612,Lo,12612,12612,12612},{12613,Lo,12613,12613,12613},{12614,Lo,12614,12614,12614},{12615,Lo,12615,12615,12615},{12616,Lo,12616,12616,12616},{12617,Lo,12617,12617,12617},{12618,Lo,12618,12618,12618},{12619,Lo,12619,12619,12619},{12620,Lo,12620,12620,12620},{12621,Lo,12621,12621,12621},{12622,Lo,12622,12622,12622},{12623,Lo,12623,12623,12623},{12624,Lo,12624,12624,12624},{12625,Lo,12625,12625,12625},{12626,Lo,12626,12626,12626},{12627,Lo,12627,12627,12627},{12628,Lo,12628,12628,12628},{12629,Lo,12629,12629,12629},{12630,Lo,12630,12630,12630},{12631,Lo,12631,12631,12631},{12632,Lo,12632,12632,12632},{12633,Lo,12633,12633,12633},{12634,Lo,12634,12634,12634},{12635,Lo,12635,12635,12635},{12636,Lo,12636,12636,12636},{12637,Lo,12637,12637,12637},{12638,Lo,12638,12638,12638},{12639,Lo,12639,12639,12639},{12640,Lo,12640,12640,12640},{12641,Lo,12641,12641,12641},{12642,Lo,12642,12642,12642},{12643,Lo,12643,12643,12643},{12644,Lo,12644,12644,12644},{12645,Lo,12645,12645,12645},{12646,Lo,12646,12646,12646},{12647,Lo,12647,12647,12647},{12648,Lo,12648,12648,12648},{12649,Lo,12649,12649,12649},{12650,Lo,12650,12650,12650},{12651,Lo,12651,12651,12651},{12652,Lo,12652,12652,12652},{12653,Lo,12653,12653,12653},{12654,Lo,12654,12654,12654},{12655,Lo,12655,12655,12655},{12656,Lo,12656,12656,12656},{12657,Lo,12657,12657,12657},{12658,Lo,12658,12658,12658},{12659,Lo,12659,12659,12659},{12660,Lo,12660,12660,12660},{12661,Lo,12661,12661,12661},{12662,Lo,12662,12662,12662},{12663,Lo,12663,12663,12663},{12664,Lo,12664,12664,12664},{12665,Lo,12665,12665,12665},{12666,Lo,12666,12666,12666},{12667,Lo,12667,12667,12667},{12668,Lo,12668,12668,12668},{12669,Lo,12669,12669,12669},{12670,Lo,12670,12670,12670},{12671,Lo,12671,12671,12671},{12672,Lo,12672,12672,12672},{12673,Lo,12673,12673,12673},{12674,Lo,12674,12674,12674},{12675,Lo,12675,12675,12675},{12676,Lo,12676,12676,12676},{12677,Lo,12677,12677,12677},{12678,Lo,12678,12678,12678},{12679,Lo,12679,12679,12679},{12680,Lo,12680,12680,12680},{12681,Lo,12681,12681,12681},{12682,Lo,12682,12682,12682},{12683,Lo,12683,12683,12683},{12684,Lo,12684,12684,12684},{12685,Lo,12685,12685,12685},{12686,Lo,12686,12686,12686},{12688,So,12688,12688,12688},{12689,So,12689,12689,12689},{12690,No,12690,12690,12690},{12691,No,12691,12691,12691},{12692,No,12692,12692,12692},{12693,No,12693,12693,12693},{12694,So,12694,12694,12694},{12695,So,12695,12695,12695},{12696,So,12696,12696,12696},{12697,So,12697,12697,12697},{12698,So,12698,12698,12698},{12699,So,12699,12699,12699},{12700,So,12700,12700,12700},{12701,So,12701,12701,12701},{12702,So,12702,12702,12702},{12703,So,12703,12703,12703},{12704,Lo,12704,12704,12704},{12705,Lo,12705,12705,12705},{12706,Lo,12706,12706,12706},{12707,Lo,12707,12707,12707},{12708,Lo,12708,12708,12708},{12709,Lo,12709,12709,12709},{12710,Lo,12710,12710,12710},{12711,Lo,12711,12711,12711},{12712,Lo,12712,12712,12712},{12713,Lo,12713,12713,12713},{12714,Lo,12714,12714,12714},{12715,Lo,12715,12715,12715},{12716,Lo,12716,12716,12716},{12717,Lo,12717,12717,12717},{12718,Lo,12718,12718,12718},{12719,Lo,12719,12719,12719},{12720,Lo,12720,12720,12720},{12721,Lo,12721,12721,12721},{12722,Lo,12722,12722,12722},{12723,Lo,12723,12723,12723},{12724,Lo,12724,12724,12724},{12725,Lo,12725,12725,12725},{12726,Lo,12726,12726,12726},{12727,Lo,12727,12727,12727},{12736,So,12736,12736,12736},{12737,So,12737,12737,12737},{12738,So,12738,12738,12738},{12739,So,12739,12739,12739},{12740,So,12740,12740,12740},{12741,So,12741,12741,12741},{12742,So,12742,12742,12742},{12743,So,12743,12743,12743},{12744,So,12744,12744,12744},{12745,So,12745,12745,12745},{12746,So,12746,12746,12746},{12747,So,12747,12747,12747},{12748,So,12748,12748,12748},{12749,So,12749,12749,12749},{12750,So,12750,12750,12750},{12751,So,12751,12751,12751},{12784,Lo,12784,12784,12784},{12785,Lo,12785,12785,12785},{12786,Lo,12786,12786,12786},{12787,Lo,12787,12787,12787},{12788,Lo,12788,12788,12788},{12789,Lo,12789,12789,12789},{12790,Lo,12790,12790,12790},{12791,Lo,12791,12791,12791},{12792,Lo,12792,12792,12792},{12793,Lo,12793,12793,12793},{12794,Lo,12794,12794,12794},{12795,Lo,12795,12795,12795},{12796,Lo,12796,12796,12796},{12797,Lo,12797,12797,12797},{12798,Lo,12798,12798,12798},{12799,Lo,12799,12799,12799},{12800,So,12800,12800,12800},{12801,So,12801,12801,12801},{12802,So,12802,12802,12802},{12803,So,12803,12803,12803},{12804,So,12804,12804,12804},{12805,So,12805,12805,12805},{12806,So,12806,12806,12806},{12807,So,12807,12807,12807},{12808,So,12808,12808,12808},{12809,So,12809,12809,12809},{12810,So,12810,12810,12810},{12811,So,12811,12811,12811},{12812,So,12812,12812,12812},{12813,So,12813,12813,12813},{12814,So,12814,12814,12814},{12815,So,12815,12815,12815},{12816,So,12816,12816,12816},{12817,So,12817,12817,12817},{12818,So,12818,12818,12818},{12819,So,12819,12819,12819},{12820,So,12820,12820,12820},{12821,So,12821,12821,12821},{12822,So,12822,12822,12822},{12823,So,12823,12823,12823},{12824,So,12824,12824,12824},{12825,So,12825,12825,12825},{12826,So,12826,12826,12826},{12827,So,12827,12827,12827},{12828,So,12828,12828,12828},{12829,So,12829,12829,12829},{12830,So,12830,12830,12830},{12832,No,12832,12832,12832},{12833,No,12833,12833,12833},{12834,No,12834,12834,12834},{12835,No,12835,12835,12835},{12836,No,12836,12836,12836},{12837,No,12837,12837,12837},{12838,No,12838,12838,12838},{12839,No,12839,12839,12839},{12840,No,12840,12840,12840},{12841,No,12841,12841,12841},{12842,So,12842,12842,12842},{12843,So,12843,12843,12843},{12844,So,12844,12844,12844},{12845,So,12845,12845,12845},{12846,So,12846,12846,12846},{12847,So,12847,12847,12847},{12848,So,12848,12848,12848},{12849,So,12849,12849,12849},{12850,So,12850,12850,12850},{12851,So,12851,12851,12851},{12852,So,12852,12852,12852},{12853,So,12853,12853,12853},{12854,So,12854,12854,12854},{12855,So,12855,12855,12855},{12856,So,12856,12856,12856},{12857,So,12857,12857,12857},{12858,So,12858,12858,12858},{12859,So,12859,12859,12859},{12860,So,12860,12860,12860},{12861,So,12861,12861,12861},{12862,So,12862,12862,12862},{12863,So,12863,12863,12863},{12864,So,12864,12864,12864},{12865,So,12865,12865,12865},{12866,So,12866,12866,12866},{12867,So,12867,12867,12867},{12880,So,12880,12880,12880},{12881,No,12881,12881,12881},{12882,No,12882,12882,12882},{12883,No,12883,12883,12883},{12884,No,12884,12884,12884},{12885,No,12885,12885,12885},{12886,No,12886,12886,12886},{12887,No,12887,12887,12887},{12888,No,12888,12888,12888},{12889,No,12889,12889,12889},{12890,No,12890,12890,12890},{12891,No,12891,12891,12891},{12892,No,12892,12892,12892},{12893,No,12893,12893,12893},{12894,No,12894,12894,12894},{12895,No,12895,12895,12895},{12896,So,12896,12896,12896},{12897,So,12897,12897,12897},{12898,So,12898,12898,12898},{12899,So,12899,12899,12899},{12900,So,12900,12900,12900},{12901,So,12901,12901,12901},{12902,So,12902,12902,12902},{12903,So,12903,12903,12903},{12904,So,12904,12904,12904},{12905,So,12905,12905,12905},{12906,So,12906,12906,12906},{12907,So,12907,12907,12907},{12908,So,12908,12908,12908},{12909,So,12909,12909,12909},{12910,So,12910,12910,12910},{12911,So,12911,12911,12911},{12912,So,12912,12912,12912},{12913,So,12913,12913,12913},{12914,So,12914,12914,12914},{12915,So,12915,12915,12915},{12916,So,12916,12916,12916},{12917,So,12917,12917,12917},{12918,So,12918,12918,12918},{12919,So,12919,12919,12919},{12920,So,12920,12920,12920},{12921,So,12921,12921,12921},{12922,So,12922,12922,12922},{12923,So,12923,12923,12923},{12924,So,12924,12924,12924},{12925,So,12925,12925,12925},{12926,So,12926,12926,12926},{12927,So,12927,12927,12927},{12928,No,12928,12928,12928},{12929,No,12929,12929,12929},{12930,No,12930,12930,12930},{12931,No,12931,12931,12931},{12932,No,12932,12932,12932},{12933,No,12933,12933,12933},{12934,No,12934,12934,12934},{12935,No,12935,12935,12935},{12936,No,12936,12936,12936},{12937,No,12937,12937,12937},{12938,So,12938,12938,12938},{12939,So,12939,12939,12939},{12940,So,12940,12940,12940},{12941,So,12941,12941,12941},{12942,So,12942,12942,12942},{12943,So,12943,12943,12943},{12944,So,12944,12944,12944},{12945,So,12945,12945,12945},{12946,So,12946,12946,12946},{12947,So,12947,12947,12947},{12948,So,12948,12948,12948},{12949,So,12949,12949,12949},{12950,So,12950,12950,12950},{12951,So,12951,12951,12951},{12952,So,12952,12952,12952},{12953,So,12953,12953,12953},{12954,So,12954,12954,12954},{12955,So,12955,12955,12955},{12956,So,12956,12956,12956},{12957,So,12957,12957,12957},{12958,So,12958,12958,12958},{12959,So,12959,12959,12959},{12960,So,12960,12960,12960},{12961,So,12961,12961,12961},{12962,So,12962,12962,12962},{12963,So,12963,12963,12963},{12964,So,12964,12964,12964},{12965,So,12965,12965,12965},{12966,So,12966,12966,12966},{12967,So,12967,12967,12967},{12968,So,12968,12968,12968},{12969,So,12969,12969,12969},{12970,So,12970,12970,12970},{12971,So,12971,12971,12971},{12972,So,12972,12972,12972},{12973,So,12973,12973,12973},{12974,So,12974,12974,12974},{12975,So,12975,12975,12975},{12976,So,12976,12976,12976},{12977,No,12977,12977,12977},{12978,No,12978,12978,12978},{12979,No,12979,12979,12979},{12980,No,12980,12980,12980},{12981,No,12981,12981,12981},{12982,No,12982,12982,12982},{12983,No,12983,12983,12983},{12984,No,12984,12984,12984},{12985,No,12985,12985,12985},{12986,No,12986,12986,12986},{12987,No,12987,12987,12987},{12988,No,12988,12988,12988},{12989,No,12989,12989,12989},{12990,No,12990,12990,12990},{12991,No,12991,12991,12991},{12992,So,12992,12992,12992},{12993,So,12993,12993,12993},{12994,So,12994,12994,12994},{12995,So,12995,12995,12995},{12996,So,12996,12996,12996},{12997,So,12997,12997,12997},{12998,So,12998,12998,12998},{12999,So,12999,12999,12999},{13000,So,13000,13000,13000},{13001,So,13001,13001,13001},{13002,So,13002,13002,13002},{13003,So,13003,13003,13003},{13004,So,13004,13004,13004},{13005,So,13005,13005,13005},{13006,So,13006,13006,13006},{13007,So,13007,13007,13007},{13008,So,13008,13008,13008},{13009,So,13009,13009,13009},{13010,So,13010,13010,13010},{13011,So,13011,13011,13011},{13012,So,13012,13012,13012},{13013,So,13013,13013,13013},{13014,So,13014,13014,13014},{13015,So,13015,13015,13015},{13016,So,13016,13016,13016},{13017,So,13017,13017,13017},{13018,So,13018,13018,13018},{13019,So,13019,13019,13019},{13020,So,13020,13020,13020},{13021,So,13021,13021,13021},{13022,So,13022,13022,13022},{13023,So,13023,13023,13023},{13024,So,13024,13024,13024},{13025,So,13025,13025,13025},{13026,So,13026,13026,13026},{13027,So,13027,13027,13027},{13028,So,13028,13028,13028},{13029,So,13029,13029,13029},{13030,So,13030,13030,13030},{13031,So,13031,13031,13031},{13032,So,13032,13032,13032},{13033,So,13033,13033,13033},{13034,So,13034,13034,13034},{13035,So,13035,13035,13035},{13036,So,13036,13036,13036},{13037,So,13037,13037,13037},{13038,So,13038,13038,13038},{13039,So,13039,13039,13039},{13040,So,13040,13040,13040},{13041,So,13041,13041,13041},{13042,So,13042,13042,13042},{13043,So,13043,13043,13043},{13044,So,13044,13044,13044},{13045,So,13045,13045,13045},{13046,So,13046,13046,13046},{13047,So,13047,13047,13047},{13048,So,13048,13048,13048},{13049,So,13049,13049,13049},{13050,So,13050,13050,13050},{13051,So,13051,13051,13051},{13052,So,13052,13052,13052},{13053,So,13053,13053,13053},{13054,So,13054,13054,13054},{13056,So,13056,13056,13056},{13057,So,13057,13057,13057},{13058,So,13058,13058,13058},{13059,So,13059,13059,13059},{13060,So,13060,13060,13060},{13061,So,13061,13061,13061},{13062,So,13062,13062,13062},{13063,So,13063,13063,13063},{13064,So,13064,13064,13064},{13065,So,13065,13065,13065},{13066,So,13066,13066,13066},{13067,So,13067,13067,13067},{13068,So,13068,13068,13068},{13069,So,13069,13069,13069},{13070,So,13070,13070,13070},{13071,So,13071,13071,13071},{13072,So,13072,13072,13072},{13073,So,13073,13073,13073},{13074,So,13074,13074,13074},{13075,So,13075,13075,13075},{13076,So,13076,13076,13076},{13077,So,13077,13077,13077},{13078,So,13078,13078,13078},{13079,So,13079,13079,13079},{13080,So,13080,13080,13080},{13081,So,13081,13081,13081},{13082,So,13082,13082,13082},{13083,So,13083,13083,13083},{13084,So,13084,13084,13084},{13085,So,13085,13085,13085},{13086,So,13086,13086,13086},{13087,So,13087,13087,13087},{13088,So,13088,13088,13088},{13089,So,13089,13089,13089},{13090,So,13090,13090,13090},{13091,So,13091,13091,13091},{13092,So,13092,13092,13092},{13093,So,13093,13093,13093},{13094,So,13094,13094,13094},{13095,So,13095,13095,13095},{13096,So,13096,13096,13096},{13097,So,13097,13097,13097},{13098,So,13098,13098,13098},{13099,So,13099,13099,13099},{13100,So,13100,13100,13100},{13101,So,13101,13101,13101},{13102,So,13102,13102,13102},{13103,So,13103,13103,13103},{13104,So,13104,13104,13104},{13105,So,13105,13105,13105},{13106,So,13106,13106,13106},{13107,So,13107,13107,13107},{13108,So,13108,13108,13108},{13109,So,13109,13109,13109},{13110,So,13110,13110,13110},{13111,So,13111,13111,13111},{13112,So,13112,13112,13112},{13113,So,13113,13113,13113},{13114,So,13114,13114,13114},{13115,So,13115,13115,13115},{13116,So,13116,13116,13116},{13117,So,13117,13117,13117},{13118,So,13118,13118,13118},{13119,So,13119,13119,13119},{13120,So,13120,13120,13120},{13121,So,13121,13121,13121},{13122,So,13122,13122,13122},{13123,So,13123,13123,13123},{13124,So,13124,13124,13124},{13125,So,13125,13125,13125},{13126,So,13126,13126,13126},{13127,So,13127,13127,13127},{13128,So,13128,13128,13128},{13129,So,13129,13129,13129},{13130,So,13130,13130,13130},{13131,So,13131,13131,13131},{13132,So,13132,13132,13132},{13133,So,13133,13133,13133},{13134,So,13134,13134,13134},{13135,So,13135,13135,13135},{13136,So,13136,13136,13136},{13137,So,13137,13137,13137},{13138,So,13138,13138,13138},{13139,So,13139,13139,13139},{13140,So,13140,13140,13140},{13141,So,13141,13141,13141},{13142,So,13142,13142,13142},{13143,So,13143,13143,13143},{13144,So,13144,13144,13144},{13145,So,13145,13145,13145},{13146,So,13146,13146,13146},{13147,So,13147,13147,13147},{13148,So,13148,13148,13148},{13149,So,13149,13149,13149},{13150,So,13150,13150,13150},{13151,So,13151,13151,13151},{13152,So,13152,13152,13152},{13153,So,13153,13153,13153},{13154,So,13154,13154,13154},{13155,So,13155,13155,13155},{13156,So,13156,13156,13156},{13157,So,13157,13157,13157},{13158,So,13158,13158,13158},{13159,So,13159,13159,13159},{13160,So,13160,13160,13160},{13161,So,13161,13161,13161},{13162,So,13162,13162,13162},{13163,So,13163,13163,13163},{13164,So,13164,13164,13164},{13165,So,13165,13165,13165},{13166,So,13166,13166,13166},{13167,So,13167,13167,13167},{13168,So,13168,13168,13168},{13169,So,13169,13169,13169},{13170,So,13170,13170,13170},{13171,So,13171,13171,13171},{13172,So,13172,13172,13172},{13173,So,13173,13173,13173},{13174,So,13174,13174,13174},{13175,So,13175,13175,13175},{13176,So,13176,13176,13176},{13177,So,13177,13177,13177},{13178,So,13178,13178,13178},{13179,So,13179,13179,13179},{13180,So,13180,13180,13180},{13181,So,13181,13181,13181},{13182,So,13182,13182,13182},{13183,So,13183,13183,13183},{13184,So,13184,13184,13184},{13185,So,13185,13185,13185},{13186,So,13186,13186,13186},{13187,So,13187,13187,13187},{13188,So,13188,13188,13188},{13189,So,13189,13189,13189},{13190,So,13190,13190,13190},{13191,So,13191,13191,13191},{13192,So,13192,13192,13192},{13193,So,13193,13193,13193},{13194,So,13194,13194,13194},{13195,So,13195,13195,13195},{13196,So,13196,13196,13196},{13197,So,13197,13197,13197},{13198,So,13198,13198,13198},{13199,So,13199,13199,13199},{13200,So,13200,13200,13200},{13201,So,13201,13201,13201},{13202,So,13202,13202,13202},{13203,So,13203,13203,13203},{13204,So,13204,13204,13204},{13205,So,13205,13205,13205},{13206,So,13206,13206,13206},{13207,So,13207,13207,13207},{13208,So,13208,13208,13208},{13209,So,13209,13209,13209},{13210,So,13210,13210,13210},{13211,So,13211,13211,13211},{13212,So,13212,13212,13212},{13213,So,13213,13213,13213},{13214,So,13214,13214,13214},{13215,So,13215,13215,13215},{13216,So,13216,13216,13216},{13217,So,13217,13217,13217},{13218,So,13218,13218,13218},{13219,So,13219,13219,13219},{13220,So,13220,13220,13220},{13221,So,13221,13221,13221},{13222,So,13222,13222,13222},{13223,So,13223,13223,13223},{13224,So,13224,13224,13224},{13225,So,13225,13225,13225},{13226,So,13226,13226,13226},{13227,So,13227,13227,13227},{13228,So,13228,13228,13228},{13229,So,13229,13229,13229},{13230,So,13230,13230,13230},{13231,So,13231,13231,13231},{13232,So,13232,13232,13232},{13233,So,13233,13233,13233},{13234,So,13234,13234,13234},{13235,So,13235,13235,13235},{13236,So,13236,13236,13236},{13237,So,13237,13237,13237},{13238,So,13238,13238,13238},{13239,So,13239,13239,13239},{13240,So,13240,13240,13240},{13241,So,13241,13241,13241},{13242,So,13242,13242,13242},{13243,So,13243,13243,13243},{13244,So,13244,13244,13244},{13245,So,13245,13245,13245},{13246,So,13246,13246,13246},{13247,So,13247,13247,13247},{13248,So,13248,13248,13248},{13249,So,13249,13249,13249},{13250,So,13250,13250,13250},{13251,So,13251,13251,13251},{13252,So,13252,13252,13252},{13253,So,13253,13253,13253},{13254,So,13254,13254,13254},{13255,So,13255,13255,13255},{13256,So,13256,13256,13256},{13257,So,13257,13257,13257},{13258,So,13258,13258,13258},{13259,So,13259,13259,13259},{13260,So,13260,13260,13260},{13261,So,13261,13261,13261},{13262,So,13262,13262,13262},{13263,So,13263,13263,13263},{13264,So,13264,13264,13264},{13265,So,13265,13265,13265},{13266,So,13266,13266,13266},{13267,So,13267,13267,13267},{13268,So,13268,13268,13268},{13269,So,13269,13269,13269},{13270,So,13270,13270,13270},{13271,So,13271,13271,13271},{13272,So,13272,13272,13272},{13273,So,13273,13273,13273},{13274,So,13274,13274,13274},{13275,So,13275,13275,13275},{13276,So,13276,13276,13276},{13277,So,13277,13277,13277},{13278,So,13278,13278,13278},{13279,So,13279,13279,13279},{13280,So,13280,13280,13280},{13281,So,13281,13281,13281},{13282,So,13282,13282,13282},{13283,So,13283,13283,13283},{13284,So,13284,13284,13284},{13285,So,13285,13285,13285},{13286,So,13286,13286,13286},{13287,So,13287,13287,13287},{13288,So,13288,13288,13288},{13289,So,13289,13289,13289},{13290,So,13290,13290,13290},{13291,So,13291,13291,13291},{13292,So,13292,13292,13292},{13293,So,13293,13293,13293},{13294,So,13294,13294,13294},{13295,So,13295,13295,13295},{13296,So,13296,13296,13296},{13297,So,13297,13297,13297},{13298,So,13298,13298,13298},{13299,So,13299,13299,13299},{13300,So,13300,13300,13300},{13301,So,13301,13301,13301},{13302,So,13302,13302,13302},{13303,So,13303,13303,13303},{13304,So,13304,13304,13304},{13305,So,13305,13305,13305},{13306,So,13306,13306,13306},{13307,So,13307,13307,13307},{13308,So,13308,13308,13308},{13309,So,13309,13309,13309},{13310,So,13310,13310,13310},{13311,So,13311,13311,13311},{13312,Lo,13312,13312,13312},{19893,Lo,19893,19893,19893},{19904,So,19904,19904,19904},{19905,So,19905,19905,19905},{19906,So,19906,19906,19906},{19907,So,19907,19907,19907},{19908,So,19908,19908,19908},{19909,So,19909,19909,19909},{19910,So,19910,19910,19910},{19911,So,19911,19911,19911},{19912,So,19912,19912,19912},{19913,So,19913,19913,19913},{19914,So,19914,19914,19914},{19915,So,19915,19915,19915},{19916,So,19916,19916,19916},{19917,So,19917,19917,19917},{19918,So,19918,19918,19918},{19919,So,19919,19919,19919},{19920,So,19920,19920,19920},{19921,So,19921,19921,19921},{19922,So,19922,19922,19922},{19923,So,19923,19923,19923},{19924,So,19924,19924,19924},{19925,So,19925,19925,19925},{19926,So,19926,19926,19926},{19927,So,19927,19927,19927},{19928,So,19928,19928,19928},{19929,So,19929,19929,19929},{19930,So,19930,19930,19930},{19931,So,19931,19931,19931},{19932,So,19932,19932,19932},{19933,So,19933,19933,19933},{19934,So,19934,19934,19934},{19935,So,19935,19935,19935},{19936,So,19936,19936,19936},{19937,So,19937,19937,19937},{19938,So,19938,19938,19938},{19939,So,19939,19939,19939},{19940,So,19940,19940,19940},{19941,So,19941,19941,19941},{19942,So,19942,19942,19942},{19943,So,19943,19943,19943},{19944,So,19944,19944,19944},{19945,So,19945,19945,19945},{19946,So,19946,19946,19946},{19947,So,19947,19947,19947},{19948,So,19948,19948,19948},{19949,So,19949,19949,19949},{19950,So,19950,19950,19950},{19951,So,19951,19951,19951},{19952,So,19952,19952,19952},{19953,So,19953,19953,19953},{19954,So,19954,19954,19954},{19955,So,19955,19955,19955},{19956,So,19956,19956,19956},{19957,So,19957,19957,19957},{19958,So,19958,19958,19958},{19959,So,19959,19959,19959},{19960,So,19960,19960,19960},{19961,So,19961,19961,19961},{19962,So,19962,19962,19962},{19963,So,19963,19963,19963},{19964,So,19964,19964,19964},{19965,So,19965,19965,19965},{19966,So,19966,19966,19966},{19967,So,19967,19967,19967},{19968,Lo,19968,19968,19968},{40891,Lo,40891,40891,40891},{40960,Lo,40960,40960,40960},{40961,Lo,40961,40961,40961},{40962,Lo,40962,40962,40962},{40963,Lo,40963,40963,40963},{40964,Lo,40964,40964,40964},{40965,Lo,40965,40965,40965},{40966,Lo,40966,40966,40966},{40967,Lo,40967,40967,40967},{40968,Lo,40968,40968,40968},{40969,Lo,40969,40969,40969},{40970,Lo,40970,40970,40970},{40971,Lo,40971,40971,40971},{40972,Lo,40972,40972,40972},{40973,Lo,40973,40973,40973},{40974,Lo,40974,40974,40974},{40975,Lo,40975,40975,40975},{40976,Lo,40976,40976,40976},{40977,Lo,40977,40977,40977},{40978,Lo,40978,40978,40978},{40979,Lo,40979,40979,40979},{40980,Lo,40980,40980,40980},{40981,Lm,40981,40981,40981},{40982,Lo,40982,40982,40982},{40983,Lo,40983,40983,40983},{40984,Lo,40984,40984,40984},{40985,Lo,40985,40985,40985},{40986,Lo,40986,40986,40986},{40987,Lo,40987,40987,40987},{40988,Lo,40988,40988,40988},{40989,Lo,40989,40989,40989},{40990,Lo,40990,40990,40990},{40991,Lo,40991,40991,40991},{40992,Lo,40992,40992,40992},{40993,Lo,40993,40993,40993},{40994,Lo,40994,40994,40994},{40995,Lo,40995,40995,40995},{40996,Lo,40996,40996,40996},{40997,Lo,40997,40997,40997},{40998,Lo,40998,40998,40998},{40999,Lo,40999,40999,40999},{41000,Lo,41000,41000,41000},{41001,Lo,41001,41001,41001},{41002,Lo,41002,41002,41002},{41003,Lo,41003,41003,41003},{41004,Lo,41004,41004,41004},{41005,Lo,41005,41005,41005},{41006,Lo,41006,41006,41006},{41007,Lo,41007,41007,41007},{41008,Lo,41008,41008,41008},{41009,Lo,41009,41009,41009},{41010,Lo,41010,41010,41010},{41011,Lo,41011,41011,41011},{41012,Lo,41012,41012,41012},{41013,Lo,41013,41013,41013},{41014,Lo,41014,41014,41014},{41015,Lo,41015,41015,41015},{41016,Lo,41016,41016,41016},{41017,Lo,41017,41017,41017},{41018,Lo,41018,41018,41018},{41019,Lo,41019,41019,41019},{41020,Lo,41020,41020,41020},{41021,Lo,41021,41021,41021},{41022,Lo,41022,41022,41022},{41023,Lo,41023,41023,41023},{41024,Lo,41024,41024,41024},{41025,Lo,41025,41025,41025},{41026,Lo,41026,41026,41026},{41027,Lo,41027,41027,41027},{41028,Lo,41028,41028,41028},{41029,Lo,41029,41029,41029},{41030,Lo,41030,41030,41030},{41031,Lo,41031,41031,41031},{41032,Lo,41032,41032,41032},{41033,Lo,41033,41033,41033},{41034,Lo,41034,41034,41034},{41035,Lo,41035,41035,41035},{41036,Lo,41036,41036,41036},{41037,Lo,41037,41037,41037},{41038,Lo,41038,41038,41038},{41039,Lo,41039,41039,41039},{41040,Lo,41040,41040,41040},{41041,Lo,41041,41041,41041},{41042,Lo,41042,41042,41042},{41043,Lo,41043,41043,41043},{41044,Lo,41044,41044,41044},{41045,Lo,41045,41045,41045},{41046,Lo,41046,41046,41046},{41047,Lo,41047,41047,41047},{41048,Lo,41048,41048,41048},{41049,Lo,41049,41049,41049},{41050,Lo,41050,41050,41050},{41051,Lo,41051,41051,41051},{41052,Lo,41052,41052,41052},{41053,Lo,41053,41053,41053},{41054,Lo,41054,41054,41054},{41055,Lo,41055,41055,41055},{41056,Lo,41056,41056,41056},{41057,Lo,41057,41057,41057},{41058,Lo,41058,41058,41058},{41059,Lo,41059,41059,41059},{41060,Lo,41060,41060,41060},{41061,Lo,41061,41061,41061},{41062,Lo,41062,41062,41062},{41063,Lo,41063,41063,41063},{41064,Lo,41064,41064,41064},{41065,Lo,41065,41065,41065},{41066,Lo,41066,41066,41066},{41067,Lo,41067,41067,41067},{41068,Lo,41068,41068,41068},{41069,Lo,41069,41069,41069},{41070,Lo,41070,41070,41070},{41071,Lo,41071,41071,41071},{41072,Lo,41072,41072,41072},{41073,Lo,41073,41073,41073},{41074,Lo,41074,41074,41074},{41075,Lo,41075,41075,41075},{41076,Lo,41076,41076,41076},{41077,Lo,41077,41077,41077},{41078,Lo,41078,41078,41078},{41079,Lo,41079,41079,41079},{41080,Lo,41080,41080,41080},{41081,Lo,41081,41081,41081},{41082,Lo,41082,41082,41082},{41083,Lo,41083,41083,41083},{41084,Lo,41084,41084,41084},{41085,Lo,41085,41085,41085},{41086,Lo,41086,41086,41086},{41087,Lo,41087,41087,41087},{41088,Lo,41088,41088,41088},{41089,Lo,41089,41089,41089},{41090,Lo,41090,41090,41090},{41091,Lo,41091,41091,41091},{41092,Lo,41092,41092,41092},{41093,Lo,41093,41093,41093},{41094,Lo,41094,41094,41094},{41095,Lo,41095,41095,41095},{41096,Lo,41096,41096,41096},{41097,Lo,41097,41097,41097},{41098,Lo,41098,41098,41098},{41099,Lo,41099,41099,41099},{41100,Lo,41100,41100,41100},{41101,Lo,41101,41101,41101},{41102,Lo,41102,41102,41102},{41103,Lo,41103,41103,41103},{41104,Lo,41104,41104,41104},{41105,Lo,41105,41105,41105},{41106,Lo,41106,41106,41106},{41107,Lo,41107,41107,41107},{41108,Lo,41108,41108,41108},{41109,Lo,41109,41109,41109},{41110,Lo,41110,41110,41110},{41111,Lo,41111,41111,41111},{41112,Lo,41112,41112,41112},{41113,Lo,41113,41113,41113},{41114,Lo,41114,41114,41114},{41115,Lo,41115,41115,41115},{41116,Lo,41116,41116,41116},{41117,Lo,41117,41117,41117},{41118,Lo,41118,41118,41118},{41119,Lo,41119,41119,41119},{41120,Lo,41120,41120,41120},{41121,Lo,41121,41121,41121},{41122,Lo,41122,41122,41122},{41123,Lo,41123,41123,41123},{41124,Lo,41124,41124,41124},{41125,Lo,41125,41125,41125},{41126,Lo,41126,41126,41126},{41127,Lo,41127,41127,41127},{41128,Lo,41128,41128,41128},{41129,Lo,41129,41129,41129},{41130,Lo,41130,41130,41130},{41131,Lo,41131,41131,41131},{41132,Lo,41132,41132,41132},{41133,Lo,41133,41133,41133},{41134,Lo,41134,41134,41134},{41135,Lo,41135,41135,41135},{41136,Lo,41136,41136,41136},{41137,Lo,41137,41137,41137},{41138,Lo,41138,41138,41138},{41139,Lo,41139,41139,41139},{41140,Lo,41140,41140,41140},{41141,Lo,41141,41141,41141},{41142,Lo,41142,41142,41142},{41143,Lo,41143,41143,41143},{41144,Lo,41144,41144,41144},{41145,Lo,41145,41145,41145},{41146,Lo,41146,41146,41146},{41147,Lo,41147,41147,41147},{41148,Lo,41148,41148,41148},{41149,Lo,41149,41149,41149},{41150,Lo,41150,41150,41150},{41151,Lo,41151,41151,41151},{41152,Lo,41152,41152,41152},{41153,Lo,41153,41153,41153},{41154,Lo,41154,41154,41154},{41155,Lo,41155,41155,41155},{41156,Lo,41156,41156,41156},{41157,Lo,41157,41157,41157},{41158,Lo,41158,41158,41158},{41159,Lo,41159,41159,41159},{41160,Lo,41160,41160,41160},{41161,Lo,41161,41161,41161},{41162,Lo,41162,41162,41162},{41163,Lo,41163,41163,41163},{41164,Lo,41164,41164,41164},{41165,Lo,41165,41165,41165},{41166,Lo,41166,41166,41166},{41167,Lo,41167,41167,41167},{41168,Lo,41168,41168,41168},{41169,Lo,41169,41169,41169},{41170,Lo,41170,41170,41170},{41171,Lo,41171,41171,41171},{41172,Lo,41172,41172,41172},{41173,Lo,41173,41173,41173},{41174,Lo,41174,41174,41174},{41175,Lo,41175,41175,41175},{41176,Lo,41176,41176,41176},{41177,Lo,41177,41177,41177},{41178,Lo,41178,41178,41178},{41179,Lo,41179,41179,41179},{41180,Lo,41180,41180,41180},{41181,Lo,41181,41181,41181},{41182,Lo,41182,41182,41182},{41183,Lo,41183,41183,41183},{41184,Lo,41184,41184,41184},{41185,Lo,41185,41185,41185},{41186,Lo,41186,41186,41186},{41187,Lo,41187,41187,41187},{41188,Lo,41188,41188,41188},{41189,Lo,41189,41189,41189},{41190,Lo,41190,41190,41190},{41191,Lo,41191,41191,41191},{41192,Lo,41192,41192,41192},{41193,Lo,41193,41193,41193},{41194,Lo,41194,41194,41194},{41195,Lo,41195,41195,41195},{41196,Lo,41196,41196,41196},{41197,Lo,41197,41197,41197},{41198,Lo,41198,41198,41198},{41199,Lo,41199,41199,41199},{41200,Lo,41200,41200,41200},{41201,Lo,41201,41201,41201},{41202,Lo,41202,41202,41202},{41203,Lo,41203,41203,41203},{41204,Lo,41204,41204,41204},{41205,Lo,41205,41205,41205},{41206,Lo,41206,41206,41206},{41207,Lo,41207,41207,41207},{41208,Lo,41208,41208,41208},{41209,Lo,41209,41209,41209},{41210,Lo,41210,41210,41210},{41211,Lo,41211,41211,41211},{41212,Lo,41212,41212,41212},{41213,Lo,41213,41213,41213},{41214,Lo,41214,41214,41214},{41215,Lo,41215,41215,41215},{41216,Lo,41216,41216,41216},{41217,Lo,41217,41217,41217},{41218,Lo,41218,41218,41218},{41219,Lo,41219,41219,41219},{41220,Lo,41220,41220,41220},{41221,Lo,41221,41221,41221},{41222,Lo,41222,41222,41222},{41223,Lo,41223,41223,41223},{41224,Lo,41224,41224,41224},{41225,Lo,41225,41225,41225},{41226,Lo,41226,41226,41226},{41227,Lo,41227,41227,41227},{41228,Lo,41228,41228,41228},{41229,Lo,41229,41229,41229},{41230,Lo,41230,41230,41230},{41231,Lo,41231,41231,41231},{41232,Lo,41232,41232,41232},{41233,Lo,41233,41233,41233},{41234,Lo,41234,41234,41234},{41235,Lo,41235,41235,41235},{41236,Lo,41236,41236,41236},{41237,Lo,41237,41237,41237},{41238,Lo,41238,41238,41238},{41239,Lo,41239,41239,41239},{41240,Lo,41240,41240,41240},{41241,Lo,41241,41241,41241},{41242,Lo,41242,41242,41242},{41243,Lo,41243,41243,41243},{41244,Lo,41244,41244,41244},{41245,Lo,41245,41245,41245},{41246,Lo,41246,41246,41246},{41247,Lo,41247,41247,41247},{41248,Lo,41248,41248,41248},{41249,Lo,41249,41249,41249},{41250,Lo,41250,41250,41250},{41251,Lo,41251,41251,41251},{41252,Lo,41252,41252,41252},{41253,Lo,41253,41253,41253},{41254,Lo,41254,41254,41254},{41255,Lo,41255,41255,41255},{41256,Lo,41256,41256,41256},{41257,Lo,41257,41257,41257},{41258,Lo,41258,41258,41258},{41259,Lo,41259,41259,41259},{41260,Lo,41260,41260,41260},{41261,Lo,41261,41261,41261},{41262,Lo,41262,41262,41262},{41263,Lo,41263,41263,41263},{41264,Lo,41264,41264,41264},{41265,Lo,41265,41265,41265},{41266,Lo,41266,41266,41266},{41267,Lo,41267,41267,41267},{41268,Lo,41268,41268,41268},{41269,Lo,41269,41269,41269},{41270,Lo,41270,41270,41270},{41271,Lo,41271,41271,41271},{41272,Lo,41272,41272,41272},{41273,Lo,41273,41273,41273},{41274,Lo,41274,41274,41274},{41275,Lo,41275,41275,41275},{41276,Lo,41276,41276,41276},{41277,Lo,41277,41277,41277},{41278,Lo,41278,41278,41278},{41279,Lo,41279,41279,41279},{41280,Lo,41280,41280,41280},{41281,Lo,41281,41281,41281},{41282,Lo,41282,41282,41282},{41283,Lo,41283,41283,41283},{41284,Lo,41284,41284,41284},{41285,Lo,41285,41285,41285},{41286,Lo,41286,41286,41286},{41287,Lo,41287,41287,41287},{41288,Lo,41288,41288,41288},{41289,Lo,41289,41289,41289},{41290,Lo,41290,41290,41290},{41291,Lo,41291,41291,41291},{41292,Lo,41292,41292,41292},{41293,Lo,41293,41293,41293},{41294,Lo,41294,41294,41294},{41295,Lo,41295,41295,41295},{41296,Lo,41296,41296,41296},{41297,Lo,41297,41297,41297},{41298,Lo,41298,41298,41298},{41299,Lo,41299,41299,41299},{41300,Lo,41300,41300,41300},{41301,Lo,41301,41301,41301},{41302,Lo,41302,41302,41302},{41303,Lo,41303,41303,41303},{41304,Lo,41304,41304,41304},{41305,Lo,41305,41305,41305},{41306,Lo,41306,41306,41306},{41307,Lo,41307,41307,41307},{41308,Lo,41308,41308,41308},{41309,Lo,41309,41309,41309},{41310,Lo,41310,41310,41310},{41311,Lo,41311,41311,41311},{41312,Lo,41312,41312,41312},{41313,Lo,41313,41313,41313},{41314,Lo,41314,41314,41314},{41315,Lo,41315,41315,41315},{41316,Lo,41316,41316,41316},{41317,Lo,41317,41317,41317},{41318,Lo,41318,41318,41318},{41319,Lo,41319,41319,41319},{41320,Lo,41320,41320,41320},{41321,Lo,41321,41321,41321},{41322,Lo,41322,41322,41322},{41323,Lo,41323,41323,41323},{41324,Lo,41324,41324,41324},{41325,Lo,41325,41325,41325},{41326,Lo,41326,41326,41326},{41327,Lo,41327,41327,41327},{41328,Lo,41328,41328,41328},{41329,Lo,41329,41329,41329},{41330,Lo,41330,41330,41330},{41331,Lo,41331,41331,41331},{41332,Lo,41332,41332,41332},{41333,Lo,41333,41333,41333},{41334,Lo,41334,41334,41334},{41335,Lo,41335,41335,41335},{41336,Lo,41336,41336,41336},{41337,Lo,41337,41337,41337},{41338,Lo,41338,41338,41338},{41339,Lo,41339,41339,41339},{41340,Lo,41340,41340,41340},{41341,Lo,41341,41341,41341},{41342,Lo,41342,41342,41342},{41343,Lo,41343,41343,41343},{41344,Lo,41344,41344,41344},{41345,Lo,41345,41345,41345},{41346,Lo,41346,41346,41346},{41347,Lo,41347,41347,41347},{41348,Lo,41348,41348,41348},{41349,Lo,41349,41349,41349},{41350,Lo,41350,41350,41350},{41351,Lo,41351,41351,41351},{41352,Lo,41352,41352,41352},{41353,Lo,41353,41353,41353},{41354,Lo,41354,41354,41354},{41355,Lo,41355,41355,41355},{41356,Lo,41356,41356,41356},{41357,Lo,41357,41357,41357},{41358,Lo,41358,41358,41358},{41359,Lo,41359,41359,41359},{41360,Lo,41360,41360,41360},{41361,Lo,41361,41361,41361},{41362,Lo,41362,41362,41362},{41363,Lo,41363,41363,41363},{41364,Lo,41364,41364,41364},{41365,Lo,41365,41365,41365},{41366,Lo,41366,41366,41366},{41367,Lo,41367,41367,41367},{41368,Lo,41368,41368,41368},{41369,Lo,41369,41369,41369},{41370,Lo,41370,41370,41370},{41371,Lo,41371,41371,41371},{41372,Lo,41372,41372,41372},{41373,Lo,41373,41373,41373},{41374,Lo,41374,41374,41374},{41375,Lo,41375,41375,41375},{41376,Lo,41376,41376,41376},{41377,Lo,41377,41377,41377},{41378,Lo,41378,41378,41378},{41379,Lo,41379,41379,41379},{41380,Lo,41380,41380,41380},{41381,Lo,41381,41381,41381},{41382,Lo,41382,41382,41382},{41383,Lo,41383,41383,41383},{41384,Lo,41384,41384,41384},{41385,Lo,41385,41385,41385},{41386,Lo,41386,41386,41386},{41387,Lo,41387,41387,41387},{41388,Lo,41388,41388,41388},{41389,Lo,41389,41389,41389},{41390,Lo,41390,41390,41390},{41391,Lo,41391,41391,41391},{41392,Lo,41392,41392,41392},{41393,Lo,41393,41393,41393},{41394,Lo,41394,41394,41394},{41395,Lo,41395,41395,41395},{41396,Lo,41396,41396,41396},{41397,Lo,41397,41397,41397},{41398,Lo,41398,41398,41398},{41399,Lo,41399,41399,41399},{41400,Lo,41400,41400,41400},{41401,Lo,41401,41401,41401},{41402,Lo,41402,41402,41402},{41403,Lo,41403,41403,41403},{41404,Lo,41404,41404,41404},{41405,Lo,41405,41405,41405},{41406,Lo,41406,41406,41406},{41407,Lo,41407,41407,41407},{41408,Lo,41408,41408,41408},{41409,Lo,41409,41409,41409},{41410,Lo,41410,41410,41410},{41411,Lo,41411,41411,41411},{41412,Lo,41412,41412,41412},{41413,Lo,41413,41413,41413},{41414,Lo,41414,41414,41414},{41415,Lo,41415,41415,41415},{41416,Lo,41416,41416,41416},{41417,Lo,41417,41417,41417},{41418,Lo,41418,41418,41418},{41419,Lo,41419,41419,41419},{41420,Lo,41420,41420,41420},{41421,Lo,41421,41421,41421},{41422,Lo,41422,41422,41422},{41423,Lo,41423,41423,41423},{41424,Lo,41424,41424,41424},{41425,Lo,41425,41425,41425},{41426,Lo,41426,41426,41426},{41427,Lo,41427,41427,41427},{41428,Lo,41428,41428,41428},{41429,Lo,41429,41429,41429},{41430,Lo,41430,41430,41430},{41431,Lo,41431,41431,41431},{41432,Lo,41432,41432,41432},{41433,Lo,41433,41433,41433},{41434,Lo,41434,41434,41434},{41435,Lo,41435,41435,41435},{41436,Lo,41436,41436,41436},{41437,Lo,41437,41437,41437},{41438,Lo,41438,41438,41438},{41439,Lo,41439,41439,41439},{41440,Lo,41440,41440,41440},{41441,Lo,41441,41441,41441},{41442,Lo,41442,41442,41442},{41443,Lo,41443,41443,41443},{41444,Lo,41444,41444,41444},{41445,Lo,41445,41445,41445},{41446,Lo,41446,41446,41446},{41447,Lo,41447,41447,41447},{41448,Lo,41448,41448,41448},{41449,Lo,41449,41449,41449},{41450,Lo,41450,41450,41450},{41451,Lo,41451,41451,41451},{41452,Lo,41452,41452,41452},{41453,Lo,41453,41453,41453},{41454,Lo,41454,41454,41454},{41455,Lo,41455,41455,41455},{41456,Lo,41456,41456,41456},{41457,Lo,41457,41457,41457},{41458,Lo,41458,41458,41458},{41459,Lo,41459,41459,41459},{41460,Lo,41460,41460,41460},{41461,Lo,41461,41461,41461},{41462,Lo,41462,41462,41462},{41463,Lo,41463,41463,41463},{41464,Lo,41464,41464,41464},{41465,Lo,41465,41465,41465},{41466,Lo,41466,41466,41466},{41467,Lo,41467,41467,41467},{41468,Lo,41468,41468,41468},{41469,Lo,41469,41469,41469},{41470,Lo,41470,41470,41470},{41471,Lo,41471,41471,41471},{41472,Lo,41472,41472,41472},{41473,Lo,41473,41473,41473},{41474,Lo,41474,41474,41474},{41475,Lo,41475,41475,41475},{41476,Lo,41476,41476,41476},{41477,Lo,41477,41477,41477},{41478,Lo,41478,41478,41478},{41479,Lo,41479,41479,41479},{41480,Lo,41480,41480,41480},{41481,Lo,41481,41481,41481},{41482,Lo,41482,41482,41482},{41483,Lo,41483,41483,41483},{41484,Lo,41484,41484,41484},{41485,Lo,41485,41485,41485},{41486,Lo,41486,41486,41486},{41487,Lo,41487,41487,41487},{41488,Lo,41488,41488,41488},{41489,Lo,41489,41489,41489},{41490,Lo,41490,41490,41490},{41491,Lo,41491,41491,41491},{41492,Lo,41492,41492,41492},{41493,Lo,41493,41493,41493},{41494,Lo,41494,41494,41494},{41495,Lo,41495,41495,41495},{41496,Lo,41496,41496,41496},{41497,Lo,41497,41497,41497},{41498,Lo,41498,41498,41498},{41499,Lo,41499,41499,41499},{41500,Lo,41500,41500,41500},{41501,Lo,41501,41501,41501},{41502,Lo,41502,41502,41502},{41503,Lo,41503,41503,41503},{41504,Lo,41504,41504,41504},{41505,Lo,41505,41505,41505},{41506,Lo,41506,41506,41506},{41507,Lo,41507,41507,41507},{41508,Lo,41508,41508,41508},{41509,Lo,41509,41509,41509},{41510,Lo,41510,41510,41510},{41511,Lo,41511,41511,41511},{41512,Lo,41512,41512,41512},{41513,Lo,41513,41513,41513},{41514,Lo,41514,41514,41514},{41515,Lo,41515,41515,41515},{41516,Lo,41516,41516,41516},{41517,Lo,41517,41517,41517},{41518,Lo,41518,41518,41518},{41519,Lo,41519,41519,41519},{41520,Lo,41520,41520,41520},{41521,Lo,41521,41521,41521},{41522,Lo,41522,41522,41522},{41523,Lo,41523,41523,41523},{41524,Lo,41524,41524,41524},{41525,Lo,41525,41525,41525},{41526,Lo,41526,41526,41526},{41527,Lo,41527,41527,41527},{41528,Lo,41528,41528,41528},{41529,Lo,41529,41529,41529},{41530,Lo,41530,41530,41530},{41531,Lo,41531,41531,41531},{41532,Lo,41532,41532,41532},{41533,Lo,41533,41533,41533},{41534,Lo,41534,41534,41534},{41535,Lo,41535,41535,41535},{41536,Lo,41536,41536,41536},{41537,Lo,41537,41537,41537},{41538,Lo,41538,41538,41538},{41539,Lo,41539,41539,41539},{41540,Lo,41540,41540,41540},{41541,Lo,41541,41541,41541},{41542,Lo,41542,41542,41542},{41543,Lo,41543,41543,41543},{41544,Lo,41544,41544,41544},{41545,Lo,41545,41545,41545},{41546,Lo,41546,41546,41546},{41547,Lo,41547,41547,41547},{41548,Lo,41548,41548,41548},{41549,Lo,41549,41549,41549},{41550,Lo,41550,41550,41550},{41551,Lo,41551,41551,41551},{41552,Lo,41552,41552,41552},{41553,Lo,41553,41553,41553},{41554,Lo,41554,41554,41554},{41555,Lo,41555,41555,41555},{41556,Lo,41556,41556,41556},{41557,Lo,41557,41557,41557},{41558,Lo,41558,41558,41558},{41559,Lo,41559,41559,41559},{41560,Lo,41560,41560,41560},{41561,Lo,41561,41561,41561},{41562,Lo,41562,41562,41562},{41563,Lo,41563,41563,41563},{41564,Lo,41564,41564,41564},{41565,Lo,41565,41565,41565},{41566,Lo,41566,41566,41566},{41567,Lo,41567,41567,41567},{41568,Lo,41568,41568,41568},{41569,Lo,41569,41569,41569},{41570,Lo,41570,41570,41570},{41571,Lo,41571,41571,41571},{41572,Lo,41572,41572,41572},{41573,Lo,41573,41573,41573},{41574,Lo,41574,41574,41574},{41575,Lo,41575,41575,41575},{41576,Lo,41576,41576,41576},{41577,Lo,41577,41577,41577},{41578,Lo,41578,41578,41578},{41579,Lo,41579,41579,41579},{41580,Lo,41580,41580,41580},{41581,Lo,41581,41581,41581},{41582,Lo,41582,41582,41582},{41583,Lo,41583,41583,41583},{41584,Lo,41584,41584,41584},{41585,Lo,41585,41585,41585},{41586,Lo,41586,41586,41586},{41587,Lo,41587,41587,41587},{41588,Lo,41588,41588,41588},{41589,Lo,41589,41589,41589},{41590,Lo,41590,41590,41590},{41591,Lo,41591,41591,41591},{41592,Lo,41592,41592,41592},{41593,Lo,41593,41593,41593},{41594,Lo,41594,41594,41594},{41595,Lo,41595,41595,41595},{41596,Lo,41596,41596,41596},{41597,Lo,41597,41597,41597},{41598,Lo,41598,41598,41598},{41599,Lo,41599,41599,41599},{41600,Lo,41600,41600,41600},{41601,Lo,41601,41601,41601},{41602,Lo,41602,41602,41602},{41603,Lo,41603,41603,41603},{41604,Lo,41604,41604,41604},{41605,Lo,41605,41605,41605},{41606,Lo,41606,41606,41606},{41607,Lo,41607,41607,41607},{41608,Lo,41608,41608,41608},{41609,Lo,41609,41609,41609},{41610,Lo,41610,41610,41610},{41611,Lo,41611,41611,41611},{41612,Lo,41612,41612,41612},{41613,Lo,41613,41613,41613},{41614,Lo,41614,41614,41614},{41615,Lo,41615,41615,41615},{41616,Lo,41616,41616,41616},{41617,Lo,41617,41617,41617},{41618,Lo,41618,41618,41618},{41619,Lo,41619,41619,41619},{41620,Lo,41620,41620,41620},{41621,Lo,41621,41621,41621},{41622,Lo,41622,41622,41622},{41623,Lo,41623,41623,41623},{41624,Lo,41624,41624,41624},{41625,Lo,41625,41625,41625},{41626,Lo,41626,41626,41626},{41627,Lo,41627,41627,41627},{41628,Lo,41628,41628,41628},{41629,Lo,41629,41629,41629},{41630,Lo,41630,41630,41630},{41631,Lo,41631,41631,41631},{41632,Lo,41632,41632,41632},{41633,Lo,41633,41633,41633},{41634,Lo,41634,41634,41634},{41635,Lo,41635,41635,41635},{41636,Lo,41636,41636,41636},{41637,Lo,41637,41637,41637},{41638,Lo,41638,41638,41638},{41639,Lo,41639,41639,41639},{41640,Lo,41640,41640,41640},{41641,Lo,41641,41641,41641},{41642,Lo,41642,41642,41642},{41643,Lo,41643,41643,41643},{41644,Lo,41644,41644,41644},{41645,Lo,41645,41645,41645},{41646,Lo,41646,41646,41646},{41647,Lo,41647,41647,41647},{41648,Lo,41648,41648,41648},{41649,Lo,41649,41649,41649},{41650,Lo,41650,41650,41650},{41651,Lo,41651,41651,41651},{41652,Lo,41652,41652,41652},{41653,Lo,41653,41653,41653},{41654,Lo,41654,41654,41654},{41655,Lo,41655,41655,41655},{41656,Lo,41656,41656,41656},{41657,Lo,41657,41657,41657},{41658,Lo,41658,41658,41658},{41659,Lo,41659,41659,41659},{41660,Lo,41660,41660,41660},{41661,Lo,41661,41661,41661},{41662,Lo,41662,41662,41662},{41663,Lo,41663,41663,41663},{41664,Lo,41664,41664,41664},{41665,Lo,41665,41665,41665},{41666,Lo,41666,41666,41666},{41667,Lo,41667,41667,41667},{41668,Lo,41668,41668,41668},{41669,Lo,41669,41669,41669},{41670,Lo,41670,41670,41670},{41671,Lo,41671,41671,41671},{41672,Lo,41672,41672,41672},{41673,Lo,41673,41673,41673},{41674,Lo,41674,41674,41674},{41675,Lo,41675,41675,41675},{41676,Lo,41676,41676,41676},{41677,Lo,41677,41677,41677},{41678,Lo,41678,41678,41678},{41679,Lo,41679,41679,41679},{41680,Lo,41680,41680,41680},{41681,Lo,41681,41681,41681},{41682,Lo,41682,41682,41682},{41683,Lo,41683,41683,41683},{41684,Lo,41684,41684,41684},{41685,Lo,41685,41685,41685},{41686,Lo,41686,41686,41686},{41687,Lo,41687,41687,41687},{41688,Lo,41688,41688,41688},{41689,Lo,41689,41689,41689},{41690,Lo,41690,41690,41690},{41691,Lo,41691,41691,41691},{41692,Lo,41692,41692,41692},{41693,Lo,41693,41693,41693},{41694,Lo,41694,41694,41694},{41695,Lo,41695,41695,41695},{41696,Lo,41696,41696,41696},{41697,Lo,41697,41697,41697},{41698,Lo,41698,41698,41698},{41699,Lo,41699,41699,41699},{41700,Lo,41700,41700,41700},{41701,Lo,41701,41701,41701},{41702,Lo,41702,41702,41702},{41703,Lo,41703,41703,41703},{41704,Lo,41704,41704,41704},{41705,Lo,41705,41705,41705},{41706,Lo,41706,41706,41706},{41707,Lo,41707,41707,41707},{41708,Lo,41708,41708,41708},{41709,Lo,41709,41709,41709},{41710,Lo,41710,41710,41710},{41711,Lo,41711,41711,41711},{41712,Lo,41712,41712,41712},{41713,Lo,41713,41713,41713},{41714,Lo,41714,41714,41714},{41715,Lo,41715,41715,41715},{41716,Lo,41716,41716,41716},{41717,Lo,41717,41717,41717},{41718,Lo,41718,41718,41718},{41719,Lo,41719,41719,41719},{41720,Lo,41720,41720,41720},{41721,Lo,41721,41721,41721},{41722,Lo,41722,41722,41722},{41723,Lo,41723,41723,41723},{41724,Lo,41724,41724,41724},{41725,Lo,41725,41725,41725},{41726,Lo,41726,41726,41726},{41727,Lo,41727,41727,41727},{41728,Lo,41728,41728,41728},{41729,Lo,41729,41729,41729},{41730,Lo,41730,41730,41730},{41731,Lo,41731,41731,41731},{41732,Lo,41732,41732,41732},{41733,Lo,41733,41733,41733},{41734,Lo,41734,41734,41734},{41735,Lo,41735,41735,41735},{41736,Lo,41736,41736,41736},{41737,Lo,41737,41737,41737},{41738,Lo,41738,41738,41738},{41739,Lo,41739,41739,41739},{41740,Lo,41740,41740,41740},{41741,Lo,41741,41741,41741},{41742,Lo,41742,41742,41742},{41743,Lo,41743,41743,41743},{41744,Lo,41744,41744,41744},{41745,Lo,41745,41745,41745},{41746,Lo,41746,41746,41746},{41747,Lo,41747,41747,41747},{41748,Lo,41748,41748,41748},{41749,Lo,41749,41749,41749},{41750,Lo,41750,41750,41750},{41751,Lo,41751,41751,41751},{41752,Lo,41752,41752,41752},{41753,Lo,41753,41753,41753},{41754,Lo,41754,41754,41754},{41755,Lo,41755,41755,41755},{41756,Lo,41756,41756,41756},{41757,Lo,41757,41757,41757},{41758,Lo,41758,41758,41758},{41759,Lo,41759,41759,41759},{41760,Lo,41760,41760,41760},{41761,Lo,41761,41761,41761},{41762,Lo,41762,41762,41762},{41763,Lo,41763,41763,41763},{41764,Lo,41764,41764,41764},{41765,Lo,41765,41765,41765},{41766,Lo,41766,41766,41766},{41767,Lo,41767,41767,41767},{41768,Lo,41768,41768,41768},{41769,Lo,41769,41769,41769},{41770,Lo,41770,41770,41770},{41771,Lo,41771,41771,41771},{41772,Lo,41772,41772,41772},{41773,Lo,41773,41773,41773},{41774,Lo,41774,41774,41774},{41775,Lo,41775,41775,41775},{41776,Lo,41776,41776,41776},{41777,Lo,41777,41777,41777},{41778,Lo,41778,41778,41778},{41779,Lo,41779,41779,41779},{41780,Lo,41780,41780,41780},{41781,Lo,41781,41781,41781},{41782,Lo,41782,41782,41782},{41783,Lo,41783,41783,41783},{41784,Lo,41784,41784,41784},{41785,Lo,41785,41785,41785},{41786,Lo,41786,41786,41786},{41787,Lo,41787,41787,41787},{41788,Lo,41788,41788,41788},{41789,Lo,41789,41789,41789},{41790,Lo,41790,41790,41790},{41791,Lo,41791,41791,41791},{41792,Lo,41792,41792,41792},{41793,Lo,41793,41793,41793},{41794,Lo,41794,41794,41794},{41795,Lo,41795,41795,41795},{41796,Lo,41796,41796,41796},{41797,Lo,41797,41797,41797},{41798,Lo,41798,41798,41798},{41799,Lo,41799,41799,41799},{41800,Lo,41800,41800,41800},{41801,Lo,41801,41801,41801},{41802,Lo,41802,41802,41802},{41803,Lo,41803,41803,41803},{41804,Lo,41804,41804,41804},{41805,Lo,41805,41805,41805},{41806,Lo,41806,41806,41806},{41807,Lo,41807,41807,41807},{41808,Lo,41808,41808,41808},{41809,Lo,41809,41809,41809},{41810,Lo,41810,41810,41810},{41811,Lo,41811,41811,41811},{41812,Lo,41812,41812,41812},{41813,Lo,41813,41813,41813},{41814,Lo,41814,41814,41814},{41815,Lo,41815,41815,41815},{41816,Lo,41816,41816,41816},{41817,Lo,41817,41817,41817},{41818,Lo,41818,41818,41818},{41819,Lo,41819,41819,41819},{41820,Lo,41820,41820,41820},{41821,Lo,41821,41821,41821},{41822,Lo,41822,41822,41822},{41823,Lo,41823,41823,41823},{41824,Lo,41824,41824,41824},{41825,Lo,41825,41825,41825},{41826,Lo,41826,41826,41826},{41827,Lo,41827,41827,41827},{41828,Lo,41828,41828,41828},{41829,Lo,41829,41829,41829},{41830,Lo,41830,41830,41830},{41831,Lo,41831,41831,41831},{41832,Lo,41832,41832,41832},{41833,Lo,41833,41833,41833},{41834,Lo,41834,41834,41834},{41835,Lo,41835,41835,41835},{41836,Lo,41836,41836,41836},{41837,Lo,41837,41837,41837},{41838,Lo,41838,41838,41838},{41839,Lo,41839,41839,41839},{41840,Lo,41840,41840,41840},{41841,Lo,41841,41841,41841},{41842,Lo,41842,41842,41842},{41843,Lo,41843,41843,41843},{41844,Lo,41844,41844,41844},{41845,Lo,41845,41845,41845},{41846,Lo,41846,41846,41846},{41847,Lo,41847,41847,41847},{41848,Lo,41848,41848,41848},{41849,Lo,41849,41849,41849},{41850,Lo,41850,41850,41850},{41851,Lo,41851,41851,41851},{41852,Lo,41852,41852,41852},{41853,Lo,41853,41853,41853},{41854,Lo,41854,41854,41854},{41855,Lo,41855,41855,41855},{41856,Lo,41856,41856,41856},{41857,Lo,41857,41857,41857},{41858,Lo,41858,41858,41858},{41859,Lo,41859,41859,41859},{41860,Lo,41860,41860,41860},{41861,Lo,41861,41861,41861},{41862,Lo,41862,41862,41862},{41863,Lo,41863,41863,41863},{41864,Lo,41864,41864,41864},{41865,Lo,41865,41865,41865},{41866,Lo,41866,41866,41866},{41867,Lo,41867,41867,41867},{41868,Lo,41868,41868,41868},{41869,Lo,41869,41869,41869},{41870,Lo,41870,41870,41870},{41871,Lo,41871,41871,41871},{41872,Lo,41872,41872,41872},{41873,Lo,41873,41873,41873},{41874,Lo,41874,41874,41874},{41875,Lo,41875,41875,41875},{41876,Lo,41876,41876,41876},{41877,Lo,41877,41877,41877},{41878,Lo,41878,41878,41878},{41879,Lo,41879,41879,41879},{41880,Lo,41880,41880,41880},{41881,Lo,41881,41881,41881},{41882,Lo,41882,41882,41882},{41883,Lo,41883,41883,41883},{41884,Lo,41884,41884,41884},{41885,Lo,41885,41885,41885},{41886,Lo,41886,41886,41886},{41887,Lo,41887,41887,41887},{41888,Lo,41888,41888,41888},{41889,Lo,41889,41889,41889},{41890,Lo,41890,41890,41890},{41891,Lo,41891,41891,41891},{41892,Lo,41892,41892,41892},{41893,Lo,41893,41893,41893},{41894,Lo,41894,41894,41894},{41895,Lo,41895,41895,41895},{41896,Lo,41896,41896,41896},{41897,Lo,41897,41897,41897},{41898,Lo,41898,41898,41898},{41899,Lo,41899,41899,41899},{41900,Lo,41900,41900,41900},{41901,Lo,41901,41901,41901},{41902,Lo,41902,41902,41902},{41903,Lo,41903,41903,41903},{41904,Lo,41904,41904,41904},{41905,Lo,41905,41905,41905},{41906,Lo,41906,41906,41906},{41907,Lo,41907,41907,41907},{41908,Lo,41908,41908,41908},{41909,Lo,41909,41909,41909},{41910,Lo,41910,41910,41910},{41911,Lo,41911,41911,41911},{41912,Lo,41912,41912,41912},{41913,Lo,41913,41913,41913},{41914,Lo,41914,41914,41914},{41915,Lo,41915,41915,41915},{41916,Lo,41916,41916,41916},{41917,Lo,41917,41917,41917},{41918,Lo,41918,41918,41918},{41919,Lo,41919,41919,41919},{41920,Lo,41920,41920,41920},{41921,Lo,41921,41921,41921},{41922,Lo,41922,41922,41922},{41923,Lo,41923,41923,41923},{41924,Lo,41924,41924,41924},{41925,Lo,41925,41925,41925},{41926,Lo,41926,41926,41926},{41927,Lo,41927,41927,41927},{41928,Lo,41928,41928,41928},{41929,Lo,41929,41929,41929},{41930,Lo,41930,41930,41930},{41931,Lo,41931,41931,41931},{41932,Lo,41932,41932,41932},{41933,Lo,41933,41933,41933},{41934,Lo,41934,41934,41934},{41935,Lo,41935,41935,41935},{41936,Lo,41936,41936,41936},{41937,Lo,41937,41937,41937},{41938,Lo,41938,41938,41938},{41939,Lo,41939,41939,41939},{41940,Lo,41940,41940,41940},{41941,Lo,41941,41941,41941},{41942,Lo,41942,41942,41942},{41943,Lo,41943,41943,41943},{41944,Lo,41944,41944,41944},{41945,Lo,41945,41945,41945},{41946,Lo,41946,41946,41946},{41947,Lo,41947,41947,41947},{41948,Lo,41948,41948,41948},{41949,Lo,41949,41949,41949},{41950,Lo,41950,41950,41950},{41951,Lo,41951,41951,41951},{41952,Lo,41952,41952,41952},{41953,Lo,41953,41953,41953},{41954,Lo,41954,41954,41954},{41955,Lo,41955,41955,41955},{41956,Lo,41956,41956,41956},{41957,Lo,41957,41957,41957},{41958,Lo,41958,41958,41958},{41959,Lo,41959,41959,41959},{41960,Lo,41960,41960,41960},{41961,Lo,41961,41961,41961},{41962,Lo,41962,41962,41962},{41963,Lo,41963,41963,41963},{41964,Lo,41964,41964,41964},{41965,Lo,41965,41965,41965},{41966,Lo,41966,41966,41966},{41967,Lo,41967,41967,41967},{41968,Lo,41968,41968,41968},{41969,Lo,41969,41969,41969},{41970,Lo,41970,41970,41970},{41971,Lo,41971,41971,41971},{41972,Lo,41972,41972,41972},{41973,Lo,41973,41973,41973},{41974,Lo,41974,41974,41974},{41975,Lo,41975,41975,41975},{41976,Lo,41976,41976,41976},{41977,Lo,41977,41977,41977},{41978,Lo,41978,41978,41978},{41979,Lo,41979,41979,41979},{41980,Lo,41980,41980,41980},{41981,Lo,41981,41981,41981},{41982,Lo,41982,41982,41982},{41983,Lo,41983,41983,41983},{41984,Lo,41984,41984,41984},{41985,Lo,41985,41985,41985},{41986,Lo,41986,41986,41986},{41987,Lo,41987,41987,41987},{41988,Lo,41988,41988,41988},{41989,Lo,41989,41989,41989},{41990,Lo,41990,41990,41990},{41991,Lo,41991,41991,41991},{41992,Lo,41992,41992,41992},{41993,Lo,41993,41993,41993},{41994,Lo,41994,41994,41994},{41995,Lo,41995,41995,41995},{41996,Lo,41996,41996,41996},{41997,Lo,41997,41997,41997},{41998,Lo,41998,41998,41998},{41999,Lo,41999,41999,41999},{42000,Lo,42000,42000,42000},{42001,Lo,42001,42001,42001},{42002,Lo,42002,42002,42002},{42003,Lo,42003,42003,42003},{42004,Lo,42004,42004,42004},{42005,Lo,42005,42005,42005},{42006,Lo,42006,42006,42006},{42007,Lo,42007,42007,42007},{42008,Lo,42008,42008,42008},{42009,Lo,42009,42009,42009},{42010,Lo,42010,42010,42010},{42011,Lo,42011,42011,42011},{42012,Lo,42012,42012,42012},{42013,Lo,42013,42013,42013},{42014,Lo,42014,42014,42014},{42015,Lo,42015,42015,42015},{42016,Lo,42016,42016,42016},{42017,Lo,42017,42017,42017},{42018,Lo,42018,42018,42018},{42019,Lo,42019,42019,42019},{42020,Lo,42020,42020,42020},{42021,Lo,42021,42021,42021},{42022,Lo,42022,42022,42022},{42023,Lo,42023,42023,42023},{42024,Lo,42024,42024,42024},{42025,Lo,42025,42025,42025},{42026,Lo,42026,42026,42026},{42027,Lo,42027,42027,42027},{42028,Lo,42028,42028,42028},{42029,Lo,42029,42029,42029},{42030,Lo,42030,42030,42030},{42031,Lo,42031,42031,42031},{42032,Lo,42032,42032,42032},{42033,Lo,42033,42033,42033},{42034,Lo,42034,42034,42034},{42035,Lo,42035,42035,42035},{42036,Lo,42036,42036,42036},{42037,Lo,42037,42037,42037},{42038,Lo,42038,42038,42038},{42039,Lo,42039,42039,42039},{42040,Lo,42040,42040,42040},{42041,Lo,42041,42041,42041},{42042,Lo,42042,42042,42042},{42043,Lo,42043,42043,42043},{42044,Lo,42044,42044,42044},{42045,Lo,42045,42045,42045},{42046,Lo,42046,42046,42046},{42047,Lo,42047,42047,42047},{42048,Lo,42048,42048,42048},{42049,Lo,42049,42049,42049},{42050,Lo,42050,42050,42050},{42051,Lo,42051,42051,42051},{42052,Lo,42052,42052,42052},{42053,Lo,42053,42053,42053},{42054,Lo,42054,42054,42054},{42055,Lo,42055,42055,42055},{42056,Lo,42056,42056,42056},{42057,Lo,42057,42057,42057},{42058,Lo,42058,42058,42058},{42059,Lo,42059,42059,42059},{42060,Lo,42060,42060,42060},{42061,Lo,42061,42061,42061},{42062,Lo,42062,42062,42062},{42063,Lo,42063,42063,42063},{42064,Lo,42064,42064,42064},{42065,Lo,42065,42065,42065},{42066,Lo,42066,42066,42066},{42067,Lo,42067,42067,42067},{42068,Lo,42068,42068,42068},{42069,Lo,42069,42069,42069},{42070,Lo,42070,42070,42070},{42071,Lo,42071,42071,42071},{42072,Lo,42072,42072,42072},{42073,Lo,42073,42073,42073},{42074,Lo,42074,42074,42074},{42075,Lo,42075,42075,42075},{42076,Lo,42076,42076,42076},{42077,Lo,42077,42077,42077},{42078,Lo,42078,42078,42078},{42079,Lo,42079,42079,42079},{42080,Lo,42080,42080,42080},{42081,Lo,42081,42081,42081},{42082,Lo,42082,42082,42082},{42083,Lo,42083,42083,42083},{42084,Lo,42084,42084,42084},{42085,Lo,42085,42085,42085},{42086,Lo,42086,42086,42086},{42087,Lo,42087,42087,42087},{42088,Lo,42088,42088,42088},{42089,Lo,42089,42089,42089},{42090,Lo,42090,42090,42090},{42091,Lo,42091,42091,42091},{42092,Lo,42092,42092,42092},{42093,Lo,42093,42093,42093},{42094,Lo,42094,42094,42094},{42095,Lo,42095,42095,42095},{42096,Lo,42096,42096,42096},{42097,Lo,42097,42097,42097},{42098,Lo,42098,42098,42098},{42099,Lo,42099,42099,42099},{42100,Lo,42100,42100,42100},{42101,Lo,42101,42101,42101},{42102,Lo,42102,42102,42102},{42103,Lo,42103,42103,42103},{42104,Lo,42104,42104,42104},{42105,Lo,42105,42105,42105},{42106,Lo,42106,42106,42106},{42107,Lo,42107,42107,42107},{42108,Lo,42108,42108,42108},{42109,Lo,42109,42109,42109},{42110,Lo,42110,42110,42110},{42111,Lo,42111,42111,42111},{42112,Lo,42112,42112,42112},{42113,Lo,42113,42113,42113},{42114,Lo,42114,42114,42114},{42115,Lo,42115,42115,42115},{42116,Lo,42116,42116,42116},{42117,Lo,42117,42117,42117},{42118,Lo,42118,42118,42118},{42119,Lo,42119,42119,42119},{42120,Lo,42120,42120,42120},{42121,Lo,42121,42121,42121},{42122,Lo,42122,42122,42122},{42123,Lo,42123,42123,42123},{42124,Lo,42124,42124,42124},{42128,So,42128,42128,42128},{42129,So,42129,42129,42129},{42130,So,42130,42130,42130},{42131,So,42131,42131,42131},{42132,So,42132,42132,42132},{42133,So,42133,42133,42133},{42134,So,42134,42134,42134},{42135,So,42135,42135,42135},{42136,So,42136,42136,42136},{42137,So,42137,42137,42137},{42138,So,42138,42138,42138},{42139,So,42139,42139,42139},{42140,So,42140,42140,42140},{42141,So,42141,42141,42141},{42142,So,42142,42142,42142},{42143,So,42143,42143,42143},{42144,So,42144,42144,42144},{42145,So,42145,42145,42145},{42146,So,42146,42146,42146},{42147,So,42147,42147,42147},{42148,So,42148,42148,42148},{42149,So,42149,42149,42149},{42150,So,42150,42150,42150},{42151,So,42151,42151,42151},{42152,So,42152,42152,42152},{42153,So,42153,42153,42153},{42154,So,42154,42154,42154},{42155,So,42155,42155,42155},{42156,So,42156,42156,42156},{42157,So,42157,42157,42157},{42158,So,42158,42158,42158},{42159,So,42159,42159,42159},{42160,So,42160,42160,42160},{42161,So,42161,42161,42161},{42162,So,42162,42162,42162},{42163,So,42163,42163,42163},{42164,So,42164,42164,42164},{42165,So,42165,42165,42165},{42166,So,42166,42166,42166},{42167,So,42167,42167,42167},{42168,So,42168,42168,42168},{42169,So,42169,42169,42169},{42170,So,42170,42170,42170},{42171,So,42171,42171,42171},{42172,So,42172,42172,42172},{42173,So,42173,42173,42173},{42174,So,42174,42174,42174},{42175,So,42175,42175,42175},{42176,So,42176,42176,42176},{42177,So,42177,42177,42177},{42178,So,42178,42178,42178},{42179,So,42179,42179,42179},{42180,So,42180,42180,42180},{42181,So,42181,42181,42181},{42182,So,42182,42182,42182},{42752,Sk,42752,42752,42752},{42753,Sk,42753,42753,42753},{42754,Sk,42754,42754,42754},{42755,Sk,42755,42755,42755},{42756,Sk,42756,42756,42756},{42757,Sk,42757,42757,42757},{42758,Sk,42758,42758,42758},{42759,Sk,42759,42759,42759},{42760,Sk,42760,42760,42760},{42761,Sk,42761,42761,42761},{42762,Sk,42762,42762,42762},{42763,Sk,42763,42763,42763},{42764,Sk,42764,42764,42764},{42765,Sk,42765,42765,42765},{42766,Sk,42766,42766,42766},{42767,Sk,42767,42767,42767},{42768,Sk,42768,42768,42768},{42769,Sk,42769,42769,42769},{42770,Sk,42770,42770,42770},{42771,Sk,42771,42771,42771},{42772,Sk,42772,42772,42772},{42773,Sk,42773,42773,42773},{42774,Sk,42774,42774,42774},{42775,Lm,42775,42775,42775},{42776,Lm,42776,42776,42776},{42777,Lm,42777,42777,42777},{42778,Lm,42778,42778,42778},{42784,Sk,42784,42784,42784},{42785,Sk,42785,42785,42785},{43008,Lo,43008,43008,43008},{43009,Lo,43009,43009,43009},{43010,Mc,43010,43010,43010},{43011,Lo,43011,43011,43011},{43012,Lo,43012,43012,43012},{43013,Lo,43013,43013,43013},{43014,Mn,43014,43014,43014},{43015,Lo,43015,43015,43015},{43016,Lo,43016,43016,43016},{43017,Lo,43017,43017,43017},{43018,Lo,43018,43018,43018},{43019,Mn,43019,43019,43019},{43020,Lo,43020,43020,43020},{43021,Lo,43021,43021,43021},{43022,Lo,43022,43022,43022},{43023,Lo,43023,43023,43023},{43024,Lo,43024,43024,43024},{43025,Lo,43025,43025,43025},{43026,Lo,43026,43026,43026},{43027,Lo,43027,43027,43027},{43028,Lo,43028,43028,43028},{43029,Lo,43029,43029,43029},{43030,Lo,43030,43030,43030},{43031,Lo,43031,43031,43031},{43032,Lo,43032,43032,43032},{43033,Lo,43033,43033,43033},{43034,Lo,43034,43034,43034},{43035,Lo,43035,43035,43035},{43036,Lo,43036,43036,43036},{43037,Lo,43037,43037,43037},{43038,Lo,43038,43038,43038},{43039,Lo,43039,43039,43039},{43040,Lo,43040,43040,43040},{43041,Lo,43041,43041,43041},{43042,Lo,43042,43042,43042},{43043,Mc,43043,43043,43043},{43044,Mc,43044,43044,43044},{43045,Mn,43045,43045,43045},{43046,Mn,43046,43046,43046},{43047,Mc,43047,43047,43047},{43048,So,43048,43048,43048},{43049,So,43049,43049,43049},{43050,So,43050,43050,43050},{43051,So,43051,43051,43051},{43072,Lo,43072,43072,43072},{43073,Lo,43073,43073,43073},{43074,Lo,43074,43074,43074},{43075,Lo,43075,43075,43075},{43076,Lo,43076,43076,43076},{43077,Lo,43077,43077,43077},{43078,Lo,43078,43078,43078},{43079,Lo,43079,43079,43079},{43080,Lo,43080,43080,43080},{43081,Lo,43081,43081,43081},{43082,Lo,43082,43082,43082},{43083,Lo,43083,43083,43083},{43084,Lo,43084,43084,43084},{43085,Lo,43085,43085,43085},{43086,Lo,43086,43086,43086},{43087,Lo,43087,43087,43087},{43088,Lo,43088,43088,43088},{43089,Lo,43089,43089,43089},{43090,Lo,43090,43090,43090},{43091,Lo,43091,43091,43091},{43092,Lo,43092,43092,43092},{43093,Lo,43093,43093,43093},{43094,Lo,43094,43094,43094},{43095,Lo,43095,43095,43095},{43096,Lo,43096,43096,43096},{43097,Lo,43097,43097,43097},{43098,Lo,43098,43098,43098},{43099,Lo,43099,43099,43099},{43100,Lo,43100,43100,43100},{43101,Lo,43101,43101,43101},{43102,Lo,43102,43102,43102},{43103,Lo,43103,43103,43103},{43104,Lo,43104,43104,43104},{43105,Lo,43105,43105,43105},{43106,Lo,43106,43106,43106},{43107,Lo,43107,43107,43107},{43108,Lo,43108,43108,43108},{43109,Lo,43109,43109,43109},{43110,Lo,43110,43110,43110},{43111,Lo,43111,43111,43111},{43112,Lo,43112,43112,43112},{43113,Lo,43113,43113,43113},{43114,Lo,43114,43114,43114},{43115,Lo,43115,43115,43115},{43116,Lo,43116,43116,43116},{43117,Lo,43117,43117,43117},{43118,Lo,43118,43118,43118},{43119,Lo,43119,43119,43119},{43120,Lo,43120,43120,43120},{43121,Lo,43121,43121,43121},{43122,Lo,43122,43122,43122},{43123,Lo,43123,43123,43123},{43124,Po,43124,43124,43124},{43125,Po,43125,43125,43125},{43126,Po,43126,43126,43126},{43127,Po,43127,43127,43127},{44032,Lo,44032,44032,44032},{55203,Lo,55203,55203,55203},{55296,Cs,55296,55296,55296},{56191,Cs,56191,56191,56191},{56192,Cs,56192,56192,56192},{56319,Cs,56319,56319,56319},{56320,Cs,56320,56320,56320},{57343,Cs,57343,57343,57343},{57344,Co,57344,57344,57344},{63743,Co,63743,63743,63743},{63744,Lo,63744,63744,63744},{63745,Lo,63745,63745,63745},{63746,Lo,63746,63746,63746},{63747,Lo,63747,63747,63747},{63748,Lo,63748,63748,63748},{63749,Lo,63749,63749,63749},{63750,Lo,63750,63750,63750},{63751,Lo,63751,63751,63751},{63752,Lo,63752,63752,63752},{63753,Lo,63753,63753,63753},{63754,Lo,63754,63754,63754},{63755,Lo,63755,63755,63755},{63756,Lo,63756,63756,63756},{63757,Lo,63757,63757,63757},{63758,Lo,63758,63758,63758},{63759,Lo,63759,63759,63759},{63760,Lo,63760,63760,63760},{63761,Lo,63761,63761,63761},{63762,Lo,63762,63762,63762},{63763,Lo,63763,63763,63763},{63764,Lo,63764,63764,63764},{63765,Lo,63765,63765,63765},{63766,Lo,63766,63766,63766},{63767,Lo,63767,63767,63767},{63768,Lo,63768,63768,63768},{63769,Lo,63769,63769,63769},{63770,Lo,63770,63770,63770},{63771,Lo,63771,63771,63771},{63772,Lo,63772,63772,63772},{63773,Lo,63773,63773,63773},{63774,Lo,63774,63774,63774},{63775,Lo,63775,63775,63775},{63776,Lo,63776,63776,63776},{63777,Lo,63777,63777,63777},{63778,Lo,63778,63778,63778},{63779,Lo,63779,63779,63779},{63780,Lo,63780,63780,63780},{63781,Lo,63781,63781,63781},{63782,Lo,63782,63782,63782},{63783,Lo,63783,63783,63783},{63784,Lo,63784,63784,63784},{63785,Lo,63785,63785,63785},{63786,Lo,63786,63786,63786},{63787,Lo,63787,63787,63787},{63788,Lo,63788,63788,63788},{63789,Lo,63789,63789,63789},{63790,Lo,63790,63790,63790},{63791,Lo,63791,63791,63791},{63792,Lo,63792,63792,63792},{63793,Lo,63793,63793,63793},{63794,Lo,63794,63794,63794},{63795,Lo,63795,63795,63795},{63796,Lo,63796,63796,63796},{63797,Lo,63797,63797,63797},{63798,Lo,63798,63798,63798},{63799,Lo,63799,63799,63799},{63800,Lo,63800,63800,63800},{63801,Lo,63801,63801,63801},{63802,Lo,63802,63802,63802},{63803,Lo,63803,63803,63803},{63804,Lo,63804,63804,63804},{63805,Lo,63805,63805,63805},{63806,Lo,63806,63806,63806},{63807,Lo,63807,63807,63807},{63808,Lo,63808,63808,63808},{63809,Lo,63809,63809,63809},{63810,Lo,63810,63810,63810},{63811,Lo,63811,63811,63811},{63812,Lo,63812,63812,63812},{63813,Lo,63813,63813,63813},{63814,Lo,63814,63814,63814},{63815,Lo,63815,63815,63815},{63816,Lo,63816,63816,63816},{63817,Lo,63817,63817,63817},{63818,Lo,63818,63818,63818},{63819,Lo,63819,63819,63819},{63820,Lo,63820,63820,63820},{63821,Lo,63821,63821,63821},{63822,Lo,63822,63822,63822},{63823,Lo,63823,63823,63823},{63824,Lo,63824,63824,63824},{63825,Lo,63825,63825,63825},{63826,Lo,63826,63826,63826},{63827,Lo,63827,63827,63827},{63828,Lo,63828,63828,63828},{63829,Lo,63829,63829,63829},{63830,Lo,63830,63830,63830},{63831,Lo,63831,63831,63831},{63832,Lo,63832,63832,63832},{63833,Lo,63833,63833,63833},{63834,Lo,63834,63834,63834},{63835,Lo,63835,63835,63835},{63836,Lo,63836,63836,63836},{63837,Lo,63837,63837,63837},{63838,Lo,63838,63838,63838},{63839,Lo,63839,63839,63839},{63840,Lo,63840,63840,63840},{63841,Lo,63841,63841,63841},{63842,Lo,63842,63842,63842},{63843,Lo,63843,63843,63843},{63844,Lo,63844,63844,63844},{63845,Lo,63845,63845,63845},{63846,Lo,63846,63846,63846},{63847,Lo,63847,63847,63847},{63848,Lo,63848,63848,63848},{63849,Lo,63849,63849,63849},{63850,Lo,63850,63850,63850},{63851,Lo,63851,63851,63851},{63852,Lo,63852,63852,63852},{63853,Lo,63853,63853,63853},{63854,Lo,63854,63854,63854},{63855,Lo,63855,63855,63855},{63856,Lo,63856,63856,63856},{63857,Lo,63857,63857,63857},{63858,Lo,63858,63858,63858},{63859,Lo,63859,63859,63859},{63860,Lo,63860,63860,63860},{63861,Lo,63861,63861,63861},{63862,Lo,63862,63862,63862},{63863,Lo,63863,63863,63863},{63864,Lo,63864,63864,63864},{63865,Lo,63865,63865,63865},{63866,Lo,63866,63866,63866},{63867,Lo,63867,63867,63867},{63868,Lo,63868,63868,63868},{63869,Lo,63869,63869,63869},{63870,Lo,63870,63870,63870},{63871,Lo,63871,63871,63871},{63872,Lo,63872,63872,63872},{63873,Lo,63873,63873,63873},{63874,Lo,63874,63874,63874},{63875,Lo,63875,63875,63875},{63876,Lo,63876,63876,63876},{63877,Lo,63877,63877,63877},{63878,Lo,63878,63878,63878},{63879,Lo,63879,63879,63879},{63880,Lo,63880,63880,63880},{63881,Lo,63881,63881,63881},{63882,Lo,63882,63882,63882},{63883,Lo,63883,63883,63883},{63884,Lo,63884,63884,63884},{63885,Lo,63885,63885,63885},{63886,Lo,63886,63886,63886},{63887,Lo,63887,63887,63887},{63888,Lo,63888,63888,63888},{63889,Lo,63889,63889,63889},{63890,Lo,63890,63890,63890},{63891,Lo,63891,63891,63891},{63892,Lo,63892,63892,63892},{63893,Lo,63893,63893,63893},{63894,Lo,63894,63894,63894},{63895,Lo,63895,63895,63895},{63896,Lo,63896,63896,63896},{63897,Lo,63897,63897,63897},{63898,Lo,63898,63898,63898},{63899,Lo,63899,63899,63899},{63900,Lo,63900,63900,63900},{63901,Lo,63901,63901,63901},{63902,Lo,63902,63902,63902},{63903,Lo,63903,63903,63903},{63904,Lo,63904,63904,63904},{63905,Lo,63905,63905,63905},{63906,Lo,63906,63906,63906},{63907,Lo,63907,63907,63907},{63908,Lo,63908,63908,63908},{63909,Lo,63909,63909,63909},{63910,Lo,63910,63910,63910},{63911,Lo,63911,63911,63911},{63912,Lo,63912,63912,63912},{63913,Lo,63913,63913,63913},{63914,Lo,63914,63914,63914},{63915,Lo,63915,63915,63915},{63916,Lo,63916,63916,63916},{63917,Lo,63917,63917,63917},{63918,Lo,63918,63918,63918},{63919,Lo,63919,63919,63919},{63920,Lo,63920,63920,63920},{63921,Lo,63921,63921,63921},{63922,Lo,63922,63922,63922},{63923,Lo,63923,63923,63923},{63924,Lo,63924,63924,63924},{63925,Lo,63925,63925,63925},{63926,Lo,63926,63926,63926},{63927,Lo,63927,63927,63927},{63928,Lo,63928,63928,63928},{63929,Lo,63929,63929,63929},{63930,Lo,63930,63930,63930},{63931,Lo,63931,63931,63931},{63932,Lo,63932,63932,63932},{63933,Lo,63933,63933,63933},{63934,Lo,63934,63934,63934},{63935,Lo,63935,63935,63935},{63936,Lo,63936,63936,63936},{63937,Lo,63937,63937,63937},{63938,Lo,63938,63938,63938},{63939,Lo,63939,63939,63939},{63940,Lo,63940,63940,63940},{63941,Lo,63941,63941,63941},{63942,Lo,63942,63942,63942},{63943,Lo,63943,63943,63943},{63944,Lo,63944,63944,63944},{63945,Lo,63945,63945,63945},{63946,Lo,63946,63946,63946},{63947,Lo,63947,63947,63947},{63948,Lo,63948,63948,63948},{63949,Lo,63949,63949,63949},{63950,Lo,63950,63950,63950},{63951,Lo,63951,63951,63951},{63952,Lo,63952,63952,63952},{63953,Lo,63953,63953,63953},{63954,Lo,63954,63954,63954},{63955,Lo,63955,63955,63955},{63956,Lo,63956,63956,63956},{63957,Lo,63957,63957,63957},{63958,Lo,63958,63958,63958},{63959,Lo,63959,63959,63959},{63960,Lo,63960,63960,63960},{63961,Lo,63961,63961,63961},{63962,Lo,63962,63962,63962},{63963,Lo,63963,63963,63963},{63964,Lo,63964,63964,63964},{63965,Lo,63965,63965,63965},{63966,Lo,63966,63966,63966},{63967,Lo,63967,63967,63967},{63968,Lo,63968,63968,63968},{63969,Lo,63969,63969,63969},{63970,Lo,63970,63970,63970},{63971,Lo,63971,63971,63971},{63972,Lo,63972,63972,63972},{63973,Lo,63973,63973,63973},{63974,Lo,63974,63974,63974},{63975,Lo,63975,63975,63975},{63976,Lo,63976,63976,63976},{63977,Lo,63977,63977,63977},{63978,Lo,63978,63978,63978},{63979,Lo,63979,63979,63979},{63980,Lo,63980,63980,63980},{63981,Lo,63981,63981,63981},{63982,Lo,63982,63982,63982},{63983,Lo,63983,63983,63983},{63984,Lo,63984,63984,63984},{63985,Lo,63985,63985,63985},{63986,Lo,63986,63986,63986},{63987,Lo,63987,63987,63987},{63988,Lo,63988,63988,63988},{63989,Lo,63989,63989,63989},{63990,Lo,63990,63990,63990},{63991,Lo,63991,63991,63991},{63992,Lo,63992,63992,63992},{63993,Lo,63993,63993,63993},{63994,Lo,63994,63994,63994},{63995,Lo,63995,63995,63995},{63996,Lo,63996,63996,63996},{63997,Lo,63997,63997,63997},{63998,Lo,63998,63998,63998},{63999,Lo,63999,63999,63999},{64000,Lo,64000,64000,64000},{64001,Lo,64001,64001,64001},{64002,Lo,64002,64002,64002},{64003,Lo,64003,64003,64003},{64004,Lo,64004,64004,64004},{64005,Lo,64005,64005,64005},{64006,Lo,64006,64006,64006},{64007,Lo,64007,64007,64007},{64008,Lo,64008,64008,64008},{64009,Lo,64009,64009,64009},{64010,Lo,64010,64010,64010},{64011,Lo,64011,64011,64011},{64012,Lo,64012,64012,64012},{64013,Lo,64013,64013,64013},{64014,Lo,64014,64014,64014},{64015,Lo,64015,64015,64015},{64016,Lo,64016,64016,64016},{64017,Lo,64017,64017,64017},{64018,Lo,64018,64018,64018},{64019,Lo,64019,64019,64019},{64020,Lo,64020,64020,64020},{64021,Lo,64021,64021,64021},{64022,Lo,64022,64022,64022},{64023,Lo,64023,64023,64023},{64024,Lo,64024,64024,64024},{64025,Lo,64025,64025,64025},{64026,Lo,64026,64026,64026},{64027,Lo,64027,64027,64027},{64028,Lo,64028,64028,64028},{64029,Lo,64029,64029,64029},{64030,Lo,64030,64030,64030},{64031,Lo,64031,64031,64031},{64032,Lo,64032,64032,64032},{64033,Lo,64033,64033,64033},{64034,Lo,64034,64034,64034},{64035,Lo,64035,64035,64035},{64036,Lo,64036,64036,64036},{64037,Lo,64037,64037,64037},{64038,Lo,64038,64038,64038},{64039,Lo,64039,64039,64039},{64040,Lo,64040,64040,64040},{64041,Lo,64041,64041,64041},{64042,Lo,64042,64042,64042},{64043,Lo,64043,64043,64043},{64044,Lo,64044,64044,64044},{64045,Lo,64045,64045,64045},{64048,Lo,64048,64048,64048},{64049,Lo,64049,64049,64049},{64050,Lo,64050,64050,64050},{64051,Lo,64051,64051,64051},{64052,Lo,64052,64052,64052},{64053,Lo,64053,64053,64053},{64054,Lo,64054,64054,64054},{64055,Lo,64055,64055,64055},{64056,Lo,64056,64056,64056},{64057,Lo,64057,64057,64057},{64058,Lo,64058,64058,64058},{64059,Lo,64059,64059,64059},{64060,Lo,64060,64060,64060},{64061,Lo,64061,64061,64061},{64062,Lo,64062,64062,64062},{64063,Lo,64063,64063,64063},{64064,Lo,64064,64064,64064},{64065,Lo,64065,64065,64065},{64066,Lo,64066,64066,64066},{64067,Lo,64067,64067,64067},{64068,Lo,64068,64068,64068},{64069,Lo,64069,64069,64069},{64070,Lo,64070,64070,64070},{64071,Lo,64071,64071,64071},{64072,Lo,64072,64072,64072},{64073,Lo,64073,64073,64073},{64074,Lo,64074,64074,64074},{64075,Lo,64075,64075,64075},{64076,Lo,64076,64076,64076},{64077,Lo,64077,64077,64077},{64078,Lo,64078,64078,64078},{64079,Lo,64079,64079,64079},{64080,Lo,64080,64080,64080},{64081,Lo,64081,64081,64081},{64082,Lo,64082,64082,64082},{64083,Lo,64083,64083,64083},{64084,Lo,64084,64084,64084},{64085,Lo,64085,64085,64085},{64086,Lo,64086,64086,64086},{64087,Lo,64087,64087,64087},{64088,Lo,64088,64088,64088},{64089,Lo,64089,64089,64089},{64090,Lo,64090,64090,64090},{64091,Lo,64091,64091,64091},{64092,Lo,64092,64092,64092},{64093,Lo,64093,64093,64093},{64094,Lo,64094,64094,64094},{64095,Lo,64095,64095,64095},{64096,Lo,64096,64096,64096},{64097,Lo,64097,64097,64097},{64098,Lo,64098,64098,64098},{64099,Lo,64099,64099,64099},{64100,Lo,64100,64100,64100},{64101,Lo,64101,64101,64101},{64102,Lo,64102,64102,64102},{64103,Lo,64103,64103,64103},{64104,Lo,64104,64104,64104},{64105,Lo,64105,64105,64105},{64106,Lo,64106,64106,64106},{64112,Lo,64112,64112,64112},{64113,Lo,64113,64113,64113},{64114,Lo,64114,64114,64114},{64115,Lo,64115,64115,64115},{64116,Lo,64116,64116,64116},{64117,Lo,64117,64117,64117},{64118,Lo,64118,64118,64118},{64119,Lo,64119,64119,64119},{64120,Lo,64120,64120,64120},{64121,Lo,64121,64121,64121},{64122,Lo,64122,64122,64122},{64123,Lo,64123,64123,64123},{64124,Lo,64124,64124,64124},{64125,Lo,64125,64125,64125},{64126,Lo,64126,64126,64126},{64127,Lo,64127,64127,64127},{64128,Lo,64128,64128,64128},{64129,Lo,64129,64129,64129},{64130,Lo,64130,64130,64130},{64131,Lo,64131,64131,64131},{64132,Lo,64132,64132,64132},{64133,Lo,64133,64133,64133},{64134,Lo,64134,64134,64134},{64135,Lo,64135,64135,64135},{64136,Lo,64136,64136,64136},{64137,Lo,64137,64137,64137},{64138,Lo,64138,64138,64138},{64139,Lo,64139,64139,64139},{64140,Lo,64140,64140,64140},{64141,Lo,64141,64141,64141},{64142,Lo,64142,64142,64142},{64143,Lo,64143,64143,64143},{64144,Lo,64144,64144,64144},{64145,Lo,64145,64145,64145},{64146,Lo,64146,64146,64146},{64147,Lo,64147,64147,64147},{64148,Lo,64148,64148,64148},{64149,Lo,64149,64149,64149},{64150,Lo,64150,64150,64150},{64151,Lo,64151,64151,64151},{64152,Lo,64152,64152,64152},{64153,Lo,64153,64153,64153},{64154,Lo,64154,64154,64154},{64155,Lo,64155,64155,64155},{64156,Lo,64156,64156,64156},{64157,Lo,64157,64157,64157},{64158,Lo,64158,64158,64158},{64159,Lo,64159,64159,64159},{64160,Lo,64160,64160,64160},{64161,Lo,64161,64161,64161},{64162,Lo,64162,64162,64162},{64163,Lo,64163,64163,64163},{64164,Lo,64164,64164,64164},{64165,Lo,64165,64165,64165},{64166,Lo,64166,64166,64166},{64167,Lo,64167,64167,64167},{64168,Lo,64168,64168,64168},{64169,Lo,64169,64169,64169},{64170,Lo,64170,64170,64170},{64171,Lo,64171,64171,64171},{64172,Lo,64172,64172,64172},{64173,Lo,64173,64173,64173},{64174,Lo,64174,64174,64174},{64175,Lo,64175,64175,64175},{64176,Lo,64176,64176,64176},{64177,Lo,64177,64177,64177},{64178,Lo,64178,64178,64178},{64179,Lo,64179,64179,64179},{64180,Lo,64180,64180,64180},{64181,Lo,64181,64181,64181},{64182,Lo,64182,64182,64182},{64183,Lo,64183,64183,64183},{64184,Lo,64184,64184,64184},{64185,Lo,64185,64185,64185},{64186,Lo,64186,64186,64186},{64187,Lo,64187,64187,64187},{64188,Lo,64188,64188,64188},{64189,Lo,64189,64189,64189},{64190,Lo,64190,64190,64190},{64191,Lo,64191,64191,64191},{64192,Lo,64192,64192,64192},{64193,Lo,64193,64193,64193},{64194,Lo,64194,64194,64194},{64195,Lo,64195,64195,64195},{64196,Lo,64196,64196,64196},{64197,Lo,64197,64197,64197},{64198,Lo,64198,64198,64198},{64199,Lo,64199,64199,64199},{64200,Lo,64200,64200,64200},{64201,Lo,64201,64201,64201},{64202,Lo,64202,64202,64202},{64203,Lo,64203,64203,64203},{64204,Lo,64204,64204,64204},{64205,Lo,64205,64205,64205},{64206,Lo,64206,64206,64206},{64207,Lo,64207,64207,64207},{64208,Lo,64208,64208,64208},{64209,Lo,64209,64209,64209},{64210,Lo,64210,64210,64210},{64211,Lo,64211,64211,64211},{64212,Lo,64212,64212,64212},{64213,Lo,64213,64213,64213},{64214,Lo,64214,64214,64214},{64215,Lo,64215,64215,64215},{64216,Lo,64216,64216,64216},{64217,Lo,64217,64217,64217},{64256,Ll | SM,64256,64256,64256},{64257,Ll | SM,64257,64257,64257},{64258,Ll | SM,64258,64258,64258},{64259,Ll | SM,64259,64259,64259},{64260,Ll | SM,64260,64260,64260},{64261,Ll | SM,64261,64261,64261},{64262,Ll | SM,64262,64262,64262},{64275,Ll | SM,64275,64275,64275},{64276,Ll | SM,64276,64276,64276},{64277,Ll | SM,64277,64277,64277},{64278,Ll | SM,64278,64278,64278},{64279,Ll | SM,64279,64279,64279},{64285,Lo,64285,64285,64285},{64286,Mn,64286,64286,64286},{64287,Lo,64287,64287,64287},{64288,Lo,64288,64288,64288},{64289,Lo,64289,64289,64289},{64290,Lo,64290,64290,64290},{64291,Lo,64291,64291,64291},{64292,Lo,64292,64292,64292},{64293,Lo,64293,64293,64293},{64294,Lo,64294,64294,64294},{64295,Lo,64295,64295,64295},{64296,Lo,64296,64296,64296},{64297,Sm,64297,64297,64297},{64298,Lo,64298,64298,64298},{64299,Lo,64299,64299,64299},{64300,Lo,64300,64300,64300},{64301,Lo,64301,64301,64301},{64302,Lo,64302,64302,64302},{64303,Lo,64303,64303,64303},{64304,Lo,64304,64304,64304},{64305,Lo,64305,64305,64305},{64306,Lo,64306,64306,64306},{64307,Lo,64307,64307,64307},{64308,Lo,64308,64308,64308},{64309,Lo,64309,64309,64309},{64310,Lo,64310,64310,64310},{64312,Lo,64312,64312,64312},{64313,Lo,64313,64313,64313},{64314,Lo,64314,64314,64314},{64315,Lo,64315,64315,64315},{64316,Lo,64316,64316,64316},{64318,Lo,64318,64318,64318},{64320,Lo,64320,64320,64320},{64321,Lo,64321,64321,64321},{64323,Lo,64323,64323,64323},{64324,Lo,64324,64324,64324},{64326,Lo,64326,64326,64326},{64327,Lo,64327,64327,64327},{64328,Lo,64328,64328,64328},{64329,Lo,64329,64329,64329},{64330,Lo,64330,64330,64330},{64331,Lo,64331,64331,64331},{64332,Lo,64332,64332,64332},{64333,Lo,64333,64333,64333},{64334,Lo,64334,64334,64334},{64335,Lo,64335,64335,64335},{64336,Lo,64336,64336,64336},{64337,Lo,64337,64337,64337},{64338,Lo,64338,64338,64338},{64339,Lo,64339,64339,64339},{64340,Lo,64340,64340,64340},{64341,Lo,64341,64341,64341},{64342,Lo,64342,64342,64342},{64343,Lo,64343,64343,64343},{64344,Lo,64344,64344,64344},{64345,Lo,64345,64345,64345},{64346,Lo,64346,64346,64346},{64347,Lo,64347,64347,64347},{64348,Lo,64348,64348,64348},{64349,Lo,64349,64349,64349},{64350,Lo,64350,64350,64350},{64351,Lo,64351,64351,64351},{64352,Lo,64352,64352,64352},{64353,Lo,64353,64353,64353},{64354,Lo,64354,64354,64354},{64355,Lo,64355,64355,64355},{64356,Lo,64356,64356,64356},{64357,Lo,64357,64357,64357},{64358,Lo,64358,64358,64358},{64359,Lo,64359,64359,64359},{64360,Lo,64360,64360,64360},{64361,Lo,64361,64361,64361},{64362,Lo,64362,64362,64362},{64363,Lo,64363,64363,64363},{64364,Lo,64364,64364,64364},{64365,Lo,64365,64365,64365},{64366,Lo,64366,64366,64366},{64367,Lo,64367,64367,64367},{64368,Lo,64368,64368,64368},{64369,Lo,64369,64369,64369},{64370,Lo,64370,64370,64370},{64371,Lo,64371,64371,64371},{64372,Lo,64372,64372,64372},{64373,Lo,64373,64373,64373},{64374,Lo,64374,64374,64374},{64375,Lo,64375,64375,64375},{64376,Lo,64376,64376,64376},{64377,Lo,64377,64377,64377},{64378,Lo,64378,64378,64378},{64379,Lo,64379,64379,64379},{64380,Lo,64380,64380,64380},{64381,Lo,64381,64381,64381},{64382,Lo,64382,64382,64382},{64383,Lo,64383,64383,64383},{64384,Lo,64384,64384,64384},{64385,Lo,64385,64385,64385},{64386,Lo,64386,64386,64386},{64387,Lo,64387,64387,64387},{64388,Lo,64388,64388,64388},{64389,Lo,64389,64389,64389},{64390,Lo,64390,64390,64390},{64391,Lo,64391,64391,64391},{64392,Lo,64392,64392,64392},{64393,Lo,64393,64393,64393},{64394,Lo,64394,64394,64394},{64395,Lo,64395,64395,64395},{64396,Lo,64396,64396,64396},{64397,Lo,64397,64397,64397},{64398,Lo,64398,64398,64398},{64399,Lo,64399,64399,64399},{64400,Lo,64400,64400,64400},{64401,Lo,64401,64401,64401},{64402,Lo,64402,64402,64402},{64403,Lo,64403,64403,64403},{64404,Lo,64404,64404,64404},{64405,Lo,64405,64405,64405},{64406,Lo,64406,64406,64406},{64407,Lo,64407,64407,64407},{64408,Lo,64408,64408,64408},{64409,Lo,64409,64409,64409},{64410,Lo,64410,64410,64410},{64411,Lo,64411,64411,64411},{64412,Lo,64412,64412,64412},{64413,Lo,64413,64413,64413},{64414,Lo,64414,64414,64414},{64415,Lo,64415,64415,64415},{64416,Lo,64416,64416,64416},{64417,Lo,64417,64417,64417},{64418,Lo,64418,64418,64418},{64419,Lo,64419,64419,64419},{64420,Lo,64420,64420,64420},{64421,Lo,64421,64421,64421},{64422,Lo,64422,64422,64422},{64423,Lo,64423,64423,64423},{64424,Lo,64424,64424,64424},{64425,Lo,64425,64425,64425},{64426,Lo,64426,64426,64426},{64427,Lo,64427,64427,64427},{64428,Lo,64428,64428,64428},{64429,Lo,64429,64429,64429},{64430,Lo,64430,64430,64430},{64431,Lo,64431,64431,64431},{64432,Lo,64432,64432,64432},{64433,Lo,64433,64433,64433},{64467,Lo,64467,64467,64467},{64468,Lo,64468,64468,64468},{64469,Lo,64469,64469,64469},{64470,Lo,64470,64470,64470},{64471,Lo,64471,64471,64471},{64472,Lo,64472,64472,64472},{64473,Lo,64473,64473,64473},{64474,Lo,64474,64474,64474},{64475,Lo,64475,64475,64475},{64476,Lo,64476,64476,64476},{64477,Lo,64477,64477,64477},{64478,Lo,64478,64478,64478},{64479,Lo,64479,64479,64479},{64480,Lo,64480,64480,64480},{64481,Lo,64481,64481,64481},{64482,Lo,64482,64482,64482},{64483,Lo,64483,64483,64483},{64484,Lo,64484,64484,64484},{64485,Lo,64485,64485,64485},{64486,Lo,64486,64486,64486},{64487,Lo,64487,64487,64487},{64488,Lo,64488,64488,64488},{64489,Lo,64489,64489,64489},{64490,Lo,64490,64490,64490},{64491,Lo,64491,64491,64491},{64492,Lo,64492,64492,64492},{64493,Lo,64493,64493,64493},{64494,Lo,64494,64494,64494},{64495,Lo,64495,64495,64495},{64496,Lo,64496,64496,64496},{64497,Lo,64497,64497,64497},{64498,Lo,64498,64498,64498},{64499,Lo,64499,64499,64499},{64500,Lo,64500,64500,64500},{64501,Lo,64501,64501,64501},{64502,Lo,64502,64502,64502},{64503,Lo,64503,64503,64503},{64504,Lo,64504,64504,64504},{64505,Lo,64505,64505,64505},{64506,Lo,64506,64506,64506},{64507,Lo,64507,64507,64507},{64508,Lo,64508,64508,64508},{64509,Lo,64509,64509,64509},{64510,Lo,64510,64510,64510},{64511,Lo,64511,64511,64511},{64512,Lo,64512,64512,64512},{64513,Lo,64513,64513,64513},{64514,Lo,64514,64514,64514},{64515,Lo,64515,64515,64515},{64516,Lo,64516,64516,64516},{64517,Lo,64517,64517,64517},{64518,Lo,64518,64518,64518},{64519,Lo,64519,64519,64519},{64520,Lo,64520,64520,64520},{64521,Lo,64521,64521,64521},{64522,Lo,64522,64522,64522},{64523,Lo,64523,64523,64523},{64524,Lo,64524,64524,64524},{64525,Lo,64525,64525,64525},{64526,Lo,64526,64526,64526},{64527,Lo,64527,64527,64527},{64528,Lo,64528,64528,64528},{64529,Lo,64529,64529,64529},{64530,Lo,64530,64530,64530},{64531,Lo,64531,64531,64531},{64532,Lo,64532,64532,64532},{64533,Lo,64533,64533,64533},{64534,Lo,64534,64534,64534},{64535,Lo,64535,64535,64535},{64536,Lo,64536,64536,64536},{64537,Lo,64537,64537,64537},{64538,Lo,64538,64538,64538},{64539,Lo,64539,64539,64539},{64540,Lo,64540,64540,64540},{64541,Lo,64541,64541,64541},{64542,Lo,64542,64542,64542},{64543,Lo,64543,64543,64543},{64544,Lo,64544,64544,64544},{64545,Lo,64545,64545,64545},{64546,Lo,64546,64546,64546},{64547,Lo,64547,64547,64547},{64548,Lo,64548,64548,64548},{64549,Lo,64549,64549,64549},{64550,Lo,64550,64550,64550},{64551,Lo,64551,64551,64551},{64552,Lo,64552,64552,64552},{64553,Lo,64553,64553,64553},{64554,Lo,64554,64554,64554},{64555,Lo,64555,64555,64555},{64556,Lo,64556,64556,64556},{64557,Lo,64557,64557,64557},{64558,Lo,64558,64558,64558},{64559,Lo,64559,64559,64559},{64560,Lo,64560,64560,64560},{64561,Lo,64561,64561,64561},{64562,Lo,64562,64562,64562},{64563,Lo,64563,64563,64563},{64564,Lo,64564,64564,64564},{64565,Lo,64565,64565,64565},{64566,Lo,64566,64566,64566},{64567,Lo,64567,64567,64567},{64568,Lo,64568,64568,64568},{64569,Lo,64569,64569,64569},{64570,Lo,64570,64570,64570},{64571,Lo,64571,64571,64571},{64572,Lo,64572,64572,64572},{64573,Lo,64573,64573,64573},{64574,Lo,64574,64574,64574},{64575,Lo,64575,64575,64575},{64576,Lo,64576,64576,64576},{64577,Lo,64577,64577,64577},{64578,Lo,64578,64578,64578},{64579,Lo,64579,64579,64579},{64580,Lo,64580,64580,64580},{64581,Lo,64581,64581,64581},{64582,Lo,64582,64582,64582},{64583,Lo,64583,64583,64583},{64584,Lo,64584,64584,64584},{64585,Lo,64585,64585,64585},{64586,Lo,64586,64586,64586},{64587,Lo,64587,64587,64587},{64588,Lo,64588,64588,64588},{64589,Lo,64589,64589,64589},{64590,Lo,64590,64590,64590},{64591,Lo,64591,64591,64591},{64592,Lo,64592,64592,64592},{64593,Lo,64593,64593,64593},{64594,Lo,64594,64594,64594},{64595,Lo,64595,64595,64595},{64596,Lo,64596,64596,64596},{64597,Lo,64597,64597,64597},{64598,Lo,64598,64598,64598},{64599,Lo,64599,64599,64599},{64600,Lo,64600,64600,64600},{64601,Lo,64601,64601,64601},{64602,Lo,64602,64602,64602},{64603,Lo,64603,64603,64603},{64604,Lo,64604,64604,64604},{64605,Lo,64605,64605,64605},{64606,Lo,64606,64606,64606},{64607,Lo,64607,64607,64607},{64608,Lo,64608,64608,64608},{64609,Lo,64609,64609,64609},{64610,Lo,64610,64610,64610},{64611,Lo,64611,64611,64611},{64612,Lo,64612,64612,64612},{64613,Lo,64613,64613,64613},{64614,Lo,64614,64614,64614},{64615,Lo,64615,64615,64615},{64616,Lo,64616,64616,64616},{64617,Lo,64617,64617,64617},{64618,Lo,64618,64618,64618},{64619,Lo,64619,64619,64619},{64620,Lo,64620,64620,64620},{64621,Lo,64621,64621,64621},{64622,Lo,64622,64622,64622},{64623,Lo,64623,64623,64623},{64624,Lo,64624,64624,64624},{64625,Lo,64625,64625,64625},{64626,Lo,64626,64626,64626},{64627,Lo,64627,64627,64627},{64628,Lo,64628,64628,64628},{64629,Lo,64629,64629,64629},{64630,Lo,64630,64630,64630},{64631,Lo,64631,64631,64631},{64632,Lo,64632,64632,64632},{64633,Lo,64633,64633,64633},{64634,Lo,64634,64634,64634},{64635,Lo,64635,64635,64635},{64636,Lo,64636,64636,64636},{64637,Lo,64637,64637,64637},{64638,Lo,64638,64638,64638},{64639,Lo,64639,64639,64639},{64640,Lo,64640,64640,64640},{64641,Lo,64641,64641,64641},{64642,Lo,64642,64642,64642},{64643,Lo,64643,64643,64643},{64644,Lo,64644,64644,64644},{64645,Lo,64645,64645,64645},{64646,Lo,64646,64646,64646},{64647,Lo,64647,64647,64647},{64648,Lo,64648,64648,64648},{64649,Lo,64649,64649,64649},{64650,Lo,64650,64650,64650},{64651,Lo,64651,64651,64651},{64652,Lo,64652,64652,64652},{64653,Lo,64653,64653,64653},{64654,Lo,64654,64654,64654},{64655,Lo,64655,64655,64655},{64656,Lo,64656,64656,64656},{64657,Lo,64657,64657,64657},{64658,Lo,64658,64658,64658},{64659,Lo,64659,64659,64659},{64660,Lo,64660,64660,64660},{64661,Lo,64661,64661,64661},{64662,Lo,64662,64662,64662},{64663,Lo,64663,64663,64663},{64664,Lo,64664,64664,64664},{64665,Lo,64665,64665,64665},{64666,Lo,64666,64666,64666},{64667,Lo,64667,64667,64667},{64668,Lo,64668,64668,64668},{64669,Lo,64669,64669,64669},{64670,Lo,64670,64670,64670},{64671,Lo,64671,64671,64671},{64672,Lo,64672,64672,64672},{64673,Lo,64673,64673,64673},{64674,Lo,64674,64674,64674},{64675,Lo,64675,64675,64675},{64676,Lo,64676,64676,64676},{64677,Lo,64677,64677,64677},{64678,Lo,64678,64678,64678},{64679,Lo,64679,64679,64679},{64680,Lo,64680,64680,64680},{64681,Lo,64681,64681,64681},{64682,Lo,64682,64682,64682},{64683,Lo,64683,64683,64683},{64684,Lo,64684,64684,64684},{64685,Lo,64685,64685,64685},{64686,Lo,64686,64686,64686},{64687,Lo,64687,64687,64687},{64688,Lo,64688,64688,64688},{64689,Lo,64689,64689,64689},{64690,Lo,64690,64690,64690},{64691,Lo,64691,64691,64691},{64692,Lo,64692,64692,64692},{64693,Lo,64693,64693,64693},{64694,Lo,64694,64694,64694},{64695,Lo,64695,64695,64695},{64696,Lo,64696,64696,64696},{64697,Lo,64697,64697,64697},{64698,Lo,64698,64698,64698},{64699,Lo,64699,64699,64699},{64700,Lo,64700,64700,64700},{64701,Lo,64701,64701,64701},{64702,Lo,64702,64702,64702},{64703,Lo,64703,64703,64703},{64704,Lo,64704,64704,64704},{64705,Lo,64705,64705,64705},{64706,Lo,64706,64706,64706},{64707,Lo,64707,64707,64707},{64708,Lo,64708,64708,64708},{64709,Lo,64709,64709,64709},{64710,Lo,64710,64710,64710},{64711,Lo,64711,64711,64711},{64712,Lo,64712,64712,64712},{64713,Lo,64713,64713,64713},{64714,Lo,64714,64714,64714},{64715,Lo,64715,64715,64715},{64716,Lo,64716,64716,64716},{64717,Lo,64717,64717,64717},{64718,Lo,64718,64718,64718},{64719,Lo,64719,64719,64719},{64720,Lo,64720,64720,64720},{64721,Lo,64721,64721,64721},{64722,Lo,64722,64722,64722},{64723,Lo,64723,64723,64723},{64724,Lo,64724,64724,64724},{64725,Lo,64725,64725,64725},{64726,Lo,64726,64726,64726},{64727,Lo,64727,64727,64727},{64728,Lo,64728,64728,64728},{64729,Lo,64729,64729,64729},{64730,Lo,64730,64730,64730},{64731,Lo,64731,64731,64731},{64732,Lo,64732,64732,64732},{64733,Lo,64733,64733,64733},{64734,Lo,64734,64734,64734},{64735,Lo,64735,64735,64735},{64736,Lo,64736,64736,64736},{64737,Lo,64737,64737,64737},{64738,Lo,64738,64738,64738},{64739,Lo,64739,64739,64739},{64740,Lo,64740,64740,64740},{64741,Lo,64741,64741,64741},{64742,Lo,64742,64742,64742},{64743,Lo,64743,64743,64743},{64744,Lo,64744,64744,64744},{64745,Lo,64745,64745,64745},{64746,Lo,64746,64746,64746},{64747,Lo,64747,64747,64747},{64748,Lo,64748,64748,64748},{64749,Lo,64749,64749,64749},{64750,Lo,64750,64750,64750},{64751,Lo,64751,64751,64751},{64752,Lo,64752,64752,64752},{64753,Lo,64753,64753,64753},{64754,Lo,64754,64754,64754},{64755,Lo,64755,64755,64755},{64756,Lo,64756,64756,64756},{64757,Lo,64757,64757,64757},{64758,Lo,64758,64758,64758},{64759,Lo,64759,64759,64759},{64760,Lo,64760,64760,64760},{64761,Lo,64761,64761,64761},{64762,Lo,64762,64762,64762},{64763,Lo,64763,64763,64763},{64764,Lo,64764,64764,64764},{64765,Lo,64765,64765,64765},{64766,Lo,64766,64766,64766},{64767,Lo,64767,64767,64767},{64768,Lo,64768,64768,64768},{64769,Lo,64769,64769,64769},{64770,Lo,64770,64770,64770},{64771,Lo,64771,64771,64771},{64772,Lo,64772,64772,64772},{64773,Lo,64773,64773,64773},{64774,Lo,64774,64774,64774},{64775,Lo,64775,64775,64775},{64776,Lo,64776,64776,64776},{64777,Lo,64777,64777,64777},{64778,Lo,64778,64778,64778},{64779,Lo,64779,64779,64779},{64780,Lo,64780,64780,64780},{64781,Lo,64781,64781,64781},{64782,Lo,64782,64782,64782},{64783,Lo,64783,64783,64783},{64784,Lo,64784,64784,64784},{64785,Lo,64785,64785,64785},{64786,Lo,64786,64786,64786},{64787,Lo,64787,64787,64787},{64788,Lo,64788,64788,64788},{64789,Lo,64789,64789,64789},{64790,Lo,64790,64790,64790},{64791,Lo,64791,64791,64791},{64792,Lo,64792,64792,64792},{64793,Lo,64793,64793,64793},{64794,Lo,64794,64794,64794},{64795,Lo,64795,64795,64795},{64796,Lo,64796,64796,64796},{64797,Lo,64797,64797,64797},{64798,Lo,64798,64798,64798},{64799,Lo,64799,64799,64799},{64800,Lo,64800,64800,64800},{64801,Lo,64801,64801,64801},{64802,Lo,64802,64802,64802},{64803,Lo,64803,64803,64803},{64804,Lo,64804,64804,64804},{64805,Lo,64805,64805,64805},{64806,Lo,64806,64806,64806},{64807,Lo,64807,64807,64807},{64808,Lo,64808,64808,64808},{64809,Lo,64809,64809,64809},{64810,Lo,64810,64810,64810},{64811,Lo,64811,64811,64811},{64812,Lo,64812,64812,64812},{64813,Lo,64813,64813,64813},{64814,Lo,64814,64814,64814},{64815,Lo,64815,64815,64815},{64816,Lo,64816,64816,64816},{64817,Lo,64817,64817,64817},{64818,Lo,64818,64818,64818},{64819,Lo,64819,64819,64819},{64820,Lo,64820,64820,64820},{64821,Lo,64821,64821,64821},{64822,Lo,64822,64822,64822},{64823,Lo,64823,64823,64823},{64824,Lo,64824,64824,64824},{64825,Lo,64825,64825,64825},{64826,Lo,64826,64826,64826},{64827,Lo,64827,64827,64827},{64828,Lo,64828,64828,64828},{64829,Lo,64829,64829,64829},{64830,Ps,64830,64830,64830},{64831,Pe,64831,64831,64831},{64848,Lo,64848,64848,64848},{64849,Lo,64849,64849,64849},{64850,Lo,64850,64850,64850},{64851,Lo,64851,64851,64851},{64852,Lo,64852,64852,64852},{64853,Lo,64853,64853,64853},{64854,Lo,64854,64854,64854},{64855,Lo,64855,64855,64855},{64856,Lo,64856,64856,64856},{64857,Lo,64857,64857,64857},{64858,Lo,64858,64858,64858},{64859,Lo,64859,64859,64859},{64860,Lo,64860,64860,64860},{64861,Lo,64861,64861,64861},{64862,Lo,64862,64862,64862},{64863,Lo,64863,64863,64863},{64864,Lo,64864,64864,64864},{64865,Lo,64865,64865,64865},{64866,Lo,64866,64866,64866},{64867,Lo,64867,64867,64867},{64868,Lo,64868,64868,64868},{64869,Lo,64869,64869,64869},{64870,Lo,64870,64870,64870},{64871,Lo,64871,64871,64871},{64872,Lo,64872,64872,64872},{64873,Lo,64873,64873,64873},{64874,Lo,64874,64874,64874},{64875,Lo,64875,64875,64875},{64876,Lo,64876,64876,64876},{64877,Lo,64877,64877,64877},{64878,Lo,64878,64878,64878},{64879,Lo,64879,64879,64879},{64880,Lo,64880,64880,64880},{64881,Lo,64881,64881,64881},{64882,Lo,64882,64882,64882},{64883,Lo,64883,64883,64883},{64884,Lo,64884,64884,64884},{64885,Lo,64885,64885,64885},{64886,Lo,64886,64886,64886},{64887,Lo,64887,64887,64887},{64888,Lo,64888,64888,64888},{64889,Lo,64889,64889,64889},{64890,Lo,64890,64890,64890},{64891,Lo,64891,64891,64891},{64892,Lo,64892,64892,64892},{64893,Lo,64893,64893,64893},{64894,Lo,64894,64894,64894},{64895,Lo,64895,64895,64895},{64896,Lo,64896,64896,64896},{64897,Lo,64897,64897,64897},{64898,Lo,64898,64898,64898},{64899,Lo,64899,64899,64899},{64900,Lo,64900,64900,64900},{64901,Lo,64901,64901,64901},{64902,Lo,64902,64902,64902},{64903,Lo,64903,64903,64903},{64904,Lo,64904,64904,64904},{64905,Lo,64905,64905,64905},{64906,Lo,64906,64906,64906},{64907,Lo,64907,64907,64907},{64908,Lo,64908,64908,64908},{64909,Lo,64909,64909,64909},{64910,Lo,64910,64910,64910},{64911,Lo,64911,64911,64911},{64914,Lo,64914,64914,64914},{64915,Lo,64915,64915,64915},{64916,Lo,64916,64916,64916},{64917,Lo,64917,64917,64917},{64918,Lo,64918,64918,64918},{64919,Lo,64919,64919,64919},{64920,Lo,64920,64920,64920},{64921,Lo,64921,64921,64921},{64922,Lo,64922,64922,64922},{64923,Lo,64923,64923,64923},{64924,Lo,64924,64924,64924},{64925,Lo,64925,64925,64925},{64926,Lo,64926,64926,64926},{64927,Lo,64927,64927,64927},{64928,Lo,64928,64928,64928},{64929,Lo,64929,64929,64929},{64930,Lo,64930,64930,64930},{64931,Lo,64931,64931,64931},{64932,Lo,64932,64932,64932},{64933,Lo,64933,64933,64933},{64934,Lo,64934,64934,64934},{64935,Lo,64935,64935,64935},{64936,Lo,64936,64936,64936},{64937,Lo,64937,64937,64937},{64938,Lo,64938,64938,64938},{64939,Lo,64939,64939,64939},{64940,Lo,64940,64940,64940},{64941,Lo,64941,64941,64941},{64942,Lo,64942,64942,64942},{64943,Lo,64943,64943,64943},{64944,Lo,64944,64944,64944},{64945,Lo,64945,64945,64945},{64946,Lo,64946,64946,64946},{64947,Lo,64947,64947,64947},{64948,Lo,64948,64948,64948},{64949,Lo,64949,64949,64949},{64950,Lo,64950,64950,64950},{64951,Lo,64951,64951,64951},{64952,Lo,64952,64952,64952},{64953,Lo,64953,64953,64953},{64954,Lo,64954,64954,64954},{64955,Lo,64955,64955,64955},{64956,Lo,64956,64956,64956},{64957,Lo,64957,64957,64957},{64958,Lo,64958,64958,64958},{64959,Lo,64959,64959,64959},{64960,Lo,64960,64960,64960},{64961,Lo,64961,64961,64961},{64962,Lo,64962,64962,64962},{64963,Lo,64963,64963,64963},{64964,Lo,64964,64964,64964},{64965,Lo,64965,64965,64965},{64966,Lo,64966,64966,64966},{64967,Lo,64967,64967,64967},{65008,Lo,65008,65008,65008},{65009,Lo,65009,65009,65009},{65010,Lo,65010,65010,65010},{65011,Lo,65011,65011,65011},{65012,Lo,65012,65012,65012},{65013,Lo,65013,65013,65013},{65014,Lo,65014,65014,65014},{65015,Lo,65015,65015,65015},{65016,Lo,65016,65016,65016},{65017,Lo,65017,65017,65017},{65018,Lo,65018,65018,65018},{65019,Lo,65019,65019,65019},{65020,Sc,65020,65020,65020},{65021,So,65021,65021,65021},{65024,Mn,65024,65024,65024},{65025,Mn,65025,65025,65025},{65026,Mn,65026,65026,65026},{65027,Mn,65027,65027,65027},{65028,Mn,65028,65028,65028},{65029,Mn,65029,65029,65029},{65030,Mn,65030,65030,65030},{65031,Mn,65031,65031,65031},{65032,Mn,65032,65032,65032},{65033,Mn,65033,65033,65033},{65034,Mn,65034,65034,65034},{65035,Mn,65035,65035,65035},{65036,Mn,65036,65036,65036},{65037,Mn,65037,65037,65037},{65038,Mn,65038,65038,65038},{65039,Mn,65039,65039,65039},{65040,Po,65040,65040,65040},{65041,Po,65041,65041,65041},{65042,Po,65042,65042,65042},{65043,Po,65043,65043,65043},{65044,Po,65044,65044,65044},{65045,Po,65045,65045,65045},{65046,Po,65046,65046,65046},{65047,Ps,65047,65047,65047},{65048,Pe,65048,65048,65048},{65049,Po,65049,65049,65049},{65056,Mn,65056,65056,65056},{65057,Mn,65057,65057,65057},{65058,Mn,65058,65058,65058},{65059,Mn,65059,65059,65059},{65072,Po,65072,65072,65072},{65073,Pd,65073,65073,65073},{65074,Pd,65074,65074,65074},{65075,Pc,65075,65075,65075},{65076,Pc,65076,65076,65076},{65077,Ps,65077,65077,65077},{65078,Pe,65078,65078,65078},{65079,Ps,65079,65079,65079},{65080,Pe,65080,65080,65080},{65081,Ps,65081,65081,65081},{65082,Pe,65082,65082,65082},{65083,Ps,65083,65083,65083},{65084,Pe,65084,65084,65084},{65085,Ps,65085,65085,65085},{65086,Pe,65086,65086,65086},{65087,Ps,65087,65087,65087},{65088,Pe,65088,65088,65088},{65089,Ps,65089,65089,65089},{65090,Pe,65090,65090,65090},{65091,Ps,65091,65091,65091},{65092,Pe,65092,65092,65092},{65093,Po,65093,65093,65093},{65094,Po,65094,65094,65094},{65095,Ps,65095,65095,65095},{65096,Pe,65096,65096,65096},{65097,Po,65097,65097,65097},{65098,Po,65098,65098,65098},{65099,Po,65099,65099,65099},{65100,Po,65100,65100,65100},{65101,Pc,65101,65101,65101},{65102,Pc,65102,65102,65102},{65103,Pc,65103,65103,65103},{65104,Po,65104,65104,65104},{65105,Po,65105,65105,65105},{65106,Po,65106,65106,65106},{65108,Po,65108,65108,65108},{65109,Po,65109,65109,65109},{65110,Po,65110,65110,65110},{65111,Po,65111,65111,65111},{65112,Pd,65112,65112,65112},{65113,Ps,65113,65113,65113},{65114,Pe,65114,65114,65114},{65115,Ps,65115,65115,65115},{65116,Pe,65116,65116,65116},{65117,Ps,65117,65117,65117},{65118,Pe,65118,65118,65118},{65119,Po,65119,65119,65119},{65120,Po,65120,65120,65120},{65121,Po,65121,65121,65121},{65122,Sm,65122,65122,65122},{65123,Pd,65123,65123,65123},{65124,Sm,65124,65124,65124},{65125,Sm,65125,65125,65125},{65126,Sm,65126,65126,65126},{65128,Po,65128,65128,65128},{65129,Sc,65129,65129,65129},{65130,Po,65130,65130,65130},{65131,Po,65131,65131,65131},{65136,Lo,65136,65136,65136},{65137,Lo,65137,65137,65137},{65138,Lo,65138,65138,65138},{65139,Lo,65139,65139,65139},{65140,Lo,65140,65140,65140},{65142,Lo,65142,65142,65142},{65143,Lo,65143,65143,65143},{65144,Lo,65144,65144,65144},{65145,Lo,65145,65145,65145},{65146,Lo,65146,65146,65146},{65147,Lo,65147,65147,65147},{65148,Lo,65148,65148,65148},{65149,Lo,65149,65149,65149},{65150,Lo,65150,65150,65150},{65151,Lo,65151,65151,65151},{65152,Lo,65152,65152,65152},{65153,Lo,65153,65153,65153},{65154,Lo,65154,65154,65154},{65155,Lo,65155,65155,65155},{65156,Lo,65156,65156,65156},{65157,Lo,65157,65157,65157},{65158,Lo,65158,65158,65158},{65159,Lo,65159,65159,65159},{65160,Lo,65160,65160,65160},{65161,Lo,65161,65161,65161},{65162,Lo,65162,65162,65162},{65163,Lo,65163,65163,65163},{65164,Lo,65164,65164,65164},{65165,Lo,65165,65165,65165},{65166,Lo,65166,65166,65166},{65167,Lo,65167,65167,65167},{65168,Lo,65168,65168,65168},{65169,Lo,65169,65169,65169},{65170,Lo,65170,65170,65170},{65171,Lo,65171,65171,65171},{65172,Lo,65172,65172,65172},{65173,Lo,65173,65173,65173},{65174,Lo,65174,65174,65174},{65175,Lo,65175,65175,65175},{65176,Lo,65176,65176,65176},{65177,Lo,65177,65177,65177},{65178,Lo,65178,65178,65178},{65179,Lo,65179,65179,65179},{65180,Lo,65180,65180,65180},{65181,Lo,65181,65181,65181},{65182,Lo,65182,65182,65182},{65183,Lo,65183,65183,65183},{65184,Lo,65184,65184,65184},{65185,Lo,65185,65185,65185},{65186,Lo,65186,65186,65186},{65187,Lo,65187,65187,65187},{65188,Lo,65188,65188,65188},{65189,Lo,65189,65189,65189},{65190,Lo,65190,65190,65190},{65191,Lo,65191,65191,65191},{65192,Lo,65192,65192,65192},{65193,Lo,65193,65193,65193},{65194,Lo,65194,65194,65194},{65195,Lo,65195,65195,65195},{65196,Lo,65196,65196,65196},{65197,Lo,65197,65197,65197},{65198,Lo,65198,65198,65198},{65199,Lo,65199,65199,65199},{65200,Lo,65200,65200,65200},{65201,Lo,65201,65201,65201},{65202,Lo,65202,65202,65202},{65203,Lo,65203,65203,65203},{65204,Lo,65204,65204,65204},{65205,Lo,65205,65205,65205},{65206,Lo,65206,65206,65206},{65207,Lo,65207,65207,65207},{65208,Lo,65208,65208,65208},{65209,Lo,65209,65209,65209},{65210,Lo,65210,65210,65210},{65211,Lo,65211,65211,65211},{65212,Lo,65212,65212,65212},{65213,Lo,65213,65213,65213},{65214,Lo,65214,65214,65214},{65215,Lo,65215,65215,65215},{65216,Lo,65216,65216,65216},{65217,Lo,65217,65217,65217},{65218,Lo,65218,65218,65218},{65219,Lo,65219,65219,65219},{65220,Lo,65220,65220,65220},{65221,Lo,65221,65221,65221},{65222,Lo,65222,65222,65222},{65223,Lo,65223,65223,65223},{65224,Lo,65224,65224,65224},{65225,Lo,65225,65225,65225},{65226,Lo,65226,65226,65226},{65227,Lo,65227,65227,65227},{65228,Lo,65228,65228,65228},{65229,Lo,65229,65229,65229},{65230,Lo,65230,65230,65230},{65231,Lo,65231,65231,65231},{65232,Lo,65232,65232,65232},{65233,Lo,65233,65233,65233},{65234,Lo,65234,65234,65234},{65235,Lo,65235,65235,65235},{65236,Lo,65236,65236,65236},{65237,Lo,65237,65237,65237},{65238,Lo,65238,65238,65238},{65239,Lo,65239,65239,65239},{65240,Lo,65240,65240,65240},{65241,Lo,65241,65241,65241},{65242,Lo,65242,65242,65242},{65243,Lo,65243,65243,65243},{65244,Lo,65244,65244,65244},{65245,Lo,65245,65245,65245},{65246,Lo,65246,65246,65246},{65247,Lo,65247,65247,65247},{65248,Lo,65248,65248,65248},{65249,Lo,65249,65249,65249},{65250,Lo,65250,65250,65250},{65251,Lo,65251,65251,65251},{65252,Lo,65252,65252,65252},{65253,Lo,65253,65253,65253},{65254,Lo,65254,65254,65254},{65255,Lo,65255,65255,65255},{65256,Lo,65256,65256,65256},{65257,Lo,65257,65257,65257},{65258,Lo,65258,65258,65258},{65259,Lo,65259,65259,65259},{65260,Lo,65260,65260,65260},{65261,Lo,65261,65261,65261},{65262,Lo,65262,65262,65262},{65263,Lo,65263,65263,65263},{65264,Lo,65264,65264,65264},{65265,Lo,65265,65265,65265},{65266,Lo,65266,65266,65266},{65267,Lo,65267,65267,65267},{65268,Lo,65268,65268,65268},{65269,Lo,65269,65269,65269},{65270,Lo,65270,65270,65270},{65271,Lo,65271,65271,65271},{65272,Lo,65272,65272,65272},{65273,Lo,65273,65273,65273},{65274,Lo,65274,65274,65274},{65275,Lo,65275,65275,65275},{65276,Lo,65276,65276,65276},{65279,Cf,65279,65279,65279},{65281,Po,65281,65281,65281},{65282,Po,65282,65282,65282},{65283,Po,65283,65283,65283},{65284,Sc,65284,65284,65284},{65285,Po,65285,65285,65285},{65286,Po,65286,65286,65286},{65287,Po,65287,65287,65287},{65288,Ps,65288,65288,65288},{65289,Pe,65289,65289,65289},{65290,Po,65290,65290,65290},{65291,Sm,65291,65291,65291},{65292,Po,65292,65292,65292},{65293,Pd,65293,65293,65293},{65294,Po,65294,65294,65294},{65295,Po,65295,65295,65295},{65296,Nd,65296,65296,65296},{65297,Nd,65297,65297,65297},{65298,Nd,65298,65298,65298},{65299,Nd,65299,65299,65299},{65300,Nd,65300,65300,65300},{65301,Nd,65301,65301,65301},{65302,Nd,65302,65302,65302},{65303,Nd,65303,65303,65303},{65304,Nd,65304,65304,65304},{65305,Nd,65305,65305,65305},{65306,Po,65306,65306,65306},{65307,Po,65307,65307,65307},{65308,Sm,65308,65308,65308},{65309,Sm,65309,65309,65309},{65310,Sm,65310,65310,65310},{65311,Po,65311,65311,65311},{65312,Po,65312,65312,65312},{65313,Lu,65313,65345,65313},{65314,Lu,65314,65346,65314},{65315,Lu,65315,65347,65315},{65316,Lu,65316,65348,65316},{65317,Lu,65317,65349,65317},{65318,Lu,65318,65350,65318},{65319,Lu,65319,65351,65319},{65320,Lu,65320,65352,65320},{65321,Lu,65321,65353,65321},{65322,Lu,65322,65354,65322},{65323,Lu,65323,65355,65323},{65324,Lu,65324,65356,65324},{65325,Lu,65325,65357,65325},{65326,Lu,65326,65358,65326},{65327,Lu,65327,65359,65327},{65328,Lu,65328,65360,65328},{65329,Lu,65329,65361,65329},{65330,Lu,65330,65362,65330},{65331,Lu,65331,65363,65331},{65332,Lu,65332,65364,65332},{65333,Lu,65333,65365,65333},{65334,Lu,65334,65366,65334},{65335,Lu,65335,65367,65335},{65336,Lu,65336,65368,65336},{65337,Lu,65337,65369,65337},{65338,Lu,65338,65370,65338},{65339,Ps,65339,65339,65339},{65340,Po,65340,65340,65340},{65341,Pe,65341,65341,65341},{65342,Sk,65342,65342,65342},{65343,Pc,65343,65343,65343},{65344,Sk,65344,65344,65344},{65345,Ll,65313,65345,65313},{65346,Ll,65314,65346,65314},{65347,Ll,65315,65347,65315},{65348,Ll,65316,65348,65316},{65349,Ll,65317,65349,65317},{65350,Ll,65318,65350,65318},{65351,Ll,65319,65351,65319},{65352,Ll,65320,65352,65320},{65353,Ll,65321,65353,65321},{65354,Ll,65322,65354,65322},{65355,Ll,65323,65355,65323},{65356,Ll,65324,65356,65324},{65357,Ll,65325,65357,65325},{65358,Ll,65326,65358,65326},{65359,Ll,65327,65359,65327},{65360,Ll,65328,65360,65328},{65361,Ll,65329,65361,65329},{65362,Ll,65330,65362,65330},{65363,Ll,65331,65363,65331},{65364,Ll,65332,65364,65332},{65365,Ll,65333,65365,65333},{65366,Ll,65334,65366,65334},{65367,Ll,65335,65367,65335},{65368,Ll,65336,65368,65336},{65369,Ll,65337,65369,65337},{65370,Ll,65338,65370,65338},{65371,Ps,65371,65371,65371},{65372,Sm,65372,65372,65372},{65373,Pe,65373,65373,65373},{65374,Sm,65374,65374,65374},{65375,Ps,65375,65375,65375},{65376,Pe,65376,65376,65376},{65377,Po,65377,65377,65377},{65378,Ps,65378,65378,65378},{65379,Pe,65379,65379,65379},{65380,Po,65380,65380,65380},{65381,Po,65381,65381,65381},{65382,Lo,65382,65382,65382},{65383,Lo,65383,65383,65383},{65384,Lo,65384,65384,65384},{65385,Lo,65385,65385,65385},{65386,Lo,65386,65386,65386},{65387,Lo,65387,65387,65387},{65388,Lo,65388,65388,65388},{65389,Lo,65389,65389,65389},{65390,Lo,65390,65390,65390},{65391,Lo,65391,65391,65391},{65392,Lm,65392,65392,65392},{65393,Lo,65393,65393,65393},{65394,Lo,65394,65394,65394},{65395,Lo,65395,65395,65395},{65396,Lo,65396,65396,65396},{65397,Lo,65397,65397,65397},{65398,Lo,65398,65398,65398},{65399,Lo,65399,65399,65399},{65400,Lo,65400,65400,65400},{65401,Lo,65401,65401,65401},{65402,Lo,65402,65402,65402},{65403,Lo,65403,65403,65403},{65404,Lo,65404,65404,65404},{65405,Lo,65405,65405,65405},{65406,Lo,65406,65406,65406},{65407,Lo,65407,65407,65407},{65408,Lo,65408,65408,65408},{65409,Lo,65409,65409,65409},{65410,Lo,65410,65410,65410},{65411,Lo,65411,65411,65411},{65412,Lo,65412,65412,65412},{65413,Lo,65413,65413,65413},{65414,Lo,65414,65414,65414},{65415,Lo,65415,65415,65415},{65416,Lo,65416,65416,65416},{65417,Lo,65417,65417,65417},{65418,Lo,65418,65418,65418},{65419,Lo,65419,65419,65419},{65420,Lo,65420,65420,65420},{65421,Lo,65421,65421,65421},{65422,Lo,65422,65422,65422},{65423,Lo,65423,65423,65423},{65424,Lo,65424,65424,65424},{65425,Lo,65425,65425,65425},{65426,Lo,65426,65426,65426},{65427,Lo,65427,65427,65427},{65428,Lo,65428,65428,65428},{65429,Lo,65429,65429,65429},{65430,Lo,65430,65430,65430},{65431,Lo,65431,65431,65431},{65432,Lo,65432,65432,65432},{65433,Lo,65433,65433,65433},{65434,Lo,65434,65434,65434},{65435,Lo,65435,65435,65435},{65436,Lo,65436,65436,65436},{65437,Lo,65437,65437,65437},{65438,Lm,65438,65438,65438},{65439,Lm,65439,65439,65439},{65440,Lo,65440,65440,65440},{65441,Lo,65441,65441,65441},{65442,Lo,65442,65442,65442},{65443,Lo,65443,65443,65443},{65444,Lo,65444,65444,65444},{65445,Lo,65445,65445,65445},{65446,Lo,65446,65446,65446},{65447,Lo,65447,65447,65447},{65448,Lo,65448,65448,65448},{65449,Lo,65449,65449,65449},{65450,Lo,65450,65450,65450},{65451,Lo,65451,65451,65451},{65452,Lo,65452,65452,65452},{65453,Lo,65453,65453,65453},{65454,Lo,65454,65454,65454},{65455,Lo,65455,65455,65455},{65456,Lo,65456,65456,65456},{65457,Lo,65457,65457,65457},{65458,Lo,65458,65458,65458},{65459,Lo,65459,65459,65459},{65460,Lo,65460,65460,65460},{65461,Lo,65461,65461,65461},{65462,Lo,65462,65462,65462},{65463,Lo,65463,65463,65463},{65464,Lo,65464,65464,65464},{65465,Lo,65465,65465,65465},{65466,Lo,65466,65466,65466},{65467,Lo,65467,65467,65467},{65468,Lo,65468,65468,65468},{65469,Lo,65469,65469,65469},{65470,Lo,65470,65470,65470},{65474,Lo,65474,65474,65474},{65475,Lo,65475,65475,65475},{65476,Lo,65476,65476,65476},{65477,Lo,65477,65477,65477},{65478,Lo,65478,65478,65478},{65479,Lo,65479,65479,65479},{65482,Lo,65482,65482,65482},{65483,Lo,65483,65483,65483},{65484,Lo,65484,65484,65484},{65485,Lo,65485,65485,65485},{65486,Lo,65486,65486,65486},{65487,Lo,65487,65487,65487},{65490,Lo,65490,65490,65490},{65491,Lo,65491,65491,65491},{65492,Lo,65492,65492,65492},{65493,Lo,65493,65493,65493},{65494,Lo,65494,65494,65494},{65495,Lo,65495,65495,65495},{65498,Lo,65498,65498,65498},{65499,Lo,65499,65499,65499},{65500,Lo,65500,65500,65500},{65504,Sc,65504,65504,65504},{65505,Sc,65505,65505,65505},{65506,Sm,65506,65506,65506},{65507,Sk,65507,65507,65507},{65508,So,65508,65508,65508},{65509,Sc,65509,65509,65509},{65510,Sc,65510,65510,65510},{65512,So,65512,65512,65512},{65513,Sm,65513,65513,65513},{65514,Sm,65514,65514,65514},{65515,Sm,65515,65515,65515},{65516,Sm,65516,65516,65516},{65517,So,65517,65517,65517},{65518,So,65518,65518,65518},{65529,Cf,65529,65529,65529},{65530,Cf,65530,65530,65530},{65531,Cf,65531,65531,65531},{65532,So,65532,65532,65532},{65533,So,65533,65533,65533},{65536,Lo,65536,65536,65536},{65537,Lo,65537,65537,65537},{65538,Lo,65538,65538,65538},{65539,Lo,65539,65539,65539},{65540,Lo,65540,65540,65540},{65541,Lo,65541,65541,65541},{65542,Lo,65542,65542,65542},{65543,Lo,65543,65543,65543},{65544,Lo,65544,65544,65544},{65545,Lo,65545,65545,65545},{65546,Lo,65546,65546,65546},{65547,Lo,65547,65547,65547},{65549,Lo,65549,65549,65549},{65550,Lo,65550,65550,65550},{65551,Lo,65551,65551,65551},{65552,Lo,65552,65552,65552},{65553,Lo,65553,65553,65553},{65554,Lo,65554,65554,65554},{65555,Lo,65555,65555,65555},{65556,Lo,65556,65556,65556},{65557,Lo,65557,65557,65557},{65558,Lo,65558,65558,65558},{65559,Lo,65559,65559,65559},{65560,Lo,65560,65560,65560},{65561,Lo,65561,65561,65561},{65562,Lo,65562,65562,65562},{65563,Lo,65563,65563,65563},{65564,Lo,65564,65564,65564},{65565,Lo,65565,65565,65565},{65566,Lo,65566,65566,65566},{65567,Lo,65567,65567,65567},{65568,Lo,65568,65568,65568},{65569,Lo,65569,65569,65569},{65570,Lo,65570,65570,65570},{65571,Lo,65571,65571,65571},{65572,Lo,65572,65572,65572},{65573,Lo,65573,65573,65573},{65574,Lo,65574,65574,65574},{65576,Lo,65576,65576,65576},{65577,Lo,65577,65577,65577},{65578,Lo,65578,65578,65578},{65579,Lo,65579,65579,65579},{65580,Lo,65580,65580,65580},{65581,Lo,65581,65581,65581},{65582,Lo,65582,65582,65582},{65583,Lo,65583,65583,65583},{65584,Lo,65584,65584,65584},{65585,Lo,65585,65585,65585},{65586,Lo,65586,65586,65586},{65587,Lo,65587,65587,65587},{65588,Lo,65588,65588,65588},{65589,Lo,65589,65589,65589},{65590,Lo,65590,65590,65590},{65591,Lo,65591,65591,65591},{65592,Lo,65592,65592,65592},{65593,Lo,65593,65593,65593},{65594,Lo,65594,65594,65594},{65596,Lo,65596,65596,65596},{65597,Lo,65597,65597,65597},{65599,Lo,65599,65599,65599},{65600,Lo,65600,65600,65600},{65601,Lo,65601,65601,65601},{65602,Lo,65602,65602,65602},{65603,Lo,65603,65603,65603},{65604,Lo,65604,65604,65604},{65605,Lo,65605,65605,65605},{65606,Lo,65606,65606,65606},{65607,Lo,65607,65607,65607},{65608,Lo,65608,65608,65608},{65609,Lo,65609,65609,65609},{65610,Lo,65610,65610,65610},{65611,Lo,65611,65611,65611},{65612,Lo,65612,65612,65612},{65613,Lo,65613,65613,65613},{65616,Lo,65616,65616,65616},{65617,Lo,65617,65617,65617},{65618,Lo,65618,65618,65618},{65619,Lo,65619,65619,65619},{65620,Lo,65620,65620,65620},{65621,Lo,65621,65621,65621},{65622,Lo,65622,65622,65622},{65623,Lo,65623,65623,65623},{65624,Lo,65624,65624,65624},{65625,Lo,65625,65625,65625},{65626,Lo,65626,65626,65626},{65627,Lo,65627,65627,65627},{65628,Lo,65628,65628,65628},{65629,Lo,65629,65629,65629},{65664,Lo,65664,65664,65664},{65665,Lo,65665,65665,65665},{65666,Lo,65666,65666,65666},{65667,Lo,65667,65667,65667},{65668,Lo,65668,65668,65668},{65669,Lo,65669,65669,65669},{65670,Lo,65670,65670,65670},{65671,Lo,65671,65671,65671},{65672,Lo,65672,65672,65672},{65673,Lo,65673,65673,65673},{65674,Lo,65674,65674,65674},{65675,Lo,65675,65675,65675},{65676,Lo,65676,65676,65676},{65677,Lo,65677,65677,65677},{65678,Lo,65678,65678,65678},{65679,Lo,65679,65679,65679},{65680,Lo,65680,65680,65680},{65681,Lo,65681,65681,65681},{65682,Lo,65682,65682,65682},{65683,Lo,65683,65683,65683},{65684,Lo,65684,65684,65684},{65685,Lo,65685,65685,65685},{65686,Lo,65686,65686,65686},{65687,Lo,65687,65687,65687},{65688,Lo,65688,65688,65688},{65689,Lo,65689,65689,65689},{65690,Lo,65690,65690,65690},{65691,Lo,65691,65691,65691},{65692,Lo,65692,65692,65692},{65693,Lo,65693,65693,65693},{65694,Lo,65694,65694,65694},{65695,Lo,65695,65695,65695},{65696,Lo,65696,65696,65696},{65697,Lo,65697,65697,65697},{65698,Lo,65698,65698,65698},{65699,Lo,65699,65699,65699},{65700,Lo,65700,65700,65700},{65701,Lo,65701,65701,65701},{65702,Lo,65702,65702,65702},{65703,Lo,65703,65703,65703},{65704,Lo,65704,65704,65704},{65705,Lo,65705,65705,65705},{65706,Lo,65706,65706,65706},{65707,Lo,65707,65707,65707},{65708,Lo,65708,65708,65708},{65709,Lo,65709,65709,65709},{65710,Lo,65710,65710,65710},{65711,Lo,65711,65711,65711},{65712,Lo,65712,65712,65712},{65713,Lo,65713,65713,65713},{65714,Lo,65714,65714,65714},{65715,Lo,65715,65715,65715},{65716,Lo,65716,65716,65716},{65717,Lo,65717,65717,65717},{65718,Lo,65718,65718,65718},{65719,Lo,65719,65719,65719},{65720,Lo,65720,65720,65720},{65721,Lo,65721,65721,65721},{65722,Lo,65722,65722,65722},{65723,Lo,65723,65723,65723},{65724,Lo,65724,65724,65724},{65725,Lo,65725,65725,65725},{65726,Lo,65726,65726,65726},{65727,Lo,65727,65727,65727},{65728,Lo,65728,65728,65728},{65729,Lo,65729,65729,65729},{65730,Lo,65730,65730,65730},{65731,Lo,65731,65731,65731},{65732,Lo,65732,65732,65732},{65733,Lo,65733,65733,65733},{65734,Lo,65734,65734,65734},{65735,Lo,65735,65735,65735},{65736,Lo,65736,65736,65736},{65737,Lo,65737,65737,65737},{65738,Lo,65738,65738,65738},{65739,Lo,65739,65739,65739},{65740,Lo,65740,65740,65740},{65741,Lo,65741,65741,65741},{65742,Lo,65742,65742,65742},{65743,Lo,65743,65743,65743},{65744,Lo,65744,65744,65744},{65745,Lo,65745,65745,65745},{65746,Lo,65746,65746,65746},{65747,Lo,65747,65747,65747},{65748,Lo,65748,65748,65748},{65749,Lo,65749,65749,65749},{65750,Lo,65750,65750,65750},{65751,Lo,65751,65751,65751},{65752,Lo,65752,65752,65752},{65753,Lo,65753,65753,65753},{65754,Lo,65754,65754,65754},{65755,Lo,65755,65755,65755},{65756,Lo,65756,65756,65756},{65757,Lo,65757,65757,65757},{65758,Lo,65758,65758,65758},{65759,Lo,65759,65759,65759},{65760,Lo,65760,65760,65760},{65761,Lo,65761,65761,65761},{65762,Lo,65762,65762,65762},{65763,Lo,65763,65763,65763},{65764,Lo,65764,65764,65764},{65765,Lo,65765,65765,65765},{65766,Lo,65766,65766,65766},{65767,Lo,65767,65767,65767},{65768,Lo,65768,65768,65768},{65769,Lo,65769,65769,65769},{65770,Lo,65770,65770,65770},{65771,Lo,65771,65771,65771},{65772,Lo,65772,65772,65772},{65773,Lo,65773,65773,65773},{65774,Lo,65774,65774,65774},{65775,Lo,65775,65775,65775},{65776,Lo,65776,65776,65776},{65777,Lo,65777,65777,65777},{65778,Lo,65778,65778,65778},{65779,Lo,65779,65779,65779},{65780,Lo,65780,65780,65780},{65781,Lo,65781,65781,65781},{65782,Lo,65782,65782,65782},{65783,Lo,65783,65783,65783},{65784,Lo,65784,65784,65784},{65785,Lo,65785,65785,65785},{65786,Lo,65786,65786,65786},{65792,Po,65792,65792,65792},{65793,Po,65793,65793,65793},{65794,So,65794,65794,65794},{65799,No,65799,65799,65799},{65800,No,65800,65800,65800},{65801,No,65801,65801,65801},{65802,No,65802,65802,65802},{65803,No,65803,65803,65803},{65804,No,65804,65804,65804},{65805,No,65805,65805,65805},{65806,No,65806,65806,65806},{65807,No,65807,65807,65807},{65808,No,65808,65808,65808},{65809,No,65809,65809,65809},{65810,No,65810,65810,65810},{65811,No,65811,65811,65811},{65812,No,65812,65812,65812},{65813,No,65813,65813,65813},{65814,No,65814,65814,65814},{65815,No,65815,65815,65815},{65816,No,65816,65816,65816},{65817,No,65817,65817,65817},{65818,No,65818,65818,65818},{65819,No,65819,65819,65819},{65820,No,65820,65820,65820},{65821,No,65821,65821,65821},{65822,No,65822,65822,65822},{65823,No,65823,65823,65823},{65824,No,65824,65824,65824},{65825,No,65825,65825,65825},{65826,No,65826,65826,65826},{65827,No,65827,65827,65827},{65828,No,65828,65828,65828},{65829,No,65829,65829,65829},{65830,No,65830,65830,65830},{65831,No,65831,65831,65831},{65832,No,65832,65832,65832},{65833,No,65833,65833,65833},{65834,No,65834,65834,65834},{65835,No,65835,65835,65835},{65836,No,65836,65836,65836},{65837,No,65837,65837,65837},{65838,No,65838,65838,65838},{65839,No,65839,65839,65839},{65840,No,65840,65840,65840},{65841,No,65841,65841,65841},{65842,No,65842,65842,65842},{65843,No,65843,65843,65843},{65847,So,65847,65847,65847},{65848,So,65848,65848,65848},{65849,So,65849,65849,65849},{65850,So,65850,65850,65850},{65851,So,65851,65851,65851},{65852,So,65852,65852,65852},{65853,So,65853,65853,65853},{65854,So,65854,65854,65854},{65855,So,65855,65855,65855},{65856,Nl,65856,65856,65856},{65857,Nl,65857,65857,65857},{65858,Nl,65858,65858,65858},{65859,Nl,65859,65859,65859},{65860,Nl,65860,65860,65860},{65861,Nl,65861,65861,65861},{65862,Nl,65862,65862,65862},{65863,Nl,65863,65863,65863},{65864,Nl,65864,65864,65864},{65865,Nl,65865,65865,65865},{65866,Nl,65866,65866,65866},{65867,Nl,65867,65867,65867},{65868,Nl,65868,65868,65868},{65869,Nl,65869,65869,65869},{65870,Nl,65870,65870,65870},{65871,Nl,65871,65871,65871},{65872,Nl,65872,65872,65872},{65873,Nl,65873,65873,65873},{65874,Nl,65874,65874,65874},{65875,Nl,65875,65875,65875},{65876,Nl,65876,65876,65876},{65877,Nl,65877,65877,65877},{65878,Nl,65878,65878,65878},{65879,Nl,65879,65879,65879},{65880,Nl,65880,65880,65880},{65881,Nl,65881,65881,65881},{65882,Nl,65882,65882,65882},{65883,Nl,65883,65883,65883},{65884,Nl,65884,65884,65884},{65885,Nl,65885,65885,65885},{65886,Nl,65886,65886,65886},{65887,Nl,65887,65887,65887},{65888,Nl,65888,65888,65888},{65889,Nl,65889,65889,65889},{65890,Nl,65890,65890,65890},{65891,Nl,65891,65891,65891},{65892,Nl,65892,65892,65892},{65893,Nl,65893,65893,65893},{65894,Nl,65894,65894,65894},{65895,Nl,65895,65895,65895},{65896,Nl,65896,65896,65896},{65897,Nl,65897,65897,65897},{65898,Nl,65898,65898,65898},{65899,Nl,65899,65899,65899},{65900,Nl,65900,65900,65900},{65901,Nl,65901,65901,65901},{65902,Nl,65902,65902,65902},{65903,Nl,65903,65903,65903},{65904,Nl,65904,65904,65904},{65905,Nl,65905,65905,65905},{65906,Nl,65906,65906,65906},{65907,Nl,65907,65907,65907},{65908,Nl,65908,65908,65908},{65909,No,65909,65909,65909},{65910,No,65910,65910,65910},{65911,No,65911,65911,65911},{65912,No,65912,65912,65912},{65913,So,65913,65913,65913},{65914,So,65914,65914,65914},{65915,So,65915,65915,65915},{65916,So,65916,65916,65916},{65917,So,65917,65917,65917},{65918,So,65918,65918,65918},{65919,So,65919,65919,65919},{65920,So,65920,65920,65920},{65921,So,65921,65921,65921},{65922,So,65922,65922,65922},{65923,So,65923,65923,65923},{65924,So,65924,65924,65924},{65925,So,65925,65925,65925},{65926,So,65926,65926,65926},{65927,So,65927,65927,65927},{65928,So,65928,65928,65928},{65929,So,65929,65929,65929},{65930,No,65930,65930,65930},{66304,Lo,66304,66304,66304},{66305,Lo,66305,66305,66305},{66306,Lo,66306,66306,66306},{66307,Lo,66307,66307,66307},{66308,Lo,66308,66308,66308},{66309,Lo,66309,66309,66309},{66310,Lo,66310,66310,66310},{66311,Lo,66311,66311,66311},{66312,Lo,66312,66312,66312},{66313,Lo,66313,66313,66313},{66314,Lo,66314,66314,66314},{66315,Lo,66315,66315,66315},{66316,Lo,66316,66316,66316},{66317,Lo,66317,66317,66317},{66318,Lo,66318,66318,66318},{66319,Lo,66319,66319,66319},{66320,Lo,66320,66320,66320},{66321,Lo,66321,66321,66321},{66322,Lo,66322,66322,66322},{66323,Lo,66323,66323,66323},{66324,Lo,66324,66324,66324},{66325,Lo,66325,66325,66325},{66326,Lo,66326,66326,66326},{66327,Lo,66327,66327,66327},{66328,Lo,66328,66328,66328},{66329,Lo,66329,66329,66329},{66330,Lo,66330,66330,66330},{66331,Lo,66331,66331,66331},{66332,Lo,66332,66332,66332},{66333,Lo,66333,66333,66333},{66334,Lo,66334,66334,66334},{66336,No,66336,66336,66336},{66337,No,66337,66337,66337},{66338,No,66338,66338,66338},{66339,No,66339,66339,66339},{66352,Lo,66352,66352,66352},{66353,Lo,66353,66353,66353},{66354,Lo,66354,66354,66354},{66355,Lo,66355,66355,66355},{66356,Lo,66356,66356,66356},{66357,Lo,66357,66357,66357},{66358,Lo,66358,66358,66358},{66359,Lo,66359,66359,66359},{66360,Lo,66360,66360,66360},{66361,Lo,66361,66361,66361},{66362,Lo,66362,66362,66362},{66363,Lo,66363,66363,66363},{66364,Lo,66364,66364,66364},{66365,Lo,66365,66365,66365},{66366,Lo,66366,66366,66366},{66367,Lo,66367,66367,66367},{66368,Lo,66368,66368,66368},{66369,Nl,66369,66369,66369},{66370,Lo,66370,66370,66370},{66371,Lo,66371,66371,66371},{66372,Lo,66372,66372,66372},{66373,Lo,66373,66373,66373},{66374,Lo,66374,66374,66374},{66375,Lo,66375,66375,66375},{66376,Lo,66376,66376,66376},{66377,Lo,66377,66377,66377},{66378,Nl,66378,66378,66378},{66432,Lo,66432,66432,66432},{66433,Lo,66433,66433,66433},{66434,Lo,66434,66434,66434},{66435,Lo,66435,66435,66435},{66436,Lo,66436,66436,66436},{66437,Lo,66437,66437,66437},{66438,Lo,66438,66438,66438},{66439,Lo,66439,66439,66439},{66440,Lo,66440,66440,66440},{66441,Lo,66441,66441,66441},{66442,Lo,66442,66442,66442},{66443,Lo,66443,66443,66443},{66444,Lo,66444,66444,66444},{66445,Lo,66445,66445,66445},{66446,Lo,66446,66446,66446},{66447,Lo,66447,66447,66447},{66448,Lo,66448,66448,66448},{66449,Lo,66449,66449,66449},{66450,Lo,66450,66450,66450},{66451,Lo,66451,66451,66451},{66452,Lo,66452,66452,66452},{66453,Lo,66453,66453,66453},{66454,Lo,66454,66454,66454},{66455,Lo,66455,66455,66455},{66456,Lo,66456,66456,66456},{66457,Lo,66457,66457,66457},{66458,Lo,66458,66458,66458},{66459,Lo,66459,66459,66459},{66460,Lo,66460,66460,66460},{66461,Lo,66461,66461,66461},{66463,Po,66463,66463,66463},{66464,Lo,66464,66464,66464},{66465,Lo,66465,66465,66465},{66466,Lo,66466,66466,66466},{66467,Lo,66467,66467,66467},{66468,Lo,66468,66468,66468},{66469,Lo,66469,66469,66469},{66470,Lo,66470,66470,66470},{66471,Lo,66471,66471,66471},{66472,Lo,66472,66472,66472},{66473,Lo,66473,66473,66473},{66474,Lo,66474,66474,66474},{66475,Lo,66475,66475,66475},{66476,Lo,66476,66476,66476},{66477,Lo,66477,66477,66477},{66478,Lo,66478,66478,66478},{66479,Lo,66479,66479,66479},{66480,Lo,66480,66480,66480},{66481,Lo,66481,66481,66481},{66482,Lo,66482,66482,66482},{66483,Lo,66483,66483,66483},{66484,Lo,66484,66484,66484},{66485,Lo,66485,66485,66485},{66486,Lo,66486,66486,66486},{66487,Lo,66487,66487,66487},{66488,Lo,66488,66488,66488},{66489,Lo,66489,66489,66489},{66490,Lo,66490,66490,66490},{66491,Lo,66491,66491,66491},{66492,Lo,66492,66492,66492},{66493,Lo,66493,66493,66493},{66494,Lo,66494,66494,66494},{66495,Lo,66495,66495,66495},{66496,Lo,66496,66496,66496},{66497,Lo,66497,66497,66497},{66498,Lo,66498,66498,66498},{66499,Lo,66499,66499,66499},{66504,Lo,66504,66504,66504},{66505,Lo,66505,66505,66505},{66506,Lo,66506,66506,66506},{66507,Lo,66507,66507,66507},{66508,Lo,66508,66508,66508},{66509,Lo,66509,66509,66509},{66510,Lo,66510,66510,66510},{66511,Lo,66511,66511,66511},{66512,Po,66512,66512,66512},{66513,Nl,66513,66513,66513},{66514,Nl,66514,66514,66514},{66515,Nl,66515,66515,66515},{66516,Nl,66516,66516,66516},{66517,Nl,66517,66517,66517},{66560,Lu,66560,66600,66560},{66561,Lu,66561,66601,66561},{66562,Lu,66562,66602,66562},{66563,Lu,66563,66603,66563},{66564,Lu,66564,66604,66564},{66565,Lu,66565,66605,66565},{66566,Lu,66566,66606,66566},{66567,Lu,66567,66607,66567},{66568,Lu,66568,66608,66568},{66569,Lu,66569,66609,66569},{66570,Lu,66570,66610,66570},{66571,Lu,66571,66611,66571},{66572,Lu,66572,66612,66572},{66573,Lu,66573,66613,66573},{66574,Lu,66574,66614,66574},{66575,Lu,66575,66615,66575},{66576,Lu,66576,66616,66576},{66577,Lu,66577,66617,66577},{66578,Lu,66578,66618,66578},{66579,Lu,66579,66619,66579},{66580,Lu,66580,66620,66580},{66581,Lu,66581,66621,66581},{66582,Lu,66582,66622,66582},{66583,Lu,66583,66623,66583},{66584,Lu,66584,66624,66584},{66585,Lu,66585,66625,66585},{66586,Lu,66586,66626,66586},{66587,Lu,66587,66627,66587},{66588,Lu,66588,66628,66588},{66589,Lu,66589,66629,66589},{66590,Lu,66590,66630,66590},{66591,Lu,66591,66631,66591},{66592,Lu,66592,66632,66592},{66593,Lu,66593,66633,66593},{66594,Lu,66594,66634,66594},{66595,Lu,66595,66635,66595},{66596,Lu,66596,66636,66596},{66597,Lu,66597,66637,66597},{66598,Lu,66598,66638,66598},{66599,Lu,66599,66639,66599},{66600,Ll,66560,66600,66560},{66601,Ll,66561,66601,66561},{66602,Ll,66562,66602,66562},{66603,Ll,66563,66603,66563},{66604,Ll,66564,66604,66564},{66605,Ll,66565,66605,66565},{66606,Ll,66566,66606,66566},{66607,Ll,66567,66607,66567},{66608,Ll,66568,66608,66568},{66609,Ll,66569,66609,66569},{66610,Ll,66570,66610,66570},{66611,Ll,66571,66611,66571},{66612,Ll,66572,66612,66572},{66613,Ll,66573,66613,66573},{66614,Ll,66574,66614,66574},{66615,Ll,66575,66615,66575},{66616,Ll,66576,66616,66576},{66617,Ll,66577,66617,66577},{66618,Ll,66578,66618,66578},{66619,Ll,66579,66619,66579},{66620,Ll,66580,66620,66580},{66621,Ll,66581,66621,66581},{66622,Ll,66582,66622,66582},{66623,Ll,66583,66623,66583},{66624,Ll,66584,66624,66584},{66625,Ll,66585,66625,66585},{66626,Ll,66586,66626,66586},{66627,Ll,66587,66627,66587},{66628,Ll,66588,66628,66588},{66629,Ll,66589,66629,66589},{66630,Ll,66590,66630,66590},{66631,Ll,66591,66631,66591},{66632,Ll,66592,66632,66592},{66633,Ll,66593,66633,66593},{66634,Ll,66594,66634,66594},{66635,Ll,66595,66635,66595},{66636,Ll,66596,66636,66596},{66637,Ll,66597,66637,66597},{66638,Ll,66598,66638,66598},{66639,Ll,66599,66639,66599},{66640,Lo,66640,66640,66640},{66641,Lo,66641,66641,66641},{66642,Lo,66642,66642,66642},{66643,Lo,66643,66643,66643},{66644,Lo,66644,66644,66644},{66645,Lo,66645,66645,66645},{66646,Lo,66646,66646,66646},{66647,Lo,66647,66647,66647},{66648,Lo,66648,66648,66648},{66649,Lo,66649,66649,66649},{66650,Lo,66650,66650,66650},{66651,Lo,66651,66651,66651},{66652,Lo,66652,66652,66652},{66653,Lo,66653,66653,66653},{66654,Lo,66654,66654,66654},{66655,Lo,66655,66655,66655},{66656,Lo,66656,66656,66656},{66657,Lo,66657,66657,66657},{66658,Lo,66658,66658,66658},{66659,Lo,66659,66659,66659},{66660,Lo,66660,66660,66660},{66661,Lo,66661,66661,66661},{66662,Lo,66662,66662,66662},{66663,Lo,66663,66663,66663},{66664,Lo,66664,66664,66664},{66665,Lo,66665,66665,66665},{66666,Lo,66666,66666,66666},{66667,Lo,66667,66667,66667},{66668,Lo,66668,66668,66668},{66669,Lo,66669,66669,66669},{66670,Lo,66670,66670,66670},{66671,Lo,66671,66671,66671},{66672,Lo,66672,66672,66672},{66673,Lo,66673,66673,66673},{66674,Lo,66674,66674,66674},{66675,Lo,66675,66675,66675},{66676,Lo,66676,66676,66676},{66677,Lo,66677,66677,66677},{66678,Lo,66678,66678,66678},{66679,Lo,66679,66679,66679},{66680,Lo,66680,66680,66680},{66681,Lo,66681,66681,66681},{66682,Lo,66682,66682,66682},{66683,Lo,66683,66683,66683},{66684,Lo,66684,66684,66684},{66685,Lo,66685,66685,66685},{66686,Lo,66686,66686,66686},{66687,Lo,66687,66687,66687},{66688,Lo,66688,66688,66688},{66689,Lo,66689,66689,66689},{66690,Lo,66690,66690,66690},{66691,Lo,66691,66691,66691},{66692,Lo,66692,66692,66692},{66693,Lo,66693,66693,66693},{66694,Lo,66694,66694,66694},{66695,Lo,66695,66695,66695},{66696,Lo,66696,66696,66696},{66697,Lo,66697,66697,66697},{66698,Lo,66698,66698,66698},{66699,Lo,66699,66699,66699},{66700,Lo,66700,66700,66700},{66701,Lo,66701,66701,66701},{66702,Lo,66702,66702,66702},{66703,Lo,66703,66703,66703},{66704,Lo,66704,66704,66704},{66705,Lo,66705,66705,66705},{66706,Lo,66706,66706,66706},{66707,Lo,66707,66707,66707},{66708,Lo,66708,66708,66708},{66709,Lo,66709,66709,66709},{66710,Lo,66710,66710,66710},{66711,Lo,66711,66711,66711},{66712,Lo,66712,66712,66712},{66713,Lo,66713,66713,66713},{66714,Lo,66714,66714,66714},{66715,Lo,66715,66715,66715},{66716,Lo,66716,66716,66716},{66717,Lo,66717,66717,66717},{66720,Nd,66720,66720,66720},{66721,Nd,66721,66721,66721},{66722,Nd,66722,66722,66722},{66723,Nd,66723,66723,66723},{66724,Nd,66724,66724,66724},{66725,Nd,66725,66725,66725},{66726,Nd,66726,66726,66726},{66727,Nd,66727,66727,66727},{66728,Nd,66728,66728,66728},{66729,Nd,66729,66729,66729},{67584,Lo,67584,67584,67584},{67585,Lo,67585,67585,67585},{67586,Lo,67586,67586,67586},{67587,Lo,67587,67587,67587},{67588,Lo,67588,67588,67588},{67589,Lo,67589,67589,67589},{67592,Lo,67592,67592,67592},{67594,Lo,67594,67594,67594},{67595,Lo,67595,67595,67595},{67596,Lo,67596,67596,67596},{67597,Lo,67597,67597,67597},{67598,Lo,67598,67598,67598},{67599,Lo,67599,67599,67599},{67600,Lo,67600,67600,67600},{67601,Lo,67601,67601,67601},{67602,Lo,67602,67602,67602},{67603,Lo,67603,67603,67603},{67604,Lo,67604,67604,67604},{67605,Lo,67605,67605,67605},{67606,Lo,67606,67606,67606},{67607,Lo,67607,67607,67607},{67608,Lo,67608,67608,67608},{67609,Lo,67609,67609,67609},{67610,Lo,67610,67610,67610},{67611,Lo,67611,67611,67611},{67612,Lo,67612,67612,67612},{67613,Lo,67613,67613,67613},{67614,Lo,67614,67614,67614},{67615,Lo,67615,67615,67615},{67616,Lo,67616,67616,67616},{67617,Lo,67617,67617,67617},{67618,Lo,67618,67618,67618},{67619,Lo,67619,67619,67619},{67620,Lo,67620,67620,67620},{67621,Lo,67621,67621,67621},{67622,Lo,67622,67622,67622},{67623,Lo,67623,67623,67623},{67624,Lo,67624,67624,67624},{67625,Lo,67625,67625,67625},{67626,Lo,67626,67626,67626},{67627,Lo,67627,67627,67627},{67628,Lo,67628,67628,67628},{67629,Lo,67629,67629,67629},{67630,Lo,67630,67630,67630},{67631,Lo,67631,67631,67631},{67632,Lo,67632,67632,67632},{67633,Lo,67633,67633,67633},{67634,Lo,67634,67634,67634},{67635,Lo,67635,67635,67635},{67636,Lo,67636,67636,67636},{67637,Lo,67637,67637,67637},{67639,Lo,67639,67639,67639},{67640,Lo,67640,67640,67640},{67644,Lo,67644,67644,67644},{67647,Lo,67647,67647,67647},{67840,Lo,67840,67840,67840},{67841,Lo,67841,67841,67841},{67842,Lo,67842,67842,67842},{67843,Lo,67843,67843,67843},{67844,Lo,67844,67844,67844},{67845,Lo,67845,67845,67845},{67846,Lo,67846,67846,67846},{67847,Lo,67847,67847,67847},{67848,Lo,67848,67848,67848},{67849,Lo,67849,67849,67849},{67850,Lo,67850,67850,67850},{67851,Lo,67851,67851,67851},{67852,Lo,67852,67852,67852},{67853,Lo,67853,67853,67853},{67854,Lo,67854,67854,67854},{67855,Lo,67855,67855,67855},{67856,Lo,67856,67856,67856},{67857,Lo,67857,67857,67857},{67858,Lo,67858,67858,67858},{67859,Lo,67859,67859,67859},{67860,Lo,67860,67860,67860},{67861,Lo,67861,67861,67861},{67862,No,67862,67862,67862},{67863,No,67863,67863,67863},{67864,No,67864,67864,67864},{67865,No,67865,67865,67865},{67871,Po,67871,67871,67871},{68096,Lo,68096,68096,68096},{68097,Mn,68097,68097,68097},{68098,Mn,68098,68098,68098},{68099,Mn,68099,68099,68099},{68101,Mn,68101,68101,68101},{68102,Mn,68102,68102,68102},{68108,Mn,68108,68108,68108},{68109,Mn,68109,68109,68109},{68110,Mn,68110,68110,68110},{68111,Mn,68111,68111,68111},{68112,Lo,68112,68112,68112},{68113,Lo,68113,68113,68113},{68114,Lo,68114,68114,68114},{68115,Lo,68115,68115,68115},{68117,Lo,68117,68117,68117},{68118,Lo,68118,68118,68118},{68119,Lo,68119,68119,68119},{68121,Lo,68121,68121,68121},{68122,Lo,68122,68122,68122},{68123,Lo,68123,68123,68123},{68124,Lo,68124,68124,68124},{68125,Lo,68125,68125,68125},{68126,Lo,68126,68126,68126},{68127,Lo,68127,68127,68127},{68128,Lo,68128,68128,68128},{68129,Lo,68129,68129,68129},{68130,Lo,68130,68130,68130},{68131,Lo,68131,68131,68131},{68132,Lo,68132,68132,68132},{68133,Lo,68133,68133,68133},{68134,Lo,68134,68134,68134},{68135,Lo,68135,68135,68135},{68136,Lo,68136,68136,68136},{68137,Lo,68137,68137,68137},{68138,Lo,68138,68138,68138},{68139,Lo,68139,68139,68139},{68140,Lo,68140,68140,68140},{68141,Lo,68141,68141,68141},{68142,Lo,68142,68142,68142},{68143,Lo,68143,68143,68143},{68144,Lo,68144,68144,68144},{68145,Lo,68145,68145,68145},{68146,Lo,68146,68146,68146},{68147,Lo,68147,68147,68147},{68152,Mn,68152,68152,68152},{68153,Mn,68153,68153,68153},{68154,Mn,68154,68154,68154},{68159,Mn,68159,68159,68159},{68160,No,68160,68160,68160},{68161,No,68161,68161,68161},{68162,No,68162,68162,68162},{68163,No,68163,68163,68163},{68164,No,68164,68164,68164},{68165,No,68165,68165,68165},{68166,No,68166,68166,68166},{68167,No,68167,68167,68167},{68176,Po,68176,68176,68176},{68177,Po,68177,68177,68177},{68178,Po,68178,68178,68178},{68179,Po,68179,68179,68179},{68180,Po,68180,68180,68180},{68181,Po,68181,68181,68181},{68182,Po,68182,68182,68182},{68183,Po,68183,68183,68183},{68184,Po,68184,68184,68184},{73728,Lo,73728,73728,73728},{73729,Lo,73729,73729,73729},{73730,Lo,73730,73730,73730},{73731,Lo,73731,73731,73731},{73732,Lo,73732,73732,73732},{73733,Lo,73733,73733,73733},{73734,Lo,73734,73734,73734},{73735,Lo,73735,73735,73735},{73736,Lo,73736,73736,73736},{73737,Lo,73737,73737,73737},{73738,Lo,73738,73738,73738},{73739,Lo,73739,73739,73739},{73740,Lo,73740,73740,73740},{73741,Lo,73741,73741,73741},{73742,Lo,73742,73742,73742},{73743,Lo,73743,73743,73743},{73744,Lo,73744,73744,73744},{73745,Lo,73745,73745,73745},{73746,Lo,73746,73746,73746},{73747,Lo,73747,73747,73747},{73748,Lo,73748,73748,73748},{73749,Lo,73749,73749,73749},{73750,Lo,73750,73750,73750},{73751,Lo,73751,73751,73751},{73752,Lo,73752,73752,73752},{73753,Lo,73753,73753,73753},{73754,Lo,73754,73754,73754},{73755,Lo,73755,73755,73755},{73756,Lo,73756,73756,73756},{73757,Lo,73757,73757,73757},{73758,Lo,73758,73758,73758},{73759,Lo,73759,73759,73759},{73760,Lo,73760,73760,73760},{73761,Lo,73761,73761,73761},{73762,Lo,73762,73762,73762},{73763,Lo,73763,73763,73763},{73764,Lo,73764,73764,73764},{73765,Lo,73765,73765,73765},{73766,Lo,73766,73766,73766},{73767,Lo,73767,73767,73767},{73768,Lo,73768,73768,73768},{73769,Lo,73769,73769,73769},{73770,Lo,73770,73770,73770},{73771,Lo,73771,73771,73771},{73772,Lo,73772,73772,73772},{73773,Lo,73773,73773,73773},{73774,Lo,73774,73774,73774},{73775,Lo,73775,73775,73775},{73776,Lo,73776,73776,73776},{73777,Lo,73777,73777,73777},{73778,Lo,73778,73778,73778},{73779,Lo,73779,73779,73779},{73780,Lo,73780,73780,73780},{73781,Lo,73781,73781,73781},{73782,Lo,73782,73782,73782},{73783,Lo,73783,73783,73783},{73784,Lo,73784,73784,73784},{73785,Lo,73785,73785,73785},{73786,Lo,73786,73786,73786},{73787,Lo,73787,73787,73787},{73788,Lo,73788,73788,73788},{73789,Lo,73789,73789,73789},{73790,Lo,73790,73790,73790},{73791,Lo,73791,73791,73791},{73792,Lo,73792,73792,73792},{73793,Lo,73793,73793,73793},{73794,Lo,73794,73794,73794},{73795,Lo,73795,73795,73795},{73796,Lo,73796,73796,73796},{73797,Lo,73797,73797,73797},{73798,Lo,73798,73798,73798},{73799,Lo,73799,73799,73799},{73800,Lo,73800,73800,73800},{73801,Lo,73801,73801,73801},{73802,Lo,73802,73802,73802},{73803,Lo,73803,73803,73803},{73804,Lo,73804,73804,73804},{73805,Lo,73805,73805,73805},{73806,Lo,73806,73806,73806},{73807,Lo,73807,73807,73807},{73808,Lo,73808,73808,73808},{73809,Lo,73809,73809,73809},{73810,Lo,73810,73810,73810},{73811,Lo,73811,73811,73811},{73812,Lo,73812,73812,73812},{73813,Lo,73813,73813,73813},{73814,Lo,73814,73814,73814},{73815,Lo,73815,73815,73815},{73816,Lo,73816,73816,73816},{73817,Lo,73817,73817,73817},{73818,Lo,73818,73818,73818},{73819,Lo,73819,73819,73819},{73820,Lo,73820,73820,73820},{73821,Lo,73821,73821,73821},{73822,Lo,73822,73822,73822},{73823,Lo,73823,73823,73823},{73824,Lo,73824,73824,73824},{73825,Lo,73825,73825,73825},{73826,Lo,73826,73826,73826},{73827,Lo,73827,73827,73827},{73828,Lo,73828,73828,73828},{73829,Lo,73829,73829,73829},{73830,Lo,73830,73830,73830},{73831,Lo,73831,73831,73831},{73832,Lo,73832,73832,73832},{73833,Lo,73833,73833,73833},{73834,Lo,73834,73834,73834},{73835,Lo,73835,73835,73835},{73836,Lo,73836,73836,73836},{73837,Lo,73837,73837,73837},{73838,Lo,73838,73838,73838},{73839,Lo,73839,73839,73839},{73840,Lo,73840,73840,73840},{73841,Lo,73841,73841,73841},{73842,Lo,73842,73842,73842},{73843,Lo,73843,73843,73843},{73844,Lo,73844,73844,73844},{73845,Lo,73845,73845,73845},{73846,Lo,73846,73846,73846},{73847,Lo,73847,73847,73847},{73848,Lo,73848,73848,73848},{73849,Lo,73849,73849,73849},{73850,Lo,73850,73850,73850},{73851,Lo,73851,73851,73851},{73852,Lo,73852,73852,73852},{73853,Lo,73853,73853,73853},{73854,Lo,73854,73854,73854},{73855,Lo,73855,73855,73855},{73856,Lo,73856,73856,73856},{73857,Lo,73857,73857,73857},{73858,Lo,73858,73858,73858},{73859,Lo,73859,73859,73859},{73860,Lo,73860,73860,73860},{73861,Lo,73861,73861,73861},{73862,Lo,73862,73862,73862},{73863,Lo,73863,73863,73863},{73864,Lo,73864,73864,73864},{73865,Lo,73865,73865,73865},{73866,Lo,73866,73866,73866},{73867,Lo,73867,73867,73867},{73868,Lo,73868,73868,73868},{73869,Lo,73869,73869,73869},{73870,Lo,73870,73870,73870},{73871,Lo,73871,73871,73871},{73872,Lo,73872,73872,73872},{73873,Lo,73873,73873,73873},{73874,Lo,73874,73874,73874},{73875,Lo,73875,73875,73875},{73876,Lo,73876,73876,73876},{73877,Lo,73877,73877,73877},{73878,Lo,73878,73878,73878},{73879,Lo,73879,73879,73879},{73880,Lo,73880,73880,73880},{73881,Lo,73881,73881,73881},{73882,Lo,73882,73882,73882},{73883,Lo,73883,73883,73883},{73884,Lo,73884,73884,73884},{73885,Lo,73885,73885,73885},{73886,Lo,73886,73886,73886},{73887,Lo,73887,73887,73887},{73888,Lo,73888,73888,73888},{73889,Lo,73889,73889,73889},{73890,Lo,73890,73890,73890},{73891,Lo,73891,73891,73891},{73892,Lo,73892,73892,73892},{73893,Lo,73893,73893,73893},{73894,Lo,73894,73894,73894},{73895,Lo,73895,73895,73895},{73896,Lo,73896,73896,73896},{73897,Lo,73897,73897,73897},{73898,Lo,73898,73898,73898},{73899,Lo,73899,73899,73899},{73900,Lo,73900,73900,73900},{73901,Lo,73901,73901,73901},{73902,Lo,73902,73902,73902},{73903,Lo,73903,73903,73903},{73904,Lo,73904,73904,73904},{73905,Lo,73905,73905,73905},{73906,Lo,73906,73906,73906},{73907,Lo,73907,73907,73907},{73908,Lo,73908,73908,73908},{73909,Lo,73909,73909,73909},{73910,Lo,73910,73910,73910},{73911,Lo,73911,73911,73911},{73912,Lo,73912,73912,73912},{73913,Lo,73913,73913,73913},{73914,Lo,73914,73914,73914},{73915,Lo,73915,73915,73915},{73916,Lo,73916,73916,73916},{73917,Lo,73917,73917,73917},{73918,Lo,73918,73918,73918},{73919,Lo,73919,73919,73919},{73920,Lo,73920,73920,73920},{73921,Lo,73921,73921,73921},{73922,Lo,73922,73922,73922},{73923,Lo,73923,73923,73923},{73924,Lo,73924,73924,73924},{73925,Lo,73925,73925,73925},{73926,Lo,73926,73926,73926},{73927,Lo,73927,73927,73927},{73928,Lo,73928,73928,73928},{73929,Lo,73929,73929,73929},{73930,Lo,73930,73930,73930},{73931,Lo,73931,73931,73931},{73932,Lo,73932,73932,73932},{73933,Lo,73933,73933,73933},{73934,Lo,73934,73934,73934},{73935,Lo,73935,73935,73935},{73936,Lo,73936,73936,73936},{73937,Lo,73937,73937,73937},{73938,Lo,73938,73938,73938},{73939,Lo,73939,73939,73939},{73940,Lo,73940,73940,73940},{73941,Lo,73941,73941,73941},{73942,Lo,73942,73942,73942},{73943,Lo,73943,73943,73943},{73944,Lo,73944,73944,73944},{73945,Lo,73945,73945,73945},{73946,Lo,73946,73946,73946},{73947,Lo,73947,73947,73947},{73948,Lo,73948,73948,73948},{73949,Lo,73949,73949,73949},{73950,Lo,73950,73950,73950},{73951,Lo,73951,73951,73951},{73952,Lo,73952,73952,73952},{73953,Lo,73953,73953,73953},{73954,Lo,73954,73954,73954},{73955,Lo,73955,73955,73955},{73956,Lo,73956,73956,73956},{73957,Lo,73957,73957,73957},{73958,Lo,73958,73958,73958},{73959,Lo,73959,73959,73959},{73960,Lo,73960,73960,73960},{73961,Lo,73961,73961,73961},{73962,Lo,73962,73962,73962},{73963,Lo,73963,73963,73963},{73964,Lo,73964,73964,73964},{73965,Lo,73965,73965,73965},{73966,Lo,73966,73966,73966},{73967,Lo,73967,73967,73967},{73968,Lo,73968,73968,73968},{73969,Lo,73969,73969,73969},{73970,Lo,73970,73970,73970},{73971,Lo,73971,73971,73971},{73972,Lo,73972,73972,73972},{73973,Lo,73973,73973,73973},{73974,Lo,73974,73974,73974},{73975,Lo,73975,73975,73975},{73976,Lo,73976,73976,73976},{73977,Lo,73977,73977,73977},{73978,Lo,73978,73978,73978},{73979,Lo,73979,73979,73979},{73980,Lo,73980,73980,73980},{73981,Lo,73981,73981,73981},{73982,Lo,73982,73982,73982},{73983,Lo,73983,73983,73983},{73984,Lo,73984,73984,73984},{73985,Lo,73985,73985,73985},{73986,Lo,73986,73986,73986},{73987,Lo,73987,73987,73987},{73988,Lo,73988,73988,73988},{73989,Lo,73989,73989,73989},{73990,Lo,73990,73990,73990},{73991,Lo,73991,73991,73991},{73992,Lo,73992,73992,73992},{73993,Lo,73993,73993,73993},{73994,Lo,73994,73994,73994},{73995,Lo,73995,73995,73995},{73996,Lo,73996,73996,73996},{73997,Lo,73997,73997,73997},{73998,Lo,73998,73998,73998},{73999,Lo,73999,73999,73999},{74000,Lo,74000,74000,74000},{74001,Lo,74001,74001,74001},{74002,Lo,74002,74002,74002},{74003,Lo,74003,74003,74003},{74004,Lo,74004,74004,74004},{74005,Lo,74005,74005,74005},{74006,Lo,74006,74006,74006},{74007,Lo,74007,74007,74007},{74008,Lo,74008,74008,74008},{74009,Lo,74009,74009,74009},{74010,Lo,74010,74010,74010},{74011,Lo,74011,74011,74011},{74012,Lo,74012,74012,74012},{74013,Lo,74013,74013,74013},{74014,Lo,74014,74014,74014},{74015,Lo,74015,74015,74015},{74016,Lo,74016,74016,74016},{74017,Lo,74017,74017,74017},{74018,Lo,74018,74018,74018},{74019,Lo,74019,74019,74019},{74020,Lo,74020,74020,74020},{74021,Lo,74021,74021,74021},{74022,Lo,74022,74022,74022},{74023,Lo,74023,74023,74023},{74024,Lo,74024,74024,74024},{74025,Lo,74025,74025,74025},{74026,Lo,74026,74026,74026},{74027,Lo,74027,74027,74027},{74028,Lo,74028,74028,74028},{74029,Lo,74029,74029,74029},{74030,Lo,74030,74030,74030},{74031,Lo,74031,74031,74031},{74032,Lo,74032,74032,74032},{74033,Lo,74033,74033,74033},{74034,Lo,74034,74034,74034},{74035,Lo,74035,74035,74035},{74036,Lo,74036,74036,74036},{74037,Lo,74037,74037,74037},{74038,Lo,74038,74038,74038},{74039,Lo,74039,74039,74039},{74040,Lo,74040,74040,74040},{74041,Lo,74041,74041,74041},{74042,Lo,74042,74042,74042},{74043,Lo,74043,74043,74043},{74044,Lo,74044,74044,74044},{74045,Lo,74045,74045,74045},{74046,Lo,74046,74046,74046},{74047,Lo,74047,74047,74047},{74048,Lo,74048,74048,74048},{74049,Lo,74049,74049,74049},{74050,Lo,74050,74050,74050},{74051,Lo,74051,74051,74051},{74052,Lo,74052,74052,74052},{74053,Lo,74053,74053,74053},{74054,Lo,74054,74054,74054},{74055,Lo,74055,74055,74055},{74056,Lo,74056,74056,74056},{74057,Lo,74057,74057,74057},{74058,Lo,74058,74058,74058},{74059,Lo,74059,74059,74059},{74060,Lo,74060,74060,74060},{74061,Lo,74061,74061,74061},{74062,Lo,74062,74062,74062},{74063,Lo,74063,74063,74063},{74064,Lo,74064,74064,74064},{74065,Lo,74065,74065,74065},{74066,Lo,74066,74066,74066},{74067,Lo,74067,74067,74067},{74068,Lo,74068,74068,74068},{74069,Lo,74069,74069,74069},{74070,Lo,74070,74070,74070},{74071,Lo,74071,74071,74071},{74072,Lo,74072,74072,74072},{74073,Lo,74073,74073,74073},{74074,Lo,74074,74074,74074},{74075,Lo,74075,74075,74075},{74076,Lo,74076,74076,74076},{74077,Lo,74077,74077,74077},{74078,Lo,74078,74078,74078},{74079,Lo,74079,74079,74079},{74080,Lo,74080,74080,74080},{74081,Lo,74081,74081,74081},{74082,Lo,74082,74082,74082},{74083,Lo,74083,74083,74083},{74084,Lo,74084,74084,74084},{74085,Lo,74085,74085,74085},{74086,Lo,74086,74086,74086},{74087,Lo,74087,74087,74087},{74088,Lo,74088,74088,74088},{74089,Lo,74089,74089,74089},{74090,Lo,74090,74090,74090},{74091,Lo,74091,74091,74091},{74092,Lo,74092,74092,74092},{74093,Lo,74093,74093,74093},{74094,Lo,74094,74094,74094},{74095,Lo,74095,74095,74095},{74096,Lo,74096,74096,74096},{74097,Lo,74097,74097,74097},{74098,Lo,74098,74098,74098},{74099,Lo,74099,74099,74099},{74100,Lo,74100,74100,74100},{74101,Lo,74101,74101,74101},{74102,Lo,74102,74102,74102},{74103,Lo,74103,74103,74103},{74104,Lo,74104,74104,74104},{74105,Lo,74105,74105,74105},{74106,Lo,74106,74106,74106},{74107,Lo,74107,74107,74107},{74108,Lo,74108,74108,74108},{74109,Lo,74109,74109,74109},{74110,Lo,74110,74110,74110},{74111,Lo,74111,74111,74111},{74112,Lo,74112,74112,74112},{74113,Lo,74113,74113,74113},{74114,Lo,74114,74114,74114},{74115,Lo,74115,74115,74115},{74116,Lo,74116,74116,74116},{74117,Lo,74117,74117,74117},{74118,Lo,74118,74118,74118},{74119,Lo,74119,74119,74119},{74120,Lo,74120,74120,74120},{74121,Lo,74121,74121,74121},{74122,Lo,74122,74122,74122},{74123,Lo,74123,74123,74123},{74124,Lo,74124,74124,74124},{74125,Lo,74125,74125,74125},{74126,Lo,74126,74126,74126},{74127,Lo,74127,74127,74127},{74128,Lo,74128,74128,74128},{74129,Lo,74129,74129,74129},{74130,Lo,74130,74130,74130},{74131,Lo,74131,74131,74131},{74132,Lo,74132,74132,74132},{74133,Lo,74133,74133,74133},{74134,Lo,74134,74134,74134},{74135,Lo,74135,74135,74135},{74136,Lo,74136,74136,74136},{74137,Lo,74137,74137,74137},{74138,Lo,74138,74138,74138},{74139,Lo,74139,74139,74139},{74140,Lo,74140,74140,74140},{74141,Lo,74141,74141,74141},{74142,Lo,74142,74142,74142},{74143,Lo,74143,74143,74143},{74144,Lo,74144,74144,74144},{74145,Lo,74145,74145,74145},{74146,Lo,74146,74146,74146},{74147,Lo,74147,74147,74147},{74148,Lo,74148,74148,74148},{74149,Lo,74149,74149,74149},{74150,Lo,74150,74150,74150},{74151,Lo,74151,74151,74151},{74152,Lo,74152,74152,74152},{74153,Lo,74153,74153,74153},{74154,Lo,74154,74154,74154},{74155,Lo,74155,74155,74155},{74156,Lo,74156,74156,74156},{74157,Lo,74157,74157,74157},{74158,Lo,74158,74158,74158},{74159,Lo,74159,74159,74159},{74160,Lo,74160,74160,74160},{74161,Lo,74161,74161,74161},{74162,Lo,74162,74162,74162},{74163,Lo,74163,74163,74163},{74164,Lo,74164,74164,74164},{74165,Lo,74165,74165,74165},{74166,Lo,74166,74166,74166},{74167,Lo,74167,74167,74167},{74168,Lo,74168,74168,74168},{74169,Lo,74169,74169,74169},{74170,Lo,74170,74170,74170},{74171,Lo,74171,74171,74171},{74172,Lo,74172,74172,74172},{74173,Lo,74173,74173,74173},{74174,Lo,74174,74174,74174},{74175,Lo,74175,74175,74175},{74176,Lo,74176,74176,74176},{74177,Lo,74177,74177,74177},{74178,Lo,74178,74178,74178},{74179,Lo,74179,74179,74179},{74180,Lo,74180,74180,74180},{74181,Lo,74181,74181,74181},{74182,Lo,74182,74182,74182},{74183,Lo,74183,74183,74183},{74184,Lo,74184,74184,74184},{74185,Lo,74185,74185,74185},{74186,Lo,74186,74186,74186},{74187,Lo,74187,74187,74187},{74188,Lo,74188,74188,74188},{74189,Lo,74189,74189,74189},{74190,Lo,74190,74190,74190},{74191,Lo,74191,74191,74191},{74192,Lo,74192,74192,74192},{74193,Lo,74193,74193,74193},{74194,Lo,74194,74194,74194},{74195,Lo,74195,74195,74195},{74196,Lo,74196,74196,74196},{74197,Lo,74197,74197,74197},{74198,Lo,74198,74198,74198},{74199,Lo,74199,74199,74199},{74200,Lo,74200,74200,74200},{74201,Lo,74201,74201,74201},{74202,Lo,74202,74202,74202},{74203,Lo,74203,74203,74203},{74204,Lo,74204,74204,74204},{74205,Lo,74205,74205,74205},{74206,Lo,74206,74206,74206},{74207,Lo,74207,74207,74207},{74208,Lo,74208,74208,74208},{74209,Lo,74209,74209,74209},{74210,Lo,74210,74210,74210},{74211,Lo,74211,74211,74211},{74212,Lo,74212,74212,74212},{74213,Lo,74213,74213,74213},{74214,Lo,74214,74214,74214},{74215,Lo,74215,74215,74215},{74216,Lo,74216,74216,74216},{74217,Lo,74217,74217,74217},{74218,Lo,74218,74218,74218},{74219,Lo,74219,74219,74219},{74220,Lo,74220,74220,74220},{74221,Lo,74221,74221,74221},{74222,Lo,74222,74222,74222},{74223,Lo,74223,74223,74223},{74224,Lo,74224,74224,74224},{74225,Lo,74225,74225,74225},{74226,Lo,74226,74226,74226},{74227,Lo,74227,74227,74227},{74228,Lo,74228,74228,74228},{74229,Lo,74229,74229,74229},{74230,Lo,74230,74230,74230},{74231,Lo,74231,74231,74231},{74232,Lo,74232,74232,74232},{74233,Lo,74233,74233,74233},{74234,Lo,74234,74234,74234},{74235,Lo,74235,74235,74235},{74236,Lo,74236,74236,74236},{74237,Lo,74237,74237,74237},{74238,Lo,74238,74238,74238},{74239,Lo,74239,74239,74239},{74240,Lo,74240,74240,74240},{74241,Lo,74241,74241,74241},{74242,Lo,74242,74242,74242},{74243,Lo,74243,74243,74243},{74244,Lo,74244,74244,74244},{74245,Lo,74245,74245,74245},{74246,Lo,74246,74246,74246},{74247,Lo,74247,74247,74247},{74248,Lo,74248,74248,74248},{74249,Lo,74249,74249,74249},{74250,Lo,74250,74250,74250},{74251,Lo,74251,74251,74251},{74252,Lo,74252,74252,74252},{74253,Lo,74253,74253,74253},{74254,Lo,74254,74254,74254},{74255,Lo,74255,74255,74255},{74256,Lo,74256,74256,74256},{74257,Lo,74257,74257,74257},{74258,Lo,74258,74258,74258},{74259,Lo,74259,74259,74259},{74260,Lo,74260,74260,74260},{74261,Lo,74261,74261,74261},{74262,Lo,74262,74262,74262},{74263,Lo,74263,74263,74263},{74264,Lo,74264,74264,74264},{74265,Lo,74265,74265,74265},{74266,Lo,74266,74266,74266},{74267,Lo,74267,74267,74267},{74268,Lo,74268,74268,74268},{74269,Lo,74269,74269,74269},{74270,Lo,74270,74270,74270},{74271,Lo,74271,74271,74271},{74272,Lo,74272,74272,74272},{74273,Lo,74273,74273,74273},{74274,Lo,74274,74274,74274},{74275,Lo,74275,74275,74275},{74276,Lo,74276,74276,74276},{74277,Lo,74277,74277,74277},{74278,Lo,74278,74278,74278},{74279,Lo,74279,74279,74279},{74280,Lo,74280,74280,74280},{74281,Lo,74281,74281,74281},{74282,Lo,74282,74282,74282},{74283,Lo,74283,74283,74283},{74284,Lo,74284,74284,74284},{74285,Lo,74285,74285,74285},{74286,Lo,74286,74286,74286},{74287,Lo,74287,74287,74287},{74288,Lo,74288,74288,74288},{74289,Lo,74289,74289,74289},{74290,Lo,74290,74290,74290},{74291,Lo,74291,74291,74291},{74292,Lo,74292,74292,74292},{74293,Lo,74293,74293,74293},{74294,Lo,74294,74294,74294},{74295,Lo,74295,74295,74295},{74296,Lo,74296,74296,74296},{74297,Lo,74297,74297,74297},{74298,Lo,74298,74298,74298},{74299,Lo,74299,74299,74299},{74300,Lo,74300,74300,74300},{74301,Lo,74301,74301,74301},{74302,Lo,74302,74302,74302},{74303,Lo,74303,74303,74303},{74304,Lo,74304,74304,74304},{74305,Lo,74305,74305,74305},{74306,Lo,74306,74306,74306},{74307,Lo,74307,74307,74307},{74308,Lo,74308,74308,74308},{74309,Lo,74309,74309,74309},{74310,Lo,74310,74310,74310},{74311,Lo,74311,74311,74311},{74312,Lo,74312,74312,74312},{74313,Lo,74313,74313,74313},{74314,Lo,74314,74314,74314},{74315,Lo,74315,74315,74315},{74316,Lo,74316,74316,74316},{74317,Lo,74317,74317,74317},{74318,Lo,74318,74318,74318},{74319,Lo,74319,74319,74319},{74320,Lo,74320,74320,74320},{74321,Lo,74321,74321,74321},{74322,Lo,74322,74322,74322},{74323,Lo,74323,74323,74323},{74324,Lo,74324,74324,74324},{74325,Lo,74325,74325,74325},{74326,Lo,74326,74326,74326},{74327,Lo,74327,74327,74327},{74328,Lo,74328,74328,74328},{74329,Lo,74329,74329,74329},{74330,Lo,74330,74330,74330},{74331,Lo,74331,74331,74331},{74332,Lo,74332,74332,74332},{74333,Lo,74333,74333,74333},{74334,Lo,74334,74334,74334},{74335,Lo,74335,74335,74335},{74336,Lo,74336,74336,74336},{74337,Lo,74337,74337,74337},{74338,Lo,74338,74338,74338},{74339,Lo,74339,74339,74339},{74340,Lo,74340,74340,74340},{74341,Lo,74341,74341,74341},{74342,Lo,74342,74342,74342},{74343,Lo,74343,74343,74343},{74344,Lo,74344,74344,74344},{74345,Lo,74345,74345,74345},{74346,Lo,74346,74346,74346},{74347,Lo,74347,74347,74347},{74348,Lo,74348,74348,74348},{74349,Lo,74349,74349,74349},{74350,Lo,74350,74350,74350},{74351,Lo,74351,74351,74351},{74352,Lo,74352,74352,74352},{74353,Lo,74353,74353,74353},{74354,Lo,74354,74354,74354},{74355,Lo,74355,74355,74355},{74356,Lo,74356,74356,74356},{74357,Lo,74357,74357,74357},{74358,Lo,74358,74358,74358},{74359,Lo,74359,74359,74359},{74360,Lo,74360,74360,74360},{74361,Lo,74361,74361,74361},{74362,Lo,74362,74362,74362},{74363,Lo,74363,74363,74363},{74364,Lo,74364,74364,74364},{74365,Lo,74365,74365,74365},{74366,Lo,74366,74366,74366},{74367,Lo,74367,74367,74367},{74368,Lo,74368,74368,74368},{74369,Lo,74369,74369,74369},{74370,Lo,74370,74370,74370},{74371,Lo,74371,74371,74371},{74372,Lo,74372,74372,74372},{74373,Lo,74373,74373,74373},{74374,Lo,74374,74374,74374},{74375,Lo,74375,74375,74375},{74376,Lo,74376,74376,74376},{74377,Lo,74377,74377,74377},{74378,Lo,74378,74378,74378},{74379,Lo,74379,74379,74379},{74380,Lo,74380,74380,74380},{74381,Lo,74381,74381,74381},{74382,Lo,74382,74382,74382},{74383,Lo,74383,74383,74383},{74384,Lo,74384,74384,74384},{74385,Lo,74385,74385,74385},{74386,Lo,74386,74386,74386},{74387,Lo,74387,74387,74387},{74388,Lo,74388,74388,74388},{74389,Lo,74389,74389,74389},{74390,Lo,74390,74390,74390},{74391,Lo,74391,74391,74391},{74392,Lo,74392,74392,74392},{74393,Lo,74393,74393,74393},{74394,Lo,74394,74394,74394},{74395,Lo,74395,74395,74395},{74396,Lo,74396,74396,74396},{74397,Lo,74397,74397,74397},{74398,Lo,74398,74398,74398},{74399,Lo,74399,74399,74399},{74400,Lo,74400,74400,74400},{74401,Lo,74401,74401,74401},{74402,Lo,74402,74402,74402},{74403,Lo,74403,74403,74403},{74404,Lo,74404,74404,74404},{74405,Lo,74405,74405,74405},{74406,Lo,74406,74406,74406},{74407,Lo,74407,74407,74407},{74408,Lo,74408,74408,74408},{74409,Lo,74409,74409,74409},{74410,Lo,74410,74410,74410},{74411,Lo,74411,74411,74411},{74412,Lo,74412,74412,74412},{74413,Lo,74413,74413,74413},{74414,Lo,74414,74414,74414},{74415,Lo,74415,74415,74415},{74416,Lo,74416,74416,74416},{74417,Lo,74417,74417,74417},{74418,Lo,74418,74418,74418},{74419,Lo,74419,74419,74419},{74420,Lo,74420,74420,74420},{74421,Lo,74421,74421,74421},{74422,Lo,74422,74422,74422},{74423,Lo,74423,74423,74423},{74424,Lo,74424,74424,74424},{74425,Lo,74425,74425,74425},{74426,Lo,74426,74426,74426},{74427,Lo,74427,74427,74427},{74428,Lo,74428,74428,74428},{74429,Lo,74429,74429,74429},{74430,Lo,74430,74430,74430},{74431,Lo,74431,74431,74431},{74432,Lo,74432,74432,74432},{74433,Lo,74433,74433,74433},{74434,Lo,74434,74434,74434},{74435,Lo,74435,74435,74435},{74436,Lo,74436,74436,74436},{74437,Lo,74437,74437,74437},{74438,Lo,74438,74438,74438},{74439,Lo,74439,74439,74439},{74440,Lo,74440,74440,74440},{74441,Lo,74441,74441,74441},{74442,Lo,74442,74442,74442},{74443,Lo,74443,74443,74443},{74444,Lo,74444,74444,74444},{74445,Lo,74445,74445,74445},{74446,Lo,74446,74446,74446},{74447,Lo,74447,74447,74447},{74448,Lo,74448,74448,74448},{74449,Lo,74449,74449,74449},{74450,Lo,74450,74450,74450},{74451,Lo,74451,74451,74451},{74452,Lo,74452,74452,74452},{74453,Lo,74453,74453,74453},{74454,Lo,74454,74454,74454},{74455,Lo,74455,74455,74455},{74456,Lo,74456,74456,74456},{74457,Lo,74457,74457,74457},{74458,Lo,74458,74458,74458},{74459,Lo,74459,74459,74459},{74460,Lo,74460,74460,74460},{74461,Lo,74461,74461,74461},{74462,Lo,74462,74462,74462},{74463,Lo,74463,74463,74463},{74464,Lo,74464,74464,74464},{74465,Lo,74465,74465,74465},{74466,Lo,74466,74466,74466},{74467,Lo,74467,74467,74467},{74468,Lo,74468,74468,74468},{74469,Lo,74469,74469,74469},{74470,Lo,74470,74470,74470},{74471,Lo,74471,74471,74471},{74472,Lo,74472,74472,74472},{74473,Lo,74473,74473,74473},{74474,Lo,74474,74474,74474},{74475,Lo,74475,74475,74475},{74476,Lo,74476,74476,74476},{74477,Lo,74477,74477,74477},{74478,Lo,74478,74478,74478},{74479,Lo,74479,74479,74479},{74480,Lo,74480,74480,74480},{74481,Lo,74481,74481,74481},{74482,Lo,74482,74482,74482},{74483,Lo,74483,74483,74483},{74484,Lo,74484,74484,74484},{74485,Lo,74485,74485,74485},{74486,Lo,74486,74486,74486},{74487,Lo,74487,74487,74487},{74488,Lo,74488,74488,74488},{74489,Lo,74489,74489,74489},{74490,Lo,74490,74490,74490},{74491,Lo,74491,74491,74491},{74492,Lo,74492,74492,74492},{74493,Lo,74493,74493,74493},{74494,Lo,74494,74494,74494},{74495,Lo,74495,74495,74495},{74496,Lo,74496,74496,74496},{74497,Lo,74497,74497,74497},{74498,Lo,74498,74498,74498},{74499,Lo,74499,74499,74499},{74500,Lo,74500,74500,74500},{74501,Lo,74501,74501,74501},{74502,Lo,74502,74502,74502},{74503,Lo,74503,74503,74503},{74504,Lo,74504,74504,74504},{74505,Lo,74505,74505,74505},{74506,Lo,74506,74506,74506},{74507,Lo,74507,74507,74507},{74508,Lo,74508,74508,74508},{74509,Lo,74509,74509,74509},{74510,Lo,74510,74510,74510},{74511,Lo,74511,74511,74511},{74512,Lo,74512,74512,74512},{74513,Lo,74513,74513,74513},{74514,Lo,74514,74514,74514},{74515,Lo,74515,74515,74515},{74516,Lo,74516,74516,74516},{74517,Lo,74517,74517,74517},{74518,Lo,74518,74518,74518},{74519,Lo,74519,74519,74519},{74520,Lo,74520,74520,74520},{74521,Lo,74521,74521,74521},{74522,Lo,74522,74522,74522},{74523,Lo,74523,74523,74523},{74524,Lo,74524,74524,74524},{74525,Lo,74525,74525,74525},{74526,Lo,74526,74526,74526},{74527,Lo,74527,74527,74527},{74528,Lo,74528,74528,74528},{74529,Lo,74529,74529,74529},{74530,Lo,74530,74530,74530},{74531,Lo,74531,74531,74531},{74532,Lo,74532,74532,74532},{74533,Lo,74533,74533,74533},{74534,Lo,74534,74534,74534},{74535,Lo,74535,74535,74535},{74536,Lo,74536,74536,74536},{74537,Lo,74537,74537,74537},{74538,Lo,74538,74538,74538},{74539,Lo,74539,74539,74539},{74540,Lo,74540,74540,74540},{74541,Lo,74541,74541,74541},{74542,Lo,74542,74542,74542},{74543,Lo,74543,74543,74543},{74544,Lo,74544,74544,74544},{74545,Lo,74545,74545,74545},{74546,Lo,74546,74546,74546},{74547,Lo,74547,74547,74547},{74548,Lo,74548,74548,74548},{74549,Lo,74549,74549,74549},{74550,Lo,74550,74550,74550},{74551,Lo,74551,74551,74551},{74552,Lo,74552,74552,74552},{74553,Lo,74553,74553,74553},{74554,Lo,74554,74554,74554},{74555,Lo,74555,74555,74555},{74556,Lo,74556,74556,74556},{74557,Lo,74557,74557,74557},{74558,Lo,74558,74558,74558},{74559,Lo,74559,74559,74559},{74560,Lo,74560,74560,74560},{74561,Lo,74561,74561,74561},{74562,Lo,74562,74562,74562},{74563,Lo,74563,74563,74563},{74564,Lo,74564,74564,74564},{74565,Lo,74565,74565,74565},{74566,Lo,74566,74566,74566},{74567,Lo,74567,74567,74567},{74568,Lo,74568,74568,74568},{74569,Lo,74569,74569,74569},{74570,Lo,74570,74570,74570},{74571,Lo,74571,74571,74571},{74572,Lo,74572,74572,74572},{74573,Lo,74573,74573,74573},{74574,Lo,74574,74574,74574},{74575,Lo,74575,74575,74575},{74576,Lo,74576,74576,74576},{74577,Lo,74577,74577,74577},{74578,Lo,74578,74578,74578},{74579,Lo,74579,74579,74579},{74580,Lo,74580,74580,74580},{74581,Lo,74581,74581,74581},{74582,Lo,74582,74582,74582},{74583,Lo,74583,74583,74583},{74584,Lo,74584,74584,74584},{74585,Lo,74585,74585,74585},{74586,Lo,74586,74586,74586},{74587,Lo,74587,74587,74587},{74588,Lo,74588,74588,74588},{74589,Lo,74589,74589,74589},{74590,Lo,74590,74590,74590},{74591,Lo,74591,74591,74591},{74592,Lo,74592,74592,74592},{74593,Lo,74593,74593,74593},{74594,Lo,74594,74594,74594},{74595,Lo,74595,74595,74595},{74596,Lo,74596,74596,74596},{74597,Lo,74597,74597,74597},{74598,Lo,74598,74598,74598},{74599,Lo,74599,74599,74599},{74600,Lo,74600,74600,74600},{74601,Lo,74601,74601,74601},{74602,Lo,74602,74602,74602},{74603,Lo,74603,74603,74603},{74604,Lo,74604,74604,74604},{74605,Lo,74605,74605,74605},{74606,Lo,74606,74606,74606},{74752,Nl,74752,74752,74752},{74753,Nl,74753,74753,74753},{74754,Nl,74754,74754,74754},{74755,Nl,74755,74755,74755},{74756,Nl,74756,74756,74756},{74757,Nl,74757,74757,74757},{74758,Nl,74758,74758,74758},{74759,Nl,74759,74759,74759},{74760,Nl,74760,74760,74760},{74761,Nl,74761,74761,74761},{74762,Nl,74762,74762,74762},{74763,Nl,74763,74763,74763},{74764,Nl,74764,74764,74764},{74765,Nl,74765,74765,74765},{74766,Nl,74766,74766,74766},{74767,Nl,74767,74767,74767},{74768,Nl,74768,74768,74768},{74769,Nl,74769,74769,74769},{74770,Nl,74770,74770,74770},{74771,Nl,74771,74771,74771},{74772,Nl,74772,74772,74772},{74773,Nl,74773,74773,74773},{74774,Nl,74774,74774,74774},{74775,Nl,74775,74775,74775},{74776,Nl,74776,74776,74776},{74777,Nl,74777,74777,74777},{74778,Nl,74778,74778,74778},{74779,Nl,74779,74779,74779},{74780,Nl,74780,74780,74780},{74781,Nl,74781,74781,74781},{74782,Nl,74782,74782,74782},{74783,Nl,74783,74783,74783},{74784,Nl,74784,74784,74784},{74785,Nl,74785,74785,74785},{74786,Nl,74786,74786,74786},{74787,Nl,74787,74787,74787},{74788,Nl,74788,74788,74788},{74789,Nl,74789,74789,74789},{74790,Nl,74790,74790,74790},{74791,Nl,74791,74791,74791},{74792,Nl,74792,74792,74792},{74793,Nl,74793,74793,74793},{74794,Nl,74794,74794,74794},{74795,Nl,74795,74795,74795},{74796,Nl,74796,74796,74796},{74797,Nl,74797,74797,74797},{74798,Nl,74798,74798,74798},{74799,Nl,74799,74799,74799},{74800,Nl,74800,74800,74800},{74801,Nl,74801,74801,74801},{74802,Nl,74802,74802,74802},{74803,Nl,74803,74803,74803},{74804,Nl,74804,74804,74804},{74805,Nl,74805,74805,74805},{74806,Nl,74806,74806,74806},{74807,Nl,74807,74807,74807},{74808,Nl,74808,74808,74808},{74809,Nl,74809,74809,74809},{74810,Nl,74810,74810,74810},{74811,Nl,74811,74811,74811},{74812,Nl,74812,74812,74812},{74813,Nl,74813,74813,74813},{74814,Nl,74814,74814,74814},{74815,Nl,74815,74815,74815},{74816,Nl,74816,74816,74816},{74817,Nl,74817,74817,74817},{74818,Nl,74818,74818,74818},{74819,Nl,74819,74819,74819},{74820,Nl,74820,74820,74820},{74821,Nl,74821,74821,74821},{74822,Nl,74822,74822,74822},{74823,Nl,74823,74823,74823},{74824,Nl,74824,74824,74824},{74825,Nl,74825,74825,74825},{74826,Nl,74826,74826,74826},{74827,Nl,74827,74827,74827},{74828,Nl,74828,74828,74828},{74829,Nl,74829,74829,74829},{74830,Nl,74830,74830,74830},{74831,Nl,74831,74831,74831},{74832,Nl,74832,74832,74832},{74833,Nl,74833,74833,74833},{74834,Nl,74834,74834,74834},{74835,Nl,74835,74835,74835},{74836,Nl,74836,74836,74836},{74837,Nl,74837,74837,74837},{74838,Nl,74838,74838,74838},{74839,Nl,74839,74839,74839},{74840,Nl,74840,74840,74840},{74841,Nl,74841,74841,74841},{74842,Nl,74842,74842,74842},{74843,Nl,74843,74843,74843},{74844,Nl,74844,74844,74844},{74845,Nl,74845,74845,74845},{74846,Nl,74846,74846,74846},{74847,Nl,74847,74847,74847},{74848,Nl,74848,74848,74848},{74849,Nl,74849,74849,74849},{74850,Nl,74850,74850,74850},{74864,Po,74864,74864,74864},{74865,Po,74865,74865,74865},{74866,Po,74866,74866,74866},{74867,Po,74867,74867,74867},{118784,So,118784,118784,118784},{118785,So,118785,118785,118785},{118786,So,118786,118786,118786},{118787,So,118787,118787,118787},{118788,So,118788,118788,118788},{118789,So,118789,118789,118789},{118790,So,118790,118790,118790},{118791,So,118791,118791,118791},{118792,So,118792,118792,118792},{118793,So,118793,118793,118793},{118794,So,118794,118794,118794},{118795,So,118795,118795,118795},{118796,So,118796,118796,118796},{118797,So,118797,118797,118797},{118798,So,118798,118798,118798},{118799,So,118799,118799,118799},{118800,So,118800,118800,118800},{118801,So,118801,118801,118801},{118802,So,118802,118802,118802},{118803,So,118803,118803,118803},{118804,So,118804,118804,118804},{118805,So,118805,118805,118805},{118806,So,118806,118806,118806},{118807,So,118807,118807,118807},{118808,So,118808,118808,118808},{118809,So,118809,118809,118809},{118810,So,118810,118810,118810},{118811,So,118811,118811,118811},{118812,So,118812,118812,118812},{118813,So,118813,118813,118813},{118814,So,118814,118814,118814},{118815,So,118815,118815,118815},{118816,So,118816,118816,118816},{118817,So,118817,118817,118817},{118818,So,118818,118818,118818},{118819,So,118819,118819,118819},{118820,So,118820,118820,118820},{118821,So,118821,118821,118821},{118822,So,118822,118822,118822},{118823,So,118823,118823,118823},{118824,So,118824,118824,118824},{118825,So,118825,118825,118825},{118826,So,118826,118826,118826},{118827,So,118827,118827,118827},{118828,So,118828,118828,118828},{118829,So,118829,118829,118829},{118830,So,118830,118830,118830},{118831,So,118831,118831,118831},{118832,So,118832,118832,118832},{118833,So,118833,118833,118833},{118834,So,118834,118834,118834},{118835,So,118835,118835,118835},{118836,So,118836,118836,118836},{118837,So,118837,118837,118837},{118838,So,118838,118838,118838},{118839,So,118839,118839,118839},{118840,So,118840,118840,118840},{118841,So,118841,118841,118841},{118842,So,118842,118842,118842},{118843,So,118843,118843,118843},{118844,So,118844,118844,118844},{118845,So,118845,118845,118845},{118846,So,118846,118846,118846},{118847,So,118847,118847,118847},{118848,So,118848,118848,118848},{118849,So,118849,118849,118849},{118850,So,118850,118850,118850},{118851,So,118851,118851,118851},{118852,So,118852,118852,118852},{118853,So,118853,118853,118853},{118854,So,118854,118854,118854},{118855,So,118855,118855,118855},{118856,So,118856,118856,118856},{118857,So,118857,118857,118857},{118858,So,118858,118858,118858},{118859,So,118859,118859,118859},{118860,So,118860,118860,118860},{118861,So,118861,118861,118861},{118862,So,118862,118862,118862},{118863,So,118863,118863,118863},{118864,So,118864,118864,118864},{118865,So,118865,118865,118865},{118866,So,118866,118866,118866},{118867,So,118867,118867,118867},{118868,So,118868,118868,118868},{118869,So,118869,118869,118869},{118870,So,118870,118870,118870},{118871,So,118871,118871,118871},{118872,So,118872,118872,118872},{118873,So,118873,118873,118873},{118874,So,118874,118874,118874},{118875,So,118875,118875,118875},{118876,So,118876,118876,118876},{118877,So,118877,118877,118877},{118878,So,118878,118878,118878},{118879,So,118879,118879,118879},{118880,So,118880,118880,118880},{118881,So,118881,118881,118881},{118882,So,118882,118882,118882},{118883,So,118883,118883,118883},{118884,So,118884,118884,118884},{118885,So,118885,118885,118885},{118886,So,118886,118886,118886},{118887,So,118887,118887,118887},{118888,So,118888,118888,118888},{118889,So,118889,118889,118889},{118890,So,118890,118890,118890},{118891,So,118891,118891,118891},{118892,So,118892,118892,118892},{118893,So,118893,118893,118893},{118894,So,118894,118894,118894},{118895,So,118895,118895,118895},{118896,So,118896,118896,118896},{118897,So,118897,118897,118897},{118898,So,118898,118898,118898},{118899,So,118899,118899,118899},{118900,So,118900,118900,118900},{118901,So,118901,118901,118901},{118902,So,118902,118902,118902},{118903,So,118903,118903,118903},{118904,So,118904,118904,118904},{118905,So,118905,118905,118905},{118906,So,118906,118906,118906},{118907,So,118907,118907,118907},{118908,So,118908,118908,118908},{118909,So,118909,118909,118909},{118910,So,118910,118910,118910},{118911,So,118911,118911,118911},{118912,So,118912,118912,118912},{118913,So,118913,118913,118913},{118914,So,118914,118914,118914},{118915,So,118915,118915,118915},{118916,So,118916,118916,118916},{118917,So,118917,118917,118917},{118918,So,118918,118918,118918},{118919,So,118919,118919,118919},{118920,So,118920,118920,118920},{118921,So,118921,118921,118921},{118922,So,118922,118922,118922},{118923,So,118923,118923,118923},{118924,So,118924,118924,118924},{118925,So,118925,118925,118925},{118926,So,118926,118926,118926},{118927,So,118927,118927,118927},{118928,So,118928,118928,118928},{118929,So,118929,118929,118929},{118930,So,118930,118930,118930},{118931,So,118931,118931,118931},{118932,So,118932,118932,118932},{118933,So,118933,118933,118933},{118934,So,118934,118934,118934},{118935,So,118935,118935,118935},{118936,So,118936,118936,118936},{118937,So,118937,118937,118937},{118938,So,118938,118938,118938},{118939,So,118939,118939,118939},{118940,So,118940,118940,118940},{118941,So,118941,118941,118941},{118942,So,118942,118942,118942},{118943,So,118943,118943,118943},{118944,So,118944,118944,118944},{118945,So,118945,118945,118945},{118946,So,118946,118946,118946},{118947,So,118947,118947,118947},{118948,So,118948,118948,118948},{118949,So,118949,118949,118949},{118950,So,118950,118950,118950},{118951,So,118951,118951,118951},{118952,So,118952,118952,118952},{118953,So,118953,118953,118953},{118954,So,118954,118954,118954},{118955,So,118955,118955,118955},{118956,So,118956,118956,118956},{118957,So,118957,118957,118957},{118958,So,118958,118958,118958},{118959,So,118959,118959,118959},{118960,So,118960,118960,118960},{118961,So,118961,118961,118961},{118962,So,118962,118962,118962},{118963,So,118963,118963,118963},{118964,So,118964,118964,118964},{118965,So,118965,118965,118965},{118966,So,118966,118966,118966},{118967,So,118967,118967,118967},{118968,So,118968,118968,118968},{118969,So,118969,118969,118969},{118970,So,118970,118970,118970},{118971,So,118971,118971,118971},{118972,So,118972,118972,118972},{118973,So,118973,118973,118973},{118974,So,118974,118974,118974},{118975,So,118975,118975,118975},{118976,So,118976,118976,118976},{118977,So,118977,118977,118977},{118978,So,118978,118978,118978},{118979,So,118979,118979,118979},{118980,So,118980,118980,118980},{118981,So,118981,118981,118981},{118982,So,118982,118982,118982},{118983,So,118983,118983,118983},{118984,So,118984,118984,118984},{118985,So,118985,118985,118985},{118986,So,118986,118986,118986},{118987,So,118987,118987,118987},{118988,So,118988,118988,118988},{118989,So,118989,118989,118989},{118990,So,118990,118990,118990},{118991,So,118991,118991,118991},{118992,So,118992,118992,118992},{118993,So,118993,118993,118993},{118994,So,118994,118994,118994},{118995,So,118995,118995,118995},{118996,So,118996,118996,118996},{118997,So,118997,118997,118997},{118998,So,118998,118998,118998},{118999,So,118999,118999,118999},{119000,So,119000,119000,119000},{119001,So,119001,119001,119001},{119002,So,119002,119002,119002},{119003,So,119003,119003,119003},{119004,So,119004,119004,119004},{119005,So,119005,119005,119005},{119006,So,119006,119006,119006},{119007,So,119007,119007,119007},{119008,So,119008,119008,119008},{119009,So,119009,119009,119009},{119010,So,119010,119010,119010},{119011,So,119011,119011,119011},{119012,So,119012,119012,119012},{119013,So,119013,119013,119013},{119014,So,119014,119014,119014},{119015,So,119015,119015,119015},{119016,So,119016,119016,119016},{119017,So,119017,119017,119017},{119018,So,119018,119018,119018},{119019,So,119019,119019,119019},{119020,So,119020,119020,119020},{119021,So,119021,119021,119021},{119022,So,119022,119022,119022},{119023,So,119023,119023,119023},{119024,So,119024,119024,119024},{119025,So,119025,119025,119025},{119026,So,119026,119026,119026},{119027,So,119027,119027,119027},{119028,So,119028,119028,119028},{119029,So,119029,119029,119029},{119040,So,119040,119040,119040},{119041,So,119041,119041,119041},{119042,So,119042,119042,119042},{119043,So,119043,119043,119043},{119044,So,119044,119044,119044},{119045,So,119045,119045,119045},{119046,So,119046,119046,119046},{119047,So,119047,119047,119047},{119048,So,119048,119048,119048},{119049,So,119049,119049,119049},{119050,So,119050,119050,119050},{119051,So,119051,119051,119051},{119052,So,119052,119052,119052},{119053,So,119053,119053,119053},{119054,So,119054,119054,119054},{119055,So,119055,119055,119055},{119056,So,119056,119056,119056},{119057,So,119057,119057,119057},{119058,So,119058,119058,119058},{119059,So,119059,119059,119059},{119060,So,119060,119060,119060},{119061,So,119061,119061,119061},{119062,So,119062,119062,119062},{119063,So,119063,119063,119063},{119064,So,119064,119064,119064},{119065,So,119065,119065,119065},{119066,So,119066,119066,119066},{119067,So,119067,119067,119067},{119068,So,119068,119068,119068},{119069,So,119069,119069,119069},{119070,So,119070,119070,119070},{119071,So,119071,119071,119071},{119072,So,119072,119072,119072},{119073,So,119073,119073,119073},{119074,So,119074,119074,119074},{119075,So,119075,119075,119075},{119076,So,119076,119076,119076},{119077,So,119077,119077,119077},{119078,So,119078,119078,119078},{119082,So,119082,119082,119082},{119083,So,119083,119083,119083},{119084,So,119084,119084,119084},{119085,So,119085,119085,119085},{119086,So,119086,119086,119086},{119087,So,119087,119087,119087},{119088,So,119088,119088,119088},{119089,So,119089,119089,119089},{119090,So,119090,119090,119090},{119091,So,119091,119091,119091},{119092,So,119092,119092,119092},{119093,So,119093,119093,119093},{119094,So,119094,119094,119094},{119095,So,119095,119095,119095},{119096,So,119096,119096,119096},{119097,So,119097,119097,119097},{119098,So,119098,119098,119098},{119099,So,119099,119099,119099},{119100,So,119100,119100,119100},{119101,So,119101,119101,119101},{119102,So,119102,119102,119102},{119103,So,119103,119103,119103},{119104,So,119104,119104,119104},{119105,So,119105,119105,119105},{119106,So,119106,119106,119106},{119107,So,119107,119107,119107},{119108,So,119108,119108,119108},{119109,So,119109,119109,119109},{119110,So,119110,119110,119110},{119111,So,119111,119111,119111},{119112,So,119112,119112,119112},{119113,So,119113,119113,119113},{119114,So,119114,119114,119114},{119115,So,119115,119115,119115},{119116,So,119116,119116,119116},{119117,So,119117,119117,119117},{119118,So,119118,119118,119118},{119119,So,119119,119119,119119},{119120,So,119120,119120,119120},{119121,So,119121,119121,119121},{119122,So,119122,119122,119122},{119123,So,119123,119123,119123},{119124,So,119124,119124,119124},{119125,So,119125,119125,119125},{119126,So,119126,119126,119126},{119127,So,119127,119127,119127},{119128,So,119128,119128,119128},{119129,So,119129,119129,119129},{119130,So,119130,119130,119130},{119131,So,119131,119131,119131},{119132,So,119132,119132,119132},{119133,So,119133,119133,119133},{119134,So,119134,119134,119134},{119135,So,119135,119135,119135},{119136,So,119136,119136,119136},{119137,So,119137,119137,119137},{119138,So,119138,119138,119138},{119139,So,119139,119139,119139},{119140,So,119140,119140,119140},{119141,Mc,119141,119141,119141},{119142,Mc,119142,119142,119142},{119143,Mn,119143,119143,119143},{119144,Mn,119144,119144,119144},{119145,Mn,119145,119145,119145},{119146,So,119146,119146,119146},{119147,So,119147,119147,119147},{119148,So,119148,119148,119148},{119149,Mc,119149,119149,119149},{119150,Mc,119150,119150,119150},{119151,Mc,119151,119151,119151},{119152,Mc,119152,119152,119152},{119153,Mc,119153,119153,119153},{119154,Mc,119154,119154,119154},{119155,Cf,119155,119155,119155},{119156,Cf,119156,119156,119156},{119157,Cf,119157,119157,119157},{119158,Cf,119158,119158,119158},{119159,Cf,119159,119159,119159},{119160,Cf,119160,119160,119160},{119161,Cf,119161,119161,119161},{119162,Cf,119162,119162,119162},{119163,Mn,119163,119163,119163},{119164,Mn,119164,119164,119164},{119165,Mn,119165,119165,119165},{119166,Mn,119166,119166,119166},{119167,Mn,119167,119167,119167},{119168,Mn,119168,119168,119168},{119169,Mn,119169,119169,119169},{119170,Mn,119170,119170,119170},{119171,So,119171,119171,119171},{119172,So,119172,119172,119172},{119173,Mn,119173,119173,119173},{119174,Mn,119174,119174,119174},{119175,Mn,119175,119175,119175},{119176,Mn,119176,119176,119176},{119177,Mn,119177,119177,119177},{119178,Mn,119178,119178,119178},{119179,Mn,119179,119179,119179},{119180,So,119180,119180,119180},{119181,So,119181,119181,119181},{119182,So,119182,119182,119182},{119183,So,119183,119183,119183},{119184,So,119184,119184,119184},{119185,So,119185,119185,119185},{119186,So,119186,119186,119186},{119187,So,119187,119187,119187},{119188,So,119188,119188,119188},{119189,So,119189,119189,119189},{119190,So,119190,119190,119190},{119191,So,119191,119191,119191},{119192,So,119192,119192,119192},{119193,So,119193,119193,119193},{119194,So,119194,119194,119194},{119195,So,119195,119195,119195},{119196,So,119196,119196,119196},{119197,So,119197,119197,119197},{119198,So,119198,119198,119198},{119199,So,119199,119199,119199},{119200,So,119200,119200,119200},{119201,So,119201,119201,119201},{119202,So,119202,119202,119202},{119203,So,119203,119203,119203},{119204,So,119204,119204,119204},{119205,So,119205,119205,119205},{119206,So,119206,119206,119206},{119207,So,119207,119207,119207},{119208,So,119208,119208,119208},{119209,So,119209,119209,119209},{119210,Mn,119210,119210,119210},{119211,Mn,119211,119211,119211},{119212,Mn,119212,119212,119212},{119213,Mn,119213,119213,119213},{119214,So,119214,119214,119214},{119215,So,119215,119215,119215},{119216,So,119216,119216,119216},{119217,So,119217,119217,119217},{119218,So,119218,119218,119218},{119219,So,119219,119219,119219},{119220,So,119220,119220,119220},{119221,So,119221,119221,119221},{119222,So,119222,119222,119222},{119223,So,119223,119223,119223},{119224,So,119224,119224,119224},{119225,So,119225,119225,119225},{119226,So,119226,119226,119226},{119227,So,119227,119227,119227},{119228,So,119228,119228,119228},{119229,So,119229,119229,119229},{119230,So,119230,119230,119230},{119231,So,119231,119231,119231},{119232,So,119232,119232,119232},{119233,So,119233,119233,119233},{119234,So,119234,119234,119234},{119235,So,119235,119235,119235},{119236,So,119236,119236,119236},{119237,So,119237,119237,119237},{119238,So,119238,119238,119238},{119239,So,119239,119239,119239},{119240,So,119240,119240,119240},{119241,So,119241,119241,119241},{119242,So,119242,119242,119242},{119243,So,119243,119243,119243},{119244,So,119244,119244,119244},{119245,So,119245,119245,119245},{119246,So,119246,119246,119246},{119247,So,119247,119247,119247},{119248,So,119248,119248,119248},{119249,So,119249,119249,119249},{119250,So,119250,119250,119250},{119251,So,119251,119251,119251},{119252,So,119252,119252,119252},{119253,So,119253,119253,119253},{119254,So,119254,119254,119254},{119255,So,119255,119255,119255},{119256,So,119256,119256,119256},{119257,So,119257,119257,119257},{119258,So,119258,119258,119258},{119259,So,119259,119259,119259},{119260,So,119260,119260,119260},{119261,So,119261,119261,119261},{119296,So,119296,119296,119296},{119297,So,119297,119297,119297},{119298,So,119298,119298,119298},{119299,So,119299,119299,119299},{119300,So,119300,119300,119300},{119301,So,119301,119301,119301},{119302,So,119302,119302,119302},{119303,So,119303,119303,119303},{119304,So,119304,119304,119304},{119305,So,119305,119305,119305},{119306,So,119306,119306,119306},{119307,So,119307,119307,119307},{119308,So,119308,119308,119308},{119309,So,119309,119309,119309},{119310,So,119310,119310,119310},{119311,So,119311,119311,119311},{119312,So,119312,119312,119312},{119313,So,119313,119313,119313},{119314,So,119314,119314,119314},{119315,So,119315,119315,119315},{119316,So,119316,119316,119316},{119317,So,119317,119317,119317},{119318,So,119318,119318,119318},{119319,So,119319,119319,119319},{119320,So,119320,119320,119320},{119321,So,119321,119321,119321},{119322,So,119322,119322,119322},{119323,So,119323,119323,119323},{119324,So,119324,119324,119324},{119325,So,119325,119325,119325},{119326,So,119326,119326,119326},{119327,So,119327,119327,119327},{119328,So,119328,119328,119328},{119329,So,119329,119329,119329},{119330,So,119330,119330,119330},{119331,So,119331,119331,119331},{119332,So,119332,119332,119332},{119333,So,119333,119333,119333},{119334,So,119334,119334,119334},{119335,So,119335,119335,119335},{119336,So,119336,119336,119336},{119337,So,119337,119337,119337},{119338,So,119338,119338,119338},{119339,So,119339,119339,119339},{119340,So,119340,119340,119340},{119341,So,119341,119341,119341},{119342,So,119342,119342,119342},{119343,So,119343,119343,119343},{119344,So,119344,119344,119344},{119345,So,119345,119345,119345},{119346,So,119346,119346,119346},{119347,So,119347,119347,119347},{119348,So,119348,119348,119348},{119349,So,119349,119349,119349},{119350,So,119350,119350,119350},{119351,So,119351,119351,119351},{119352,So,119352,119352,119352},{119353,So,119353,119353,119353},{119354,So,119354,119354,119354},{119355,So,119355,119355,119355},{119356,So,119356,119356,119356},{119357,So,119357,119357,119357},{119358,So,119358,119358,119358},{119359,So,119359,119359,119359},{119360,So,119360,119360,119360},{119361,So,119361,119361,119361},{119362,Mn,119362,119362,119362},{119363,Mn,119363,119363,119363},{119364,Mn,119364,119364,119364},{119365,So,119365,119365,119365},{119552,So,119552,119552,119552},{119553,So,119553,119553,119553},{119554,So,119554,119554,119554},{119555,So,119555,119555,119555},{119556,So,119556,119556,119556},{119557,So,119557,119557,119557},{119558,So,119558,119558,119558},{119559,So,119559,119559,119559},{119560,So,119560,119560,119560},{119561,So,119561,119561,119561},{119562,So,119562,119562,119562},{119563,So,119563,119563,119563},{119564,So,119564,119564,119564},{119565,So,119565,119565,119565},{119566,So,119566,119566,119566},{119567,So,119567,119567,119567},{119568,So,119568,119568,119568},{119569,So,119569,119569,119569},{119570,So,119570,119570,119570},{119571,So,119571,119571,119571},{119572,So,119572,119572,119572},{119573,So,119573,119573,119573},{119574,So,119574,119574,119574},{119575,So,119575,119575,119575},{119576,So,119576,119576,119576},{119577,So,119577,119577,119577},{119578,So,119578,119578,119578},{119579,So,119579,119579,119579},{119580,So,119580,119580,119580},{119581,So,119581,119581,119581},{119582,So,119582,119582,119582},{119583,So,119583,119583,119583},{119584,So,119584,119584,119584},{119585,So,119585,119585,119585},{119586,So,119586,119586,119586},{119587,So,119587,119587,119587},{119588,So,119588,119588,119588},{119589,So,119589,119589,119589},{119590,So,119590,119590,119590},{119591,So,119591,119591,119591},{119592,So,119592,119592,119592},{119593,So,119593,119593,119593},{119594,So,119594,119594,119594},{119595,So,119595,119595,119595},{119596,So,119596,119596,119596},{119597,So,119597,119597,119597},{119598,So,119598,119598,119598},{119599,So,119599,119599,119599},{119600,So,119600,119600,119600},{119601,So,119601,119601,119601},{119602,So,119602,119602,119602},{119603,So,119603,119603,119603},{119604,So,119604,119604,119604},{119605,So,119605,119605,119605},{119606,So,119606,119606,119606},{119607,So,119607,119607,119607},{119608,So,119608,119608,119608},{119609,So,119609,119609,119609},{119610,So,119610,119610,119610},{119611,So,119611,119611,119611},{119612,So,119612,119612,119612},{119613,So,119613,119613,119613},{119614,So,119614,119614,119614},{119615,So,119615,119615,119615},{119616,So,119616,119616,119616},{119617,So,119617,119617,119617},{119618,So,119618,119618,119618},{119619,So,119619,119619,119619},{119620,So,119620,119620,119620},{119621,So,119621,119621,119621},{119622,So,119622,119622,119622},{119623,So,119623,119623,119623},{119624,So,119624,119624,119624},{119625,So,119625,119625,119625},{119626,So,119626,119626,119626},{119627,So,119627,119627,119627},{119628,So,119628,119628,119628},{119629,So,119629,119629,119629},{119630,So,119630,119630,119630},{119631,So,119631,119631,119631},{119632,So,119632,119632,119632},{119633,So,119633,119633,119633},{119634,So,119634,119634,119634},{119635,So,119635,119635,119635},{119636,So,119636,119636,119636},{119637,So,119637,119637,119637},{119638,So,119638,119638,119638},{119648,No,119648,119648,119648},{119649,No,119649,119649,119649},{119650,No,119650,119650,119650},{119651,No,119651,119651,119651},{119652,No,119652,119652,119652},{119653,No,119653,119653,119653},{119654,No,119654,119654,119654},{119655,No,119655,119655,119655},{119656,No,119656,119656,119656},{119657,No,119657,119657,119657},{119658,No,119658,119658,119658},{119659,No,119659,119659,119659},{119660,No,119660,119660,119660},{119661,No,119661,119661,119661},{119662,No,119662,119662,119662},{119663,No,119663,119663,119663},{119664,No,119664,119664,119664},{119665,No,119665,119665,119665},{119808,Lu,119808,119808,119808},{119809,Lu,119809,119809,119809},{119810,Lu,119810,119810,119810},{119811,Lu,119811,119811,119811},{119812,Lu,119812,119812,119812},{119813,Lu,119813,119813,119813},{119814,Lu,119814,119814,119814},{119815,Lu,119815,119815,119815},{119816,Lu,119816,119816,119816},{119817,Lu,119817,119817,119817},{119818,Lu,119818,119818,119818},{119819,Lu,119819,119819,119819},{119820,Lu,119820,119820,119820},{119821,Lu,119821,119821,119821},{119822,Lu,119822,119822,119822},{119823,Lu,119823,119823,119823},{119824,Lu,119824,119824,119824},{119825,Lu,119825,119825,119825},{119826,Lu,119826,119826,119826},{119827,Lu,119827,119827,119827},{119828,Lu,119828,119828,119828},{119829,Lu,119829,119829,119829},{119830,Lu,119830,119830,119830},{119831,Lu,119831,119831,119831},{119832,Lu,119832,119832,119832},{119833,Lu,119833,119833,119833},{119834,Ll,119834,119834,119834},{119835,Ll,119835,119835,119835},{119836,Ll,119836,119836,119836},{119837,Ll,119837,119837,119837},{119838,Ll,119838,119838,119838},{119839,Ll,119839,119839,119839},{119840,Ll,119840,119840,119840},{119841,Ll,119841,119841,119841},{119842,Ll,119842,119842,119842},{119843,Ll,119843,119843,119843},{119844,Ll,119844,119844,119844},{119845,Ll,119845,119845,119845},{119846,Ll,119846,119846,119846},{119847,Ll,119847,119847,119847},{119848,Ll,119848,119848,119848},{119849,Ll,119849,119849,119849},{119850,Ll,119850,119850,119850},{119851,Ll,119851,119851,119851},{119852,Ll,119852,119852,119852},{119853,Ll,119853,119853,119853},{119854,Ll,119854,119854,119854},{119855,Ll,119855,119855,119855},{119856,Ll,119856,119856,119856},{119857,Ll,119857,119857,119857},{119858,Ll,119858,119858,119858},{119859,Ll,119859,119859,119859},{119860,Lu,119860,119860,119860},{119861,Lu,119861,119861,119861},{119862,Lu,119862,119862,119862},{119863,Lu,119863,119863,119863},{119864,Lu,119864,119864,119864},{119865,Lu,119865,119865,119865},{119866,Lu,119866,119866,119866},{119867,Lu,119867,119867,119867},{119868,Lu,119868,119868,119868},{119869,Lu,119869,119869,119869},{119870,Lu,119870,119870,119870},{119871,Lu,119871,119871,119871},{119872,Lu,119872,119872,119872},{119873,Lu,119873,119873,119873},{119874,Lu,119874,119874,119874},{119875,Lu,119875,119875,119875},{119876,Lu,119876,119876,119876},{119877,Lu,119877,119877,119877},{119878,Lu,119878,119878,119878},{119879,Lu,119879,119879,119879},{119880,Lu,119880,119880,119880},{119881,Lu,119881,119881,119881},{119882,Lu,119882,119882,119882},{119883,Lu,119883,119883,119883},{119884,Lu,119884,119884,119884},{119885,Lu,119885,119885,119885},{119886,Ll,119886,119886,119886},{119887,Ll,119887,119887,119887},{119888,Ll,119888,119888,119888},{119889,Ll,119889,119889,119889},{119890,Ll,119890,119890,119890},{119891,Ll,119891,119891,119891},{119892,Ll,119892,119892,119892},{119894,Ll,119894,119894,119894},{119895,Ll,119895,119895,119895},{119896,Ll,119896,119896,119896},{119897,Ll,119897,119897,119897},{119898,Ll,119898,119898,119898},{119899,Ll,119899,119899,119899},{119900,Ll,119900,119900,119900},{119901,Ll,119901,119901,119901},{119902,Ll,119902,119902,119902},{119903,Ll,119903,119903,119903},{119904,Ll,119904,119904,119904},{119905,Ll,119905,119905,119905},{119906,Ll,119906,119906,119906},{119907,Ll,119907,119907,119907},{119908,Ll,119908,119908,119908},{119909,Ll,119909,119909,119909},{119910,Ll,119910,119910,119910},{119911,Ll,119911,119911,119911},{119912,Lu,119912,119912,119912},{119913,Lu,119913,119913,119913},{119914,Lu,119914,119914,119914},{119915,Lu,119915,119915,119915},{119916,Lu,119916,119916,119916},{119917,Lu,119917,119917,119917},{119918,Lu,119918,119918,119918},{119919,Lu,119919,119919,119919},{119920,Lu,119920,119920,119920},{119921,Lu,119921,119921,119921},{119922,Lu,119922,119922,119922},{119923,Lu,119923,119923,119923},{119924,Lu,119924,119924,119924},{119925,Lu,119925,119925,119925},{119926,Lu,119926,119926,119926},{119927,Lu,119927,119927,119927},{119928,Lu,119928,119928,119928},{119929,Lu,119929,119929,119929},{119930,Lu,119930,119930,119930},{119931,Lu,119931,119931,119931},{119932,Lu,119932,119932,119932},{119933,Lu,119933,119933,119933},{119934,Lu,119934,119934,119934},{119935,Lu,119935,119935,119935},{119936,Lu,119936,119936,119936},{119937,Lu,119937,119937,119937},{119938,Ll,119938,119938,119938},{119939,Ll,119939,119939,119939},{119940,Ll,119940,119940,119940},{119941,Ll,119941,119941,119941},{119942,Ll,119942,119942,119942},{119943,Ll,119943,119943,119943},{119944,Ll,119944,119944,119944},{119945,Ll,119945,119945,119945},{119946,Ll,119946,119946,119946},{119947,Ll,119947,119947,119947},{119948,Ll,119948,119948,119948},{119949,Ll,119949,119949,119949},{119950,Ll,119950,119950,119950},{119951,Ll,119951,119951,119951},{119952,Ll,119952,119952,119952},{119953,Ll,119953,119953,119953},{119954,Ll,119954,119954,119954},{119955,Ll,119955,119955,119955},{119956,Ll,119956,119956,119956},{119957,Ll,119957,119957,119957},{119958,Ll,119958,119958,119958},{119959,Ll,119959,119959,119959},{119960,Ll,119960,119960,119960},{119961,Ll,119961,119961,119961},{119962,Ll,119962,119962,119962},{119963,Ll,119963,119963,119963},{119964,Lu,119964,119964,119964},{119966,Lu,119966,119966,119966},{119967,Lu,119967,119967,119967},{119970,Lu,119970,119970,119970},{119973,Lu,119973,119973,119973},{119974,Lu,119974,119974,119974},{119977,Lu,119977,119977,119977},{119978,Lu,119978,119978,119978},{119979,Lu,119979,119979,119979},{119980,Lu,119980,119980,119980},{119982,Lu,119982,119982,119982},{119983,Lu,119983,119983,119983},{119984,Lu,119984,119984,119984},{119985,Lu,119985,119985,119985},{119986,Lu,119986,119986,119986},{119987,Lu,119987,119987,119987},{119988,Lu,119988,119988,119988},{119989,Lu,119989,119989,119989},{119990,Ll,119990,119990,119990},{119991,Ll,119991,119991,119991},{119992,Ll,119992,119992,119992},{119993,Ll,119993,119993,119993},{119995,Ll,119995,119995,119995},{119997,Ll,119997,119997,119997},{119998,Ll,119998,119998,119998},{119999,Ll,119999,119999,119999},{120000,Ll,120000,120000,120000},{120001,Ll,120001,120001,120001},{120002,Ll,120002,120002,120002},{120003,Ll,120003,120003,120003},{120005,Ll,120005,120005,120005},{120006,Ll,120006,120006,120006},{120007,Ll,120007,120007,120007},{120008,Ll,120008,120008,120008},{120009,Ll,120009,120009,120009},{120010,Ll,120010,120010,120010},{120011,Ll,120011,120011,120011},{120012,Ll,120012,120012,120012},{120013,Ll,120013,120013,120013},{120014,Ll,120014,120014,120014},{120015,Ll,120015,120015,120015},{120016,Lu,120016,120016,120016},{120017,Lu,120017,120017,120017},{120018,Lu,120018,120018,120018},{120019,Lu,120019,120019,120019},{120020,Lu,120020,120020,120020},{120021,Lu,120021,120021,120021},{120022,Lu,120022,120022,120022},{120023,Lu,120023,120023,120023},{120024,Lu,120024,120024,120024},{120025,Lu,120025,120025,120025},{120026,Lu,120026,120026,120026},{120027,Lu,120027,120027,120027},{120028,Lu,120028,120028,120028},{120029,Lu,120029,120029,120029},{120030,Lu,120030,120030,120030},{120031,Lu,120031,120031,120031},{120032,Lu,120032,120032,120032},{120033,Lu,120033,120033,120033},{120034,Lu,120034,120034,120034},{120035,Lu,120035,120035,120035},{120036,Lu,120036,120036,120036},{120037,Lu,120037,120037,120037},{120038,Lu,120038,120038,120038},{120039,Lu,120039,120039,120039},{120040,Lu,120040,120040,120040},{120041,Lu,120041,120041,120041},{120042,Ll,120042,120042,120042},{120043,Ll,120043,120043,120043},{120044,Ll,120044,120044,120044},{120045,Ll,120045,120045,120045},{120046,Ll,120046,120046,120046},{120047,Ll,120047,120047,120047},{120048,Ll,120048,120048,120048},{120049,Ll,120049,120049,120049},{120050,Ll,120050,120050,120050},{120051,Ll,120051,120051,120051},{120052,Ll,120052,120052,120052},{120053,Ll,120053,120053,120053},{120054,Ll,120054,120054,120054},{120055,Ll,120055,120055,120055},{120056,Ll,120056,120056,120056},{120057,Ll,120057,120057,120057},{120058,Ll,120058,120058,120058},{120059,Ll,120059,120059,120059},{120060,Ll,120060,120060,120060},{120061,Ll,120061,120061,120061},{120062,Ll,120062,120062,120062},{120063,Ll,120063,120063,120063},{120064,Ll,120064,120064,120064},{120065,Ll,120065,120065,120065},{120066,Ll,120066,120066,120066},{120067,Ll,120067,120067,120067},{120068,Lu,120068,120068,120068},{120069,Lu,120069,120069,120069},{120071,Lu,120071,120071,120071},{120072,Lu,120072,120072,120072},{120073,Lu,120073,120073,120073},{120074,Lu,120074,120074,120074},{120077,Lu,120077,120077,120077},{120078,Lu,120078,120078,120078},{120079,Lu,120079,120079,120079},{120080,Lu,120080,120080,120080},{120081,Lu,120081,120081,120081},{120082,Lu,120082,120082,120082},{120083,Lu,120083,120083,120083},{120084,Lu,120084,120084,120084},{120086,Lu,120086,120086,120086},{120087,Lu,120087,120087,120087},{120088,Lu,120088,120088,120088},{120089,Lu,120089,120089,120089},{120090,Lu,120090,120090,120090},{120091,Lu,120091,120091,120091},{120092,Lu,120092,120092,120092},{120094,Ll,120094,120094,120094},{120095,Ll,120095,120095,120095},{120096,Ll,120096,120096,120096},{120097,Ll,120097,120097,120097},{120098,Ll,120098,120098,120098},{120099,Ll,120099,120099,120099},{120100,Ll,120100,120100,120100},{120101,Ll,120101,120101,120101},{120102,Ll,120102,120102,120102},{120103,Ll,120103,120103,120103},{120104,Ll,120104,120104,120104},{120105,Ll,120105,120105,120105},{120106,Ll,120106,120106,120106},{120107,Ll,120107,120107,120107},{120108,Ll,120108,120108,120108},{120109,Ll,120109,120109,120109},{120110,Ll,120110,120110,120110},{120111,Ll,120111,120111,120111},{120112,Ll,120112,120112,120112},{120113,Ll,120113,120113,120113},{120114,Ll,120114,120114,120114},{120115,Ll,120115,120115,120115},{120116,Ll,120116,120116,120116},{120117,Ll,120117,120117,120117},{120118,Ll,120118,120118,120118},{120119,Ll,120119,120119,120119},{120120,Lu,120120,120120,120120},{120121,Lu,120121,120121,120121},{120123,Lu,120123,120123,120123},{120124,Lu,120124,120124,120124},{120125,Lu,120125,120125,120125},{120126,Lu,120126,120126,120126},{120128,Lu,120128,120128,120128},{120129,Lu,120129,120129,120129},{120130,Lu,120130,120130,120130},{120131,Lu,120131,120131,120131},{120132,Lu,120132,120132,120132},{120134,Lu,120134,120134,120134},{120138,Lu,120138,120138,120138},{120139,Lu,120139,120139,120139},{120140,Lu,120140,120140,120140},{120141,Lu,120141,120141,120141},{120142,Lu,120142,120142,120142},{120143,Lu,120143,120143,120143},{120144,Lu,120144,120144,120144},{120146,Ll,120146,120146,120146},{120147,Ll,120147,120147,120147},{120148,Ll,120148,120148,120148},{120149,Ll,120149,120149,120149},{120150,Ll,120150,120150,120150},{120151,Ll,120151,120151,120151},{120152,Ll,120152,120152,120152},{120153,Ll,120153,120153,120153},{120154,Ll,120154,120154,120154},{120155,Ll,120155,120155,120155},{120156,Ll,120156,120156,120156},{120157,Ll,120157,120157,120157},{120158,Ll,120158,120158,120158},{120159,Ll,120159,120159,120159},{120160,Ll,120160,120160,120160},{120161,Ll,120161,120161,120161},{120162,Ll,120162,120162,120162},{120163,Ll,120163,120163,120163},{120164,Ll,120164,120164,120164},{120165,Ll,120165,120165,120165},{120166,Ll,120166,120166,120166},{120167,Ll,120167,120167,120167},{120168,Ll,120168,120168,120168},{120169,Ll,120169,120169,120169},{120170,Ll,120170,120170,120170},{120171,Ll,120171,120171,120171},{120172,Lu,120172,120172,120172},{120173,Lu,120173,120173,120173},{120174,Lu,120174,120174,120174},{120175,Lu,120175,120175,120175},{120176,Lu,120176,120176,120176},{120177,Lu,120177,120177,120177},{120178,Lu,120178,120178,120178},{120179,Lu,120179,120179,120179},{120180,Lu,120180,120180,120180},{120181,Lu,120181,120181,120181},{120182,Lu,120182,120182,120182},{120183,Lu,120183,120183,120183},{120184,Lu,120184,120184,120184},{120185,Lu,120185,120185,120185},{120186,Lu,120186,120186,120186},{120187,Lu,120187,120187,120187},{120188,Lu,120188,120188,120188},{120189,Lu,120189,120189,120189},{120190,Lu,120190,120190,120190},{120191,Lu,120191,120191,120191},{120192,Lu,120192,120192,120192},{120193,Lu,120193,120193,120193},{120194,Lu,120194,120194,120194},{120195,Lu,120195,120195,120195},{120196,Lu,120196,120196,120196},{120197,Lu,120197,120197,120197},{120198,Ll,120198,120198,120198},{120199,Ll,120199,120199,120199},{120200,Ll,120200,120200,120200},{120201,Ll,120201,120201,120201},{120202,Ll,120202,120202,120202},{120203,Ll,120203,120203,120203},{120204,Ll,120204,120204,120204},{120205,Ll,120205,120205,120205},{120206,Ll,120206,120206,120206},{120207,Ll,120207,120207,120207},{120208,Ll,120208,120208,120208},{120209,Ll,120209,120209,120209},{120210,Ll,120210,120210,120210},{120211,Ll,120211,120211,120211},{120212,Ll,120212,120212,120212},{120213,Ll,120213,120213,120213},{120214,Ll,120214,120214,120214},{120215,Ll,120215,120215,120215},{120216,Ll,120216,120216,120216},{120217,Ll,120217,120217,120217},{120218,Ll,120218,120218,120218},{120219,Ll,120219,120219,120219},{120220,Ll,120220,120220,120220},{120221,Ll,120221,120221,120221},{120222,Ll,120222,120222,120222},{120223,Ll,120223,120223,120223},{120224,Lu,120224,120224,120224},{120225,Lu,120225,120225,120225},{120226,Lu,120226,120226,120226},{120227,Lu,120227,120227,120227},{120228,Lu,120228,120228,120228},{120229,Lu,120229,120229,120229},{120230,Lu,120230,120230,120230},{120231,Lu,120231,120231,120231},{120232,Lu,120232,120232,120232},{120233,Lu,120233,120233,120233},{120234,Lu,120234,120234,120234},{120235,Lu,120235,120235,120235},{120236,Lu,120236,120236,120236},{120237,Lu,120237,120237,120237},{120238,Lu,120238,120238,120238},{120239,Lu,120239,120239,120239},{120240,Lu,120240,120240,120240},{120241,Lu,120241,120241,120241},{120242,Lu,120242,120242,120242},{120243,Lu,120243,120243,120243},{120244,Lu,120244,120244,120244},{120245,Lu,120245,120245,120245},{120246,Lu,120246,120246,120246},{120247,Lu,120247,120247,120247},{120248,Lu,120248,120248,120248},{120249,Lu,120249,120249,120249},{120250,Ll,120250,120250,120250},{120251,Ll,120251,120251,120251},{120252,Ll,120252,120252,120252},{120253,Ll,120253,120253,120253},{120254,Ll,120254,120254,120254},{120255,Ll,120255,120255,120255},{120256,Ll,120256,120256,120256},{120257,Ll,120257,120257,120257},{120258,Ll,120258,120258,120258},{120259,Ll,120259,120259,120259},{120260,Ll,120260,120260,120260},{120261,Ll,120261,120261,120261},{120262,Ll,120262,120262,120262},{120263,Ll,120263,120263,120263},{120264,Ll,120264,120264,120264},{120265,Ll,120265,120265,120265},{120266,Ll,120266,120266,120266},{120267,Ll,120267,120267,120267},{120268,Ll,120268,120268,120268},{120269,Ll,120269,120269,120269},{120270,Ll,120270,120270,120270},{120271,Ll,120271,120271,120271},{120272,Ll,120272,120272,120272},{120273,Ll,120273,120273,120273},{120274,Ll,120274,120274,120274},{120275,Ll,120275,120275,120275},{120276,Lu,120276,120276,120276},{120277,Lu,120277,120277,120277},{120278,Lu,120278,120278,120278},{120279,Lu,120279,120279,120279},{120280,Lu,120280,120280,120280},{120281,Lu,120281,120281,120281},{120282,Lu,120282,120282,120282},{120283,Lu,120283,120283,120283},{120284,Lu,120284,120284,120284},{120285,Lu,120285,120285,120285},{120286,Lu,120286,120286,120286},{120287,Lu,120287,120287,120287},{120288,Lu,120288,120288,120288},{120289,Lu,120289,120289,120289},{120290,Lu,120290,120290,120290},{120291,Lu,120291,120291,120291},{120292,Lu,120292,120292,120292},{120293,Lu,120293,120293,120293},{120294,Lu,120294,120294,120294},{120295,Lu,120295,120295,120295},{120296,Lu,120296,120296,120296},{120297,Lu,120297,120297,120297},{120298,Lu,120298,120298,120298},{120299,Lu,120299,120299,120299},{120300,Lu,120300,120300,120300},{120301,Lu,120301,120301,120301},{120302,Ll,120302,120302,120302},{120303,Ll,120303,120303,120303},{120304,Ll,120304,120304,120304},{120305,Ll,120305,120305,120305},{120306,Ll,120306,120306,120306},{120307,Ll,120307,120307,120307},{120308,Ll,120308,120308,120308},{120309,Ll,120309,120309,120309},{120310,Ll,120310,120310,120310},{120311,Ll,120311,120311,120311},{120312,Ll,120312,120312,120312},{120313,Ll,120313,120313,120313},{120314,Ll,120314,120314,120314},{120315,Ll,120315,120315,120315},{120316,Ll,120316,120316,120316},{120317,Ll,120317,120317,120317},{120318,Ll,120318,120318,120318},{120319,Ll,120319,120319,120319},{120320,Ll,120320,120320,120320},{120321,Ll,120321,120321,120321},{120322,Ll,120322,120322,120322},{120323,Ll,120323,120323,120323},{120324,Ll,120324,120324,120324},{120325,Ll,120325,120325,120325},{120326,Ll,120326,120326,120326},{120327,Ll,120327,120327,120327},{120328,Lu,120328,120328,120328},{120329,Lu,120329,120329,120329},{120330,Lu,120330,120330,120330},{120331,Lu,120331,120331,120331},{120332,Lu,120332,120332,120332},{120333,Lu,120333,120333,120333},{120334,Lu,120334,120334,120334},{120335,Lu,120335,120335,120335},{120336,Lu,120336,120336,120336},{120337,Lu,120337,120337,120337},{120338,Lu,120338,120338,120338},{120339,Lu,120339,120339,120339},{120340,Lu,120340,120340,120340},{120341,Lu,120341,120341,120341},{120342,Lu,120342,120342,120342},{120343,Lu,120343,120343,120343},{120344,Lu,120344,120344,120344},{120345,Lu,120345,120345,120345},{120346,Lu,120346,120346,120346},{120347,Lu,120347,120347,120347},{120348,Lu,120348,120348,120348},{120349,Lu,120349,120349,120349},{120350,Lu,120350,120350,120350},{120351,Lu,120351,120351,120351},{120352,Lu,120352,120352,120352},{120353,Lu,120353,120353,120353},{120354,Ll,120354,120354,120354},{120355,Ll,120355,120355,120355},{120356,Ll,120356,120356,120356},{120357,Ll,120357,120357,120357},{120358,Ll,120358,120358,120358},{120359,Ll,120359,120359,120359},{120360,Ll,120360,120360,120360},{120361,Ll,120361,120361,120361},{120362,Ll,120362,120362,120362},{120363,Ll,120363,120363,120363},{120364,Ll,120364,120364,120364},{120365,Ll,120365,120365,120365},{120366,Ll,120366,120366,120366},{120367,Ll,120367,120367,120367},{120368,Ll,120368,120368,120368},{120369,Ll,120369,120369,120369},{120370,Ll,120370,120370,120370},{120371,Ll,120371,120371,120371},{120372,Ll,120372,120372,120372},{120373,Ll,120373,120373,120373},{120374,Ll,120374,120374,120374},{120375,Ll,120375,120375,120375},{120376,Ll,120376,120376,120376},{120377,Ll,120377,120377,120377},{120378,Ll,120378,120378,120378},{120379,Ll,120379,120379,120379},{120380,Lu,120380,120380,120380},{120381,Lu,120381,120381,120381},{120382,Lu,120382,120382,120382},{120383,Lu,120383,120383,120383},{120384,Lu,120384,120384,120384},{120385,Lu,120385,120385,120385},{120386,Lu,120386,120386,120386},{120387,Lu,120387,120387,120387},{120388,Lu,120388,120388,120388},{120389,Lu,120389,120389,120389},{120390,Lu,120390,120390,120390},{120391,Lu,120391,120391,120391},{120392,Lu,120392,120392,120392},{120393,Lu,120393,120393,120393},{120394,Lu,120394,120394,120394},{120395,Lu,120395,120395,120395},{120396,Lu,120396,120396,120396},{120397,Lu,120397,120397,120397},{120398,Lu,120398,120398,120398},{120399,Lu,120399,120399,120399},{120400,Lu,120400,120400,120400},{120401,Lu,120401,120401,120401},{120402,Lu,120402,120402,120402},{120403,Lu,120403,120403,120403},{120404,Lu,120404,120404,120404},{120405,Lu,120405,120405,120405},{120406,Ll,120406,120406,120406},{120407,Ll,120407,120407,120407},{120408,Ll,120408,120408,120408},{120409,Ll,120409,120409,120409},{120410,Ll,120410,120410,120410},{120411,Ll,120411,120411,120411},{120412,Ll,120412,120412,120412},{120413,Ll,120413,120413,120413},{120414,Ll,120414,120414,120414},{120415,Ll,120415,120415,120415},{120416,Ll,120416,120416,120416},{120417,Ll,120417,120417,120417},{120418,Ll,120418,120418,120418},{120419,Ll,120419,120419,120419},{120420,Ll,120420,120420,120420},{120421,Ll,120421,120421,120421},{120422,Ll,120422,120422,120422},{120423,Ll,120423,120423,120423},{120424,Ll,120424,120424,120424},{120425,Ll,120425,120425,120425},{120426,Ll,120426,120426,120426},{120427,Ll,120427,120427,120427},{120428,Ll,120428,120428,120428},{120429,Ll,120429,120429,120429},{120430,Ll,120430,120430,120430},{120431,Ll,120431,120431,120431},{120432,Lu,120432,120432,120432},{120433,Lu,120433,120433,120433},{120434,Lu,120434,120434,120434},{120435,Lu,120435,120435,120435},{120436,Lu,120436,120436,120436},{120437,Lu,120437,120437,120437},{120438,Lu,120438,120438,120438},{120439,Lu,120439,120439,120439},{120440,Lu,120440,120440,120440},{120441,Lu,120441,120441,120441},{120442,Lu,120442,120442,120442},{120443,Lu,120443,120443,120443},{120444,Lu,120444,120444,120444},{120445,Lu,120445,120445,120445},{120446,Lu,120446,120446,120446},{120447,Lu,120447,120447,120447},{120448,Lu,120448,120448,120448},{120449,Lu,120449,120449,120449},{120450,Lu,120450,120450,120450},{120451,Lu,120451,120451,120451},{120452,Lu,120452,120452,120452},{120453,Lu,120453,120453,120453},{120454,Lu,120454,120454,120454},{120455,Lu,120455,120455,120455},{120456,Lu,120456,120456,120456},{120457,Lu,120457,120457,120457},{120458,Ll,120458,120458,120458},{120459,Ll,120459,120459,120459},{120460,Ll,120460,120460,120460},{120461,Ll,120461,120461,120461},{120462,Ll,120462,120462,120462},{120463,Ll,120463,120463,120463},{120464,Ll,120464,120464,120464},{120465,Ll,120465,120465,120465},{120466,Ll,120466,120466,120466},{120467,Ll,120467,120467,120467},{120468,Ll,120468,120468,120468},{120469,Ll,120469,120469,120469},{120470,Ll,120470,120470,120470},{120471,Ll,120471,120471,120471},{120472,Ll,120472,120472,120472},{120473,Ll,120473,120473,120473},{120474,Ll,120474,120474,120474},{120475,Ll,120475,120475,120475},{120476,Ll,120476,120476,120476},{120477,Ll,120477,120477,120477},{120478,Ll,120478,120478,120478},{120479,Ll,120479,120479,120479},{120480,Ll,120480,120480,120480},{120481,Ll,120481,120481,120481},{120482,Ll,120482,120482,120482},{120483,Ll,120483,120483,120483},{120484,Ll,120484,120484,120484},{120485,Ll,120485,120485,120485},{120488,Lu,120488,120488,120488},{120489,Lu,120489,120489,120489},{120490,Lu,120490,120490,120490},{120491,Lu,120491,120491,120491},{120492,Lu,120492,120492,120492},{120493,Lu,120493,120493,120493},{120494,Lu,120494,120494,120494},{120495,Lu,120495,120495,120495},{120496,Lu,120496,120496,120496},{120497,Lu,120497,120497,120497},{120498,Lu,120498,120498,120498},{120499,Lu,120499,120499,120499},{120500,Lu,120500,120500,120500},{120501,Lu,120501,120501,120501},{120502,Lu,120502,120502,120502},{120503,Lu,120503,120503,120503},{120504,Lu,120504,120504,120504},{120505,Lu,120505,120505,120505},{120506,Lu,120506,120506,120506},{120507,Lu,120507,120507,120507},{120508,Lu,120508,120508,120508},{120509,Lu,120509,120509,120509},{120510,Lu,120510,120510,120510},{120511,Lu,120511,120511,120511},{120512,Lu,120512,120512,120512},{120513,Sm,120513,120513,120513},{120514,Ll,120514,120514,120514},{120515,Ll,120515,120515,120515},{120516,Ll,120516,120516,120516},{120517,Ll,120517,120517,120517},{120518,Ll,120518,120518,120518},{120519,Ll,120519,120519,120519},{120520,Ll,120520,120520,120520},{120521,Ll,120521,120521,120521},{120522,Ll,120522,120522,120522},{120523,Ll,120523,120523,120523},{120524,Ll,120524,120524,120524},{120525,Ll,120525,120525,120525},{120526,Ll,120526,120526,120526},{120527,Ll,120527,120527,120527},{120528,Ll,120528,120528,120528},{120529,Ll,120529,120529,120529},{120530,Ll,120530,120530,120530},{120531,Ll,120531,120531,120531},{120532,Ll,120532,120532,120532},{120533,Ll,120533,120533,120533},{120534,Ll,120534,120534,120534},{120535,Ll,120535,120535,120535},{120536,Ll,120536,120536,120536},{120537,Ll,120537,120537,120537},{120538,Ll,120538,120538,120538},{120539,Sm,120539,120539,120539},{120540,Ll,120540,120540,120540},{120541,Ll,120541,120541,120541},{120542,Ll,120542,120542,120542},{120543,Ll,120543,120543,120543},{120544,Ll,120544,120544,120544},{120545,Ll,120545,120545,120545},{120546,Lu,120546,120546,120546},{120547,Lu,120547,120547,120547},{120548,Lu,120548,120548,120548},{120549,Lu,120549,120549,120549},{120550,Lu,120550,120550,120550},{120551,Lu,120551,120551,120551},{120552,Lu,120552,120552,120552},{120553,Lu,120553,120553,120553},{120554,Lu,120554,120554,120554},{120555,Lu,120555,120555,120555},{120556,Lu,120556,120556,120556},{120557,Lu,120557,120557,120557},{120558,Lu,120558,120558,120558},{120559,Lu,120559,120559,120559},{120560,Lu,120560,120560,120560},{120561,Lu,120561,120561,120561},{120562,Lu,120562,120562,120562},{120563,Lu,120563,120563,120563},{120564,Lu,120564,120564,120564},{120565,Lu,120565,120565,120565},{120566,Lu,120566,120566,120566},{120567,Lu,120567,120567,120567},{120568,Lu,120568,120568,120568},{120569,Lu,120569,120569,120569},{120570,Lu,120570,120570,120570},{120571,Sm,120571,120571,120571},{120572,Ll,120572,120572,120572},{120573,Ll,120573,120573,120573},{120574,Ll,120574,120574,120574},{120575,Ll,120575,120575,120575},{120576,Ll,120576,120576,120576},{120577,Ll,120577,120577,120577},{120578,Ll,120578,120578,120578},{120579,Ll,120579,120579,120579},{120580,Ll,120580,120580,120580},{120581,Ll,120581,120581,120581},{120582,Ll,120582,120582,120582},{120583,Ll,120583,120583,120583},{120584,Ll,120584,120584,120584},{120585,Ll,120585,120585,120585},{120586,Ll,120586,120586,120586},{120587,Ll,120587,120587,120587},{120588,Ll,120588,120588,120588},{120589,Ll,120589,120589,120589},{120590,Ll,120590,120590,120590},{120591,Ll,120591,120591,120591},{120592,Ll,120592,120592,120592},{120593,Ll,120593,120593,120593},{120594,Ll,120594,120594,120594},{120595,Ll,120595,120595,120595},{120596,Ll,120596,120596,120596},{120597,Sm,120597,120597,120597},{120598,Ll,120598,120598,120598},{120599,Ll,120599,120599,120599},{120600,Ll,120600,120600,120600},{120601,Ll,120601,120601,120601},{120602,Ll,120602,120602,120602},{120603,Ll,120603,120603,120603},{120604,Lu,120604,120604,120604},{120605,Lu,120605,120605,120605},{120606,Lu,120606,120606,120606},{120607,Lu,120607,120607,120607},{120608,Lu,120608,120608,120608},{120609,Lu,120609,120609,120609},{120610,Lu,120610,120610,120610},{120611,Lu,120611,120611,120611},{120612,Lu,120612,120612,120612},{120613,Lu,120613,120613,120613},{120614,Lu,120614,120614,120614},{120615,Lu,120615,120615,120615},{120616,Lu,120616,120616,120616},{120617,Lu,120617,120617,120617},{120618,Lu,120618,120618,120618},{120619,Lu,120619,120619,120619},{120620,Lu,120620,120620,120620},{120621,Lu,120621,120621,120621},{120622,Lu,120622,120622,120622},{120623,Lu,120623,120623,120623},{120624,Lu,120624,120624,120624},{120625,Lu,120625,120625,120625},{120626,Lu,120626,120626,120626},{120627,Lu,120627,120627,120627},{120628,Lu,120628,120628,120628},{120629,Sm,120629,120629,120629},{120630,Ll,120630,120630,120630},{120631,Ll,120631,120631,120631},{120632,Ll,120632,120632,120632},{120633,Ll,120633,120633,120633},{120634,Ll,120634,120634,120634},{120635,Ll,120635,120635,120635},{120636,Ll,120636,120636,120636},{120637,Ll,120637,120637,120637},{120638,Ll,120638,120638,120638},{120639,Ll,120639,120639,120639},{120640,Ll,120640,120640,120640},{120641,Ll,120641,120641,120641},{120642,Ll,120642,120642,120642},{120643,Ll,120643,120643,120643},{120644,Ll,120644,120644,120644},{120645,Ll,120645,120645,120645},{120646,Ll,120646,120646,120646},{120647,Ll,120647,120647,120647},{120648,Ll,120648,120648,120648},{120649,Ll,120649,120649,120649},{120650,Ll,120650,120650,120650},{120651,Ll,120651,120651,120651},{120652,Ll,120652,120652,120652},{120653,Ll,120653,120653,120653},{120654,Ll,120654,120654,120654},{120655,Sm,120655,120655,120655},{120656,Ll,120656,120656,120656},{120657,Ll,120657,120657,120657},{120658,Ll,120658,120658,120658},{120659,Ll,120659,120659,120659},{120660,Ll,120660,120660,120660},{120661,Ll,120661,120661,120661},{120662,Lu,120662,120662,120662},{120663,Lu,120663,120663,120663},{120664,Lu,120664,120664,120664},{120665,Lu,120665,120665,120665},{120666,Lu,120666,120666,120666},{120667,Lu,120667,120667,120667},{120668,Lu,120668,120668,120668},{120669,Lu,120669,120669,120669},{120670,Lu,120670,120670,120670},{120671,Lu,120671,120671,120671},{120672,Lu,120672,120672,120672},{120673,Lu,120673,120673,120673},{120674,Lu,120674,120674,120674},{120675,Lu,120675,120675,120675},{120676,Lu,120676,120676,120676},{120677,Lu,120677,120677,120677},{120678,Lu,120678,120678,120678},{120679,Lu,120679,120679,120679},{120680,Lu,120680,120680,120680},{120681,Lu,120681,120681,120681},{120682,Lu,120682,120682,120682},{120683,Lu,120683,120683,120683},{120684,Lu,120684,120684,120684},{120685,Lu,120685,120685,120685},{120686,Lu,120686,120686,120686},{120687,Sm,120687,120687,120687},{120688,Ll,120688,120688,120688},{120689,Ll,120689,120689,120689},{120690,Ll,120690,120690,120690},{120691,Ll,120691,120691,120691},{120692,Ll,120692,120692,120692},{120693,Ll,120693,120693,120693},{120694,Ll,120694,120694,120694},{120695,Ll,120695,120695,120695},{120696,Ll,120696,120696,120696},{120697,Ll,120697,120697,120697},{120698,Ll,120698,120698,120698},{120699,Ll,120699,120699,120699},{120700,Ll,120700,120700,120700},{120701,Ll,120701,120701,120701},{120702,Ll,120702,120702,120702},{120703,Ll,120703,120703,120703},{120704,Ll,120704,120704,120704},{120705,Ll,120705,120705,120705},{120706,Ll,120706,120706,120706},{120707,Ll,120707,120707,120707},{120708,Ll,120708,120708,120708},{120709,Ll,120709,120709,120709},{120710,Ll,120710,120710,120710},{120711,Ll,120711,120711,120711},{120712,Ll,120712,120712,120712},{120713,Sm,120713,120713,120713},{120714,Ll,120714,120714,120714},{120715,Ll,120715,120715,120715},{120716,Ll,120716,120716,120716},{120717,Ll,120717,120717,120717},{120718,Ll,120718,120718,120718},{120719,Ll,120719,120719,120719},{120720,Lu,120720,120720,120720},{120721,Lu,120721,120721,120721},{120722,Lu,120722,120722,120722},{120723,Lu,120723,120723,120723},{120724,Lu,120724,120724,120724},{120725,Lu,120725,120725,120725},{120726,Lu,120726,120726,120726},{120727,Lu,120727,120727,120727},{120728,Lu,120728,120728,120728},{120729,Lu,120729,120729,120729},{120730,Lu,120730,120730,120730},{120731,Lu,120731,120731,120731},{120732,Lu,120732,120732,120732},{120733,Lu,120733,120733,120733},{120734,Lu,120734,120734,120734},{120735,Lu,120735,120735,120735},{120736,Lu,120736,120736,120736},{120737,Lu,120737,120737,120737},{120738,Lu,120738,120738,120738},{120739,Lu,120739,120739,120739},{120740,Lu,120740,120740,120740},{120741,Lu,120741,120741,120741},{120742,Lu,120742,120742,120742},{120743,Lu,120743,120743,120743},{120744,Lu,120744,120744,120744},{120745,Sm,120745,120745,120745},{120746,Ll,120746,120746,120746},{120747,Ll,120747,120747,120747},{120748,Ll,120748,120748,120748},{120749,Ll,120749,120749,120749},{120750,Ll,120750,120750,120750},{120751,Ll,120751,120751,120751},{120752,Ll,120752,120752,120752},{120753,Ll,120753,120753,120753},{120754,Ll,120754,120754,120754},{120755,Ll,120755,120755,120755},{120756,Ll,120756,120756,120756},{120757,Ll,120757,120757,120757},{120758,Ll,120758,120758,120758},{120759,Ll,120759,120759,120759},{120760,Ll,120760,120760,120760},{120761,Ll,120761,120761,120761},{120762,Ll,120762,120762,120762},{120763,Ll,120763,120763,120763},{120764,Ll,120764,120764,120764},{120765,Ll,120765,120765,120765},{120766,Ll,120766,120766,120766},{120767,Ll,120767,120767,120767},{120768,Ll,120768,120768,120768},{120769,Ll,120769,120769,120769},{120770,Ll,120770,120770,120770},{120771,Sm,120771,120771,120771},{120772,Ll,120772,120772,120772},{120773,Ll,120773,120773,120773},{120774,Ll,120774,120774,120774},{120775,Ll,120775,120775,120775},{120776,Ll,120776,120776,120776},{120777,Ll,120777,120777,120777},{120778,Lu,120778,120778,120778},{120779,Ll,120779,120779,120779},{120782,Nd,120782,120782,120782},{120783,Nd,120783,120783,120783},{120784,Nd,120784,120784,120784},{120785,Nd,120785,120785,120785},{120786,Nd,120786,120786,120786},{120787,Nd,120787,120787,120787},{120788,Nd,120788,120788,120788},{120789,Nd,120789,120789,120789},{120790,Nd,120790,120790,120790},{120791,Nd,120791,120791,120791},{120792,Nd,120792,120792,120792},{120793,Nd,120793,120793,120793},{120794,Nd,120794,120794,120794},{120795,Nd,120795,120795,120795},{120796,Nd,120796,120796,120796},{120797,Nd,120797,120797,120797},{120798,Nd,120798,120798,120798},{120799,Nd,120799,120799,120799},{120800,Nd,120800,120800,120800},{120801,Nd,120801,120801,120801},{120802,Nd,120802,120802,120802},{120803,Nd,120803,120803,120803},{120804,Nd,120804,120804,120804},{120805,Nd,120805,120805,120805},{120806,Nd,120806,120806,120806},{120807,Nd,120807,120807,120807},{120808,Nd,120808,120808,120808},{120809,Nd,120809,120809,120809},{120810,Nd,120810,120810,120810},{120811,Nd,120811,120811,120811},{120812,Nd,120812,120812,120812},{120813,Nd,120813,120813,120813},{120814,Nd,120814,120814,120814},{120815,Nd,120815,120815,120815},{120816,Nd,120816,120816,120816},{120817,Nd,120817,120817,120817},{120818,Nd,120818,120818,120818},{120819,Nd,120819,120819,120819},{120820,Nd,120820,120820,120820},{120821,Nd,120821,120821,120821},{120822,Nd,120822,120822,120822},{120823,Nd,120823,120823,120823},{120824,Nd,120824,120824,120824},{120825,Nd,120825,120825,120825},{120826,Nd,120826,120826,120826},{120827,Nd,120827,120827,120827},{120828,Nd,120828,120828,120828},{120829,Nd,120829,120829,120829},{120830,Nd,120830,120830,120830},{120831,Nd,120831,120831,120831},{131072,Lo,131072,131072,131072},{173782,Lo,173782,173782,173782},{194560,Lo,194560,194560,194560},{194561,Lo,194561,194561,194561},{194562,Lo,194562,194562,194562},{194563,Lo,194563,194563,194563},{194564,Lo,194564,194564,194564},{194565,Lo,194565,194565,194565},{194566,Lo,194566,194566,194566},{194567,Lo,194567,194567,194567},{194568,Lo,194568,194568,194568},{194569,Lo,194569,194569,194569},{194570,Lo,194570,194570,194570},{194571,Lo,194571,194571,194571},{194572,Lo,194572,194572,194572},{194573,Lo,194573,194573,194573},{194574,Lo,194574,194574,194574},{194575,Lo,194575,194575,194575},{194576,Lo,194576,194576,194576},{194577,Lo,194577,194577,194577},{194578,Lo,194578,194578,194578},{194579,Lo,194579,194579,194579},{194580,Lo,194580,194580,194580},{194581,Lo,194581,194581,194581},{194582,Lo,194582,194582,194582},{194583,Lo,194583,194583,194583},{194584,Lo,194584,194584,194584},{194585,Lo,194585,194585,194585},{194586,Lo,194586,194586,194586},{194587,Lo,194587,194587,194587},{194588,Lo,194588,194588,194588},{194589,Lo,194589,194589,194589},{194590,Lo,194590,194590,194590},{194591,Lo,194591,194591,194591},{194592,Lo,194592,194592,194592},{194593,Lo,194593,194593,194593},{194594,Lo,194594,194594,194594},{194595,Lo,194595,194595,194595},{194596,Lo,194596,194596,194596},{194597,Lo,194597,194597,194597},{194598,Lo,194598,194598,194598},{194599,Lo,194599,194599,194599},{194600,Lo,194600,194600,194600},{194601,Lo,194601,194601,194601},{194602,Lo,194602,194602,194602},{194603,Lo,194603,194603,194603},{194604,Lo,194604,194604,194604},{194605,Lo,194605,194605,194605},{194606,Lo,194606,194606,194606},{194607,Lo,194607,194607,194607},{194608,Lo,194608,194608,194608},{194609,Lo,194609,194609,194609},{194610,Lo,194610,194610,194610},{194611,Lo,194611,194611,194611},{194612,Lo,194612,194612,194612},{194613,Lo,194613,194613,194613},{194614,Lo,194614,194614,194614},{194615,Lo,194615,194615,194615},{194616,Lo,194616,194616,194616},{194617,Lo,194617,194617,194617},{194618,Lo,194618,194618,194618},{194619,Lo,194619,194619,194619},{194620,Lo,194620,194620,194620},{194621,Lo,194621,194621,194621},{194622,Lo,194622,194622,194622},{194623,Lo,194623,194623,194623},{194624,Lo,194624,194624,194624},{194625,Lo,194625,194625,194625},{194626,Lo,194626,194626,194626},{194627,Lo,194627,194627,194627},{194628,Lo,194628,194628,194628},{194629,Lo,194629,194629,194629},{194630,Lo,194630,194630,194630},{194631,Lo,194631,194631,194631},{194632,Lo,194632,194632,194632},{194633,Lo,194633,194633,194633},{194634,Lo,194634,194634,194634},{194635,Lo,194635,194635,194635},{194636,Lo,194636,194636,194636},{194637,Lo,194637,194637,194637},{194638,Lo,194638,194638,194638},{194639,Lo,194639,194639,194639},{194640,Lo,194640,194640,194640},{194641,Lo,194641,194641,194641},{194642,Lo,194642,194642,194642},{194643,Lo,194643,194643,194643},{194644,Lo,194644,194644,194644},{194645,Lo,194645,194645,194645},{194646,Lo,194646,194646,194646},{194647,Lo,194647,194647,194647},{194648,Lo,194648,194648,194648},{194649,Lo,194649,194649,194649},{194650,Lo,194650,194650,194650},{194651,Lo,194651,194651,194651},{194652,Lo,194652,194652,194652},{194653,Lo,194653,194653,194653},{194654,Lo,194654,194654,194654},{194655,Lo,194655,194655,194655},{194656,Lo,194656,194656,194656},{194657,Lo,194657,194657,194657},{194658,Lo,194658,194658,194658},{194659,Lo,194659,194659,194659},{194660,Lo,194660,194660,194660},{194661,Lo,194661,194661,194661},{194662,Lo,194662,194662,194662},{194663,Lo,194663,194663,194663},{194664,Lo,194664,194664,194664},{194665,Lo,194665,194665,194665},{194666,Lo,194666,194666,194666},{194667,Lo,194667,194667,194667},{194668,Lo,194668,194668,194668},{194669,Lo,194669,194669,194669},{194670,Lo,194670,194670,194670},{194671,Lo,194671,194671,194671},{194672,Lo,194672,194672,194672},{194673,Lo,194673,194673,194673},{194674,Lo,194674,194674,194674},{194675,Lo,194675,194675,194675},{194676,Lo,194676,194676,194676},{194677,Lo,194677,194677,194677},{194678,Lo,194678,194678,194678},{194679,Lo,194679,194679,194679},{194680,Lo,194680,194680,194680},{194681,Lo,194681,194681,194681},{194682,Lo,194682,194682,194682},{194683,Lo,194683,194683,194683},{194684,Lo,194684,194684,194684},{194685,Lo,194685,194685,194685},{194686,Lo,194686,194686,194686},{194687,Lo,194687,194687,194687},{194688,Lo,194688,194688,194688},{194689,Lo,194689,194689,194689},{194690,Lo,194690,194690,194690},{194691,Lo,194691,194691,194691},{194692,Lo,194692,194692,194692},{194693,Lo,194693,194693,194693},{194694,Lo,194694,194694,194694},{194695,Lo,194695,194695,194695},{194696,Lo,194696,194696,194696},{194697,Lo,194697,194697,194697},{194698,Lo,194698,194698,194698},{194699,Lo,194699,194699,194699},{194700,Lo,194700,194700,194700},{194701,Lo,194701,194701,194701},{194702,Lo,194702,194702,194702},{194703,Lo,194703,194703,194703},{194704,Lo,194704,194704,194704},{194705,Lo,194705,194705,194705},{194706,Lo,194706,194706,194706},{194707,Lo,194707,194707,194707},{194708,Lo,194708,194708,194708},{194709,Lo,194709,194709,194709},{194710,Lo,194710,194710,194710},{194711,Lo,194711,194711,194711},{194712,Lo,194712,194712,194712},{194713,Lo,194713,194713,194713},{194714,Lo,194714,194714,194714},{194715,Lo,194715,194715,194715},{194716,Lo,194716,194716,194716},{194717,Lo,194717,194717,194717},{194718,Lo,194718,194718,194718},{194719,Lo,194719,194719,194719},{194720,Lo,194720,194720,194720},{194721,Lo,194721,194721,194721},{194722,Lo,194722,194722,194722},{194723,Lo,194723,194723,194723},{194724,Lo,194724,194724,194724},{194725,Lo,194725,194725,194725},{194726,Lo,194726,194726,194726},{194727,Lo,194727,194727,194727},{194728,Lo,194728,194728,194728},{194729,Lo,194729,194729,194729},{194730,Lo,194730,194730,194730},{194731,Lo,194731,194731,194731},{194732,Lo,194732,194732,194732},{194733,Lo,194733,194733,194733},{194734,Lo,194734,194734,194734},{194735,Lo,194735,194735,194735},{194736,Lo,194736,194736,194736},{194737,Lo,194737,194737,194737},{194738,Lo,194738,194738,194738},{194739,Lo,194739,194739,194739},{194740,Lo,194740,194740,194740},{194741,Lo,194741,194741,194741},{194742,Lo,194742,194742,194742},{194743,Lo,194743,194743,194743},{194744,Lo,194744,194744,194744},{194745,Lo,194745,194745,194745},{194746,Lo,194746,194746,194746},{194747,Lo,194747,194747,194747},{194748,Lo,194748,194748,194748},{194749,Lo,194749,194749,194749},{194750,Lo,194750,194750,194750},{194751,Lo,194751,194751,194751},{194752,Lo,194752,194752,194752},{194753,Lo,194753,194753,194753},{194754,Lo,194754,194754,194754},{194755,Lo,194755,194755,194755},{194756,Lo,194756,194756,194756},{194757,Lo,194757,194757,194757},{194758,Lo,194758,194758,194758},{194759,Lo,194759,194759,194759},{194760,Lo,194760,194760,194760},{194761,Lo,194761,194761,194761},{194762,Lo,194762,194762,194762},{194763,Lo,194763,194763,194763},{194764,Lo,194764,194764,194764},{194765,Lo,194765,194765,194765},{194766,Lo,194766,194766,194766},{194767,Lo,194767,194767,194767},{194768,Lo,194768,194768,194768},{194769,Lo,194769,194769,194769},{194770,Lo,194770,194770,194770},{194771,Lo,194771,194771,194771},{194772,Lo,194772,194772,194772},{194773,Lo,194773,194773,194773},{194774,Lo,194774,194774,194774},{194775,Lo,194775,194775,194775},{194776,Lo,194776,194776,194776},{194777,Lo,194777,194777,194777},{194778,Lo,194778,194778,194778},{194779,Lo,194779,194779,194779},{194780,Lo,194780,194780,194780},{194781,Lo,194781,194781,194781},{194782,Lo,194782,194782,194782},{194783,Lo,194783,194783,194783},{194784,Lo,194784,194784,194784},{194785,Lo,194785,194785,194785},{194786,Lo,194786,194786,194786},{194787,Lo,194787,194787,194787},{194788,Lo,194788,194788,194788},{194789,Lo,194789,194789,194789},{194790,Lo,194790,194790,194790},{194791,Lo,194791,194791,194791},{194792,Lo,194792,194792,194792},{194793,Lo,194793,194793,194793},{194794,Lo,194794,194794,194794},{194795,Lo,194795,194795,194795},{194796,Lo,194796,194796,194796},{194797,Lo,194797,194797,194797},{194798,Lo,194798,194798,194798},{194799,Lo,194799,194799,194799},{194800,Lo,194800,194800,194800},{194801,Lo,194801,194801,194801},{194802,Lo,194802,194802,194802},{194803,Lo,194803,194803,194803},{194804,Lo,194804,194804,194804},{194805,Lo,194805,194805,194805},{194806,Lo,194806,194806,194806},{194807,Lo,194807,194807,194807},{194808,Lo,194808,194808,194808},{194809,Lo,194809,194809,194809},{194810,Lo,194810,194810,194810},{194811,Lo,194811,194811,194811},{194812,Lo,194812,194812,194812},{194813,Lo,194813,194813,194813},{194814,Lo,194814,194814,194814},{194815,Lo,194815,194815,194815},{194816,Lo,194816,194816,194816},{194817,Lo,194817,194817,194817},{194818,Lo,194818,194818,194818},{194819,Lo,194819,194819,194819},{194820,Lo,194820,194820,194820},{194821,Lo,194821,194821,194821},{194822,Lo,194822,194822,194822},{194823,Lo,194823,194823,194823},{194824,Lo,194824,194824,194824},{194825,Lo,194825,194825,194825},{194826,Lo,194826,194826,194826},{194827,Lo,194827,194827,194827},{194828,Lo,194828,194828,194828},{194829,Lo,194829,194829,194829},{194830,Lo,194830,194830,194830},{194831,Lo,194831,194831,194831},{194832,Lo,194832,194832,194832},{194833,Lo,194833,194833,194833},{194834,Lo,194834,194834,194834},{194835,Lo,194835,194835,194835},{194836,Lo,194836,194836,194836},{194837,Lo,194837,194837,194837},{194838,Lo,194838,194838,194838},{194839,Lo,194839,194839,194839},{194840,Lo,194840,194840,194840},{194841,Lo,194841,194841,194841},{194842,Lo,194842,194842,194842},{194843,Lo,194843,194843,194843},{194844,Lo,194844,194844,194844},{194845,Lo,194845,194845,194845},{194846,Lo,194846,194846,194846},{194847,Lo,194847,194847,194847},{194848,Lo,194848,194848,194848},{194849,Lo,194849,194849,194849},{194850,Lo,194850,194850,194850},{194851,Lo,194851,194851,194851},{194852,Lo,194852,194852,194852},{194853,Lo,194853,194853,194853},{194854,Lo,194854,194854,194854},{194855,Lo,194855,194855,194855},{194856,Lo,194856,194856,194856},{194857,Lo,194857,194857,194857},{194858,Lo,194858,194858,194858},{194859,Lo,194859,194859,194859},{194860,Lo,194860,194860,194860},{194861,Lo,194861,194861,194861},{194862,Lo,194862,194862,194862},{194863,Lo,194863,194863,194863},{194864,Lo,194864,194864,194864},{194865,Lo,194865,194865,194865},{194866,Lo,194866,194866,194866},{194867,Lo,194867,194867,194867},{194868,Lo,194868,194868,194868},{194869,Lo,194869,194869,194869},{194870,Lo,194870,194870,194870},{194871,Lo,194871,194871,194871},{194872,Lo,194872,194872,194872},{194873,Lo,194873,194873,194873},{194874,Lo,194874,194874,194874},{194875,Lo,194875,194875,194875},{194876,Lo,194876,194876,194876},{194877,Lo,194877,194877,194877},{194878,Lo,194878,194878,194878},{194879,Lo,194879,194879,194879},{194880,Lo,194880,194880,194880},{194881,Lo,194881,194881,194881},{194882,Lo,194882,194882,194882},{194883,Lo,194883,194883,194883},{194884,Lo,194884,194884,194884},{194885,Lo,194885,194885,194885},{194886,Lo,194886,194886,194886},{194887,Lo,194887,194887,194887},{194888,Lo,194888,194888,194888},{194889,Lo,194889,194889,194889},{194890,Lo,194890,194890,194890},{194891,Lo,194891,194891,194891},{194892,Lo,194892,194892,194892},{194893,Lo,194893,194893,194893},{194894,Lo,194894,194894,194894},{194895,Lo,194895,194895,194895},{194896,Lo,194896,194896,194896},{194897,Lo,194897,194897,194897},{194898,Lo,194898,194898,194898},{194899,Lo,194899,194899,194899},{194900,Lo,194900,194900,194900},{194901,Lo,194901,194901,194901},{194902,Lo,194902,194902,194902},{194903,Lo,194903,194903,194903},{194904,Lo,194904,194904,194904},{194905,Lo,194905,194905,194905},{194906,Lo,194906,194906,194906},{194907,Lo,194907,194907,194907},{194908,Lo,194908,194908,194908},{194909,Lo,194909,194909,194909},{194910,Lo,194910,194910,194910},{194911,Lo,194911,194911,194911},{194912,Lo,194912,194912,194912},{194913,Lo,194913,194913,194913},{194914,Lo,194914,194914,194914},{194915,Lo,194915,194915,194915},{194916,Lo,194916,194916,194916},{194917,Lo,194917,194917,194917},{194918,Lo,194918,194918,194918},{194919,Lo,194919,194919,194919},{194920,Lo,194920,194920,194920},{194921,Lo,194921,194921,194921},{194922,Lo,194922,194922,194922},{194923,Lo,194923,194923,194923},{194924,Lo,194924,194924,194924},{194925,Lo,194925,194925,194925},{194926,Lo,194926,194926,194926},{194927,Lo,194927,194927,194927},{194928,Lo,194928,194928,194928},{194929,Lo,194929,194929,194929},{194930,Lo,194930,194930,194930},{194931,Lo,194931,194931,194931},{194932,Lo,194932,194932,194932},{194933,Lo,194933,194933,194933},{194934,Lo,194934,194934,194934},{194935,Lo,194935,194935,194935},{194936,Lo,194936,194936,194936},{194937,Lo,194937,194937,194937},{194938,Lo,194938,194938,194938},{194939,Lo,194939,194939,194939},{194940,Lo,194940,194940,194940},{194941,Lo,194941,194941,194941},{194942,Lo,194942,194942,194942},{194943,Lo,194943,194943,194943},{194944,Lo,194944,194944,194944},{194945,Lo,194945,194945,194945},{194946,Lo,194946,194946,194946},{194947,Lo,194947,194947,194947},{194948,Lo,194948,194948,194948},{194949,Lo,194949,194949,194949},{194950,Lo,194950,194950,194950},{194951,Lo,194951,194951,194951},{194952,Lo,194952,194952,194952},{194953,Lo,194953,194953,194953},{194954,Lo,194954,194954,194954},{194955,Lo,194955,194955,194955},{194956,Lo,194956,194956,194956},{194957,Lo,194957,194957,194957},{194958,Lo,194958,194958,194958},{194959,Lo,194959,194959,194959},{194960,Lo,194960,194960,194960},{194961,Lo,194961,194961,194961},{194962,Lo,194962,194962,194962},{194963,Lo,194963,194963,194963},{194964,Lo,194964,194964,194964},{194965,Lo,194965,194965,194965},{194966,Lo,194966,194966,194966},{194967,Lo,194967,194967,194967},{194968,Lo,194968,194968,194968},{194969,Lo,194969,194969,194969},{194970,Lo,194970,194970,194970},{194971,Lo,194971,194971,194971},{194972,Lo,194972,194972,194972},{194973,Lo,194973,194973,194973},{194974,Lo,194974,194974,194974},{194975,Lo,194975,194975,194975},{194976,Lo,194976,194976,194976},{194977,Lo,194977,194977,194977},{194978,Lo,194978,194978,194978},{194979,Lo,194979,194979,194979},{194980,Lo,194980,194980,194980},{194981,Lo,194981,194981,194981},{194982,Lo,194982,194982,194982},{194983,Lo,194983,194983,194983},{194984,Lo,194984,194984,194984},{194985,Lo,194985,194985,194985},{194986,Lo,194986,194986,194986},{194987,Lo,194987,194987,194987},{194988,Lo,194988,194988,194988},{194989,Lo,194989,194989,194989},{194990,Lo,194990,194990,194990},{194991,Lo,194991,194991,194991},{194992,Lo,194992,194992,194992},{194993,Lo,194993,194993,194993},{194994,Lo,194994,194994,194994},{194995,Lo,194995,194995,194995},{194996,Lo,194996,194996,194996},{194997,Lo,194997,194997,194997},{194998,Lo,194998,194998,194998},{194999,Lo,194999,194999,194999},{195000,Lo,195000,195000,195000},{195001,Lo,195001,195001,195001},{195002,Lo,195002,195002,195002},{195003,Lo,195003,195003,195003},{195004,Lo,195004,195004,195004},{195005,Lo,195005,195005,195005},{195006,Lo,195006,195006,195006},{195007,Lo,195007,195007,195007},{195008,Lo,195008,195008,195008},{195009,Lo,195009,195009,195009},{195010,Lo,195010,195010,195010},{195011,Lo,195011,195011,195011},{195012,Lo,195012,195012,195012},{195013,Lo,195013,195013,195013},{195014,Lo,195014,195014,195014},{195015,Lo,195015,195015,195015},{195016,Lo,195016,195016,195016},{195017,Lo,195017,195017,195017},{195018,Lo,195018,195018,195018},{195019,Lo,195019,195019,195019},{195020,Lo,195020,195020,195020},{195021,Lo,195021,195021,195021},{195022,Lo,195022,195022,195022},{195023,Lo,195023,195023,195023},{195024,Lo,195024,195024,195024},{195025,Lo,195025,195025,195025},{195026,Lo,195026,195026,195026},{195027,Lo,195027,195027,195027},{195028,Lo,195028,195028,195028},{195029,Lo,195029,195029,195029},{195030,Lo,195030,195030,195030},{195031,Lo,195031,195031,195031},{195032,Lo,195032,195032,195032},{195033,Lo,195033,195033,195033},{195034,Lo,195034,195034,195034},{195035,Lo,195035,195035,195035},{195036,Lo,195036,195036,195036},{195037,Lo,195037,195037,195037},{195038,Lo,195038,195038,195038},{195039,Lo,195039,195039,195039},{195040,Lo,195040,195040,195040},{195041,Lo,195041,195041,195041},{195042,Lo,195042,195042,195042},{195043,Lo,195043,195043,195043},{195044,Lo,195044,195044,195044},{195045,Lo,195045,195045,195045},{195046,Lo,195046,195046,195046},{195047,Lo,195047,195047,195047},{195048,Lo,195048,195048,195048},{195049,Lo,195049,195049,195049},{195050,Lo,195050,195050,195050},{195051,Lo,195051,195051,195051},{195052,Lo,195052,195052,195052},{195053,Lo,195053,195053,195053},{195054,Lo,195054,195054,195054},{195055,Lo,195055,195055,195055},{195056,Lo,195056,195056,195056},{195057,Lo,195057,195057,195057},{195058,Lo,195058,195058,195058},{195059,Lo,195059,195059,195059},{195060,Lo,195060,195060,195060},{195061,Lo,195061,195061,195061},{195062,Lo,195062,195062,195062},{195063,Lo,195063,195063,195063},{195064,Lo,195064,195064,195064},{195065,Lo,195065,195065,195065},{195066,Lo,195066,195066,195066},{195067,Lo,195067,195067,195067},{195068,Lo,195068,195068,195068},{195069,Lo,195069,195069,195069},{195070,Lo,195070,195070,195070},{195071,Lo,195071,195071,195071},{195072,Lo,195072,195072,195072},{195073,Lo,195073,195073,195073},{195074,Lo,195074,195074,195074},{195075,Lo,195075,195075,195075},{195076,Lo,195076,195076,195076},{195077,Lo,195077,195077,195077},{195078,Lo,195078,195078,195078},{195079,Lo,195079,195079,195079},{195080,Lo,195080,195080,195080},{195081,Lo,195081,195081,195081},{195082,Lo,195082,195082,195082},{195083,Lo,195083,195083,195083},{195084,Lo,195084,195084,195084},{195085,Lo,195085,195085,195085},{195086,Lo,195086,195086,195086},{195087,Lo,195087,195087,195087},{195088,Lo,195088,195088,195088},{195089,Lo,195089,195089,195089},{195090,Lo,195090,195090,195090},{195091,Lo,195091,195091,195091},{195092,Lo,195092,195092,195092},{195093,Lo,195093,195093,195093},{195094,Lo,195094,195094,195094},{195095,Lo,195095,195095,195095},{195096,Lo,195096,195096,195096},{195097,Lo,195097,195097,195097},{195098,Lo,195098,195098,195098},{195099,Lo,195099,195099,195099},{195100,Lo,195100,195100,195100},{195101,Lo,195101,195101,195101},{917505,Cf,917505,917505,917505},{917536,Cf,917536,917536,917536},{917537,Cf,917537,917537,917537},{917538,Cf,917538,917538,917538},{917539,Cf,917539,917539,917539},{917540,Cf,917540,917540,917540},{917541,Cf,917541,917541,917541},{917542,Cf,917542,917542,917542},{917543,Cf,917543,917543,917543},{917544,Cf,917544,917544,917544},{917545,Cf,917545,917545,917545},{917546,Cf,917546,917546,917546},{917547,Cf,917547,917547,917547},{917548,Cf,917548,917548,917548},{917549,Cf,917549,917549,917549},{917550,Cf,917550,917550,917550},{917551,Cf,917551,917551,917551},{917552,Cf,917552,917552,917552},{917553,Cf,917553,917553,917553},{917554,Cf,917554,917554,917554},{917555,Cf,917555,917555,917555},{917556,Cf,917556,917556,917556},{917557,Cf,917557,917557,917557},{917558,Cf,917558,917558,917558},{917559,Cf,917559,917559,917559},{917560,Cf,917560,917560,917560},{917561,Cf,917561,917561,917561},{917562,Cf,917562,917562,917562},{917563,Cf,917563,917563,917563},{917564,Cf,917564,917564,917564},{917565,Cf,917565,917565,917565},{917566,Cf,917566,917566,917566},{917567,Cf,917567,917567,917567},{917568,Cf,917568,917568,917568},{917569,Cf,917569,917569,917569},{917570,Cf,917570,917570,917570},{917571,Cf,917571,917571,917571},{917572,Cf,917572,917572,917572},{917573,Cf,917573,917573,917573},{917574,Cf,917574,917574,917574},{917575,Cf,917575,917575,917575},{917576,Cf,917576,917576,917576},{917577,Cf,917577,917577,917577},{917578,Cf,917578,917578,917578},{917579,Cf,917579,917579,917579},{917580,Cf,917580,917580,917580},{917581,Cf,917581,917581,917581},{917582,Cf,917582,917582,917582},{917583,Cf,917583,917583,917583},{917584,Cf,917584,917584,917584},{917585,Cf,917585,917585,917585},{917586,Cf,917586,917586,917586},{917587,Cf,917587,917587,917587},{917588,Cf,917588,917588,917588},{917589,Cf,917589,917589,917589},{917590,Cf,917590,917590,917590},{917591,Cf,917591,917591,917591},{917592,Cf,917592,917592,917592},{917593,Cf,917593,917593,917593},{917594,Cf,917594,917594,917594},{917595,Cf,917595,917595,917595},{917596,Cf,917596,917596,917596},{917597,Cf,917597,917597,917597},{917598,Cf,917598,917598,917598},{917599,Cf,917599,917599,917599},{917600,Cf,917600,917600,917600},{917601,Cf,917601,917601,917601},{917602,Cf,917602,917602,917602},{917603,Cf,917603,917603,917603},{917604,Cf,917604,917604,917604},{917605,Cf,917605,917605,917605},{917606,Cf,917606,917606,917606},{917607,Cf,917607,917607,917607},{917608,Cf,917608,917608,917608},{917609,Cf,917609,917609,917609},{917610,Cf,917610,917610,917610},{917611,Cf,917611,917611,917611},{917612,Cf,917612,917612,917612},{917613,Cf,917613,917613,917613},{917614,Cf,917614,917614,917614},{917615,Cf,917615,917615,917615},{917616,Cf,917616,917616,917616},{917617,Cf,917617,917617,917617},{917618,Cf,917618,917618,917618},{917619,Cf,917619,917619,917619},{917620,Cf,917620,917620,917620},{917621,Cf,917621,917621,917621},{917622,Cf,917622,917622,917622},{917623,Cf,917623,917623,917623},{917624,Cf,917624,917624,917624},{917625,Cf,917625,917625,917625},{917626,Cf,917626,917626,917626},{917627,Cf,917627,917627,917627},{917628,Cf,917628,917628,917628},{917629,Cf,917629,917629,917629},{917630,Cf,917630,917630,917630},{917631,Cf,917631,917631,917631},{917760,Mn,917760,917760,917760},{917761,Mn,917761,917761,917761},{917762,Mn,917762,917762,917762},{917763,Mn,917763,917763,917763},{917764,Mn,917764,917764,917764},{917765,Mn,917765,917765,917765},{917766,Mn,917766,917766,917766},{917767,Mn,917767,917767,917767},{917768,Mn,917768,917768,917768},{917769,Mn,917769,917769,917769},{917770,Mn,917770,917770,917770},{917771,Mn,917771,917771,917771},{917772,Mn,917772,917772,917772},{917773,Mn,917773,917773,917773},{917774,Mn,917774,917774,917774},{917775,Mn,917775,917775,917775},{917776,Mn,917776,917776,917776},{917777,Mn,917777,917777,917777},{917778,Mn,917778,917778,917778},{917779,Mn,917779,917779,917779},{917780,Mn,917780,917780,917780},{917781,Mn,917781,917781,917781},{917782,Mn,917782,917782,917782},{917783,Mn,917783,917783,917783},{917784,Mn,917784,917784,917784},{917785,Mn,917785,917785,917785},{917786,Mn,917786,917786,917786},{917787,Mn,917787,917787,917787},{917788,Mn,917788,917788,917788},{917789,Mn,917789,917789,917789},{917790,Mn,917790,917790,917790},{917791,Mn,917791,917791,917791},{917792,Mn,917792,917792,917792},{917793,Mn,917793,917793,917793},{917794,Mn,917794,917794,917794},{917795,Mn,917795,917795,917795},{917796,Mn,917796,917796,917796},{917797,Mn,917797,917797,917797},{917798,Mn,917798,917798,917798},{917799,Mn,917799,917799,917799},{917800,Mn,917800,917800,917800},{917801,Mn,917801,917801,917801},{917802,Mn,917802,917802,917802},{917803,Mn,917803,917803,917803},{917804,Mn,917804,917804,917804},{917805,Mn,917805,917805,917805},{917806,Mn,917806,917806,917806},{917807,Mn,917807,917807,917807},{917808,Mn,917808,917808,917808},{917809,Mn,917809,917809,917809},{917810,Mn,917810,917810,917810},{917811,Mn,917811,917811,917811},{917812,Mn,917812,917812,917812},{917813,Mn,917813,917813,917813},{917814,Mn,917814,917814,917814},{917815,Mn,917815,917815,917815},{917816,Mn,917816,917816,917816},{917817,Mn,917817,917817,917817},{917818,Mn,917818,917818,917818},{917819,Mn,917819,917819,917819},{917820,Mn,917820,917820,917820},{917821,Mn,917821,917821,917821},{917822,Mn,917822,917822,917822},{917823,Mn,917823,917823,917823},{917824,Mn,917824,917824,917824},{917825,Mn,917825,917825,917825},{917826,Mn,917826,917826,917826},{917827,Mn,917827,917827,917827},{917828,Mn,917828,917828,917828},{917829,Mn,917829,917829,917829},{917830,Mn,917830,917830,917830},{917831,Mn,917831,917831,917831},{917832,Mn,917832,917832,917832},{917833,Mn,917833,917833,917833},{917834,Mn,917834,917834,917834},{917835,Mn,917835,917835,917835},{917836,Mn,917836,917836,917836},{917837,Mn,917837,917837,917837},{917838,Mn,917838,917838,917838},{917839,Mn,917839,917839,917839},{917840,Mn,917840,917840,917840},{917841,Mn,917841,917841,917841},{917842,Mn,917842,917842,917842},{917843,Mn,917843,917843,917843},{917844,Mn,917844,917844,917844},{917845,Mn,917845,917845,917845},{917846,Mn,917846,917846,917846},{917847,Mn,917847,917847,917847},{917848,Mn,917848,917848,917848},{917849,Mn,917849,917849,917849},{917850,Mn,917850,917850,917850},{917851,Mn,917851,917851,917851},{917852,Mn,917852,917852,917852},{917853,Mn,917853,917853,917853},{917854,Mn,917854,917854,917854},{917855,Mn,917855,917855,917855},{917856,Mn,917856,917856,917856},{917857,Mn,917857,917857,917857},{917858,Mn,917858,917858,917858},{917859,Mn,917859,917859,917859},{917860,Mn,917860,917860,917860},{917861,Mn,917861,917861,917861},{917862,Mn,917862,917862,917862},{917863,Mn,917863,917863,917863},{917864,Mn,917864,917864,917864},{917865,Mn,917865,917865,917865},{917866,Mn,917866,917866,917866},{917867,Mn,917867,917867,917867},{917868,Mn,917868,917868,917868},{917869,Mn,917869,917869,917869},{917870,Mn,917870,917870,917870},{917871,Mn,917871,917871,917871},{917872,Mn,917872,917872,917872},{917873,Mn,917873,917873,917873},{917874,Mn,917874,917874,917874},{917875,Mn,917875,917875,917875},{917876,Mn,917876,917876,917876},{917877,Mn,917877,917877,917877},{917878,Mn,917878,917878,917878},{917879,Mn,917879,917879,917879},{917880,Mn,917880,917880,917880},{917881,Mn,917881,917881,917881},{917882,Mn,917882,917882,917882},{917883,Mn,917883,917883,917883},{917884,Mn,917884,917884,917884},{917885,Mn,917885,917885,917885},{917886,Mn,917886,917886,917886},{917887,Mn,917887,917887,917887},{917888,Mn,917888,917888,917888},{917889,Mn,917889,917889,917889},{917890,Mn,917890,917890,917890},{917891,Mn,917891,917891,917891},{917892,Mn,917892,917892,917892},{917893,Mn,917893,917893,917893},{917894,Mn,917894,917894,917894},{917895,Mn,917895,917895,917895},{917896,Mn,917896,917896,917896},{917897,Mn,917897,917897,917897},{917898,Mn,917898,917898,917898},{917899,Mn,917899,917899,917899},{917900,Mn,917900,917900,917900},{917901,Mn,917901,917901,917901},{917902,Mn,917902,917902,917902},{917903,Mn,917903,917903,917903},{917904,Mn,917904,917904,917904},{917905,Mn,917905,917905,917905},{917906,Mn,917906,917906,917906},{917907,Mn,917907,917907,917907},{917908,Mn,917908,917908,917908},{917909,Mn,917909,917909,917909},{917910,Mn,917910,917910,917910},{917911,Mn,917911,917911,917911},{917912,Mn,917912,917912,917912},{917913,Mn,917913,917913,917913},{917914,Mn,917914,917914,917914},{917915,Mn,917915,917915,917915},{917916,Mn,917916,917916,917916},{917917,Mn,917917,917917,917917},{917918,Mn,917918,917918,917918},{917919,Mn,917919,917919,917919},{917920,Mn,917920,917920,917920},{917921,Mn,917921,917921,917921},{917922,Mn,917922,917922,917922},{917923,Mn,917923,917923,917923},{917924,Mn,917924,917924,917924},{917925,Mn,917925,917925,917925},{917926,Mn,917926,917926,917926},{917927,Mn,917927,917927,917927},{917928,Mn,917928,917928,917928},{917929,Mn,917929,917929,917929},{917930,Mn,917930,917930,917930},{917931,Mn,917931,917931,917931},{917932,Mn,917932,917932,917932},{917933,Mn,917933,917933,917933},{917934,Mn,917934,917934,917934},{917935,Mn,917935,917935,917935},{917936,Mn,917936,917936,917936},{917937,Mn,917937,917937,917937},{917938,Mn,917938,917938,917938},{917939,Mn,917939,917939,917939},{917940,Mn,917940,917940,917940},{917941,Mn,917941,917941,917941},{917942,Mn,917942,917942,917942},{917943,Mn,917943,917943,917943},{917944,Mn,917944,917944,917944},{917945,Mn,917945,917945,917945},{917946,Mn,917946,917946,917946},{917947,Mn,917947,917947,917947},{917948,Mn,917948,917948,917948},{917949,Mn,917949,917949,917949},{917950,Mn,917950,917950,917950},{917951,Mn,917951,917951,917951},{917952,Mn,917952,917952,917952},{917953,Mn,917953,917953,917953},{917954,Mn,917954,917954,917954},{917955,Mn,917955,917955,917955},{917956,Mn,917956,917956,917956},{917957,Mn,917957,917957,917957},{917958,Mn,917958,917958,917958},{917959,Mn,917959,917959,917959},{917960,Mn,917960,917960,917960},{917961,Mn,917961,917961,917961},{917962,Mn,917962,917962,917962},{917963,Mn,917963,917963,917963},{917964,Mn,917964,917964,917964},{917965,Mn,917965,917965,917965},{917966,Mn,917966,917966,917966},{917967,Mn,917967,917967,917967},{917968,Mn,917968,917968,917968},{917969,Mn,917969,917969,917969},{917970,Mn,917970,917970,917970},{917971,Mn,917971,917971,917971},{917972,Mn,917972,917972,917972},{917973,Mn,917973,917973,917973},{917974,Mn,917974,917974,917974},{917975,Mn,917975,917975,917975},{917976,Mn,917976,917976,917976},{917977,Mn,917977,917977,917977},{917978,Mn,917978,917978,917978},{917979,Mn,917979,917979,917979},{917980,Mn,917980,917980,917980},{917981,Mn,917981,917981,917981},{917982,Mn,917982,917982,917982},{917983,Mn,917983,917983,917983},{917984,Mn,917984,917984,917984},{917985,Mn,917985,917985,917985},{917986,Mn,917986,917986,917986},{917987,Mn,917987,917987,917987},{917988,Mn,917988,917988,917988},{917989,Mn,917989,917989,917989},{917990,Mn,917990,917990,917990},{917991,Mn,917991,917991,917991},{917992,Mn,917992,917992,917992},{917993,Mn,917993,917993,917993},{917994,Mn,917994,917994,917994},{917995,Mn,917995,917995,917995},{917996,Mn,917996,917996,917996},{917997,Mn,917997,917997,917997},{917998,Mn,917998,917998,917998},{917999,Mn,917999,917999,917999},{983040,Co,983040,983040,983040},{1048573,Co,1048573,1048573,1048573},{1048576,Co,1048576,1048576,1048576},{1114109,Co,1114109,1114109,1114109}];
    SpecialCaseData[] internalSpecialCaseData = [{code:223,upperCaseMapping:[83,83],lowerCaseMapping:[223],titleCaseMapping:[83,115]},{code:304,upperCaseMapping:[304],lowerCaseMapping:[105,775],titleCaseMapping:[304]},{code:329,upperCaseMapping:[700,78],lowerCaseMapping:[329],titleCaseMapping:[700,78]},{code:496,upperCaseMapping:[74,780],lowerCaseMapping:[496],titleCaseMapping:[74,780]},{code:912,upperCaseMapping:[921,776,769],lowerCaseMapping:[912],titleCaseMapping:[921,776,769]},{code:944,upperCaseMapping:[933,776,769],lowerCaseMapping:[944],titleCaseMapping:[933,776,769]},{code:1415,upperCaseMapping:[1333,1362],lowerCaseMapping:[1415],titleCaseMapping:[1333,1410]},{code:7830,upperCaseMapping:[72,817],lowerCaseMapping:[7830],titleCaseMapping:[72,817]},{code:7831,upperCaseMapping:[84,776],lowerCaseMapping:[7831],titleCaseMapping:[84,776]},{code:7832,upperCaseMapping:[87,778],lowerCaseMapping:[7832],titleCaseMapping:[87,778]},{code:7833,upperCaseMapping:[89,778],lowerCaseMapping:[7833],titleCaseMapping:[89,778]},{code:7834,upperCaseMapping:[65,702],lowerCaseMapping:[7834],titleCaseMapping:[65,702]},{code:8016,upperCaseMapping:[933,787],lowerCaseMapping:[8016],titleCaseMapping:[933,787]},{code:8018,upperCaseMapping:[933,787,768],lowerCaseMapping:[8018],titleCaseMapping:[933,787,768]},{code:8020,upperCaseMapping:[933,787,769],lowerCaseMapping:[8020],titleCaseMapping:[933,787,769]},{code:8022,upperCaseMapping:[933,787,834],lowerCaseMapping:[8022],titleCaseMapping:[933,787,834]},{code:8064,upperCaseMapping:[7944,921],lowerCaseMapping:[8064],titleCaseMapping:[8072]},{code:8065,upperCaseMapping:[7945,921],lowerCaseMapping:[8065],titleCaseMapping:[8073]},{code:8066,upperCaseMapping:[7946,921],lowerCaseMapping:[8066],titleCaseMapping:[8074]},{code:8067,upperCaseMapping:[7947,921],lowerCaseMapping:[8067],titleCaseMapping:[8075]},{code:8068,upperCaseMapping:[7948,921],lowerCaseMapping:[8068],titleCaseMapping:[8076]},{code:8069,upperCaseMapping:[7949,921],lowerCaseMapping:[8069],titleCaseMapping:[8077]},{code:8070,upperCaseMapping:[7950,921],lowerCaseMapping:[8070],titleCaseMapping:[8078]},{code:8071,upperCaseMapping:[7951,921],lowerCaseMapping:[8071],titleCaseMapping:[8079]},{code:8072,upperCaseMapping:[7944,921],lowerCaseMapping:[8064],titleCaseMapping:[8072]},{code:8073,upperCaseMapping:[7945,921],lowerCaseMapping:[8065],titleCaseMapping:[8073]},{code:8074,upperCaseMapping:[7946,921],lowerCaseMapping:[8066],titleCaseMapping:[8074]},{code:8075,upperCaseMapping:[7947,921],lowerCaseMapping:[8067],titleCaseMapping:[8075]},{code:8076,upperCaseMapping:[7948,921],lowerCaseMapping:[8068],titleCaseMapping:[8076]},{code:8077,upperCaseMapping:[7949,921],lowerCaseMapping:[8069],titleCaseMapping:[8077]},{code:8078,upperCaseMapping:[7950,921],lowerCaseMapping:[8070],titleCaseMapping:[8078]},{code:8079,upperCaseMapping:[7951,921],lowerCaseMapping:[8071],titleCaseMapping:[8079]},{code:8080,upperCaseMapping:[7976,921],lowerCaseMapping:[8080],titleCaseMapping:[8088]},{code:8081,upperCaseMapping:[7977,921],lowerCaseMapping:[8081],titleCaseMapping:[8089]},{code:8082,upperCaseMapping:[7978,921],lowerCaseMapping:[8082],titleCaseMapping:[8090]},{code:8083,upperCaseMapping:[7979,921],lowerCaseMapping:[8083],titleCaseMapping:[8091]},{code:8084,upperCaseMapping:[7980,921],lowerCaseMapping:[8084],titleCaseMapping:[8092]},{code:8085,upperCaseMapping:[7981,921],lowerCaseMapping:[8085],titleCaseMapping:[8093]},{code:8086,upperCaseMapping:[7982,921],lowerCaseMapping:[8086],titleCaseMapping:[8094]},{code:8087,upperCaseMapping:[7983,921],lowerCaseMapping:[8087],titleCaseMapping:[8095]},{code:8088,upperCaseMapping:[7976,921],lowerCaseMapping:[8080],titleCaseMapping:[8088]},{code:8089,upperCaseMapping:[7977,921],lowerCaseMapping:[8081],titleCaseMapping:[8089]},{code:8090,upperCaseMapping:[7978,921],lowerCaseMapping:[8082],titleCaseMapping:[8090]},{code:8091,upperCaseMapping:[7979,921],lowerCaseMapping:[8083],titleCaseMapping:[8091]},{code:8092,upperCaseMapping:[7980,921],lowerCaseMapping:[8084],titleCaseMapping:[8092]},{code:8093,upperCaseMapping:[7981,921],lowerCaseMapping:[8085],titleCaseMapping:[8093]},{code:8094,upperCaseMapping:[7982,921],lowerCaseMapping:[8086],titleCaseMapping:[8094]},{code:8095,upperCaseMapping:[7983,921],lowerCaseMapping:[8087],titleCaseMapping:[8095]},{code:8096,upperCaseMapping:[8040,921],lowerCaseMapping:[8096],titleCaseMapping:[8104]},{code:8097,upperCaseMapping:[8041,921],lowerCaseMapping:[8097],titleCaseMapping:[8105]},{code:8098,upperCaseMapping:[8042,921],lowerCaseMapping:[8098],titleCaseMapping:[8106]},{code:8099,upperCaseMapping:[8043,921],lowerCaseMapping:[8099],titleCaseMapping:[8107]},{code:8100,upperCaseMapping:[8044,921],lowerCaseMapping:[8100],titleCaseMapping:[8108]},{code:8101,upperCaseMapping:[8045,921],lowerCaseMapping:[8101],titleCaseMapping:[8109]},{code:8102,upperCaseMapping:[8046,921],lowerCaseMapping:[8102],titleCaseMapping:[8110]},{code:8103,upperCaseMapping:[8047,921],lowerCaseMapping:[8103],titleCaseMapping:[8111]},{code:8104,upperCaseMapping:[8040,921],lowerCaseMapping:[8096],titleCaseMapping:[8104]},{code:8105,upperCaseMapping:[8041,921],lowerCaseMapping:[8097],titleCaseMapping:[8105]},{code:8106,upperCaseMapping:[8042,921],lowerCaseMapping:[8098],titleCaseMapping:[8106]},{code:8107,upperCaseMapping:[8043,921],lowerCaseMapping:[8099],titleCaseMapping:[8107]},{code:8108,upperCaseMapping:[8044,921],lowerCaseMapping:[8100],titleCaseMapping:[8108]},{code:8109,upperCaseMapping:[8045,921],lowerCaseMapping:[8101],titleCaseMapping:[8109]},{code:8110,upperCaseMapping:[8046,921],lowerCaseMapping:[8102],titleCaseMapping:[8110]},{code:8111,upperCaseMapping:[8047,921],lowerCaseMapping:[8103],titleCaseMapping:[8111]},{code:8114,upperCaseMapping:[8122,921],lowerCaseMapping:[8114],titleCaseMapping:[8122,837]},{code:8115,upperCaseMapping:[913,921],lowerCaseMapping:[8115],titleCaseMapping:[8124]},{code:8116,upperCaseMapping:[902,921],lowerCaseMapping:[8116],titleCaseMapping:[902,837]},{code:8118,upperCaseMapping:[913,834],lowerCaseMapping:[8118],titleCaseMapping:[913,834]},{code:8119,upperCaseMapping:[913,834,921],lowerCaseMapping:[8119],titleCaseMapping:[913,834,837]},{code:8124,upperCaseMapping:[913,921],lowerCaseMapping:[8115],titleCaseMapping:[8124]},{code:8130,upperCaseMapping:[8138,921],lowerCaseMapping:[8130],titleCaseMapping:[8138,837]},{code:8131,upperCaseMapping:[919,921],lowerCaseMapping:[8131],titleCaseMapping:[8140]},{code:8132,upperCaseMapping:[905,921],lowerCaseMapping:[8132],titleCaseMapping:[905,837]},{code:8134,upperCaseMapping:[919,834],lowerCaseMapping:[8134],titleCaseMapping:[919,834]},{code:8135,upperCaseMapping:[919,834,921],lowerCaseMapping:[8135],titleCaseMapping:[919,834,837]},{code:8140,upperCaseMapping:[919,921],lowerCaseMapping:[8131],titleCaseMapping:[8140]},{code:8146,upperCaseMapping:[921,776,768],lowerCaseMapping:[8146],titleCaseMapping:[921,776,768]},{code:8147,upperCaseMapping:[921,776,769],lowerCaseMapping:[8147],titleCaseMapping:[921,776,769]},{code:8150,upperCaseMapping:[921,834],lowerCaseMapping:[8150],titleCaseMapping:[921,834]},{code:8151,upperCaseMapping:[921,776,834],lowerCaseMapping:[8151],titleCaseMapping:[921,776,834]},{code:8162,upperCaseMapping:[933,776,768],lowerCaseMapping:[8162],titleCaseMapping:[933,776,768]},{code:8163,upperCaseMapping:[933,776,769],lowerCaseMapping:[8163],titleCaseMapping:[933,776,769]},{code:8164,upperCaseMapping:[929,787],lowerCaseMapping:[8164],titleCaseMapping:[929,787]},{code:8166,upperCaseMapping:[933,834],lowerCaseMapping:[8166],titleCaseMapping:[933,834]},{code:8167,upperCaseMapping:[933,776,834],lowerCaseMapping:[8167],titleCaseMapping:[933,776,834]},{code:8178,upperCaseMapping:[8186,921],lowerCaseMapping:[8178],titleCaseMapping:[8186,837]},{code:8179,upperCaseMapping:[937,921],lowerCaseMapping:[8179],titleCaseMapping:[8188]},{code:8180,upperCaseMapping:[911,921],lowerCaseMapping:[8180],titleCaseMapping:[911,837]},{code:8182,upperCaseMapping:[937,834],lowerCaseMapping:[8182],titleCaseMapping:[937,834]},{code:8183,upperCaseMapping:[937,834,921],lowerCaseMapping:[8183],titleCaseMapping:[937,834,837]},{code:8188,upperCaseMapping:[937,921],lowerCaseMapping:[8179],titleCaseMapping:[8188]},{code:64256,upperCaseMapping:[70,70],lowerCaseMapping:[64256],titleCaseMapping:[70,102]},{code:64257,upperCaseMapping:[70,73],lowerCaseMapping:[64257],titleCaseMapping:[70,105]},{code:64258,upperCaseMapping:[70,76],lowerCaseMapping:[64258],titleCaseMapping:[70,108]},{code:64259,upperCaseMapping:[70,70,73],lowerCaseMapping:[64259],titleCaseMapping:[70,102,105]},{code:64260,upperCaseMapping:[70,70,76],lowerCaseMapping:[64260],titleCaseMapping:[70,102,108]},{code:64261,upperCaseMapping:[83,84],lowerCaseMapping:[64261],titleCaseMapping:[83,116]},{code:64262,upperCaseMapping:[83,84],lowerCaseMapping:[64262],titleCaseMapping:[83,116]},{code:64275,upperCaseMapping:[1348,1350],lowerCaseMapping:[64275],titleCaseMapping:[1348,1398]},{code:64276,upperCaseMapping:[1348,1333],lowerCaseMapping:[64276],titleCaseMapping:[1348,1381]},{code:64277,upperCaseMapping:[1348,1339],lowerCaseMapping:[64277],titleCaseMapping:[1348,1387]},{code:64278,upperCaseMapping:[1358,1350],lowerCaseMapping:[64278],titleCaseMapping:[1358,1398]},{code:64279,upperCaseMapping:[1348,1341],lowerCaseMapping:[64279],titleCaseMapping:[1348,1389]}];
    FoldingCaseData[] internalFoldingCaseData = [{code:65,mapping:[97]},{code:66,mapping:[98]},{code:67,mapping:[99]},{code:68,mapping:[100]},{code:69,mapping:[101]},{code:70,mapping:[102]},{code:71,mapping:[103]},{code:72,mapping:[104]},{code:73,mapping:[105]},{code:74,mapping:[106]},{code:75,mapping:[107]},{code:76,mapping:[108]},{code:77,mapping:[109]},{code:78,mapping:[110]},{code:79,mapping:[111]},{code:80,mapping:[112]},{code:81,mapping:[113]},{code:82,mapping:[114]},{code:83,mapping:[115]},{code:84,mapping:[116]},{code:85,mapping:[117]},{code:86,mapping:[118]},{code:87,mapping:[119]},{code:88,mapping:[120]},{code:89,mapping:[121]},{code:90,mapping:[122]},{code:181,mapping:[956]},{code:192,mapping:[224]},{code:193,mapping:[225]},{code:194,mapping:[226]},{code:195,mapping:[227]},{code:196,mapping:[228]},{code:197,mapping:[229]},{code:198,mapping:[230]},{code:199,mapping:[231]},{code:200,mapping:[232]},{code:201,mapping:[233]},{code:202,mapping:[234]},{code:203,mapping:[235]},{code:204,mapping:[236]},{code:205,mapping:[237]},{code:206,mapping:[238]},{code:207,mapping:[239]},{code:208,mapping:[240]},{code:209,mapping:[241]},{code:210,mapping:[242]},{code:211,mapping:[243]},{code:212,mapping:[244]},{code:213,mapping:[245]},{code:214,mapping:[246]},{code:216,mapping:[248]},{code:217,mapping:[249]},{code:218,mapping:[250]},{code:219,mapping:[251]},{code:220,mapping:[252]},{code:221,mapping:[253]},{code:222,mapping:[254]},{code:223,mapping:[115,115]},{code:256,mapping:[257]},{code:258,mapping:[259]},{code:260,mapping:[261]},{code:262,mapping:[263]},{code:264,mapping:[265]},{code:266,mapping:[267]},{code:268,mapping:[269]},{code:270,mapping:[271]},{code:272,mapping:[273]},{code:274,mapping:[275]},{code:276,mapping:[277]},{code:278,mapping:[279]},{code:280,mapping:[281]},{code:282,mapping:[283]},{code:284,mapping:[285]},{code:286,mapping:[287]},{code:288,mapping:[289]},{code:290,mapping:[291]},{code:292,mapping:[293]},{code:294,mapping:[295]},{code:296,mapping:[297]},{code:298,mapping:[299]},{code:300,mapping:[301]},{code:302,mapping:[303]},{code:304,mapping:[105,775]},{code:306,mapping:[307]},{code:308,mapping:[309]},{code:310,mapping:[311]},{code:313,mapping:[314]},{code:315,mapping:[316]},{code:317,mapping:[318]},{code:319,mapping:[320]},{code:321,mapping:[322]},{code:323,mapping:[324]},{code:325,mapping:[326]},{code:327,mapping:[328]},{code:329,mapping:[700,110]},{code:330,mapping:[331]},{code:332,mapping:[333]},{code:334,mapping:[335]},{code:336,mapping:[337]},{code:338,mapping:[339]},{code:340,mapping:[341]},{code:342,mapping:[343]},{code:344,mapping:[345]},{code:346,mapping:[347]},{code:348,mapping:[349]},{code:350,mapping:[351]},{code:352,mapping:[353]},{code:354,mapping:[355]},{code:356,mapping:[357]},{code:358,mapping:[359]},{code:360,mapping:[361]},{code:362,mapping:[363]},{code:364,mapping:[365]},{code:366,mapping:[367]},{code:368,mapping:[369]},{code:370,mapping:[371]},{code:372,mapping:[373]},{code:374,mapping:[375]},{code:376,mapping:[255]},{code:377,mapping:[378]},{code:379,mapping:[380]},{code:381,mapping:[382]},{code:383,mapping:[115]},{code:385,mapping:[595]},{code:386,mapping:[387]},{code:388,mapping:[389]},{code:390,mapping:[596]},{code:391,mapping:[392]},{code:393,mapping:[598]},{code:394,mapping:[599]},{code:395,mapping:[396]},{code:398,mapping:[477]},{code:399,mapping:[601]},{code:400,mapping:[603]},{code:401,mapping:[402]},{code:403,mapping:[608]},{code:404,mapping:[611]},{code:406,mapping:[617]},{code:407,mapping:[616]},{code:408,mapping:[409]},{code:412,mapping:[623]},{code:413,mapping:[626]},{code:415,mapping:[629]},{code:416,mapping:[417]},{code:418,mapping:[419]},{code:420,mapping:[421]},{code:422,mapping:[640]},{code:423,mapping:[424]},{code:425,mapping:[643]},{code:428,mapping:[429]},{code:430,mapping:[648]},{code:431,mapping:[432]},{code:433,mapping:[650]},{code:434,mapping:[651]},{code:435,mapping:[436]},{code:437,mapping:[438]},{code:439,mapping:[658]},{code:440,mapping:[441]},{code:444,mapping:[445]},{code:452,mapping:[454]},{code:453,mapping:[454]},{code:455,mapping:[457]},{code:456,mapping:[457]},{code:458,mapping:[460]},{code:459,mapping:[460]},{code:461,mapping:[462]},{code:463,mapping:[464]},{code:465,mapping:[466]},{code:467,mapping:[468]},{code:469,mapping:[470]},{code:471,mapping:[472]},{code:473,mapping:[474]},{code:475,mapping:[476]},{code:478,mapping:[479]},{code:480,mapping:[481]},{code:482,mapping:[483]},{code:484,mapping:[485]},{code:486,mapping:[487]},{code:488,mapping:[489]},{code:490,mapping:[491]},{code:492,mapping:[493]},{code:494,mapping:[495]},{code:496,mapping:[106,780]},{code:497,mapping:[499]},{code:498,mapping:[499]},{code:500,mapping:[501]},{code:502,mapping:[405]},{code:503,mapping:[447]},{code:504,mapping:[505]},{code:506,mapping:[507]},{code:508,mapping:[509]},{code:510,mapping:[511]},{code:512,mapping:[513]},{code:514,mapping:[515]},{code:516,mapping:[517]},{code:518,mapping:[519]},{code:520,mapping:[521]},{code:522,mapping:[523]},{code:524,mapping:[525]},{code:526,mapping:[527]},{code:528,mapping:[529]},{code:530,mapping:[531]},{code:532,mapping:[533]},{code:534,mapping:[535]},{code:536,mapping:[537]},{code:538,mapping:[539]},{code:540,mapping:[541]},{code:542,mapping:[543]},{code:544,mapping:[414]},{code:546,mapping:[547]},{code:548,mapping:[549]},{code:550,mapping:[551]},{code:552,mapping:[553]},{code:554,mapping:[555]},{code:556,mapping:[557]},{code:558,mapping:[559]},{code:560,mapping:[561]},{code:562,mapping:[563]},{code:570,mapping:[11365]},{code:571,mapping:[572]},{code:573,mapping:[410]},{code:574,mapping:[11366]},{code:577,mapping:[578]},{code:579,mapping:[384]},{code:580,mapping:[649]},{code:581,mapping:[652]},{code:582,mapping:[583]},{code:584,mapping:[585]},{code:586,mapping:[587]},{code:588,mapping:[589]},{code:590,mapping:[591]},{code:837,mapping:[953]},{code:902,mapping:[940]},{code:904,mapping:[941]},{code:905,mapping:[942]},{code:906,mapping:[943]},{code:908,mapping:[972]},{code:910,mapping:[973]},{code:911,mapping:[974]},{code:912,mapping:[953,776,769]},{code:913,mapping:[945]},{code:914,mapping:[946]},{code:915,mapping:[947]},{code:916,mapping:[948]},{code:917,mapping:[949]},{code:918,mapping:[950]},{code:919,mapping:[951]},{code:920,mapping:[952]},{code:921,mapping:[953]},{code:922,mapping:[954]},{code:923,mapping:[955]},{code:924,mapping:[956]},{code:925,mapping:[957]},{code:926,mapping:[958]},{code:927,mapping:[959]},{code:928,mapping:[960]},{code:929,mapping:[961]},{code:931,mapping:[963]},{code:932,mapping:[964]},{code:933,mapping:[965]},{code:934,mapping:[966]},{code:935,mapping:[967]},{code:936,mapping:[968]},{code:937,mapping:[969]},{code:938,mapping:[970]},{code:939,mapping:[971]},{code:944,mapping:[965,776,769]},{code:962,mapping:[963]},{code:976,mapping:[946]},{code:977,mapping:[952]},{code:981,mapping:[966]},{code:982,mapping:[960]},{code:984,mapping:[985]},{code:986,mapping:[987]},{code:988,mapping:[989]},{code:990,mapping:[991]},{code:992,mapping:[993]},{code:994,mapping:[995]},{code:996,mapping:[997]},{code:998,mapping:[999]},{code:1000,mapping:[1001]},{code:1002,mapping:[1003]},{code:1004,mapping:[1005]},{code:1006,mapping:[1007]},{code:1008,mapping:[954]},{code:1009,mapping:[961]},{code:1012,mapping:[952]},{code:1013,mapping:[949]},{code:1015,mapping:[1016]},{code:1017,mapping:[1010]},{code:1018,mapping:[1019]},{code:1021,mapping:[891]},{code:1022,mapping:[892]},{code:1023,mapping:[893]},{code:1024,mapping:[1104]},{code:1025,mapping:[1105]},{code:1026,mapping:[1106]},{code:1027,mapping:[1107]},{code:1028,mapping:[1108]},{code:1029,mapping:[1109]},{code:1030,mapping:[1110]},{code:1031,mapping:[1111]},{code:1032,mapping:[1112]},{code:1033,mapping:[1113]},{code:1034,mapping:[1114]},{code:1035,mapping:[1115]},{code:1036,mapping:[1116]},{code:1037,mapping:[1117]},{code:1038,mapping:[1118]},{code:1039,mapping:[1119]},{code:1040,mapping:[1072]},{code:1041,mapping:[1073]},{code:1042,mapping:[1074]},{code:1043,mapping:[1075]},{code:1044,mapping:[1076]},{code:1045,mapping:[1077]},{code:1046,mapping:[1078]},{code:1047,mapping:[1079]},{code:1048,mapping:[1080]},{code:1049,mapping:[1081]},{code:1050,mapping:[1082]},{code:1051,mapping:[1083]},{code:1052,mapping:[1084]},{code:1053,mapping:[1085]},{code:1054,mapping:[1086]},{code:1055,mapping:[1087]},{code:1056,mapping:[1088]},{code:1057,mapping:[1089]},{code:1058,mapping:[1090]},{code:1059,mapping:[1091]},{code:1060,mapping:[1092]},{code:1061,mapping:[1093]},{code:1062,mapping:[1094]},{code:1063,mapping:[1095]},{code:1064,mapping:[1096]},{code:1065,mapping:[1097]},{code:1066,mapping:[1098]},{code:1067,mapping:[1099]},{code:1068,mapping:[1100]},{code:1069,mapping:[1101]},{code:1070,mapping:[1102]},{code:1071,mapping:[1103]},{code:1120,mapping:[1121]},{code:1122,mapping:[1123]},{code:1124,mapping:[1125]},{code:1126,mapping:[1127]},{code:1128,mapping:[1129]},{code:1130,mapping:[1131]},{code:1132,mapping:[1133]},{code:1134,mapping:[1135]},{code:1136,mapping:[1137]},{code:1138,mapping:[1139]},{code:1140,mapping:[1141]},{code:1142,mapping:[1143]},{code:1144,mapping:[1145]},{code:1146,mapping:[1147]},{code:1148,mapping:[1149]},{code:1150,mapping:[1151]},{code:1152,mapping:[1153]},{code:1162,mapping:[1163]},{code:1164,mapping:[1165]},{code:1166,mapping:[1167]},{code:1168,mapping:[1169]},{code:1170,mapping:[1171]},{code:1172,mapping:[1173]},{code:1174,mapping:[1175]},{code:1176,mapping:[1177]},{code:1178,mapping:[1179]},{code:1180,mapping:[1181]},{code:1182,mapping:[1183]},{code:1184,mapping:[1185]},{code:1186,mapping:[1187]},{code:1188,mapping:[1189]},{code:1190,mapping:[1191]},{code:1192,mapping:[1193]},{code:1194,mapping:[1195]},{code:1196,mapping:[1197]},{code:1198,mapping:[1199]},{code:1200,mapping:[1201]},{code:1202,mapping:[1203]},{code:1204,mapping:[1205]},{code:1206,mapping:[1207]},{code:1208,mapping:[1209]},{code:1210,mapping:[1211]},{code:1212,mapping:[1213]},{code:1214,mapping:[1215]},{code:1216,mapping:[1231]},{code:1217,mapping:[1218]},{code:1219,mapping:[1220]},{code:1221,mapping:[1222]},{code:1223,mapping:[1224]},{code:1225,mapping:[1226]},{code:1227,mapping:[1228]},{code:1229,mapping:[1230]},{code:1232,mapping:[1233]},{code:1234,mapping:[1235]},{code:1236,mapping:[1237]},{code:1238,mapping:[1239]},{code:1240,mapping:[1241]},{code:1242,mapping:[1243]},{code:1244,mapping:[1245]},{code:1246,mapping:[1247]},{code:1248,mapping:[1249]},{code:1250,mapping:[1251]},{code:1252,mapping:[1253]},{code:1254,mapping:[1255]},{code:1256,mapping:[1257]},{code:1258,mapping:[1259]},{code:1260,mapping:[1261]},{code:1262,mapping:[1263]},{code:1264,mapping:[1265]},{code:1266,mapping:[1267]},{code:1268,mapping:[1269]},{code:1270,mapping:[1271]},{code:1272,mapping:[1273]},{code:1274,mapping:[1275]},{code:1276,mapping:[1277]},{code:1278,mapping:[1279]},{code:1280,mapping:[1281]},{code:1282,mapping:[1283]},{code:1284,mapping:[1285]},{code:1286,mapping:[1287]},{code:1288,mapping:[1289]},{code:1290,mapping:[1291]},{code:1292,mapping:[1293]},{code:1294,mapping:[1295]},{code:1296,mapping:[1297]},{code:1298,mapping:[1299]},{code:1329,mapping:[1377]},{code:1330,mapping:[1378]},{code:1331,mapping:[1379]},{code:1332,mapping:[1380]},{code:1333,mapping:[1381]},{code:1334,mapping:[1382]},{code:1335,mapping:[1383]},{code:1336,mapping:[1384]},{code:1337,mapping:[1385]},{code:1338,mapping:[1386]},{code:1339,mapping:[1387]},{code:1340,mapping:[1388]},{code:1341,mapping:[1389]},{code:1342,mapping:[1390]},{code:1343,mapping:[1391]},{code:1344,mapping:[1392]},{code:1345,mapping:[1393]},{code:1346,mapping:[1394]},{code:1347,mapping:[1395]},{code:1348,mapping:[1396]},{code:1349,mapping:[1397]},{code:1350,mapping:[1398]},{code:1351,mapping:[1399]},{code:1352,mapping:[1400]},{code:1353,mapping:[1401]},{code:1354,mapping:[1402]},{code:1355,mapping:[1403]},{code:1356,mapping:[1404]},{code:1357,mapping:[1405]},{code:1358,mapping:[1406]},{code:1359,mapping:[1407]},{code:1360,mapping:[1408]},{code:1361,mapping:[1409]},{code:1362,mapping:[1410]},{code:1363,mapping:[1411]},{code:1364,mapping:[1412]},{code:1365,mapping:[1413]},{code:1366,mapping:[1414]},{code:1415,mapping:[1381,1410]},{code:4256,mapping:[11520]},{code:4257,mapping:[11521]},{code:4258,mapping:[11522]},{code:4259,mapping:[11523]},{code:4260,mapping:[11524]},{code:4261,mapping:[11525]},{code:4262,mapping:[11526]},{code:4263,mapping:[11527]},{code:4264,mapping:[11528]},{code:4265,mapping:[11529]},{code:4266,mapping:[11530]},{code:4267,mapping:[11531]},{code:4268,mapping:[11532]},{code:4269,mapping:[11533]},{code:4270,mapping:[11534]},{code:4271,mapping:[11535]},{code:4272,mapping:[11536]},{code:4273,mapping:[11537]},{code:4274,mapping:[11538]},{code:4275,mapping:[11539]},{code:4276,mapping:[11540]},{code:4277,mapping:[11541]},{code:4278,mapping:[11542]},{code:4279,mapping:[11543]},{code:4280,mapping:[11544]},{code:4281,mapping:[11545]},{code:4282,mapping:[11546]},{code:4283,mapping:[11547]},{code:4284,mapping:[11548]},{code:4285,mapping:[11549]},{code:4286,mapping:[11550]},{code:4287,mapping:[11551]},{code:4288,mapping:[11552]},{code:4289,mapping:[11553]},{code:4290,mapping:[11554]},{code:4291,mapping:[11555]},{code:4292,mapping:[11556]},{code:4293,mapping:[11557]},{code:7680,mapping:[7681]},{code:7682,mapping:[7683]},{code:7684,mapping:[7685]},{code:7686,mapping:[7687]},{code:7688,mapping:[7689]},{code:7690,mapping:[7691]},{code:7692,mapping:[7693]},{code:7694,mapping:[7695]},{code:7696,mapping:[7697]},{code:7698,mapping:[7699]},{code:7700,mapping:[7701]},{code:7702,mapping:[7703]},{code:7704,mapping:[7705]},{code:7706,mapping:[7707]},{code:7708,mapping:[7709]},{code:7710,mapping:[7711]},{code:7712,mapping:[7713]},{code:7714,mapping:[7715]},{code:7716,mapping:[7717]},{code:7718,mapping:[7719]},{code:7720,mapping:[7721]},{code:7722,mapping:[7723]},{code:7724,mapping:[7725]},{code:7726,mapping:[7727]},{code:7728,mapping:[7729]},{code:7730,mapping:[7731]},{code:7732,mapping:[7733]},{code:7734,mapping:[7735]},{code:7736,mapping:[7737]},{code:7738,mapping:[7739]},{code:7740,mapping:[7741]},{code:7742,mapping:[7743]},{code:7744,mapping:[7745]},{code:7746,mapping:[7747]},{code:7748,mapping:[7749]},{code:7750,mapping:[7751]},{code:7752,mapping:[7753]},{code:7754,mapping:[7755]},{code:7756,mapping:[7757]},{code:7758,mapping:[7759]},{code:7760,mapping:[7761]},{code:7762,mapping:[7763]},{code:7764,mapping:[7765]},{code:7766,mapping:[7767]},{code:7768,mapping:[7769]},{code:7770,mapping:[7771]},{code:7772,mapping:[7773]},{code:7774,mapping:[7775]},{code:7776,mapping:[7777]},{code:7778,mapping:[7779]},{code:7780,mapping:[7781]},{code:7782,mapping:[7783]},{code:7784,mapping:[7785]},{code:7786,mapping:[7787]},{code:7788,mapping:[7789]},{code:7790,mapping:[7791]},{code:7792,mapping:[7793]},{code:7794,mapping:[7795]},{code:7796,mapping:[7797]},{code:7798,mapping:[7799]},{code:7800,mapping:[7801]},{code:7802,mapping:[7803]},{code:7804,mapping:[7805]},{code:7806,mapping:[7807]},{code:7808,mapping:[7809]},{code:7810,mapping:[7811]},{code:7812,mapping:[7813]},{code:7814,mapping:[7815]},{code:7816,mapping:[7817]},{code:7818,mapping:[7819]},{code:7820,mapping:[7821]},{code:7822,mapping:[7823]},{code:7824,mapping:[7825]},{code:7826,mapping:[7827]},{code:7828,mapping:[7829]},{code:7830,mapping:[104,817]},{code:7831,mapping:[116,776]},{code:7832,mapping:[119,778]},{code:7833,mapping:[121,778]},{code:7834,mapping:[97,702]},{code:7835,mapping:[7777]},{code:7840,mapping:[7841]},{code:7842,mapping:[7843]},{code:7844,mapping:[7845]},{code:7846,mapping:[7847]},{code:7848,mapping:[7849]},{code:7850,mapping:[7851]},{code:7852,mapping:[7853]},{code:7854,mapping:[7855]},{code:7856,mapping:[7857]},{code:7858,mapping:[7859]},{code:7860,mapping:[7861]},{code:7862,mapping:[7863]},{code:7864,mapping:[7865]},{code:7866,mapping:[7867]},{code:7868,mapping:[7869]},{code:7870,mapping:[7871]},{code:7872,mapping:[7873]},{code:7874,mapping:[7875]},{code:7876,mapping:[7877]},{code:7878,mapping:[7879]},{code:7880,mapping:[7881]},{code:7882,mapping:[7883]},{code:7884,mapping:[7885]},{code:7886,mapping:[7887]},{code:7888,mapping:[7889]},{code:7890,mapping:[7891]},{code:7892,mapping:[7893]},{code:7894,mapping:[7895]},{code:7896,mapping:[7897]},{code:7898,mapping:[7899]},{code:7900,mapping:[7901]},{code:7902,mapping:[7903]},{code:7904,mapping:[7905]},{code:7906,mapping:[7907]},{code:7908,mapping:[7909]},{code:7910,mapping:[7911]},{code:7912,mapping:[7913]},{code:7914,mapping:[7915]},{code:7916,mapping:[7917]},{code:7918,mapping:[7919]},{code:7920,mapping:[7921]},{code:7922,mapping:[7923]},{code:7924,mapping:[7925]},{code:7926,mapping:[7927]},{code:7928,mapping:[7929]},{code:7944,mapping:[7936]},{code:7945,mapping:[7937]},{code:7946,mapping:[7938]},{code:7947,mapping:[7939]},{code:7948,mapping:[7940]},{code:7949,mapping:[7941]},{code:7950,mapping:[7942]},{code:7951,mapping:[7943]},{code:7960,mapping:[7952]},{code:7961,mapping:[7953]},{code:7962,mapping:[7954]},{code:7963,mapping:[7955]},{code:7964,mapping:[7956]},{code:7965,mapping:[7957]},{code:7976,mapping:[7968]},{code:7977,mapping:[7969]},{code:7978,mapping:[7970]},{code:7979,mapping:[7971]},{code:7980,mapping:[7972]},{code:7981,mapping:[7973]},{code:7982,mapping:[7974]},{code:7983,mapping:[7975]},{code:7992,mapping:[7984]},{code:7993,mapping:[7985]},{code:7994,mapping:[7986]},{code:7995,mapping:[7987]},{code:7996,mapping:[7988]},{code:7997,mapping:[7989]},{code:7998,mapping:[7990]},{code:7999,mapping:[7991]},{code:8008,mapping:[8000]},{code:8009,mapping:[8001]},{code:8010,mapping:[8002]},{code:8011,mapping:[8003]},{code:8012,mapping:[8004]},{code:8013,mapping:[8005]},{code:8016,mapping:[965,787]},{code:8018,mapping:[965,787,768]},{code:8020,mapping:[965,787,769]},{code:8022,mapping:[965,787,834]},{code:8025,mapping:[8017]},{code:8027,mapping:[8019]},{code:8029,mapping:[8021]},{code:8031,mapping:[8023]},{code:8040,mapping:[8032]},{code:8041,mapping:[8033]},{code:8042,mapping:[8034]},{code:8043,mapping:[8035]},{code:8044,mapping:[8036]},{code:8045,mapping:[8037]},{code:8046,mapping:[8038]},{code:8047,mapping:[8039]},{code:8064,mapping:[7936,953]},{code:8065,mapping:[7937,953]},{code:8066,mapping:[7938,953]},{code:8067,mapping:[7939,953]},{code:8068,mapping:[7940,953]},{code:8069,mapping:[7941,953]},{code:8070,mapping:[7942,953]},{code:8071,mapping:[7943,953]},{code:8072,mapping:[7936,953]},{code:8073,mapping:[7937,953]},{code:8074,mapping:[7938,953]},{code:8075,mapping:[7939,953]},{code:8076,mapping:[7940,953]},{code:8077,mapping:[7941,953]},{code:8078,mapping:[7942,953]},{code:8079,mapping:[7943,953]},{code:8080,mapping:[7968,953]},{code:8081,mapping:[7969,953]},{code:8082,mapping:[7970,953]},{code:8083,mapping:[7971,953]},{code:8084,mapping:[7972,953]},{code:8085,mapping:[7973,953]},{code:8086,mapping:[7974,953]},{code:8087,mapping:[7975,953]},{code:8088,mapping:[7968,953]},{code:8089,mapping:[7969,953]},{code:8090,mapping:[7970,953]},{code:8091,mapping:[7971,953]},{code:8092,mapping:[7972,953]},{code:8093,mapping:[7973,953]},{code:8094,mapping:[7974,953]},{code:8095,mapping:[7975,953]},{code:8096,mapping:[8032,953]},{code:8097,mapping:[8033,953]},{code:8098,mapping:[8034,953]},{code:8099,mapping:[8035,953]},{code:8100,mapping:[8036,953]},{code:8101,mapping:[8037,953]},{code:8102,mapping:[8038,953]},{code:8103,mapping:[8039,953]},{code:8104,mapping:[8032,953]},{code:8105,mapping:[8033,953]},{code:8106,mapping:[8034,953]},{code:8107,mapping:[8035,953]},{code:8108,mapping:[8036,953]},{code:8109,mapping:[8037,953]},{code:8110,mapping:[8038,953]},{code:8111,mapping:[8039,953]},{code:8114,mapping:[8048,953]},{code:8115,mapping:[945,953]},{code:8116,mapping:[940,953]},{code:8118,mapping:[945,834]},{code:8119,mapping:[945,834,953]},{code:8120,mapping:[8112]},{code:8121,mapping:[8113]},{code:8122,mapping:[8048]},{code:8123,mapping:[8049]},{code:8124,mapping:[945,953]},{code:8126,mapping:[953]},{code:8130,mapping:[8052,953]},{code:8131,mapping:[951,953]},{code:8132,mapping:[942,953]},{code:8134,mapping:[951,834]},{code:8135,mapping:[951,834,953]},{code:8136,mapping:[8050]},{code:8137,mapping:[8051]},{code:8138,mapping:[8052]},{code:8139,mapping:[8053]},{code:8140,mapping:[951,953]},{code:8146,mapping:[953,776,768]},{code:8147,mapping:[953,776,769]},{code:8150,mapping:[953,834]},{code:8151,mapping:[953,776,834]},{code:8152,mapping:[8144]},{code:8153,mapping:[8145]},{code:8154,mapping:[8054]},{code:8155,mapping:[8055]},{code:8162,mapping:[965,776,768]},{code:8163,mapping:[965,776,769]},{code:8164,mapping:[961,787]},{code:8166,mapping:[965,834]},{code:8167,mapping:[965,776,834]},{code:8168,mapping:[8160]},{code:8169,mapping:[8161]},{code:8170,mapping:[8058]},{code:8171,mapping:[8059]},{code:8172,mapping:[8165]},{code:8178,mapping:[8060,953]},{code:8179,mapping:[969,953]},{code:8180,mapping:[974,953]},{code:8182,mapping:[969,834]},{code:8183,mapping:[969,834,953]},{code:8184,mapping:[8056]},{code:8185,mapping:[8057]},{code:8186,mapping:[8060]},{code:8187,mapping:[8061]},{code:8188,mapping:[969,953]},{code:8486,mapping:[969]},{code:8490,mapping:[107]},{code:8491,mapping:[229]},{code:8498,mapping:[8526]},{code:8544,mapping:[8560]},{code:8545,mapping:[8561]},{code:8546,mapping:[8562]},{code:8547,mapping:[8563]},{code:8548,mapping:[8564]},{code:8549,mapping:[8565]},{code:8550,mapping:[8566]},{code:8551,mapping:[8567]},{code:8552,mapping:[8568]},{code:8553,mapping:[8569]},{code:8554,mapping:[8570]},{code:8555,mapping:[8571]},{code:8556,mapping:[8572]},{code:8557,mapping:[8573]},{code:8558,mapping:[8574]},{code:8559,mapping:[8575]},{code:8579,mapping:[8580]},{code:9398,mapping:[9424]},{code:9399,mapping:[9425]},{code:9400,mapping:[9426]},{code:9401,mapping:[9427]},{code:9402,mapping:[9428]},{code:9403,mapping:[9429]},{code:9404,mapping:[9430]},{code:9405,mapping:[9431]},{code:9406,mapping:[9432]},{code:9407,mapping:[9433]},{code:9408,mapping:[9434]},{code:9409,mapping:[9435]},{code:9410,mapping:[9436]},{code:9411,mapping:[9437]},{code:9412,mapping:[9438]},{code:9413,mapping:[9439]},{code:9414,mapping:[9440]},{code:9415,mapping:[9441]},{code:9416,mapping:[9442]},{code:9417,mapping:[9443]},{code:9418,mapping:[9444]},{code:9419,mapping:[9445]},{code:9420,mapping:[9446]},{code:9421,mapping:[9447]},{code:9422,mapping:[9448]},{code:9423,mapping:[9449]},{code:11264,mapping:[11312]},{code:11265,mapping:[11313]},{code:11266,mapping:[11314]},{code:11267,mapping:[11315]},{code:11268,mapping:[11316]},{code:11269,mapping:[11317]},{code:11270,mapping:[11318]},{code:11271,mapping:[11319]},{code:11272,mapping:[11320]},{code:11273,mapping:[11321]},{code:11274,mapping:[11322]},{code:11275,mapping:[11323]},{code:11276,mapping:[11324]},{code:11277,mapping:[11325]},{code:11278,mapping:[11326]},{code:11279,mapping:[11327]},{code:11280,mapping:[11328]},{code:11281,mapping:[11329]},{code:11282,mapping:[11330]},{code:11283,mapping:[11331]},{code:11284,mapping:[11332]},{code:11285,mapping:[11333]},{code:11286,mapping:[11334]},{code:11287,mapping:[11335]},{code:11288,mapping:[11336]},{code:11289,mapping:[11337]},{code:11290,mapping:[11338]},{code:11291,mapping:[11339]},{code:11292,mapping:[11340]},{code:11293,mapping:[11341]},{code:11294,mapping:[11342]},{code:11295,mapping:[11343]},{code:11296,mapping:[11344]},{code:11297,mapping:[11345]},{code:11298,mapping:[11346]},{code:11299,mapping:[11347]},{code:11300,mapping:[11348]},{code:11301,mapping:[11349]},{code:11302,mapping:[11350]},{code:11303,mapping:[11351]},{code:11304,mapping:[11352]},{code:11305,mapping:[11353]},{code:11306,mapping:[11354]},{code:11307,mapping:[11355]},{code:11308,mapping:[11356]},{code:11309,mapping:[11357]},{code:11310,mapping:[11358]},{code:11360,mapping:[11361]},{code:11362,mapping:[619]},{code:11363,mapping:[7549]},{code:11364,mapping:[637]},{code:11367,mapping:[11368]},{code:11369,mapping:[11370]},{code:11371,mapping:[11372]},{code:11381,mapping:[11382]},{code:11392,mapping:[11393]},{code:11394,mapping:[11395]},{code:11396,mapping:[11397]},{code:11398,mapping:[11399]},{code:11400,mapping:[11401]},{code:11402,mapping:[11403]},{code:11404,mapping:[11405]},{code:11406,mapping:[11407]},{code:11408,mapping:[11409]},{code:11410,mapping:[11411]},{code:11412,mapping:[11413]},{code:11414,mapping:[11415]},{code:11416,mapping:[11417]},{code:11418,mapping:[11419]},{code:11420,mapping:[11421]},{code:11422,mapping:[11423]},{code:11424,mapping:[11425]},{code:11426,mapping:[11427]},{code:11428,mapping:[11429]},{code:11430,mapping:[11431]},{code:11432,mapping:[11433]},{code:11434,mapping:[11435]},{code:11436,mapping:[11437]},{code:11438,mapping:[11439]},{code:11440,mapping:[11441]},{code:11442,mapping:[11443]},{code:11444,mapping:[11445]},{code:11446,mapping:[11447]},{code:11448,mapping:[11449]},{code:11450,mapping:[11451]},{code:11452,mapping:[11453]},{code:11454,mapping:[11455]},{code:11456,mapping:[11457]},{code:11458,mapping:[11459]},{code:11460,mapping:[11461]},{code:11462,mapping:[11463]},{code:11464,mapping:[11465]},{code:11466,mapping:[11467]},{code:11468,mapping:[11469]},{code:11470,mapping:[11471]},{code:11472,mapping:[11473]},{code:11474,mapping:[11475]},{code:11476,mapping:[11477]},{code:11478,mapping:[11479]},{code:11480,mapping:[11481]},{code:11482,mapping:[11483]},{code:11484,mapping:[11485]},{code:11486,mapping:[11487]},{code:11488,mapping:[11489]},{code:11490,mapping:[11491]},{code:64256,mapping:[102,102]},{code:64257,mapping:[102,105]},{code:64258,mapping:[102,108]},{code:64259,mapping:[102,102,105]},{code:64260,mapping:[102,102,108]},{code:64261,mapping:[115,116]},{code:64262,mapping:[115,116]},{code:64275,mapping:[1396,1398]},{code:64276,mapping:[1396,1381]},{code:64277,mapping:[1396,1387]},{code:64278,mapping:[1406,1398]},{code:64279,mapping:[1396,1389]},{code:65313,mapping:[65345]},{code:65314,mapping:[65346]},{code:65315,mapping:[65347]},{code:65316,mapping:[65348]},{code:65317,mapping:[65349]},{code:65318,mapping:[65350]},{code:65319,mapping:[65351]},{code:65320,mapping:[65352]},{code:65321,mapping:[65353]},{code:65322,mapping:[65354]},{code:65323,mapping:[65355]},{code:65324,mapping:[65356]},{code:65325,mapping:[65357]},{code:65326,mapping:[65358]},{code:65327,mapping:[65359]},{code:65328,mapping:[65360]},{code:65329,mapping:[65361]},{code:65330,mapping:[65362]},{code:65331,mapping:[65363]},{code:65332,mapping:[65364]},{code:65333,mapping:[65365]},{code:65334,mapping:[65366]},{code:65335,mapping:[65367]},{code:65336,mapping:[65368]},{code:65337,mapping:[65369]},{code:65338,mapping:[65370]},{code:66560,mapping:[66600]},{code:66561,mapping:[66601]},{code:66562,mapping:[66602]},{code:66563,mapping:[66603]},{code:66564,mapping:[66604]},{code:66565,mapping:[66605]},{code:66566,mapping:[66606]},{code:66567,mapping:[66607]},{code:66568,mapping:[66608]},{code:66569,mapping:[66609]},{code:66570,mapping:[66610]},{code:66571,mapping:[66611]},{code:66572,mapping:[66612]},{code:66573,mapping:[66613]},{code:66574,mapping:[66614]},{code:66575,mapping:[66615]},{code:66576,mapping:[66616]},{code:66577,mapping:[66617]},{code:66578,mapping:[66618]},{code:66579,mapping:[66619]},{code:66580,mapping:[66620]},{code:66581,mapping:[66621]},{code:66582,mapping:[66622]},{code:66583,mapping:[66623]},{code:66584,mapping:[66624]},{code:66585,mapping:[66625]},{code:66586,mapping:[66626]},{code:66587,mapping:[66627]},{code:66588,mapping:[66628]},{code:66589,mapping:[66629]},{code:66590,mapping:[66630]},{code:66591,mapping:[66631]},{code:66592,mapping:[66632]},{code:66593,mapping:[66633]},{code:66594,mapping:[66634]},{code:66595,mapping:[66635]},{code:66596,mapping:[66636]},{code:66597,mapping:[66637]},{code:66598,mapping:[66638]},{code:66599,mapping:[66639]}];
}
